/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/languages/languageSelector","vs/editor/common/languages","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/languages/tokenizationRegistry","vs/editor/common/model/textModelSearch","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/model","vs/editor/common/languages/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],we=function(X){for(var e=[],m=0,i=X.length;m<i;m++)e[m]=ve[X[m]];return e};define(ve[56],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(i,k){if(!i)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=m}),define(ve[74],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function m(T){return T?T.replace(/\$\((.*?)\)/g,(I,y)=>` ${y} `).trim():""}e.getCodiconAriaLabel=m;class i{constructor(I,y,P){this.id=I,this.definition=y,this.description=P,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function k(T,I){const y=["codicon","codicon-"+T];return I&&y.push("codicon-modifier-"+I),y}e.getClassNamesArray=k;var C;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function y(D){if(D instanceof i)return["codicon","codicon-"+D.id];const c=I.exec(D.id);if(!c)return y(i.error);let[,b,p]=c;const v=["codicon","codicon-"+b];return p&&v.push("codicon-modifier-"+p.substr(1)),v}T.asClassNameArray=y;function P(D){return y(D).join(" ")}T.asClassName=P;function L(D){return"."+y(D).join(".")}T.asCSSSelector=L})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ve[75],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function i(L){const D=[];for(let c in L)m.call(L,c)&&D.push(L[c]);return D}e.values=i;function k(L,D){for(let c in L)if(m.call(L,c)&&D({key:c,value:L[c]},function(){delete L[c]})===!1)return}e.forEach=k;function C(L,D){const c=Object.create(null);for(const b of L){const p=D(b);let v=c[p];v||(v=c[p]=[]),v.push(b)}return c}e.groupBy=C;function T(L){const D=Object.create(null);return L&&L.forEach((c,b)=>{D[b]=c}),D}e.fromMap=T;function I(L,D){const c=[],b=[];for(let p of L)D.has(p)||c.push(p);for(let p of D)L.has(p)||b.push(p);return{removed:c,added:b}}e.diffSets=I;function y(L,D){const c=[],b=[];for(let[p,v]of L)D.has(p)||c.push(v);for(let[p,v]of D)L.has(p)||b.push(v);return{removed:c,added:b}}e.diffMaps=y;class P{constructor(){this.map=new Map}add(D,c){let b=this.map.get(D);b||(b=new Set,this.map.set(D,b)),b.add(c)}delete(D,c){const b=this.map.get(D);!b||(b.delete(c),b.size===0&&this.map.delete(D))}forEach(D,c){const b=this.map.get(D);!b||b.forEach(c)}}e.SetMap=P}),define(ve[57],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(T){return(I,y,P)=>{let L=null,D=null;if(typeof P.value=="function"?(L="value",D=P.value):typeof P.get=="function"&&(L="get",D=P.get),!D)throw new Error("not supported");P[L]=T(D,y)}}e.createDecorator=m;function i(T,I,y){let P=null,L=null;if(typeof y.value=="function"?(P="value",L=y.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(P="get",L=y.get),!L)throw new Error("not supported");const D=`$memoize$${I}`;y[P]=function(...c){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,c)}),this[D]}}e.memoize=i;function k(T,I,y){return m((P,L)=>{const D=`$debounce$${L}`,c=`$debounce$result$${L}`;return function(...b){this[c]||(this[c]=y?y():void 0),clearTimeout(this[D]),I&&(this[c]=I(this[c],...b),b=[this[c]]),this[D]=setTimeout(()=>{P.apply(this,b),this[c]=y?y():void 0},T)}})}e.debounce=k;function C(T,I,y){return m((P,L)=>{const D=`$throttle$timer$${L}`,c=`$throttle$result$${L}`,b=`$throttle$lastRun$${L}`,p=`$throttle$pending$${L}`;return function(...v){if(this[c]||(this[c]=y?y():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),I&&(this[c]=I(this[c],...v)),this[p])return;const w=this[b]+T;w<=Date.now()?(this[b]=Date.now(),P.apply(this,[this[c]]),this[c]=y?y():void 0):(this[p]=!0,this[D]=setTimeout(()=>{this[p]=!1,this[b]=Date.now(),P.apply(this,[this[c]]),this[c]=y?y():void 0},w-Date.now()))}})}e.throttle=C}),define(ve[15],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(E=>{E(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=m,e.errorHandler=new m;function i(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=i;function k(g){y(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=k;function C(g){y(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=C;function T(g){if(g instanceof Error){let{name:a,message:E}=g;const r=g.stacktrace||g.stack;return{$isError:!0,name:a,message:E,stack:r}}return g}e.transformErrorForSerialization=T;const I="Canceled";function y(g){return g instanceof Error&&g.name===I&&g.message===I}e.isPromiseCanceledError=y;class P extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=P;function L(){const g=new Error(I);return g.name=g.message,g}e.canceled=L;function D(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=D;function c(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=c;function b(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function p(g){const a=new Error(`${g} has been disposed`);return a.name="DISPOSED",a}e.disposed=p;function v(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=v;class w extends Error{constructor(a){super("NotImplemented");a&&(this.message=a)}}e.NotImplementedError=w;class R extends Error{constructor(a){super("NotSupported");a&&(this.message=a)}}e.NotSupportedError=R;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function s(g){const a=g;return a instanceof Error&&Array.isArray(a.actions)}e.isErrorWithActions=s;function n(g,a=Object.create(null)){const E=new Error(g);return a.actions&&(E.actions=a.actions),E}e.createErrorWithActions=n}),define(ve[16],we([0,1,15]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(V,te=0){return V[V.length-(1+te)]}e.tail=i;function k(V){if(V.length===0)throw new Error("Invalid tail call");return[V.slice(0,V.length-1),V[V.length-1]]}e.tail2=k;function C(V,te,me=(ge,ke)=>ge===ke){if(V===te)return!0;if(!V||!te||V.length!==te.length)return!1;for(let ge=0,ke=V.length;ge<ke;ge++)if(!me(V[ge],te[ge]))return!1;return!0}e.equals=C;function T(V,te,me){let ge=0,ke=V.length-1;for(;ge<=ke;){const Be=(ge+ke)/2|0,xe=me(V[Be],te);if(xe<0)ge=Be+1;else if(xe>0)ke=Be-1;else return Be}return-(ge+1)}e.binarySearch=T;function I(V,te){let me=0,ge=V.length;if(ge===0)return 0;for(;me<ge;){const ke=Math.floor((me+ge)/2);te(V[ke])?ge=ke:me=ke+1}return me}e.findFirstInSorted=I;function y(V,te,me){if(V=V|0,V>=te.length)throw new TypeError("invalid index");let ge=te[Math.floor(te.length*Math.random())],ke=[],Be=[],xe=[];for(let q of te){const Y=me(q,ge);Y<0?ke.push(q):Y>0?Be.push(q):xe.push(q)}return V<ke.length?y(V,ke,me):V<ke.length+xe.length?xe[0]:y(V-(ke.length+xe.length),Be,me)}e.quickSelect=y;function P(V,te){const me=[];let ge;for(const ke of V.slice(0).sort(te))!ge||te(ge[0],ke)!==0?(ge=[ke],me.push(ge)):ge.push(ke);return me}e.groupBy=P;function L(V,te,me){const ge=[];function ke(q,Y,re){if(Y===0&&re.length===0)return;const ue=ge[ge.length-1];ue&&ue.start+ue.deleteCount===q?(ue.deleteCount+=Y,ue.toInsert.push(...re)):ge.push({start:q,deleteCount:Y,toInsert:re})}let Be=0,xe=0;for(;;){if(Be===V.length){ke(Be,0,te.slice(xe));break}if(xe===te.length){ke(Be,V.length-Be,[]);break}const q=V[Be],Y=te[xe],re=me(q,Y);re===0?(Be+=1,xe+=1):re<0?(ke(Be,1,[]),Be+=1):re>0&&(ke(Be,0,[Y]),xe+=1)}return ge}e.sortedDiff=L;function D(V,te,me){const ge=L(V,te,me),ke=[],Be=[];for(const xe of ge)ke.push(...V.slice(xe.start,xe.start+xe.deleteCount)),Be.push(...xe.toInsert);return{removed:ke,added:Be}}e.delta=D;function c(V,te,me){if(me===0)return[];const ge=V.slice(0,me).sort(te);return p(V,te,ge,me,V.length),ge}e.top=c;function b(V,te,me,ge,ke){return me===0?Promise.resolve([]):new Promise((Be,xe)=>{(async()=>{const q=V.length,Y=V.slice(0,me).sort(te);for(let re=me,ue=Math.min(me+ge,q);re<q;re=ue,ue=Math.min(ue+ge,q)){if(re>me&&await new Promise(J=>setTimeout(J)),ke&&ke.isCancellationRequested)throw(0,m.canceled)();p(V,te,Y,re,ue)}return Y})().then(Be,xe)})}e.topAsync=b;function p(V,te,me,ge,ke){for(const Be=me.length;ge<ke;ge++){const xe=V[ge];if(te(xe,me[Be-1])<0){me.pop();const q=I(me,Y=>te(xe,Y)<0);me.splice(q,0,xe)}}}function v(V){return V.filter(te=>!!te)}e.coalesce=v;function w(V){let te=0;for(let me=0;me<V.length;me++)V[me]&&(V[te]=V[me],te+=1);V.length=te}e.coalesceInPlace=w;function R(V,te,me){V.splice(me,0,V.splice(te,1)[0])}e.move=R;function S(V){return!Array.isArray(V)||V.length===0}e.isFalsyOrEmpty=S;function s(V){return Array.isArray(V)&&V.length>0}e.isNonEmptyArray=s;function n(V,te=me=>me){const me=new Set;return V.filter(ge=>{const ke=te(ge);return me.has(ke)?!1:(me.add(ke),!0)})}e.distinct=n;function g(V){const te=new Set;return me=>{const ge=V(me);return te.has(ge)?!1:(te.add(ge),!0)}}e.uniqueFilter=g;function a(V,te){const me=E(V,te);if(me!==-1)return V[me]}e.findLast=a;function E(V,te){for(let me=V.length-1;me>=0;me--){const ge=V[me];if(te(ge))return me}return-1}e.lastIndex=E;function r(V,te){return V.length>0?V[0]:te}e.firstOrDefault=r;function t(V,te,me=(ge,ke)=>ge===ke){let ge=0;for(let ke=0,Be=Math.min(V.length,te.length);ke<Be&&me(V[ke],te[ke]);ke++)ge++;return ge}e.commonPrefixLength=t;function o(V){return[].concat(...V)}e.flatten=o;function h(V,te){let me=typeof te=="number"?V:0;typeof te=="number"?me=V:(me=0,te=V);const ge=[];if(me<=te)for(let ke=me;ke<te;ke++)ge.push(ke);else for(let ke=me;ke>te;ke--)ge.push(ke);return ge}e.range=h;function u(V,te,me){return V.reduce((ge,ke)=>(ge[te(ke)]=me?me(ke):ke,ge),Object.create(null))}e.index=u;function d(V,te){return V.push(te),()=>f(V,te)}e.insert=d;function f(V,te){const me=V.indexOf(te);if(me>-1)return V.splice(me,1),te}e.remove=f;function l(V,te,me){const ge=V.slice(0,te),ke=V.slice(te);return ge.concat(me,ke)}e.arrayInsert=l;function _(V,te){let me;if(typeof te=="number"){let ge=te;me=()=>{const ke=Math.sin(ge++)*179426549;return ke-Math.floor(ke)}}else me=Math.random;for(let ge=V.length-1;ge>0;ge-=1){const ke=Math.floor(me()*(ge+1)),Be=V[ge];V[ge]=V[ke],V[ke]=Be}}e.shuffle=_;function A(V,te){const me=V.indexOf(te);me>-1&&(V.splice(me,1),V.unshift(te))}e.pushToStart=A;function N(V,te){const me=V.indexOf(te);me>-1&&(V.splice(me,1),V.push(te))}e.pushToEnd=N;function x(V,te){return Array.isArray(V)?V.map(te):te(V)}e.mapArrayOrNot=x;function F(V){return Array.isArray(V)?V:[V]}e.asArray=F;function O(V){return V[Math.floor(Math.random()*V.length)]}e.getRandomElement=O;function z(V,te){for(const me of V){const ge=te(me);if(ge!==void 0)return ge}}e.mapFind=z;function $(V,te,me){const ge=B(V,te),ke=V.length,Be=me.length;V.length=ke+Be;for(let xe=ke-1;xe>=ge;xe--)V[xe+Be]=V[xe];for(let xe=0;xe<Be;xe++)V[xe+ge]=me[xe]}e.insertInto=$;function M(V,te,me,ge){const ke=B(V,te),Be=V.splice(ke,me);return $(V,ke,ge),Be}e.splice=M;function B(V,te){return te<0?Math.max(te+V.length,0):Math.min(te,V.length)}function W(V,te){return(me,ge)=>te(V(me),V(ge))}e.compareBy=W;const U=(V,te)=>V-te;e.numberComparator=U;function j(V,te){if(V.length===0)return;let me=V[0];for(let ge=1;ge<V.length;ge++){const ke=V[ge];te(ke,me)>0&&(me=ke)}return me}e.findMaxBy=j;function Z(V,te){if(V.length===0)return;let me=V[0];for(let ge=1;ge<V.length;ge++){const ke=V[ge];te(ke,me)>=0&&(me=ke)}return me}e.findLastMaxBy=Z;function ce(V,te){return j(V,(me,ge)=>-te(me,ge))}e.findMinBy=ce;class Q{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let me=this.firstIdx;for(;me<this.items.length&&te(this.items[me]);)me++;const ge=me===this.firstIdx?null:this.items.slice(this.firstIdx,me);return this.firstIdx=me,ge}takeFromEndWhile(te){let me=this.lastIdx;for(;me>=0&&te(this.items[me]);)me--;const ge=me===this.lastIdx?null:this.items.slice(me+1,this.lastIdx+1);return this.lastIdx=me,ge}peek(){return this.items[this.firstIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}takeCount(te){const me=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,me}}e.ArrayQueue=Q}),define(ve[76],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(i){const k=this;let C=!1,T;return function(){return C||(C=!0,T=i.apply(k,arguments)),T}}e.once=m}),define(ve[77],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(ve[78],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(i){function k(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}i.is=k;const C=Object.freeze([]);function T(){return C}i.empty=T;function*I(g){yield g}i.single=I;function y(g){return g||C}i.from=y;function P(g){return!g||g[Symbol.iterator]().next().done===!0}i.isEmpty=P;function L(g){return g[Symbol.iterator]().next().value}i.first=L;function D(g,a){for(const E of g)if(a(E))return!0;return!1}i.some=D;function c(g,a){for(const E of g)if(a(E))return E}i.find=c;function*b(g,a){for(const E of g)a(E)&&(yield E)}i.filter=b;function*p(g,a){let E=0;for(const r of g)yield a(r,E++)}i.map=p;function*v(...g){for(const a of g)for(const E of a)yield E}i.concat=v;function*w(g){for(const a of g)for(const E of a)yield E}i.concatNested=w;function R(g,a,E){let r=E;for(const t of g)r=a(r,t);return r}i.reduce=R;function*S(g,a,E=g.length){for(a<0&&(a+=g.length),E<0?E+=g.length:E>g.length&&(E=g.length);a<E;a++)yield g[a]}i.slice=S;function s(g,a=Number.POSITIVE_INFINITY){const E=[];if(a===0)return[E,g];const r=g[Symbol.iterator]();for(let t=0;t<a;t++){const o=r.next();if(o.done)return[E,i.empty()];E.push(o.value)}return[E,{[Symbol.iterator](){return r}}]}i.consume=s;function n(g,a,E=(r,t)=>r===t){const r=g[Symbol.iterator](),t=a[Symbol.iterator]();for(;;){const o=r.next(),h=t.next();if(o.done!==h.done)return!1;if(o.done)return!0;if(!E(o.value,h.value))return!1}}i.equals=n})(m=e.Iterable||(e.Iterable={}))}),define(ve[58],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var i;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(a){a.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function T(a,E=!1){let r=0,t=a.length,o="",h=0,u=16,d=0;function f(O){let z=0,$=0;for(;z<O;){const M=a.charCodeAt(r);if(M>=48&&M<=57)$=$*16+M-48;else if(M>=65&&M<=70)$=$*16+M-65+10;else if(M>=97&&M<=102)$=$*16+M-97+10;else break;r++,z++}return z<O&&($=-1),$}function l(O){r=O,o="",h=0,u=16,d=0}function _(){const O=r;if(a.charCodeAt(r)===48)r++;else for(r++;r<a.length&&P(a.charCodeAt(r));)r++;if(r<a.length&&a.charCodeAt(r)===46)if(r++,r<a.length&&P(a.charCodeAt(r)))for(r++;r<a.length&&P(a.charCodeAt(r));)r++;else return d=3,a.substring(O,r);let z=r;if(r<a.length&&(a.charCodeAt(r)===69||a.charCodeAt(r)===101))if(r++,(r<a.length&&a.charCodeAt(r)===43||a.charCodeAt(r)===45)&&r++,r<a.length&&P(a.charCodeAt(r))){for(r++;r<a.length&&P(a.charCodeAt(r));)r++;z=r}else d=3;return a.substring(O,z)}function A(){let O="",z=r;for(;;){if(r>=t){O+=a.substring(z,r),d=2;break}const $=a.charCodeAt(r);if($===34){O+=a.substring(z,r),r++;break}if($===92){if(O+=a.substring(z,r),r++,r>=t){d=2;break}switch(a.charCodeAt(r++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const B=f(4);B>=0?O+=String.fromCharCode(B):d=4;break}default:d=5}z=r;continue}if($>=0&&$<=31)if(y($)){O+=a.substring(z,r),d=2;break}else d=6;r++}return O}function N(){if(o="",d=0,h=r,r>=t)return h=t,u=17;let O=a.charCodeAt(r);if(I(O)){do r++,o+=String.fromCharCode(O),O=a.charCodeAt(r);while(I(O));return u=15}if(y(O))return r++,o+=String.fromCharCode(O),O===13&&a.charCodeAt(r)===10&&(r++,o+=`
`),u=14;switch(O){case 123:return r++,u=1;case 125:return r++,u=2;case 91:return r++,u=3;case 93:return r++,u=4;case 58:return r++,u=6;case 44:return r++,u=5;case 34:return r++,o=A(),u=10;case 47:{const z=r-1;if(a.charCodeAt(r+1)===47){for(r+=2;r<t&&!y(a.charCodeAt(r));)r++;return o=a.substring(z,r),u=12}if(a.charCodeAt(r+1)===42){r+=2;const $=t-1;let M=!1;for(;r<$;){if(a.charCodeAt(r)===42&&a.charCodeAt(r+1)===47){r+=2,M=!0;break}r++}return M||(r++,d=1),o=a.substring(z,r),u=13}return o+=String.fromCharCode(O),r++,u=16}case 45:if(o+=String.fromCharCode(O),r++,r===t||!P(a.charCodeAt(r)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),u=11;default:for(;r<t&&x(O);)r++,O=a.charCodeAt(r);if(h!==r){switch(o=a.substring(h,r),o){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return o+=String.fromCharCode(O),r++,u=16}}function x(O){if(I(O)||y(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let O;do O=N();while(O>=12&&O<=15);return O}return{setPosition:l,getPosition:()=>r,scan:E?F:N,getToken:()=>u,getTokenValue:()=>o,getTokenOffset:()=>h,getTokenLength:()=>r-h,getTokenError:()=>d}}e.createScanner=T;function I(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function y(a){return a===10||a===13||a===8232||a===8233}function P(a){return a>=48&&a<=57}var L;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(L||(L={}));function D(a,E){const r=[],t=new Object;let o;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(f,l,_,A){h.value=f,h.offset=l,h.length=_,h.type=A,h.colonOffset=void 0,o=h}try{s(a,{onObjectBegin:(f,l)=>{if(E<=f)throw t;o=void 0,u=E>f,r.push("")},onObjectProperty:(f,l,_)=>{if(E<l||(d(f,l,_,"property"),r[r.length-1]=f,E<=l+_))throw t},onObjectEnd:(f,l)=>{if(E<=f)throw t;o=void 0,r.pop()},onArrayBegin:(f,l)=>{if(E<=f)throw t;o=void 0,r.push(0)},onArrayEnd:(f,l)=>{if(E<=f)throw t;o=void 0,r.pop()},onLiteralValue:(f,l,_)=>{if(E<l||(d(f,l,_,g(f)),E<=l+_))throw t},onSeparator:(f,l,_)=>{if(E<=l)throw t;if(f===":"&&o&&o.type==="property")o.colonOffset=l,u=!1,o=void 0;else if(f===","){const A=r[r.length-1];typeof A=="number"?r[r.length-1]=A+1:(u=!0,r[r.length-1]=""),o=void 0}}})}catch(f){if(f!==t)throw f}return{path:r,previousNode:o,isAtPropertyKey:u,matches:f=>{let l=0;for(let _=0;l<f.length&&_<r.length;_++)if(f[l]===r[_]||f[l]==="*")l++;else if(f[l]!=="**")return!1;return l===f.length}}}e.getLocation=D;function c(a,E=[],r=C.DEFAULT){let t=null,o=[];const h=[];function u(f){Array.isArray(o)?o.push(f):t!==null&&(o[t]=f)}return s(a,{onObjectBegin:()=>{const f={};u(f),h.push(o),o=f,t=null},onObjectProperty:f=>{t=f},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const f=[];u(f),h.push(o),o=f,t=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:u,onError:(f,l,_)=>{E.push({error:f,offset:l,length:_})}},r),o[0]}e.parse=c;function b(a,E=[],r=C.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(f){t.type==="property"&&(t.length=f-t.offset,t=t.parent)}function h(f){return t.children.push(f),f}s(a,{onObjectBegin:f=>{t=h({type:"object",offset:f,length:-1,parent:t,children:[]})},onObjectProperty:(f,l,_)=>{t=h({type:"property",offset:l,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:f,offset:l,length:_,parent:t})},onObjectEnd:(f,l)=>{t.length=f+l-t.offset,t=t.parent,o(f+l)},onArrayBegin:(f,l)=>{t=h({type:"array",offset:f,length:-1,parent:t,children:[]})},onArrayEnd:(f,l)=>{t.length=f+l-t.offset,t=t.parent,o(f+l)},onLiteralValue:(f,l,_)=>{h({type:g(f),offset:l,length:_,parent:t,value:f}),o(l+_)},onSeparator:(f,l,_)=>{t.type==="property"&&(f===":"?t.colonOffset=l:f===","&&o(l))},onError:(f,l,_)=>{E.push({error:f,offset:l,length:_})}},r);const d=t.children[0];return d&&delete d.parent,d}e.parseTree=b;function p(a,E){if(!a)return;let r=a;for(let t of E)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const h of r.children)if(Array.isArray(h.children)&&h.children[0].value===t){r=h.children[1],o=!0;break}if(!o)return}else{const o=t;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=p;function v(a){if(!a.parent||!a.parent.children)return[];const E=v(a.parent);if(a.parent.type==="property"){const r=a.parent.children[0].value;E.push(r)}else if(a.parent.type==="array"){const r=a.parent.children.indexOf(a);r!==-1&&E.push(r)}return E}e.getNodePath=v;function w(a){switch(a.type){case"array":return a.children.map(w);case"object":{const E=Object.create(null);for(let r of a.children){const t=r.children[1];t&&(E[r.children[0].value]=w(t))}return E}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=w;function R(a,E,r=!1){return E>=a.offset&&E<a.offset+a.length||r&&E===a.offset+a.length}e.contains=R;function S(a,E,r=!1){if(R(a,E,r)){const t=a.children;if(Array.isArray(t))for(let o=0;o<t.length&&t[o].offset<=E;o++){const h=S(t[o],E,r);if(h)return h}return a}}e.findNodeAtOffset=S;function s(a,E,r=C.DEFAULT){const t=T(a,!1);function o(Q){return Q?()=>Q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function h(Q){return Q?V=>Q(V,t.getTokenOffset(),t.getTokenLength()):()=>!0}const u=o(E.onObjectBegin),d=h(E.onObjectProperty),f=o(E.onObjectEnd),l=o(E.onArrayBegin),_=o(E.onArrayEnd),A=h(E.onLiteralValue),N=h(E.onSeparator),x=o(E.onComment),F=h(E.onError),O=r&&r.disallowComments,z=r&&r.allowTrailingComma;function $(){for(;;){const Q=t.scan();switch(t.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:O||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(Q){case 12:case 13:O?M(10):x();break;case 16:M(1);break;case 15:case 14:break;default:return Q}}}function M(Q,V=[],te=[]){if(F(Q),V.length+te.length>0){let me=t.getToken();for(;me!==17;){if(V.indexOf(me)!==-1){$();break}else if(te.indexOf(me)!==-1)break;me=$()}}}function B(Q){const V=t.getTokenValue();return Q?A(V):d(V),$(),!0}function W(){switch(t.getToken()){case 11:{let Q=0;try{Q=JSON.parse(t.getTokenValue()),typeof Q!="number"&&(M(2),Q=0)}catch{M(2)}A(Q);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return $(),!0}function U(){return t.getToken()!==10?(M(3,[],[2,5]),!1):(B(!1),t.getToken()===6?(N(":"),$(),ce()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function j(){u(),$();let Q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(Q||M(4,[],[]),N(","),$(),t.getToken()===2&&z)break}else Q&&M(6,[],[]);U()||M(4,[],[2,5]),Q=!0}return f(),t.getToken()!==2?M(7,[2],[]):$(),!0}function Z(){l(),$();let Q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(Q||M(4,[],[]),N(","),$(),t.getToken()===4&&z)break}else Q&&M(6,[],[]);ce()||M(4,[],[4,5]),Q=!0}return _(),t.getToken()!==4?M(8,[4],[]):$(),!0}function ce(){switch(t.getToken()){case 3:return Z();case 1:return j();case 10:return B(!0);default:return W()}}return $(),t.getToken()===17?r.allowEmptyContent?!0:(M(4,[],[]),!1):ce()?(t.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=s;function n(a,E){let r=T(a),t=[],o,h=0,u;do switch(u=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:h!==u&&t.push(a.substring(h,u)),E!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,E)),h=r.getPosition();break}while(o!==17);return t.join("")}e.stripComments=n;function g(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ve[139],we([0,1,58]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(P,L,D){let c,b,p,v,w;if(L){for(v=L.offset,w=v+L.length,p=v;p>0&&!y(P,p-1);)p--;let u=w;for(;u<P.length&&!y(P,u);)u++;b=P.substring(p,u),c=T(b,D)}else b=P,c=0,p=0,v=0,w=P.length;const R=I(D,P);let S=!1,s=0,n;D.insertSpaces?n=C(" ",D.tabSize||4):n="	";const g=(0,m.createScanner)(b,!1);let a=!1;function E(){return R+C(n,c+s)}function r(){let u=g.scan();for(S=!1;u===15||u===14;)S=S||u===14,u=g.scan();return a=u===16||g.getTokenError()!==0,u}const t=[];function o(u,d,f){!a&&d<w&&f>v&&P.substring(d,f)!==u&&t.push({offset:d,length:f-d,content:u})}let h=r();if(h!==17){const u=g.getTokenOffset()+p,d=C(n,c);o(d,p,u)}for(;h!==17;){let u=g.getTokenOffset()+g.getTokenLength()+p,d=r(),f="";for(;!S&&(d===12||d===13);){const _=g.getTokenOffset()+p;o(" ",u,_),u=g.getTokenOffset()+g.getTokenLength()+p,f=d===12?E():"",d=r()}if(d===2)h!==1&&(s--,f=E());else if(d===4)h!==3&&(s--,f=E());else{switch(h){case 3:case 1:s++,f=E();break;case 5:case 12:f=E();break;case 13:S?f=E():f=" ";break;case 6:f=" ";break;case 10:if(d===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?f=" ":d!==5&&d!==17&&(a=!0);break;case 16:a=!0;break}S&&(d===12||d===13)&&(f=E())}const l=g.getTokenOffset()+p;o(f,u,l),h=d}return t}e.format=i;function k(P,L){const D=JSON.stringify(P,void 0,L.insertSpaces?L.tabSize||4:"	");return L.eol!==void 0?D.replace(/\r\n|\r|\n/g,L.eol):D}e.toFormattedString=k;function C(P,L){let D="";for(let c=0;c<L;c++)D+=P;return D}function T(P,L){let D=0,c=0;const b=L.tabSize||4;for(;D<P.length;){const p=P.charAt(D);if(p===" ")c++;else if(p==="	")c+=b;else break;D++}return Math.floor(c/b)}function I(P,L){for(let D=0;D<L.length;D++){const c=L.charAt(D);if(c==="\r")return D+1<L.length&&L.charAt(D+1)===`
`?`\r
`:"\r";if(c===`
`)return`
`}return P&&P.eol||`
`}e.getEOL=I;function y(P,L){return`\r
`.indexOf(P.charAt(L))!==-1}e.isEOL=y}),define(ve[140],we([0,1,58,139]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(P,L,D){return C(P,L,void 0,D)}e.removeProperty=k;function C(P,L,D,c,b){const p=L.slice(),v=[],w=(0,m.parseTree)(P,v);let R,S;for(;p.length>0&&(S=p.pop(),R=(0,m.findNodeAtLocation)(w,p),R===void 0&&D!==void 0);)typeof S=="string"?D={[S]:D}:D=[D];if(R)if(R.type==="object"&&typeof S=="string"&&Array.isArray(R.children)){const s=(0,m.findNodeAtLocation)(R,[S]);if(s!==void 0)if(D===void 0){if(!s.parent)throw new Error("Malformed AST");const n=R.children.indexOf(s.parent);let g,a=s.parent.offset+s.parent.length;if(n>0){const E=R.children[n-1];g=E.offset+E.length}else g=R.offset+1,R.children.length>1&&(a=R.children[1].offset);return T(P,{offset:g,length:a-g,content:""},c)}else return T(P,{offset:s.offset,length:s.length,content:JSON.stringify(D)},c);else{if(D===void 0)return[];const n=`${JSON.stringify(S)}: ${JSON.stringify(D)}`,g=b?b(R.children.map(E=>E.children[0].value)):R.children.length;let a;if(g>0){const E=R.children[g-1];a={offset:E.offset+E.length,length:0,content:","+n}}else R.children.length===0?a={offset:R.offset+1,length:0,content:n}:a={offset:R.offset+1,length:0,content:n+","};return T(P,a,c)}}else if(R.type==="array"&&typeof S=="number"&&Array.isArray(R.children))if(D!==void 0){const s=`${JSON.stringify(D)}`;let n;if(R.children.length===0||S===0)n={offset:R.offset+1,length:0,content:R.children.length===0?s:s+","};else{const g=S===-1||S>R.children.length?R.children.length:S,a=R.children[g-1];n={offset:a.offset+a.length,length:0,content:","+s}}return T(P,n,c)}else{const s=S,n=R.children[s];let g;if(R.children.length===1)g={offset:R.offset+1,length:R.length-2,content:""};else if(R.children.length-1===s){const a=R.children[s-1],E=a.offset+a.length,r=R.offset+R.length;g={offset:E,length:r-2-E,content:""}}else g={offset:n.offset,length:R.children[s+1].offset-n.offset,content:""};return T(P,g,c)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${R.type}`);else{if(D===void 0)throw new Error("Can not delete in empty document");return T(P,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(D)},c)}}e.setProperty=C;function T(P,L,D){let c=I(P,L),b=L.offset,p=L.offset+L.content.length;if(L.length===0||L.content.length===0){for(;b>0&&!(0,i.isEOL)(c,b-1);)b--;for(;p<c.length&&!(0,i.isEOL)(c,p);)p++}const v=(0,i.format)(c,{offset:b,length:p-b},D);for(let R=v.length-1;R>=0;R--){const S=v[R];c=I(c,S),b=Math.min(b,S.offset),p=Math.max(p,S.offset+S.length),p+=S.content.length-S.length}const w=P.length-(c.length-p)-b;return[{offset:b,length:w,content:c.substring(b,p)}]}e.withFormatting=T;function I(P,L){return P.substring(0,L.offset)+L.content+P.substring(L.offset+L.length)}e.applyEdit=I;function y(P,L){let D=L.slice(0).sort((b,p)=>{const v=b.offset-p.offset;return v===0?b.length-p.length:v}),c=P.length;for(let b=D.length-1;b>=0;b--){let p=D[b];if(p.offset+p.length<=c)P=I(P,p);else throw new Error("Overlapping edit");c=p.offset}return P}e.applyEdits=y}),define(ve[93],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new m(()=>k(this.getValue()))}}e.Lazy=m}),define(ve[6],we([0,1,76,78]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let C=null;function T(t){C=t}if(e.setDisposableTracker=T,k){const t="__is_disposable_tracked__";T(new class{trackDisposable(o){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[t]||console.log(h)},3e3)}setParent(o,h){if(o&&o!==S.None)try{o[t]=!0}catch{}}markAsDisposed(o){if(o&&o!==S.None)try{o[t]=!0}catch{}}markAsSingleton(o){}})}function I(t){return C?.trackDisposable(t),t}function y(t){C?.markAsDisposed(t)}function P(t,o){C?.setParent(t,o)}function L(t,o){if(!!C)for(const h of t)C.setParent(h,o)}function D(t){return C?.markAsSingleton(t),t}e.markAsSingleton=D;class c extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=c;function b(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=b;function p(t){if(i.Iterable.is(t)){let o=[];for(const h of t)if(h)try{h.dispose()}catch(u){o.push(u)}if(o.length===1)throw o[0];if(o.length>1)throw new c(o);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=p;function v(...t){const o=w(()=>p(t));return L(t,o),o}e.combinedDisposable=v;function w(t){const o=I({dispose:(0,m.once)(()=>{y(o),t()})});return o}e.toDisposable=w;class R{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{p(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return P(o,this),this._isDisposed?R.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=R,R.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new R,I(this),P(this._store,this)}dispose(){y(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&P(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&P(o,null),o}}e.MutableDisposable=s;class n{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=n;class g{constructor(){this.references=new Map}acquire(o,...h){let u=this.references.get(o);u||(u={counter:0,object:this.createReferencedObject(o,...h)},this.references.set(o,u));const{object:d}=u,f=(0,m.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(o,u.object),this.references.delete(o))});return u.counter++,{object:d,dispose:f}}}e.ReferenceCollection=g;class a{constructor(o){this.referenceCollection=o}async acquire(o,...h){const u=this.referenceCollection.acquire(o,...h);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(d){throw u.dispose(),d}}}e.AsyncReferenceCollection=a;class E{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=E;function r(t){const o=new R;try{t(o)}finally{o.dispose()}}e.disposeOnReturn=r}),define(ve[94],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(C){this.element=C,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class i{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let C=this._first;for(;C!==m.Undefined;){const T=C.next;C.prev=m.Undefined,C.next=m.Undefined,C=T}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,T){const I=new m(C);if(this._first===m.Undefined)this._first=I,this._last=I;else if(T){const P=this._last;this._last=I,I.prev=P,P.next=I}else{const P=this._first;this._first=I,I.next=P,P.prev=I}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(I))}}shift(){if(this._first!==m.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==m.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==m.Undefined&&C.next!==m.Undefined){const T=C.prev;T.next=C.next,C.next.prev=T}else C.prev===m.Undefined&&C.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):C.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):C.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==m.Undefined;)yield C.element,C=C.next}}e.LinkedList=i}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(Re,Te){for(var De=0;De<Te.length;De++){var se=Te[De];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Re,se.key,se)}}function e(Re,Te,De){return Te&&X(Re.prototype,Te),De&&X(Re,De),Re}function m(Re,Te){if(!!Re){if(typeof Re=="string")return i(Re,Te);var De=Object.prototype.toString.call(Re).slice(8,-1);if(De==="Object"&&Re.constructor&&(De=Re.constructor.name),De==="Map"||De==="Set")return Array.from(Re);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return i(Re,Te)}}function i(Re,Te){(Te==null||Te>Re.length)&&(Te=Re.length);for(var De=0,se=new Array(Te);De<Te;De++)se[De]=Re[De];return se}function k(Re,Te){var De=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(De)return(De=De.call(Re)).next.bind(De);if(Array.isArray(Re)||(De=m(Re))||Te&&Re&&typeof Re.length=="number"){De&&(Re=De);var se=0;return function(){return se>=Re.length?{done:!0}:{done:!1,value:Re[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function T(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function I(Re){C.exports.defaults=Re}C.exports={defaults:T(),getDefaults:T,changeDefaults:I};var y=/[&<>"']/,P=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Te){return c[Te]};function p(Re,Te){if(Te){if(y.test(Re))return Re.replace(P,b)}else if(L.test(Re))return Re.replace(D,b);return Re}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(Re){return Re.replace(v,function(Te,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var R=/(^|[^\[])\^/g;function S(Re,Te){Re=Re.source||Re,Te=Te||"";var De={replace:function(fe,be){return be=be.source||be,be=be.replace(R,"$1"),Re=Re.replace(fe,be),De},getRegex:function(){return new RegExp(Re,Te)}};return De}var s=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(Re,Te,De){if(Re){var se;try{se=decodeURIComponent(w(De)).replace(s,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Te&&!n.test(De)&&(De=o(Te,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var a={},E=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(Re,Te){a[" "+Re]||(E.test(Re)?a[" "+Re]=Re+"/":a[" "+Re]=f(Re,"/",!0)),Re=a[" "+Re];var De=Re.indexOf(":")===-1;return Te.substring(0,2)==="//"?De?Te:Re.replace(r,"$1")+Te:Te.charAt(0)==="/"?De?Te:Re.replace(t,"$1")+Te:Re+Te}var h={exec:function(){}};function u(Re){for(var Te=1,De,se;Te<arguments.length;Te++){De=arguments[Te];for(se in De)Object.prototype.hasOwnProperty.call(De,se)&&(Re[se]=De[se])}return Re}function d(Re,Te){var De=Re.replace(/\|/g,function(be,_e,Ne){for(var Qe=!1,$e=_e;--$e>=0&&Ne[$e]==="\\";)Qe=!Qe;return Qe?"|":" |"}),se=De.split(/ \|/),fe=0;if(se[0].trim()||se.shift(),se[se.length-1].trim()||se.pop(),se.length>Te)se.splice(Te);else for(;se.length<Te;)se.push("");for(;fe<se.length;fe++)se[fe]=se[fe].trim().replace(/\\\|/g,"|");return se}function f(Re,Te,De){var se=Re.length;if(se===0)return"";for(var fe=0;fe<se;){var be=Re.charAt(se-fe-1);if(be===Te&&!De)fe++;else if(be!==Te&&De)fe++;else break}return Re.substr(0,se-fe)}function l(Re,Te){if(Re.indexOf(Te[1])===-1)return-1;for(var De=Re.length,se=0,fe=0;fe<De;fe++)if(Re[fe]==="\\")fe++;else if(Re[fe]===Te[0])se++;else if(Re[fe]===Te[1]&&(se--,se<0))return fe;return-1}function _(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Re,Te){if(Te<1)return"";for(var De="";Te>1;)Te&1&&(De+=Re),Te>>=1,Re+=Re;return De+Re}var N={escape:p,unescape:w,edit:S,cleanUrl:g,resolveUrl:o,noopTest:h,merge:u,splitCells:d,rtrim:f,findClosingBracket:l,checkSanitizeDeprecation:_,repeatString:A},x=C.exports.defaults,F=N.rtrim,O=N.splitCells,z=N.escape,$=N.findClosingBracket;function M(Re,Te,De,se){var fe=Te.href,be=Te.title?z(Te.title):null,_e=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){se.state.inLink=!0;var Ne={type:"link",raw:De,href:fe,title:be,text:_e,tokens:se.inlineTokens(_e,[])};return se.state.inLink=!1,Ne}else return{type:"image",raw:De,href:fe,title:be,text:z(_e)}}function B(Re,Te){var De=Re.match(/^(\s+)(?:```)/);if(De===null)return Te;var se=De[1];return Te.split(`
`).map(function(fe){var be=fe.match(/^\s+/);if(be===null)return fe;var _e=be[0];return _e.length>=se.length?fe.slice(se.length):fe}).join(`
`)}var W=function(){function Re(De){this.options=De||x}var Te=Re.prototype;return Te.space=function(se){var fe=this.rules.block.newline.exec(se);if(fe)return fe[0].length>1?{type:"space",raw:fe[0]}:{raw:`
`}},Te.code=function(se){var fe=this.rules.block.code.exec(se);if(fe){var be=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?be:F(be,`
`)}}},Te.fences=function(se){var fe=this.rules.block.fences.exec(se);if(fe){var be=fe[0],_e=B(be,fe[3]||"");return{type:"code",raw:be,lang:fe[2]?fe[2].trim():fe[2],text:_e}}},Te.heading=function(se){var fe=this.rules.block.heading.exec(se);if(fe){var be=fe[2].trim();if(/#$/.test(be)){var _e=F(be,"#");(this.options.pedantic||!_e||/ $/.test(_e))&&(be=_e.trim())}var Ne={type:"heading",raw:fe[0],depth:fe[1].length,text:be,tokens:[]};return this.lexer.inline(Ne.text,Ne.tokens),Ne}},Te.hr=function(se){var fe=this.rules.block.hr.exec(se);if(fe)return{type:"hr",raw:fe[0]}},Te.blockquote=function(se){var fe=this.rules.block.blockquote.exec(se);if(fe){var be=fe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},Te.list=function(se){var fe=this.rules.block.list.exec(se);if(fe){var be,_e,Ne,Qe,$e,Xe,st,ot,he,ye,de=fe[1].trim(),K=de.length>1,Ie={type:"list",raw:"",ordered:K,start:K?+de.slice(0,-1):"",loose:!1,items:[]};de=K?"\\d{1,9}\\"+de.slice(-1):"\\"+de,this.options.pedantic&&(de=K?de:"[*+-]");for(var Me=new RegExp("^( {0,3}"+de+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");se&&!(this.rules.block.hr.test(se)||!(fe=Me.exec(se)));){he=fe[2].split(`
`),this.options.pedantic?(Qe=2,ye=he[0].trimLeft()):(Qe=fe[2].search(/[^ ]/),Qe=fe[1].length+(Qe>4?1:Qe),ye=he[0].slice(Qe-fe[1].length)),Xe=!1,be=fe[0],!he[0]&&/^ *$/.test(he[1])&&(be=fe[1]+he.slice(0,2).join(`
`)+`
`,Ie.loose=!0,he=[]);var Ze=new RegExp("^ {0,"+Math.min(3,Qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for($e=1;$e<he.length;$e++){if(ot=he[$e],this.options.pedantic&&(ot=ot.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ze.test(ot)){be=fe[1]+he.slice(0,$e).join(`
`)+`
`;break}if(!Xe){ot.trim()||(Xe=!0),ot.search(/[^ ]/)>=Qe?ye+=`
`+ot.slice(Qe):ye+=`
`+ot;continue}if(ot.search(/[^ ]/)>=Qe||!ot.trim()){ye+=`
`+ot.slice(Qe);continue}else{be=fe[1]+he.slice(0,$e).join(`
`)+`
`;break}}Ie.loose||(st?Ie.loose=!0:/\n *\n *$/.test(be)&&(st=!0)),this.options.gfm&&(_e=/^\[[ xX]\] /.exec(ye),_e&&(Ne=_e[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:be,task:!!_e,checked:Ne,loose:!1,text:ye}),Ie.raw+=be,se=se.slice(be.length)}Ie.items[Ie.items.length-1].raw=be.trimRight(),Ie.items[Ie.items.length-1].text=ye.trimRight(),Ie.raw=Ie.raw.trimRight();var qe=Ie.items.length;for($e=0;$e<qe;$e++)this.lexer.state.top=!1,Ie.items[$e].tokens=this.lexer.blockTokens(Ie.items[$e].text,[]),Ie.items[$e].tokens.some(function(ht){return ht.type==="space"})&&(Ie.loose=!0,Ie.items[$e].loose=!0);return Ie}},Te.html=function(se){var fe=this.rules.block.html.exec(se);if(fe){var be={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(fe[0]):z(fe[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},Te.def=function(se){var fe=this.rules.block.def.exec(se);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var be=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:fe[0],href:fe[2],title:fe[3]}}},Te.table=function(se){var fe=this.rules.block.table.exec(se);if(fe){var be={type:"table",header:O(fe[1]).map(function(st){return{text:st}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]?fe[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=fe[0];var _e=be.align.length,Ne,Qe,$e,Xe;for(Ne=0;Ne<_e;Ne++)/^ *-+: *$/.test(be.align[Ne])?be.align[Ne]="right":/^ *:-+: *$/.test(be.align[Ne])?be.align[Ne]="center":/^ *:-+ *$/.test(be.align[Ne])?be.align[Ne]="left":be.align[Ne]=null;for(_e=be.rows.length,Ne=0;Ne<_e;Ne++)be.rows[Ne]=O(be.rows[Ne],be.header.length).map(function(st){return{text:st}});for(_e=be.header.length,Qe=0;Qe<_e;Qe++)be.header[Qe].tokens=[],this.lexer.inlineTokens(be.header[Qe].text,be.header[Qe].tokens);for(_e=be.rows.length,Qe=0;Qe<_e;Qe++)for(Xe=be.rows[Qe],$e=0;$e<Xe.length;$e++)Xe[$e].tokens=[],this.lexer.inlineTokens(Xe[$e].text,Xe[$e].tokens);return be}}},Te.lheading=function(se){var fe=this.rules.block.lheading.exec(se);if(fe){var be={type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Te.paragraph=function(se){var fe=this.rules.block.paragraph.exec(se);if(fe){var be={type:"paragraph",raw:fe[0],text:fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Te.text=function(se){var fe=this.rules.block.text.exec(se);if(fe){var be={type:"text",raw:fe[0],text:fe[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Te.escape=function(se){var fe=this.rules.inline.escape.exec(se);if(fe)return{type:"escape",raw:fe[0],text:z(fe[1])}},Te.tag=function(se){var fe=this.rules.inline.tag.exec(se);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):z(fe[0]):fe[0]}},Te.link=function(se){var fe=this.rules.inline.link.exec(se);if(fe){var be=fe[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var _e=F(be.slice(0,-1),"\\");if((be.length-_e.length)%2==0)return}else{var Ne=$(fe[2],"()");if(Ne>-1){var Qe=fe[0].indexOf("!")===0?5:4,$e=Qe+fe[1].length+Ne;fe[2]=fe[2].substring(0,Ne),fe[0]=fe[0].substring(0,$e).trim(),fe[3]=""}}var Xe=fe[2],st="";if(this.options.pedantic){var ot=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Xe);ot&&(Xe=ot[1],st=ot[3])}else st=fe[3]?fe[3].slice(1,-1):"";return Xe=Xe.trim(),/^</.test(Xe)&&(this.options.pedantic&&!/>$/.test(be)?Xe=Xe.slice(1):Xe=Xe.slice(1,-1)),M(fe,{href:Xe&&Xe.replace(this.rules.inline._escapes,"$1"),title:st&&st.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},Te.reflink=function(se,fe){var be;if((be=this.rules.inline.reflink.exec(se))||(be=this.rules.inline.nolink.exec(se))){var _e=(be[2]||be[1]).replace(/\s+/g," ");if(_e=fe[_e.toLowerCase()],!_e||!_e.href){var Ne=be[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return M(be,_e,be[0],this.lexer)}},Te.emStrong=function(se,fe,be){be===void 0&&(be="");var _e=this.rules.inline.emStrong.lDelim.exec(se);if(!!_e&&!(_e[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=_e[1]||_e[2]||"";if(!Ne||Ne&&(be===""||this.rules.inline.punctuation.exec(be))){var Qe=_e[0].length-1,$e,Xe,st=Qe,ot=0,he=_e[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(he.lastIndex=0,fe=fe.slice(-1*se.length+Qe);(_e=he.exec(fe))!=null;)if($e=_e[1]||_e[2]||_e[3]||_e[4]||_e[5]||_e[6],!!$e){if(Xe=$e.length,_e[3]||_e[4]){st+=Xe;continue}else if((_e[5]||_e[6])&&Qe%3&&!((Qe+Xe)%3)){ot+=Xe;continue}if(st-=Xe,!(st>0)){if(Xe=Math.min(Xe,Xe+st+ot),Math.min(Qe,Xe)%2){var ye=se.slice(1,Qe+_e.index+Xe);return{type:"em",raw:se.slice(0,Qe+_e.index+Xe+1),text:ye,tokens:this.lexer.inlineTokens(ye,[])}}var de=se.slice(2,Qe+_e.index+Xe-1);return{type:"strong",raw:se.slice(0,Qe+_e.index+Xe+1),text:de,tokens:this.lexer.inlineTokens(de,[])}}}}}},Te.codespan=function(se){var fe=this.rules.inline.code.exec(se);if(fe){var be=fe[2].replace(/\n/g," "),_e=/[^ ]/.test(be),Ne=/^ /.test(be)&&/ $/.test(be);return _e&&Ne&&(be=be.substring(1,be.length-1)),be=z(be,!0),{type:"codespan",raw:fe[0],text:be}}},Te.br=function(se){var fe=this.rules.inline.br.exec(se);if(fe)return{type:"br",raw:fe[0]}},Te.del=function(se){var fe=this.rules.inline.del.exec(se);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2],[])}},Te.autolink=function(se,fe){var be=this.rules.inline.autolink.exec(se);if(be){var _e,Ne;return be[2]==="@"?(_e=z(this.options.mangle?fe(be[1]):be[1]),Ne="mailto:"+_e):(_e=z(be[1]),Ne=_e),{type:"link",raw:be[0],text:_e,href:Ne,tokens:[{type:"text",raw:_e,text:_e}]}}},Te.url=function(se,fe){var be;if(be=this.rules.inline.url.exec(se)){var _e,Ne;if(be[2]==="@")_e=z(this.options.mangle?fe(be[0]):be[0]),Ne="mailto:"+_e;else{var Qe;do Qe=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(Qe!==be[0]);_e=z(be[0]),be[1]==="www."?Ne="http://"+_e:Ne=_e}return{type:"link",raw:be[0],text:_e,href:Ne,tokens:[{type:"text",raw:_e,text:_e}]}}},Te.inlineText=function(se,fe){var be=this.rules.inline.text.exec(se);if(be){var _e;return this.lexer.state.inRawBlock?_e=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):z(be[0]):be[0]:_e=z(this.options.smartypants?fe(be[0]):be[0]),{type:"text",raw:be[0],text:_e}}},Re}(),U=N.noopTest,j=N.edit,Z=N.merge,ce={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:U,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ce._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ce._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ce.def=j(ce.def).replace("label",ce._label).replace("title",ce._title).getRegex(),ce.bullet=/(?:[*+-]|\d{1,9}[.)])/,ce.listItemStart=j(/^( *)(bull) */).replace("bull",ce.bullet).getRegex(),ce.list=j(ce.list).replace(/bull/g,ce.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ce.def.source+")").getRegex(),ce._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ce._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ce.html=j(ce.html,"i").replace("comment",ce._comment).replace("tag",ce._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ce.paragraph=j(ce._paragraph).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.blockquote=j(ce.blockquote).replace("paragraph",ce.paragraph).getRegex(),ce.normal=Z({},ce),ce.gfm=Z({},ce.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ce.gfm.table=j(ce.gfm.table).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.pedantic=Z({},ce.normal,{html:j(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ce._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:U,paragraph:j(ce.normal._paragraph).replace("hr",ce.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ce.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:U,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:U,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=j(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=j(ce._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=j(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=j(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=j(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=j(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=j(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=j(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=j(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=j(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=Z({},Q),Q.pedantic=Z({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:j(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:j(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=Z({},Q.normal,{escape:j(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=j(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=Z({},Q.gfm,{br:j(Q.br).replace("{2,}","*").getRegex(),text:j(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var V={block:ce,inline:Q},te=W,me=C.exports.defaults,ge=V.block,ke=V.inline,Be=N.repeatString;function xe(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(Re){var Te="",De,se,fe=Re.length;for(De=0;De<fe;De++)se=Re.charCodeAt(De),Math.random()>.5&&(se="x"+se.toString(16)),Te+="&#"+se+";";return Te}var Y=function(){function Re(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||me,this.options.tokenizer=this.options.tokenizer||new te,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:ge.normal,inline:ke.normal};this.options.pedantic?(se.block=ge.pedantic,se.inline=ke.pedantic):this.options.gfm&&(se.block=ge.gfm,this.options.breaks?se.inline=ke.breaks:se.inline=ke.gfm),this.tokenizer.rules=se}Re.lex=function(se,fe){var be=new Re(fe);return be.lex(se)},Re.lexInline=function(se,fe){var be=new Re(fe);return be.inlineTokens(se)};var Te=Re.prototype;return Te.lex=function(se){se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},Te.blockTokens=function(se,fe){var be=this;fe===void 0&&(fe=[]),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var _e,Ne,Qe,$e;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(st){return(_e=st.call({lexer:be},se,fe))?(se=se.substring(_e.raw.length),fe.push(_e),!0):!1}))){if(_e=this.tokenizer.space(se)){se=se.substring(_e.raw.length),_e.type&&fe.push(_e);continue}if(_e=this.tokenizer.code(se)){se=se.substring(_e.raw.length),Ne=fe[fe.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+_e.raw,Ne.text+=`
`+_e.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):fe.push(_e);continue}if(_e=this.tokenizer.fences(se)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(_e=this.tokenizer.heading(se)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(_e=this.tokenizer.hr(se)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(_e=this.tokenizer.blockquote(se)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(_e=this.tokenizer.list(se)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(_e=this.tokenizer.html(se)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(_e=this.tokenizer.def(se)){se=se.substring(_e.raw.length),Ne=fe[fe.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+_e.raw,Ne.text+=`
`+_e.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[_e.tag]||(this.tokens.links[_e.tag]={href:_e.href,title:_e.title});continue}if(_e=this.tokenizer.table(se)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(_e=this.tokenizer.lheading(se)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(Qe=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var st=1/0,ot=se.slice(1),he=void 0;be.options.extensions.startBlock.forEach(function(ye){he=ye.call({lexer:this},ot),typeof he=="number"&&he>=0&&(st=Math.min(st,he))}),st<1/0&&st>=0&&(Qe=se.substring(0,st+1))}(),this.state.top&&(_e=this.tokenizer.paragraph(Qe))){Ne=fe[fe.length-1],$e&&Ne.type==="paragraph"?(Ne.raw+=`
`+_e.raw,Ne.text+=`
`+_e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):fe.push(_e),$e=Qe.length!==se.length,se=se.substring(_e.raw.length);continue}if(_e=this.tokenizer.text(se)){se=se.substring(_e.raw.length),Ne=fe[fe.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+_e.raw,Ne.text+=`
`+_e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):fe.push(_e);continue}if(se){var Xe="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Xe);break}else throw new Error(Xe)}}return this.state.top=!0,fe},Te.inline=function(se,fe){this.inlineQueue.push({src:se,tokens:fe})},Te.inlineTokens=function(se,fe){var be=this;fe===void 0&&(fe=[]);var _e,Ne,Qe,$e=se,Xe,st,ot;if(this.tokens.links){var he=Object.keys(this.tokens.links);if(he.length>0)for(;(Xe=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)he.includes(Xe[0].slice(Xe[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,Xe.index)+"["+Be("a",Xe[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Xe=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,Xe.index)+"["+Be("a",Xe[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Xe=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,Xe.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(st||(ot=""),st=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(de){return(_e=de.call({lexer:be},se,fe))?(se=se.substring(_e.raw.length),fe.push(_e),!0):!1}))){if(_e=this.tokenizer.escape(se)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(_e=this.tokenizer.tag(se)){se=se.substring(_e.raw.length),Ne=fe[fe.length-1],Ne&&_e.type==="text"&&Ne.type==="text"?(Ne.raw+=_e.raw,Ne.text+=_e.text):fe.push(_e);continue}if(_e=this.tokenizer.link(se)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(_e=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(_e.raw.length),Ne=fe[fe.length-1],Ne&&_e.type==="text"&&Ne.type==="text"?(Ne.raw+=_e.raw,Ne.text+=_e.text):fe.push(_e);continue}if(_e=this.tokenizer.emStrong(se,$e,ot)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(_e=this.tokenizer.codespan(se)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(_e=this.tokenizer.br(se)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(_e=this.tokenizer.del(se)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(_e=this.tokenizer.autolink(se,q)){se=se.substring(_e.raw.length),fe.push(_e);continue}if(!this.state.inLink&&(_e=this.tokenizer.url(se,q))){se=se.substring(_e.raw.length),fe.push(_e);continue}if(Qe=se,this.options.extensions&&this.options.extensions.startInline&&function(){var de=1/0,K=se.slice(1),Ie=void 0;be.options.extensions.startInline.forEach(function(Me){Ie=Me.call({lexer:this},K),typeof Ie=="number"&&Ie>=0&&(de=Math.min(de,Ie))}),de<1/0&&de>=0&&(Qe=se.substring(0,de+1))}(),_e=this.tokenizer.inlineText(Qe,xe)){se=se.substring(_e.raw.length),_e.raw.slice(-1)!=="_"&&(ot=_e.raw.slice(-1)),st=!0,Ne=fe[fe.length-1],Ne&&Ne.type==="text"?(Ne.raw+=_e.raw,Ne.text+=_e.text):fe.push(_e);continue}if(se){var ye="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return fe},e(Re,null,[{key:"rules",get:function(){return{block:ge,inline:ke}}}]),Re}(),re=C.exports.defaults,ue=N.cleanUrl,J=N.escape,ae=function(){function Re(De){this.options=De||re}var Te=Re.prototype;return Te.code=function(se,fe,be){var _e=(fe||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(se,_e);Ne!=null&&Ne!==se&&(be=!0,se=Ne)}return se=se.replace(/\n$/,"")+`
`,_e?'<pre><code class="'+this.options.langPrefix+J(_e,!0)+'">'+(be?se:J(se,!0))+`</code></pre>
`:"<pre><code>"+(be?se:J(se,!0))+`</code></pre>
`},Te.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Te.html=function(se){return se},Te.heading=function(se,fe,be,_e){return this.options.headerIds?"<h"+fe+' id="'+this.options.headerPrefix+_e.slug(be)+'">'+se+"</h"+fe+`>
`:"<h"+fe+">"+se+"</h"+fe+`>
`},Te.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Te.list=function(se,fe,be){var _e=fe?"ol":"ul",Ne=fe&&be!==1?' start="'+be+'"':"";return"<"+_e+Ne+`>
`+se+"</"+_e+`>
`},Te.listitem=function(se){return"<li>"+se+`</li>
`},Te.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Te.paragraph=function(se){return"<p>"+se+`</p>
`},Te.table=function(se,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+fe+`</table>
`},Te.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Te.tablecell=function(se,fe){var be=fe.header?"th":"td",_e=fe.align?"<"+be+' align="'+fe.align+'">':"<"+be+">";return _e+se+"</"+be+`>
`},Te.strong=function(se){return"<strong>"+se+"</strong>"},Te.em=function(se){return"<em>"+se+"</em>"},Te.codespan=function(se){return"<code>"+se+"</code>"},Te.br=function(){return this.options.xhtml?"<br/>":"<br>"},Te.del=function(se){return"<del>"+se+"</del>"},Te.link=function(se,fe,be){if(se=ue(this.options.sanitize,this.options.baseUrl,se),se===null)return be;var _e='<a href="'+J(se)+'"';return fe&&(_e+=' title="'+fe+'"'),_e+=">"+be+"</a>",_e},Te.image=function(se,fe,be){if(se=ue(this.options.sanitize,this.options.baseUrl,se),se===null)return be;var _e='<img src="'+se+'" alt="'+be+'"';return fe&&(_e+=' title="'+fe+'"'),_e+=this.options.xhtml?"/>":">",_e},Te.text=function(se){return se},Re}(),Ee=function(){function Re(){}var Te=Re.prototype;return Te.strong=function(se){return se},Te.em=function(se){return se},Te.codespan=function(se){return se},Te.del=function(se){return se},Te.html=function(se){return se},Te.text=function(se){return se},Te.link=function(se,fe,be){return""+be},Te.image=function(se,fe,be){return""+be},Te.br=function(){return""},Re}(),Oe=function(){function Re(){this.seen={}}var Te=Re.prototype;return Te.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Te.getNextSafeSlug=function(se,fe){var be=se,_e=0;if(this.seen.hasOwnProperty(be)){_e=this.seen[se];do _e++,be=se+"-"+_e;while(this.seen.hasOwnProperty(be))}return fe||(this.seen[se]=_e,this.seen[be]=0),be},Te.slug=function(se,fe){fe===void 0&&(fe={});var be=this.serialize(se);return this.getNextSafeSlug(be,fe.dryrun)},Re}(),Ve=ae,Ke=Ee,Je=Oe,it=C.exports.defaults,at=N.unescape,et=function(){function Re(De){this.options=De||it,this.options.renderer=this.options.renderer||new Ve,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Je}Re.parse=function(se,fe){var be=new Re(fe);return be.parse(se)},Re.parseInline=function(se,fe){var be=new Re(fe);return be.parseInline(se)};var Te=Re.prototype;return Te.parse=function(se,fe){fe===void 0&&(fe=!0);var be="",_e,Ne,Qe,$e,Xe,st,ot,he,ye,de,K,Ie,Me,Ze,qe,ht,Et,Dt,bt,mt=se.length;for(_e=0;_e<mt;_e++){if(de=se[_e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(bt=this.options.extensions.renderers[de.type].call({parser:this},de),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(de.type))){be+=bt||"";continue}switch(de.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(de.tokens),de.depth,at(this.parseInline(de.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(de.text,de.lang,de.escaped);continue}case"table":{for(he="",ot="",$e=de.header.length,Ne=0;Ne<$e;Ne++)ot+=this.renderer.tablecell(this.parseInline(de.header[Ne].tokens),{header:!0,align:de.align[Ne]});for(he+=this.renderer.tablerow(ot),ye="",$e=de.rows.length,Ne=0;Ne<$e;Ne++){for(st=de.rows[Ne],ot="",Xe=st.length,Qe=0;Qe<Xe;Qe++)ot+=this.renderer.tablecell(this.parseInline(st[Qe].tokens),{header:!1,align:de.align[Qe]});ye+=this.renderer.tablerow(ot)}be+=this.renderer.table(he,ye);continue}case"blockquote":{ye=this.parse(de.tokens),be+=this.renderer.blockquote(ye);continue}case"list":{for(K=de.ordered,Ie=de.start,Me=de.loose,$e=de.items.length,ye="",Ne=0;Ne<$e;Ne++)qe=de.items[Ne],ht=qe.checked,Et=qe.task,Ze="",qe.task&&(Dt=this.renderer.checkbox(ht),Me?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=Dt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=Dt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:Dt}):Ze+=Dt),Ze+=this.parse(qe.tokens,Me),ye+=this.renderer.listitem(Ze,Et,ht);be+=this.renderer.list(ye,K,Ie);continue}case"html":{be+=this.renderer.html(de.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(de.tokens));continue}case"text":{for(ye=de.tokens?this.parseInline(de.tokens):de.text;_e+1<mt&&se[_e+1].type==="text";)de=se[++_e],ye+=`
`+(de.tokens?this.parseInline(de.tokens):de.text);be+=fe?this.renderer.paragraph(ye):ye;continue}default:{var wt='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(wt);return}else throw new Error(wt)}}}return be},Te.parseInline=function(se,fe){fe=fe||this.renderer;var be="",_e,Ne,Qe,$e=se.length;for(_e=0;_e<$e;_e++){if(Ne=se[_e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(Qe=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),Qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){be+=Qe||"";continue}switch(Ne.type){case"escape":{be+=fe.text(Ne.text);break}case"html":{be+=fe.html(Ne.text);break}case"link":{be+=fe.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,fe));break}case"image":{be+=fe.image(Ne.href,Ne.title,Ne.text);break}case"strong":{be+=fe.strong(this.parseInline(Ne.tokens,fe));break}case"em":{be+=fe.em(this.parseInline(Ne.tokens,fe));break}case"codespan":{be+=fe.codespan(Ne.text);break}case"br":{be+=fe.br();break}case"del":{be+=fe.del(this.parseInline(Ne.tokens,fe));break}case"text":{be+=fe.text(Ne.text);break}default:{var Xe='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return be},Re}(),nt=Y,ct=et,vt=W,We=ae,At=Ee,ee=Oe,ie=N.merge,Se=N.checkSanitizeDeprecation,ne=N.escape,Ce=C.exports.getDefaults,Fe=C.exports.changeDefaults,Ge=C.exports.defaults;function ze(Re,Te,De){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof Te=="function"&&(De=Te,Te=null),Te=ie({},ze.defaults,Te||{}),Se(Te),De){var se=Te.highlight,fe;try{fe=nt.lex(Re,Te)}catch(Qe){return De(Qe)}var be=function($e){var Xe;if(!$e)try{Te.walkTokens&&ze.walkTokens(fe,Te.walkTokens),Xe=ct.parse(fe,Te)}catch(st){$e=st}return Te.highlight=se,$e?De($e):De(null,Xe)};if(!se||se.length<3||(delete Te.highlight,!fe.length))return be();var _e=0;ze.walkTokens(fe,function(Qe){Qe.type==="code"&&(_e++,setTimeout(function(){se(Qe.text,Qe.lang,function($e,Xe){if($e)return be($e);Xe!=null&&Xe!==Qe.text&&(Qe.text=Xe,Qe.escaped=!0),_e--,_e===0&&be()})},0))}),_e===0&&be();return}try{var Ne=nt.lex(Re,Te);return Te.walkTokens&&ze.walkTokens(Ne,Te.walkTokens),ct.parse(Ne,Te)}catch(Qe){if(Qe.message+=`
Please report this to https://github.com/markedjs/marked.`,Te.silent)return"<p>An error occurred:</p><pre>"+ne(Qe.message+"",!0)+"</pre>";throw Qe}}ze.options=ze.setOptions=function(Re){return ie(ze.defaults,Re),Fe(ze.defaults),ze},ze.getDefaults=Ce,ze.defaults=Ge,ze.use=function(){for(var Re=this,Te=arguments.length,De=new Array(Te),se=0;se<Te;se++)De[se]=arguments[se];var fe=ie.apply(void 0,[{}].concat(De)),be=ze.defaults.extensions||{renderers:{},childTokens:{}},_e;De.forEach(function(Ne){if(Ne.extensions&&(_e=!0,Ne.extensions.forEach(function($e){if(!$e.name)throw new Error("extension name required");if($e.renderer){var Xe=be.renderers?be.renderers[$e.name]:null;Xe?be.renderers[$e.name]=function(){for(var st=arguments.length,ot=new Array(st),he=0;he<st;he++)ot[he]=arguments[he];var ye=$e.renderer.apply(this,ot);return ye===!1&&(ye=Xe.apply(this,ot)),ye}:be.renderers[$e.name]=$e.renderer}if($e.tokenizer){if(!$e.level||$e.level!=="block"&&$e.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[$e.level]?be[$e.level].unshift($e.tokenizer):be[$e.level]=[$e.tokenizer],$e.start&&($e.level==="block"?be.startBlock?be.startBlock.push($e.start):be.startBlock=[$e.start]:$e.level==="inline"&&(be.startInline?be.startInline.push($e.start):be.startInline=[$e.start]))}$e.childTokens&&(be.childTokens[$e.name]=$e.childTokens)})),Ne.renderer&&function(){var $e=ze.defaults.renderer||new We,Xe=function(he){var ye=$e[he];$e[he]=function(){for(var de=arguments.length,K=new Array(de),Ie=0;Ie<de;Ie++)K[Ie]=arguments[Ie];var Me=Ne.renderer[he].apply($e,K);return Me===!1&&(Me=ye.apply($e,K)),Me}};for(var st in Ne.renderer)Xe(st);fe.renderer=$e}(),Ne.tokenizer&&function(){var $e=ze.defaults.tokenizer||new vt,Xe=function(he){var ye=$e[he];$e[he]=function(){for(var de=arguments.length,K=new Array(de),Ie=0;Ie<de;Ie++)K[Ie]=arguments[Ie];var Me=Ne.tokenizer[he].apply($e,K);return Me===!1&&(Me=ye.apply($e,K)),Me}};for(var st in Ne.tokenizer)Xe(st);fe.tokenizer=$e}(),Ne.walkTokens){var Qe=ze.defaults.walkTokens;fe.walkTokens=function($e){Ne.walkTokens.call(Re,$e),Qe&&Qe($e)}}_e&&(fe.extensions=be),ze.setOptions(fe)})},ze.walkTokens=function(Re,Te){for(var De=function(){var _e=fe.value;switch(Te(_e),_e.type){case"table":{for(var Ne=k(_e.header),Qe;!(Qe=Ne()).done;){var $e=Qe.value;ze.walkTokens($e.tokens,Te)}for(var Xe=k(_e.rows),st;!(st=Xe()).done;)for(var ot=st.value,he=k(ot),ye;!(ye=he()).done;){var de=ye.value;ze.walkTokens(de.tokens,Te)}break}case"list":{ze.walkTokens(_e.items,Te);break}default:ze.defaults.extensions&&ze.defaults.extensions.childTokens&&ze.defaults.extensions.childTokens[_e.type]?ze.defaults.extensions.childTokens[_e.type].forEach(function(K){ze.walkTokens(_e[K],Te)}):_e.tokens&&ze.walkTokens(_e.tokens,Te)}},se=k(Re),fe;!(fe=se()).done;)De()},ze.parseInline=function(Re,Te){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");Te=ie({},ze.defaults,Te||{}),Se(Te);try{var De=nt.lexInline(Re,Te);return Te.walkTokens&&ze.walkTokens(De,Te.walkTokens),ct.parseInline(De,Te)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Te.silent)return"<p>An error occurred:</p><pre>"+ne(se.message+"",!0)+"</pre>";throw se}},ze.Parser=ct,ze.parser=ct.parse,ze.Renderer=We,ze.TextRenderer=At,ze.Lexer=nt,ze.lexer=nt.lex,ze.Tokenizer=vt,ze.Slugger=ee,ze.parse=ze;var ut=ze;return ut}),define(ve[79],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(T,I,y){return Math.min(Math.max(T,I),y)}e.clamp=m;function i(T,I){return(I+T%I)%I}e.rot=i;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class C{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function X(k){const C=[];typeof k=="number"&&C.push("code/timeOrigin",k);function T(y){C.push(y,Date.now())}function I(){const y=[];for(let P=0;P<C.length;P+=2)y.push({name:C[P],startTime:C[P+1]});return y}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))C.push({name:T.name,startTime:Math.round(k+T.startTime)});return C}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function m(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=m(i))}(),define(ve[12],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let i=!1,k=!1,C=!1,T=!1,I=!1,y=!1,P=!1,L=!1,D,c=m,b,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const w=typeof v?.versions?.electron=="string",R=w&&v?.type==="renderer";if(e.isElectronSandboxed=R&&v?.sandboxed,typeof navigator=="object"&&!R)p=navigator.userAgent,i=p.indexOf("Windows")>=0,k=p.indexOf("Macintosh")>=0,L=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=p.indexOf("Linux")>=0,y=!0,D=navigator.language,c=D;else if(typeof v=="object"){i=v.platform==="win32",k=v.platform==="darwin",C=v.platform==="linux",T=C&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,P=w,D=m,c=m;const o=v.env.VSCODE_NLS_CONFIG;if(o)try{const h=JSON.parse(o),u=h.availableLanguages["*"];D=h.locale,c=u||m,b=h._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var S;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function s(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=s;let n=0;k?n=1:i?n=3:C&&(n=2),e.isWindows=i,e.isMacintosh=k,e.isLinux=C,e.isLinuxSnap=T,e.isNative=I,e.isElectron=P,e.isWeb=y,e.isIOS=L,e.platform=n,e.userAgent=p,e.language=c;var g;(function(o){function h(){return e.language}o.value=h;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=u;function d(){return e.language==="en"}o.isDefault=d})(g=e.Language||(e.Language={})),e.locale=D,e.translationsConfigFile=b,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let d=0,f=o.length;d<f;d++){const l=o[d];if(l.id===u.data.vscodeScheduleAsyncWork){o.splice(d,1),l.callback();return}}});let h=0;return u=>{const d=++h;o.push({id:d,callback:u}),e.globals.postMessage({vscodeScheduleAsyncWork:d},"*")}}return o=>setTimeout(o)})();var a;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||L?2:i?1:3;let E=!0,r=!1;function t(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,E=new Uint16Array(o.buffer)[0]===(2<<8)+1}return E}e.isLittleEndian=t}),define(ve[40],we([0,1,12]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const k=m.globals.vscode.process;i={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(ve[8],we([0,1,40]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,k=97,C=90,T=122,I=46,y=47,P=92,L=58,D=63;class c extends Error{constructor(n,g,a){let E;typeof g=="string"&&g.indexOf("not ")===0?(E="must not be",g=g.replace(/^not /,"")):E="must be";const r=n.indexOf(".")!==-1?"property":"argument";let t=`The "${n}" ${r} ${E} of type ${g}`;t+=`. Received type ${typeof a}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function b(s,n){if(typeof s!="string")throw new c(n,"string",s)}function p(s){return s===y||s===P}function v(s){return s===y}function w(s){return s>=i&&s<=C||s>=k&&s<=T}function R(s,n,g,a){let E="",r=0,t=-1,o=0,h=0;for(let u=0;u<=s.length;++u){if(u<s.length)h=s.charCodeAt(u);else{if(a(h))break;h=y}if(a(h)){if(!(t===u-1||o===1))if(o===2){if(E.length<2||r!==2||E.charCodeAt(E.length-1)!==I||E.charCodeAt(E.length-2)!==I){if(E.length>2){const d=E.lastIndexOf(g);d===-1?(E="",r=0):(E=E.slice(0,d),r=E.length-1-E.lastIndexOf(g)),t=u,o=0;continue}else if(E.length!==0){E="",r=0,t=u,o=0;continue}}n&&(E+=E.length>0?`${g}..`:"..",r=2)}else E.length>0?E+=`${g}${s.slice(t+1,u)}`:E=s.slice(t+1,u),r=u-t-1;t=u,o=0}else h===I&&o!==-1?++o:o=-1}return E}function S(s,n){if(n===null||typeof n!="object")throw new c("pathObject","Object",n);const g=n.dir||n.root,a=n.base||`${n.name||""}${n.ext||""}`;return g?g===n.root?`${g}${a}`:`${g}${s}${a}`:a}e.win32={resolve(...s){let n="",g="",a=!1;for(let E=s.length-1;E>=-1;E--){let r;if(E>=0){if(r=s[E],b(r,"path"),r.length===0)continue}else n.length===0?r=m.cwd():(r=m.env[`=${n}`]||m.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==n.toLowerCase()&&r.charCodeAt(2)===P)&&(r=`${n}\\`));const t=r.length;let o=0,h="",u=!1;const d=r.charCodeAt(0);if(t===1)p(d)&&(o=1,u=!0);else if(p(d))if(u=!0,p(r.charCodeAt(1))){let f=2,l=f;for(;f<t&&!p(r.charCodeAt(f));)f++;if(f<t&&f!==l){const _=r.slice(l,f);for(l=f;f<t&&p(r.charCodeAt(f));)f++;if(f<t&&f!==l){for(l=f;f<t&&!p(r.charCodeAt(f));)f++;(f===t||f!==l)&&(h=`\\\\${_}\\${r.slice(l,f)}`,o=f)}}}else o=1;else w(d)&&r.charCodeAt(1)===L&&(h=r.slice(0,2),o=2,t>2&&p(r.charCodeAt(2))&&(u=!0,o=3));if(h.length>0)if(n.length>0){if(h.toLowerCase()!==n.toLowerCase())continue}else n=h;if(a){if(n.length>0)break}else if(g=`${r.slice(o)}\\${g}`,a=u,u&&n.length>0)break}return g=R(g,!a,"\\",p),a?`${n}\\${g}`:`${n}${g}`||"."},normalize(s){b(s,"path");const n=s.length;if(n===0)return".";let g=0,a,E=!1;const r=s.charCodeAt(0);if(n===1)return v(r)?"\\":s;if(p(r))if(E=!0,p(s.charCodeAt(1))){let o=2,h=o;for(;o<n&&!p(s.charCodeAt(o));)o++;if(o<n&&o!==h){const u=s.slice(h,o);for(h=o;o<n&&p(s.charCodeAt(o));)o++;if(o<n&&o!==h){for(h=o;o<n&&!p(s.charCodeAt(o));)o++;if(o===n)return`\\\\${u}\\${s.slice(h)}\\`;o!==h&&(a=`\\\\${u}\\${s.slice(h,o)}`,g=o)}}}else g=1;else w(r)&&s.charCodeAt(1)===L&&(a=s.slice(0,2),g=2,n>2&&p(s.charCodeAt(2))&&(E=!0,g=3));let t=g<n?R(s.slice(g),!E,"\\",p):"";return t.length===0&&!E&&(t="."),t.length>0&&p(s.charCodeAt(n-1))&&(t+="\\"),a===void 0?E?`\\${t}`:t:E?`${a}\\${t}`:`${a}${t}`},isAbsolute(s){b(s,"path");const n=s.length;if(n===0)return!1;const g=s.charCodeAt(0);return p(g)||n>2&&w(g)&&s.charCodeAt(1)===L&&p(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let n,g;for(let r=0;r<s.length;++r){const t=s[r];b(t,"path"),t.length>0&&(n===void 0?n=g=t:n+=`\\${t}`)}if(n===void 0)return".";let a=!0,E=0;if(typeof g=="string"&&p(g.charCodeAt(0))){++E;const r=g.length;r>1&&p(g.charCodeAt(1))&&(++E,r>2&&(p(g.charCodeAt(2))?++E:a=!1))}if(a){for(;E<n.length&&p(n.charCodeAt(E));)E++;E>=2&&(n=`\\${n.slice(E)}`)}return e.win32.normalize(n)},relative(s,n){if(b(s,"from"),b(n,"to"),s===n)return"";const g=e.win32.resolve(s),a=e.win32.resolve(n);if(g===a||(s=g.toLowerCase(),n=a.toLowerCase(),s===n))return"";let E=0;for(;E<s.length&&s.charCodeAt(E)===P;)E++;let r=s.length;for(;r-1>E&&s.charCodeAt(r-1)===P;)r--;const t=r-E;let o=0;for(;o<n.length&&n.charCodeAt(o)===P;)o++;let h=n.length;for(;h-1>o&&n.charCodeAt(h-1)===P;)h--;const u=h-o,d=t<u?t:u;let f=-1,l=0;for(;l<d;l++){const A=s.charCodeAt(E+l);if(A!==n.charCodeAt(o+l))break;A===P&&(f=l)}if(l!==d){if(f===-1)return a}else{if(u>d){if(n.charCodeAt(o+l)===P)return a.slice(o+l+1);if(l===2)return a.slice(o+l)}t>d&&(s.charCodeAt(E+l)===P?f=l:l===2&&(f=3)),f===-1&&(f=0)}let _="";for(l=E+f+1;l<=r;++l)(l===r||s.charCodeAt(l)===P)&&(_+=_.length===0?"..":"\\..");return o+=f,_.length>0?`${_}${a.slice(o,h)}`:(a.charCodeAt(o)===P&&++o,a.slice(o,h))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const n=e.win32.resolve(s);if(n.length<=2)return s;if(n.charCodeAt(0)===P){if(n.charCodeAt(1)===P){const g=n.charCodeAt(2);if(g!==D&&g!==I)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(w(n.charCodeAt(0))&&n.charCodeAt(1)===L&&n.charCodeAt(2)===P)return`\\\\?\\${n}`;return s},dirname(s){b(s,"path");const n=s.length;if(n===0)return".";let g=-1,a=0;const E=s.charCodeAt(0);if(n===1)return p(E)?s:".";if(p(E)){if(g=a=1,p(s.charCodeAt(1))){let o=2,h=o;for(;o<n&&!p(s.charCodeAt(o));)o++;if(o<n&&o!==h){for(h=o;o<n&&p(s.charCodeAt(o));)o++;if(o<n&&o!==h){for(h=o;o<n&&!p(s.charCodeAt(o));)o++;if(o===n)return s;o!==h&&(g=a=o+1)}}}}else w(E)&&s.charCodeAt(1)===L&&(g=n>2&&p(s.charCodeAt(2))?3:2,a=g);let r=-1,t=!0;for(let o=n-1;o>=a;--o)if(p(s.charCodeAt(o))){if(!t){r=o;break}}else t=!1;if(r===-1){if(g===-1)return".";r=g}return s.slice(0,r)},basename(s,n){n!==void 0&&b(n,"ext"),b(s,"path");let g=0,a=-1,E=!0,r;if(s.length>=2&&w(s.charCodeAt(0))&&s.charCodeAt(1)===L&&(g=2),n!==void 0&&n.length>0&&n.length<=s.length){if(n===s)return"";let t=n.length-1,o=-1;for(r=s.length-1;r>=g;--r){const h=s.charCodeAt(r);if(p(h)){if(!E){g=r+1;break}}else o===-1&&(E=!1,o=r+1),t>=0&&(h===n.charCodeAt(t)?--t==-1&&(a=r):(t=-1,a=o))}return g===a?a=o:a===-1&&(a=s.length),s.slice(g,a)}for(r=s.length-1;r>=g;--r)if(p(s.charCodeAt(r))){if(!E){g=r+1;break}}else a===-1&&(E=!1,a=r+1);return a===-1?"":s.slice(g,a)},extname(s){b(s,"path");let n=0,g=-1,a=0,E=-1,r=!0,t=0;s.length>=2&&s.charCodeAt(1)===L&&w(s.charCodeAt(0))&&(n=a=2);for(let o=s.length-1;o>=n;--o){const h=s.charCodeAt(o);if(p(h)){if(!r){a=o+1;break}continue}E===-1&&(r=!1,E=o+1),h===I?g===-1?g=o:t!==1&&(t=1):g!==-1&&(t=-1)}return g===-1||E===-1||t===0||t===1&&g===E-1&&g===a+1?"":s.slice(g,E)},format:S.bind(null,"\\"),parse(s){b(s,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return n;const g=s.length;let a=0,E=s.charCodeAt(0);if(g===1)return p(E)?(n.root=n.dir=s,n):(n.base=n.name=s,n);if(p(E)){if(a=1,p(s.charCodeAt(1))){let f=2,l=f;for(;f<g&&!p(s.charCodeAt(f));)f++;if(f<g&&f!==l){for(l=f;f<g&&p(s.charCodeAt(f));)f++;if(f<g&&f!==l){for(l=f;f<g&&!p(s.charCodeAt(f));)f++;f===g?a=f:f!==l&&(a=f+1)}}}}else if(w(E)&&s.charCodeAt(1)===L){if(g<=2)return n.root=n.dir=s,n;if(a=2,p(s.charCodeAt(2))){if(g===3)return n.root=n.dir=s,n;a=3}}a>0&&(n.root=s.slice(0,a));let r=-1,t=a,o=-1,h=!0,u=s.length-1,d=0;for(;u>=a;--u){if(E=s.charCodeAt(u),p(E)){if(!h){t=u+1;break}continue}o===-1&&(h=!1,o=u+1),E===I?r===-1?r=u:d!==1&&(d=1):r!==-1&&(d=-1)}return o!==-1&&(r===-1||d===0||d===1&&r===o-1&&r===t+1?n.base=n.name=s.slice(t,o):(n.name=s.slice(t,r),n.base=s.slice(t,o),n.ext=s.slice(r,o))),t>0&&t!==a?n.dir=s.slice(0,t-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...s){let n="",g=!1;for(let a=s.length-1;a>=-1&&!g;a--){const E=a>=0?s[a]:m.cwd();b(E,"path"),E.length!==0&&(n=`${E}/${n}`,g=E.charCodeAt(0)===y)}return n=R(n,!g,"/",v),g?`/${n}`:n.length>0?n:"."},normalize(s){if(b(s,"path"),s.length===0)return".";const n=s.charCodeAt(0)===y,g=s.charCodeAt(s.length-1)===y;return s=R(s,!n,"/",v),s.length===0?n?"/":g?"./":".":(g&&(s+="/"),n?`/${s}`:s)},isAbsolute(s){return b(s,"path"),s.length>0&&s.charCodeAt(0)===y},join(...s){if(s.length===0)return".";let n;for(let g=0;g<s.length;++g){const a=s[g];b(a,"path"),a.length>0&&(n===void 0?n=a:n+=`/${a}`)}return n===void 0?".":e.posix.normalize(n)},relative(s,n){if(b(s,"from"),b(n,"to"),s===n||(s=e.posix.resolve(s),n=e.posix.resolve(n),s===n))return"";const g=1,a=s.length,E=a-g,r=1,t=n.length-r,o=E<t?E:t;let h=-1,u=0;for(;u<o;u++){const f=s.charCodeAt(g+u);if(f!==n.charCodeAt(r+u))break;f===y&&(h=u)}if(u===o)if(t>o){if(n.charCodeAt(r+u)===y)return n.slice(r+u+1);if(u===0)return n.slice(r+u)}else E>o&&(s.charCodeAt(g+u)===y?h=u:u===0&&(h=0));let d="";for(u=g+h+1;u<=a;++u)(u===a||s.charCodeAt(u)===y)&&(d+=d.length===0?"..":"/..");return`${d}${n.slice(r+h)}`},toNamespacedPath(s){return s},dirname(s){if(b(s,"path"),s.length===0)return".";const n=s.charCodeAt(0)===y;let g=-1,a=!0;for(let E=s.length-1;E>=1;--E)if(s.charCodeAt(E)===y){if(!a){g=E;break}}else a=!1;return g===-1?n?"/":".":n&&g===1?"//":s.slice(0,g)},basename(s,n){n!==void 0&&b(n,"ext"),b(s,"path");let g=0,a=-1,E=!0,r;if(n!==void 0&&n.length>0&&n.length<=s.length){if(n===s)return"";let t=n.length-1,o=-1;for(r=s.length-1;r>=0;--r){const h=s.charCodeAt(r);if(h===y){if(!E){g=r+1;break}}else o===-1&&(E=!1,o=r+1),t>=0&&(h===n.charCodeAt(t)?--t==-1&&(a=r):(t=-1,a=o))}return g===a?a=o:a===-1&&(a=s.length),s.slice(g,a)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===y){if(!E){g=r+1;break}}else a===-1&&(E=!1,a=r+1);return a===-1?"":s.slice(g,a)},extname(s){b(s,"path");let n=-1,g=0,a=-1,E=!0,r=0;for(let t=s.length-1;t>=0;--t){const o=s.charCodeAt(t);if(o===y){if(!E){g=t+1;break}continue}a===-1&&(E=!1,a=t+1),o===I?n===-1?n=t:r!==1&&(r=1):n!==-1&&(r=-1)}return n===-1||a===-1||r===0||r===1&&n===a-1&&n===g+1?"":s.slice(n,a)},format:S.bind(null,"/"),parse(s){b(s,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return n;const g=s.charCodeAt(0)===y;let a;g?(n.root="/",a=1):a=0;let E=-1,r=0,t=-1,o=!0,h=s.length-1,u=0;for(;h>=a;--h){const d=s.charCodeAt(h);if(d===y){if(!o){r=h+1;break}continue}t===-1&&(o=!1,t=h+1),d===I?E===-1?E=h:u!==1&&(u=1):E!==-1&&(u=-1)}if(t!==-1){const d=r===0&&g?1:r;E===-1||u===0||u===1&&E===t-1&&E===r+1?n.base=n.name=s.slice(d,t):(n.name=s.slice(d,E),n.base=s.slice(d,t),n.ext=s.slice(E,t))}return r>0?n.dir=s.slice(0,r-1):g&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[95],we([0,1,8]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var i;(function(D){D.text="text/plain",D.binary="application/octet-stream",D.unknown="application/unknown",D.markdown="text/markdown",D.latex="text/latex"})(i=e.Mimes||(e.Mimes={}));const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(D){const c=(0,m.extname)(D),b=k[c.toLowerCase()];return b!==void 0?b:I(D)}e.getMediaOrTextMime=T;function I(D){const c=(0,m.extname)(D);return C[c.toLowerCase()]}e.getMediaMime=I;function y(D){for(const c in C)if(C[c]===D)return c}e.getExtensionForMimeType=y;const P=/^(.+)\/(.+?)(;.+)?$/;function L(D,c){const b=P.exec(D);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:c?void 0:D}e.normalizeMimeType=L}),define(ve[96],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var i;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(i=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(C,...T){const I=T.reduce((L,D)=>(L[D]=!0,L),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(L=>!I[L]).forEach(L=>{for(let D=0;D<y.length;D++)if(L.search(y[D])!==-1){delete C[L];break}})}e.sanitizeProcessEnvironment=k}),define(ve[46],we([0,1,12]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=m.globals.performance&&typeof m.globals.performance.now=="function";class k{constructor(T){this._highResolution=i&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new k(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ve[3],we([0,1,15,76,6,94,46]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(n){n.None=()=>k.Disposable.None;function g(M){return(B,W=null,U)=>{let j=!1,Z;return Z=M(ce=>{if(!j)return Z?Z.dispose():j=!0,B.call(W,ce)},null,U),j&&Z.dispose(),Z}}n.once=g;function a(M,B){return u((W,U=null,j)=>M(Z=>W.call(U,B(Z)),null,j))}n.map=a;function E(M,B){return u((W,U=null,j)=>M(Z=>{B(Z),W.call(U,Z)},null,j))}n.forEach=E;function r(M,B){return u((W,U=null,j)=>M(Z=>B(Z)&&W.call(U,Z),null,j))}n.filter=r;function t(M){return M}n.signal=t;function o(...M){return(B,W=null,U)=>(0,k.combinedDisposable)(...M.map(j=>j(Z=>B.call(W,Z),null,U)))}n.any=o;function h(M,B,W){let U=W;return a(M,j=>(U=B(U,j),U))}n.reduce=h;function u(M){let B;const W=new c({onFirstListenerAdd(){B=M(W.fire,W)},onLastListenerRemove(){B.dispose()}});return W.event}function d(M,B,W,U=100,j=!1){let Z,ce,Q=0;return M(V=>{Q++,Z=W(Z,V),j&&!ce&&(B(Z),Z=void 0),clearTimeout(ce),ce=setTimeout(()=>{const te=Z;Z=void 0,ce=void 0,(!j||Q>1)&&B(te),Q=0},U)})}n.debouncedListener=d;function f(M,B,W=100,U=!1,j){let Z,ce,Q,V=0;const te=new c({leakWarningThreshold:j,onFirstListenerAdd(){Z=M(me=>{V++,ce=B(ce,me),U&&!Q&&(te.fire(ce),ce=void 0),clearTimeout(Q),Q=setTimeout(()=>{const ge=ce;ce=void 0,Q=void 0,(!U||V>1)&&te.fire(ge),V=0},W)})},onLastListenerRemove(){Z.dispose()}});return te.event}n.debounce=f;function l(M,B=(W,U)=>W===U){let W=!0,U;return r(M,j=>{const Z=W||!B(j,U);return W=!1,U=j,Z})}n.latch=l;function _(M,B){return[n.filter(M,B),n.filter(M,W=>!B(W))]}n.split=_;function A(M,B=!1,W=[]){let U=W.slice(),j=M(Q=>{U?U.push(Q):ce.fire(Q)});const Z=()=>{U&&U.forEach(Q=>ce.fire(Q)),U=null},ce=new c({onFirstListenerAdd(){j||(j=M(Q=>ce.fire(Q)))},onFirstListenerDidAdd(){U&&(B?setTimeout(Z):Z())},onLastListenerRemove(){j&&j.dispose(),j=null}});return ce.event}n.buffer=A;class N{constructor(B){this.event=B}map(B){return new N(a(this.event,B))}forEach(B){return new N(E(this.event,B))}filter(B){return new N(r(this.event,B))}reduce(B,W){return new N(h(this.event,B,W))}latch(){return new N(l(this.event))}debounce(B,W=100,U=!1,j){return new N(f(this.event,B,W,U,j))}on(B,W,U){return this.event(B,W,U)}once(B,W,U){return g(this.event)(B,W,U)}}function x(M){return new N(M)}n.chain=x;function F(M,B,W=U=>U){const U=(...Q)=>ce.fire(W(...Q)),j=()=>M.on(B,U),Z=()=>M.removeListener(B,U),ce=new c({onFirstListenerAdd:j,onLastListenerRemove:Z});return ce.event}n.fromNodeEventEmitter=F;function O(M,B,W=U=>U){const U=(...Q)=>ce.fire(W(...Q)),j=()=>M.addEventListener(B,U),Z=()=>M.removeEventListener(B,U),ce=new c({onFirstListenerAdd:j,onLastListenerRemove:Z});return ce.event}n.fromDOMEventEmitter=O;function z(M){return new Promise(B=>g(M)(B))}n.toPromise=z;function $(M,B){return B(void 0),M(W=>B(W))}n.runAndSubscribe=$})(I=e.Event||(e.Event={}));class y{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${y._idPool++}`}start(g){this._stopWatch=new T.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let P=-1;function L(n){const g=P;return P=n,{dispose(){P=g}}}e.setGlobalLeakWarningThreshold=L;class D{constructor(g,a=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g){let a=P;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||g<a)return;this._stacks||(this._stacks=new Map);const E=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(E)||0;if(this._stacks.set(E,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let t,o=0;for(const[h,u]of this._stacks)(!t||o<u)&&(t=h,o=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${o}):`),console.warn(t)}return()=>{const t=this._stacks.get(E)||0;this._stacks.set(E,t-1)}}}class c{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=P>0?new D(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(g,a,E)=>{this._listeners||(this._listeners=new C.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(a?[g,a]:g);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,a);const o=this._leakageMon?.check(this._listeners.size),h=(0,k.toDisposable)(()=>{o&&o(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return E instanceof k.DisposableStore?E.add(h):Array.isArray(E)&&E.push(h),h}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,g]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,E]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,E):a[0].call(a[1],E)}catch(r){(0,m.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class b extends c{async fireAsync(g,a,E){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,g]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[r,t]=this._asyncDeliveryQueue.shift(),o=[],h={...t,token:a,waitUntil:u=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");E&&(u=E(u,typeof r=="function"?r:r[0])),o.push(u)}};try{typeof r=="function"?r.call(void 0,h):r[0].call(r[1],h)}catch(u){(0,m.onUnexpectedError)(u);continue}Object.freeze(o),await Promise.allSettled(o).then(u=>{for(const d of u)d.status==="rejected"&&(0,m.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=b;class p extends c{constructor(g){super(g);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=p;class v extends p{constructor(g){super(g);this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=v;class w extends c{constructor(g){super(g);this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(a=>super.fire(a)),this._queuedEvents=[]})}}e.MicrotaskEmitter=w;class R{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const a={event:g,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const E=()=>{this.hasListeners&&this.unhook(a);const r=this.events.indexOf(a);this.events.splice(r,1)};return(0,k.toDisposable)((0,i.once)(E))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(a=>this.emitter.fire(a))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=R;class S{constructor(){this.buffers=[]}wrapEvent(g){return(a,E,r)=>g(t=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>a.call(E,t)):a.call(E,t)},void 0,r)}bufferEvents(g){const a=[];this.buffers.push(a);const E=g();return this.buffers.pop(),a.forEach(r=>r()),E}}e.EventBufferer=S;class s{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=k.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(ve[21],we([0,1,3]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(I,y){const P=setTimeout(I.bind(y),0);return{dispose(){clearTimeout(P)}}});var k;(function(I){function y(P){return P===I.None||P===I.Cancelled||P instanceof C?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}I.isCancellationToken=y,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(k=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=k.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=T}),define(ve[141],we([0,1,21]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class i{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new m.CancellationTokenSource,I=this.task(T.token);return this.result={promise:I,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=i;class k{constructor(T){this.computeFn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const I=JSON.stringify(T);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.computeFn(T)),this.lastCache}}e.LRUCachedComputed=k}),define(ve[97],we([0,1,15,6]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(s){const n=s;return n?[n.on,n.pause,n.resume,n.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=k;function C(s){const n=s;return n?k(n.stream)&&Array.isArray(n.buffer)&&typeof n.ended=="boolean":!1}e.isReadableBufferedStream=C;function T(s,n){return new I(s,n)}e.newWriteableStream=T;class I{constructor(n,g){this.reducer=n,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(n){if(!this.state.destroyed){if(this.state.flowing)this.emitData(n);else if(this.buffer.data.push(n),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(n){this.state.destroyed||(this.state.flowing?this.emitError(n):this.buffer.error.push(n))}end(n){this.state.destroyed||(typeof n!="undefined"&&this.write(n),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(n){this.listeners.data.slice(0).forEach(g=>g(n))}emitError(n){this.listeners.error.length===0?(0,m.onUnexpectedError)(n):this.listeners.error.slice(0).forEach(g=>g(n))}emitEnd(){this.listeners.end.slice(0).forEach(n=>n())}on(n,g){if(!this.state.destroyed)switch(n){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(n,g){if(this.state.destroyed)return;let a;switch(n){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const E=a.indexOf(g);E>=0&&a.splice(E,1)}}flowData(){if(this.buffer.data.length>0){const n=this.reducer(this.buffer.data);this.emitData(n),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const n of this.buffer.error)this.emitError(n);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(s,n){const g=[];let a;for(;(a=s.read())!==null;)g.push(a);return n(g)}e.consumeReadable=y;function P(s,n,g){const a=[];let E;for(;(E=s.read())!==null&&a.length<g;)a.push(E);return E===null&&a.length>0?n(a):{read:()=>{if(a.length>0)return a.shift();if(typeof E!="undefined"){const r=E;return E=void 0,r}return s.read()}}}e.peekReadable=P;function L(s,n){return new Promise((g,a)=>{const E=[];D(s,{onData:r=>{n&&E.push(r)},onError:r=>{n?a(r):g(void 0)},onEnd:()=>{g(n?n(E):void 0)}})})}e.consumeStream=L;function D(s,n){let g=!1;return s.on("error",a=>{g||n.onError(a)}),s.on("end",()=>{g||n.onEnd()}),s.on("data",a=>{g||n.onData(a)}),(0,i.toDisposable)(()=>g=!0)}e.listenStream=D;function c(s,n){return new Promise((g,a)=>{const E=new i.DisposableStore,r=[],t=u=>{if(r.push(u),r.length>n)return E.dispose(),s.pause(),g({stream:s,buffer:r,ended:!1})},o=u=>a(u),h=()=>g({stream:s,buffer:r,ended:!0});E.add((0,i.toDisposable)(()=>s.removeListener("error",o))),s.on("error",o),E.add((0,i.toDisposable)(()=>s.removeListener("end",h))),s.on("end",h),E.add((0,i.toDisposable)(()=>s.removeListener("data",t))),s.on("data",t)})}e.peekStream=c;function b(s,n){const g=T(n);return g.end(s),g}e.toStream=b;function p(){const s=T(()=>{throw new Error("not supported")});return s.end(),s}e.emptyStream=p;function v(s){let n=!1;return{read:()=>n?null:(n=!0,s)}}e.toReadable=v;function w(s,n,g){const a=T(g);return D(s,{onData:E=>a.write(n.data(E)),onError:E=>a.error(n.error?n.error(E):E),onEnd:()=>a.end()}),a}e.transform=w;function R(s,n,g){let a=!1;return{read:()=>{const E=n.read();return a?E:(a=!0,E!==null?g([s,E]):s)}}}e.prefixedReadable=R;function S(s,n,g){let a=!1;const E=T(g);return D(n,{onData:r=>a?E.write(r):(a=!0,E.write(g([s,r]))),onError:r=>E.error(r),onEnd:()=>{a||(a=!0,E.write(s)),E.end()}}),E}e.prefixedStream=S}),define(ve[22],we([0,1,97]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let k,C;class T{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return i?new T(Buffer.allocUnsafe(d)):new T(new Uint8Array(d))}static wrap(d){return i&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new T(d)}static fromString(d,f){return!(f?.dontUseNodeBuffer||!1)&&i?new T(Buffer.from(d)):(k||(k=new TextEncoder),new T(k.encode(d)))}static fromByteArray(d){const f=T.alloc(d.length);for(let l=0,_=d.length;l<_;l++)f.buffer[l]=d[l];return f}static concat(d,f){if(typeof f=="undefined"){f=0;for(let A=0,N=d.length;A<N;A++)f+=d[A].byteLength}const l=T.alloc(f);let _=0;for(let A=0,N=d.length;A<N;A++){const x=d[A];l.set(x,_),_+=x.byteLength}return l}clone(){const d=T.alloc(this.byteLength);return d.set(this),d}toString(){return i?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(d,f){return new T(this.buffer.subarray(d,f))}set(d,f){if(d instanceof T)this.buffer.set(d.buffer,f);else if(d instanceof Uint8Array)this.buffer.set(d,f);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),f);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),f);else throw new Error("Unkown argument 'array'")}readUInt32BE(d){return P(this.buffer,d)}writeUInt32BE(d,f){L(this.buffer,d,f)}readUInt32LE(d){return D(this.buffer,d)}writeUInt32LE(d,f){c(this.buffer,d,f)}readUInt8(d){return b(this.buffer,d)}writeUInt8(d,f){p(this.buffer,d,f)}}e.VSBuffer=T;function I(u,d){return u[d+0]<<0>>>0|u[d+1]<<8>>>0}e.readUInt16LE=I;function y(u,d,f){u[f+0]=d&255,d=d>>>8,u[f+1]=d&255}e.writeUInt16LE=y;function P(u,d){return u[d]*2**24+u[d+1]*2**16+u[d+2]*2**8+u[d+3]}e.readUInt32BE=P;function L(u,d,f){u[f+3]=d,d=d>>>8,u[f+2]=d,d=d>>>8,u[f+1]=d,d=d>>>8,u[f]=d}e.writeUInt32BE=L;function D(u,d){return u[d+0]<<0>>>0|u[d+1]<<8>>>0|u[d+2]<<16>>>0|u[d+3]<<24>>>0}e.readUInt32LE=D;function c(u,d,f){u[f+0]=d&255,d=d>>>8,u[f+1]=d&255,d=d>>>8,u[f+2]=d&255,d=d>>>8,u[f+3]=d&255}e.writeUInt32LE=c;function b(u,d){return u[d]}e.readUInt8=b;function p(u,d,f){u[f]=d}e.writeUInt8=p;function v(u){return m.consumeReadable(u,d=>T.concat(d))}e.readableToBuffer=v;function w(u){return m.toReadable(u)}e.bufferToReadable=w;function R(u){return m.consumeStream(u,d=>T.concat(d))}e.streamToBuffer=R;async function S(u){return u.ended?T.concat(u.buffer):T.concat([...u.buffer,await R(u.stream)])}e.bufferedStreamToBuffer=S;function s(u){return m.toStream(u,d=>T.concat(d))}e.bufferToStream=s;function n(u){return m.transform(u,{data:d=>typeof d=="string"?T.fromString(d):T.wrap(d)},d=>T.concat(d))}e.streamToBufferReadableStream=n;function g(u){return m.newWriteableStream(d=>T.concat(d),u)}e.newWriteableBufferStream=g;function a(u,d){return m.prefixedReadable(u,d,f=>T.concat(f))}e.prefixedBufferReadable=a;function E(u,d){return m.prefixedStream(u,d,f=>T.concat(f))}e.prefixedBufferStream=E;function r(u){let d=0,f=0,l=0;const _=new Uint8Array(Math.floor(u.length/4*3)),A=x=>{switch(f){case 3:_[l++]=d|x,f=0;break;case 2:_[l++]=d|x>>>2,d=x<<6,f=3;break;case 1:_[l++]=d|x>>>4,d=x<<4,f=2;break;default:d=x<<2,f=1}};for(let x=0;x<u.length;x++){const F=u.charCodeAt(x);if(F>=65&&F<=90)A(F-65);else if(F>=97&&F<=122)A(F-97+26);else if(F>=48&&F<=57)A(F-48+52);else if(F===43||F===45)A(62);else if(F===47||F===95)A(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${u[x]}`)}}const N=l;for(;f>0;)A(0);return T.wrap(_).slice(0,N)}e.decodeBase64=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:u},d=!0,f=!1){const l=f?o:t;let _="";const A=u.byteLength%3;let N=0;for(;N<u.byteLength-A;N+=3){const x=u[N+0],F=u[N+1],O=u[N+2];_+=l[x>>>2],_+=l[(x<<4|F>>>4)&63],_+=l[(F<<2|O>>>6)&63],_+=l[O&63]}if(A===1){const x=u[N+0];_+=l[x>>>2],_+=l[x<<4&63],d&&(_+="==")}else if(A===2){const x=u[N+0],F=u[N+1];_+=l[x>>>2],_+=l[(x<<4|F>>>4)&63],_+=l[F<<2&63],d&&(_+="=")}return _}e.encodeBase64=h}),define(ve[9],we([0,1,141,93]),function(X,e,m,i){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=C;const T=/{(\d+)}/g;function I(ne,...Ce){return Ce.length===0?ne:ne.replace(T,function(Fe,Ge){const ze=parseInt(Ge,10);return isNaN(ze)||ze<0||ze>=Ce.length?Fe:Ce[ze]})}e.format=I;const y=/{([^}]+)}/g;function P(ne,Ce){return ne.replace(y,(Fe,Ge)=>Ce[Ge]??Fe)}e.format2=P;function L(ne){return ne.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=L;function D(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function c(ne,Ce){let Fe=0;const Ge=Ce.charCodeAt(0);for(let ze=ne.length-1;ze>=0;ze--)ne.charCodeAt(ze)===Ge&&Fe++;return Fe}e.count=c;function b(ne,Ce,Fe="\u2026"){return ne.length<=Ce?ne:`${ne.substr(0,Ce)}${Fe}`}e.truncate=b;function p(ne,Ce=" "){const Fe=v(ne,Ce);return w(Fe,Ce)}e.trim=p;function v(ne,Ce){if(!ne||!Ce)return ne;const Fe=Ce.length;if(Fe===0||ne.length===0)return ne;let Ge=0;for(;ne.indexOf(Ce,Ge)===Ge;)Ge=Ge+Fe;return ne.substring(Ge)}e.ltrim=v;function w(ne,Ce){if(!ne||!Ce)return ne;const Fe=Ce.length,Ge=ne.length;if(Fe===0||Ge===0)return ne;let ze=Ge,ut=-1;for(;ut=ne.lastIndexOf(Ce,ze-1),!(ut===-1||ut+Fe!==ze);){if(ut===0)return"";ze=ut}return ne.substring(0,ze)}e.rtrim=w;function R(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=R;function S(ne){return ne.replace(/\*/g,"")}e.stripWildcards=S;function s(ne,Ce,Fe={}){if(!ne)throw new Error("Cannot create regex from empty string");Ce||(ne=D(ne)),Fe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let Ge="";return Fe.global&&(Ge+="g"),Fe.matchCase||(Ge+="i"),Fe.multiline&&(Ge+="m"),Fe.unicode&&(Ge+="u"),new RegExp(ne,Ge)}e.createRegExp=s;function n(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=n;function g(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function a(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=a;function E(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=E;function r(ne){for(let Ce=0,Fe=ne.length;Ce<Fe;Ce++){const Ge=ne.charCodeAt(Ce);if(Ge!==32&&Ge!==9)return Ce}return-1}e.firstNonWhitespaceIndex=r;function t(ne,Ce=0,Fe=ne.length){for(let Ge=Ce;Ge<Fe;Ge++){const ze=ne.charCodeAt(Ge);if(ze!==32&&ze!==9)return ne.substring(Ce,Ge)}return ne.substring(Ce,Fe)}e.getLeadingWhitespace=t;function o(ne,Ce=ne.length-1){for(let Fe=Ce;Fe>=0;Fe--){const Ge=ne.charCodeAt(Fe);if(Ge!==32&&Ge!==9)return Fe}return-1}e.lastNonWhitespaceIndex=o;function h(ne,Ce){return ne<Ce?-1:ne>Ce?1:0}e.compare=h;function u(ne,Ce,Fe=0,Ge=ne.length,ze=0,ut=Ce.length){for(;Fe<Ge&&ze<ut;Fe++,ze++){let De=ne.charCodeAt(Fe),se=Ce.charCodeAt(ze);if(De<se)return-1;if(De>se)return 1}const Re=Ge-Fe,Te=ut-ze;return Re<Te?-1:Re>Te?1:0}e.compareSubstring=u;function d(ne,Ce){return f(ne,Ce,0,ne.length,0,Ce.length)}e.compareIgnoreCase=d;function f(ne,Ce,Fe=0,Ge=ne.length,ze=0,ut=Ce.length){for(;Fe<Ge&&ze<ut;Fe++,ze++){let De=ne.charCodeAt(Fe),se=Ce.charCodeAt(ze);if(De===se)continue;if(De>=128||se>=128)return u(ne.toLowerCase(),Ce.toLowerCase(),Fe,Ge,ze,ut);l(De)&&(De-=32),l(se)&&(se-=32);const fe=De-se;if(fe!==0)return fe}const Re=Ge-Fe,Te=ut-ze;return Re<Te?-1:Re>Te?1:0}e.compareSubstringIgnoreCase=f;function l(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=l;function _(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=_;function A(ne,Ce){return ne.length===Ce.length&&f(ne,Ce)===0}e.equalsIgnoreCase=A;function N(ne,Ce){const Fe=Ce.length;return Ce.length>ne.length?!1:f(ne,Ce,0,Fe)===0}e.startsWithIgnoreCase=N;function x(ne,Ce){let Fe,Ge=Math.min(ne.length,Ce.length);for(Fe=0;Fe<Ge;Fe++)if(ne.charCodeAt(Fe)!==Ce.charCodeAt(Fe))return Fe;return Ge}e.commonPrefixLength=x;function F(ne,Ce){let Fe,Ge=Math.min(ne.length,Ce.length);const ze=ne.length-1,ut=Ce.length-1;for(Fe=0;Fe<Ge;Fe++)if(ne.charCodeAt(ze-Fe)!==Ce.charCodeAt(ut-Fe))return Fe;return Ge}e.commonSuffixLength=F;function O(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=O;function z(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=z;function $(ne,Ce){return(ne-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=$;function M(ne,Ce,Fe){const Ge=ne.charCodeAt(Fe);if(O(Ge)&&Fe+1<Ce){const ze=ne.charCodeAt(Fe+1);if(z(ze))return $(Ge,ze)}return Ge}e.getNextCodePoint=M;function B(ne,Ce){const Fe=ne.charCodeAt(Ce-1);if(z(Fe)&&Ce>1){const Ge=ne.charCodeAt(Ce-2);if(O(Ge))return $(Ge,Fe)}return Fe}class W{constructor(Ce,Fe=0){this._str=Ce,this._len=Ce.length,this._offset=Fe}get offset(){return this._offset}setOffset(Ce){this._offset=Ce}prevCodePoint(){const Ce=B(this._str,this._offset);return this._offset-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=M(this._str,this._len,this._offset);return this._offset+=Ce>=65536?2:1,Ce}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class U{constructor(Ce,Fe=0){this._iterator=new W(Ce,Fe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Ce=nt.getInstance(),Fe=this._iterator,Ge=Fe.offset;let ze=Ce.getGraphemeBreakType(Fe.nextCodePoint());for(;!Fe.eol();){const ut=Fe.offset,Re=Ce.getGraphemeBreakType(Fe.nextCodePoint());if(at(ze,Re)){Fe.setOffset(ut);break}ze=Re}return Fe.offset-Ge}prevGraphemeLength(){const Ce=nt.getInstance(),Fe=this._iterator,Ge=Fe.offset;let ze=Ce.getGraphemeBreakType(Fe.prevCodePoint());for(;Fe.offset>0;){const ut=Fe.offset,Re=Ce.getGraphemeBreakType(Fe.prevCodePoint());if(at(Re,ze)){Fe.setOffset(ut);break}ze=Re}return Ge-Fe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=U;function j(ne,Ce){return new U(ne,Ce).nextGraphemeLength()}e.nextCharLength=j;function Z(ne,Ce){return new U(ne,Ce).prevGraphemeLength()}e.prevCharLength=Z;function ce(ne,Ce){Ce>0&&z(ne.charCodeAt(Ce))&&Ce--;const Fe=Ce+j(ne,Ce);return[Fe-Z(ne,Fe),Fe]}e.getCharContainingOffset=ce;const Q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function V(ne){return Q.test(ne)}e.containsRTL=V;const te=/^[\t\n\r\x20-\x7E]*$/;function me(ne){return te.test(ne)}e.isBasicASCII=me,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ge(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=ge;function ke(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=ke;function Be(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=Be;function xe(ne,Ce){if(ne.length<Ce)return ne;const Fe=/\b/g;let Ge=0;for(;Fe.test(ne)&&!(ne.length-Fe.lastIndex<Ce);)Ge=Fe.lastIndex,Fe.lastIndex+=1;return ne.substring(Ge).replace(/^\s/,"")}e.lcut=xe;const q=/\x1B\x5B[12]?K/g,Y=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function ue(ne){return ne&&(ne=ne.replace(q,""),ne=ne.replace(Y,""),ne=ne.replace(re,"")),ne}e.removeAnsiEscapeCodes=ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function J(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=J;function ae(ne){return J(ne)?ne.substr(1):ne}e.stripUTF8BOM=ae;function Ee(ne,Ce){if(!ne||!Ce||ne.length<Ce.length)return!1;const Fe=Ce.length,Ge=ne.toLowerCase();let ze=0,ut=-1;for(;ze<Fe;){const Re=Ge.indexOf(Ce[ze],ut+1);if(Re<0)return!1;ut=Re,ze++}return!0}e.fuzzyContains=Ee;function Oe(ne,Ce=!1){return ne?(Ce&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=Oe;function Ve(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=Ve;function Ke(ne,Ce=1){if(Ce===0)return"";let Fe=-1;do Fe=ne.indexOf(`
`,Fe+1),Ce--;while(Ce>0&&Fe>=0);return Fe===-1?ne:(ne[Fe-1]==="\r"&&Fe--,ne.substr(0,Fe))}e.getNLines=Ke;function Je(ne){const Ce=90-65+1;return ne=ne%(2*Ce),ne<Ce?String.fromCharCode(97+ne):String.fromCharCode(65+ne-Ce)}e.singleLetterHash=Je;function it(ne){return nt.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=it;function at(ne,Ce){return ne===0?Ce!==5&&Ce!==7:ne===2&&Ce===3?!1:ne===4||ne===2||ne===3||Ce===4||Ce===2||Ce===3?!0:!(ne===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(ne===11||ne===9)&&(Ce===9||Ce===10)||(ne===12||ne===10)&&Ce===10||Ce===5||Ce===13||Ce===7||ne===1||ne===13&&Ce===14||ne===6&&Ce===6)}var et;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class nt{constructor(){this._data=ct()}static getInstance(){return nt._INSTANCE||(nt._INSTANCE=new nt),nt._INSTANCE}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const Fe=this._data,Ge=Fe.length/3;let ze=1;for(;ze<=Ge;)if(Ce<Fe[3*ze])ze=2*ze;else if(Ce>Fe[3*ze+1])ze=2*ze+1;else return Fe[3*ze+2];return 0}}nt._INSTANCE=null;function ct(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function vt(ne,Ce){if(ne===0)return 0;const Fe=We(ne,Ce);if(Fe!==void 0)return Fe;const Ge=new W(Ce,ne);return Ge.prevCodePoint(),Ge.offset}e.getLeftDeleteOffset=vt;function We(ne,Ce){const Fe=new W(Ce,ne);let Ge=Fe.prevCodePoint();for(;At(Ge)||Ge===65039||Ge===8419;){if(Fe.offset===0)return;Ge=Fe.prevCodePoint()}if(!Be(Ge))return;let ze=Fe.offset;return ze>0&&Fe.prevCodePoint()===8205&&(ze=Fe.offset),ze}function At(ne){return 127995<=ne&&ne<=127999}var ee;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(ee||(ee={})),e.noBreakWhitespace="\xA0";class ie{constructor(Ce){this.confusableDictionary=Ce}static getInstance(Ce){return ie.cache.get(Array.from(Ce))}static getLocales(){return ie._locales.getValue()}isAmbiguous(Ce){return this.confusableDictionary.has(Ce)}getPrimaryConfusable(Ce){return this.confusableDictionary.get(Ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ie,k=ie,ie.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')),ie.cache=new m.LRUCachedComputed(ne=>{function Ce(se){const fe=new Map;for(let be=0;be<se.length;be+=2)fe.set(se[be],se[be+1]);return fe}function Fe(se,fe){const be=new Map(se);for(const[_e,Ne]of fe)be.set(_e,Ne);return be}function Ge(se,fe){if(!se)return fe;const be=new Map;for(const[_e,Ne]of se)fe.has(_e)&&be.set(_e,Ne);return be}const ze=k.ambiguousCharacterData.getValue();let ut=ne.filter(se=>!se.startsWith("_")&&se in ze);ut.length===0&&(ut=["_default"]);let Re;for(const se of ut){const fe=Ce(ze[se]);Re=Ge(Re,fe)}const Te=Ce(ze._common),De=Fe(Te,Re);return new ie(De)}),ie._locales=new i.Lazy(()=>Object.keys(ie.ambiguousCharacterData.getValue()).filter(ne=>!ne.startsWith("_")));class Se{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Se.getRawData())),this._data}static isInvisibleCharacter(Ce){return Se.getData().has(Ce)}static get codePoints(){return Se.getData()}}e.InvisibleCharacters=Se,Se._data=void 0}),define(ve[47],we([0,1,9]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(R){return k(R,0)}e.hash=i;function k(R,S){switch(typeof R){case"object":return R===null?C(349,S):Array.isArray(R)?y(R,S):P(R,S);case"string":return I(R,S);case"boolean":return T(R,S);case"number":return C(R,S);case"undefined":return C(937,S);default:return C(617,S)}}e.doHash=k;function C(R,S){return(S<<5)-S+R|0}e.numberHash=C;function T(R,S){return C(R?433:863,S)}function I(R,S){S=C(149417,S);for(let s=0,n=R.length;s<n;s++)S=C(R.charCodeAt(s),S);return S}e.stringHash=I;function y(R,S){return S=C(104579,S),R.reduce((s,n)=>k(n,s),S)}function P(R,S){return S=C(181387,S),Object.keys(R).sort().reduce((s,n)=>(s=I(n,s),k(R[n],s)),S)}class L{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=k(S,this._value),this._value}}e.Hasher=L;var D;(function(R){R[R.BLOCK_SIZE=64]="BLOCK_SIZE",R[R.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function c(R,S,s=32){const n=s-S,g=~((1<<n)-1);return(R<<S|(g&R)>>>n)>>>0}function b(R,S=0,s=R.byteLength,n=0){for(let g=0;g<s;g++)R[S+g]=n}function p(R,S,s="0"){for(;R.length<S;)R=s+R;return R}function v(R,S=32){return R instanceof ArrayBuffer?Array.from(new Uint8Array(R)).map(s=>s.toString(16).padStart(2,"0")).join(""):p((R>>>0).toString(16),S/4)}e.toHexString=v;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const s=S.length;if(s===0)return;const n=this._buff;let g=this._buffLen,a=this._leftoverHighSurrogate,E,r;for(a!==0?(E=a,r=-1,a=0):(E=S.charCodeAt(0),r=0);;){let t=E;if(m.isHighSurrogate(E))if(r+1<s){const o=S.charCodeAt(r+1);m.isLowSurrogate(o)?(r++,t=m.computeCodePoint(E,o)):t=65533}else{a=E;break}else m.isLowSurrogate(E)&&(t=65533);if(g=this._push(n,g,t),r++,r<s)E=S.charCodeAt(r);else break}this._buffLen=g,this._leftoverHighSurrogate=a}_push(S,s,n){return n<128?S[s++]=n:n<2048?(S[s++]=192|(n&1984)>>>6,S[s++]=128|(n&63)>>>0):n<65536?(S[s++]=224|(n&61440)>>>12,S[s++]=128|(n&4032)>>>6,S[s++]=128|(n&63)>>>0):(S[s++]=240|(n&1835008)>>>18,S[s++]=128|(n&258048)>>>12,S[s++]=128|(n&4032)>>>6,S[s++]=128|(n&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=w._bigBlock32,s=this._buffDV;for(let u=0;u<64;u+=4)S.setUint32(u,s.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)S.setUint32(u,c(S.getUint32(u-12,!1)^S.getUint32(u-32,!1)^S.getUint32(u-56,!1)^S.getUint32(u-64,!1),1),!1);let n=this._h0,g=this._h1,a=this._h2,E=this._h3,r=this._h4,t,o,h;for(let u=0;u<80;u++)u<20?(t=g&a|~g&E,o=1518500249):u<40?(t=g^a^E,o=1859775393):u<60?(t=g&a|g&E|a&E,o=2400959708):(t=g^a^E,o=3395469782),h=c(n,5)+t+r+o+S.getUint32(u*4,!1)&4294967295,r=E,E=a,a=c(g,30),g=n,n=h;this._h0=this._h0+n&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+E&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))});var tt=this&&this.__classPrivateFieldSet||function(X,e,m,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,m):k?k.value=m:e.set(X,m),m},Le=this&&this.__classPrivateFieldGet||function(X,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(X):i?i.value:e.get(X)};define(ve[24],we([0,1,16,9]),function(X,e,m,i){"use strict";var k,C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(r,t,o){let h=r.get(t);return h===void 0&&(h=o,r.set(t,h)),h}e.getOrSet=I;function y(r){const t=[];return r.forEach((o,h)=>{t.push(`${h} => ${o}`)}),`Map(${r.size}) {${t.join(", ")}}`}e.mapToString=y;function P(r){const t=[];return r.forEach(o=>{t.push(o)}),`Set(${r.size}) {${t.join(", ")}}`}e.setToString=P;class L{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const o=t.charCodeAt(0),h=this._value.charCodeAt(this._pos);return o-h}value(){return this._value[this._pos]}}e.StringIterator=L;class D{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=D;class c{constructor(t=!0,o=!0){this._splitOnBackslash=t,this._caseSensitive=o}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let o=t.length-1;o>=0;o--,this._valueLen--){const h=this._value.charCodeAt(o);if(!(h===47||this._splitOnBackslash&&h===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var b;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(b||(b={}));class p{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,i.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(w||(w={}));class R{constructor(t){this._iter=t}static forUris(t=()=>!1){return new R(new p(t))}static forPaths(t=!1){return new R(new c(void 0,!t))}static forStrings(){return new R(new L)}static forConfigKeys(){return new R(new D)}clear(){this._root=void 0}fill(t,o){if(o){const h=o.slice(0);(0,m.shuffle)(h);for(let u of h)this.set(u,t)}else{const h=t.slice(0);(0,m.shuffle)(h);for(let u of h)this.set(u[0],u[1])}}set(t,o){const h=this._iter.reset(t);let u;this._root||(this._root=new v,this._root.segment=h.value());const d=[];for(u=this._root;;){const l=h.cmp(u.segment);if(l>0)u.left||(u.left=new v,u.left.segment=h.value()),d.push([-1,u]),u=u.left;else if(l<0)u.right||(u.right=new v,u.right.segment=h.value()),d.push([1,u]),u=u.right;else if(h.hasNext())h.next(),u.mid||(u.mid=new v,u.mid.segment=h.value()),d.push([0,u]),u=u.mid;else break}const f=u.value;u.value=o,u.key=t;for(let l=d.length-1;l>=0;l--){const _=d[l][1];_.updateHeight();const A=_.balanceFactor();if(A<-1||A>1){const N=d[l][0],x=d[l+1][0];if(N===1&&x===1)d[l][1]=_.rotateLeft();else if(N===-1&&x===-1)d[l][1]=_.rotateRight();else if(N===1&&x===-1)_.right=d[l+1][1]=d[l+1][1].rotateRight(),d[l][1]=_.rotateLeft();else if(N===-1&&x===1)_.left=d[l+1][1]=d[l+1][1].rotateLeft(),d[l][1]=_.rotateRight();else throw new Error;if(l>0)switch(d[l-1][0]){case-1:d[l-1][1].left=d[l][1];break;case 1:d[l-1][1].right=d[l][1];break;case 0:d[l-1][1].mid=d[l][1];break}else this._root=d[0][1]}}return f}get(t){return this._getNode(t)?.value}_getNode(t){const o=this._iter.reset(t);let h=this._root;for(;h;){const u=o.cmp(h.segment);if(u>0)h=h.left;else if(u<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else break}return h}has(t){const o=this._getNode(t);return!(o?.value===void 0&&o?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,o){const h=this._iter.reset(t),u=[];let d=this._root;for(;d;){const f=h.cmp(d.segment);if(f>0)u.push([-1,d]),d=d.left;else if(f<0)u.push([1,d]),d=d.right;else if(h.hasNext())h.next(),u.push([0,d]),d=d.mid;else break}if(!!d){if(o?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const f=this._min(d.right),{key:l,value:_,segment:A}=f;this._delete(f.key,!1),d.key=l,d.value=_,d.segment=A}else{const f=d.left??d.right;if(u.length>0){const[l,_]=u[u.length-1];switch(l){case-1:_.left=f;break;case 0:_.mid=f;break;case 1:_.right=f;break}}else this._root=f}for(let f=u.length-1;f>=0;f--){const l=u[f][1];l.updateHeight();const _=l.balanceFactor();if(_>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),u[f][1]=l.rotateLeft()):_<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),u[f][1]=l.rotateRight()),f>0)switch(u[f-1][0]){case-1:u[f-1][1].left=u[f][1];break;case 1:u[f-1][1].right=u[f][1];break;case 0:u[f-1][1].mid=u[f][1];break}else this._root=u[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const o=this._iter.reset(t);let h=this._root,u;for(;h;){const d=o.cmp(h.segment);if(d>0)h=h.left;else if(d<0)h=h.right;else if(o.hasNext())o.next(),u=h.value||u,h=h.mid;else break}return h&&h.value||u}findSuperstr(t){const o=this._iter.reset(t);let h=this._root;for(;h;){const u=o.cmp(h.segment);if(u>0)h=h.left;else if(u<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(t){for(const[o,h]of this)t(h,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=o=>{if(!o)return!0;const h=o.balanceFactor();return h<-1||h>1?!1:t(o.left)&&t(o.right)};return t(this._root)}}e.TernarySearchTree=R;class S{constructor(t,o){this.uri=t,this.value=o}}class s{constructor(t,o){this[k]="ResourceMap",t instanceof s?(this.map=new Map(t.map),this.toKey=o??s.defaultToKey):(this.map=new Map,this.toKey=t??s.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new S(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o!="undefined"&&(t=t.bind(o));for(let[h,u]of this.map)t(u.value,u.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=s,s.defaultToKey=r=>r.toString();var n;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(n=e.Touch||(e.Touch={}));class g{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const h=this._map.get(t);if(!!h)return o!==0&&this.touch(h,o),h.value}set(t,o,h=0){let u=this._map.get(t);if(u)u.value=o,h!==0&&this.touch(u,h);else{switch(u={key:t,value:o,next:void 0,previous:void 0},h){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(t,u),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const h=this._state;let u=this._head;for(;u;){if(o?t.bind(o)(u.value,u.key,this):t(u.value,u.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const t=this,o=this._state;let h=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:h.key,done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return u}values(){const t=this,o=this._state;let h=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:h.value,done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return u}entries(){const t=this,o=this._state;let h=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:[h.key,h.value],done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return u}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,h=this.size;for(;o&&h>t;)this._map.delete(o.key),o=o.next,h--;this._head=o,this._size=h,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,h=t.previous;if(!o||!h)throw new Error("Invalid list");o.previous=h,h.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const h=t.next,u=t.previous;t===this._tail?(u.next=void 0,this._tail=u):(h.previous=u,u.next=h),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const h=t.next,u=t.previous;t===this._head?(h.previous=void 0,this._head=h):(h.previous=u,u.next=h),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,h)=>{t.push([h,o])}),t}fromJSON(t){this.clear();for(const[o,h]of t)this.set(o,h)}}e.LinkedMap=g;class a extends g{constructor(t,o=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class E{constructor(t){T.set(this,void 0),tt(this,T,t,"f")}get size(){return Le(this,T,"f").size}forEach(t,o){Le(this,T,"f").forEach(t,o)}get(t){return Le(this,T,"f").get(t)}has(t){return Le(this,T,"f").has(t)}entries(){return Le(this,T,"f").entries()}keys(){return Le(this,T,"f").keys()}values(){return Le(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Le(this,T,"f").entries()}}e.ReadonlyMapView=E}),define(ve[98],we([0,1,24,9]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...J){return function(ae,Ee){for(let Oe=0,Ve=J.length;Oe<Ve;Oe++){const Ke=J[Oe](ae,Ee);if(Ke)return Ke}return null}}e.or=k,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(J,ae,Ee){if(!Ee||Ee.length<ae.length)return null;let Oe;return J?Oe=i.startsWithIgnoreCase(Ee,ae):Oe=Ee.indexOf(ae)===0,Oe?ae.length>0?[{start:0,end:ae.length}]:[]:null}function T(J,ae){const Ee=ae.toLowerCase().indexOf(J.toLowerCase());return Ee===-1?null:[{start:Ee,end:Ee+J.length}]}e.matchesContiguousSubString=T;function I(J,ae){return y(J.toLowerCase(),ae.toLowerCase(),0,0)}e.matchesSubString=I;function y(J,ae,Ee,Oe){if(Ee===J.length)return[];if(Oe===ae.length)return null;if(J[Ee]===ae[Oe]){let Ve=null;return(Ve=y(J,ae,Ee+1,Oe+1))?R({start:Oe,end:Oe+1},Ve):null}return y(J,ae,Ee,Oe+1)}function P(J){return 97<=J&&J<=122}function L(J){return 65<=J&&J<=90}e.isUpper=L;function D(J){return 48<=J&&J<=57}function c(J){return J===32||J===9||J===10||J===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>b.add(J.charCodeAt(0)));function p(J){return c(J)||b.has(J)}function v(J,ae){return J===ae||p(J)&&p(ae)}function w(J){return P(J)||L(J)||D(J)}function R(J,ae){return ae.length===0?ae=[J]:J.end===ae[0].start?ae[0].start=J.start:ae.unshift(J),ae}function S(J,ae){for(let Ee=ae;Ee<J.length;Ee++){const Oe=J.charCodeAt(Ee);if(L(Oe)||D(Oe)||Ee>0&&!w(J.charCodeAt(Ee-1)))return Ee}return J.length}function s(J,ae,Ee,Oe){if(Ee===J.length)return[];if(Oe===ae.length)return null;if(J[Ee]!==ae[Oe].toLowerCase())return null;{let Ve=null,Ke=Oe+1;for(Ve=s(J,ae,Ee+1,Oe+1);!Ve&&(Ke=S(ae,Ke))<ae.length;)Ve=s(J,ae,Ee+1,Ke),Ke++;return Ve===null?null:R({start:Oe,end:Oe+1},Ve)}}function n(J){let ae=0,Ee=0,Oe=0,Ve=0,Ke=0;for(let nt=0;nt<J.length;nt++)Ke=J.charCodeAt(nt),L(Ke)&&ae++,P(Ke)&&Ee++,w(Ke)&&Oe++,D(Ke)&&Ve++;const Je=ae/J.length,it=Ee/J.length,at=Oe/J.length,et=Ve/J.length;return{upperPercent:Je,lowerPercent:it,alphaPercent:at,numericPercent:et}}function g(J){const{upperPercent:ae,lowerPercent:Ee}=J;return Ee===0&&ae>.6}function a(J){const{upperPercent:ae,lowerPercent:Ee,alphaPercent:Oe,numericPercent:Ve}=J;return Ee>.2&&ae<.8&&Oe>.6&&Ve<.2}function E(J){let ae=0,Ee=0,Oe=0,Ve=0;for(let Ke=0;Ke<J.length;Ke++)Oe=J.charCodeAt(Ke),L(Oe)&&ae++,P(Oe)&&Ee++,c(Oe)&&Ve++;return(ae===0||Ee===0)&&Ve===0?J.length<=30:ae<=5}function r(J,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!E(J)||ae.length>60)return null;const Ee=n(ae);if(!a(Ee)){if(!g(Ee))return null;ae=ae.toLowerCase()}let Oe=null,Ve=0;for(J=J.toLowerCase();Ve<ae.length&&(Oe=s(J,ae,0,Ve))===null;)Ve=S(ae,Ve+1);return Oe}e.matchesCamelCase=r;function t(J,ae,Ee=!1){if(!ae||ae.length===0)return null;let Oe=null,Ve=0;for(J=J.toLowerCase(),ae=ae.toLowerCase();Ve<ae.length&&(Oe=o(J,ae,0,Ve,Ee))===null;)Ve=h(ae,Ve+1);return Oe}e.matchesWords=t;function o(J,ae,Ee,Oe,Ve){if(Ee===J.length)return[];if(Oe===ae.length)return null;if(v(J.charCodeAt(Ee),ae.charCodeAt(Oe))){let Ke=null,Je=Oe+1;if(Ke=o(J,ae,Ee+1,Oe+1,Ve),!Ve)for(;!Ke&&(Je=h(ae,Je))<ae.length;)Ke=o(J,ae,Ee+1,Je,Ve),Je++;return Ke===null?null:R({start:Oe,end:Oe+1},Ke)}else return null}function h(J,ae){for(let Ee=ae;Ee<J.length;Ee++)if(p(J.charCodeAt(Ee))||Ee>0&&p(J.charCodeAt(Ee-1)))return Ee;return J.length}const u=k(e.matchesPrefix,r,T),d=k(e.matchesPrefix,r,I),f=new m.LRUCache(1e4);function l(J,ae,Ee=!1){if(typeof J!="string"||typeof ae!="string")return null;let Oe=f.get(J);Oe||(Oe=new RegExp(i.convertSimple2RegExpPattern(J),"i"),f.set(J,Oe));const Ve=Oe.exec(ae);return Ve?[{start:Ve.index,end:Ve.index+Ve[0].length}]:Ee?d(J,ae):u(J,ae)}e.matchesFuzzy=l;function _(J,ae){const Ee=ke(J,J.toLowerCase(),0,ae,ae.toLowerCase(),0,!0);return Ee?N(Ee):null}e.matchesFuzzy2=_;function A(J,ae,Ee,Oe,Ve,Ke){const Je=Math.min(13,J.length);for(;Ee<Je;Ee++){const it=ke(J,ae,Ee,Oe,Ve,Ke,!1);if(it)return it}return[0,Ke]}e.anyScore=A;function N(J){if(typeof J=="undefined")return[];const ae=[],Ee=J[1];for(let Oe=J.length-1;Oe>1;Oe--){const Ve=J[Oe]+Ee,Ke=ae[ae.length-1];Ke&&Ke.end===Ve?Ke.end=Ve+1:ae.push({start:Ve,end:Ve+1})}return ae}e.createMatches=N;const x=128;function F(){const J=[],ae=[];for(let Ee=0;Ee<=x;Ee++)ae[Ee]=0;for(let Ee=0;Ee<=x;Ee++)J.push(ae.slice(0));return J}function O(J){const ae=[];for(let Ee=0;Ee<=J;Ee++)ae[Ee]=0;return ae}const z=O(2*x),$=O(2*x),M=F(),B=F(),W=F(),U=!1;function j(J,ae,Ee,Oe,Ve){function Ke(it,at,et=" "){for(;it.length<at;)it=et+it;return it}let Je=` |   |${Oe.split("").map(it=>Ke(it,3)).join("|")}
`;for(let it=0;it<=Ee;it++)it===0?Je+=" |":Je+=`${ae[it-1]}|`,Je+=J[it].slice(0,Ve+1).map(at=>Ke(at.toString(),3)).join("|")+`
`;return Je}function Z(J,ae,Ee,Oe){J=J.substr(ae),Ee=Ee.substr(Oe),console.log(j(B,J,J.length,Ee,Ee.length)),console.log(j(W,J,J.length,Ee,Ee.length)),console.log(j(M,J,J.length,Ee,Ee.length))}function ce(J,ae){if(ae<0||ae>=J.length)return!1;const Ee=J.codePointAt(ae);switch(Ee){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(Ee)}}function Q(J,ae){if(ae<0||ae>=J.length)return!1;switch(J.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function V(J,ae,Ee){return ae[J]!==Ee[J]}function te(J,ae,Ee,Oe,Ve,Ke,Je=!1){for(;ae<Ee&&Ve<Ke;)J[ae]===Oe[Ve]&&(Je&&(z[ae]=Ve),ae+=1),Ve+=1;return ae===Ee}e.isPatternInWord=te;var me;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(me||(me={}));var ge;(function(J){J.Default=[-100,0];function ae(Ee){return!Ee||Ee.length===2&&Ee[0]===-100&&Ee[1]===0}J.isDefault=ae})(ge=e.FuzzyScore||(e.FuzzyScore={}));function ke(J,ae,Ee,Oe,Ve,Ke,Je){const it=J.length>x?x:J.length,at=Oe.length>x?x:Oe.length;if(Ee>=it||Ke>=at||it-Ee>at-Ke||!te(ae,Ee,it,Ve,Ke,at,!0))return;Be(it,at,Ee,Ke,ae,Ve);let et=1,nt=1,ct=Ee,vt=Ke;const We=[!1];for(et=1,ct=Ee;ct<it;et++,ct++){const ne=z[ct],Ce=$[ct],Fe=ct+1<it?$[ct+1]:at;for(nt=ne-Ke+1,vt=ne;vt<Fe;nt++,vt++){let Ge=Number.MIN_SAFE_INTEGER,ze=!1;vt<=Ce&&(Ge=xe(J,ae,ct,Ee,Oe,Ve,vt,at,Ke,M[et-1][nt-1]===0,We));let ut=0;Ge!==Number.MAX_SAFE_INTEGER&&(ze=!0,ut=Ge+B[et-1][nt-1]);const Re=vt>ne,Te=Re?B[et][nt-1]+(M[et][nt-1]>0?-5:0):0,De=vt>ne+1&&M[et][nt-1]>0,se=De?B[et][nt-2]+(M[et][nt-2]>0?-5:0):0;if(De&&(!Re||se>=Te)&&(!ze||se>=ut))B[et][nt]=se,W[et][nt]=3,M[et][nt]=0;else if(Re&&(!ze||Te>=ut))B[et][nt]=Te,W[et][nt]=2,M[et][nt]=0;else if(ze)B[et][nt]=ut,W[et][nt]=1,M[et][nt]=M[et-1][nt-1]+1;else throw new Error("not possible")}}if(U&&Z(J,Ee,Oe,Ke),!We[0]&&!Je)return;et--,nt--;const At=[B[et][nt],Ke];let ee=0,ie=0;for(;et>=1;){let ne=nt;do{const Ce=W[et][ne];if(Ce===3)ne=ne-2;else if(Ce===2)ne=ne-1;else break}while(ne>=1);ee>1&&ae[Ee+et-1]===Ve[Ke+nt-1]&&!V(ne+Ke-1,Oe,Ve)&&ee+1>M[et][ne]&&(ne=nt),ne===nt?ee++:ee=1,ie||(ie=ne),et--,nt=ne-1,At.push(nt)}at===it&&(At[0]+=2);const Se=ie-it;return At[0]-=Se,At}e.fuzzyScore=ke;function Be(J,ae,Ee,Oe,Ve,Ke){let Je=J-1,it=ae-1;for(;Je>=Ee&&it>=Oe;)Ve[Je]===Ke[it]&&($[Je]=it,Je--),it--}function xe(J,ae,Ee,Oe,Ve,Ke,Je,it,at,et,nt){if(ae[Ee]!==Ke[Je])return Number.MIN_SAFE_INTEGER;let ct=1,vt=!1;return Je===Ee-Oe?ct=J[Ee]===Ve[Je]?7:5:V(Je,Ve,Ke)&&(Je===0||!V(Je-1,Ve,Ke))?(ct=J[Ee]===Ve[Je]?7:5,vt=!0):ce(Ke,Je)&&(Je===0||!ce(Ke,Je-1))?ct=5:(ce(Ke,Je-1)||Q(Ke,Je-1))&&(ct=5,vt=!0),ct>1&&Ee===Oe&&(nt[0]=!0),vt||(vt=V(Je,Ve,Ke)||ce(Ke,Je-1)||Q(Ke,Je-1)),Ee===Oe?Je>at&&(ct-=vt?3:5):et?ct+=vt?2:0:ct+=vt?0:1,Je+1===it&&(ct-=vt?3:5),ct}function q(J,ae,Ee,Oe,Ve,Ke,Je){return re(J,ae,Ee,Oe,Ve,Ke,!0,Je)}e.fuzzyScoreGracefulAggressive=q;function Y(J,ae,Ee,Oe,Ve,Ke,Je){return re(J,ae,Ee,Oe,Ve,Ke,!1,Je)}e.fuzzyScoreGraceful=Y;function re(J,ae,Ee,Oe,Ve,Ke,Je,it){let at=ke(J,ae,Ee,Oe,Ve,Ke,it);if(at&&!Je)return at;if(J.length>=3){const et=Math.min(7,J.length-1);for(let nt=Ee+1;nt<et;nt++){const ct=ue(J,nt);if(ct){const vt=ke(ct,ct.toLowerCase(),Ee,Oe,Ve,Ke,it);vt&&(vt[0]-=3,(!at||vt[0]>at[0])&&(at=vt))}}}return at}function ue(J,ae){if(ae+1>=J.length)return;const Ee=J[ae],Oe=J[ae+1];if(Ee!==Oe)return J.slice(0,ae)+Oe+Ee+J.slice(ae+2)}}),define(ve[142],we([0,1,74,98,9]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(m.CSSIcon.iconNameCharacter),I=new RegExp(`(\\\\)?${C.source}`,"g");function y(w){return w.replace(I,(R,S)=>S?R:`\\${R}`)}e.escapeIcons=y;const P=new RegExp(`\\\\${C.source}`,"g");function L(w){return w.replace(P,R=>`\\${R}`)}e.markdownEscapeEscapedIcons=L;const D=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function c(w){return w.indexOf(e.iconStartMarker)===-1?w:w.replace(D,(R,S,s,n)=>s?R:S||n||"")}e.stripIcons=c;function b(w){const R=w.indexOf(e.iconStartMarker);return R===-1?{text:w}:p(w,R)}e.parseLabelWithIcons=b;function p(w,R){const S=[];let s="";function n(u){if(u){s+=u;for(const d of u)S.push(E)}}let g=-1,a="",E=0,r,t,o=R;const h=w.length;for(n(w.substr(0,R));o<h;)r=w[o],t=w[o+1],r===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(g=o,n(a),a=e.iconStartMarker,o++):r===")"&&g!==-1?(E+=o-g+1,g=-1,a=""):g!==-1?T.test(r)?a+=r:(n(a),g=-1,a=""):n(r),o++;return n(a),{text:s,iconOffsets:S}}function v(w,R,S=!1){const{text:s,iconOffsets:n}=R;if(!n||n.length===0)return(0,i.matchesFuzzy)(w,s,S);const g=(0,k.ltrim)(s," "),a=s.length-g.length,E=(0,i.matchesFuzzy)(w,g,S);if(E)for(const r of E){const t=n[r.start+a]+a;r.start+=t,r.end+=t}return E}e.matchesFuzzyIconAware=v}),define(ve[99],we([0,1,15,142]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(b="",p=!1){if(this.value=b,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(b,p=0){return this.value+=P(this.supportThemeIcons?(0,i.escapeIcons)(b):b).replace(/([ \t]+)/g,(v,w)=>"&nbsp;".repeat(w.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(b){return this.value+=b,this}appendCodeblock(b,p){return this.value+="\n```",this.value+=b,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=C;function T(c){return I(c)?!c.value:Array.isArray(c)?c.every(T):!0}e.isEmptyMarkdownString=T;function I(c){return c instanceof C?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function y(c,b){return c===b?!0:!c||!b?!1:c.value===b.value&&c.isTrusted===b.isTrusted&&c.supportThemeIcons===b.supportThemeIcons}e.markdownStringEqual=y;function P(c){return c.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function L(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=L;function D(c){const b=[],p=c.split("|").map(w=>w.trim());c=p[0];const v=p[1];if(v){const w=/height=(\d+)/.exec(v),R=/width=(\d+)/.exec(v),S=w?w[1]:"",s=R?R[1]:"",n=isFinite(parseInt(s)),g=isFinite(parseInt(S));n&&b.push(`width="${s}"`),g&&b.push(`height="${S}"`)}return{href:c,dimensions:b}}e.parseHrefAndDimensions=D}),define(ve[80],we([0,1,24]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new m.LRUCache(1e4);function k(P){return y(P,"NFC",i)}e.normalizeNFC=k;const C=new m.LRUCache(1e4);function T(P){return y(P,"NFD",C)}e.normalizeNFD=T;const I=/[^\u0000-\u0080]/;function y(P,L,D){if(!P)return P;const c=D.get(P);if(c)return c;let b;return I.test(P)?b=P.normalize(L):b=P,D.set(P,b),b}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(L){return T(L).replace(P,"")}}()}),define(ve[48],we([0,1,9]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(i||(i={})),function(k){const C="error",T="warning",I="warn",y="info",P="ignore";function L(c){return c?m.equalsIgnoreCase(C,c)?k.Error:m.equalsIgnoreCase(T,c)||m.equalsIgnoreCase(I,c)?k.Warning:m.equalsIgnoreCase(y,c)?k.Info:k.Ignore:k.Ignore}k.fromValue=L;function D(c){switch(c){case k.Error:return C;case k.Warning:return T;case k.Info:return y;default:return P}}k.toString=D}(i||(i={})),e.default=i}),define(ve[13],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(d){return Array.isArray(d)}e.isArray=m;function i(d){return typeof d=="string"}e.isString=i;function k(d){return Array.isArray(d)&&d.every(f=>i(f))}e.isStringArray=k;function C(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=C;function T(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=T;function I(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=I;function y(d){return d===!0||d===!1}e.isBoolean=y;function P(d){return typeof d=="undefined"}e.isUndefined=P;function L(d){return!D(d)}e.isDefined=L;function D(d){return P(d)||d===null}e.isUndefinedOrNull=D;function c(d,f){if(!d)throw new Error(f?`Unexpected type, expected '${f}'`:"Unexpected type")}e.assertType=c;function b(d){if(D(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=b;function p(...d){const f=[];for(let l=0;l<d.length;l++){const _=d[l];if(D(_))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);f.push(_)}return f}e.assertAllDefined=p;const v=Object.prototype.hasOwnProperty;function w(d){if(!C(d))return!1;for(let f in d)if(v.call(d,f))return!1;return!0}e.isEmptyObject=w;function R(d){return typeof d=="function"}e.isFunction=R;function S(...d){return d.length>0&&d.every(R)}e.areFunctions=S;function s(d,f){const l=Math.min(d.length,f.length);for(let _=0;_<l;_++)n(d[_],f[_])}e.validateConstraints=s;function n(d,f){if(i(f)){if(typeof d!==f)throw new Error(`argument does not match constraint: typeof ${f}`)}else if(R(f)){try{if(d instanceof f)return}catch{}if(!D(d)&&d.constructor===f||f.length===1&&f.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=n;function g(d){let f=[],l=Object.getPrototypeOf(d);for(;Object.prototype!==l;)f=f.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return f}e.getAllPropertyNames=g;function a(d){const f=[];for(const l of g(d))typeof d[l]=="function"&&f.push(l);return f}e.getAllMethodNames=a;function E(d,f){const l=A=>function(){const N=Array.prototype.slice.call(arguments,0);return f(A,N)};let _={};for(const A of d)_[A]=l(A);return _}e.createProxyObject=E;function r(d){return d===null?void 0:d}e.withNullAsUndefined=r;function t(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=t;function o(d){return class{constructor(){return new Proxy({},{get(f,l){if(f[l])return f[l];throw new Error(`Not Implemented: ${d}->${String(l)}`)}})}}}e.NotImplementedProxy=o;function h(d,f="Unreachable"){throw new Error(f)}e.assertNever=h;function u(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=u}),define(ve[28],we([0,1,8,12,9,13]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function I(o){return o.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=I;function y(o){return o.indexOf("/")===-1&&(o=I(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=y;function P(o,h=m.posix.sep){if(!o)return"";const u=o.length,d=o.charCodeAt(0);if(T(d)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let l=3;const _=l;for(;l<u&&!T(o.charCodeAt(l));l++);if(_!==l&&!T(o.charCodeAt(l+1))){for(l+=1;l<u;l++)if(T(o.charCodeAt(l)))return o.slice(0,l+1).replace(/[\\/]/g,h)}}return h}else if(R(d)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+h:o.slice(0,2);let f=o.indexOf("://");if(f!==-1){for(f+=3;f<u;f++)if(T(o.charCodeAt(f)))return o.slice(0,f+1)}return""}e.getRoot=P;function L(o){if(!i.isWindows||!o||o.length<5)return!1;let h=o.charCodeAt(0);if(h!==92||(h=o.charCodeAt(1),h!==92))return!1;let u=2;const d=u;for(;u<o.length&&(h=o.charCodeAt(u),h!==92);u++);return!(d===u||(h=o.charCodeAt(u+1),isNaN(h)||h===92))}e.isUNC=L;const D=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(o,h=i.isWindows){const u=h?D:c;return!(!o||o.length===0||/^\s+$/.test(o)||(u.lastIndex=0,u.test(o))||h&&b.test(o)||o==="."||o===".."||h&&o[o.length-1]==="."||h&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=p;function v(o,h,u){const d=o===h;return!u||d?d:!o||!h?!1:(0,k.equalsIgnoreCase)(o,h)}e.isEqual=v;function w(o,h,u,d=m.sep){if(o===h)return!0;if(!o||!h||h.length>o.length)return!1;if(u){if(!(0,k.startsWithIgnoreCase)(o,h))return!1;if(h.length===o.length)return!0;let l=h.length;return h.charAt(h.length-1)===d&&l--,o.charAt(l)===d}return h.charAt(h.length-1)!==d&&(h+=d),o.indexOf(h)===0}e.isEqualOrParent=w;function R(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=R;function S(o,h){return i.isWindows&&o.endsWith(":")&&(o+=m.sep),(0,m.isAbsolute)(o)||(o=(0,m.join)(h,o)),o=(0,m.normalize)(o),i.isWindows?(o=(0,k.rtrim)(o,m.sep),o.endsWith(":")&&(o+=m.sep)):(o=(0,k.rtrim)(o,m.sep),o||(o=m.sep)),o}e.sanitizeFilePath=S;function s(o){const h=(0,m.normalize)(o);return i.isWindows?o.length>3?!1:n(h)&&(o.length===2||h.charCodeAt(2)===92):h===m.posix.sep}e.isRootOrDriveLetter=s;function n(o,h){return(h!==void 0?h:i.isWindows)?R(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=n;function g(o){return n(o)?o[0]:void 0}e.getDriveLetter=g;function a(o,h,u){return h.length>o.length?-1:o===h?0:(u&&(o=o.toLowerCase(),h=h.toLowerCase()),o.indexOf(h))}e.indexOfPath=a;function E(o){const h=o.split(":");let u,d,f;for(const l of h){const _=Number(l);(0,C.isNumber)(_)?d===void 0?d=_:f===void 0&&(f=_):u=u?[u,l].join(":"):l}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:d!==void 0?d:void 0,column:f!==void 0?f:d!==void 0?1:void 0}}e.parseLineAndColumnAware=E;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(o,h,u=8){let d="";for(let l=0;l<u;l++)d+=r.charAt(Math.floor(Math.random()*r.length));let f;return h?f=`${h}-${d}`:f=d,o?(0,m.join)(o,f):f}e.randomPath=t}),define(ve[25],we([0,1,13]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const w=Array.isArray(v)?[]:{};return Object.keys(v).forEach(R=>{v[R]&&typeof v[R]=="object"?w[R]=i(v[R]):w[R]=v[R]}),w}e.deepClone=i;function k(v){if(!v||typeof v!="object")return v;const w=[v];for(;w.length>0;){const R=w.shift();Object.freeze(R);for(const S in R)if(C.call(R,S)){const s=R[S];typeof s=="object"&&!Object.isFrozen(s)&&w.push(s)}}return v}e.deepFreeze=k;const C=Object.prototype.hasOwnProperty;function T(v,w){return I(v,w,new Set)}e.cloneAndChange=T;function I(v,w,R){if((0,m.isUndefinedOrNull)(v))return v;const S=w(v);if(typeof S!="undefined")return S;if((0,m.isArray)(v)){const s=[];for(const n of v)s.push(I(n,w,R));return s}if((0,m.isObject)(v)){if(R.has(v))throw new Error("Cannot clone recursive data-structure");R.add(v);const s={};for(let n in v)C.call(v,n)&&(s[n]=I(v[n],w,R));return R.delete(v),s}return v}function y(v,w,R=!0){return(0,m.isObject)(v)?((0,m.isObject)(w)&&Object.keys(w).forEach(S=>{S in v?R&&((0,m.isObject)(v[S])&&(0,m.isObject)(w[S])?y(v[S],w[S],R):v[S]=w[S]):v[S]=w[S]}),v):w}e.mixin=y;function P(v,w){if(v===w)return!0;if(v==null||w===null||w===void 0||typeof v!=typeof w||typeof v!="object"||Array.isArray(v)!==Array.isArray(w))return!1;let R,S;if(Array.isArray(v)){if(v.length!==w.length)return!1;for(R=0;R<v.length;R++)if(!P(v[R],w[R]))return!1}else{const s=[];for(S in v)s.push(S);s.sort();const n=[];for(S in w)n.push(S);if(n.sort(),!P(s,n))return!1;for(R=0;R<s.length;R++)if(!P(v[s[R]],w[s[R]]))return!1}return!0}e.equals=P;function L(v){const w=new Set;return JSON.stringify(v,(R,S)=>{if((0,m.isObject)(S)||Array.isArray(S)){if(w.has(S))return"[Circular]";w.add(S)}return S})}e.safeStringify=L;function D(v,w,R){const S=w(v);return typeof S=="undefined"?R:S}e.getOrDefault=D;function c(v,w){const R=Object.create(null);return!v||!w||Object.keys(w).forEach(s=>{const n=v[s],g=w[s];P(n,g)||(R[s]=g)}),R}e.distinct=c;function b(v,w){const R=w.toLowerCase(),S=Object.keys(v).find(s=>s.toLowerCase()===R);return S?v[S]:v[w]}e.getCaseInsensitive=b;function p(v,w){const R=Object.create(null);for(const[S,s]of Object.entries(v))w(S,s)&&(R[S]=s);return R}e.filter=p}),define(ve[100],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function i(C){return C<0?0:C>255?255:C|0}e.toUint8=i;function k(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=k}),define(ve[2],we([0,1,8,12]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,C=/^\//,T=/^\/\//;function I(r,t){if(!r.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!C.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(r,t){return!r&&!t?"file":r}function P(r,t){switch(r){case"https":case"http":case"file":t?t[0]!==D&&(t=D+t):t=D;break}return t}const L="",D="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(t,o,h,u,d,f=!1){typeof t=="object"?(this.scheme=t.scheme||L,this.authority=t.authority||L,this.path=t.path||L,this.query=t.query||L,this.fragment=t.fragment||L):(this.scheme=y(t,f),this.authority=o||L,this.path=P(this.scheme,h||L),this.query=u||L,this.fragment=d||L,I(this,f))}static isUri(t){return t instanceof b?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return s(this,!1)}with(t){if(!t)return this;let{scheme:o,authority:h,path:u,query:d,fragment:f}=t;return o===void 0?o=this.scheme:o===null&&(o=L),h===void 0?h=this.authority:h===null&&(h=L),u===void 0?u=this.path:u===null&&(u=L),d===void 0?d=this.query:d===null&&(d=L),f===void 0?f=this.fragment:f===null&&(f=L),o===this.scheme&&h===this.authority&&u===this.path&&d===this.query&&f===this.fragment?this:new v(o,h,u,d,f)}static parse(t,o=!1){const h=c.exec(t);return h?new v(h[2]||L,E(h[4]||L),E(h[5]||L),E(h[7]||L),E(h[9]||L),o):new v(L,L,L,L,L)}static file(t){let o=L;if(i.isWindows&&(t=t.replace(/\\/g,D)),t[0]===D&&t[1]===D){const h=t.indexOf(D,2);h===-1?(o=t.substring(2),t=D):(o=t.substring(2,h),t=t.substring(h)||D)}return new v("file",o,t,L,L)}static from(t){const o=new v(t.scheme,t.authority,t.path,t.query,t.fragment);return I(o,!0),o}static joinPath(t,...o){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return i.isWindows&&t.scheme==="file"?h=b.file(m.win32.join(s(t,!0),...o)).path:h=m.posix.join(t.path,...o),t.with({path:h})}toString(t=!1){return n(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof b)return t;{const o=new v(t);return o._formatted=t.external,o._fsPath=t._sep===p?t.fsPath:null,o}}else return t}}e.URI=b;const p=i.isWindows?1:void 0;class v extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(t=!1){return t?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=p),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function R(r,t){let o,h=-1;for(let u=0;u<r.length;u++){const d=r.charCodeAt(u);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||t&&d===47)h!==-1&&(o+=encodeURIComponent(r.substring(h,u)),h=-1),o!==void 0&&(o+=r.charAt(u));else{o===void 0&&(o=r.substr(0,u));const f=w[d];f!==void 0?(h!==-1&&(o+=encodeURIComponent(r.substring(h,u)),h=-1),o+=f):h===-1&&(h=u)}}return h!==-1&&(o+=encodeURIComponent(r.substring(h))),o!==void 0?o:r}function S(r){let t;for(let o=0;o<r.length;o++){const h=r.charCodeAt(o);h===35||h===63?(t===void 0&&(t=r.substr(0,o)),t+=w[h]):t!==void 0&&(t+=r[o])}return t!==void 0?t:r}function s(r,t){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?t?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,i.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=s;function n(r,t){const o=t?S:R;let h="",{scheme:u,authority:d,path:f,query:l,fragment:_}=r;if(u&&(h+=u,h+=":"),(d||u==="file")&&(h+=D,h+=D),d){let A=d.indexOf("@");if(A!==-1){const N=d.substr(0,A);d=d.substr(A+1),A=N.indexOf(":"),A===-1?h+=o(N,!1):(h+=o(N.substr(0,A),!1),h+=":",h+=o(N.substr(A+1),!1)),h+="@"}d=d.toLowerCase(),A=d.indexOf(":"),A===-1?h+=o(d,!1):(h+=o(d.substr(0,A),!1),h+=d.substr(A))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const A=f.charCodeAt(1);A>=65&&A<=90&&(f=`/${String.fromCharCode(A+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const A=f.charCodeAt(0);A>=65&&A<=90&&(f=`${String.fromCharCode(A+32)}:${f.substr(2)}`)}h+=o(f,!0)}return l&&(h+="?",h+=o(l,!1)),_&&(h+="#",h+=t?_:R(_,!1)),h}function g(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+g(r.substr(3)):r}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(r){return r.match(a)?r.replace(a,t=>g(t)):r}}),define(ve[59],we([0,1,22,9,2]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(L){return JSON.stringify(L,y)}e.stringify=C;function T(L){let D=JSON.parse(L);return D=P(D),D}e.parse=T;var I;(function(L){L[L.Uri=1]="Uri",L[L.Regexp=2]="Regexp",L[L.ScmResource=3]="ScmResource",L[L.ScmResourceGroup=4]="ScmResourceGroup",L[L.ScmProvider=5]="ScmProvider",L[L.CommentController=6]="CommentController",L[L.CommentThread=7]="CommentThread",L[L.CommentThreadReply=8]="CommentThreadReply",L[L.CommentNode=9]="CommentNode",L[L.CommentThreadNode=10]="CommentThreadNode",L[L.TimelineActionContext=11]="TimelineActionContext",L[L.NotebookCellActionContext=12]="NotebookCellActionContext",L[L.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function y(L,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,i.regExpFlags)(D)}:D}function P(L,D=0){if(!L||D>200)return L;if(typeof L=="object"){switch(L.$mid){case 1:return k.URI.revive(L);case 2:return new RegExp(L.source,L.flags)}if(L instanceof m.VSBuffer||L instanceof Uint8Array)return L;if(Array.isArray(L))for(let c=0;c<L.length;++c)L[c]=P(L[c],D+1);else for(const c in L)Object.hasOwnProperty.call(L,c)&&(L[c]=P(L[c],D+1))}return L}e.revive=P}),define(ve[10],we([0,1,12,2]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(k=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,P,L){this._hosts[y]=P,this._ports[y]=L}setConnectionToken(y,P){this._connectionTokens[y]=P}rewrite(y){if(this._delegate)return this._delegate(y);const P=y.authority;let L=this._hosts[P];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const D=this._ports[P],c=this._connectionTokens[P];let b=`path=${encodeURIComponent(y.path)}`;return typeof c=="string"&&(b+=`&tkn=${encodeURIComponent(c)}`),i.URI.from({scheme:m.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${L}:${D}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new C;class T{asBrowserUri(y,P){const L=this.toUri(y,P);return L.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===k.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${k.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?L.with({scheme:k.vscodeFileResource,authority:L.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(y,P){const L=this.toUri(y,P);return L.scheme===k.vscodeFileResource?L.with({scheme:k.file,authority:L.authority!==T.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(y,P){return i.URI.isUri(y)?y:i.URI.parse(P.toUrl(y))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(ve[23],we([0,1,28,10,8,12,9,2]),function(X,e,m,i,k,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(b){return(0,I.uriToFsPath)(b,!0)}e.originalFSPath=y;class P{constructor(p){this._ignorePathCasing=p}compare(p,v,w=!1){return p===v?0:(0,T.compare)(this.getComparisonKey(p,w),this.getComparisonKey(v,w))}isEqual(p,v,w=!1){return p===v?!0:!p||!v?!1:this.getComparisonKey(p,w)===this.getComparisonKey(v,w)}getComparisonKey(p,v=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,v,w=!1){if(p.scheme===v.scheme){if(p.scheme===i.Schemas.file)return m.isEqualOrParent(y(p),y(v),this._ignorePathCasing(p))&&p.query===v.query&&(w||p.fragment===v.fragment);if((0,e.isEqualAuthority)(p.authority,v.authority))return m.isEqualOrParent(p.path,v.path,this._ignorePathCasing(p),"/")&&p.query===v.query&&(w||p.fragment===v.fragment)}return!1}joinPath(p,...v){return I.URI.joinPath(p,...v)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return k.posix.basename(p.path)}extname(p){return k.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let v;return p.scheme===i.Schemas.file?v=I.URI.file(k.dirname(y(p))).path:(v=k.posix.dirname(p.path),p.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),v="/")),p.with({path:v})}normalizePath(p){if(!p.path.length)return p;let v;return p.scheme===i.Schemas.file?v=I.URI.file(k.normalize(y(p))).path:v=k.posix.normalize(p.path),p.with({path:v})}relativePath(p,v){if(p.scheme!==v.scheme||!(0,e.isEqualAuthority)(p.authority,v.authority))return;if(p.scheme===i.Schemas.file){const S=k.relative(y(p),y(v));return C.isWindows?m.toSlashes(S):S}let w=p.path||"/",R=v.path||"/";if(this._ignorePathCasing(p)){let S=0;for(const s=Math.min(w.length,R.length);S<s&&!(w.charCodeAt(S)!==R.charCodeAt(S)&&w.charAt(S).toLowerCase()!==R.charAt(S).toLowerCase());S++);w=R.substr(0,S)+w.substr(S)}return k.posix.relative(w,R)}resolvePath(p,v){if(p.scheme===i.Schemas.file){const w=I.URI.file(k.resolve(y(p),v));return p.with({authority:w.authority,path:w.path})}return v=m.toPosixPath(v),p.with({path:k.posix.resolve(p.path,v)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,v){return p===v||p!==void 0&&v!==void 0&&(0,T.equalsIgnoreCase)(p,v)}hasTrailingPathSeparator(p,v=k.sep){if(p.scheme===i.Schemas.file){const w=y(p);return w.length>m.getRoot(w).length&&w[w.length-1]===v}else{const w=p.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,v=k.sep){return(0,e.hasTrailingPathSeparator)(p,v)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,v=k.sep){let w=!1;if(p.scheme===i.Schemas.file){const R=y(p);w=R!==void 0&&R.length===m.getRoot(R).length&&R[R.length-1]===v}else{v="/";const R=p.path;w=R.length===1&&R.charCodeAt(R.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(p,v)?p.with({path:p.path+"/"}):p}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(b=>b.scheme===i.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new P(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(b,p){const v=[];for(let w=0;w<b.length;w++){const R=p(b[w]);b.some((S,s)=>s===w?!1:(0,e.isEqualOrParent)(R,p(S)))||v.push(b[w])}return v}e.distinctParents=L;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function p(v){const w=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(s=>{const[n,g]=s.split(":");n&&g&&w.set(n,g)});const S=v.path.substring(0,v.path.indexOf(";"));return S&&w.set(b.META_DATA_MIME,S),w}b.parseMetaData=p})(D=e.DataUri||(e.DataUri={}));function c(b,p,v){if(p){let w=b.path;return w&&w[0]!==k.posix.sep&&(w=k.posix.sep+w),b.with({scheme:v,authority:p,path:w})}return b.with({scheme:v})}e.toLocalResource=c}),define(ve[18],we([0,1,21,15,3,6,23,12]),function(X,e,m,i,k,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(Q){return!!Q&&typeof Q.then=="function"}e.isThenable=y;function P(Q){const V=new m.CancellationTokenSource,te=Q(V.token),me=new Promise((ge,ke)=>{const Be=V.token.onCancellationRequested(()=>{Be.dispose(),V.dispose(),ke((0,i.canceled)())});Promise.resolve(te).then(xe=>{Be.dispose(),V.dispose(),ge(xe)},xe=>{Be.dispose(),V.dispose(),ke(xe)})});return new class{cancel(){V.cancel()}then(ge,ke){return me.then(ge,ke)}catch(ge){return this.then(void 0,ge)}finally(ge){return me.finally(ge)}}}e.createCancelablePromise=P;function L(Q,V,te){return Promise.race([Q,new Promise(me=>V.onCancellationRequested(()=>me(te)))])}e.raceCancellation=L;async function D(Q){let V=-1;const te=Q.map((ge,ke)=>ge.then(Be=>(V=ke,Be))),me=await Promise.race(te);return Q.forEach((ge,ke)=>{ke!==V&&ge.cancel()}),me}e.raceCancellablePromises=D;function c(Q,V,te){let me;const ge=setTimeout(()=>{me?.(void 0),te?.()},V);return Promise.race([Q.finally(()=>clearTimeout(ge)),new Promise(ke=>me=ke)])}e.raceTimeout=c;function b(Q){return new Promise((V,te)=>{const me=Q();y(me)?me.then(V,te):V(me)})}e.asPromise=b;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(V){if(this.activePromise){if(this.queuedPromiseFactory=V,!this.queuedPromise){const te=()=>{this.queuedPromise=null;const me=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,me};this.queuedPromise=new Promise(me=>{this.activePromise.then(te,te).then(me)})}return new Promise((te,me)=>{this.queuedPromise.then(te,me)})}return this.activePromise=V(),new Promise((te,me)=>{this.activePromise.then(ge=>{this.activePromise=null,te(ge)},ge=>{this.activePromise=null,me(ge)})})}}e.Throttler=p;class v{constructor(){this.current=Promise.resolve(null)}queue(V){return this.current=this.current.then(()=>V(),()=>V())}}e.Sequencer=v;class w{constructor(){this.promiseMap=new Map}queue(V,te){const ge=(this.promiseMap.get(V)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.promiseMap.get(V)===ge&&this.promiseMap.delete(V)});return this.promiseMap.set(V,ge),ge}}e.SequencerByKey=w;const R=(Q,V)=>{let te=!0;const me=setTimeout(()=>{te=!1,V()},Q);return{isTriggered:()=>te,dispose:()=>{clearTimeout(me),te=!1}}},S=Q=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,Q())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class s{constructor(V){this.defaultDelay=V,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(V,te=this.defaultDelay){this.task=V,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,ke)=>{this.doResolve=ge,this.doReject=ke}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const me=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=te===e.MicrotaskDelay?S(me):R(te,me),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,i.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=s;class n{constructor(V){this.delayer=new s(V),this.throttler=new p}trigger(V,te){return this.delayer.trigger(()=>this.throttler.queue(V),te)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=n;class g{constructor(){this._isOpen=!1,this._promise=new Promise((V,te)=>{this._completePromise=V})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class a extends g{constructor(V){super();this._timeout=setTimeout(()=>this.open(),V)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function E(Q,V){return V?new Promise((te,me)=>{const ge=setTimeout(()=>{ke.dispose(),te()},Q),ke=V.onCancellationRequested(()=>{clearTimeout(ge),ke.dispose(),me((0,i.canceled)())})}):P(te=>E(Q,te))}e.timeout=E;function r(Q,V=0){const te=setTimeout(Q,V);return(0,C.toDisposable)(()=>clearTimeout(te))}e.disposableTimeout=r;function t(Q){const V=[];let te=0;const me=Q.length;function ge(){return te<me?Q[te++]():null}function ke(Be){Be!=null&&V.push(Be);const xe=ge();return xe?xe.then(ke):Promise.resolve(V)}return Promise.resolve(null).then(ke)}e.sequence=t;function o(Q,V=me=>!!me,te=null){let me=0;const ge=Q.length,ke=()=>{if(me>=ge)return Promise.resolve(te);const Be=Q[me++];return Promise.resolve(Be()).then(q=>V(q)?Promise.resolve(q):ke())};return ke()}e.first=o;function h(Q,V=me=>!!me,te=null){if(Q.length===0)return Promise.resolve(te);let me=Q.length;const ge=()=>{me=-1;for(const ke of Q)ke.cancel?.()};return new Promise((ke,Be)=>{for(const xe of Q)xe.then(q=>{--me>=0&&V(q)?(ge(),ke(q)):me===0&&ke(te)}).catch(q=>{--me>=0&&(ge(),Be(q))})})}e.firstParallel=h;class u{constructor(V){this._size=0,this.maxDegreeOfParalellism=V,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(V){return this._size++,new Promise((te,me)=>{this.outstandingPromises.push({factory:V,c:te,e:me}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const V=this.outstandingPromises.shift();this.runningPromises++;const te=V.factory();te.then(V.c,V.e),te.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class d extends u{constructor(){super(1)}}e.Queue=d;class f{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const V=new B;return this.drainers.add(V),V.p}isDrained(){for(const[,V]of this.queues)if(V.size>0)return!1;return!0}queueFor(V,te=T.extUri){const me=te.getComparisonKey(V);let ge=this.queues.get(me);return ge||(ge=new d,k.Event.once(ge.onFinished)(()=>{ge?.dispose(),this.queues.delete(me),this.onDidQueueFinish()}),this.queues.set(me,ge)),ge}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const V of this.drainers)V.complete();this.drainers.clear()}dispose(){for(const[,V]of this.queues)V.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=f;class l{constructor(V,te){this._token=-1,typeof V=="function"&&typeof te=="number"&&this.setIfNotSet(V,te)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(V,te){this.cancel(),this._token=setTimeout(()=>{this._token=-1,V()},te)}setIfNotSet(V,te){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,V()},te))}}e.TimeoutTimer=l;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(V,te){this.cancel(),this._token=setInterval(()=>{V()},te)}}e.IntervalTimer=_;class A{constructor(V,te){this.timeoutToken=-1,this.runner=V,this.timeout=te,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(V=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,V)}get delay(){return this.timeout}set delay(V){this.timeout=V}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class N{constructor(V,te){te%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.runner=V,this.timeout=te,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(V=this.timeout){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(V/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class x extends A{constructor(V,te){super(V,te);this.units=[]}work(V){this.units.push(V),this.isScheduled()||this.schedule()}doRun(){const V=this.units;this.units=[],this.runner&&this.runner(V)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class F extends C.Disposable{constructor(V,te,me,ge){super();this.maxWorkChunkSize=V,this.maxPendingWork=te,this.throttleDelay=me,this.handler=ge,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(V){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+V.length>this.maxPendingWork)return!1}else if(this.pending+V.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...V),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new A(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Q=>{(0,I.setTimeout0)(()=>{if(V)return;const te=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.runWhenIdle=(Q,V)=>{const te=requestIdleCallback(Q,typeof V=="number"?{timeout:V}:void 0);let me=!1;return{dispose(){me||(me=!0,cancelIdleCallback(te))}}}}();class O{constructor(V){this._didRun=!1,this._executor=()=>{try{this._value=V()}catch(te){this._error=te}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function z(Q,V,te){let me;for(let ge=0;ge<te;ge++)try{return await Q()}catch(ke){me=ke,await E(V)}throw me}e.retry=z;class ${hasPending(V){return this._pending?typeof V=="number"?this._pending.taskId===V:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(V,te,me){return this._pending={taskId:V,cancel:()=>me?.(),promise:te},te.then(()=>this.donePending(V),()=>this.donePending(V)),te}donePending(V){this._pending&&V===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const V=this._next;this._next=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}setNext(V){if(this._next)this._next.run=V;else{let te,me;const ge=new Promise((ke,Be)=>{te=ke,me=Be});this._next={run:V,promise:ge,promiseResolve:te,promiseReject:me}}return this._next.promise}}e.TaskSequentializer=$;class M{constructor(V,te=()=>Date.now()){this.interval=V,this.nowFn=te,this.lastIncrementTime=0,this.value=0}increment(){const V=this.nowFn();return V-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=V,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((V,te)=>{this.completeCallback=V,this.errorCallback=te})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(V){return new Promise(te=>{this.completeCallback(V),this.resolved=!0,te()})}error(V){return new Promise(te=>{this.errorCallback(V),this.rejected=!0,te()})}cancel(){new Promise(V=>{this.errorCallback((0,i.canceled)()),this.rejected=!0,V()})}}e.DeferredPromise=B;var W;(function(Q){async function V(me){let ge;const ke=await Promise.all(me.map(Be=>Be.then(xe=>xe,xe=>{ge||(ge=xe)})));if(typeof ge!="undefined")throw ge;return ke}Q.settled=V;function te(me){return new Promise(async(ge,ke)=>{try{await me(ge,ke)}catch(Be){ke(Be)}})}Q.withAsyncBody=te})(W=e.Promises||(e.Promises={}));var U;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(U||(U={}));class j{constructor(V){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const te={emitOne:me=>this.emitOne(me),emitMany:me=>this.emitMany(me),reject:me=>this.reject(me)};try{await Promise.resolve(V(te)),this.resolve()}catch(me){this.reject(me)}finally{te.emitOne=void 0,te.emitMany=void 0,te.reject=void 0}})}static fromArray(V){return new j(te=>{te.emitMany(V)})}static fromPromise(V){return new j(async te=>{te.emitMany(await V)})}static fromPromises(V){return new j(async te=>{await Promise.all(V.map(async me=>te.emitOne(await me)))})}static merge(V){return new j(async te=>{await Promise.all(V.map(async me=>{for await(const ge of me)te.emitOne(ge)}))})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(V<this._results.length)return{done:!1,value:this._results[V++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(V,te){return new j(async me=>{for await(const ge of V)me.emitOne(te(ge))})}map(V){return j.map(this,V)}static filter(V,te){return new j(async me=>{for await(const ge of V)te(ge)&&me.emitOne(ge)})}filter(V){return j.filter(this,V)}static coalesce(V){return j.filter(V,te=>!!te)}coalesce(){return j.coalesce(this)}static async toPromise(V){const te=[];for await(const me of V)te.push(me);return te}toPromise(){return j.toPromise(this)}emitOne(V){this._state===0&&(this._results.push(V),this._onStateChanged.fire())}emitMany(V){this._state===0&&(this._results=this._results.concat(V),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(V){this._state===0&&(this._state=2,this._error=V,this._onStateChanged.fire())}}e.AsyncIterableObject=j,j.EMPTY=j.fromArray([]);class Z extends j{constructor(V,te){super(te);this._source=V}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Z;function ce(Q){const V=new m.CancellationTokenSource,te=Q(V.token);return new Z(V,async me=>{const ge=V.token.onCancellationRequested(()=>{ge.dispose(),V.dispose(),me.reject((0,i.canceled)())});try{for await(const ke of te){if(V.token.isCancellationRequested)return;me.emitOne(ke)}ge.dispose(),V.dispose()}catch(ke){ge.dispose(),V.dispose(),me.reject(ke)}})}e.createCancelableAsyncIterable=ce}),define(ve[101],we([0,1,18,8]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new m.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),C=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(f,l,_=!1){const A=f||"",N=l||"",x=k.value.collator.compare(A,N);return k.value.collatorIsNumeric&&x===0&&A!==N?A<N?-1:1:x}e.compareFileNames=I;function y(f,l){const _=C.value.collator;return f=f||"",l=l||"",g(_,f,l)}e.compareFileNamesDefault=y;function P(f,l){const _=C.value.collator;return f=f||"",l=l||"",t(f,l)||g(_,f,l)}e.compareFileNamesUpper=P;function L(f,l){const _=C.value.collator;return f=f||"",l=l||"",r(f,l)||g(_,f,l)}e.compareFileNamesLower=L;function D(f,l){return f=f||"",l=l||"",f===l?0:f<l?-1:1}e.compareFileNamesUnicode=D;function c(f,l,_=!1){_||(f=f&&f.toLowerCase(),l=l&&l.toLowerCase());const[A,N]=s(f),[x,F]=s(l);return A!==x?A<x?-1:1:N===F?0:N<F?-1:1}e.noIntlCompareFileNames=c;function b(f,l){const[_,A]=s(f),[N,x]=s(l);let F=k.value.collator.compare(A,x);if(F===0){if(k.value.collatorIsNumeric&&A!==x)return A<x?-1:1;if(F=k.value.collator.compare(_,N),k.value.collatorIsNumeric&&F===0&&_!==N)return _<N?-1:1}return F}e.compareFileExtensions=b;function p(f,l){f=f||"",l=l||"";const _=n(f),A=n(l),N=C.value.collator,x=T.value.collator;return g(x,_,A)||g(N,f,l)}e.compareFileExtensionsDefault=p;function v(f,l){f=f||"",l=l||"";const _=n(f),A=n(l),N=C.value.collator,x=T.value.collator;return g(x,_,A)||t(f,l)||g(N,f,l)}e.compareFileExtensionsUpper=v;function w(f,l){f=f||"",l=l||"";const _=n(f),A=n(l),N=C.value.collator,x=T.value.collator;return g(x,_,A)||r(f,l)||g(N,f,l)}e.compareFileExtensionsLower=w;function R(f,l){f=f||"",l=l||"";const _=n(f).toLowerCase(),A=n(l).toLowerCase();return _!==A?_<A?-1:1:f!==l?f<l?-1:1:0}e.compareFileExtensionsUnicode=R;const S=/^(.*?)(\.([^.]*))?$/;function s(f,l=!1){const _=f?S.exec(f):[];let A=[_&&_[1]||"",_&&_[3]||""];return l&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function n(f){const l=f?S.exec(f):[];return l&&l[1]&&l[1].charAt(0)!=="."&&l[3]||""}function g(f,l,_){let A=f.compare(l,_);return A!==0?A:l.length!==_.length?l.length<_.length?-1:1:0}function a(f){const l=f.charAt(0);return l.toLocaleUpperCase()!==l}function E(f){const l=f.charAt(0);return l.toLocaleLowerCase()!==l}function r(f,l){return a(f)&&E(l)?-1:E(f)&&a(l)?1:0}function t(f,l){return E(f)&&a(l)?-1:a(f)&&E(l)?1:0}function o(f,l,_=!1){return _||(f=f&&f.toLowerCase(),l=l&&l.toLowerCase()),f===l?0:f<l?-1:1}function h(f,l,_=!1){const A=f.split(i.sep),N=l.split(i.sep),x=A.length-1,F=N.length-1;let O,z;for(let $=0;;$++){if(O=x===$,z=F===$,O&&z)return I(A[$],N[$],_);if(O)return-1;if(z)return 1;const M=o(A[$],N[$],_);if(M!==0)return M}}e.comparePaths=h;function u(f,l,_){const A=f.toLowerCase(),N=l.toLowerCase(),x=d(f,l,_);if(x)return x;const F=A.endsWith(_),O=N.endsWith(_);if(F!==O)return F?-1:1;const z=I(A,N);return z!==0?z:A.localeCompare(N)}e.compareAnything=u;function d(f,l,_){const A=f.toLowerCase(),N=l.toLowerCase(),x=A.startsWith(_),F=N.startsWith(_);if(x!==F)return x?-1:1;if(x&&F){if(A.length<N.length)return-1;if(A.length>N.length)return 1}return 0}e.compareByPrefix=d}),define(ve[102],we([0,1,101,98,47,8,12,9]),function(X,e,m,i,k,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,P=[y,[]];function L(M,B,W,U){if(!M||!B)return P;const j=M.length,Z=B.length;if(j<Z)return P;const ce=M.toLowerCase();return D(B,W,Z,M,ce,j,U)}e.scoreFuzzy=L;function D(M,B,W,U,j,Z,ce){const Q=[],V=[];for(let ke=0;ke<W;ke++){const Be=ke*Z,xe=Be-Z,q=ke>0,Y=M[ke],re=B[ke];for(let ue=0;ue<Z;ue++){const J=ue>0,ae=Be+ue,Ee=ae-1,Oe=xe+ue-1,Ve=J?Q[Ee]:0,Ke=q&&J?Q[Oe]:0,Je=q&&J?V[Oe]:0;let it;!Ke&&q?it=0:it=c(Y,re,U,j,ue,Je),it&&Ke+it>=Ve&&(ce||q||j.startsWith(B,ue))?(V[ae]=Je+1,Q[ae]=Ke+it):(V[ae]=y,Q[ae]=Ve)}}const te=[];let me=W-1,ge=Z-1;for(;me>=0&&ge>=0;){const ke=me*Z+ge;V[ke]===y||(te.push(ge),me--),ge--}return[Q[W*Z-1],te.reverse()]}function c(M,B,W,U,j,Z){let ce=0;if(!b(B,U[j]))return ce;if(ce+=1,Z>0&&(ce+=Z*5),M===W[j]&&(ce+=1),j===0)ce+=8;else{const Q=p(W.charCodeAt(j-1));Q?ce+=Q:(0,i.isUpper)(W.charCodeAt(j))&&Z===0&&(ce+=2)}return ce}function b(M,B){return M===B?!0:M==="/"||M==="\\"?B==="/"||B==="\\":!1}function p(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function w(M,B,W=0,U=0){const j=B;return j.values&&j.values.length>1?R(M,j.values,W,U):S(M,B,W,U)}e.scoreFuzzy2=w;function R(M,B,W,U){let j=0;const Z=[];for(const ce of B){const[Q,V]=S(M,ce,W,U);if(typeof Q!="number")return v;j+=Q,Z.push(...V)}return[j,d(Z)]}function S(M,B,W,U){const j=(0,i.fuzzyScore)(B.original,B.originalLowercase,W,M,M.toLowerCase(),U,!0);return j?[j[0],(0,i.createMatches)(j)]:v}const s=Object.freeze({score:0}),n=1<<18,g=1<<17,a=1<<16;function E(M,B,W,U){const j=U.values?U.values:[U];return(0,k.hash)({[U.normalized]:{values:j.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:M,description:B,allowNonContiguousMatches:W}})}function r(M,B,W,U,j){if(!M||!B.normalized)return s;const Z=U.getItemLabel(M);if(!Z)return s;const ce=U.getItemDescription(M),Q=E(Z,ce,W,B),V=j[Q];if(V)return V;const te=t(Z,ce,U.getItemPath(M),B,W);return j[Q]=te,te}e.scoreItemFuzzy=r;function t(M,B,W,U,j){const Z=!W||!U.containsPathSeparator;return W&&(T.isLinux?U.pathNormalized===W:(0,I.equalsIgnoreCase)(U.pathNormalized,W))?{score:n,labelMatch:[{start:0,end:M.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:U.values&&U.values.length>1?o(M,B,W,U.values,Z,j):h(M,B,W,U,Z,j)}function o(M,B,W,U,j,Z){let ce=0;const Q=[],V=[];for(const te of U){const{score:me,labelMatch:ge,descriptionMatch:ke}=h(M,B,W,te,j,Z);if(me===y)return s;ce+=me,ge&&Q.push(...ge),ke&&V.push(...ke)}return{score:ce,labelMatch:d(Q),descriptionMatch:d(V)}}function h(M,B,W,U,j,Z){if(j||!B){const[ce,Q]=L(M,U.normalized,U.normalizedLowercase,Z&&!U.expectContiguousMatch);if(ce){const V=(0,i.matchesPrefix)(U.normalized,M);let te;return V?(te=g,te+=Math.round(U.normalized.length/M.length*100)):te=a,{score:te+ce,labelMatch:V||u(Q)}}}if(B){let ce=B;W&&(ce=`${B}${C.sep}`);const Q=ce.length,V=`${ce}${M}`,[te,me]=L(V,U.normalized,U.normalizedLowercase,Z&&!U.expectContiguousMatch);if(te){const ge=u(me),ke=[],Be=[];return ge.forEach(xe=>{xe.start<Q&&xe.end>Q?(ke.push({start:0,end:xe.end-Q}),Be.push({start:xe.start,end:Q})):xe.start>=Q?ke.push({start:xe.start-Q,end:xe.end-Q}):Be.push(xe)}),{score:te,labelMatch:ke,descriptionMatch:Be}}}return s}function u(M){const B=[];if(!M)return B;let W;for(const U of M)W&&W.end===U?W.end+=1:(W={start:U,end:U+1},B.push(W));return B}function d(M){const B=M.sort((j,Z)=>j.start-Z.start),W=[];let U;for(const j of B)!U||!f(U,j)?(U=j,W.push(j)):(U.start=Math.min(U.start,j.start),U.end=Math.max(U.end,j.end));return W}function f(M,B){return!(M.end<B.start||B.end<M.start)}function l(M,B,W,U,j,Z){const ce=r(M,W,U,j,Z),Q=r(B,W,U,j,Z),V=ce.score,te=Q.score;if((V===n||te===n)&&V!==te)return V===n?-1:1;if(V>a||te>a){if(V!==te)return V>te?-1:1;if(V<g&&te<g){const Y=A(ce.labelMatch,Q.labelMatch);if(Y!==0)return Y}const xe=j.getItemLabel(M)||"",q=j.getItemLabel(B)||"";if(xe.length!==q.length)return xe.length-q.length}if(V!==te)return V>te?-1:1;const me=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,ge=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0;if(me&&!ge)return-1;if(ge&&!me)return 1;const ke=_(M,ce,j),Be=_(B,Q,j);return ke&&Be&&ke!==Be?Be>ke?-1:1:N(M,B,W,j)}e.compareItemsByFuzzyScore=l;function _(M,B,W){let U=-1,j=-1;if(B.descriptionMatch&&B.descriptionMatch.length?U=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(U=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(j=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const Z=W.getItemDescription(M);Z&&(j+=Z.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(j=B.descriptionMatch[B.descriptionMatch.length-1].end);return j-U}function A(M,B){if(!M&&!B||(!M||!M.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!M||!M.length)return 1;const W=M[0].start,j=M[M.length-1].end-W,Z=B[0].start,Q=B[B.length-1].end-Z;return j===Q?0:Q<j?1:-1}function N(M,B,W,U){const j=U.getItemLabel(M)||"",Z=U.getItemLabel(B)||"",ce=U.getItemDescription(M),Q=U.getItemDescription(B),V=j.length+(ce?ce.length:0),te=Z.length+(Q?Q.length:0);if(V!==te)return V-te;const me=U.getItemPath(M),ge=U.getItemPath(B);return me&&ge&&me.length!==ge.length?me.length-ge.length:j!==Z?(0,m.compareAnything)(j,Z,W.normalized):ce&&Q&&ce!==Q?(0,m.compareAnything)(ce,Q,W.normalized):me&&ge&&me!==ge?(0,m.compareAnything)(me,ge,W.normalized):0}function x(M){return M.startsWith('"')&&M.endsWith('"')}const F=" ";function O(M){typeof M!="string"&&(M="");const B=M.toLowerCase(),{pathNormalized:W,normalized:U,normalizedLowercase:j}=z(M),Z=W.indexOf(C.sep)>=0,ce=x(M);let Q;const V=M.split(F);if(V.length>1)for(const te of V){const me=x(te),{pathNormalized:ge,normalized:ke,normalizedLowercase:Be}=z(te);ke&&(Q||(Q=[]),Q.push({original:te,originalLowercase:te.toLowerCase(),pathNormalized:ge,normalized:ke,normalizedLowercase:Be,expectContiguousMatch:me}))}return{original:M,originalLowercase:B,pathNormalized:W,normalized:U,normalizedLowercase:j,values:Q,containsPathSeparator:Z,expectContiguousMatch:ce}}e.prepareQuery=O;function z(M){let B;T.isWindows?B=M.replace(/\//g,C.sep):B=M.replace(/\\/g,C.sep);const W=(0,I.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:W,normalizedLowercase:W.toLowerCase()}}function $(M){return Array.isArray(M)?O(M.map(B=>B.original).join(F)):O(M.original)}e.pieceToQuery=$}),define(ve[32],we([0,1,18,28,24,8,9]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",P="[^/\\\\]",L=/\//g;function D(B){switch(B){case 0:return"";case 1:return`${P}*?`;default:return`(?:${y}|${P}+${y}|${y}${P}+)*?`}}function c(B,W){if(!B)return[];const U=[];let j=!1,Z=!1,ce="";for(const Q of B){switch(Q){case W:if(!j&&!Z){U.push(ce),ce="";continue}break;case"{":j=!0;break;case"}":j=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}ce+=Q}return ce&&U.push(ce),U}e.splitGlobAware=c;function b(B){if(!B)return"";let W="";const U=c(B,e.GLOB_SPLIT);if(U.every(j=>j===e.GLOBSTAR))W=".*";else{let j=!1;U.forEach((Z,ce)=>{if(Z===e.GLOBSTAR){j||(W+=D(2),j=!0);return}let Q=!1,V="",te=!1,me="";for(const ge of Z){if(ge!=="}"&&Q){V+=ge;continue}if(te&&(ge!=="]"||!me)){let ke;ge==="-"?ke=ge:(ge==="^"||ge==="!")&&!me?ke="^":ge===e.GLOB_SPLIT?ke="":ke=T.escapeRegExpCharacters(ge),me+=ke;continue}switch(ge){case"{":Q=!0;continue;case"[":te=!0;continue;case"}":{W+=`(?:${c(V,",").map(xe=>b(xe)).join("|")})`,Q=!1,V="";break}case"]":W+="["+me+"]",te=!1,me="";break;case"?":W+=P;continue;case"*":W+=D(1);continue;default:W+=T.escapeRegExpCharacters(ge)}}ce<U.length-1&&(U[ce+1]!==e.GLOBSTAR||ce+2<U.length)&&(W+=y),j=!1})}return W}const p=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,R=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new k.LRUCache(1e4),g=function(){return!1},a=function(){return null};function E(B,W){if(!B)return a;let U;typeof B!="string"?U=B.pattern:U=B,U=U.trim();const j=`${U}_${!!W.trimForExclusions}`;let Z=n.get(j);if(Z)return r(Z,B);let ce;if(p.test(U)){const Q=U.substr(4);Z=function(V,te){return typeof V=="string"&&V.endsWith(Q)?U:null}}else(ce=v.exec(t(U,W)))?Z=o(ce[1],U):(W.trimForExclusions?R:w).test(U)?Z=h(U,W):(ce=S.exec(t(U,W)))?Z=u(ce[1].substr(1),U,!0):(ce=s.exec(t(U,W)))?Z=u(ce[1],U,!1):Z=d(U);return n.set(j,Z),r(Z,B)}function r(B,W){return typeof W=="string"?B:function(U,j){return i.isEqualOrParent(U,W.base)?B(C.relative(W.base,U),j):null}}function t(B,W){return W.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function o(B,W){const U=`/${B}`,j=`\\${B}`,Z=function(Q,V){return typeof Q!="string"?null:V?V===B?W:null:Q===B||Q.endsWith(U)||Q.endsWith(j)?W:null},ce=[B];return Z.basenames=ce,Z.patterns=[W],Z.allBasenames=ce,Z}function h(B,W){const U=M(B.slice(1,-1).split(",").map(V=>E(V,W)).filter(V=>V!==a),B),j=U.length;if(!j)return a;if(j===1)return U[0];const Z=function(V,te){for(let me=0,ge=U.length;me<ge;me++)if(U[me](V,te))return B;return null},ce=U.find(V=>!!V.allBasenames);ce&&(Z.allBasenames=ce.allBasenames);const Q=U.reduce((V,te)=>te.allPaths?V.concat(te.allPaths):V,[]);return Q.length&&(Z.allPaths=Q),Z}function u(B,W,U){const j=C.sep===C.posix.sep,Z=j?B:B.replace(L,C.sep),ce=C.sep+Z,Q=C.posix.sep+B,V=U?function(te,me){return typeof te=="string"&&(te===Z||te.endsWith(ce)||!j&&(te===B||te.endsWith(Q)))?W:null}:function(te,me){return typeof te=="string"&&(te===Z||!j&&te===B)?W:null};return V.allPaths=[(U?"*/":"./")+B],V}function d(B){try{const W=new RegExp(`^${b(B)}$`);return function(U){return W.lastIndex=0,typeof U=="string"&&W.test(U)?B:null}}catch{return a}}function f(B,W,U){return!B||typeof W!="string"?!1:l(B)(W,void 0,U)}e.match=f;function l(B,W={}){if(!B)return g;if(typeof B=="string"||x(B)){const U=E(B,W);if(U===a)return g;const j=function(Z,ce){return!!U(Z,ce)};return U.allBasenames&&(j.allBasenames=U.allBasenames),U.allPaths&&(j.allPaths=U.allPaths),j}return z(B,W)}e.parse=l;function _(B){if(!B)return;let W;return U=>(W||(W=(B()||Promise.resolve([])).then(j=>j?N(j):{})),W.then(j=>!!j[U]))}e.hasSiblingPromiseFn=_;function A(B){if(!B)return;let W;return U=>{if(!W){const j=B();W=j?N(j):{}}return!!W[U]}}e.hasSiblingFn=A;function N(B){const W={};for(const U of B)W[U]=!0;return W}function x(B){const W=B;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=x;function F(B){return B.allBasenames||[]}e.getBasenameTerms=F;function O(B){return B.allPaths||[]}e.getPathTerms=O;function z(B,W){const U=M(Object.getOwnPropertyNames(B).map(V=>$(V,B[V],W)).filter(V=>V!==a)),j=U.length;if(!j)return a;if(!U.some(V=>!!V.requiresSiblings)){if(j===1)return U[0];const V=function(ge,ke){for(let Be=0,xe=U.length;Be<xe;Be++){const q=U[Be](ge,ke);if(q)return q}return null},te=U.find(ge=>!!ge.allBasenames);te&&(V.allBasenames=te.allBasenames);const me=U.reduce((ge,ke)=>ke.allPaths?ge.concat(ke.allPaths):ge,[]);return me.length&&(V.allPaths=me),V}const Z=function(V,te,me){let ge;for(let ke=0,Be=U.length;ke<Be;ke++){const xe=U[ke];xe.requiresSiblings&&me&&(te||(te=C.basename(V)),ge||(ge=te.substr(0,te.length-C.extname(V).length)));const q=xe(V,te,ge,me);if(q)return q}return null},ce=U.find(V=>!!V.allBasenames);ce&&(Z.allBasenames=ce.allBasenames);const Q=U.reduce((V,te)=>te.allPaths?V.concat(te.allPaths):V,[]);return Q.length&&(Z.allPaths=Q),Z}function $(B,W,U){if(W===!1)return a;const j=E(B,U);if(j===a)return a;if(typeof W=="boolean")return j;if(W){const Z=W.when;if(typeof Z=="string"){const ce=(Q,V,te,me)=>{if(!me||!j(Q,V))return null;const ge=Z.replace("$(basename)",te),ke=me(ge);return(0,m.isThenable)(ke)?ke.then(Be=>Be?B:null):ke?B:null};return ce.requiresSiblings=!0,ce}}return j}function M(B,W){const U=B.filter(V=>!!V.basenames);if(U.length<2)return B;const j=U.reduce((V,te)=>{const me=te.basenames;return me?V.concat(me):V},[]);let Z;if(W){Z=[];for(let V=0,te=j.length;V<te;V++)Z.push(W)}else Z=U.reduce((V,te)=>{const me=te.patterns;return me?V.concat(me):V},[]);const ce=function(V,te){if(typeof V!="string")return null;if(!te){let ge;for(ge=V.length;ge>0;ge--){const ke=V.charCodeAt(ge-1);if(ke===47||ke===92)break}te=V.substr(ge)}const me=j.indexOf(te);return me!==-1?Z[me]:null};ce.basenames=j,ce.patterns=Z,ce.allBasenames=j;const Q=B.filter(V=>!V.basenames);return Q.push(ce),Q}}),define(ve[81],we([0,1,28,10,8,12,23,9,2]),function(X,e,m,i,k,C,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(t,o,h){if(typeof t=="string"&&(t=y.URI.file(t)),h){const d=h.getWorkspaceFolder(t);if(d){const f=h.getWorkspace().folders.length>1;let l;if((0,T.isEqual)(d.uri,t)?l="":l=(0,T.relativePath)(d.uri,t),f){const _=d.name?d.name:(0,T.basename)(d.uri);l=l?_+" \u2022 "+l:_}return l}}if(t.scheme!==i.Schemas.file&&t.scheme!==i.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(t.fsPath))return(0,k.normalize)(D(t.fsPath));let u=(0,k.normalize)(t.fsPath);return!C.isWindows&&o?.userHome&&(u=b(u,o.userHome.fsPath)),u}e.getPathLabel=P;function L(t){if(!t)return;typeof t=="string"&&(t=y.URI.file(t));const o=(0,T.basename)(t)||(t.scheme===i.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,m.isRootOrDriveLetter)(o)?D(o):o}e.getBaseLabel=L;function D(t,o){return(0,m.hasDriveLetter)(t,o)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=D;let c=Object.create(null);function b(t,o){if(C.isWindows||!t||!o)return t;let h=c.original===o?c.normalized:void 0;return h||(h=`${(0,I.rtrim)(o,k.posix.sep)}${k.posix.sep}`,c={original:o,normalized:h}),(C.isLinux?t.startsWith(h):(0,I.startsWithIgnoreCase)(t,h))&&(t=`~/${t.substr(h.length)}`),t}e.tildify=b;function p(t,o){return t.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=p;const v="\u2026",w="\\\\",R="~";function S(t,o=k.sep){const h=new Array(t.length);let u=!1;for(let d=0;d<t.length;d++){let f=t[d];if(f===""){h[d]=`.${o}`;continue}if(!f){h[d]=f;continue}u=!0;let l="";f.indexOf(w)===0?(l=f.substr(0,f.indexOf(w)+w.length),f=f.substr(f.indexOf(w)+w.length)):f.indexOf(o)===0?(l=f.substr(0,f.indexOf(o)+o.length),f=f.substr(f.indexOf(o)+o.length)):f.indexOf(R)===0&&(l=f.substr(0,f.indexOf(R)+R.length),f=f.substr(f.indexOf(R)+R.length));const _=f.split(o);for(let A=1;u&&A<=_.length;A++)for(let N=_.length-A;u&&N>=0;N--){u=!1;let x=_.slice(N,N+A).join(o);for(let F=0;!u&&F<t.length;F++)if(F!==d&&t[F]&&t[F].indexOf(x)>-1){const O=N+A===_.length,z=N>0&&t[F].indexOf(o)>-1?o+x:x,$=t[F].endsWith(z);u=!O||$}if(!u){let F="";(_[0].endsWith(":")||l!=="")&&(N===1&&(N=0,A++,x=_[0]+o+x),N>0&&(F=_[0]+o),F=l+F),N>0&&(F=F+v+o),F=F+x,N+A<_.length&&(F=F+o+v),h[d]=F}}u&&(h[d]=f)}return h}e.shorten=S;var s;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function n(t,o=Object.create(null)){const h=[];let u=!1,d="";for(const f of t)if(f==="$"||u&&f==="{")d&&h.push({value:d,type:s.TEXT}),d="",u=!0;else if(f==="}"&&u){const l=o[d];if(typeof l=="string")l.length&&h.push({value:l,type:s.VARIABLE});else if(l){const _=h[h.length-1];(!_||_.type!==s.SEPARATOR)&&h.push({value:l.label,type:s.SEPARATOR})}d="",u=!1}else d+=f;return d&&!u&&h.push({value:d,type:s.TEXT}),h.filter((f,l)=>{if(f.type===s.SEPARATOR){const _=h[l-1],A=h[l+1];return[_,A].every(N=>N&&(N.type===s.VARIABLE||N.type===s.TEXT)&&N.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=n;function g(t,o){return C.isMacintosh||o?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function a(t,o){return C.isMacintosh||o?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,h=>h==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function E(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=E;function r(t){const o=t.indexOf("/")!==-1?k.posix:k.win32,h=o.basename(t),u=o.dirname(t);return h.length?{name:h,parentPath:u}:{name:u,parentPath:""}}e.splitName=r}),define(ve[103],we([0,1,2]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(L){return L.toJSON()}class k{constructor(D){this._uriTransformer=D}transformIncoming(D){const c=this._uriTransformer.transformIncoming(D);return c===D?D:i(m.URI.from(c))}transformOutgoing(D){const c=this._uriTransformer.transformOutgoing(D);return c===D?D:i(m.URI.from(c))}transformOutgoingURI(D){const c=this._uriTransformer.transformOutgoing(D);return c===D?D:m.URI.from(c)}transformOutgoingScheme(D){return this._uriTransformer.transformOutgoingScheme(D)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function C(L,D,c){if(!L||c>200)return null;if(typeof L=="object"){if(L instanceof m.URI)return D.transformOutgoing(L);for(let b in L)if(Object.hasOwnProperty.call(L,b)){const p=C(L[b],D,c+1);p!==null&&(L[b]=p)}}return null}function T(L,D){const c=C(L,D,0);return c===null?L:c}e.transformOutgoingURIs=T;function I(L,D,c,b){if(!L||b>200)return null;if(typeof L=="object"){if(L.$mid===1)return c?m.URI.revive(D.transformIncoming(L)):D.transformIncoming(L);for(let p in L)if(Object.hasOwnProperty.call(L,p)){const v=I(L[p],D,c,b+1);v!==null&&(L[p]=v)}}return null}function y(L,D){const c=I(L,D,!1,0);return c===null?L:c}e.transformIncomingURIs=y;function P(L,D){const c=I(L,D,!0,0);return c===null?L:c}e.transformAndReviveIncomingURIs=P}),define(ve[33],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(y){return m.test(y)}e.isUUID=i;const k=new Uint8Array(16),C=[];for(let y=0;y<256;y++)C.push(y.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(y){for(let P=0;P<y.length;P++)y[P]=Math.floor(Math.random()*256);return y};function I(){T(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let y=0,P="";return P+=C[k[y++]],P+=C[k[y++]],P+=C[k[y++]],P+=C[k[y++]],P+="-",P+=C[k[y++]],P+=C[k[y++]],P+="-",P+=C[k[y++]],P+=C[k[y++]],P+="-",P+=C[k[y++]],P+=C[k[y++]],P+="-",P+=C[k[y++]],P+=C[k[y++]],P+=C[k[y++]],P+=C[k[y++]],P+=C[k[y++]],P+=C[k[y++]],P}e.generateUuid=I}),define(ve[143],we([0,1,104]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(C="utf8"){this.stringDecoder=new m.StringDecoder(C),this.remaining=null}write(C){const T=[],I=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(I.length<1)return T;let y=0,P,L=y;for(;L<I.length;)if(P=I.charCodeAt(L),P===13||P===10){if(T.push(I.substring(y,L)),L++,L<I.length){const D=P;P=I.charCodeAt(L),(D===13&&P===10||D===10&&P===13)&&L++}y=L}else L++;return this.remaining=y<I.length?I.substr(y):null,T}end(){return this.remaining}}e.LineDecoder=i}),define(ve[29],we([0,1,60,82,291,18,28,80,8,12,23,2]),function(X,e,m,i,k,C,T,I,y,P,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var c;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(c=e.RimRafMode||(e.RimRafMode={}));async function b(O,z=c.UNLINK){if((0,T.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return z===c.UNLINK?v(O):p(O)}async function p(O){try{const z=(0,T.randomPath)((0,i.tmpdir)());try{await m.promises.rename(O,z)}catch{return v(O)}v(z).catch($=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function v(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function w(O){if((0,T.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(O,{recursive:!0})}e.rimrafSync=w;async function R(O,z){return n(await(z?S(O):(0,k.promisify)(m.readdir)(O)))}async function S(O){try{return await(0,k.promisify)(m.readdir)(O,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const z=[],$=await R(O);for(const M of $){let B=!1,W=!1,U=!1;try{const j=await e.Promises.lstat((0,y.join)(O,M));B=j.isFile(),W=j.isDirectory(),U=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}z.push({name:M,isFile:()=>B,isDirectory:()=>W,isSymbolicLink:()=>U})}return z}function s(O){return n(m.readdirSync(O))}e.readdirSync=s;function n(O){return O.map(z=>typeof z=="string"?P.isMacintosh?(0,I.normalizeNFC)(z):z:(z.name=P.isMacintosh?(0,I.normalizeNFC)(z.name):z.name,z))}async function g(O){const z=await R(O),$=[];for(const M of z)await E.existsDirectory((0,y.join)(O,M))&&$.push(M);return $}function a(O,z=1e3){return new Promise($=>{let M=!1;const B=setInterval(()=>{M||(M=!0,m.access(O,W=>{M=!1,W&&(clearInterval(B),$(void 0))}))},z)})}e.whenDeleted=a;var E;(function(O){async function z(B){let W;try{if(W=await e.Promises.lstat(B),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(P.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw j}throw U}}O.stat=z;async function $(B){try{const{stat:W,symbolicLink:U}=await O.stat(B);return W.isFile()&&U?.dangling!==!0}catch{}return!1}O.existsFile=$;async function M(B){try{const{stat:W,symbolicLink:U}=await O.stat(B);return W.isDirectory()&&U?.dangling!==!0}catch{}return!1}O.existsDirectory=M})(E=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new C.ResourceQueue;function t(O,z,$){return r.queueFor(D.URI.file(O),L.extUriBiasedIgnorePathCase).queue(()=>{const M=d($);return new Promise((B,W)=>h(O,z,M,U=>U?W(U):B()))})}let o=!0;function h(O,z,$,M){if(!o)return m.writeFile(O,z,{mode:$.mode,flag:$.flag},M);m.open(O,$.flag,$.mode,(B,W)=>{if(B)return M(B);m.writeFile(W,z,U=>{if(U)return m.close(W,()=>M(U));m.fdatasync(W,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),o=!1),m.close(W,Z=>M(Z))))})})}function u(O,z,$){const M=d($);if(!o)return m.writeFileSync(O,z,{mode:M.mode,flag:M.flag});const B=m.openSync(O,M.flag,M.mode);try{m.writeFileSync(B,z);try{m.fdatasyncSync(B)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),o=!1}}finally{m.closeSync(B)}}e.writeFileSync=u;function d(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function f(O,z){if(O===z)return;async function $(M){try{const B=await e.Promises.lstat(M);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(M,B.atime,new Date)}catch{}}try{await e.Promises.rename(O,z),await $(z)}catch(M){if(O.toLowerCase()!==z.toLowerCase()&&M.code==="EXDEV"||O.endsWith("."))await l(O,z,{preserveSymlinks:!1}),await b(O,c.MOVE),await $(z);else throw M}}async function l(O,z,$){return A(O,z,{root:{source:O,target:z},options:$,handledSourcePaths:new Set})}const _=511;async function A(O,z,$){if($.handledSourcePaths.has(O))return;$.handledSourcePaths.add(O);const{stat:M,symbolicLink:B}=await E.stat(O);if(B){if($.options.preserveSymlinks)try{return await F(O,z,$)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(B.dangling)return}return M.isDirectory()?N(O,z,M.mode&_,$):x(O,z,M.mode&_)}async function N(O,z,$,M){await e.Promises.mkdir(z,{recursive:!0,mode:$});const B=await R(O);for(const W of B)await A((0,y.join)(O,W),(0,y.join)(z,W),M)}async function x(O,z,$){await e.Promises.copyFile(O,z),await e.Promises.chmod(z,$)}async function F(O,z,$){let M=await e.Promises.readlink(O);(0,T.isEqualOrParent)(M,$.root.source,!P.isLinux)&&(M=(0,y.join)($.root.target,M.substr($.root.source.length+1))),await e.Promises.symlink(M,z)}e.Promises=new class{get access(){return(0,k.promisify)(m.access)}get stat(){return(0,k.promisify)(m.stat)}get lstat(){return(0,k.promisify)(m.lstat)}get utimes(){return(0,k.promisify)(m.utimes)}get read(){return(0,k.promisify)(m.read)}get readFile(){return(0,k.promisify)(m.readFile)}get write(){return(0,k.promisify)(m.write)}get appendFile(){return(0,k.promisify)(m.appendFile)}get fdatasync(){return(0,k.promisify)(m.fdatasync)}get truncate(){return(0,k.promisify)(m.truncate)}get rename(){return(0,k.promisify)(m.rename)}get copyFile(){return(0,k.promisify)(m.copyFile)}get open(){return(0,k.promisify)(m.open)}get close(){return(0,k.promisify)(m.close)}get symlink(){return(0,k.promisify)(m.symlink)}get readlink(){return(0,k.promisify)(m.readlink)}get chmod(){return(0,k.promisify)(m.chmod)}get mkdir(){return(0,k.promisify)(m.mkdir)}get unlink(){return(0,k.promisify)(m.unlink)}get rmdir(){return(0,k.promisify)(m.rmdir)}get realpath(){return(0,k.promisify)(m.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return R}get readDirsInDir(){return g}get writeFile(){return t}get rm(){return b}get move(){return f}get copy(){return l}}}),define(ve[105],we([0,1,60,8,12,9,29]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(c){if(k.isLinux)return c;const b=(0,i.dirname)(c);if(c===b)return c;const p=((0,i.basename)(c)||c).toLowerCase();try{const w=(0,T.readdirSync)(b).filter(R=>R.toLowerCase()===p);if(w.length===1){const R=I(b);if(R)return(0,i.join)(R,w[0])}else if(w.length>1){const R=w.indexOf(p);if(R>=0){const S=I(b);if(S)return(0,i.join)(S,w[R])}}}catch{}return null}e.realcaseSync=I;async function y(c){if(k.isLinux)return c;const b=(0,i.dirname)(c);if(c===b)return c;const p=((0,i.basename)(c)||c).toLowerCase();try{const w=(await T.Promises.readdir(b)).filter(R=>R.toLowerCase()===p);if(w.length===1){const R=await y(b);if(R)return(0,i.join)(R,w[0])}else if(w.length>1){const R=w.indexOf(p);if(R>=0){const S=await y(b);if(S)return(0,i.join)(S,w[R])}}}catch{}return null}e.realcase=y;async function P(c){try{return await T.Promises.realpath(c)}catch{const p=D(c);return await T.Promises.access(p,m.constants.R_OK),p}}e.realpath=P;function L(c){try{return m.realpathSync(c)}catch{const p=D(c);return m.accessSync(p,m.constants.R_OK),p}}e.realpathSync=L;function D(c){return(0,C.rtrim)((0,i.normalize)(c),i.sep)}});var je=this&&this.__decorate||function(X,e,m,i){var k=arguments.length,C=k<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,m):i,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(X,e,m,i);else for(var I=X.length-1;I>=0;I--)(T=X[I])&&(C=(k<3?T(C):k>3?T(e,m,C):T(e,m))||C);return k>3&&C&&Object.defineProperty(e,m,C),C};define(ve[106],we([0,1,16,18,22,21,57,15,3,6,59,9,13]),function(X,e,m,i,k,C,T,I,y,P,L,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function p(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function w(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var R;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(R||(R={}));class S{constructor(U){this.buffer=U,this.pos=0}read(U){const j=this.buffer.slice(this.pos,this.pos+U);return this.pos+=j.byteLength,j}}class s{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var n;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(n||(n={}));function g(W){const U=k.VSBuffer.alloc(4);return U.writeUInt32BE(W,0),U}function a(W){return W.read(4).readUInt32BE(0)}function E(W){const U=k.VSBuffer.alloc(1);return U.writeUInt8(W,0),U}const r={Undefined:E(n.Undefined),String:E(n.String),Buffer:E(n.Buffer),VSBuffer:E(n.VSBuffer),Array:E(n.Array),Object:E(n.Object)},t=typeof Buffer!="undefined";function o(W,U){if(typeof U=="undefined")W.write(r.Undefined);else if(typeof U=="string"){const j=k.VSBuffer.fromString(U);W.write(r.String),W.write(g(j.byteLength)),W.write(j)}else if(t&&Buffer.isBuffer(U)){const j=k.VSBuffer.wrap(U);W.write(r.Buffer),W.write(g(j.byteLength)),W.write(j)}else if(U instanceof k.VSBuffer)W.write(r.VSBuffer),W.write(g(U.byteLength)),W.write(U);else if(Array.isArray(U)){W.write(r.Array),W.write(g(U.length));for(const j of U)o(W,j)}else{const j=k.VSBuffer.fromString(JSON.stringify(U));W.write(r.Object),W.write(g(j.byteLength)),W.write(j)}}function h(W){switch(W.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return W.read(a(W)).toString();case n.Buffer:return W.read(a(W)).buffer;case n.VSBuffer:return W.read(a(W));case n.Array:{const j=a(W),Z=[];for(let ce=0;ce<j;ce++)Z.push(h(W));return Z}case n.Object:return JSON.parse(W.read(a(W)).toString())}}class u{constructor(U,j,Z=null,ce=1e3){this.protocol=U,this.ctx=j,this.logger=Z,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(U,j){this.channels.set(U,j),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const j=this.send([U.type]);this.logger&&this.logger.logOutgoing(j,0,1,w(U.type));return}case 201:case 202:case 204:case 203:{const j=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(j,U.id,1,w(U.type),U.data);return}}}send(U,j=void 0){const Z=new s;return o(Z,U),o(Z,j),this.sendBuffer(Z.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onRawMessage(U){const j=new S(U),Z=h(j),ce=h(j),Q=Z[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,Z[1],1,`${p(Q)}: ${Z[2]}.${Z[3]}`,ce),this.onPromise({type:Q,id:Z[1],channelName:Z[2],name:Z[3],arg:ce});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,Z[1],1,`${p(Q)}: ${Z[2]}.${Z[3]}`,ce),this.onEventListen({type:Q,id:Z[1],channelName:Z[2],name:Z[3],arg:ce});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,Z[1],1,`${p(Q)}`),this.disposeActiveRequest({type:Q,id:Z[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,Z[1],1,`${p(Q)}`),this.disposeActiveRequest({type:Q,id:Z[1]})}}onPromise(U){const j=this.channels.get(U.channelName);if(!j){this.collectPendingRequest(U);return}const Z=new C.CancellationTokenSource;let ce;try{ce=j.call(this.ctx,U.name,U.arg,Z.token)}catch(te){ce=Promise.reject(te)}const Q=U.id;ce.then(te=>{this.sendResponse({id:Q,data:te,type:201}),this.activeRequests.delete(U.id)},te=>{te instanceof Error?this.sendResponse({id:Q,data:{message:te.message,name:te.name,stack:te.stack?te.stack.split?te.stack.split(`
`):te.stack:void 0},type:202}):this.sendResponse({id:Q,data:te,type:203}),this.activeRequests.delete(U.id)});const V=(0,P.toDisposable)(()=>Z.cancel());this.activeRequests.set(U.id,V)}onEventListen(U){const j=this.channels.get(U.channelName);if(!j){this.collectPendingRequest(U);return}const Z=U.id,Q=j.listen(this.ctx,U.name,U.arg)(V=>this.sendResponse({id:Z,data:V,type:204}));this.activeRequests.set(U.id,Q)}disposeActiveRequest(U){const j=this.activeRequests.get(U.id);j&&(j.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let j=this.pendingRequests.get(U.channelName);j||(j=[],this.pendingRequests.set(U.channelName,j));const Z=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:U,timeoutTimer:Z})}flushPendingRequests(U){const j=this.pendingRequests.get(U);if(j){for(const Z of j)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.onPromise(Z.request);break;case 102:this.onEventListen(Z.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var d;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class f{constructor(U,j=null){this.protocol=U,this.isDisposed=!1,this.state=R.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Z=>this.onBuffer(Z)),this.logger=j}getChannel(U){const j=this;return{call(Z,ce,Q){return j.isDisposed?Promise.reject(I.canceled()):j.requestPromise(U,Z,ce,Q)},listen(Z,ce){return j.isDisposed?Promise.reject(I.canceled()):j.requestEvent(U,Z,ce)}}}requestPromise(U,j,Z,ce=C.CancellationToken.None){const Q=this.lastRequestId++,te={id:Q,type:100,channelName:U,name:j,arg:Z};if(ce.isCancellationRequested)return Promise.reject(I.canceled());let me;return new Promise((ke,Be)=>{if(ce.isCancellationRequested)return Be(I.canceled());const xe=()=>{const ue=J=>{switch(J.type){case 201:this.handlers.delete(Q),ke(J.data);break;case 202:{this.handlers.delete(Q);const ae=new Error(J.data.message);ae.stack=J.data.stack,ae.name=J.data.name,Be(ae);break}case 203:this.handlers.delete(Q),Be(J.data);break}};this.handlers.set(Q,ue),this.sendRequest(te)};let q=null;this.state===R.Idle?xe():(q=(0,i.createCancelablePromise)(ue=>this.whenInitialized()),q.then(()=>{q=null,xe()}));const Y=()=>{q?(q.cancel(),q=null):this.sendRequest({id:Q,type:101}),Be(I.canceled())},re=ce.onCancellationRequested(Y);me=(0,P.combinedDisposable)((0,P.toDisposable)(Y),re),this.activeRequests.add(me)}).finally(()=>{this.activeRequests.delete(me)})}requestEvent(U,j,Z){const ce=this.lastRequestId++,V={id:ce,type:102,channelName:U,name:j,arg:Z};let te=null;const me=new y.Emitter({onFirstListenerAdd:()=>{te=(0,i.createCancelablePromise)(ke=>this.whenInitialized()),te.then(()=>{te=null,this.activeRequests.add(me),this.sendRequest(V)})},onLastListenerRemove:()=>{te?(te.cancel(),te=null):(this.activeRequests.delete(me),this.sendRequest({id:ce,type:103}))}}),ge=ke=>me.fire(ke.data);return this.handlers.set(ce,ge),me.event}sendRequest(U){switch(U.type){case 100:case 102:{const j=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(j,U.id,0,`${p(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const j=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(j,U.id,0,p(U.type));return}}}send(U,j=void 0){const Z=new s;return o(Z,U),o(Z,j),this.sendBuffer(Z.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onBuffer(U){const j=new S(U),Z=h(j),ce=h(j),Q=Z[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,w(Q)),this.onResponse({type:Z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,Z[1],0,w(Q),ce),this.onResponse({type:Z[0],id:Z[1],data:ce})}}onResponse(U){if(U.type===200){this.state=R.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(U.id);j&&j(U)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===R.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}je([T.memoize],f.prototype,"onDidInitializePromise",null),e.ChannelClient=f;class l{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:j,onDidClientDisconnect:Z})=>{y.Event.once(j.onMessage)(Q=>{const V=new S(Q),te=h(V),me=new u(j,te),ge=new f(j);this.channels.forEach((Be,xe)=>me.registerChannel(xe,Be));const ke={channelServer:me,channelClient:ge,ctx:te};this._connections.add(ke),this._onDidAddConnection.fire(ke),Z(()=>{me.dispose(),ge.dispose(),this._connections.delete(ke),this._onDidRemoveConnection.fire(ke)})})})}get connections(){const U=[];return this._connections.forEach(j=>U.push(j)),U}getChannel(U,j){const Z=this;return{call(ce,Q,V){let te;if((0,c.isFunction)(j)){let ge=(0,m.getRandomElement)(Z.connections.filter(j));te=ge?Promise.resolve(ge):y.Event.toPromise(y.Event.filter(Z.onDidAddConnection,j))}else te=j.routeCall(Z,ce,Q);const me=te.then(ge=>ge.channelClient.getChannel(U));return A(me).call(ce,Q,V)},listen(ce,Q){if((0,c.isFunction)(j))return Z.getMulticastEvent(U,j,ce,Q);const V=j.routeEvent(Z,ce,Q).then(te=>te.channelClient.getChannel(U));return A(V).listen(ce,Q)}}}getMulticastEvent(U,j,Z,ce){const Q=this;let V=new P.DisposableStore;const te=new y.Emitter({onFirstListenerAdd:()=>{V=new P.DisposableStore;const me=new y.EventMultiplexer,ge=new Map,ke=xe=>{const Y=xe.channelClient.getChannel(U).listen(Z,ce),re=me.add(Y);ge.set(xe,re)},Be=xe=>{const q=ge.get(xe);!q||(q.dispose(),ge.delete(xe))};Q.connections.filter(j).forEach(ke),y.Event.filter(Q.onDidAddConnection,j)(ke,void 0,V),Q.onDidRemoveConnection(Be,void 0,V),me.event(te.fire,te,V),V.add(me)},onLastListenerRemove:()=>{V.dispose()}});return te.event}registerChannel(U,j){this.channels.set(U,j),this._connections.forEach(Z=>{Z.channelServer.registerChannel(U,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=l;class _{constructor(U,j,Z=null){const ce=new s;o(ce,j),U.send(ce.buffer),this.channelClient=new f(U,Z),this.channelServer=new u(U,j,Z)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,j){this.channelServer.registerChannel(U,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function A(W){return{call(U,j,Z){return W.then(ce=>ce.call(U,j,Z))},listen(U,j){const Z=new y.Relay;return W.then(ce=>Z.input=ce.listen(U,j)),Z.event}}}e.getDelayedChannel=A;function N(W){let U=!1;return{call(j,Z,ce){return U?W.call(j,Z,ce):(0,i.timeout)(0).then(()=>U=!0).then(()=>W.call(j,Z,ce))},listen(j,Z){if(U)return W.listen(j,Z);const ce=new y.Relay;return(0,i.timeout)(0).then(()=>U=!0).then(()=>ce.input=W.listen(j,Z)),ce.event}}}e.getNextTickChannel=N;class x{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const j of U.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await y.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=x;var F;(function(W){function U(Q,V){const te=Q,me=V&&V.disableMarshalling,ge=new Map;for(const ke in te)Z(ke)&&ge.set(ke,y.Event.buffer(te[ke],!0));return new class{listen(ke,Be,xe){const q=ge.get(Be);if(q)return q;if(ce(Be)){const Y=te[Be];if(typeof Y=="function")return Y.call(te,xe)}throw new Error(`Event not found: ${Be}`)}call(ke,Be,xe){const q=te[Be];if(typeof q=="function"){if(!me&&Array.isArray(xe))for(let Y=0;Y<xe.length;Y++)xe[Y]=(0,L.revive)(xe[Y]);return q.apply(te,xe)}throw new Error(`Method not found: ${Be}`)}}}W.fromService=U;function j(Q,V){const te=V&&V.disableMarshalling;return new Proxy({},{get(me,ge){if(typeof ge=="string")return V?.properties?.has(ge)?V.properties.get(ge):ce(ge)?function(ke){return Q.listen(ge,ke)}:Z(ge)?Q.listen(ge):async function(...ke){let Be;V&&!(0,c.isUndefinedOrNull)(V.context)?Be=[V.context,...ke]:Be=ke;const xe=await Q.call(ge,Be);return te?xe:(0,L.revive)(xe)};throw new Error(`Property not found: ${String(ge)}`)}})}W.toService=j;function Z(Q){return Q[0]==="o"&&Q[1]==="n"&&D.isUpperAsciiLetter(Q.charCodeAt(2))}function ce(Q){return/^onDynamic/.test(Q)&&D.isUpperAsciiLetter(Q.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){let U=W.toString();if(U!=="[object Object]")return U}return W}function $(W){return Array.isArray(W)?W.map(z):z(W)}function M(W,U,j,Z,ce,Q,V){V=$(V);const te=O[ce],me=te[Z%te.length];let ge=[`%c[${W}]%c[${String(U).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${me}`];/\($/.test(Q)?(ge=ge.concat(V),ge.push(")")):ge.push(V),console.log.apply(console,ge)}e.logWithColors=M;class B{constructor(U,j){this._outgoingPrefix=U,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,j,Z,ce,Q){this._totalOutgoing+=U,M(this._outgoingPrefix,this._totalOutgoing,U,j,Z,ce,Q)}logIncoming(U,j,Z,ce,Q){this._totalIncoming+=U,M(this._incomingPrefix,this._totalIncoming,U,j,Z,ce,Q)}}e.IPCLogger=B}),define(ve[107],we([0,1,22,3,6,106]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(t){t.enableDiagnostics=!1,t.records=[];const o=new WeakMap;let h=0;function u(f,l){if(!o.has(f)){const _=String(++h);o.set(f,_)}return o.get(f)}function d(f,l,_,A){if(!t.enableDiagnostics)return;const N=u(f,l);if(A instanceof m.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const x=m.VSBuffer.alloc(A.byteLength);x.set(A),t.records.push({timestamp:Date.now(),id:N,label:l,type:_,buff:x})}else t.records.push({timestamp:Date.now(),id:N,label:l,type:_,data:A})}t.traceSocketEvent=d})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var y;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function L(){return P||(P=m.VSBuffer.alloc(0)),P}class D{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,h){if(o===0)return L();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const l=this._chunks[0];return h&&(this._chunks.shift(),this._totalLength-=o),l}if(this._chunks[0].byteLength>o){const l=this._chunks[0].slice(0,o);return h&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),l}let u=m.VSBuffer.alloc(o),d=0,f=0;for(;o>0;){const l=this._chunks[f];if(l.byteLength>o){const _=l.slice(0,o);u.set(_,d),d+=o,h&&(this._chunks[f]=l.slice(o),this._totalLength-=o),o-=o}else u.set(l,d),d+=l.byteLength,h?(this._chunks.shift(),this._totalLength-=l.byteLength):f++,o-=l.byteLength}return u}}e.ChunkStream=D;var c;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(c||(c={}));function b(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var p;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(o,h,u,d){this.type=o,this.id=h,this.ack=u,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends k.Disposable{constructor(o){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new D,this._register(this._socket.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const h=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=h.readUInt32BE(9),this._state.messageType=h.readUInt8(0),this._state.id=h.readUInt32BE(1),this._state.ack=h.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:b(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,d=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",h),this._onMessage.fire(new v(u,d,f,h)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class R{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=m.VSBuffer.alloc(13);h.writeUInt8(o.type,0),h.writeUInt32BE(o.id,1),h.writeUInt32BE(o.ack,5),h.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:b(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(h,o.data)}_bufferAdd(o,h){const u=this._totalLength===0;return this._data.push(o,h),this._totalLength+=o.byteLength+h.byteLength,u}_bufferTake(){const o=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,h){this._bufferAdd(o,h)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class S extends k.Disposable{constructor(o){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new R(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(h=>{h.type===1&&this._onMessage.fire(h.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new v(1,0,0,o))}}e.Protocol=S;class s extends C.IPCClient{constructor(o,h,u=null){super(o,h,u);this.protocol=o}static fromSocket(o,h){return new s(new S(o),h)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=s;class n{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=n;class g{constructor(o){this.data=o,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],h=0,u=this._first;for(;u;)o[h++]=u.data,u=u.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const h=new g(o);if(!this._first){this._first=h,this._last=h;return}this._last.next=h,this._last=h}}class E{constructor(){this.lastRuns=[];const o=Date.now();for(let h=0;h<E._HISTORY_LENGTH;h++)this.lastRuns[h]=o-1e3*h;setInterval(()=>{for(let h=E._HISTORY_LENGTH;h>=1;h--)this.lastRuns[h]=this.lastRuns[h-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return E._INSTANCE||(E._INSTANCE=new E),E._INSTANCE}load(){const o=Date.now(),h=(1+E._HISTORY_LENGTH)*1e3;let u=0;for(let d=0;d<E._HISTORY_LENGTH;d++)o-this.lastRuns[d]<=h&&u++;return 1-u/E._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}E._HISTORY_LENGTH=10,E._INSTANCE=null;class r{constructor(o,h=null,u=E.getInstance()){this._onControlMessage=new n,this.onControlMessage=this._onControlMessage.event,this._onMessage=new n,this.onMessage=this._onMessage.event,this._onDidDispose=new n,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new n,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new n,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new R(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),h&&this._socketReader.acceptChunk(h)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new v(5,0,0,L());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new v(7,0,0,L());this._socketWriter.write(o)}sendResume(){const o=new v(8,0,0,L());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,h){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new R(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(h)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new v(3,0,this._incomingAckId,L());this._socketWriter.write(o);const h=this._outgoingUnackMsg.toArray();for(let u=0,d=h.length;u<d;u++)this._socketWriter.write(h[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const h=this._outgoingUnackMsg.peek();if(h&&h.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const h=Date.now();h-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=h,this._socketWriter.write(new v(6,0,0,L())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const h=this._outgoingUnackMsg.toArray();for(let u=0,d=h.length;u<d;u++)this._socketWriter.write(h[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const h=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new v(1,h,this._incomingAckId,o);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(o){const h=new v(2,0,0,o);this._socketWriter.write(h)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),h=Date.now()-o.writtenTime,u=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(h>=2e4&&u>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const f=Math.max(2e4-h,2e4-u,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},f)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new v(3,0,this._incomingAckId,L());this._socketWriter.write(o)}}e.PersistentProtocol=r}),define(ve[108],we([0,1,100]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class i{constructor(I){const y=(0,m.toUint8)(I);this._defaultValue=y,this._asciiMap=i._createAsciiMap(y),this._map=new Map}static _createAsciiMap(I){const y=new Uint8Array(256);for(let P=0;P<256;P++)y[P]=I;return y}set(I,y){const P=(0,m.toUint8)(y);I>=0&&I<256?this._asciiMap[I]=P:this._map.set(I,P)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=i;var k;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(k||(k={}));class C{constructor(){this._actual=new i(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=C}),define(ve[144],we([0,1,108]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var i;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(i=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends m.CharacterClassifier{constructor(I){super(0);for(let y=0,P=I.length;y<P;y++)this.set(I.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function C(T){const I={};return y=>(I.hasOwnProperty(y)||(I[y]=T(y)),I[y])}e.getMapForWordSeparators=C(T=>new k(T))}),define(ve[49],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(k,C){this.lineNumber=k,this.column=C}with(k=this.lineNumber,C=this.column){return k===this.lineNumber&&C===this.column?this:new m(k,C)}delta(k=0,C=0){return this.with(this.lineNumber+k,this.column+C)}equals(k){return m.equals(this,k)}static equals(k,C){return!k&&!C?!0:!!k&&!!C&&k.lineNumber===C.lineNumber&&k.column===C.column}isBefore(k){return m.isBefore(this,k)}static isBefore(k,C){return k.lineNumber<C.lineNumber?!0:C.lineNumber<k.lineNumber?!1:k.column<C.column}isBeforeOrEqual(k){return m.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,C){return k.lineNumber<C.lineNumber?!0:C.lineNumber<k.lineNumber?!1:k.column<=C.column}static compare(k,C){const T=k.lineNumber|0,I=C.lineNumber|0;if(T===I){const y=k.column|0,P=C.column|0;return y-P}return T-I}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new m(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=m}),define(ve[41],we([0,1,49]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class i{constructor(C,T,I,y){C>I||C===I&&T>y?(this.startLineNumber=I,this.startColumn=y,this.endLineNumber=C,this.endColumn=T):(this.startLineNumber=C,this.startColumn=T,this.endLineNumber=I,this.endColumn=y)}isEmpty(){return i.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return i.containsPosition(this,C)}static containsPosition(C,T){return!(T.lineNumber<C.startLineNumber||T.lineNumber>C.endLineNumber||T.lineNumber===C.startLineNumber&&T.column<C.startColumn||T.lineNumber===C.endLineNumber&&T.column>C.endColumn)}static strictContainsPosition(C,T){return!(T.lineNumber<C.startLineNumber||T.lineNumber>C.endLineNumber||T.lineNumber===C.startLineNumber&&T.column<=C.startColumn||T.lineNumber===C.endLineNumber&&T.column>=C.endColumn)}containsRange(C){return i.containsRange(this,C)}static containsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>C.endColumn)}strictContainsRange(C){return i.strictContainsRange(this,C)}static strictContainsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<=C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>=C.endColumn)}plusRange(C){return i.plusRange(this,C)}static plusRange(C,T){let I,y,P,L;return T.startLineNumber<C.startLineNumber?(I=T.startLineNumber,y=T.startColumn):T.startLineNumber===C.startLineNumber?(I=T.startLineNumber,y=Math.min(T.startColumn,C.startColumn)):(I=C.startLineNumber,y=C.startColumn),T.endLineNumber>C.endLineNumber?(P=T.endLineNumber,L=T.endColumn):T.endLineNumber===C.endLineNumber?(P=T.endLineNumber,L=Math.max(T.endColumn,C.endColumn)):(P=C.endLineNumber,L=C.endColumn),new i(I,y,P,L)}intersectRanges(C){return i.intersectRanges(this,C)}static intersectRanges(C,T){let I=C.startLineNumber,y=C.startColumn,P=C.endLineNumber,L=C.endColumn,D=T.startLineNumber,c=T.startColumn,b=T.endLineNumber,p=T.endColumn;return I<D?(I=D,y=c):I===D&&(y=Math.max(y,c)),P>b?(P=b,L=p):P===b&&(L=Math.min(L,p)),I>P||I===P&&y>L?null:new i(I,y,P,L)}equalsRange(C){return i.equalsRange(this,C)}static equalsRange(C,T){return!!C&&!!T&&C.startLineNumber===T.startLineNumber&&C.startColumn===T.startColumn&&C.endLineNumber===T.endLineNumber&&C.endColumn===T.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(C){return new m.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(C){return new m.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,T){return new i(this.startLineNumber,this.startColumn,C,T)}setStartPosition(C,T){return new i(C,T,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(C){return new i(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,T=C){return new i(C.lineNumber,C.column,T.lineNumber,T.column)}static lift(C){return C?new i(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<C.startColumn)}static areIntersecting(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<=T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,T){if(C&&T){const P=C.startLineNumber|0,L=T.startLineNumber|0;if(P===L){const D=C.startColumn|0,c=T.startColumn|0;if(D===c){const b=C.endLineNumber|0,p=T.endLineNumber|0;if(b===p){const v=C.endColumn|0,w=T.endColumn|0;return v-w}return b-p}return D-c}return P-L}return(C?1:0)-(T?1:0)}static compareRangesUsingEnds(C,T){return C.endLineNumber===T.endLineNumber?C.endColumn===T.endColumn?C.startLineNumber===T.startLineNumber?C.startColumn-T.startColumn:C.startLineNumber-T.startLineNumber:C.endColumn-T.endColumn:C.endLineNumber-T.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=i}),define(ve[145],we([0,1,49,41]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class C extends i.Range{constructor(I,y,P,L){super(I,y,P,L);this.selectionStartLineNumber=I,this.selectionStartColumn=y,this.positionLineNumber=P,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return C.selectionsEqual(this,I)}static selectionsEqual(I,y){return I.selectionStartLineNumber===y.selectionStartLineNumber&&I.selectionStartColumn===y.selectionStartColumn&&I.positionLineNumber===y.positionLineNumber&&I.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,y){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,I,y):new C(I,y,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new m.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(I,y){return this.getDirection()===0?new C(I,y,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,I,y)}static fromPositions(I,y=I){return new C(I.lineNumber,I.column,y.lineNumber,y.column)}static fromRange(I,y){return y===0?new C(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):new C(I.endLineNumber,I.endColumn,I.startLineNumber,I.startColumn)}static liftSelection(I){return new C(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,y){if(I&&!y||!I&&y)return!1;if(!I&&!y)return!0;if(I.length!==y.length)return!1;for(let P=0,L=I.length;P<L;P++)if(!this.selectionsEqual(I[P],y[P]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,y,P,L,D){return D===0?new C(I,y,P,L):new C(P,L,I,y)}}e.Selection=C}),define(ve[146],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class i{constructor(I){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=I.open,this.close=I.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(I.notIn))for(let y=0,P=I.notIn.length;y<P;y++)switch(I.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(I){switch(I){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(I,y){if(I.getTokenCount()===0)return!0;const P=I.findTokenIndexAtOffset(y-2),L=I.getStandardTokenType(P);return this.isOK(L)}_findNeutralCharacterInRange(I,y){for(let P=I;P<=y;P++){const L=String.fromCharCode(P);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=i;class k{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of I)C(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),C(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),C(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),C(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&C(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=k;function C(T,I,y){T.has(I)?T.get(I).push(y):T.set(I,[y])}}),define(ve[83],we([0,1,32,8]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(C,T,I,y){if(Array.isArray(C)){let P=0;for(const L of C){const D=k(L,T,I,y);if(D===10)return D;D>P&&(P=D)}return P}else{if(typeof C=="string")return y?C==="*"?5:C===I?10:0:0;if(C){const{language:P,pattern:L,scheme:D,hasAccessToAllModels:c}=C;if(!y&&!c)return 0;let b=0;if(D)if(D===T.scheme)b=10;else if(D==="*")b=5;else return 0;if(P)if(P===I)b=10;else if(P==="*")b=Math.max(b,5);else return 0;if(L){let p;if(typeof L=="string"?p=L:p={...L,base:(0,i.normalize)(L.base)},p===T.fsPath||(0,m.match)(p,T.fsPath))b=10;else return 0}return b}else return 0}}e.score=k}),define(ve[147],we([0,1,108]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var i;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(i=e.State||(e.State={}));class k{constructor(p,v,w){const R=new Uint8Array(p*v);for(let S=0,s=p*v;S<s;S++)R[S]=w;this._data=R,this.rows=p,this.cols=v}get(p,v){return this._data[p*this.cols+v]}set(p,v,w){this._data[p*this.cols+v]=w}}e.Uint8Matrix=k;class C{constructor(p){let v=0,w=0;for(let S=0,s=p.length;S<s;S++){const[n,g,a]=p[S];g>v&&(v=g),n>w&&(w=n),a>w&&(w=a)}v++,w++;const R=new k(w,v,0);for(let S=0,s=p.length;S<s;S++){const[n,g,a]=p[S];R.set(n,g,a)}this._states=R,this._maxCharCode=v}nextState(p,v){return v<0||v>=this._maxCharCode?0:this._states.get(p,v)}}e.StateMachine=C;let T=null;function I(){return T===null&&(T=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var y;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let P=null;function L(){if(P===null){P=new m.CharacterClassifier(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<b.length;v++)P.set(b.charCodeAt(v),1);const p=".,;";for(let v=0;v<p.length;v++)P.set(p.charCodeAt(v),2)}return P}class D{static _createLink(p,v,w,R,S){let s=S-1;do{const n=v.charCodeAt(s);if(p.get(n)!==2)break;s--}while(s>R);if(R>0){const n=v.charCodeAt(R-1),g=v.charCodeAt(s);(n===40&&g===41||n===91&&g===93||n===123&&g===125)&&s--}return{range:{startLineNumber:w,startColumn:R+1,endLineNumber:w,endColumn:s+2},url:v.substring(R,s+1)}}static computeLinks(p,v=I()){const w=L(),R=[];for(let S=1,s=p.getLineCount();S<=s;S++){const n=p.getLineContent(S),g=n.length;let a=0,E=0,r=0,t=1,o=!1,h=!1,u=!1,d=!1;for(;a<g;){let f=!1;const l=n.charCodeAt(a);if(t===13){let _;switch(l){case 40:o=!0,_=0;break;case 41:_=o?0:1;break;case 91:u=!0,h=!0,_=0;break;case 93:u=!1,_=h?0:1;break;case 123:d=!0,_=0;break;case 125:_=d?0:1;break;case 39:_=r===34||r===96?0:1;break;case 34:_=r===39||r===96?0:1;break;case 96:_=r===39||r===34?0:1;break;case 42:_=r===42?1:0;break;case 124:_=r===124?1:0;break;case 32:_=u?0:1;break;default:_=w.get(l)}_===1&&(R.push(D._createLink(w,n,S,E,a)),f=!0)}else if(t===12){let _;l===91?(h=!0,_=0):_=w.get(l),_===1?f=!0:t=13}else t=v.nextState(t,l),t===0&&(f=!0);f&&(t=1,o=!1,h=!1,d=!1,E=a+1,r=l),a++}t===13&&R.push(D._createLink(w,n,S,E,g))}return R}}e.LinkComputer=D;function c(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:D.computeLinks(b)}e.computeLinks=c}),define(ve[148],we([0,1,3,6]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class k{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,y){return this._map.set(I,y),this.fire([I]),(0,i.toDisposable)(()=>{this._map.get(I)===y&&(this._map.delete(I),this.fire([I]))})}registerFactory(I,y){this._factories.get(I)?.dispose();const P=new C(this,I,y);return this._factories.set(I,P),(0,i.toDisposable)(()=>{const L=this._factories.get(I);!L||L!==P||(this._factories.delete(I),L.dispose())})}async getOrCreate(I){const y=this.get(I);if(y)return y;const P=this._factories.get(I);return!P||P.isResolved?null:(await P.resolve(),this.get(I))}get(I){return this._map.get(I)||null}isResolved(I){if(this.get(I))return!0;const P=this._factories.get(I);return!!(!P||P.isResolved)}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=k;class C extends i.Disposable{constructor(I,y,P){super();this._registry=I,this._languageId=y,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const I=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,I&&!this._isDisposed&&this._register(this._registry.register(this._languageId,I))}}}),define(ve[109],we([0,1,25]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var i;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(i=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(v){v[v.TextDefined=0]="TextDefined",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(v){v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var I;(function(v){v[v.LF=0]="LF",v[v.CRLF=1]="CRLF"})(I=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(w){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,w.tabSize|0),this.indentSize=w.tabSize|0,this.insertSpaces=Boolean(w.insertSpaces),this.defaultEOL=w.defaultEOL|0,this.trimAutoWhitespace=Boolean(w.trimAutoWhitespace),this.bracketPairColorizationOptions=w.bracketPairColorizationOptions}equals(w){return this.tabSize===w.tabSize&&this.indentSize===w.indentSize&&this.insertSpaces===w.insertSpaces&&this.defaultEOL===w.defaultEOL&&this.trimAutoWhitespace===w.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,w.bracketPairColorizationOptions)}createChangeEvent(w){return{tabSize:this.tabSize!==w.tabSize,indentSize:this.indentSize!==w.indentSize,insertSpaces:this.insertSpaces!==w.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==w.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class P{constructor(w,R){this._findMatchBrand=void 0,this.range=w,this.matches=R}}e.FindMatch=P;var L;(function(v){v[v.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",v[v.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",v[v.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",v[v.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(L=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var D;(function(v){v[v.Left=0]="Left",v[v.Right=1]="Right",v[v.None=2]="None"})(D=e.PositionAffinity||(e.PositionAffinity={}));var c;(function(v){v[v.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c=e.ModelConstants||(e.ModelConstants={}));class b{constructor(w,R,S,s,n,g){this.identifier=w,this.range=R,this.text=S,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=n,this._isTracked=g}}e.ValidAnnotatedEditOperation=b;class p{constructor(w,R,S){this.reverseEdits=w,this.changes=R,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=p}),define(ve[149],we([0,1,9,144,49,41,109]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class y{constructor(s,n,g,a){this.searchString=s,this.isRegex=n,this.matchCase=g,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=P(this.searchString):s=this.searchString.indexOf(`
`)>=0;let n=null;try{n=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch{return null}if(!n)return null;let g=!this.isRegex&&!s;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new L(n,this.wordSeparators?(0,i.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=y;function P(S){if(!S||S.length===0)return!1;for(let s=0,n=S.length;s<n;s++)if(S.charCodeAt(s)===92){if(s++,s>=n)break;const a=S.charCodeAt(s);if(a===110||a===114||a===87)return!0}return!1}e.isMultilineRegexSource=P;class L{constructor(s,n,g){this.regex=s,this.wordSeparators=n,this.simpleSearch=g}}e.SearchData=L;function D(S,s,n){if(!n)return new T.FindMatch(S,null);const g=[];for(let a=0,E=s.length;a<E;a++)g[a]=s[a];return new T.FindMatch(S,g)}e.createFindMatch=D;class c{constructor(s){const n=[];let g=0;for(let a=0,E=s.length;a<E;a++)s.charCodeAt(a)===10&&(n[g++]=a);this._lineFeedsOffsets=n}findLineFeedCountBeforeOffset(s){const n=this._lineFeedsOffsets;let g=0,a=n.length-1;if(a===-1||s<=n[0])return 0;for(;g<a;){const E=g+((a-g)/2>>0);n[E]>=s?a=E-1:n[E+1]>=s?(g=E,a=E):g=E+1}return g+1}}class b{static findMatches(s,n,g,a,E){const r=n.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(s,g,new R(r.wordSeparators,r.regex),a,E):this._doFindMatchesLineByLine(s,g,r,a,E):[]}static _getMultilineMatchRange(s,n,g,a,E,r){let t,o=0;a?(o=a.findLineFeedCountBeforeOffset(E),t=n+E+o):t=n+E;let h;if(a){const l=a.findLineFeedCountBeforeOffset(E+r.length)-o;h=t+r.length+l}else h=t+r.length;const u=s.getPositionAt(t),d=s.getPositionAt(h);return new C.Range(u.lineNumber,u.column,d.lineNumber,d.column)}static _doFindMatchesMultiline(s,n,g,a,E){const r=s.getOffsetAt(n.getStartPosition()),t=s.getValueInRange(n,1),o=s.getEOL()===`\r
`?new c(t):null,h=[];let u=0,d;for(g.reset(0);d=g.next(t);)if(h[u++]=D(this._getMultilineMatchRange(s,r,t,o,d.index,d[0]),d,a),u>=E)return h;return h}static _doFindMatchesLineByLine(s,n,g,a,E){const r=[];let t=0;if(n.startLineNumber===n.endLineNumber){const h=s.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return t=this._findMatchesInLine(g,h,n.startLineNumber,n.startColumn-1,t,r,a,E),r}const o=s.getLineContent(n.startLineNumber).substring(n.startColumn-1);t=this._findMatchesInLine(g,o,n.startLineNumber,n.startColumn-1,t,r,a,E);for(let h=n.startLineNumber+1;h<n.endLineNumber&&t<E;h++)t=this._findMatchesInLine(g,s.getLineContent(h),h,0,t,r,a,E);if(t<E){const h=s.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);t=this._findMatchesInLine(g,h,n.endLineNumber,0,t,r,a,E)}return r}static _findMatchesInLine(s,n,g,a,E,r,t,o){const h=s.wordSeparators;if(!t&&s.simpleSearch){const f=s.simpleSearch,l=f.length,_=n.length;let A=-l;for(;(A=n.indexOf(f,A+l))!==-1;)if((!h||w(h,n,_,A,l))&&(r[E++]=new T.FindMatch(new C.Range(g,A+1+a,g,A+1+l+a),null),E>=o))return E;return E}const u=new R(s.wordSeparators,s.regex);let d;u.reset(0);do if(d=u.next(n),d&&(r[E++]=D(new C.Range(g,d.index+1+a,g,d.index+1+d[0].length+a),d,t),E>=o))return E;while(d);return E}static findNextMatch(s,n,g,a){const E=n.parseSearchRequest();if(!E)return null;const r=new R(E.wordSeparators,E.regex);return E.regex.multiline?this._doFindNextMatchMultiline(s,g,r,a):this._doFindNextMatchLineByLine(s,g,r,a)}static _doFindNextMatchMultiline(s,n,g,a){const E=new k.Position(n.lineNumber,1),r=s.getOffsetAt(E),t=s.getLineCount(),o=s.getValueInRange(new C.Range(E.lineNumber,E.column,t,s.getLineMaxColumn(t)),1),h=s.getEOL()===`\r
`?new c(o):null;g.reset(n.column-1);let u=g.next(o);return u?D(this._getMultilineMatchRange(s,r,o,h,u.index,u[0]),u,a):n.lineNumber!==1||n.column!==1?this._doFindNextMatchMultiline(s,new k.Position(1,1),g,a):null}static _doFindNextMatchLineByLine(s,n,g,a){const E=s.getLineCount(),r=n.lineNumber,t=s.getLineContent(r),o=this._findFirstMatchInLine(g,t,r,n.column,a);if(o)return o;for(let h=1;h<=E;h++){const u=(r+h-1)%E,d=s.getLineContent(u+1),f=this._findFirstMatchInLine(g,d,u+1,1,a);if(f)return f}return null}static _findFirstMatchInLine(s,n,g,a,E){s.reset(a-1);const r=s.next(n);return r?D(new C.Range(g,r.index+1,g,r.index+1+r[0].length),r,E):null}static findPreviousMatch(s,n,g,a){const E=n.parseSearchRequest();if(!E)return null;const r=new R(E.wordSeparators,E.regex);return E.regex.multiline?this._doFindPreviousMatchMultiline(s,g,r,a):this._doFindPreviousMatchLineByLine(s,g,r,a)}static _doFindPreviousMatchMultiline(s,n,g,a){const E=this._doFindMatchesMultiline(s,new C.Range(1,1,n.lineNumber,n.column),g,a,10*I);if(E.length>0)return E[E.length-1];const r=s.getLineCount();return n.lineNumber!==r||n.column!==s.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(s,new k.Position(r,s.getLineMaxColumn(r)),g,a):null}static _doFindPreviousMatchLineByLine(s,n,g,a){const E=s.getLineCount(),r=n.lineNumber,t=s.getLineContent(r).substring(0,n.column-1),o=this._findLastMatchInLine(g,t,r,a);if(o)return o;for(let h=1;h<=E;h++){const u=(E+r-h-1)%E,d=s.getLineContent(u+1),f=this._findLastMatchInLine(g,d,u+1,a);if(f)return f}return null}static _findLastMatchInLine(s,n,g,a){let E=null,r;for(s.reset(0);r=s.next(n);)E=D(new C.Range(g,r.index+1,g,r.index+1+r[0].length),r,a);return E}}e.TextModelSearch=b;function p(S,s,n,g,a){if(g===0)return!0;const E=s.charCodeAt(g-1);if(S.get(E)!==0||E===13||E===10)return!0;if(a>0){const r=s.charCodeAt(g);if(S.get(r)!==0)return!0}return!1}function v(S,s,n,g,a){if(g+a===n)return!0;const E=s.charCodeAt(g+a);if(S.get(E)!==0||E===13||E===10)return!0;if(a>0){const r=s.charCodeAt(g+a-1);if(S.get(r)!==0)return!0}return!1}function w(S,s,n,g,a){return p(S,s,n,g,a)&&v(S,s,n,g,a)}e.isValidMatch=w;class R{constructor(s,n){this._wordSeparators=s,this._searchRegex=n,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const n=s.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===n||(g=this._searchRegex.exec(s),!g))return null;const a=g.index,E=g[0].length;if(a===this._prevMatchStartIndex&&E===this._prevMatchLength){if(E===0){m.getNextCodePoint(s,n,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=E,!this._wordSeparators||w(this._wordSeparators,s,n,a,E))return g}while(g);return null}}e.Searcher=R}),define(ve[110],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(I=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)I.indexOf(P)>=0||(y+="\\"+P);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=m();function i(I){let y=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)y=I;else{let P="g";I.ignoreCase&&(P+="i"),I.multiline&&(P+="m"),I.unicode&&(P+="u"),y=new RegExp(I.source,P)}return y.lastIndex=0,y}e.ensureValidWordDefinition=i;const k={maxLen:1e3,windowSize:15,timeBudget:150};function C(I,y,P,L,D=k){if(P.length>D.maxLen){let w=I-D.maxLen/2;return w<0?w=0:L+=w,P=P.substring(w,I+D.maxLen/2),C(I,y,P,L,D)}const c=Date.now(),b=I-1-L;let p=-1,v=null;for(let w=1;!(Date.now()-c>=D.timeBudget);w++){const R=b-D.windowSize*w;y.lastIndex=Math.max(0,R);const S=T(y,P,b,p);if(!S&&v||(v=S,R<=0))break;p=R}if(v){const w={word:v[0],startColumn:L+1+v.index,endColumn:L+1+v.index+v[0].length};return y.lastIndex=0,w}return null}e.getWordAtText=C;function T(I,y,P,L){let D;for(;D=I.exec(y);){const c=D.index||0;if(c<=P&&I.lastIndex>=P)return D;if(L>0&&c>L)return null}return null}}),define(ve[111],we([0,1,22,12]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(k||(k={}));function C(D){for(let c=0,b=D.length;c<b;c+=4){const p=D[c+0],v=D[c+1],w=D[c+2],R=D[c+3];D[c+0]=R,D[c+1]=w,D[c+2]=v,D[c+3]=p}}function T(D){const c=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return i.isLittleEndian()||C(c),m.VSBuffer.wrap(c)}function I(D){const c=D.buffer;if(i.isLittleEndian()||C(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const b=new Uint8Array(c.byteLength);return b.set(c),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function y(D){const c=new Uint32Array(P(D));let b=0;if(c[b++]=D.id,D.type==="full")c[b++]=1,c[b++]=D.data.length,c.set(D.data,b),b+=D.data.length;else{c[b++]=2,c[b++]=D.deltas.length;for(const p of D.deltas)c[b++]=p.start,c[b++]=p.deleteCount,p.data?(c[b++]=p.data.length,c.set(p.data,b),b+=p.data.length):c[b++]=0}return T(c)}e.encodeSemanticTokensDto=y;function P(D){let c=0;if(c+=1+1,D.type==="full")c+=1+D.data.length;else{c+=1,c+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(c+=b.data.length)}return c}function L(D){const c=I(D);let b=0;const p=c[b++];if(c[b++]===1){const S=c[b++],s=c.subarray(b,b+S);return b+=S,{id:p,type:"full",data:s}}const w=c[b++],R=[];for(let S=0;S<w;S++){const s=c[b++],n=c[b++],g=c[b++];let a;g>0&&(a=c.subarray(b,b+g),b+=g),R[S]={start:s,deleteCount:n,data:a}}return{id:p,type:"delta",deltas:R}}e.decodeSemanticTokensDto=L}),define(ve[112],we([0,1,16,100]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class k{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,P){y=(0,i.toUint32)(y);const L=this.values,D=this.prefixSum,c=P.length;return c===0?!1:(this.values=new Uint32Array(L.length+c),this.values.set(L.subarray(0,y),0),this.values.set(L.subarray(y),y+c),this.values.set(P,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(y,P){return y=(0,i.toUint32)(y),P=(0,i.toUint32)(P),this.values[y]===P?!1:(this.values[y]=P,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,P){y=(0,i.toUint32)(y),P=(0,i.toUint32)(P);const L=this.values,D=this.prefixSum;if(y>=L.length)return!1;const c=L.length-y;return P>=c&&(P=c),P===0?!1:(this.values=new Uint32Array(L.length-P),this.values.set(L.subarray(0,y),0),this.values.set(L.subarray(y+P),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(y){return y<0?0:(y=(0,i.toUint32)(y),this._getPrefixSum(y))}_getPrefixSum(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),y>=this.values.length&&(y=this.values.length-1);for(let L=P;L<=y;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let P=0,L=this.values.length-1,D=0,c=0,b=0;for(;P<=L;)if(D=P+(L-P)/2|0,c=this.prefixSum[D],b=c-this.values[D],y<b)L=D-1;else if(y>=c)P=D+1;else break;return new T(D,y-b)}}e.PrefixSumComputer=k;class C{constructor(y){this._values=y,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(y){return this._ensureValid(),y===0?0:this._prefixSum[y-1]}getIndexOf(y){this._ensureValid();const P=this._indexBySum[y],L=P>0?this._prefixSum[P-1]:0;return new T(P,y-L)}removeValues(y,P){this._values.splice(y,P),this._invalidate(y)}insertValues(y,P){this._values=(0,m.arrayInsert)(this._values,y,P),this._invalidate(y)}_invalidate(y){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,y-1)}_ensureValid(){if(!this._isValid){for(let y=this._validEndIndex+1,P=this._values.length;y<P;y++){const L=this._values[y],D=y>0?this._prefixSum[y-1]:0;this._prefixSum[y]=D+L;for(let c=0;c<L;c++)this._indexBySum[D+c]=y}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(y,P){this._values[y]!==P&&(this._values[y]=P,this._invalidate(y))}}e.ConstantTimePrefixSumComputer=C;class T{constructor(y,P){this.index=y,this.remainder=P,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=P}}e.PrefixSumIndexOfResult=T}),define(ve[150],we([0,1,9,49,112]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(I,y,P,L){this._uri=I,this._lines=y,this._eol=P,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const y=I.changes;for(const P of y)this._acceptDeleteRange(P.range),this._acceptInsertText(new i.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,y=this._lines.length,P=new Uint32Array(y);for(let L=0;L<y;L++)P[L]=this._lines[L].length+I;this._lineStarts=new k.PrefixSumComputer(P)}}_setLineText(I,y){this._lines[I]=y,this._lineStarts&&this._lineStarts.setValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,y){if(y.length===0)return;const P=(0,m.splitLines)(y);if(P.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+P[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}P[P.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+P[0]);const L=new Uint32Array(P.length-1);for(let D=1;D<P.length;D++)this._lines.splice(I.lineNumber+D-1,0,P[D]),L[D-1]=P[D].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,L)}}e.MirrorTextModel=C}),define(ve[151],we([19,20]),function(X,e){return X.create("vs/base/common/date",e)}),define(ve[152],we([0,1,151]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,k=i*60,C=k*24,T=C*7,I=C*30,y=C*365;function P(D,c){typeof D!="number"&&(D=D.getTime());const b=Math.round((new Date().getTime()-D)/1e3);if(b<-30)return(0,m.localize)(0,null,P(new Date().getTime()+b*1e3,!1));if(b<30)return(0,m.localize)(1,null);let p;return b<i?(p=b,c?p===1?(0,m.localize)(2,null,p):(0,m.localize)(3,null,p):p===1?(0,m.localize)(4,null,p):(0,m.localize)(5,null,p)):b<k?(p=Math.floor(b/i),c?p===1?(0,m.localize)(6,null,p):(0,m.localize)(7,null,p):p===1?(0,m.localize)(8,null,p):(0,m.localize)(9,null,p)):b<C?(p=Math.floor(b/k),c?p===1?(0,m.localize)(10,null,p):(0,m.localize)(11,null,p):p===1?(0,m.localize)(12,null,p):(0,m.localize)(13,null,p)):b<T?(p=Math.floor(b/C),c?p===1?(0,m.localize)(14,null,p):(0,m.localize)(15,null,p):p===1?(0,m.localize)(16,null,p):(0,m.localize)(17,null,p)):b<I?(p=Math.floor(b/T),c?p===1?(0,m.localize)(18,null,p):(0,m.localize)(19,null,p):p===1?(0,m.localize)(20,null,p):(0,m.localize)(21,null,p)):b<y?(p=Math.floor(b/I),c?p===1?(0,m.localize)(22,null,p):(0,m.localize)(23,null,p):p===1?(0,m.localize)(24,null,p):(0,m.localize)(25,null,p)):(p=Math.floor(b/y),c?p===1?(0,m.localize)(26,null,p):(0,m.localize)(27,null,p):p===1?(0,m.localize)(28,null,p):(0,m.localize)(29,null,p))}e.fromNow=P;function L(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ve[153],we([19,20]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ve[50],we([0,1,16,13,153]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(P,L){return L&&(P.stack||P.stacktrace)?k.localize(0,null,I(P),T(P.stack)||T(P.stacktrace)):I(P)}function T(P){return Array.isArray(P)?P.join(`
`):P}function I(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?k.localize(1,null,P.message):P.message||k.localize(2,null)}function y(P=null,L=!1){if(!P)return k.localize(3,null);if(Array.isArray(P)){const D=m.coalesce(P),c=y(D[0],L);return D.length>1?k.localize(4,null,c,D.length):c}if(i.isString(P))return P;if(P.detail){const D=P.detail;if(D.error)return C(D.error,L);if(D.exception)return C(D.exception,L)}return P.stack?C(P,L):P.message?P.message:k.localize(5,null)}e.toErrorMessage=y}),define(ve[154],we([19,20]),function(X,e){return X.create("vs/base/node/processes",e)}),define(ve[113],we([0,1,37,28,10,25,8,12,40,96,13,143,29,154]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function p(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(a,E){if(I.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};E&&(r.cwd=E);const t=m.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],r);return new Promise(o=>{t.once("error",h=>{o({success:!1,error:h})}),t.once("exit",(h,u)=>{o(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?p(r.status):1})}else if(I.isLinux||I.isMacintosh)try{const r=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(t=>{m.execFile(r,[a.pid.toString()],{encoding:"utf8",shell:!0},(o,h,u)=>{t(o?{success:!1,error:o}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function w(a){!a||(delete a.DEBUG,I.isMacintosh&&delete a.DYLD_LIBRARY_PATH,I.isLinux&&delete a.LD_PRELOAD)}e.removeDangerousEnvVariables=w;function R(a=y.env){return a.comspec||"cmd.exe"}e.getWindowsShell=R;class S{constructor(E,r,t,o){if(r!==void 0&&t!==void 0&&o!==void 0)this.cmd=E,this.args=r,this.shell=t,this.options=o;else{const h=E;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(y.env).forEach(u=>{h[u]=y.env[u]}),Object.keys(this.options.env).forEach(u=>{h[u]=this.options.env[u]}),this.options.env=h}}getSanitizedCommand(){let E=this.cmd.toLowerCase();const r=E.lastIndexOf(T.sep);return r!==-1&&(E=E.substring(r+1)),S.WellKnowCommands[E]?E:"other"}start(E){return I.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(y.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(r=>{let t,o;const h=new Promise((u,d)=>{t=u,o=d});if(r){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=m.exec(u,this.options,(d,f,l)=>{this.childProcess=null;const _=d;_&&_.killed?o({killed:this.terminateRequested,stdout:f.toString(),stderr:l.toString()}):this.handleExec(t,E,d,f,l)})}else{let u=null;const d=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,t,E,o);const l={terminated:this.terminateRequested};L.isNumber(f)&&(l.cmdCode=f),t(l)};if(this.shell&&I.isWindows){const f=C.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let l=!1,_=!1;const A=[];let N=this.ensureQuotes(this.cmd);A.push(N.value),l=N.quoted,this.args&&this.args.forEach(F=>{N=this.ensureQuotes(F),A.push(N.value),_=_&&N.quoted});const x=["/s","/c"];l?_?x.push('"'+A.join(" ")+'"'):A.length>1?x.push('"'+A[0]+'" '+A.slice(1).join(" ")):x.push('"'+A[0]+'"'):x.push(A.join(" ")),u=m.spawn(R(),x,f)}else this.cmd&&(u=m.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(L.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",f=>{this.childProcess=null,o({terminated:this.terminateRequested,error:f})}),u.pid&&(this.childProcess.on("close",d),this.handleSpawn(u,t,E,o,!0)))}return h})}handleClose(E,r,t,o){}ensureQuotes(E){return S.regexp.test(E)?{value:'"'+E+'"',quoted:!0}:{value:E,quoted:E.length>0&&E[0]==='"'&&E[E.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(E=>E.pid,E=>-1):new Promise(E=>{this.pidResolve=E})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(E=>(this.terminateRequested=!0,v(E,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),E=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(E=>{if(!this.shell||!I.isWindows)return E(!1);const r=m.spawn(R(),["/s","/c"]);r.on("error",t=>E(!0)),r.on("exit",t=>E(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class s extends S{constructor(E,r,t,o){super(E,r,t,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(E,r,t,o,h){[o,h].forEach((u,d)=>{const f=new D.LineDecoder;f.write(u).forEach(A=>{r({line:A,source:d===0?0:1})});const _=f.end();_&&r({line:_,source:d===0?0:1})}),E({terminated:this.terminateRequested,error:t})}handleSpawn(E,r,t,o,h){const u=new D.LineDecoder,d=new D.LineDecoder;E.stdout.on("data",f=>{u.write(f).forEach(_=>t({line:_,source:0}))}),E.stderr.on("data",f=>{d.write(f).forEach(_=>t({line:_,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=d}handleClose(E,r,t,o){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&t({line:h,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&t({line:u,source:1})}}e.LineProcess=s;function n(a){let E=[],r=!1;const t=function(o){if(r){E.push(o);return}(!a.send(o,u=>{if(u&&console.error(u),r=!1,E.length>0){const d=E.slice(0);E=[],d.forEach(f=>t(f))}})||I.isWindows)&&(r=!0)};return{send:t}}e.createQueuedSender=n;var g;(function(a){async function E(r,t,o){if(T.isAbsolute(r))return r;if(t===void 0&&(t=y.cwd()),T.dirname(r)!=="."||(o===void 0&&L.isString(y.env.PATH)&&(o=y.env.PATH.split(T.delimiter)),o===void 0||o.length===0))return T.join(t,r);async function u(d){if(await c.Promises.exists(d)){let f;try{f=await c.Promises.stat(d)}catch(l){l.message.startsWith("EACCES")&&(f=await c.Promises.lstat(d))}return f?!f.isDirectory():!1}return!1}for(let d of o){let f;if(T.isAbsolute(d)?f=T.join(d,r):f=T.join(t,d,r),await u(f))return f;let l=f+".com";if(await u(l)||(l=f+".exe",await u(l)))return l}return T.join(t,r)}a.findExecutable=E})(g=e.win32||(e.win32={}))}),define(ve[155],we([19,20]),function(X,e){return X.create("vs/editor/common/config/editorOptions",e)}),define(ve[114],we([0,1,155,12,110,16,25]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=y;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class L{constructor(ie,Se,ne,Ce){this.id=ie,this.name=Se,this.defaultValue=ne,this.schema=Ce}applyUpdate(ie,Se){return c(ie,Se)}compute(ie,Se,ne){return ne}}class D{constructor(ie,Se){this.newValue=ie,this.didChange=Se}}e.ApplyUpdateResult=D;function c(ee,ie){if(typeof ee!="object"||typeof ie!="object"||!ee||!ie)return new D(ie,ee!==ie);if(Array.isArray(ee)||Array.isArray(ie)){const ne=Array.isArray(ee)&&Array.isArray(ie)&&C.equals(ee,ie);return new D(ie,ne)}let Se=!1;for(const ne in ie)if(ie.hasOwnProperty(ne)){const Ce=c(ee[ne],ie[ne]);Ce.didChange&&(ee[ne]=Ce.newValue,Se=!0)}return new D(ee,Se)}class b{constructor(ie){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0}applyUpdate(ie,Se){return c(ie,Se)}validate(ie){return this.defaultValue}}class p{constructor(ie,Se,ne,Ce){this.id=ie,this.name=Se,this.defaultValue=ne,this.schema=Ce}applyUpdate(ie,Se){return c(ie,Se)}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,Se,ne){return ne}}function v(ee,ie){return typeof ee=="undefined"?ie:ee==="false"?!1:Boolean(ee)}e.boolean=v;class w extends p{constructor(ie,Se,ne,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="boolean",Ce.default=ne);super(ie,Se,ne,Ce)}validate(ie){return v(ie,this.defaultValue)}}function R(ee,ie,Se,ne){if(typeof ee=="undefined")return ie;let Ce=parseInt(ee,10);return isNaN(Ce)?ie:(Ce=Math.max(Se,Ce),Ce=Math.min(ne,Ce),Ce|0)}e.clampedInt=R;class S extends p{constructor(ie,Se,ne,Ce,Fe,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="integer",Ge.default=ne,Ge.minimum=Ce,Ge.maximum=Fe);super(ie,Se,ne,Ge);this.minimum=Ce,this.maximum=Fe}static clampedInt(ie,Se,ne,Ce){return R(ie,Se,ne,Ce)}validate(ie){return S.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class s extends p{constructor(ie,Se,ne,Ce,Fe){typeof Fe!="undefined"&&(Fe.type="number",Fe.default=ne);super(ie,Se,ne,Fe);this.validationFn=Ce}static clamp(ie,Se,ne){return ie<Se?Se:ie>ne?ne:ie}static float(ie,Se){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return Se;const ne=parseFloat(ie);return isNaN(ne)?Se:ne}validate(ie){return this.validationFn(s.float(ie,this.defaultValue))}}class n extends p{static string(ie,Se){return typeof ie!="string"?Se:ie}constructor(ie,Se,ne,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="string",Ce.default=ne);super(ie,Se,ne,Ce)}validate(ie){return n.string(ie,this.defaultValue)}}function g(ee,ie,Se){return typeof ee!="string"||Se.indexOf(ee)===-1?ie:ee}e.stringSet=g;class a extends p{constructor(ie,Se,ne,Ce,Fe=void 0){typeof Fe!="undefined"&&(Fe.type="string",Fe.enum=Ce,Fe.default=ne);super(ie,Se,ne,Fe);this._allowedValues=Ce}validate(ie){return g(ie,this.defaultValue,this._allowedValues)}}class E extends L{constructor(ie,Se,ne,Ce,Fe,Ge,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.enum=Fe,ze.default=Ce);super(ie,Se,ne,ze);this._allowedValues=Fe,this._convert=Ge}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function r(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends L{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,Se,ne){return ne===0?ie.accessibilitySupport:ne}}class o extends L{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:m.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{insertSpace:v(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var h;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(h=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function f(ee){switch(ee){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function l(ee){switch(ee){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class _ extends b{constructor(){super(127)}compute(ie,Se,ne){const Ce=["monaco-editor"];return Se.get(33)&&Ce.push(Se.get(33)),ie.extraEditorClassName&&Ce.push(ie.extraEditorClassName),Se.get(65)==="default"?Ce.push("mouse-default"):Se.get(65)==="copy"&&Ce.push("mouse-copy"),Se.get(99)&&Ce.push("showUnused"),Se.get(125)&&Ce.push("showDeprecated"),Ce.join(" ")}}class A extends w{constructor(){super(32,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(ie,Se,ne){return ne&&ie.emptySelectionClipboard}}class N extends L{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ie.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:m.localize(16,null),included:i.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:m.localize(18,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{cursorMoveOnType:v(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ie.seedSearchStringFromSelection=="boolean"?ie.seedSearchStringFromSelection?"always":"never":g(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":g(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(Se.loop,this.defaultValue.loop)}}}class x extends L{constructor(){super(44,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?x.OFF:ie==="true"?x.ON:ie:Boolean(ie)?x.ON:x.OFF}}e.EditorFontLigatures=x,x.OFF='"liga" off, "calt" off',x.ON='"liga" on, "calt" on';class F extends b{constructor(){super(43)}compute(ie,Se,ne){return ie.fontInfo}}class O extends p{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(ie){const Se=s.float(ie,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(Se,6,100)}compute(ie,Se,ne){return ie.fontInfo.fontSize}}class z extends L{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(S.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class $ extends L{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...Se},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...Se},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:ne,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:ne,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:ne,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:ne,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:ne,description:m.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{multiple:g(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??g(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??g(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??g(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??g(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??g(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class M extends L{constructor(){const ie={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:m.localize(41,null)},"editor.hover.above":{type:"boolean",default:ie.above,description:m.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:v(Se.enabled,this.defaultValue.enabled),delay:S.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:v(Se.sticky,this.defaultValue.sticky),above:v(Se.above,this.defaultValue.above)}}}var B;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class W extends b{constructor(){super(130)}compute(ie,Se,ne){return W.computeLayout(Se,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const Se=ie.height/ie.lineHeight,ne=ie.scrollBeyondLastLine?Se-1:0,Ce=(ie.viewLineCount+ne)/(ie.pixelRatio*ie.height),Fe=Math.floor(ie.viewLineCount/Ce);return{typicalViewportLineCount:Se,extraLinesBeyondLastLine:ne,desiredRatio:Ce,minimapLineCount:Fe}}static _computeMinimapLayout(ie,Se){const ne=ie.outerWidth,Ce=ie.outerHeight,Fe=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Fe*Ce),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ce};const Ge=Se.stableMinimapLayoutInput,ze=Ge&&ie.outerHeight===Ge.outerHeight&&ie.lineHeight===Ge.lineHeight&&ie.typicalHalfwidthCharacterWidth===Ge.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Ge.pixelRatio&&ie.scrollBeyondLastLine===Ge.scrollBeyondLastLine&&ie.minimap.enabled===Ge.minimap.enabled&&ie.minimap.side===Ge.minimap.side&&ie.minimap.size===Ge.minimap.size&&ie.minimap.showSlider===Ge.minimap.showSlider&&ie.minimap.renderCharacters===Ge.minimap.renderCharacters&&ie.minimap.maxColumn===Ge.minimap.maxColumn&&ie.minimap.scale===Ge.minimap.scale&&ie.verticalScrollbarWidth===Ge.verticalScrollbarWidth&&ie.isViewportWrapping===Ge.isViewportWrapping,ut=ie.lineHeight,Re=ie.typicalHalfwidthCharacterWidth,Te=ie.scrollBeyondLastLine,De=ie.minimap.renderCharacters;let se=Fe>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const fe=ie.minimap.maxColumn,be=ie.minimap.size,_e=ie.minimap.side,Ne=ie.verticalScrollbarWidth,Qe=ie.viewLineCount,$e=ie.remainingWidth,Xe=ie.isViewportWrapping,st=De?2:3;let ot=Math.floor(Fe*Ce);const he=ot/Fe;let ye=!1,de=!1,K=st*se,Ie=se/Fe,Me=1;if(be==="fill"||be==="fit"){const{typicalViewportLineCount:mt,extraLinesBeyondLastLine:wt,desiredRatio:_t,minimapLineCount:Mt}=W.computeContainedMinimapLineCount({viewLineCount:Qe,scrollBeyondLastLine:Te,height:Ce,lineHeight:ut,pixelRatio:Fe});if(Qe/Mt>1)ye=!0,de=!0,se=1,K=1,Ie=se/Fe;else{let Pt=!1,Rt=se+1;if(be==="fit"){const yt=Math.ceil((Qe+wt)*K);Xe&&ze&&$e<=Se.stableFitRemainingWidth?(Pt=!0,Rt=Se.stableFitMaxMinimapScale):Pt=yt>ot}if(be==="fill"||Pt){ye=!0;const yt=se;K=Math.min(ut*Fe,Math.max(1,Math.floor(1/_t))),Xe&&ze&&$e<=Se.stableFitRemainingWidth&&(Rt=Se.stableFitMaxMinimapScale),se=Math.min(Rt,Math.max(1,Math.floor(K/st))),se>yt&&(Me=Math.min(2,se/yt)),Ie=se/Fe/Me,ot=Math.ceil(Math.max(mt,Qe+wt)*K),Xe?(Se.stableMinimapLayoutInput=ie,Se.stableFitRemainingWidth=$e,Se.stableFitMaxMinimapScale=se):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const Ze=Math.floor(fe*Ie),qe=Math.min(Ze,Math.max(0,Math.floor(($e-Ne-2)*Ie/(Re+Ie)))+e.MINIMAP_GUTTER_WIDTH);let ht=Math.floor(Fe*qe);const Et=ht/Fe;ht=Math.floor(ht*Me);const Dt=De?1:2,bt=_e==="left"?0:ne-qe-Ne;return{renderMinimap:Dt,minimapLeft:bt,minimapWidth:qe,minimapHeightIsEditorHeight:ye,minimapIsSampling:de,minimapScale:se,minimapLineHeight:K,minimapCanvasInnerWidth:ht,minimapCanvasInnerHeight:ot,minimapCanvasOuterWidth:Et,minimapCanvasOuterHeight:he}}static computeLayout(ie,Se){const ne=Se.outerWidth|0,Ce=Se.outerHeight|0,Fe=Se.lineHeight|0,Ge=Se.lineNumbersDigitCount|0,ze=Se.typicalHalfwidthCharacterWidth,ut=Se.maxDigitWidth,Re=Se.pixelRatio,Te=Se.viewLineCount,De=ie.get(122),se=De==="inherit"?ie.get(121):De,fe=se==="inherit"?ie.get(117):se,be=ie.get(120),_e=ie.get(2),Ne=Se.isDominatedByLongLines,Qe=ie.get(49),$e=ie.get(59).renderType!==0,Xe=ie.get(60),st=ie.get(93),ot=ie.get(64),he=ie.get(91),ye=he.verticalScrollbarSize,de=he.verticalHasArrows,K=he.arrowSize,Ie=he.horizontalScrollbarSize,Me=ie.get(57),Ze=ie.get(37);let qe;if(typeof Me=="string"&&/^\d+(\.\d+)?ch$/.test(Me)){const St=parseFloat(Me.substr(0,Me.length-2));qe=S.clampedInt(St*ze,0,0,1e3)}else qe=S.clampedInt(Me,0,0,1e3);Ze&&(qe+=16);let ht=0;if($e){const St=Math.max(Ge,Xe);ht=Math.round(St*ut)}let Et=0;Qe&&(Et=Fe);let Dt=0,bt=Dt+Et,mt=bt+ht,wt=mt+qe;const _t=ne-Et-ht-qe;let Mt=!1,It=!1,Pt=-1;_e!==2&&(se==="inherit"&&Ne?(Mt=!0,It=!0):fe==="on"||fe==="bounded"?It=!0:fe==="wordWrapColumn"&&(Pt=be));const Rt=W._computeMinimapLayout({outerWidth:ne,outerHeight:Ce,lineHeight:Fe,typicalHalfwidthCharacterWidth:ze,pixelRatio:Re,scrollBeyondLastLine:st,minimap:ot,verticalScrollbarWidth:ye,viewLineCount:Te,remainingWidth:_t,isViewportWrapping:It},Se.memory||new P);Rt.renderMinimap!==0&&Rt.minimapLeft===0&&(Dt+=Rt.minimapWidth,bt+=Rt.minimapWidth,mt+=Rt.minimapWidth,wt+=Rt.minimapWidth);const yt=_t-Rt.minimapWidth,Ht=Math.max(1,Math.floor((yt-ye-2)/ze)),Ot=de?K:0;return It&&(Pt=Math.max(1,Ht),fe==="bounded"&&(Pt=Math.min(Pt,be))),{width:ne,height:Ce,glyphMarginLeft:Dt,glyphMarginWidth:Et,lineNumbersLeft:bt,lineNumbersWidth:ht,decorationsLeft:mt,decorationsWidth:qe,contentLeft:wt,contentWidth:yt,minimap:Rt,viewportColumn:Ht,isWordWrapMinified:Mt,isViewportWrapping:It,wrappingColumn:Pt,verticalScrollbarWidth:ye,horizontalScrollbarHeight:Ie,overviewRuler:{top:Ot,width:ye,height:Ce-2*Ot,right:0}}}}e.EditorLayoutInfoComputer=W;class U extends L{constructor(){const ie={enabled:!0};super(56,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:m.localize(43,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:v(ie.enabled,this.defaultValue.enabled)}}}class j extends L{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:m.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:m.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,markdownDescription:m.localize(46,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:v(Se.enabled,this.defaultValue.enabled),fontSize:S.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class Z extends s{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>s.clamp(ie,0,150),{markdownDescription:m.localize(47,null)})}compute(ie,Se,ne){return ie.fontInfo.lineHeight}}class ce extends L{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:m.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(49,null),m.localize(50,null),m.localize(51,null)],default:ie.size,description:m.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:m.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:m.localize(54,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:m.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:m.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:v(Se.enabled,this.defaultValue.enabled),size:g(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(Se.side,this.defaultValue.side,["right","left"]),showSlider:g(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(Se.renderCharacters,this.defaultValue.renderCharacters),scale:S.clampedInt(Se.scale,1,1,3),maxColumn:S.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Q(ee){return ee==="ctrlCmd"?i.isMacintosh?"metaKey":"ctrlKey":"altKey"}class V extends L{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(59,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{top:S.clampedInt(Se.top,0,0,1e3),bottom:S.clampedInt(Se.bottom,0,0,1e3)}}}class te extends L{constructor(){const ie={enabled:!0,cycle:!1};super(75,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:m.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:m.localize(61,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:v(Se.enabled,this.defaultValue.enabled),cycle:v(Se.cycle,this.defaultValue.cycle)}}}class me extends b{constructor(){super(128)}compute(ie,Se,ne){return ie.pixelRatio}}class ge extends L{constructor(){const ie={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:m.localize(62,null)},comments:{type:"boolean",default:ie.comments,description:m.localize(63,null)},other:{type:"boolean",default:ie.other,description:m.localize(64,null)}}}],default:ie,description:m.localize(65,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const Se=ie,ne={other:v(Se.other,this.defaultValue.other),comments:v(Se.comments,this.defaultValue.comments),strings:v(Se.strings,this.defaultValue.strings)};return ne.other&&ne.comments&&ne.strings?!0:!ne.other&&!ne.comments&&!ne.strings?!1:ne}return this.defaultValue}}var ke;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Be extends L{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null),m.localize(69,null)],default:"on",description:m.localize(70,null)})}validate(ie){let Se=this.defaultValue.renderType,ne=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(Se=4,ne=ie):ie==="interval"?Se=3:ie==="relative"?Se=2:ie==="on"?Se=1:Se=0),{renderType:Se,renderFn:ne}}}function xe(ee){const ie=ee.get(86);return ie==="editable"?ee.get(80):ie!=="on"}e.filterValidationDecorations=xe;class q extends L{constructor(){const ie=[],Se={type:"number",description:m.localize(71,null)};super(90,"rulers",ie,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:m.localize(72,null),format:"color-hex"}}}]},default:ie,description:m.localize(73,null)})}validate(ie){if(Array.isArray(ie)){const Se=[];for(let ne of ie)if(typeof ne=="number")Se.push({column:S.clampedInt(ne,0,0,1e4),color:null});else if(ne&&typeof ne=="object"){const Ce=ne;Se.push({column:S.clampedInt(Ce.column,0,0,1e4),color:Ce.color})}return Se.sort((ne,Ce)=>ne.column-Ce.column),Se}return this.defaultValue}}function Y(ee,ie){if(typeof ee!="string")return ie;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class re extends L{constructor(){const ie={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ie,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(74,null),m.localize(75,null),m.localize(76,null)],default:"auto",description:m.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(78,null),m.localize(79,null),m.localize(80,null)],default:"auto",description:m.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ie.verticalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ie.horizontalScrollbarSize,description:m.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ie.scrollByPage,description:m.localize(84,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie,ne=S.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ce=S.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:S.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Y(Se.vertical,this.defaultValue.vertical),horizontal:Y(Se.horizontal,this.defaultValue.horizontal),useShadows:v(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ne,horizontalSliderSize:S.clampedInt(Se.horizontalSliderSize,ne,0,1e3),verticalScrollbarSize:Ce,verticalSliderSize:S.clampedInt(Se.verticalSliderSize,Ce,0,1e3),scrollByPage:v(Se.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ue extends L{constructor(){const ie={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(112,"unicodeHighlight",ie,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.nonBasicASCII,description:m.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ie.invisibleCharacters,description:m.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ie.ambiguousCharacters,description:m.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.includeComments,description:m.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.includeStrings,description:m.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ie.allowedCharacters,description:m.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ie.allowedLocales,description:m.localize(91,null)}})}applyUpdate(ie,Se){let ne=!1;Se.allowedCharacters&&(T.equals(ie.allowedCharacters,Se.allowedCharacters)||(ie={...ie,allowedCharacters:Se.allowedCharacters},ne=!0)),Se.allowedLocales&&(T.equals(ie.allowedLocales,Se.allowedLocales)||(ie={...ie,allowedLocales:Se.allowedLocales},ne=!0));const Ce=super.applyUpdate(ie,Se);return ne?new D(Ce.newValue,!0):Ce}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{nonBasicASCII:Oe(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Oe(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Oe(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ie.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ie.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ie,Se){if(typeof ie!="object"||!ie)return Se;const ne={};for(const[Ce,Fe]of Object.entries(ie))Fe===!0&&(ne[Ce]=!0);return ne}}class J extends L{constructor(){const ie={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:m.localize(92,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:v(Se.enabled,this.defaultValue.enabled),mode:g(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ae extends L{constructor(){const ie={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ie,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ie.enabled,description:m.localize(93,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:v(ie.enabled,this.defaultValue.enabled)}}}class Ee extends L{constructor(){const ie={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ie,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(94,null),m.localize(95,null),m.localize(96,null)],default:ie.bracketPairs,description:m.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(98,null),m.localize(99,null),m.localize(100,null)],default:ie.bracketPairsHorizontal,description:m.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ie.highlightActiveBracketPair,description:m.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:ie.indentation,description:m.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ie.highlightActiveIndentation,description:m.localize(104,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{bracketPairs:Oe(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Oe(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:v(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Oe(ee,ie,Se){const ne=Se.indexOf(ee);return ne===-1?ie:Se[ne]}class Ve extends L{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(105,null),m.localize(106,null)],default:ie.insertMode,description:m.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:m.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:m.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:m.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:m.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:m.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:m.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:m.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:m.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(146,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{insertMode:g(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(Se.showIcons,this.defaultValue.showIcons),showStatusBar:v(Se.showStatusBar,this.defaultValue.showStatusBar),preview:v(Se.preview,this.defaultValue.preview),previewMode:g(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(Se.showMethods,this.defaultValue.showMethods),showFunctions:v(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:v(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(Se.showDeprecated,this.defaultValue.showDeprecated),showFields:v(Se.showFields,this.defaultValue.showFields),showVariables:v(Se.showVariables,this.defaultValue.showVariables),showClasses:v(Se.showClasses,this.defaultValue.showClasses),showStructs:v(Se.showStructs,this.defaultValue.showStructs),showInterfaces:v(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:v(Se.showModules,this.defaultValue.showModules),showProperties:v(Se.showProperties,this.defaultValue.showProperties),showEvents:v(Se.showEvents,this.defaultValue.showEvents),showOperators:v(Se.showOperators,this.defaultValue.showOperators),showUnits:v(Se.showUnits,this.defaultValue.showUnits),showValues:v(Se.showValues,this.defaultValue.showValues),showConstants:v(Se.showConstants,this.defaultValue.showConstants),showEnums:v(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:v(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(Se.showKeywords,this.defaultValue.showKeywords),showWords:v(Se.showWords,this.defaultValue.showWords),showColors:v(Se.showColors,this.defaultValue.showColors),showFiles:v(Se.showFiles,this.defaultValue.showFiles),showReferences:v(Se.showReferences,this.defaultValue.showReferences),showFolders:v(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:v(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(Se.showSnippets,this.defaultValue.showSnippets),showUsers:v(Se.showUsers,this.defaultValue.showUsers),showIssues:v(Se.showIssues,this.defaultValue.showIssues)}}}class Ke extends L{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(147,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Je extends b{constructor(){super(129)}compute(ie,Se,ne){return Se.get(80)?!0:ie.tabFocusMode}}var it;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(it=e.WrappingIndent||(e.WrappingIndent={}));function at(ee){switch(ee){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class et extends b{constructor(){super(131)}compute(ie,Se,ne){const Ce=Se.get(130);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:Ce.isWordWrapMinified,isViewportWrapping:Ce.isViewportWrapping,wrappingColumn:Ce.wrappingColumn}}}const nt="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",vt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:i.isMacintosh?ct:i.isLinux?vt:nt,fontWeight:"normal",fontSize:i.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function We(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var At;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.autoClosingBrackets=5]="autoClosingBrackets",ee[ee.autoClosingDelete=6]="autoClosingDelete",ee[ee.autoClosingOvertype=7]="autoClosingOvertype",ee[ee.autoClosingQuotes=8]="autoClosingQuotes",ee[ee.autoIndent=9]="autoIndent",ee[ee.automaticLayout=10]="automaticLayout",ee[ee.autoSurround=11]="autoSurround",ee[ee.bracketPairColorization=12]="bracketPairColorization",ee[ee.guides=13]="guides",ee[ee.codeLens=14]="codeLens",ee[ee.codeLensFontFamily=15]="codeLensFontFamily",ee[ee.codeLensFontSize=16]="codeLensFontSize",ee[ee.colorDecorators=17]="colorDecorators",ee[ee.columnSelection=18]="columnSelection",ee[ee.comments=19]="comments",ee[ee.contextmenu=20]="contextmenu",ee[ee.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=22]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=24]="cursorStyle",ee[ee.cursorSurroundingLines=25]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=27]="cursorWidth",ee[ee.disableLayerHinting=28]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ee[ee.domReadOnly=30]="domReadOnly",ee[ee.dragAndDrop=31]="dragAndDrop",ee[ee.emptySelectionClipboard=32]="emptySelectionClipboard",ee[ee.extraEditorClassName=33]="extraEditorClassName",ee[ee.fastScrollSensitivity=34]="fastScrollSensitivity",ee[ee.find=35]="find",ee[ee.fixedOverflowWidgets=36]="fixedOverflowWidgets",ee[ee.folding=37]="folding",ee[ee.foldingStrategy=38]="foldingStrategy",ee[ee.foldingHighlight=39]="foldingHighlight",ee[ee.foldingImportsByDefault=40]="foldingImportsByDefault",ee[ee.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=42]="fontFamily",ee[ee.fontInfo=43]="fontInfo",ee[ee.fontLigatures=44]="fontLigatures",ee[ee.fontSize=45]="fontSize",ee[ee.fontWeight=46]="fontWeight",ee[ee.formatOnPaste=47]="formatOnPaste",ee[ee.formatOnType=48]="formatOnType",ee[ee.glyphMargin=49]="glyphMargin",ee[ee.gotoLocation=50]="gotoLocation",ee[ee.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",ee[ee.hover=52]="hover",ee[ee.inDiffEditor=53]="inDiffEditor",ee[ee.inlineSuggest=54]="inlineSuggest",ee[ee.letterSpacing=55]="letterSpacing",ee[ee.lightbulb=56]="lightbulb",ee[ee.lineDecorationsWidth=57]="lineDecorationsWidth",ee[ee.lineHeight=58]="lineHeight",ee[ee.lineNumbers=59]="lineNumbers",ee[ee.lineNumbersMinChars=60]="lineNumbersMinChars",ee[ee.linkedEditing=61]="linkedEditing",ee[ee.links=62]="links",ee[ee.matchBrackets=63]="matchBrackets",ee[ee.minimap=64]="minimap",ee[ee.mouseStyle=65]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=67]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=69]="multiCursorModifier",ee[ee.multiCursorPaste=70]="multiCursorPaste",ee[ee.occurrencesHighlight=71]="occurrencesHighlight",ee[ee.overviewRulerBorder=72]="overviewRulerBorder",ee[ee.overviewRulerLanes=73]="overviewRulerLanes",ee[ee.padding=74]="padding",ee[ee.parameterHints=75]="parameterHints",ee[ee.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=78]="quickSuggestions",ee[ee.quickSuggestionsDelay=79]="quickSuggestionsDelay",ee[ee.readOnly=80]="readOnly",ee[ee.renameOnType=81]="renameOnType",ee[ee.renderControlCharacters=82]="renderControlCharacters",ee[ee.renderFinalNewline=83]="renderFinalNewline",ee[ee.renderLineHighlight=84]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=86]="renderValidationDecorations",ee[ee.renderWhitespace=87]="renderWhitespace",ee[ee.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",ee[ee.roundedSelection=89]="roundedSelection",ee[ee.rulers=90]="rulers",ee[ee.scrollbar=91]="scrollbar",ee[ee.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=93]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=94]="scrollPredominantAxis",ee[ee.selectionClipboard=95]="selectionClipboard",ee[ee.selectionHighlight=96]="selectionHighlight",ee[ee.selectOnLineNumbers=97]="selectOnLineNumbers",ee[ee.showFoldingControls=98]="showFoldingControls",ee[ee.showUnused=99]="showUnused",ee[ee.snippetSuggestions=100]="snippetSuggestions",ee[ee.smartSelect=101]="smartSelect",ee[ee.smoothScrolling=102]="smoothScrolling",ee[ee.stickyTabStops=103]="stickyTabStops",ee[ee.stopRenderingLineAfter=104]="stopRenderingLineAfter",ee[ee.suggest=105]="suggest",ee[ee.suggestFontSize=106]="suggestFontSize",ee[ee.suggestLineHeight=107]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",ee[ee.suggestSelection=109]="suggestSelection",ee[ee.tabCompletion=110]="tabCompletion",ee[ee.tabIndex=111]="tabIndex",ee[ee.unicodeHighlighting=112]="unicodeHighlighting",ee[ee.unusualLineTerminators=113]="unusualLineTerminators",ee[ee.useShadowDOM=114]="useShadowDOM",ee[ee.useTabStops=115]="useTabStops",ee[ee.wordSeparators=116]="wordSeparators",ee[ee.wordWrap=117]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=120]="wordWrapColumn",ee[ee.wordWrapOverride1=121]="wordWrapOverride1",ee[ee.wordWrapOverride2=122]="wordWrapOverride2",ee[ee.wrappingIndent=123]="wrappingIndent",ee[ee.wrappingStrategy=124]="wrappingStrategy",ee[ee.showDeprecated=125]="showDeprecated",ee[ee.inlayHints=126]="inlayHints",ee[ee.editorClassName=127]="editorClassName",ee[ee.pixelRatio=128]="pixelRatio",ee[ee.tabFocusMode=129]="tabFocusMode",ee[ee.layoutInfo=130]="layoutInfo",ee[ee.wrappingInfo=131]="wrappingInfo"})(At=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:We(new w(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(148,null)})),acceptSuggestionOnEnter:We(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(149,null),""],markdownDescription:m.localize(150,null)})),accessibilitySupport:We(new t),accessibilityPageSize:We(new S(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(151,null)})),ariaLabel:We(new n(4,"ariaLabel",m.localize(152,null))),autoClosingBrackets:We(new a(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(153,null),m.localize(154,null),""],description:m.localize(155,null)})),autoClosingDelete:We(new a(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(156,null),""],description:m.localize(157,null)})),autoClosingOvertype:We(new a(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(158,null),""],description:m.localize(159,null)})),autoClosingQuotes:We(new a(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(160,null),m.localize(161,null),""],description:m.localize(162,null)})),autoIndent:We(new E(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[m.localize(163,null),m.localize(164,null),m.localize(165,null),m.localize(166,null),m.localize(167,null)],description:m.localize(168,null)})),automaticLayout:We(new w(10,"automaticLayout",!1)),autoSurround:We(new a(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(169,null),m.localize(170,null),m.localize(171,null),""],description:m.localize(172,null)})),bracketPairColorization:We(new ae),bracketPairGuides:We(new Ee),stickyTabStops:We(new w(103,"stickyTabStops",!1,{description:m.localize(173,null)})),codeLens:We(new w(14,"codeLens",!0,{description:m.localize(174,null)})),codeLensFontFamily:We(new n(15,"codeLensFontFamily","",{description:m.localize(175,null)})),codeLensFontSize:We(new S(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(176,null)})),colorDecorators:We(new w(17,"colorDecorators",!0,{description:m.localize(177,null)})),columnSelection:We(new w(18,"columnSelection",!1,{description:m.localize(178,null)})),comments:We(new o),contextmenu:We(new w(20,"contextmenu",!0)),copyWithSyntaxHighlighting:We(new w(21,"copyWithSyntaxHighlighting",!0,{description:m.localize(179,null)})),cursorBlinking:We(new E(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:m.localize(180,null)})),cursorSmoothCaretAnimation:We(new w(23,"cursorSmoothCaretAnimation",!1,{description:m.localize(181,null)})),cursorStyle:We(new E(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],l,{description:m.localize(182,null)})),cursorSurroundingLines:We(new S(25,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(183,null)})),cursorSurroundingLinesStyle:We(new a(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(184,null),m.localize(185,null)],description:m.localize(186,null)})),cursorWidth:We(new S(27,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(187,null)})),disableLayerHinting:We(new w(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:We(new w(29,"disableMonospaceOptimizations",!1)),domReadOnly:We(new w(30,"domReadOnly",!1)),dragAndDrop:We(new w(31,"dragAndDrop",!0,{description:m.localize(188,null)})),emptySelectionClipboard:We(new A),extraEditorClassName:We(new n(33,"extraEditorClassName","")),fastScrollSensitivity:We(new s(34,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:m.localize(189,null)})),find:We(new N),fixedOverflowWidgets:We(new w(36,"fixedOverflowWidgets",!1)),folding:We(new w(37,"folding",!0,{description:m.localize(190,null)})),foldingStrategy:We(new a(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(191,null),m.localize(192,null)],description:m.localize(193,null)})),foldingHighlight:We(new w(39,"foldingHighlight",!0,{description:m.localize(194,null)})),foldingImportsByDefault:We(new w(40,"foldingImportsByDefault",!1,{description:m.localize(195,null)})),unfoldOnClickAfterEndOfLine:We(new w(41,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(196,null)})),fontFamily:We(new n(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(197,null)})),fontInfo:We(new F),fontLigatures2:We(new x),fontSize:We(new O),fontWeight:We(new z),formatOnPaste:We(new w(47,"formatOnPaste",!1,{description:m.localize(198,null)})),formatOnType:We(new w(48,"formatOnType",!1,{description:m.localize(199,null)})),glyphMargin:We(new w(49,"glyphMargin",!0,{description:m.localize(200,null)})),gotoLocation:We(new $),hideCursorInOverviewRuler:We(new w(51,"hideCursorInOverviewRuler",!1,{description:m.localize(201,null)})),hover:We(new M),inDiffEditor:We(new w(53,"inDiffEditor",!1)),letterSpacing:We(new s(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>s.clamp(ee,-5,20),{description:m.localize(202,null)})),lightbulb:We(new U),lineDecorationsWidth:We(new p(57,"lineDecorationsWidth",10)),lineHeight:We(new Z),lineNumbers:We(new Be),lineNumbersMinChars:We(new S(60,"lineNumbersMinChars",5,1,300)),linkedEditing:We(new w(61,"linkedEditing",!1,{description:m.localize(203,null)})),links:We(new w(62,"links",!0,{description:m.localize(204,null)})),matchBrackets:We(new a(63,"matchBrackets","always",["always","near","never"],{description:m.localize(205,null)})),minimap:We(new ce),mouseStyle:We(new a(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:We(new s(66,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:m.localize(206,null)})),mouseWheelZoom:We(new w(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(207,null)})),multiCursorMergeOverlapping:We(new w(68,"multiCursorMergeOverlapping",!0,{description:m.localize(208,null)})),multiCursorModifier:We(new E(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[m.localize(209,null),m.localize(210,null)],markdownDescription:m.localize(211,null)})),multiCursorPaste:We(new a(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(212,null),m.localize(213,null)],markdownDescription:m.localize(214,null)})),occurrencesHighlight:We(new w(71,"occurrencesHighlight",!0,{description:m.localize(215,null)})),overviewRulerBorder:We(new w(72,"overviewRulerBorder",!0,{description:m.localize(216,null)})),overviewRulerLanes:We(new S(73,"overviewRulerLanes",3,0,3)),padding:We(new V),parameterHints:We(new te),peekWidgetDefaultFocus:We(new a(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(217,null),m.localize(218,null)],description:m.localize(219,null)})),definitionLinkOpensInPeek:We(new w(77,"definitionLinkOpensInPeek",!1,{description:m.localize(220,null)})),quickSuggestions:We(new ge),quickSuggestionsDelay:We(new S(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(221,null)})),readOnly:We(new w(80,"readOnly",!1)),renameOnType:We(new w(81,"renameOnType",!1,{description:m.localize(222,null),markdownDeprecationMessage:m.localize(223,null)})),renderControlCharacters:We(new w(82,"renderControlCharacters",!0,{description:m.localize(224,null),restricted:!0})),renderFinalNewline:We(new w(83,"renderFinalNewline",!0,{description:m.localize(225,null)})),renderLineHighlight:We(new a(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(226,null)],description:m.localize(227,null)})),renderLineHighlightOnlyWhenFocus:We(new w(85,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(228,null)})),renderValidationDecorations:We(new a(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:We(new a(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(229,null),m.localize(230,null),m.localize(231,null),""],description:m.localize(232,null)})),revealHorizontalRightPadding:We(new S(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:We(new w(89,"roundedSelection",!0,{description:m.localize(233,null)})),rulers:We(new q),scrollbar:We(new re),scrollBeyondLastColumn:We(new S(92,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(234,null)})),scrollBeyondLastLine:We(new w(93,"scrollBeyondLastLine",!0,{description:m.localize(235,null)})),scrollPredominantAxis:We(new w(94,"scrollPredominantAxis",!0,{description:m.localize(236,null)})),selectionClipboard:We(new w(95,"selectionClipboard",!0,{description:m.localize(237,null),included:i.isLinux})),selectionHighlight:We(new w(96,"selectionHighlight",!0,{description:m.localize(238,null)})),selectOnLineNumbers:We(new w(97,"selectOnLineNumbers",!0)),showFoldingControls:We(new a(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(239,null),m.localize(240,null)],description:m.localize(241,null)})),showUnused:We(new w(99,"showUnused",!0,{description:m.localize(242,null)})),showDeprecated:We(new w(125,"showDeprecated",!0,{description:m.localize(243,null)})),inlayHints:We(new j),snippetSuggestions:We(new a(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null),m.localize(247,null)],description:m.localize(248,null)})),smartSelect:We(new Ke),smoothScrolling:We(new w(102,"smoothScrolling",!1,{description:m.localize(249,null)})),stopRenderingLineAfter:We(new S(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:We(new Ve),inlineSuggest:We(new J),suggestFontSize:We(new S(106,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(250,null)})),suggestLineHeight:We(new S(107,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(251,null)})),suggestOnTriggerCharacters:We(new w(108,"suggestOnTriggerCharacters",!0,{description:m.localize(252,null)})),suggestSelection:We(new a(109,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(253,null),m.localize(254,null),m.localize(255,null)],description:m.localize(256,null)})),tabCompletion:We(new a(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(257,null),m.localize(258,null),m.localize(259,null)],description:m.localize(260,null)})),tabIndex:We(new S(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:We(new ue),unusualLineTerminators:We(new a(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(261,null),m.localize(262,null),m.localize(263,null)],description:m.localize(264,null)})),useShadowDOM:We(new w(114,"useShadowDOM",!0)),useTabStops:We(new w(115,"useTabStops",!0,{description:m.localize(265,null)})),wordSeparators:We(new n(116,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:m.localize(266,null)})),wordWrap:We(new a(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(267,null),m.localize(268,null),m.localize(269,null),m.localize(270,null)],description:m.localize(271,null)})),wordWrapBreakAfterCharacters:We(new n(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:We(new n(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:We(new S(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(272,null)})),wordWrapOverride1:We(new a(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:We(new a(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:We(new E(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],at,{enumDescriptions:[m.localize(273,null),m.localize(274,null),m.localize(275,null),m.localize(276,null)],description:m.localize(277,null)})),wrappingStrategy:We(new a(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(278,null),m.localize(279,null)],description:m.localize(280,null)})),editorClassName:We(new _),pixelRatio:We(new me),tabFocusMode:We(new Je),layoutInfo:We(new W),wrappingInfo:We(new et)}}),define(ve[156],we([19,20]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[157],we([19,20]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[158],we([19,20]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[159],we([19,20]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ve[160],we([19,20]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ve[161],we([19,20]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(ve[162],we([19,20]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[163],we([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[164],we([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[165],we([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[166],we([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[167],we([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[168],we([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[169],we([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[170],we([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostDebugService",e)}),define(ve[171],we([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ve[172],we([19,20]),function(X,e){return X.create("vs/workbench/common/editor",e)}),define(ve[173],we([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[174],we([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ve[175],we([19,20]),function(X,e){return X.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[176],we([19,20]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[177],we([19,20]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[178],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var i;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(i=e.EditorResolution||(e.EditorResolution={}));var k;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[179],we([0,1,158]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const i=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function C(c){return c=c.trim(),c==="*"||i.test(c)}e.isValidVersionStr=C;function T(c){if(!C(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=c.match(i);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=T;function I(c){if(!c)return null;let b=c.majorBase,p=c.majorMustEqual,v=c.minorBase,w=c.minorMustEqual,R=c.patchBase,S=c.patchMustEqual;c.hasCaret&&(b===0||(w=!1),S=!1);let s=0;if(c.preRelease){const n=k.exec(c.preRelease);if(n){const[,g,a,E]=n;s=Date.UTC(Number(g),Number(a)-1,Number(E))}}return{majorBase:b,majorMustEqual:p,minorBase:v,minorMustEqual:w,patchBase:R,patchMustEqual:S,isMinimum:c.hasGreaterEquals,notBefore:s}}e.normalizeVersion=I;function y(c,b,p){let v;typeof c=="string"?v=I(T(c)):v=c;let w;b instanceof Date?w=b.getTime():typeof b=="string"&&(w=new Date(b).getTime());let R;if(typeof p=="string"?R=I(T(p)):R=p,!v||!R)return!1;let S=v.majorBase,s=v.minorBase,n=v.patchBase,g=R.majorBase,a=R.minorBase,E=R.patchBase,r=R.notBefore,t=R.majorMustEqual,o=R.minorMustEqual,h=R.patchMustEqual;return R.isMinimum?S>g?!0:S<g?!1:s>a?!0:s<a||w&&w<r?!1:n>=E:(S===1&&g===0&&(!t||!o||!h)&&(g=1,a=0,E=0,t=!0,o=!1,h=!1),S<g?!1:S>g?!t:s<a?!1:s>a?!o:n<E?!1:n>E?!h:!(w&&w<r))}e.isValidVersion=y;function P(c,b,p,v){return p.isBuiltin||typeof p.main=="undefined"?!0:D(c,b,p.engines.vscode,v)}e.isValidExtensionVersion=P;function L(c,b,p){return c==="*"||D(b,p,c)}e.isEngineValid=L;function D(c,b,p,v=[]){let w=I(T(p));if(!w)return v.push(m.localize(0,null,p)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return v.push(m.localize(1,null,p)),!1}else if(!w.majorMustEqual)return v.push(m.localize(2,null,p)),!1;return y(c,b,w)?!0:(v.push(m.localize(3,null,c,p)),!1)}}),define(ve[115],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(k,C=[],T=!1){this.ctor=k,this.staticArguments=C,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=m}),define(ve[61],we([0,1,115]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function k(T,I,y){I instanceof m.SyncDescriptor||(I=new m.SyncDescriptor(I,[],y)),i.push([T,I])}e.registerSingleton=k;function C(){return i}e.getSingletonServiceDescriptors=C}),define(ve[180],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=m;class i{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let T of this._nodes.values())T.outgoing.size===0&&C.push(T);return C}insertEdge(C,T){const I=this.lookupOrInsertNode(C),y=this.lookupOrInsertNode(T);I.outgoing.set(this._hashFn(T),y),y.incoming.set(this._hashFn(C),I)}removeNode(C){const T=this._hashFn(C);this._nodes.delete(T);for(let I of this._nodes.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(C){const T=this._hashFn(C);let I=this._nodes.get(T);return I||(I=new m(C),this._nodes.set(T,I)),I}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[T,I]of this._nodes)C.push(`${T}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,T]of this._nodes){const I=new Set([C]),y=this._findCycle(T,I);if(y)return y}}_findCycle(C,T){for(let[I,y]of C.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const P=this._findCycle(y,T);if(P)return P;T.delete(I)}}}e.Graph=i}),define(ve[4],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function I(y){return y[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=I})(m=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function i(T,I,y,P){I[m.DI_TARGET]===I?I[m.DI_DEPENDENCIES].push({id:T,index:y,optional:P}):(I[m.DI_DEPENDENCIES]=[{id:T,index:y,optional:P}],I[m.DI_TARGET]=I)}function k(T){if(m.serviceIds.has(T))return m.serviceIds.get(T);const I=function(y,P,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(I,y,L,!1)};return I.toString=()=>T,m.serviceIds.set(T,I),I}e.createDecorator=k;function C(T){return T}e.refineServiceDecorator=C}),define(ve[181],we([0,1,4]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function i(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=i}),define(ve[182],we([0,1,3,47,6,24,79,83,181]),function(X,e,m,i,k,C,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(v){return typeof v=="string"?!1:Array.isArray(v)?v.every(P):!!v.exclusive}class L{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(w,R){let S={selector:w,provider:R,_score:-1,_time:this._clock++};return this._entries.push(S),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,k.toDisposable)(()=>{if(S){const s=this._entries.indexOf(S);s>=0&&(this._entries.splice(s,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),S=void 0)}})}has(w){return this.all(w).length>0}all(w){if(!w)return[];this._updateScores(w);const R=[];for(let S of this._entries)S._score>0&&R.push(S.provider);return R}ordered(w){const R=[];return this._orderedForEach(w,S=>R.push(S.provider)),R}orderedGroups(w){const R=[];let S,s;return this._orderedForEach(w,n=>{S&&s===n._score?S.push(n.provider):(s=n._score,S=[n.provider],R.push(S))}),R}_orderedForEach(w,R){if(!!w){this._updateScores(w);for(const S of this._entries)S._score>0&&R(S)}}_updateScores(w){const R={uri:w.uri.toString(),language:w.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===R.language&&this._lastCandidate.uri===R.uri)){this._lastCandidate=R;for(let S of this._entries)if(S._score=(0,I.score)(S.selector,w.uri,w.getLanguageId(),(0,y.shouldSynchronizeModel)(w)),P(S.selector)&&S._score>0){for(let s of this._entries)s._score=0;S._score=1e3;break}this._entries.sort(L._compareByScoreAndTime)}}static _compareByScoreAndTime(w,R){return w._score<R._score?1:w._score>R._score?-1:w._time<R._time?1:w._time>R._time?-1:0}}e.LanguageFeatureRegistry=L;const D=new WeakMap;let c=0;function b(v){let w=D.get(v);return w===void 0&&(w=++c,D.set(v,w)),w}class p{constructor(w,R,S=Number.MAX_SAFE_INTEGER){this._registry=w,this.min=R,this.max=S,this._cache=new C.LRUCache(50,.7)}_key(w){return w.id+this._registry.all(w).reduce((R,S)=>(0,i.doHash)(b(S),R),0)}_clamp(w){return w===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(w*1.3)))}get(w){const R=this._key(w),S=this._cache.get(R);return this._clamp(S?.value)}update(w,R){const S=this._key(w);let s=this._cache.get(S);return s||(s=new T.MovingAverage,this._cache.set(S,s)),s.update(R),this.get(w)}}e.LanguageFeatureRequestDelays=p}),define(ve[84],we([0,1,2,41,182,148,74]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var I;(function(l){l[l.Null=0]="Null",l[l.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));var y;(function(l){l[l.NotSet=-1]="NotSet",l[l.None=0]="None",l[l.Italic=1]="Italic",l[l.Bold=2]="Bold",l[l.Underline=4]="Underline",l[l.Strikethrough=8]="Strikethrough"})(y=e.FontStyle||(e.FontStyle={}));var P;(function(l){l[l.None=0]="None",l[l.DefaultForeground=1]="DefaultForeground",l[l.DefaultBackground=2]="DefaultBackground"})(P=e.ColorId||(e.ColorId={}));var L;(function(l){l[l.Other=0]="Other",l[l.Comment=1]="Comment",l[l.String=2]="String",l[l.RegEx=3]="RegEx"})(L=e.StandardTokenType||(e.StandardTokenType={}));var D;(function(l){l[l.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",l[l.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",l[l.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",l[l.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",l[l.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",l[l.ITALIC_MASK=1024]="ITALIC_MASK",l[l.BOLD_MASK=2048]="BOLD_MASK",l[l.UNDERLINE_MASK=4096]="UNDERLINE_MASK",l[l.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",l[l.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",l[l.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",l[l.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",l[l.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",l[l.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",l[l.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",l[l.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",l[l.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",l[l.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",l[l.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",l[l.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(D=e.MetadataConsts||(e.MetadataConsts={}));class c{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&768)>>>8}static getFontStyle(_){return(_&15360)>>>10}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){const A=this.getForeground(_);let N="mtk"+A;const x=this.getFontStyle(_);return x&1&&(N+=" mtki"),x&2&&(N+=" mtkb"),x&4&&(N+=" mtku"),x&8&&(N+=" mtks"),N}static getInlineStyleFromMetadata(_,A){const N=this.getForeground(_),x=this.getFontStyle(_);let F=`color: ${A[N]};`;x&1&&(F+="font-style: italic;"),x&2&&(F+="font-weight: bold;");let O="";return x&4&&(O+=" underline"),x&8&&(O+=" line-through"),O&&(F+=`text-decoration:${O};`),F}}e.TokenMetadata=c;var b;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(b=e.CompletionItemKind||(e.CompletionItemKind={}));var p;(function(l){const _=new Map;_.set(0,T.Codicon.symbolMethod),_.set(1,T.Codicon.symbolFunction),_.set(2,T.Codicon.symbolConstructor),_.set(3,T.Codicon.symbolField),_.set(4,T.Codicon.symbolVariable),_.set(5,T.Codicon.symbolClass),_.set(6,T.Codicon.symbolStruct),_.set(7,T.Codicon.symbolInterface),_.set(8,T.Codicon.symbolModule),_.set(9,T.Codicon.symbolProperty),_.set(10,T.Codicon.symbolEvent),_.set(11,T.Codicon.symbolOperator),_.set(12,T.Codicon.symbolUnit),_.set(13,T.Codicon.symbolValue),_.set(15,T.Codicon.symbolEnum),_.set(14,T.Codicon.symbolConstant),_.set(15,T.Codicon.symbolEnum),_.set(16,T.Codicon.symbolEnumMember),_.set(17,T.Codicon.symbolKeyword),_.set(27,T.Codicon.symbolSnippet),_.set(18,T.Codicon.symbolText),_.set(19,T.Codicon.symbolColor),_.set(20,T.Codicon.symbolFile),_.set(21,T.Codicon.symbolReference),_.set(22,T.Codicon.symbolCustomColor),_.set(23,T.Codicon.symbolFolder),_.set(24,T.Codicon.symbolTypeParameter),_.set(25,T.Codicon.account),_.set(26,T.Codicon.issues);function A(F){let O=_.get(F);return O||(console.info("No codicon found for CompletionItemKind "+F),O=T.Codicon.symbolProperty),O}l.toIcon=A;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function x(F,O){let z=N.get(F);return typeof z=="undefined"&&!O&&(z=9),z}l.fromString=x})(p=e.CompletionItemKinds||(e.CompletionItemKinds={}));var v;(function(l){l[l.Deprecated=1]="Deprecated"})(v=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var R;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(R=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var s;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(s=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var n;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(n=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function a(l){return l&&m.URI.isUri(l.uri)&&i.Range.isIRange(l.range)&&(i.Range.isIRange(l.originSelectionRange)||i.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=a;var E;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(E=e.SymbolKind||(e.SymbolKind={}));var r;(function(l){l[l.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var t;(function(l){const _=new Map;_.set(0,T.Codicon.symbolFile),_.set(1,T.Codicon.symbolModule),_.set(2,T.Codicon.symbolNamespace),_.set(3,T.Codicon.symbolPackage),_.set(4,T.Codicon.symbolClass),_.set(5,T.Codicon.symbolMethod),_.set(6,T.Codicon.symbolProperty),_.set(7,T.Codicon.symbolField),_.set(8,T.Codicon.symbolConstructor),_.set(9,T.Codicon.symbolEnum),_.set(10,T.Codicon.symbolInterface),_.set(11,T.Codicon.symbolFunction),_.set(12,T.Codicon.symbolVariable),_.set(13,T.Codicon.symbolConstant),_.set(14,T.Codicon.symbolString),_.set(15,T.Codicon.symbolNumber),_.set(16,T.Codicon.symbolBoolean),_.set(17,T.Codicon.symbolArray),_.set(18,T.Codicon.symbolObject),_.set(19,T.Codicon.symbolKey),_.set(20,T.Codicon.symbolNull),_.set(21,T.Codicon.symbolEnumMember),_.set(22,T.Codicon.symbolStruct),_.set(23,T.Codicon.symbolEvent),_.set(24,T.Codicon.symbolOperator),_.set(25,T.Codicon.symbolTypeParameter);function A(N){let x=_.get(N);return x||(console.info("No codicon found for SymbolKind "+N),x=T.Codicon.symbolProperty),x}l.toIcon=A})(t=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(_){this.value=_}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var h;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(h=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(u=e.CommentMode||(e.CommentMode={}));var d;(function(l){l[l.Other=0]="Other",l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(d=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistry;var f;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(f=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[116],we([0,1,13,2,4]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function C(w){return w&&typeof w=="object"&&(!w.overrideIdentifier||typeof w.overrideIdentifier=="string")&&(!w.resource||w.resource instanceof i.URI)}e.isConfigurationOverrides=C;function T(w){return w&&typeof w=="object"&&(!w.overrideIdentifiers||m.isArray(w.overrideIdentifiers))&&!w.overrideIdentifier&&(!w.resource||w.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=T;var I;(function(w){w[w.USER=1]="USER",w[w.USER_LOCAL=2]="USER_LOCAL",w[w.USER_REMOTE=3]="USER_REMOTE",w[w.WORKSPACE=4]="WORKSPACE",w[w.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",w[w.DEFAULT=6]="DEFAULT",w[w.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(w){switch(w){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=y;function P(w,R){const S=Object.create(null);for(let s in w)L(S,s,w[s],R);return S}e.toValuesTree=P;function L(w,R,S,s){const n=R.split("."),g=n.pop();let a=w;for(let E=0;E<n.length;E++){let r=n[E],t=a[r];switch(typeof t){case"undefined":t=a[r]=Object.create(null);break;case"object":break;default:s(`Ignoring ${R} as ${n.slice(0,E+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[g]=S}catch{s(`Ignoring ${R} as ${n.join(".")} is ${JSON.stringify(a)}`)}else s(`Ignoring ${R} as ${n.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=L;function D(w,R){const S=R.split(".");c(w,S)}e.removeFromValueTree=D;function c(w,R){const S=R.shift();if(R.length===0){delete w[S];return}if(Object.keys(w).indexOf(S)!==-1){const s=w[S];typeof s=="object"&&!Array.isArray(s)&&(c(s,R),Object.keys(s).length===0&&delete w[S])}}function b(w,R,S){function s(a,E){let r=a;for(const t of E){if(typeof r!="object"||r===null)return;r=r[t]}return r}const n=R.split("."),g=s(w,n);return typeof g=="undefined"?S:g}e.getConfigurationValue=b;function p(w,R,S){Object.keys(R).forEach(s=>{s!=="__proto__"&&(s in w?m.isObject(w[s])&&m.isObject(R[s])?p(w[s],R[s],S):S&&(w[s]=R[s]):w[s]=R[s])})}e.merge=p;function v(w,R,S){const s=w.inspect(R),n=w.inspect(S);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof n.userValue!="undefined"||typeof n.workspaceValue!="undefined"||typeof n.workspaceFolderValue!="undefined"?n.value:s.defaultValue}e.getMigratedSettingValue=v}),define(ve[62],we([0,1,12,9,4]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=m.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",m.isMacintosh),T.set("isLinux",m.isLinux),T.set("isWindows",m.isWindows),T.set("isWeb",m.isWeb),T.set("isMacNative",m.isMacintosh&&!m.isWeb),T.set("isEdge",C.indexOf("Edg/")>=0),T.set("isFirefox",C.indexOf("Firefox")>=0),T.set("isChrome",C.indexOf("Chrome")>=0),T.set("isSafari",C.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var y;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return c.INSTANCE}static true(){return b.INSTANCE}static has(F){return p.create(F)}static equals(F,O){return v.create(F,O)}static notEquals(F,O){return S.create(F,O)}static regex(F,O){return t.create(F,O)}static in(F,O){return w.create(F,O)}static not(F){return s.create(F)}static and(...F){return u.create(F,null)}static or(...F){return d.create(F,null,!0)}static greater(F,O){return g.create(F,O)}static greaterEquals(F,O){return a.create(F,O)}static smaller(F,O){return E.create(F,O)}static smallerEquals(F,O){return r.create(F,O)}static deserialize(F,O=!1){if(!!F)return this._deserializeOrExpression(F,O)}static _deserializeOrExpression(F,O){let z=F.split("||");return d.create(z.map($=>this._deserializeAndExpression($,O)),null,!0)}static _deserializeAndExpression(F,O){let z=F.split("&&");return u.create(z.map($=>this._deserializeOne($,O)),null)}static _deserializeOne(F,O){if(F=F.trim(),F.indexOf("!=")>=0){let z=F.split("!=");return S.create(z[0].trim(),this._deserializeValue(z[1],O))}if(F.indexOf("==")>=0){let z=F.split("==");return v.create(z[0].trim(),this._deserializeValue(z[1],O))}if(F.indexOf("=~")>=0){let z=F.split("=~");return t.create(z[0].trim(),this._deserializeRegexValue(z[1],O))}if(F.indexOf(" in ")>=0){let z=F.split(" in ");return w.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const z=F.split(">=");return a.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const z=F.split(">");return g.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const z=F.split("<=");return r.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const z=F.split("<");return E.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(F)?s.create(F.substr(1).trim()):p.create(F)}static _deserializeValue(F,O){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let z=/^'([^']*)'$/.exec(F);return z?z[1].trim():F}static _deserializeRegexValue(F,O){if((0,i.isFalsyOrWhitespace)(F)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=F.indexOf("/"),$=F.lastIndexOf("/");if(z===$||z<0){if(O)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let M=F.slice(z+1,$),B=F[$+1]==="i"?"i":"";try{return new RegExp(M,B)}catch(W){if(O)throw new Error(`bad regexp-value '${F}', parse error: ${W}`);return console.warn(`bad regexp-value '${F}', parse error: ${W}`),null}}}e.ContextKeyExpr=P;function L(x,F){const O=x?x.substituteConstants():void 0,z=F?F.substituteConstants():void 0;return!O&&!z?!0:!O||!z?!1:O.equals(z)}e.expressionsAreEqualWithConstantSubstitution=L;function D(x,F){return x.cmp(F)}class c{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=c,c.INSTANCE=new c;class b{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return c.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class p{constructor(F,O){this.key=F,this.negated=O,this.type=2}static create(F,O=null){const z=T.get(F);return typeof z=="boolean"?z?b.INSTANCE:c.INSTANCE:new p(F,O)}cmp(F){return F.type!==this.type?this.type-F.type:l(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=T.get(this.key);return typeof F=="boolean"?F?b.INSTANCE:c.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class v{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=4}static create(F,O,z=null){if(typeof O=="boolean")return O?p.create(F,z):s.create(F,z);const $=T.get(F);return typeof $=="boolean"?O===($?"true":"false")?b.INSTANCE:c.INSTANCE:new v(F,O,z)}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=T.get(this.key);if(typeof F=="boolean"){const O=F?"true":"false";return this.value===O?b.INSTANCE:c.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=v;class w{constructor(F,O){this.key=F,this.valueKey=O,this.type=10,this.negated=null}static create(F,O){return new w(F,O)}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const O=F.getValue(this.valueKey),z=F.getValue(this.key);return Array.isArray(O)?O.indexOf(z)>=0:typeof z=="string"&&typeof O=="object"&&O!==null?I.call(O,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=R.create(this)),this.negated}}e.ContextKeyInExpr=w;class R{constructor(F){this._actual=F,this.type=11}static create(F){return new R(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new R(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=R;class S{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=5}static create(F,O,z=null){if(typeof O=="boolean")return O?s.create(F,z):p.create(F,z);const $=T.get(F);return typeof $=="boolean"?O===($?"true":"false")?c.INSTANCE:b.INSTANCE:new S(F,O,z)}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=T.get(this.key);if(typeof F=="boolean"){const O=F?"true":"false";return this.value===O?c.INSTANCE:b.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class s{constructor(F,O){this.key=F,this.negated=O,this.type=3}static create(F,O=null){const z=T.get(F);return typeof z=="boolean"?z?c.INSTANCE:b.INSTANCE:new s(F,O)}cmp(F){return F.type!==this.type?this.type-F.type:l(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=T.get(this.key);return typeof F=="boolean"?F?c.INSTANCE:b.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=s;function n(x,F){if(typeof x=="string"){const O=parseFloat(x);isNaN(O)||(x=O)}return typeof x=="string"||typeof x=="number"?F(x):c.INSTANCE}class g{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=12}static create(F,O,z=null){return n(O,$=>new g(F,$,z))}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=g;class a{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=13}static create(F,O,z=null){return n(O,$=>new a(F,$,z))}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class E{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=14}static create(F,O,z=null){return n(O,$=>new E(F,$,z))}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=E;class r{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=15}static create(F,O,z=null){return n(O,$=>new r(F,$,z))}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class t{constructor(F,O){this.key=F,this.regexp=O,this.type=7,this.negated=null}static create(F,O){return new t(F,O)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const O=this.regexp?this.regexp.source:"",z=F.regexp?F.regexp.source:"";return O<z?-1:O>z?1:0}equals(F){if(F.type===this.type){const O=this.regexp?this.regexp.source:"",z=F.regexp?F.regexp.source:"";return this.key===F.key&&O===z}return!1}substituteConstants(){return this}evaluate(F){let O=F.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class o{constructor(F){this._actual=F,this.type=8}static create(F){return new o(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new o(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function h(x){let F=null;for(let O=0,z=x.length;O<z;O++){const $=x[O].substituteConstants();if(x[O]!==$&&F===null){F=[];for(let M=0;M<O;M++)F[M]=x[M]}F!==null&&(F[O]=$)}return F===null?x:F}class u{constructor(F,O){this.expr=F,this.negated=O,this.type=6}static create(F,O){return u._normalizeArr(F,O)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const $=D(this.expr[O],F.expr[O]);if($!==0)return $}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(F.expr[O]))return!1;return!0}return!1}substituteConstants(){const F=h(this.expr);return F===this.expr?this:u.create(F,this.negated)}evaluate(F){for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].evaluate(F))return!1;return!0}static _normalizeArr(F,O){const z=[];let $=!1;for(const M of F)if(!!M){if(M.type===1){$=!0;continue}if(M.type===0)return c.INSTANCE;if(M.type===6){z.push(...M.expr);continue}z.push(M)}if(z.length===0&&$)return b.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(D);for(let M=1;M<z.length;M++)z[M-1].equals(z[M])&&(z.splice(M,1),M--);if(z.length===1)return z[0];for(;z.length>1;){const M=z[z.length-1];if(M.type!==9)break;z.pop();const B=z.pop(),W=z.length===0,U=d.create(M.expr.map(j=>u.create([j,B],null)),null,W);U&&(z.push(U),z.sort(D))}return z.length===1?z[0]:new u(z,O)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let O of this.expr)F.push(...O.keys());return F}map(F){return new u(this.expr.map(O=>O.map(F)),null)}negate(){if(!this.negated){const F=[];for(let O of this.expr)F.push(O.negate());this.negated=d.create(F,this,!0)}return this.negated}}class d{constructor(F,O){this.expr=F,this.negated=O,this.type=9}static create(F,O,z){return d._normalizeArr(F,O,z)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const $=D(this.expr[O],F.expr[O]);if($!==0)return $}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(F.expr[O]))return!1;return!0}return!1}substituteConstants(){const F=h(this.expr);return F===this.expr?this:d.create(F,this.negated,!1)}evaluate(F){for(let O=0,z=this.expr.length;O<z;O++)if(this.expr[O].evaluate(F))return!0;return!1}static _normalizeArr(F,O,z){let $=[],M=!1;if(F){for(let B=0,W=F.length;B<W;B++){const U=F[B];if(!!U){if(U.type===0){M=!0;continue}if(U.type===1)return b.INSTANCE;if(U.type===9){$=$.concat(U.expr);continue}$.push(U)}}if($.length===0&&M)return c.INSTANCE;$.sort(D)}if($.length!==0){if($.length===1)return $[0];for(let B=1;B<$.length;B++)$[B-1].equals($[B])&&($.splice(B,1),B--);if($.length===1)return $[0];if(z){for(let B=0;B<$.length;B++)for(let W=B+1;W<$.length;W++)A($[B],$[W])&&($.splice(W,1),W--);if($.length===1)return $[0]}return new d($,O)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let O of this.expr)F.push(...O.keys());return F}map(F){return new d(this.expr.map(O=>O.map(F)),null)}negate(){if(!this.negated){let F=[];for(let O of this.expr)F.push(O.negate());for(;F.length>1;){const O=F.shift(),z=F.shift(),$=[];for(const B of N(O))for(const W of N(z))$.push(u.create([B,W],null));const M=F.length===0;F.unshift(d.create($,null,M))}this.negated=F[0]}return this.negated}}class f extends p{constructor(F,O,z){super(F,null);this._defaultValue=O,typeof z=="object"?f._info.push({...z,key:F}):z!==!0&&f._info.push({key:F,description:z,type:O!=null?typeof O:void 0})}static all(){return f._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return v.create(this.key,F)}notEqualsTo(F){return S.create(this.key,F)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function l(x,F){return x<F?-1:x>F?1:0}function _(x,F,O,z){return x<O?-1:x>O?1:F<z?-1:F>z?1:0}function A(x,F){if(F.type===6&&x.type!==9&&x.type!==6){for(const $ of F.expr)if(x.equals($))return!0}const O=x.negate(),z=N(O).concat(N(F));z.sort(D);for(let $=0;$<z.length;$++){const B=z[$].negate();for(let W=$+1;W<z.length;W++){const U=z[W];if(B.equals(U))return!0}}return!1}e.implies=A;function N(x){return x.type===9?x.expr:[x]}}),define(ve[183],we([0,1,4]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[184],we([0,1,10,157,4]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function T(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function I(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function y(s,n){switch(s){case 3:return n==="x64"?"win32-x64":n==="ia32"?"win32-ia32":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function P(s,n){return n==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function L(s,n,g){return P(n,g)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===g?!0:D(g).includes(s)}e.isTargetPlatformCompatible=L;function D(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=D;function c(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=c;var b;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var p;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var v;(function(s){s.Install="install",s.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var w;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var R;(function(s){s.Unsupported="Unsupported",s.UnsupportedPreRelease="UnsupportedPreRelease",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatiblePreRelease="IncompatiblePreRelease",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(R=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class S extends Error{constructor(n,g){super(n);this.code=g,this.name=g}}e.ExtensionManagementError=S,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(ve[185],we([0,1,4]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(ve[186],we([0,1,37,10,8,12,96,29,113,159,185]),function(X,e,m,i,k,C,T,I,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const D=P.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends c{openTerminal(n,g){return this.spawnTerminal(m,n,y.getWindowsShell(),g)}spawnTerminal(n,g,a,E){const r=g.windowsExec||b.getDefaultTerminalWindows();E&&E[1]===":"&&(E=E[0].toUpperCase()+E.substr(1));const t=k.basename(r).toLowerCase();if(t==="cmder"||t==="cmder.exe")return n.spawn(r,E?[E]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return r.indexOf(" ")>=0&&o.push('""'),o.push(r),(t==="wt"||t==="wt.exe")&&o.push("-d ."),new Promise((h,u)=>{const d=w(process),f=n.spawn(a,o,{cwd:E,env:d});f.on("error",u),f.on("exit",()=>h())})}runInTerminal(n,g,a,E,r){const t="windowsExec"in r&&r.windowsExec?r.windowsExec:b.getDefaultTerminalWindows();return new Promise((o,h)=>{const u=`"${g} - ${D}"`,d=`""${a.join('" "')}" & pause"`,f=["/c","start",u,"/wait",t,"/c",d],l=Object.assign({},w(process),E);Object.keys(l).filter(N=>l[N]===null).forEach(N=>delete l[N]);const _={cwd:g,env:l,windowsVerbatimArguments:!0};m.spawn(b.CMD,f,_).on("error",N=>{h(R(N))}),o(void 0)})}static getDefaultTerminalWindows(){if(!b._DEFAULT_TERMINAL_WINDOWS){const n=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${n?"Sysnative":"System32"}\\cmd.exe`}return b._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=b,b.CMD="cmd.exe";class p extends c{openTerminal(n,g){return this.spawnTerminal(m,n,g)}runInTerminal(n,g,a,E,r){const t=r.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((o,h)=>{if(t===L.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const u=t===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",f=[i.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,X).fsPath,"-t",n||D,"-w",g];for(let A of a)f.push("-a"),f.push(A);if(E){const A=Object.assign({},w(process),E);for(let N in A){const x=A[N];x===null?(f.push("-u"),f.push(N)):(f.push("-e"),f.push(`${N}=${x}`))}}let l="";const _=m.spawn(p.OSASCRIPT,f);_.on("error",A=>{h(R(A))}),_.stderr.on("data",A=>{l+=A.toString()}),_.on("exit",A=>{if(A===0)o(void 0);else if(l){const N=l.split(`
`,1);h(new Error(N[0]))}else h(new Error(P.localize(1,null,u,A)))})}else h(new Error(P.localize(2,null,t)))})}spawnTerminal(n,g,a){const E=g.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,t)=>{const o=["-a",E];a&&o.push(a);const h=w(process),u=n.spawn("/usr/bin/open",o,{cwd:a,env:h});u.on("error",t),u.on("exit",()=>r())})}}e.MacExternalTerminalService=p,p.OSASCRIPT="/usr/bin/osascript";class v extends c{openTerminal(n,g){return this.spawnTerminal(m,n,g)}runInTerminal(n,g,a,E,r){const t=r.linuxExec?Promise.resolve(r.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((o,h)=>{let u=[];t.then(d=>{d.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const f=`${S(a)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;u.push(`''${f}''`);const l=Object.assign({},w(process),E);Object.keys(l).filter(x=>l[x]===null).forEach(x=>delete l[x]);const _={cwd:g,env:l};let A="";const N=m.spawn(d,u,_);N.on("error",x=>{h(R(x))}),N.stderr.on("data",x=>{A+=x.toString()}),N.on("exit",x=>{if(x===0)o(void 0);else if(A){const F=A.split(`
`,1);h(new Error(F[0]))}else h(new Error(P.localize(4,null,d,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!v._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)v._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const n=await I.Promises.exists("/etc/debian_version");v._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{n?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(n,g,a){const E=g.linuxExec?Promise.resolve(g.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{E.then(o=>{const h=w(process),u=n.spawn(o,[],{cwd:a,env:h});u.on("error",t),u.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=P.localize(3,null);function w(s){const n={...s.env};return(0,T.sanitizeProcessEnvironment)(n),n}function R(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(P.localize(5,null,s.path)):s}function S(s){let n="";for(let g of s)g.indexOf(" ")>=0?n+='"'+g+'"':n+=g,n+=" ";return n}}),define(ve[42],we([0,1,24,8,9,13,2,160,4]),function(X,e,m,i,k,C,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function P($){return $.create===!0}e.isFileOpenForWriteOptions=P;var L;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var D;(function($){$[$.Readonly=1]="Readonly"})(D=e.FilePermission||(e.FilePermission={}));var c;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b($){return!!($.capabilities&2)}e.hasReadWriteCapability=b;function p($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=p;function v($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function w($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=w;function R($){return b($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=R;var S;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class s extends Error{constructor(M,B){super(M);this.code=B}}e.FileSystemProviderError=s;function n($,M){const B=new s($.toString(),M);return a(B,M),B}e.createFileSystemProviderError=n;function g($){return $||n((0,I.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=g;function a($,M){return $.name=M?`${M} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=a;function E($){if(!$)return S.Unknown;if($ instanceof s)return $.code;const M=/^(.+) \(FileSystemError\)$/.exec($.name);if(!M)return S.Unknown;switch(M[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=E;function r($){if($ instanceof f)return $.fileOperationResult;switch(E($)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var t;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class o{constructor(M,B,W){this.resource=M,this.operation=B,this.target=W}isOperation(M){return this.operation===M}}e.FileOperationEvent=o;var h;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class u{constructor(M,B){this.added=void 0,this.updated=void 0,this.deleted=void 0;const W=new Map;for(const U of M){const j=W.get(U.type);j?j.push([U.resource,U]):W.set(U.type,[[U.resource,U]])}for(const[U,j]of W)switch(U){case 1:this.added=m.TernarySearchTree.forUris(()=>B),this.added.fill(j);break;case 0:this.updated=m.TernarySearchTree.forUris(()=>B),this.updated.fill(j);break;case 2:this.deleted=m.TernarySearchTree.forUris(()=>B),this.deleted.fill(j);break}}contains(M,...B){return this.doContains(M,{includeChildren:!1},...B)}affects(M,...B){return this.doContains(M,{includeChildren:!0},...B)}doContains(M,B,...W){if(!M)return!1;const U=W.length>0;return!!((!U||W.includes(1))&&(this.added?.get(M)||B.includeChildren&&this.added?.findSuperstr(M))||(!U||W.includes(0))&&(this.updated?.get(M)||B.includeChildren&&this.updated?.findSuperstr(M))||(!U||W.includes(2))&&(this.deleted?.findSubstr(M)||B.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawUpdated(){return this.updated}get rawDeleted(){return this.deleted}}e.FileChangesEvent=u;function d($,M,B){return!$||!M||$===M||M.length>$.length?!1:(M.charAt(M.length-1)!==i.sep&&(M+=i.sep),B?(0,k.startsWithIgnoreCase)($,M):$.indexOf(M)===0)}e.isParent=d;class f extends Error{constructor(M,B,W){super(M);this.fileOperationResult=B,this.options=W}}e.FileOperationError=f;class l extends f{constructor(M,B,W){super(M,2,W);this.stat=B}}e.NotModifiedSinceFileOperationError=l;var _;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=N;async function x($,M){if(!M.hasProvider(T.URI.from({scheme:$.scheme})))return new Promise(B=>{const W=M.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===$.scheme&&U.added&&(W.dispose(),B())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(M){return(0,C.isNumber)(M)||(M=0),M<F.KB?(0,I.localize)(1,null,M.toFixed(0)):M<F.MB?(0,I.localize)(2,null,(M/F.KB).toFixed(2)):M<F.GB?(0,I.localize)(3,null,(M/F.MB).toFixed(2)):M<F.TB?(0,I.localize)(4,null,(M/F.GB).toFixed(2)):(0,I.localize)(5,null,(M/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var O;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function z($){return{maxFileSize:$===0?300*F.MB:16*F.GB,maxHeapSize:$===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=z}),define(ve[85],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...k){this._entries=new Map;for(let[C,T]of k)this.set(C,T)}set(k,C){const T=this._entries.get(k);return this._entries.set(k,C),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=m}),define(ve[187],we([0,1,18,15,115,180,4,85]),function(X,e,m,i,k,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class P extends Error{constructor(p){super("cyclic dependency between services");this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class L{constructor(p=new I.ServiceCollection,v=!1,w){this._activeInstantiations=new Set,this._services=p,this._strict=v,this._parent=w,this._services.set(T.IInstantiationService,this)}createChild(p){return new L(p,this._strict,this)}invokeFunction(p,...v){let w=c.traceInvocation(p),R=!1;try{return p({get:s=>{if(R)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(s,w);if(!n)throw new Error(`[invokeFunction] unknown service '${s}'`);return n}},...v)}finally{R=!0,w.stop()}}createInstance(p,...v){let w,R;return p instanceof k.SyncDescriptor?(w=c.traceCreation(p.ctor),R=this._createInstance(p.ctor,p.staticArguments.concat(v),w)):(w=c.traceCreation(p),R=this._createInstance(p,v,w)),w.stop(),R}_createInstance(p,v=[],w){let R=T._util.getServiceDependencies(p).sort((n,g)=>n.index-g.index),S=[];for(const n of R){let g=this._getOrCreateServiceInstance(n.id,w);if(!g&&this._strict&&!n.optional)throw new Error(`[createInstance] ${p.name} depends on UNKNOWN service ${n.id}.`);S.push(g)}let s=R.length>0?R[0].index:v.length;if(v.length!==s){console.warn(`[createInstance] First service dependency of ${p.name} at position ${s+1} conflicts with ${v.length} static arguments`);let n=s-v.length;n>0?v=v.concat(new Array(n)):v=v.slice(0,s)}return new p(...[...v,...S])}_setServiceInstance(p,v){if(this._services.get(p)instanceof k.SyncDescriptor)this._services.set(p,v);else if(this._parent)this._parent._setServiceInstance(p,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){let v=this._services.get(p);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):v}_getOrCreateServiceInstance(p,v){let w=this._getServiceInstanceOrDescriptor(p);return w instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,w,v.branch(p,!0)):(v.branch(p,!1),w)}_safeCreateAndCacheServiceInstance(p,v,w){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,v,w)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,v,w){const R=new C.Graph(n=>n.id.toString());let S=0;const s=[{id:p,desc:v,_trace:w}];for(;s.length;){const n=s.pop();if(R.lookupOrInsertNode(n),S++>1e3)throw new P(R);for(let g of T._util.getServiceDependencies(n.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(g.id);if(!a&&!g.optional&&console.warn(`[createInstance] ${p} depends on ${g.id} which is NOT registered.`),a instanceof k.SyncDescriptor){const E={id:g.id,desc:a,_trace:n._trace.branch(g.id,!0)};R.insertEdge(n,E),s.push(E)}}}for(;;){const n=R.roots();if(n.length===0){if(!R.isEmpty())throw new P(R);break}for(const{data:g}of n){if(this._getServiceInstanceOrDescriptor(g.id)instanceof k.SyncDescriptor){const E=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,E)}R.removeNode(g)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,v,w=[],R,S){if(this._services.get(p)instanceof k.SyncDescriptor)return this._createServiceInstance(v,w,R,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,v,w,R,S);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(p,v=[],w,R){if(w){const S=new m.IdleValue(()=>this._createInstance(p,v,R));return new Proxy(Object.create(null),{get(s,n){if(n in s)return s[n];let g=S.value,a=g[n];return typeof a!="function"||(a=a.bind(g),s[n]=a),a},set(s,n,g){return S.value[n]=g,!0}})}else return this._createInstance(p,v,R)}}e.InstantiationService=L;var D;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(D||(D={}));class c{constructor(p,v){this.type=p,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(p){return y?new c(1,p.name||p.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(p){return y?new c(0,p.name):c._None}branch(p,v){let w=new c(2,p.toString());return this._dep.push([p,v,w]),w}stop(){let p=Date.now()-this._start;c._totals+=p;let v=!1;function w(S,s){let n=[],g=new Array(S+1).join("	");for(const[a,E,r]of s._dep)if(E&&r){v=!0,n.push(`${g}CREATES -> ${a}`);let t=w(S+1,r);t&&n.push(t)}else n.push(`${g}uses -> ${a}`);return n.join(`
`)}let R=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(p>2||v)&&console.log(R.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(ve[11],we([0,1,50,3,6,12,4]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function I(){return new Date().toISOString()}var y;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function P(E,r,t){switch(r){case y.Trace:E.trace(t);break;case y.Debug:E.debug(t);break;case y.Info:E.info(t);break;case y.Warning:E.warn(t);break;case y.Error:E.error(t);break;case y.Critical:E.critical(t);break;default:throw new Error("Invalid log level")}}e.log=P;function L(E){let r="";for(let t=0;t<E.length;t++){let o=E[t];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}r+=(t>0?" ":"")+o}return r}e.format=L;class D extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=D;class c extends D{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...t){this.checkLogLevel(y.Trace)&&this.log(y.Trace,L([r,...t]))}debug(r,...t){this.checkLogLevel(y.Debug)&&this.log(y.Debug,L([r,...t]))}info(r,...t){this.checkLogLevel(y.Info)&&this.log(y.Info,L([r,...t]))}warn(r,...t){this.checkLogLevel(y.Warning)&&this.log(y.Warning,L([r,...t]))}error(r,...t){if(this.checkLogLevel(y.Error))if(r instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=r.stack,this.log(y.Error,L(o))}else this.log(y.Error,L([r,...t]))}critical(r,...t){this.checkLogLevel(y.Critical)&&this.log(y.Critical,L([r,...t]))}flush(){}}e.AbstractMessageLogger=c;class b extends D{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!C.isWindows}trace(r,...t){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...t):console.log(`[main ${I()}]`,r,...t))}debug(r,...t){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...t):console.log(`[main ${I()}]`,r,...t))}info(r,...t){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...t):console.log(`[main ${I()}]`,r,...t))}warn(r,...t){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,r,...t):console.warn(`[main ${I()}]`,r,...t))}error(r,...t){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,r,...t):console.error(`[main ${I()}]`,r,...t))}critical(r,...t){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,r,...t):console.error(`[main ${I()}]`,r,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class p extends D{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...t){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",r,...t)}debug(r,...t){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...t)}info(r,...t){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",r,...t)}warn(r,...t){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",r,...t)}error(r,...t){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",r,...t)}critical(r,...t){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...t)}dispose(){}flush(){}}e.ConsoleLogger=p;class v extends D{constructor(r,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(t)}trace(r,...t){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(r),...t])}debug(r,...t){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(r),...t])}info(r,...t){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(r),...t])}warn(r,...t){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(r),...t])}error(r,...t){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(r),...t])}critical(r,...t){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(r),...t])}extractMessage(r){return typeof r=="string"?r:(0,m.toErrorMessage)(r,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class w extends D{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const t of this.logServices)t.setLevel(r);super.setLevel(r)}trace(r,...t){for(const o of this.logServices)o.trace(r,...t)}debug(r,...t){for(const o of this.logServices)o.debug(r,...t)}info(r,...t){for(const o of this.logServices)o.info(r,...t)}warn(r,...t){for(const o of this.logServices)o.warn(r,...t)}error(r,...t){for(const o of this.logServices)o.error(r,...t)}critical(r,...t){for(const o of this.logServices)o.critical(r,...t)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=w;class R extends k.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...t){this.logger.trace(r,...t)}debug(r,...t){this.logger.debug(r,...t)}info(r,...t){this.logger.info(r,...t)}warn(r,...t){this.logger.warn(r,...t)}error(r,...t){this.logger.error(r,...t)}critical(r,...t){this.logger.critical(r,...t)}flush(){this.logger.flush()}}e.LogService=R;class S extends k.Disposable{constructor(r,t){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(h=>h.setLevel(o))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,t){let o=this.loggers.get(r.toString());return o||(o=this.doCreateLogger(r,t?.always?y.Trace:this.logLevel,t),this.loggers.set(r.toString(),o),t?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class s{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(r){}getLevel(){return y.Info}trace(r,...t){}debug(r,...t){}info(r,...t){}warn(r,...t){}error(r,...t){}critical(r,...t){}dispose(){}flush(){}}e.NullLogService=s;function n(E){if(E.verbose)return y.Trace;if(typeof E.logLevel=="string"){const r=g(E.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function g(E){switch(E){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=g;function a(E){switch(E){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=a}),define(ve[188],we([0,1,42,11]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(I,y,P,L,D){try{const c=await new Promise((p,v)=>{X(["spdlog"],p,v)});c.setFlushOn(i.LogLevel.Trace);const b=await c.createAsyncRotatingLogger(I,y,P,L);return D&&b.clearFormatters(),b}catch(c){console.error(c)}return null}function C(I,y,P){switch(y){case i.LogLevel.Trace:I.trace(P);break;case i.LogLevel.Debug:I.debug(P);break;case i.LogLevel.Info:I.info(P);break;case i.LogLevel.Warning:I.warn(P);break;case i.LogLevel.Error:I.error(P);break;case i.LogLevel.Critical:I.critical(P);break;default:throw new Error("Invalid log level")}}class T extends i.AbstractMessageLogger{constructor(y,P,L,D,c){super();this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(y,P,L,D),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}async _createSpdLogLogger(y,P,L,D){const c=L?6:1,b=30/c*m.ByteSize.MB,p=await k(y,P,b,c,D);if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:v,message:w}of this.buffer)C(this._logger,v,w);this.buffer=[]}}log(y,P){this._logger?C(this._logger,y,P):this.getLevel()<=y&&this.buffer.push({level:y,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=T}),define(ve[117],we([0,1,48,161,4]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var T;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function P(p,v){return v-p}y.compare=P;const L=Object.create(null);L[y.Error]=(0,i.localize)(0,null),L[y.Warning]=(0,i.localize)(1,null),L[y.Info]=(0,i.localize)(2,null);function D(p){return L[p]||""}y.toString=D;function c(p){switch(p){case m.default.Error:return y.Error;case m.default.Warning:return y.Warning;case m.default.Info:return y.Info;case m.default.Ignore:return y.Hint}}y.fromSeverity=c;function b(p){switch(p){case y.Error:return m.default.Error;case y.Warning:return m.default.Warning;case y.Info:return m.default.Info;case y.Hint:return m.default.Ignore}}y.toSeverity=b}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(y){const P="";function L(c){return D(c,!0)}y.makeKey=L;function D(c,b){let p=[P];return c.source?p.push(c.source.replace("\xA6","\\\xA6")):p.push(P),c.code?typeof c.code=="string"?p.push(c.code.replace("\xA6","\\\xA6")):p.push(c.code.value.replace("\xA6","\\\xA6")):p.push(P),c.severity!==void 0&&c.severity!==null?p.push(T.toString(c.severity)):p.push(P),c.message&&b?p.push(c.message.replace("\xA6","\\\xA6")):p.push(P),c.startLineNumber!==void 0&&c.startLineNumber!==null?p.push(c.startLineNumber.toString()):p.push(P),c.startColumn!==void 0&&c.startColumn!==null?p.push(c.startColumn.toString()):p.push(P),c.endLineNumber!==void 0&&c.endLineNumber!==null?p.push(c.endLineNumber.toString()):p.push(P),c.endColumn!==void 0&&c.endColumn!==null?p.push(c.endColumn.toString()):p.push(P),p.push(P),p.join("\xA6")}y.makeKeyOptionalMessage=D})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(ve[189],we([0,1,3,48,4]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=i.default,e.INotificationService=(0,k.createDecorator)("notificationService");var C;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new y,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=I;class y{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=y}),define(ve[190],we([0,1,6,9,2,4]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(y){return{resolved:y,dispose(){}}}});function T(y,P){return k.URI.isUri(y)?(0,i.equalsIgnoreCase)(y.scheme,P):(0,i.startsWithIgnoreCase)(y,P+":")}e.matchesScheme=T;function I(y,...P){return P.some(L=>T(y,L))}e.matchesSomeScheme=I}),define(ve[191],we([0,1,10,12,40,23]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const I=i.globals.vscode.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const I=(0,C.dirname)(m.FileAccess.asFileUri("",X));T=X.__$__nodeRequire((0,C.joinPath)(I,"product.json").fsPath);const y=X.__$__nodeRequire((0,C.joinPath)(I,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:y.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var He=this&&this.__param||function(X,e){return function(m,i){e(m,i,X)}};define(ve[118],we([0,1,18,21,6,4]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var T;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(D){this.callback=D}get value(){return this._value}report(D){this._value=D,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let y=class extends k.Disposable{constructor(D,c){super();this.deferred=new m.DeferredPromise,c.withProgress(D,b=>(this.reporter=b,this.lastStep&&b.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(D){this.reporter?this.reporter.report(D):this.lastStep=D}};y=je([He(1,e.IProgressService)],y),e.UnmanagedProgress=y;class P extends k.Disposable{constructor(D){super();this.progressIndicator=D,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(D){this.stop();const c=++this.currentOperationId,b=new i.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},D),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>b.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:b.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(D){this.currentOperationId===D&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(ve[51],we([0,1,56,13]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,I){m.ok(i.isString(T)),m.ok(i.isObject(I)),m.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,I)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(ve[192],we([0,1,3,51]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class C{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,P){this.schemasById[k(y)]=P,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new C;i.Registry.add(e.Extensions.JSONContribution,T)}),define(ve[119],we([0,1,16,3,13,156,192,51]),function(X,e,m,i,k,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const L=I.Registry.as(T.Extensions.JSONContribution);class D{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(g,a=!0){this.registerConfigurations([g],a)}registerConfigurations(g,a=!0){const E=this.doRegisterConfigurations(g,a);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:E})}deregisterConfigurations(g){const a=this.doDeregisterConfigurations(g);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:g,remove:a}){const E=[];E.push(...this.doDeregisterConfigurations(a)),E.push(...this.doRegisterConfigurations(g,!1)),L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,m.distinct)(E)})}registerDefaultConfigurations(g){const a=[],E=[];for(const{overrides:r,source:t}of g)for(const o in r)if(a.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const h={...this.configurationDefaultsOverrides.get(o)?.value||{},...r[o]};this.configurationDefaultsOverrides.set(o,{source:t,value:h});const u={type:"object",default:h,description:C.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:k.isString(t)?void 0:t};E.push(...p(o)),this.configurationProperties[o]=u,this.defaultLanguageConfigurationOverridesNode.properties[o]=u}else{this.configurationDefaultsOverrides.set(o,{value:r[o],source:t});const h=this.configurationProperties[o];h&&(this.updatePropertyDefaultValue(o,h),this.updateSchema(o,h))}this.registerOverrideIdentifiers(E),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(g){const a=[];for(const{overrides:E,source:r}of g)for(const t in E){const o=this.configurationDefaultsOverrides.get(t),h=k.isString(r)?r:r?.id,u=k.isString(o?.source)?o?.source:o?.source?.id;if(h===u)if(a.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const d=this.configurationProperties[t];d&&(this.updatePropertyDefaultValue(t,d),this.updateSchema(t,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const a of g)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(g,a){const E=[];return g.forEach(r=>{E.push(...this.validateAndRegisterProperties(r,a,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),E}doDeregisterConfigurations(g){const a=[],E=r=>{if(r.properties)for(const t in r.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,r.properties[t]);r.allOf&&r.allOf.forEach(t=>E(t))};for(const r of g){E(r);const t=this.configurationContributors.indexOf(r);t!==-1&&this.configurationContributors.splice(t,1)}return a}validateAndRegisterProperties(g,a=!0,E,r,t=3){t=k.isUndefinedOrNull(g.scope)?t:g.scope;let o=[],h=g.properties;if(h)for(let d in h){if(a&&S(d)){delete h[d];continue}const f=h[d];if(f.source=E,f.defaultDefaultValue=h[d].default,this.updatePropertyDefaultValue(d,f),e.OVERRIDE_PROPERTY_REGEX.test(d)?f.scope=void 0:(f.scope=k.isUndefinedOrNull(f.scope)?t:f.scope,f.restricted=k.isUndefinedOrNull(f.restricted)?!!r?.includes(d):f.restricted),h[d].hasOwnProperty("included")&&!h[d].included){this.excludedConfigurationProperties[d]=h[d],delete h[d];continue}else this.configurationProperties[d]=h[d];!h[d].deprecationMessage&&h[d].markdownDeprecationMessage&&(h[d].deprecationMessage=h[d].markdownDeprecationMessage),o.push(d)}let u=g.allOf;if(u)for(let d of u)o.push(...this.validateAndRegisterProperties(d,a,E,r,t));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(g){const a=E=>{let r=E.properties;if(r)for(const o in r)this.updateSchema(o,r[o]);let t=E.allOf;t&&t.forEach(a)};a(g)}updateSchema(g,a){switch(e.allSettings.properties[g]=a,a.scope){case 1:e.applicationSettings.properties[g]=a;break;case 2:e.machineSettings.properties[g]=a;break;case 6:e.machineOverridableSettings.properties[g]=a;break;case 3:e.windowSettings.properties[g]=a;break;case 4:e.resourceSettings.properties[g]=a;break;case 5:e.resourceSettings.properties[g]=a,this.resourceLanguageSettingsSchema.properties[g]=a;break}}removeFromSchema(g,a){switch(delete e.allSettings.properties[g],a.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g],delete this.resourceLanguageSettingsSchema.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const a=`[${g}]`,E={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,E),e.allSettings.properties[a]=E,e.applicationSettings.properties[a]=E,e.machineSettings.properties[a]=E,e.machineOverridableSettings.properties[a]=E,e.windowSettings.properties[a]=E,e.resourceSettings.properties[a]=E}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const g={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,a){const E=this.configurationDefaultsOverrides.get(g);let r=E?.value,t=E?.source;k.isUndefined(r)&&(r=a.defaultDefaultValue,t=void 0),k.isUndefined(r)&&(r=w(a.type)),a.default=r,a.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",b=new RegExp(c,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(n){const g=[];if(e.OVERRIDE_PROPERTY_REGEX.test(n)){let a=b.exec(n);for(;a?.length;){const E=a[1].trim();E&&g.push(E),a=b.exec(n)}}return(0,m.distinct)(g)}e.overrideIdentifiersFromKey=p;function v(n){return n.reduce((g,a)=>`${g}[${a}]`,"")}e.keyFromOverrideIdentifiers=v;function w(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const R=new D;I.Registry.add(e.Extensions.Configuration,R);function S(n){return n.trim()?e.OVERRIDE_PROPERTY_REGEX.test(n)?C.localize(7,null,n):R.getConfigurationProperties()[n]!==void 0?C.localize(8,null,n):null:C.localize(6,null)}e.validateProperty=S;function s(){const n=[],g=R.getConfigurationProperties();for(const a of Object.keys(g))n.push([a,g[a].scope]);return n.push(["launch",4]),n.push(["task",4]),n}e.getScopes=s}),define(ve[193],we([0,1,16,3,58,6,24,25,13,2,116,119,51]),function(X,e,m,i,k,C,T,I,y,P,L,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(r={},t=[],o=[]){this._contents=r,this._keys=t,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,L.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,t){const o=this.getContentsForOverrideIdentifer(t);return o?r?(0,L.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const o of this.overrides)o.identifiers.includes(r)&&t.push(...o.keys);return m.distinct(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return m.distinct(r)}override(r){let t=this.overrideConfigurations.get(r);return t||(t=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,t)),t}merge(...r){const t=I.deepClone(this.contents),o=I.deepClone(this.overrides),h=[...this.keys];for(const u of r){this.mergeContents(t,u.contents);for(const d of u.overrides){const[f]=o.filter(l=>m.equals(l.identifiers,d.identifiers));f?(this.mergeContents(f.contents,d.contents),f.keys.push(...d.keys),f.keys=m.distinct(f.keys)):o.push(I.deepClone(d))}for(const d of u.keys)h.indexOf(d)===-1&&h.push(d)}return new b(t,h,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const t=this.getContentsForOverrideIdentifer(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let o={};for(const h of m.distinct([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[h],d=t[h];d&&(typeof u=="object"&&typeof d=="object"?(u=I.deepClone(u),this.mergeContents(u,d)):u=d),o[h]=u}return new b(o,this.keys,this.overrides)}mergeContents(r,t){for(const o of Object.keys(t)){if(o in r&&y.isObject(r[o])&&y.isObject(t[o])){this.mergeContents(r[o],t[o]);continue}r[o]=I.deepClone(t[o])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?I.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let t=null,o=null;const h=u=>{u&&(o?this.mergeContents(o,u):o=I.deepClone(u))};for(const u of this.overrides)m.equals(u.identifiers,[r])?t=u.contents:u.identifiers.includes(r)&&h(u.contents);return h(t),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,t){this.addKey(r),(0,L.addToValueTree)(this.contents,r,t,o=>{throw new Error(o)})}removeValue(r){this.removeKey(r)&&(0,L.removeFromValueTree)(this.contents,r)}addKey(r){let t=this.keys.length;for(let o=0;o<t;o++)r.indexOf(this.keys[o])===0&&(t=o);this.keys.splice(t,1,r)}removeKey(r){let t=this.keys.indexOf(r);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=b;class p extends b{constructor(r={}){const t=c.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(t),h=Object.create(null),u=[];for(const d in t){const f=r[d],l=f!==void 0?f:t[d].default;(0,L.addToValueTree)(h,d,l,_=>console.error(`Conflict in default settings: ${_}`))}for(const d of Object.keys(h))D.OVERRIDE_PROPERTY_REGEX.test(d)&&u.push({identifiers:(0,D.overrideIdentifiersFromKey)(d),keys:Object.keys(h[d]),contents:(0,L.toValuesTree)(h[d],f=>console.error(`Conflict in default settings file: ${f}`))});super(h,o,u)}}e.DefaultConfigurationModel=p;class v{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,t){if(!y.isUndefinedOrNull(r)){const o=this.doParseContent(r);this.parseRaw(o,t)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,t){this._raw=r;const{contents:o,keys:h,overrides:u,restricted:d}=this.doParseRaw(r,t);this._configurationModel=new b(o,h,u),this._restrictedConfigurations=d||[]}doParseContent(r){let t={},o=null,h=[],u=[],d=[];function f(_){Array.isArray(h)?h.push(_):o!==null&&(h[o]=_)}let l={onObjectBegin:()=>{let _={};f(_),u.push(h),h=_,o=null},onObjectProperty:_=>{o=_},onObjectEnd:()=>{h=u.pop()},onArrayBegin:()=>{let _=[];f(_),u.push(h),h=_,o=null},onArrayEnd:()=>{h=u.pop()},onLiteralValue:f,onError:(_,A,N)=>{d.push({error:_,offset:A,length:N})}};if(r)try{k.visit(r,l),t=h[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return t}doParseRaw(r,t){const o=c.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),h=this.filter(r,o,!0,t);r=h.raw;const u=(0,L.toValuesTree)(r,l=>console.error(`Conflict in settings file ${this._name}: ${l}`)),d=Object.keys(r),f=this.toOverrides(r,l=>console.error(`Conflict in settings file ${this._name}: ${l}`));return{contents:u,keys:d,overrides:f,restricted:h.restricted}}filter(r,t,o,h){if(!h?.scopes&&!h?.skipRestricted)return{raw:r,restricted:[]};const u={},d=[];for(let f in r)if(D.OVERRIDE_PROPERTY_REGEX.test(f)&&o){const l=this.filter(r[f],t,!1,h);u[f]=l.raw,d.push(...l.restricted)}else{const l=t[f],_=l?typeof l.scope!="undefined"?l.scope:3:void 0;l?.restricted&&d.push(f),(_===void 0||h.scopes===void 0||h.scopes.includes(_))&&(h.skipRestricted&&l?.restricted||(u[f]=r[f]))}return{raw:u,restricted:d}}toOverrides(r,t){const o=[];for(const h of Object.keys(r))if(D.OVERRIDE_PROPERTY_REGEX.test(h)){const u={};for(const d in r[h])u[d]=r[h][d];o.push({identifiers:(0,D.overrideIdentifiersFromKey)(h),keys:Object.keys(u),contents:(0,L.toValuesTree)(u,t)})}return o}}e.ConfigurationModelParser=v;class w extends C.Disposable{constructor(r,t,o,h){super();this.userSettingsResource=r,this.scopes=t,this.fileService=h,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class R{constructor(r,t,o=new b,h=new b,u=new T.ResourceMap,d=new b,f=new T.ResourceMap,l=!0){this._defaultConfiguration=r,this._localUserConfiguration=t,this._remoteUserConfiguration=o,this._workspaceConfiguration=h,this._folderConfigurations=u,this._memoryConfiguration=d,this._memoryConfigurationByResource=f,this._freeze=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(r,t,o){return this.getConsolidateConfigurationModel(t,o).getValue(r)}updateValue(r,t,o={}){let h;o.resource?(h=this._memoryConfigurationByResource.get(o.resource),h||(h=new b,this._memoryConfigurationByResource.set(o.resource,h))):h=this._memoryConfiguration,t===void 0?h.removeValue(r):h.setValue(r,t),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,t,o){const h=this.getConsolidateConfigurationModel(t,o),u=this.getFolderConfigurationModelForResource(t.resource,o),d=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,f=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),l=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),_=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),A=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),N=o?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,x=u?t.overrideIdentifier?u.freeze().override(t.overrideIdentifier).getValue(r):u.freeze().getValue(r):void 0,F=t.overrideIdentifier?d.override(t.overrideIdentifier).getValue(r):d.getValue(r),O=h.getValue(r),z=m.distinct(m.flatten(h.overrides.map($=>$.identifiers))).filter($=>h.getOverrideValue(r,$)!==void 0);return{defaultValue:f,userValue:l,userLocalValue:_,userRemoteValue:A,workspaceValue:N,workspaceFolderValue:x,memoryValue:F,value:O,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,user:l!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,workspaceFolder:x!==void 0?{value:u?.freeze().getValue(r),override:t.overrideIdentifier?u?.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:d.getValue(r),override:t.overrideIdentifier?d.getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(r){const t=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,t){this._folderConfigurations.set(r,t),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const o=[];if(!t){const{added:h,updated:u,removed:d}=g(this._defaultConfiguration,r);t=[...h,...u,...d]}for(const h of t)for(const u of(0,D.overrideIdentifiersFromKey)(h)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(u),f=r.getKeysForOverrideIdentifier(u),l=[...f.filter(_=>d.indexOf(_)===-1),...d.filter(_=>f.indexOf(_)===-1),...d.filter(_=>!I.equals(this._defaultConfiguration.override(u).getValue(_),r.override(u).getValue(_)))];o.push([u,l])}return this.updateDefaultConfiguration(r),{keys:t,overrides:o}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:o,removed:h,overrides:u}=g(this.localUserConfiguration,r),d=[...t,...o,...h];return d.length&&this.updateLocalUserConfiguration(r),{keys:d,overrides:u}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:o,removed:h,overrides:u}=g(this.remoteUserConfiguration,r);let d=[...t,...o,...h];return d.length&&this.updateRemoteUserConfiguration(r),{keys:d,overrides:u}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:o,removed:h,overrides:u}=g(this.workspaceConfiguration,r);let d=[...t,...o,...h];return d.length&&this.updateWorkspaceConfiguration(r),{keys:d,overrides:u}}compareAndUpdateFolderConfiguration(r,t){const o=this.folderConfigurations.get(r),{added:h,updated:u,removed:d,overrides:f}=g(o,t);let l=[...h,...u,...d];return(l.length||!o)&&this.updateFolderConfiguration(r,t),{keys:l,overrides:f}}compareAndDeleteFolderConfiguration(r){const t=this.folderConfigurations.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:h,removed:u,overrides:d}=g(t,void 0);return{keys:[...o,...h,...u],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,t){let o=this.getConsolidatedConfigurationModelForResource(r,t);return r.overrideIdentifier?o.override(r.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:r},t){let o=this.getWorkspaceConsolidatedConfiguration();if(t&&r){const h=t.getFolder(r);h&&(o=this.getFolderConsolidatedConfiguration(h.uri)||o);const u=this._memoryConfigurationByResource.get(r);u&&(o=o.merge(u))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let t=this._foldersConsolidatedConfigurations.get(r);if(!t){const o=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(r);h?(t=o.merge(h),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(r,t)):t=o}return t}getFolderConfigurationModelForResource(r,t){if(t&&r){const o=t.getFolder(r);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,t)=>{const{contents:o,overrides:h,keys:u}=this._folderConfigurations.get(t);return r.push([t,{contents:o,overrides:h,keys:u}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>r.add(t)),this.userConfiguration.freeze().keys.forEach(t=>r.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(h=>t.add(h))),[...t.values()]}static parse(r){const t=this.parseConfigurationModel(r.defaults),o=this.parseConfigurationModel(r.user),h=this.parseConfigurationModel(r.workspace),u=r.folders.reduce((d,f)=>(d.set(P.URI.revive(f[0]),this.parseConfigurationModel(f[1])),d),new T.ResourceMap);return new R(t,o,new b,h,u,new b,new T.ResourceMap,!1)}static parseConfigurationModel(r){return new b(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=R;function S(...E){if(E.length===0)return{keys:[],overrides:[]};if(E.length===1)return E[0];const r=new Set,t=new Map;for(const h of E)h.keys.forEach(u=>r.add(u)),h.overrides.forEach(([u,d])=>{const f=(0,T.getOrSet)(t,u,new Set);d.forEach(l=>f.add(l))});const o=[];return t.forEach((h,u)=>o.push([u,[...h.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=S;class s{constructor(r,t,o,h){this.change=r,this.previous=t,this.currentConfiguraiton=o,this.currentWorkspace=h,this._previousConfiguration=void 0;const u=new Set;r.keys.forEach(f=>u.add(f)),r.overrides.forEach(([,f])=>f.forEach(l=>u.add(l))),this.affectedKeys=[...u.values()];const d=new b;this.affectedKeys.forEach(f=>d.setValue(f,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=R.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(t){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(r,t,this.currentWorkspace);return!I.equals(o,h)}return!0}return!1}doesAffectedKeysTreeContains(r,t){let o=(0,L.toValuesTree)({[t]:!0},()=>{}),h;for(;typeof o=="object"&&(h=Object.keys(o)[0]);){if(r=r[h],!r)return!1;o=o[h]}return!0}}e.ConfigurationChangeEvent=s;class n extends s{constructor(r,t,o,h){super({keys:r.allKeys(),overrides:[]},void 0,r,t);this.source=o,this.sourceConfig=h}}e.AllKeysConfigurationChangeEvent=n;function g(E,r){const{added:t,removed:o,updated:h}=a(r,E),u=[],d=E?.getAllOverrideIdentifiers()||[],f=r?.getAllOverrideIdentifiers()||[];if(r){const l=f.filter(_=>!d.includes(_));for(const _ of l)u.push([_,r.getKeysForOverrideIdentifier(_)])}if(E){const l=d.filter(_=>!f.includes(_));for(const _ of l)u.push([_,E.getKeysForOverrideIdentifier(_)])}if(r&&E){for(const l of d)if(f.includes(l)){const _=a({contents:E.getOverrideValue(void 0,l)||{},keys:E.getKeysForOverrideIdentifier(l)},{contents:r.getOverrideValue(void 0,l)||{},keys:r.getKeysForOverrideIdentifier(l)});u.push([l,[..._.added,..._.removed,..._.updated]])}}return{added:t,removed:o,updated:h,overrides:u}}function a(E,r){const t=E?r?E.keys.filter(u=>r.keys.indexOf(u)===-1):[...E.keys]:[],o=r?E?r.keys.filter(u=>E.keys.indexOf(u)===-1):[...r.keys]:[],h=[];if(E&&r){for(const u of r.keys)if(E.keys.indexOf(u)!==-1){const d=(0,L.getConfigurationValue)(r.contents,u),f=(0,L.getConfigurationValue)(E.contents,u);I.equals(d,f)||h.push(u)}}return{added:t,removed:o,updated:h}}}),define(ve[120],we([0,1,4]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var i;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(i=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(T,I=i.Unknown,y){super(T);this._message=T,this._code=I,this._detail=y,this.isHandled=I===i.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(T){return T instanceof k&&T._code===i.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof k&&T._code===i.NoResolverFound}static isHandled(T){return T instanceof k&&T.isHandled}}e.RemoteAuthorityResolverError=k}),define(ve[63],we([0,1,10]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function i(P){return P.scheme===m.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=i;function k(P){if(!P)return;const L=P.indexOf("+");return L<0?P:P.substr(0,L)}e.getRemoteName=k;function C(P){return P.scheme!==m.Schemas.file&&P.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=C;function T(P){if(P.folders.length)return P.folders.every(L=>C(L.uri))?P.folders[0].uri:void 0;if(P.configuration&&C(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=T;function I(P){return T(P)?.scheme}e.getVirtualWorkspaceScheme=I;function y(P){return T(P)!==void 0}e.isVirtualWorkspace=y}),define(ve[27],we([0,1,9,4,63]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.getWorkspaceSupportTypeMessage=C;function T(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class y{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,p){if(typeof b=="undefined"||b===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof b=="string"||typeof p=="string"){let v=typeof b=="string"?b:b.value,w=typeof p=="string"?p:p.value;return m.equalsIgnoreCase(v,w)}return b._lower===p._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=y;function P(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function L(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=L;function D(c,b){if(b){const p=`onResolveRemoteAuthority:${(0,k.getRemoteName)(b)}`;return c.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=D,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[194],we([0,1,9,27]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(p,v){return p.uuid&&v.uuid?p.uuid===v.uuid:p.id===v.id?!0:(0,m.compareIgnoreCase)(p.id,v.id)===0}e.areSameExtensions=k;class C{constructor(v,w){this.version=w,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof C?k(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=C;function T(p,v){return`${p}.${v}`}e.getExtensionId=T;function I(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function y(p,v){return I(T(p,v))}e.getGalleryExtensionId=y;function P(p,v){const w=[],R=S=>{for(const s of w)if(s.some(n=>k(v(n),v(S))))return s;return null};for(const S of p){const s=R(S);s?s.push(S):w.push([S])}return w}e.groupByExtension=P;function L(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=L;function D(p){return{id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,isPreReleaseVersion:p.properties.isPreReleaseVersion,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0),...p.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new i.ExtensionIdentifier("pprice.better-merge");function c(p){const v=new Set;if(p.malicious)for(const w of p.malicious)v.add(w.id);return v}e.getMaliciousExtensionsSet=c;function b(p,v){const w=[],R=v.manifest.extensionDependencies?.slice(0)??[];for(;R.length;){const S=R.shift();if(S&&w.every(s=>!k(s.identifier,{id:S}))){const s=p.filter(n=>k(n.identifier,{id:S}));s.length===1&&(w.push(s[0]),R.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=b}),define(ve[121],we([0,1,3,12,4,11]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var T;(function(p){p.Http="http",p.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=D;function c(p,v){return v?v!==1&&p<1024:!i.isWindows&&p<1024}e.isPortPrivileged=c;let b=class{constructor(v){this.logService=v,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v,w){return this._tunnelProvider=v,v?(this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],w=Array.from(this._tunnels.values());for(let R of w){const S=Array.from(R.values());for(let s of S){const n=await s.value;n&&v.push(n)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:w}of v.values())await w.then(R=>R?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,w,R,S,s=!1,n=I.Private,g){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${R} on local port ${S}.`),!v)return;w||(w="localhost");const a=this.retainOrCreateTunnel(v,w,R,S,s,n,g);return a?a.then(E=>{if(!E){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(w,R);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(E);return(E.tunnelRemoteHost!==w||E.tunnelRemotePort!==R)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const w=this._tunnels.get(v.tunnelRemoteHost);if(w){const R=w.get(v.tunnelRemotePort);R&&(R.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,R))}}}}async tryDisposeTunnel(v,w,R){if(R.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${w}.`);const S=R.value.then(async s=>{s&&(await s.dispose(!0),this._onTunnelClosed.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(w),S}}async closeTunnel(v,w){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${w} `);const R=this._tunnels.get(v);if(R&&R.has(w)){const S=R.get(w);S.refcount=0,await this.tryDisposeTunnel(v,w,S)}}addTunnelToMap(v,w,R){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(w,{refcount:1,value:R})}async removeEmptyTunnelFromMap(v,w){const R=this._tunnels.get(v);R&&(await R.get(w)||R.delete(w),R.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,w){let R=[v];L(v)?(R.push(...e.LOCALHOST_ADDRESSES),R.push(...e.ALL_INTERFACES_ADDRESSES)):D(v)&&R.push(...e.ALL_INTERFACES_ADDRESSES);const S=R.map(s=>this._tunnels.get(s));for(const s of S){const n=s?.get(w);if(n)return n}}canTunnel(v){return!!P(v)}createWithProvider(v,w,R,S,s,n,g){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${R} on local port ${S}.`);const E={elevationRequired:s?c(S===void 0?R:S):!1},r={remoteAddress:{host:w,port:R},localAddressPort:S,privacy:n,public:n!==I.Private,protocol:g},t=v.forwardPort(r,E);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(w,R,t),t}};b=je([He(0,C.ILogService)],b),e.AbstractTunnelService=b}),define(ve[195],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{constructor(){this.validators=new Map}vsda(){return new Promise((k,C)=>X(["vsda"],k,C))}async createNewMessage(k){try{const C=await this.vsda(),T=new C.validator;if(T){const I=String(m._nextId++);return this.validators.set(I,T),{id:I,data:T.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,C){if(!k.id)return!0;const T=this.validators.get(k.id);if(!T)return!1;this.validators.delete(k.id);try{return T.validate(C)==="ok"}catch{return!1}}async sign(k){try{const C=await this.vsda(),T=new C.signer;if(T)return T.sign(k)}catch{}return k}}e.SignService=m,m._nextId=1}),define(ve[196],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,C,T=5){let I;return I=C(y=>{const P=typeof y=="string"?y:y.data;let L=this._terminalBufferMap.get(k);if(L){L.data.push(P);return}const D=setTimeout(()=>this.flushBuffer(k),T);L={data:[P],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(k),I.dispose()}},this._terminalBufferMap.set(k,L)}),I}stopBuffering(k){const C=this._terminalBufferMap.get(k);C&&C.dispose()}flushBuffer(k){const C=this._terminalBufferMap.get(k);C&&(this._terminalBufferMap.delete(k),this._callback(k,C.data.join("")))}}e.TerminalDataBufferer=m}),define(ve[197],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(i){i.DARK="dark",i.LIGHT="light",i.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(ve[86],we([0,1,74,3,6,4,51,197]),function(X,e,m,i,k,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var y;(function(w){function R(S){return S&&typeof S=="object"&&typeof S.id=="string"}w.isThemeColor=R})(y=e.ThemeColor||(e.ThemeColor={}));function P(w){return{id:w}}e.themeColorFromId=P;var L;(function(w){function R(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}w.isThemeIcon=R;const S=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function s(t){const o=S.exec(t);if(!o)return;let[,h]=o;return{id:h}}w.fromString=s;function n(t){return{id:t}}w.fromId=n;function g(t,o){let h=t.id;const u=h.lastIndexOf("~");return u!==-1&&(h=h.substring(0,u)),o&&(h=`${h}~${o}`),{id:h}}w.modify=g;function a(t){const o=t.id.lastIndexOf("~");if(o!==-1)return t.id.substring(o+1)}w.getModifier=a;function E(t,o){return t.id===o.id&&t.color?.id===o.color?.id}w.isEqual=E;function r(t,o){return{id:t.id,color:o?P(o):void 0}}w.asThemeIcon=r,w.asClassNameArray=m.CSSIcon.asClassNameArray,w.asClassName=m.CSSIcon.asClassName,w.asCSSSelector=m.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function D(w){switch(w){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=D,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(R){return this.themingParticipants.push(R),this.onThemingParticipantAddedEmitter.fire(R),(0,k.toDisposable)(()=>{const S=this.themingParticipants.indexOf(R);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new c;T.Registry.add(e.Extensions.ThemingContribution,b);function p(w){return b.onColorThemeChange(w)}e.registerThemingParticipant=p;class v extends k.Disposable{constructor(R){super();this.themeService=R,this.theme=R.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(R){this.theme=R,this.updateStyles()}updateStyles(){}getColor(R,S){let s=this.theme.getColor(R);return s&&S&&(s=S(s,this.theme)),s?s.toString():null}}e.Themable=v}),define(ve[43],we([0,1,24,23,2,4]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var T;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function I(c){const b=c;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=I;function y(c){const b=c;return!!(b&&typeof b=="object"&&k.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=y;class P{constructor(b,p,v,w,R){this._id=b,this._transient=v,this._configuration=w,this._ignorePathCasing=R,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=p}update(b){this._id=b.id,this._configuration=b.configuration,this._transient=b.transient,this._ignorePathCasing=b._ignorePathCasing,this.folders=b.folders}get folders(){return this._folders}set folders(b){this._folders=b,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(b){this._configuration=b}getFolder(b){return b&&this._foldersMap.findSubstr(b.with({scheme:b.scheme,authority:b.authority,path:b.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const b of this.folders)this._foldersMap.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class L{constructor(b,p){this.raw=p,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,i.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=L;function D(c){return new L({uri:c,index:0,name:(0,i.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=D}),define(ve[198],we([0,1,28,58,140,81,10,8,12,23,2,162,4,63,43]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(M){return(typeof M=="string"?(0,I.extname)(M):(0,P.extname)(M))===v}e.hasWorkspaceFileExtension=w,e.IWorkspacesService=(0,c.createDecorator)("workspacesService");function R(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=R;function S(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=S;function s(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=s;function n(M){return M&&M.hasOwnProperty("folderUri")}e.isFolderBackupInfo=n;function g(M){return M&&M.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=g;function a(M){const B=M;return typeof B?.id=="string"&&L.URI.isUri(B.uri)}e.isSingleFolderWorkspaceIdentifier=a;function E(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=E;function r(M){const B=M;return typeof B?.id=="string"&&L.URI.isUri(B.configPath)}e.isWorkspaceIdentifier=r;function t(M){const B=M;if(B?.uri)return{id:B.id,uri:L.URI.revive(B.uri)};const W=M;if(W?.configPath)return{id:W.id,configPath:L.URI.revive(W.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=t;function o(M,B){return P.extUriBiasedIgnorePathCase.isEqualOrParent(M,B.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function h(M){return u(M)||d(M)}e.isStoredWorkspaceFolder=h;function u(M){const B=M;return typeof B?.path=="string"&&(!B.name||typeof B.name=="string")}e.isRawFileWorkspaceFolder=u;function d(M){const B=M;return typeof B?.uri=="string"&&(!B.name||typeof B.name=="string")}e.isRawUriWorkspaceFolder=d;function f(M,B,W,U,j=!y.isWindows,Z){if(M.scheme!==U.scheme)return{name:W,uri:M.toString(!0)};let ce=B?void 0:Z.relativePath(U,M);if(ce!==void 0)ce.length===0?ce=".":y.isWindows&&M.scheme===T.Schemas.file&&!j&&(ce=ce.replace(/\//g,"\\"));else if(M.scheme===T.Schemas.file)ce=M.fsPath,y.isWindows&&(ce=(0,C.normalizeDriveLetter)(ce),j&&(ce=(0,m.toSlashes)(ce)));else{if(!Z.isEqualAuthority(M.authority,U.authority))return{name:W,uri:M.toString(!0)};ce=M.path}return{name:W,path:ce}}e.getStoredWorkspaceFolder=f;function l(M,B,W){let U=[],j=new Set;const Z=W.dirname(B);for(let ce of M){let Q;if(u(ce))ce.path&&(Q=W.resolvePath(Z,ce.path));else if(d(ce))try{Q=L.URI.parse(ce.uri),Q.path[0]!=="/"&&(Q=Q.with({path:"/"+Q.path}))}catch(V){console.warn(V)}if(Q){let V=W.getComparisonKey(Q);if(!j.has(V)){j.add(V);const te=ce.name||W.basenameOrAuthority(Q);U.push(new p.WorkspaceFolder({uri:Q,name:te,index:U.length},ce))}}}return U}e.toWorkspaceFolders=l;function _(M,B,W,U,j){let Z=A(B,M);const ce=j.dirname(B),Q=j.dirname(U),V=[],te=N(Z.folders);for(const Be of Z.folders){const xe=u(Be)?j.resolvePath(ce,Be.path):L.URI.parse(Be.uri);let q;W?q=!1:q=!u(Be)||(0,I.isAbsolute)(Be.path),V.push(f(xe,q,Be.name,Q,te,j))}const me={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},ge=k.setProperty(M,["folders"],V,me);let ke=k.applyEdits(M,ge);return(0,P.isEqualAuthority)(Z.remoteAuthority,(0,b.getRemoteAuthority)(U))&&(ke=k.applyEdits(ke,k.removeProperty(ke,["remoteAuthority"],me))),ke}e.rewriteWorkspaceFileForNewLocation=_;function A(M,B){let W=i.parse(B);if(W&&Array.isArray(W.folders))W.folders=W.folders.filter(U=>h(U));else throw new Error(`${M} looks like an invalid workspace file.`);return W}function N(M){return y.isWindows?M.some(B=>u(B)&&B.path.indexOf("/")>=0):!0}e.useSlashForPath=N;function x(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function F(M){return typeof M.folderUri=="string"}function O(M){return typeof M.fileUri=="string"}function z(M,B){const W={workspaces:[],files:[]};if(M){const U=function(Z,ce){for(let Q=0;Q<Z.length;Q++)try{ce(Z[Q],Q)}catch(V){B.warn(`Error restoring recent entry ${JSON.stringify(Z[Q])}: ${V.toString()}. Skip entry.`)}},j=M;if(Array.isArray(j.entries))U(j.entries,Z=>{const ce=Z.label,Q=Z.remoteAuthority;x(Z)?W.workspaces.push({label:ce,remoteAuthority:Q,workspace:{id:Z.workspace.id,configPath:L.URI.parse(Z.workspace.configPath)}}):F(Z)?W.workspaces.push({label:ce,remoteAuthority:Q,folderUri:L.URI.parse(Z.folderUri)}):O(Z)&&W.files.push({label:ce,remoteAuthority:Q,fileUri:L.URI.parse(Z.fileUri)})});else{const Z=M;Array.isArray(Z.workspaces3)&&U(Z.workspaces3,(ce,Q)=>{const V=Array.isArray(Z.workspaceLabels)&&Z.workspaceLabels[Q]||void 0;typeof ce=="object"&&typeof ce.id=="string"&&typeof ce.configURIPath=="string"?W.workspaces.push({label:V,workspace:{id:ce.id,configPath:L.URI.parse(ce.configURIPath)}}):typeof ce=="string"&&W.workspaces.push({label:V,folderUri:L.URI.parse(ce)})}),Array.isArray(Z.files2)&&U(Z.files2,(ce,Q)=>{const V=Array.isArray(Z.fileLabels)&&Z.fileLabels[Q]||void 0;typeof ce=="string"&&W.files.push({label:V,fileUri:L.URI.parse(ce)})})}}return W}e.restoreRecentlyOpened=z;function $(M){const B={entries:[]};for(const W of M.workspaces)S(W)?B.entries.push({folderUri:W.folderUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority}):B.entries.push({workspace:{id:W.workspace.id,configPath:W.workspace.configPath.toString()},label:W.label,remoteAuthority:W.remoteAuthority});for(const W of M.files)B.entries.push({fileUri:W.fileUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority});return B}e.toStoreData=$}),define(ve[87],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const C=this._idPool++;return this._data.set(C,k),this.logDebugInfo(),C}get(k,C){return this._data.has(k)?this._data.get(k)[C]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(ve[44],we([0,1,10,23,4]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new i.ExtUri(I=>{const y=this._providerInfo.get(I.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(I,y){y===null?this._providerInfo.delete(I.scheme):this._providerInfo.set(I.scheme,y)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(ve[26],we([0,1,4]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(ve[199],we([0,1,18]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class i{constructor(T,I,y){this._deferredPromises=new Map,this._id=T,this._shared=I,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of P.values())L.complete()}catch(L){for(const D of P.values())D.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,I){let y=this._value[T];return typeof y=="undefined"&&(y=I),y}update(T,I){this._value[T]=I;let y=this._deferredPromises.get(T);if(y!==void 0)return y.p;const P=new m.DeferredPromise;return this._deferredPromises.set(T,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=i;class k extends i{constructor(T,I){super(T.identifier.value,!0,I);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=k}),define(ve[200],we([0,1,3,2,11]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(I,y){this._logService=I,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,y,P){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(I)).acceptModelChanged(y.value,P)}$acceptDirtyStateChanged(I,y){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(I)).acceptDirty(y)}$acceptModelSaved(I){const y=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(I));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(I,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,y);const P=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(I));P.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};C=je([He(0,k.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(ve[14],we([0,1,4]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class i{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=i});var tt=this&&this.__classPrivateFieldSet||function(X,e,m,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,m):k?k.value=m:e.set(X,m),m},Le=this&&this.__classPrivateFieldGet||function(X,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(X):i?i.value:e.get(X)};define(ve[201],we([0,1,27,3]),function(X,e,m,i){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(I,y){k.set(this,void 0),this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(I.identifier),tt(this,k,y,"f"),Le(this,k,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(I){return Le(this,k,"f").get(this._id,I)}store(I,y){return Le(this,k,"f").store(this._id,I,y)}delete(I){return Le(this,k,"f").delete(this._id,I)}}e.ExtensionSecrets=C,k=new WeakMap}),define(ve[122],we([0,1,4,3]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new i.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(ve[64],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(S){S[S.Upsert=0]="Upsert",S[S.RemoveChild=1]="RemoveChild",S[S.Invalidated=2]="Invalidated",S[S.SetProp=3]="SetProp",S[S.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const i=new WeakMap,k=(S,s)=>{const n={controllerId:s};return i.set(S,n),n};e.createPrivateApiFor=k;const C=S=>i.get(S);e.getPrivateApiFor=C;const T=(S,s,n,g)=>{let a=n;return{enumerable:!0,configurable:!1,get(){return a},set(E){if(!g(a,E)){const r=a;a=E,S.listener?.({op:3,key:s,value:E,previous:r})}}}},I=(S,s)=>S===s,y={range:(S,s)=>S===s?!0:!S||!s?!1:S.isEqual(s),label:I,description:I,busy:I,error:I,canResolveChildren:I,tags:(S,s)=>!(S.length!==s.length||S.some(n=>!s.find(g=>n.id===g.id)))},P=Object.keys(y),L=(S,s)=>({range:T(S,"range",void 0,y.range),label:T(S,"label",s,y.label),description:T(S,"description",void 0,y.description),canResolveChildren:T(S,"canResolveChildren",!1,y.canResolveChildren),busy:T(S,"busy",!1,y.busy),error:T(S,"error",void 0,y.error),tags:T(S,"tags",[],y.tags)}),D=(S,s)=>{const n=new Map;for(const g of P)y[g](S[g],s[g])||n.set(g,s[g]);return n};e.diffTestItems=D;class c extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.DuplicateTestItemError=c;class b extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class p extends Error{constructor(s,n,g){super(`TestItem with ID "${s}" is from controller "${n}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=p;const v=S=>{const s=(0,e.getPrivateApiFor)(S);let n=new Map;return{get size(){return n.size},forEach(g,a){for(const E of n.values())g.call(a,E,this)},replace(g){const a=new Map,E=new Set(n.keys()),r={op:4,ops:[]};for(const t of g){if(!(t instanceof w))throw new b(t.id);const o=(0,e.getPrivateApiFor)(t).controllerId;if(o!==s.controllerId)throw new p(t.id,o,s.controllerId);if(a.has(t.id))throw new c(t.id);a.set(t.id,t),E.delete(t.id),r.ops.push({op:0,item:t})}for(const t of E.keys())r.ops.push({op:1,id:t});s.listener?.(r),n=a},add(g){if(!(g instanceof w))throw new b(g.id);n.set(g.id,g),s.listener?.({op:0,item:g})},delete(g){n.delete(g)&&s.listener?.({op:1,id:g})},get(g){return n.get(g)},toJSON(){return Array.from(n.values())},[Symbol.iterator](){return n.values()}}};class w{constructor(s,n,g,a){if(n.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(n)} symbol`);const E=(0,e.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:n,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return E.parent instanceof R?void 0:E.parent}},children:{value:v(this),enumerable:!0,writable:!1},...L(E,g)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=w;class R extends w{constructor(s,n){super(s,s,n,void 0)}}e.TestItemRootImpl=R}),define(ve[52],we([0,1,4,121,3,14]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(y){function P(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?i.TunnelPrivacyId.Public:i.TunnelPrivacyId.Private),protocol:D.protocol}}y.fromApiTunnel=P;function L(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==i.TunnelPrivacyId.ConstantPrivate&&D.privacy!==i.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}y.fromServiceTunnel=L})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let I=class{constructor(P){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,L){}async getTunnels(){return[]}async setTunnelExtensionFunctions(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,L){return{dispose:()=>{}}}async $providePortAttributes(P,L,D,c,b){return[]}async $forwardPort(P,L){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=je([He(0,C.IExtHostRpcService)],I),e.ExtHostTunnelService=I});var tt=this&&this.__classPrivateFieldSet||function(X,e,m,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,m):k?k.value=m:e.set(X,m),m},Le=this&&this.__classPrivateFieldGet||function(X,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(X):i?i.value:e.get(X)};define(ve[7],we([0,1,16,15,99,24,95,9,13,2,33,42,120]),function(X,e,m,i,k,C,T,I,y,P,L,D,c){"use strict";var b,p,v,w,R,S,s,n,g,a,E,r,t,o,h,u,d,f,l,_;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(G){function H(){return Reflect.construct(G,arguments,this.constructor)}return Object.defineProperty(H,"name",Object.getOwnPropertyDescriptor(G,"name")),Object.setPrototypeOf(H,G),Object.setPrototypeOf(H.prototype,G.prototype),H}let N=R=class{constructor(H){b.set(this,void 0),tt(this,b,H,"f")}static from(...H){let le=H;return new R(function(){if(le){for(const Pe of le)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();le=void 0}})}dispose(){typeof Le(this,b,"f")=="function"&&(Le(this,b,"f").call(this),tt(this,b,void 0,"f"))}};b=new WeakMap,N=R=je([A],N),e.Disposable=N;let x=S=class{constructor(H,le){if(H<0)throw(0,i.illegalArgument)("line must be non-negative");if(le<0)throw(0,i.illegalArgument)("character must be non-negative");this._line=H,this._character=le}static Min(...H){if(H.length===0)throw new TypeError;let le=H[0];for(let Pe=1;Pe<H.length;Pe++){const Ye=H[Pe];Ye.isBefore(le)&&(le=Ye)}return le}static Max(...H){if(H.length===0)throw new TypeError;let le=H[0];for(let Pe=1;Pe<H.length;Pe++){const Ye=H[Pe];Ye.isAfter(le)&&(le=Ye)}return le}static isPosition(H){if(!H)return!1;if(H instanceof S)return!0;let{line:le,character:Pe}=H;return typeof le=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<H._character}isBeforeOrEqual(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<=H._character}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this._line===H._line&&this._character===H._character}compareTo(H){return this._line<H._line?-1:this._line>H.line?1:this._character<H._character?-1:this._character>H._character?1:0}translate(H,le=0){if(H===null||le===null)throw(0,i.illegalArgument)();let Pe;return typeof H=="undefined"?Pe=0:typeof H=="number"?Pe=H:(Pe=typeof H.lineDelta=="number"?H.lineDelta:0,le=typeof H.characterDelta=="number"?H.characterDelta:0),Pe===0&&le===0?this:new S(this.line+Pe,this.character+le)}with(H,le=this.character){if(H===null||le===null)throw(0,i.illegalArgument)();let Pe;return typeof H=="undefined"?Pe=this.line:typeof H=="number"?Pe=H:(Pe=typeof H.line=="number"?H.line:this.line,le=typeof H.character=="number"?H.character:this.character),Pe===this.line&&le===this.character?this:new S(Pe,le)}toJSON(){return{line:this.line,character:this.character}}};x=S=je([A],x),e.Position=x;let F=s=class{constructor(H,le,Pe,Ye){let rt,lt;if(typeof H=="number"&&typeof le=="number"&&typeof Pe=="number"&&typeof Ye=="number"?(rt=new x(H,le),lt=new x(Pe,Ye)):H instanceof x&&le instanceof x&&(rt=H,lt=le),!rt||!lt)throw new Error("Invalid arguments");rt.isBefore(lt)?(this._start=rt,this._end=lt):(this._start=lt,this._end=rt)}static isRange(H){return H instanceof s?!0:H?x.isPosition(H.start)&&x.isPosition(H.end):!1}get start(){return this._start}get end(){return this._end}contains(H){return H instanceof s?this.contains(H._start)&&this.contains(H._end):H instanceof x?!(H.isBefore(this._start)||this._end.isBefore(H)):!1}isEqual(H){return this._start.isEqual(H._start)&&this._end.isEqual(H._end)}intersection(H){const le=x.Max(H.start,this._start),Pe=x.Min(H.end,this._end);if(!le.isAfter(Pe))return new s(le,Pe)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const le=x.Min(H.start,this._start),Pe=x.Max(H.end,this.end);return new s(le,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(H,le=this.end){if(H===null||le===null)throw(0,i.illegalArgument)();let Pe;return H?x.isPosition(H)?Pe=H:(Pe=H.start||this.start,le=H.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&le.isEqual(this.end)?this:new s(Pe,le)}toJSON(){return[this.start,this.end]}};F=s=je([A],F),e.Range=F;let O=n=class extends F{constructor(H,le,Pe,Ye){let rt,lt;if(typeof H=="number"&&typeof le=="number"&&typeof Pe=="number"&&typeof Ye=="number"?(rt=new x(H,le),lt=new x(Pe,Ye)):H instanceof x&&le instanceof x&&(rt=H,lt=le),!rt||!lt)throw new Error("Invalid arguments");super(rt,lt);this._anchor=rt,this._active=lt}static isSelection(H){return H instanceof n?!0:H?F.isRange(H)&&x.isPosition(H.anchor)&&x.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=n=je([A],O),e.Selection=O;class z{constructor(H,le,Pe){if(typeof H!="string"||H.length===0)throw(0,i.illegalArgument)("host");if(typeof le!="number"||le===0||Math.round(le)!==le)throw(0,i.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,i.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(le),this.connectionToken=Pe}}e.ResolvedAuthority=z;class $ extends Error{constructor(H,le=c.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(H);this._message=H,this._code=le,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(H,le){return new $(H,c.RemoteAuthorityResolverErrorCode.NotAvailable,le)}static TemporarilyNotAvailable(H){return new $(H,c.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var M;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(M=e.EndOfLine||(e.EndOfLine={}));var B;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(B=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let W=g=class{constructor(H,le){this._range=H,this._newText=le}static isTextEdit(H){return H instanceof g?!0:H?F.isRange(H)&&typeof H.newText=="string":!1}static replace(H,le){return new g(H,le)}static insert(H,le){return g.replace(new F(H,H),le)}static delete(H){return g.replace(H,"")}static setEndOfLine(H){const le=new g(new F(new x(0,0),new x(0,0)),"");return le.newEol=H,le}get range(){return this._range}set range(H){if(H&&!F.isRange(H))throw(0,i.illegalArgument)("range");this._range=H}get newText(){return this._newText||""}set newText(H){if(H&&typeof H!="string")throw(0,i.illegalArgument)("newText");this._newText=H}get newEol(){return this._newEol}set newEol(H){if(H&&typeof H!="number")throw(0,i.illegalArgument)("newEol");this._newEol=H}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};W=g=je([A],W),e.TextEdit=W;var U;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace"})(U=e.FileEditType||(e.FileEditType={}));let j=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(H,le,Pe,Ye){this._edits.push({_type:1,from:H,to:le,options:Pe,metadata:Ye})}createFile(H,le,Pe){this._edits.push({_type:1,from:void 0,to:H,options:le,metadata:Pe})}deleteFile(H,le,Pe){this._edits.push({_type:1,from:H,to:void 0,options:le,metadata:Pe})}replaceNotebookMetadata(H,le,Pe){this._edits.push({_type:3,metadata:Pe,uri:H,edit:{editType:5,metadata:le},notebookMetadata:le})}replaceNotebookCells(H,le,Pe,Ye,rt){let lt,ft,Tt=[],Ft;if(Ue.isNotebookRange(le)&&Ut.isNotebookCellDataArray(Pe)&&!Ut.isNotebookCellDataArray(Ye)?(lt=le.start,ft=le.end,Tt=Pe,Ft=Ye):typeof le=="number"&&typeof Pe=="number"&&Ut.isNotebookCellDataArray(Ye)&&(lt=le,ft=Pe,Tt=Ye,Ft=rt),lt===void 0||ft===void 0)throw new Error("Invalid arguments");(lt!==ft||Tt.length>0)&&this._edits.push({_type:5,uri:H,index:lt,count:ft-lt,cells:Tt,metadata:Ft})}replaceNotebookCellMetadata(H,le,Pe,Ye){this._edits.push({_type:3,metadata:Ye,uri:H,edit:{editType:8,index:le,metadata:Pe}})}replace(H,le,Pe,Ye){this._edits.push({_type:2,uri:H,edit:new W(le,Pe),metadata:Ye})}insert(H,le,Pe,Ye){this.replace(H,new F(le,le),Pe,Ye)}delete(H,le,Pe){this.replace(H,le,"",Pe)}has(H){return this._edits.some(le=>le._type===2&&le.uri.toString()===H.toString())}set(H,le){if(le)for(const Pe of le)Pe&&this._edits.push({_type:2,uri:H,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const Ye=this._edits[Pe];Ye._type===2&&Ye.uri.toString()===H.toString()&&(this._edits[Pe]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get(H){const le=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===H.toString()&&le.push(Pe.edit);return le}entries(){const H=new C.ResourceMap;for(let le of this._edits)if(le._type===2){let Pe=H.get(le.uri);Pe||(Pe=[le.uri,[]],H.set(le.uri,Pe)),Pe[1].push(le.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};j=je([A],j),e.WorkspaceEdit=j;let Z=a=class{constructor(H){this._tabstop=1,this.value=H||""}static isSnippetString(H){return H instanceof a?!0:H?typeof H.value=="string":!1}static _escape(H){return H.replace(/\$|}|\\/g,"\\$&")}appendText(H){return this.value+=a._escape(H),this}appendTabstop(H=this._tabstop++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,le=this._tabstop++){if(typeof H=="function"){const Pe=new a;Pe._tabstop=this._tabstop,H(Pe),this._tabstop=Pe._tabstop,H=Pe.value}else H=a._escape(H);return this.value+="${",this.value+=le,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,le=this._tabstop++){const Pe=H.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=le,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(H,le){if(typeof le=="function"){const Pe=new a;Pe._tabstop=this._tabstop,le(Pe),this._tabstop=Pe._tabstop,le=Pe.value}else typeof le=="string"&&(le=le.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,le&&(this.value+=":",this.value+=le),this.value+="}",this}};Z=a=je([A],Z),e.SnippetString=Z;var ce;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(ce=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let V=E=class{constructor(H,le){if(this.uri=H,le)if(le instanceof F)this.range=le;else if(le instanceof x)this.range=new F(le,le);else throw new Error("Illegal argument")}static isLocation(H){return H instanceof E?!0:H?F.isRange(H.range)&&P.URI.isUri(H.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};V=E=je([A],V),e.Location=V;let te=class{constructor(H,le){this.location=H,this.message=le}static is(H){return H?typeof H.message=="string"&&H.location&&F.isRange(H.location.range)&&P.URI.isUri(H.location.uri):!1}static isEqual(H,le){return H===le?!0:!H||!le?!1:H.message===le.message&&H.location.range.isEqual(le.location.range)&&H.location.uri.toString()===le.location.uri.toString()}};te=je([A],te),e.DiagnosticRelatedInformation=te;let me=class{constructor(H,le,Pe=Q.Error){if(!F.isRange(H))throw new TypeError("range must be set");if(!le)throw new TypeError("message must be set");this.range=H,this.message=le,this.severity=Pe}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,le){return H===le?!0:!H||!le?!1:H.message===le.message&&H.severity===le.severity&&H.code===le.code&&H.severity===le.severity&&H.source===le.source&&H.range.isEqual(le.range)&&(0,m.equals)(H.tags,le.tags)&&(0,m.equals)(H.relatedInformation,le.relatedInformation,te.isEqual)}};me=je([A],me),e.Diagnostic=me;let ge=class{constructor(H,le){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=le}};ge=je([A],ge),e.Hover=ge;var ke;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(ke=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Be=class{constructor(H,le=ke.Text){this.range=H,this.kind=le}toJSON(){return{range:this.range,kind:ke[this.kind]}}};Be=je([A],Be),e.DocumentHighlight=Be;var xe;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(xe=e.SymbolKind||(e.SymbolKind={}));var q;(function(G){G[G.Deprecated=1]="Deprecated"})(q=e.SymbolTag||(e.SymbolTag={}));let Y=r=class{constructor(H,le,Pe,Ye,rt){this.name=H,this.kind=le,this.containerName=rt,typeof Pe=="string"&&(this.containerName=Pe),Ye instanceof V?this.location=Ye:Pe instanceof F&&(this.location=new V(Ye,Pe)),r.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:xe[this.kind],location:this.location,containerName:this.containerName}}};Y=r=je([A],Y),e.SymbolInformation=Y;let re=t=class{constructor(H,le,Pe,Ye,rt){this.name=H,this.detail=le,this.kind=Pe,this.range=Ye,this.selectionRange=rt,this.children=[],t.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children&&H.children.forEach(t.validate)}};re=t=je([A],re),e.DocumentSymbol=re;var ue;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(ue=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let J=class{constructor(H,le){this.title=H,this.kind=le}};J=je([A],J),e.CodeAction=J;let ae=o=class{constructor(H){this.value=H}append(H){return new o(this.value?this.value+o.sep+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+o.sep)}};ae.sep=".",ae=o=je([A],ae),e.CodeActionKind=ae,ae.Empty=new ae(""),ae.QuickFix=ae.Empty.append("quickfix"),ae.Refactor=ae.Empty.append("refactor"),ae.RefactorExtract=ae.Refactor.append("extract"),ae.RefactorInline=ae.Refactor.append("inline"),ae.RefactorRewrite=ae.Refactor.append("rewrite"),ae.Source=ae.Empty.append("source"),ae.SourceOrganizeImports=ae.Source.append("organizeImports"),ae.SourceFixAll=ae.Source.append("fixAll");let Ee=class{constructor(H,le){if(this.range=H,this.parent=le,le&&!le.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=je([A],Ee),e.SelectionRange=Ee;class Oe{constructor(H,le,Pe,Ye,rt,lt){this.kind=H,this.name=le,this.detail=Pe,this.uri=Ye,this.range=rt,this.selectionRange=lt}}e.CallHierarchyItem=Oe;class Ve{constructor(H,le){this.fromRanges=le,this.from=H}}e.CallHierarchyIncomingCall=Ve;class Ke{constructor(H,le){this.fromRanges=le,this.to=H}}e.CallHierarchyOutgoingCall=Ke;var Je;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let it=class{constructor(H,le){this.range=H,this.command=le}get isResolved(){return!!this.command}};it=je([A],it),e.CodeLens=it;let at=h=class{constructor(H,le=!1){p.set(this,void 0),tt(this,p,new k.MarkdownString(H,{supportThemeIcons:le}),"f")}static isMarkdownString(H){return H instanceof h?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}get value(){return Le(this,p,"f").value}set value(H){Le(this,p,"f").value=H}get isTrusted(){return Le(this,p,"f").isTrusted}set isTrusted(H){Le(this,p,"f").isTrusted=H}get supportThemeIcons(){return Le(this,p,"f").supportThemeIcons}set supportThemeIcons(H){Le(this,p,"f").supportThemeIcons=H}get supportHtml(){return Le(this,p,"f").supportHtml}set supportHtml(H){Le(this,p,"f").supportHtml=H}appendText(H){return Le(this,p,"f").appendText(H),this}appendMarkdown(H){return Le(this,p,"f").appendMarkdown(H),this}appendCodeblock(H,le){return Le(this,p,"f").appendCodeblock(le??"",H),this}};p=new WeakMap,at=h=je([A],at),e.MarkdownString=at;let et=class{constructor(H,le){this.label=H,this.documentation=le}};et=je([A],et),e.ParameterInformation=et;let nt=class{constructor(H,le){this.label=H,this.documentation=le,this.parameters=[]}};nt=je([A],nt),e.SignatureInformation=nt;let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ct=je([A],ct),e.SignatureHelp=ct;var vt;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(vt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var We;(function(G){G[G.Other=0]="Other",G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(We=e.InlayHintKind||(e.InlayHintKind={}));let At=class{constructor(H,le,Pe){this.text=H,this.position=le,this.kind=Pe}};At=je([A],At),e.InlayHint=At;var ee;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ee=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ie;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(ie=e.CompletionItemKind||(e.CompletionItemKind={}));var Se;(function(G){G[G.Deprecated=1]="Deprecated"})(Se=e.CompletionItemTag||(e.CompletionItemTag={}));let ne=class{constructor(H,le){this.label=H,this.kind=le}toJSON(){return{label:this.label,kind:this.kind&&ie[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ne=je([A],ne),e.CompletionItem=ne;let Ce=class{constructor(H=[],le=!1){this.items=H,this.isIncomplete=le}};Ce=je([A],Ce),e.CompletionList=Ce;let Fe=class{constructor(H,le,Pe){this.text=H,this.range=le,this.command=Pe}};Fe=je([A],Fe),e.InlineSuggestion=Fe;let Ge=class{constructor(H){this.items=H}};Ge=je([A],Ge),e.InlineSuggestions=Ge;var ze;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(ze=e.ViewColumn||(e.ViewColumn={}));var ut;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ut=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Re;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(Re=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Te;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Te=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var De;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(De=e.TextEditorRevealType||(e.TextEditorRevealType={}));var se;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var fe;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(fe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var be;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(be=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function H(le){switch(le){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=H}(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let _e=class{constructor(H,le){if(le&&!P.URI.isUri(le))throw(0,i.illegalArgument)("target");if(!F.isRange(H)||H.isEmpty)throw(0,i.illegalArgument)("range");this.range=H,this.target=le}};_e=je([A],_e),e.DocumentLink=_e;let Ne=class{constructor(H,le,Pe,Ye){this.red=H,this.green=le,this.blue=Pe,this.alpha=Ye}};Ne=je([A],Ne),e.Color=Ne;let Qe=class{constructor(H,le){if(le&&!(le instanceof Ne))throw(0,i.illegalArgument)("color");if(!F.isRange(H)||H.isEmpty)throw(0,i.illegalArgument)("range");this.range=H,this.color=le}};Qe=je([A],Qe),e.ColorInformation=Qe;let $e=class{constructor(H){if(!H||typeof H!="string")throw(0,i.illegalArgument)("label");this.label=H}};$e=je([A],$e),e.ColorPresentation=$e;var Xe;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Xe=e.ColorFormat||(e.ColorFormat={}));var st;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(st=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ot{constructor(H,le,Pe){if(this.startIndex=H,this.length=le,this.tooltip=Pe,typeof H!="number"||H<0)throw(0,i.illegalArgument)("startIndex");if(typeof le!="number"||le<1)throw(0,i.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,i.illegalArgument)("tooltip")}}e.TerminalLink=ot;var he;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(he=e.TerminalLocation||(e.TerminalLocation={}));class ye{constructor(H){this.options=H,typeof H!="object"&&(0,i.illegalArgument)("options")}}e.TerminalProfile=ye;var de;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(de=e.TaskRevealKind||(e.TaskRevealKind={}));var K;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(K=e.TaskPanelKind||(e.TaskPanelKind={}));let Ie=u=class{constructor(H,le){if(this.label=le,typeof H!="string"||typeof le!="string")throw(0,i.illegalArgument)("name");this._id=H}static from(H){switch(H){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}get id(){return this._id}};Ie.Clean=new u("clean","Clean"),Ie.Build=new u("build","Build"),Ie.Rebuild=new u("rebuild","Rebuild"),Ie.Test=new u("test","Test"),Ie=u=je([A],Ie),e.TaskGroup=Ie;function Me(G){let H="";for(let le=0;le<G.length;le++)H+=G[le].replace(/,/g,",,")+",";return H}let Ze=class{constructor(H,le,Pe){if(typeof H!="string")throw(0,i.illegalArgument)("process");this._args=[],this._process=H,le!==void 0&&(Array.isArray(le)?(this._args=le,this._options=Pe):this._options=le)}get process(){return this._process}set process(H){if(typeof H!="string")throw(0,i.illegalArgument)("process");this._process=H}get args(){return this._args}set args(H){Array.isArray(H)||(H=[]),this._args=H}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("process"),this._process!==void 0&&H.push(this._process),this._args&&this._args.length>0)for(let le of this._args)H.push(le);return Me(H)}};Ze=je([A],Ze),e.ProcessExecution=Ze;let qe=class{constructor(H,le,Pe){if(this._args=[],Array.isArray(le)){if(!H)throw(0,i.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,i.illegalArgument)("command");this._command=H,this._args=le,this._options=Pe}else{if(typeof H!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=H,this._options=le}}get commandLine(){return this._commandLine}set commandLine(H){if(typeof H!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=H}get command(){return this._command?this._command:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,i.illegalArgument)("command");this._command=H}get args(){return this._args}set args(H){this._args=H||[]}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("shell"),this._commandLine!==void 0&&H.push(this._commandLine),this._command!==void 0&&H.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let le of this._args)H.push(typeof le=="string"?le:le.value);return Me(H)}};qe=je([A],qe),e.ShellExecution=qe;var ht;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(ht=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class Dt{constructor(H){this._callback=H}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(H){this._callback=H}get callback(){return this._callback}}e.CustomExecution=Dt;let bt=d=class{constructor(H,le,Pe,Ye,rt,lt){this.__deprecated=!1,this._definition=this.definition=H;let ft;typeof le=="string"?(this._name=this.name=le,this._source=this.source=Pe,this.execution=Ye,ft=rt,this.__deprecated=!0):le===Et.Global||le===Et.Workspace?(this.target=le,this._name=this.name=Pe,this._source=this.source=Ye,this.execution=rt,ft=lt):(this.target=le,this._name=this.name=Pe,this._source=this.source=Ye,this.execution=rt,ft=lt),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(H){this.__id=H}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof Dt?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(H){if(H==null)throw(0,i.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=H}get scope(){return this._scope}set target(H){this.clear(),this._scope=H}get name(){return this._name}set name(H){if(typeof H!="string")throw(0,i.illegalArgument)("name");this.clear(),this._name=H}get execution(){return this._execution}set execution(H){H===null&&(H=void 0),this.clear(),this._execution=H;const le=this._definition.type;(d.EmptyType===le||d.ProcessType===le||d.ShellType===le||d.ExtensionCallbackType===le)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(H){if(Array.isArray(H))this.clear(),this._problemMatchers=H,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.clear(),this._isBackground=H}get source(){return this._source}set source(H){if(typeof H!="string"||H.length===0)throw(0,i.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=H}get group(){return this._group}set group(H){H===null&&(H=void 0),this.clear(),this._group=H}get detail(){return this._detail}set detail(H){H===null&&(H=void 0),this._detail=H}get presentationOptions(){return this._presentationOptions}set presentationOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._presentationOptions=H}get runOptions(){return this._runOptions}set runOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._runOptions=H}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=d=je([A],bt),e.Task=bt;var mt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(mt=e.ProgressLocation||(e.ProgressLocation={}));let wt=class{constructor(H,le=_t.None){this.collapsibleState=le,P.URI.isUri(H)?this.resourceUri=H:this.label=H}};wt=je([A],wt),e.TreeItem=wt;var _t;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Mt=class{constructor(H){this._value=H}async asString(){return JSON.stringify(this._value)}};Mt=je([A],Mt),e.TreeDataTransferItem=Mt;let It=class{constructor(){this._items=new Map}get(H){return this._items.get(H)}set(H,le){this._items.set(H,le)}forEach(H){this._items.forEach(H)}};It=je([A],It),e.TreeDataTransfer=It;let Pt=class{constructor(H,le){this.id=H,this.color=le}};Pt=je([A],Pt),e.ThemeIcon=Pt,Pt.File=new Pt("file"),Pt.Folder=new Pt("folder");let Rt=class{constructor(H){this.id=H}};Rt=je([A],Rt),e.ThemeColor=Rt;var yt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(yt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ht=class{constructor(H,le){if(typeof H!="string"&&(!H||!P.URI.isUri(H)&&!P.URI.isUri(H.uri)))throw(0,i.illegalArgument)("base");if(typeof le!="string")throw(0,i.illegalArgument)("pattern");typeof H=="string"?(this.baseFolder=P.URI.file(H),this.base=H):P.URI.isUri(H)?(this.baseFolder=H,this.base=H.fsPath):(this.baseFolder=H.uri,this.base=H.uri.fsPath),this.pattern=le}};Ht=je([A],Ht),e.RelativePattern=Ht;let Ot=class{constructor(H,le,Pe,Ye){this.enabled=typeof H=="boolean"?H:!0,typeof le=="string"&&(this.condition=le),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};Ot=je([A],Ot),e.Breakpoint=Ot;let St=class extends Ot{constructor(H,le,Pe,Ye,rt){super(le,Pe,Ye,rt);if(H===null)throw(0,i.illegalArgument)("location");this.location=H}};St=je([A],St),e.SourceBreakpoint=St;let Qt=class extends Ot{constructor(H,le,Pe,Ye,rt){super(le,Pe,Ye,rt);this.functionName=H}};Qt=je([A],Qt),e.FunctionBreakpoint=Qt;let Vt=class extends Ot{constructor(H,le,Pe,Ye,rt,lt,ft){super(Ye,rt,lt,ft);if(!le)throw(0,i.illegalArgument)("dataId");this.label=H,this.dataId=le,this.canPersist=Pe}};Vt=je([A],Vt),e.DataBreakpoint=Vt;let Xt=class{constructor(H,le,Pe){this.command=H,this.args=le||[],this.options=Pe}};Xt=je([A],Xt),e.DebugAdapterExecutable=Xt;let oi=class{constructor(H,le){this.port=H,this.host=le}};oi=je([A],oi),e.DebugAdapterServer=oi;let Lt=class{constructor(H){this.path=H}};Lt=je([A],Lt),e.DebugAdapterNamedPipeServer=Lt;let Yt=class{constructor(H){this.implementation=H}};Yt=je([A],Yt),e.DebugAdapterInlineImplementation=Yt;let ai=class{constructor(H,le){this.range=H,this.expression=le}};ai=je([A],ai),e.EvaluatableExpression=ai;var Jt;(function(G){G[G.Automatic=0]="Automatic",G[G.Explicit=1]="Explicit"})(Jt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let zt=class{constructor(H,le){this.range=H,this.text=le}};zt=je([A],zt),e.InlineValueText=zt;let pt=class{constructor(H,le,Pe=!0){this.range=H,this.variableName=le,this.caseSensitiveLookup=Pe}};pt=je([A],pt),e.InlineValueVariableLookup=pt;let ci=class{constructor(H,le){this.range=H,this.expression=le}};ci=je([A],ci),e.InlineValueEvaluatableExpression=ci;let Nt=class{constructor(H,le){this.frameId=H,this.stoppedLocation=le}};Nt=je([A],Nt),e.InlineValueContext=Nt;var jt;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let Zt=f=class extends Error{constructor(H,le=D.FileSystemProviderErrorCode.Unknown,Pe){super(P.URI.isUri(H)?H.toString(!0):H);this.code=Pe?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,le),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(H){return new f(H,D.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(H){return new f(H,D.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(H){return new f(H,D.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(H){return new f(H,D.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(H){return new f(H,D.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(H){return new f(H,D.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}};Zt=f=je([A],Zt),e.FileSystemError=Zt;let li=class{constructor(H,le,Pe){this.start=H,this.end=le,this.kind=Pe}};li=je([A],li),e.FoldingRange=li;var fi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class ei{constructor(H,le=[]){this.tokenTypes=H,this.tokenModifiers=le}}e.SemanticTokensLegend=ei;function Si(G){return typeof G=="undefined"||(0,y.isStringArray)(G)}class qt{constructor(H){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,H){this._hasLegend=!0;for(let le=0,Pe=H.tokenTypes.length;le<Pe;le++)this._tokenTypeStrToInt.set(H.tokenTypes[le],le);for(let le=0,Pe=H.tokenModifiers.length;le<Pe;le++)this._tokenModifierStrToInt.set(H.tokenModifiers[le],le)}}push(H,le,Pe,Ye,rt){if(typeof H=="number"&&typeof le=="number"&&typeof Pe=="number"&&typeof Ye=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded(H,le,Pe,Ye,rt);if(F.isRange(H)&&typeof le=="string"&&Si(Pe))return this._push(H,le,Pe);throw(0,i.illegalArgument)()}_push(H,le,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(le))throw new Error("`tokenType` is not in the provided legend");const Ye=H.start.line,rt=H.start.character,lt=H.end.character-H.start.character,ft=this._tokenTypeStrToInt.get(le);let Tt=0;if(Pe)for(const Ft of Pe){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const Bt=this._tokenModifierStrToInt.get(Ft);Tt|=1<<Bt>>>0}this._pushEncoded(Ye,rt,lt,ft,Tt)}_pushEncoded(H,le,Pe,Ye,rt){if(this._dataIsSortedAndDeltaEncoded&&(H<this._prevLine||H===this._prevLine&&le<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Tt=this._data.length/5|0;let Ft=0,Bt=0;for(let xt=0;xt<Tt;xt++){let Wt=this._data[5*xt],di=this._data[5*xt+1];Wt===0?(Wt=Ft,di+=Bt):Wt+=Ft,this._data[5*xt]=Wt,this._data[5*xt+1]=di,Ft=Wt,Bt=di}}let lt=H,ft=le;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=rt,this._prevLine=H,this._prevChar=le}static _sortAndDeltaEncode(H){let le=[];const Pe=H.length/5|0;for(let ft=0;ft<Pe;ft++)le[ft]=ft;le.sort((ft,Tt)=>{const Ft=H[5*ft],Bt=H[5*Tt];if(Ft===Bt){const xt=H[5*ft+1],Wt=H[5*Tt+1];return xt-Wt}return Ft-Bt});const Ye=new Uint32Array(H.length);let rt=0,lt=0;for(let ft=0;ft<Pe;ft++){const Tt=5*le[ft],Ft=H[Tt+0],Bt=H[Tt+1],xt=H[Tt+2],Wt=H[Tt+3],di=H[Tt+4],$i=Ft-rt,Xi=$i===0?Bt-lt:Bt,hi=5*ft;Ye[hi+0]=$i,Ye[hi+1]=Xi,Ye[hi+2]=xt,Ye[hi+3]=Wt,Ye[hi+4]=di,rt=Ft,lt=Bt}return Ye}build(H){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),H):new Gt(qt._sortAndDeltaEncode(this._data),H)}}e.SemanticTokensBuilder=qt;class Gt{constructor(H,le){this.resultId=le,this.data=H}}e.SemanticTokens=Gt;class _i{constructor(H,le,Pe){this.start=H,this.deleteCount=le,this.data=Pe}}e.SemanticTokensEdit=_i;class Ci{constructor(H,le){this.resultId=le,this.edits=H}}e.SemanticTokensEdits=Ci;var Kt;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Kt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(G){G[G.Initial=1]="Initial",G[G.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ti=class{constructor(){}};ti.Back={iconPath:new Pt("arrow-left")},ti=je([A],ti),e.QuickInputButtons=ti;var Di;(function(G){G[G.Separator=-1]="Separator",G[G.Default=1]="Default"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(H,le,Pe){this.badge=H,this.tooltip=le,this.color=Pe}static validate(H){if(H.badge){let le=(0,I.nextCharLength)(H.badge,0);if(le<H.badge.length&&(le+=(0,I.nextCharLength)(H.badge,le)),H.badge.length>le)throw new Error("The 'badge'-property must be undefined or a short character")}if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ii=class{constructor(H){this.kind=H}};ii=je([A],ii),e.ColorTheme=ii;var gi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ue{constructor(H,le){if(H<0)throw(0,i.illegalArgument)("start must be positive");if(le<0)throw(0,i.illegalArgument)("end must be positive");H<=le?(this._start=H,this._end=le):(this._start=le,this._end=H)}static isNotebookRange(H){return H instanceof Ue?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(H){let le=this._start,Pe=this._end;return H.start!==void 0&&(le=H.start),H.end!==void 0&&(Pe=H.end),le===this._start&&Pe===this._end?this:new Ue(le,Pe)}}e.NotebookRange=Ue;class Ut{constructor(H,le,Pe,Ye,rt,lt,ft){this.kind=H,this.value=le,this.languageId=Pe,this.mime=Ye,this.outputs=rt??[],this.metadata=lt,this.executionSummary=ft,Ut.validate(this)}static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(le=>Ut.isNotebookCellData(le))}static isNotebookCellData(H){return!0}}e.NotebookCellData=Ut;class pi{constructor(H){this.cells=H}}e.NotebookData=pi;class gt{constructor(H,le){this.data=H,this.mime=le;const Pe=(0,T.normalizeMimeType)(le,!0);if(!Pe)throw new Error(`INVALID mime type: ${le}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem(H){return H instanceof gt?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const le={name:H.name,message:H.message,stack:H.stack};return gt.json(le,"application/vnd.code.notebook.error")}static stdout(H){return gt.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return gt.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,le="application/octet-stream"){return new gt(H,le)}static text(H,le=T.Mimes.text){const Pe=Le(gt,v,"f",w).encode(String(H));return new gt(Pe,le)}static json(H,le="application/json"){const Pe=JSON.stringify(H,void 0,"	");return gt.text(Pe,le)}}e.NotebookCellOutputItem=gt,v=gt,w={value:new TextEncoder};class ni{constructor(H,le,Pe){this.items=ni.ensureUniqueMimeTypes(H,!0),typeof le=="string"?(this.id=le,this.metadata=Pe):(this.id=(0,L.generateUuid)(),this.metadata=le??Pe)}static isNotebookCellOutput(H){return H instanceof ni?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&(0,y.isArray)(H.items)}static ensureUniqueMimeTypes(H,le=!1){const Pe=new Set,Ye=new Set;for(let rt=0;rt<H.length;rt++){const lt=H[rt],ft=(0,T.normalizeMimeType)(lt.mime);if(!Pe.has(ft)){Pe.add(ft);continue}Ye.add(rt),le&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ye.size===0?H:H.filter((rt,lt)=>!Ye.has(lt))}}e.NotebookCellOutput=ni;var Ii;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wi;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(H,le){this.text=H,this.alignment=le}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(H,le=[]){this.uri=H,this.provides=(0,m.asArray)(le)}}e.NotebookRendererScript=Ri;let ri=class{constructor(H,le){this.label=H,this.timestamp=le}};ri=je([A],ri),e.TimelineItem=ri;var Li;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(Li=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Mi;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Mi=e.StandardTokenType||(e.StandardTokenType={}));class Oi{constructor(H,le){this.ranges=H,this.wordPattern=le}}e.LinkedEditingRanges=Oi;class Ni{constructor(H,le){this._port=H,this._autoForwardAction=le}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var oe;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(oe=e.TestResultState||(e.TestResultState={}));var pe;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(pe=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ae=class{constructor(H=void 0,le=void 0,Pe=void 0){this.include=H,this.exclude=le,this.profile=Pe}};Ae=je([A],Ae),e.TestRunRequest=Ae;let dt=l=class{constructor(H){this.message=H}static diff(H,le,Pe){const Ye=new l(H);return Ye.expectedOutput=le,Ye.actualOutput=Pe,Ye}};dt=l=je([A],dt),e.TestMessage=dt;let Ct=class{constructor(H){this.id=H}};Ct=je([A],Ct),e.TestTag=Ct;let kt=class{constructor(H,le){this.covered=H,this.total=le}};kt=je([A],kt),e.CoveredCount=kt;let Ui=_=class{constructor(H,le,Pe,Ye){this.uri=H,this.statementCoverage=le,this.branchCoverage=Pe,this.functionCoverage=Ye}static fromDetails(H,le){const Pe=new kt(0,0),Ye=new kt(0,0),rt=new kt(0,0);for(const ft of le)if("branches"in ft){Pe.total+=1,Pe.covered+=ft.executionCount>0?1:0;for(const Tt of ft.branches)Ye.total+=1,Ye.covered+=Tt.executionCount>0?1:0}else rt.total+=1,rt.covered+=ft.executionCount>0?1:0;const lt=new _(H,Pe,Ye.total>0?Ye:void 0,rt.total>0?rt:void 0);return lt.detailedCoverage=le,lt}};Ui=_=je([A],Ui),e.FileCoverage=Ui;let Bi=class{constructor(H,le,Pe=[]){this.executionCount=H,this.location=le,this.branches=Pe}};Bi=je([A],Bi),e.StatementCoverage=Bi;let xi=class{constructor(H,le){this.executionCount=H,this.location=le}};xi=je([A],xi),e.BranchCoverage=xi;let Wi=class{constructor(H,le){this.executionCount=H,this.location=le}};Wi=je([A],Wi),e.FunctionCoverage=Wi;var qi;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(H,le,Pe,Ye,rt,lt){this.kind=H,this.name=le,this.detail=Pe,this.uri=Ye,this.range=rt,this.selectionRange=lt}}e.TypeHierarchyItem=Qi}),define(ve[123],we([0,1,56,10,9,150,110,7,16]),function(X,e,m,i,k,C,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function L(p,v){v?P.set(p,v):P.delete(p)}e.setWordDefinitionFor=L;function D(p){return P.get(p)}e.getWordDefinitionFor=D;class c extends C.MirrorTextModel{constructor(v,w,R,S,s,n,g,a){super(w,R,S,s);this._proxy=v,this._languageId=n,this._isDirty=g,this._notebook=a,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,y.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===i.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(w){return w?v._getTextInRange(w):v.getText()},get eol(){return v._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(w){return v._lineAt(w)},offsetAt(w){return v._offsetAt(w)},positionAt(w){return v._positionAt(w)},validateRange(w){return v._validateRange(w)},validatePosition(w){return v._validatePosition(w)},getWordRangeAtPosition(w,R){return v._getWordRangeAtPosition(w,R)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,m.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,m.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const w=this._validateRange(v);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const R=this._eol,S=w.start.line,s=w.end.line,n=[];n.push(this._lines[S].substring(w.start.character));for(let g=S+1;g<s;g++)n.push(this._lines[g]);return n.push(this._lines[s].substring(0,w.end.character)),n.join(R)}_lineAt(v){let w;if(v instanceof I.Position?w=v.line:typeof v=="number"&&(w=v),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new b(w,this._lines[w],w===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(v),R=this._lines[w.index].length;return new I.Position(w.index,Math.min(w.remainder,R))}_validateRange(v){if(!(v instanceof I.Range))throw new Error("Invalid argument");const w=this._validatePosition(v.start),R=this._validatePosition(v.end);return w===v.start&&R===v.end?v:new I.Range(w.line,w.character,R.line,R.character)}_validatePosition(v){if(!(v instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:w,character:R}=v,S=!1;if(w<0)w=0,R=0,S=!0;else if(w>=this._lines.length)w=this._lines.length-1,R=this._lines[w].length,S=!0;else{const s=this._lines[w].length;R<0?(R=0,S=!0):R>s&&(R=s,S=!0)}return S?new I.Position(w,R):v}_getWordRangeAtPosition(v,w){const R=this._validatePosition(v);if(!w)w=D(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const S=(0,T.getWordAtText)(R.character+1,(0,T.ensureValidWordDefinition)(w),this._lines[R.line],0);if(S)return new I.Range(R.line,S.startColumn-1,R.line,S.endColumn-1)}}e.ExtHostDocumentData=c;class b{constructor(v,w,R){this._line=v,this._text=w,this._isLastLine=R}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=b}),define(ve[202],we([0,1,7,3,112,6,83,24,2,33]),function(X,e,m,i,k,C,T,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class L{constructor(c,b,p,v){this._notebook=p,this._selector=v,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(b.onDidChangeDocument(R=>{const S=this._cellUris.get(R.document.uri);S!==void 0&&(this._cellLengths.setValue(S,this._cells[S].document.getText().length+1),this._cellLines.setValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=R=>{R===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(R=>w(R.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const c=[],b=[];for(const p of this._notebook.getCells())p.kind===m.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,p.document.uri,p.document.languageId,!0))&&(this._cellUris.set(p.document.uri,this._cells.length),this._cells.push(p),c.push(p.document.getText().length+1),b.push(p.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(b))}get version(){return this._versionId}getText(c){if(!c){let S="";for(const s of this._cells)S+=s.document.getText()+`
`;return S=S.slice(0,-1),S}if(c.isEmpty)return"";const b=this.locationAt(c.start),p=this.locationAt(c.end),v=this._cellUris.get(b.uri),w=this._cellUris.get(p.uri);if(v===void 0||w===void 0)return"";if(v===w)return this._cells[v].document.getText(new m.Range(b.range.start,p.range.end));const R=[this._cells[v].document.getText(new m.Range(b.range.start,new m.Position(this._cells[v].document.lineCount,0)))];for(let S=v+1;S<w;S++)R.push(this._cells[S].document.getText());return R.push(this._cells[w].document.getText(new m.Range(new m.Position(0,0),p.range.end))),R.join(`
`)}offsetAt(c){const b=this._cellLines.getIndexOf(c.line),p=this._cellLengths.getPrefixSum(b.index-1),v=this._cells[b.index].document.offsetAt(c.with(b.remainder));return p+v}positionAt(c){if(typeof c=="number"){const p=this._cellLengths.getIndexOf(c),v=this._cellLines.getPrefixSum(p.index-1);return this._cells[p.index].document.positionAt(p.remainder).translate(v)}const b=this._cellUris.get(c.uri);if(b!==void 0){const p=this._cellLines.getPrefixSum(b-1);return new m.Position(p+c.range.start.line,c.range.start.character)}return new m.Position(0,0)}locationAt(c){m.Range.isRange(c)||(c=new m.Range(c,c));const b=this._cellLines.getIndexOf(c.start.line);let p=b;c.isEmpty||(p=this._cellLines.getIndexOf(c.end.line));const v=new m.Position(b.remainder,c.start.character),w=new m.Position(p.remainder,c.end.character),R=new m.Range(v,w),S=this._cells[b.index];return new m.Location(S.document.uri,S.document.validateRange(R))}contains(c){return this._cellUris.has(c)}validateRange(c){const b=this.validatePosition(c.start),p=this.validatePosition(c.end);return c.with(b,p)}validatePosition(c){const b=this._cellLines.getIndexOf(c.line),p=new m.Position(b.remainder,c.character),v=this._cells[b.index].document.validatePosition(p),w=this._cellLines.getPrefixSum(b.index-1);return new m.Position(w+v.line,v.character)}}e.ExtHostNotebookConcatDocument=L}),define(ve[203],we([0,1,7,14,3]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(I){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let y=I==="light"?m.ColorThemeKind.Light:I==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=je([He(0,i.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(ve[65],we([0,1,4]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class i{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=i}),define(ve[204],we([0,1,22]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class i{constructor(){this.buffers=[]}add(y){let P=this.buffers.indexOf(y);return P<0&&(P=this.buffers.length,this.buffers.push(y)),P}}function k(I,y){if(y.serializeBuffersForPostMessage){const P=new i,L=(b,p)=>{if(p instanceof ArrayBuffer){const v=P.add(p);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(p)){const v=C(p);if(v){const w=P.add(p.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:v,byteLength:p.byteLength,byteOffset:p.byteOffset}}}}return p},D=JSON.stringify(I,L),c=P.buffers.map(b=>{const p=new Uint8Array(b);return m.VSBuffer.wrap(p)});return{message:D,buffers:c}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=k;function C(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(I,y){const P=y.map(c=>{const b=new ArrayBuffer(c.byteLength);return new Uint8Array(b).set(c.buffer),b}),L=y.length?(c,b)=>{if(typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const p=b,{index:v}=p,w=P[v];if(p.view)switch(p.view.type){case 1:return new Int8Array(w,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return b}:void 0;return{message:JSON.parse(I,L),arrayBuffers:P}}e.deserializeWebviewMessage=T}),define(ve[205],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(i){function k(T){const I=new Map;return T.types.forEach((y,P)=>{I.set(y,{asString:async()=>T.items[P].asString})}),I}i.toITreeDataTransfer=k;async function C(T){const I={types:[],items:[]},y=Array.from(T.entries());for(const P of y)I.types.push(P[0]),I.items.push({asString:await P[1].asString()});return I}i.toTreeDataTransferDTO=C})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ve[88],we([0,1,10,2]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(I,y){return I.scheme===m.Schemas.http||I.scheme===m.Schemas.https?I:(y&&y.authority&&y.isRemote&&I.scheme===m.Schemas.file&&(I=i.URI.from({scheme:m.Schemas.vscodeRemote,authority:y.authority,path:I.path})),i.URI.from({scheme:m.Schemas.https,authority:`${I.scheme}+${C(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=k;function C(I){return I.replace(/./g,y=>{const P=y.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?y:"-"+P.toString(16).padStart(4,"0")})}function T(I){return I.replace(/-([0-9a-f]{4})/g,(y,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=T}),define(ve[206],we([0,1,3,6,88]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(I,y,P){this._proxy=I,this._editors=y,this._initData=P,this._handlePool=0,this._disposables=new i.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const L=y.getVisibleTextEditors();for(const D of this._insets.values())L.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,y,P,L,D){let c;for(const s of this._editors.getVisibleTextEditors(!0))if(s.value===I){c=s;break}if(!c)throw new Error("not a visible editor");const b=this,p=this._handlePool++,v=new m.Emitter,w=new m.Emitter,R=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(s){return(0,k.asWebviewUri)(s,b._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(s){this._options=s,b._proxy.$setOptions(p,s)}get options(){return this._options}set html(s){this._html=s,b._proxy.$setHtml(p,s)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(s){return b._proxy.$postMessage(p,s)}},S=new class{constructor(){this.editor=I,this.line=y,this.height=P,this.webview=R,this.onDidDispose=w.event}dispose(){b._insets.has(p)&&(b._insets.delete(p),b._proxy.$disposeEditorInset(p),w.fire(),w.dispose(),v.dispose())}};return this._proxy.$createEditorInset(p,c.id,c.value.document.uri,y+1,P,L||{},D.identifier,D.extensionLocation),this._insets.set(p,{editor:I,inset:S,onDidReceiveMessage:v}),S}$onDidDispose(I){const y=this._insets.get(I);y&&y.inset.dispose()}$onDidReceiveMessage(I,y){const P=this._insets.get(I);P&&P.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=C}),define(ve[207],we([0,1,172,13,2,6,4,62,51,42,16,10]),function(X,e,m,i,k,C,T,I,y,P,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorTabsVisibleContext=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new I.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.SideBySideEditorActiveContext=new I.RawContextKey("sideBySideEditorActive",!1,(0,m.localize)(11,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,m.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(13,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(14,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(15,null)),e.ActiveEditorGroupLockedContext=new I.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(16,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,m.localize)(18,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,m.localize)(19,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,m.localize)(20,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(21,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,m.localize)(22,null)),e.EditorTabsVisibleContext=new I.RawContextKey("editorTabsVisible",!0,(0,m.localize)(23,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function c(F,O,z){for(const $ of z.visibleEditorPanes)if($.group.id===O&&F.matches($.input))return $.getViewState()}e.findViewStateForEditor=c;function b(F){if(g(F))return!1;const O=F;return k.URI.isUri(O?.resource)}e.isResourceEditorInput=b;function p(F){if(g(F))return!1;const O=F;return O?.original!==void 0&&O.modified!==void 0}e.isResourceDiffEditorInput=p;function v(F){if(g(F)||p(F))return!1;const O=F;return O?.primary!==void 0&&O.secondary!==void 0}e.isResourceSideBySideEditorInput=v;function w(F){if(g(F))return!1;const O=F;return O?O.resource===void 0||O.resource.scheme===D.Schemas.untitled||O.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=w;var R;(function(F){F[F.SHORT=0]="SHORT",F[F.MEDIUM=1]="MEDIUM",F[F.LONG=2]="LONG"})(R=e.Verbosity||(e.Verbosity={}));var S;(function(F){F[F.EXPLICIT=1]="EXPLICIT",F[F.AUTO=2]="AUTO",F[F.FOCUS_CHANGE=3]="FOCUS_CHANGE",F[F.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(S=e.SaveReason||(e.SaveReason={}));var s;(function(F){F[F.None=0]="None",F[F.Readonly=2]="Readonly",F[F.Untitled=4]="Untitled",F[F.Singleton=8]="Singleton",F[F.RequiresTrust=16]="RequiresTrust",F[F.CanSplitInGroup=32]="CanSplitInGroup",F[F.ForceDescription=64]="ForceDescription"})(s=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends C.Disposable{}e.AbstractEditorInput=n;function g(F){return F instanceof n}e.isEditorInput=g;function a(F){const O=F;return k.URI.isUri(O?.preferredResource)}function E(F){const O=F;return g(O?.primary)&&g(O?.secondary)}e.isSideBySideEditorInput=E;function r(F){const O=F;return g(O?.modified)&&g(O?.original)}e.isDiffEditorInput=r;function t(F){return g(F?.editor)}e.isEditorInputWithOptions=t;function o(F){const O=F;return t(F)&&O?.group!==void 0}e.isEditorInputWithOptionsAndGroup=o;function h(F){const O=F;return typeof O?.groupId=="number"&&g(O.editor)}e.isEditorIdentifier=h;var u;(function(F){F[F.UNKNOWN=0]="UNKNOWN",F[F.REPLACE=1]="REPLACE",F[F.MOVE=2]="MOVE",F[F.UNPIN=3]="UNPIN"})(u=e.EditorCloseContext||(e.EditorCloseContext={}));var d;(function(F){F[F.GROUP_ACTIVE=0]="GROUP_ACTIVE",F[F.GROUP_INDEX=1]="GROUP_INDEX",F[F.GROUP_LOCKED=2]="GROUP_LOCKED",F[F.EDITOR_OPEN=3]="EDITOR_OPEN",F[F.EDITOR_CLOSE=4]="EDITOR_CLOSE",F[F.EDITOR_MOVE=5]="EDITOR_MOVE",F[F.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",F[F.EDITOR_LABEL=7]="EDITOR_LABEL",F[F.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",F[F.EDITOR_PIN=9]="EDITOR_PIN",F[F.EDITOR_STICKY=10]="EDITOR_STICKY",F[F.EDITOR_DIRTY=11]="EDITOR_DIRTY",F[F.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(d=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var f;(function(F){F[F.PRIMARY=1]="PRIMARY",F[F.SECONDARY=2]="SECONDARY",F[F.BOTH=3]="BOTH",F[F.ANY=4]="ANY"})(f=e.SideBySideEditor||(e.SideBySideEditor={}));class l{getOriginalUri(O,z){if(!O)return;if(z?.supportSideBySide){const{primary:M,secondary:B}=this.getSideEditors(O);if(M&&B){if(z?.supportSideBySide===f.BOTH)return{primary:this.getOriginalUri(M,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(B,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===f.ANY)return this.getOriginalUri(M,{filterByScheme:z.filterByScheme})??this.getOriginalUri(B,{filterByScheme:z.filterByScheme});O=z.supportSideBySide===f.PRIMARY?M:B}}if(p(O)||v(O))return;const $=a(O)?O.preferredResource:O.resource;return!$||!z||!z.filterByScheme?$:this.filterUri($,z.filterByScheme)}getSideEditors(O){return E(O)||v(O)?{primary:O.primary,secondary:O.secondary}:r(O)||p(O)?{primary:O.modified,secondary:O.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(O,z){if(!O)return;if(z?.supportSideBySide){const{primary:M,secondary:B}=this.getSideEditors(O);if(M&&B){if(z?.supportSideBySide===f.BOTH)return{primary:this.getCanonicalUri(M,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(B,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===f.ANY)return this.getCanonicalUri(M,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(B,{filterByScheme:z.filterByScheme});O=z.supportSideBySide===f.PRIMARY?M:B}}if(p(O)||v(O))return;const $=O.resource;return!$||!z||!z.filterByScheme?$:this.filterUri($,z.filterByScheme)}filterUri(O,z){if(Array.isArray(z)){if(z.some($=>O.scheme===$))return O}else if(z===O.scheme)return O}}e.EditorResourceAccessor=new l;var _;(function(F){F[F.LEFT=0]="LEFT",F[F.RIGHT=1]="RIGHT"})(_=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(O){const z=this.instantiationService=O.get(T.IInstantiationService);for(const[$,M]of this.editorSerializerConstructors)this.createEditorSerializer($,M,z);this.editorSerializerConstructors.clear()}createEditorSerializer(O,z,$){const M=$.createInstance(z);this.editorSerializerInstances.set(O,M)}registerFileEditorFactory(O){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=O}getFileEditorFactory(){return(0,i.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(O,z){if(this.editorSerializerConstructors.has(O)||this.editorSerializerInstances.has(O))throw new Error(`A editor serializer with type ID '${O}' was already registered.`);return this.instantiationService?this.createEditorSerializer(O,z,this.instantiationService):this.editorSerializerConstructors.set(O,z),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(O),this.editorSerializerInstances.delete(O)})}getEditorSerializer(O){return this.editorSerializerInstances.get(typeof O=="string"?O:O.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new A);async function N(F,O){if(!F||!F.length)return[];const z=await Promise.all(F.map(async $=>{const M=k.URI.revive($.fileUri);if(!M||!await O.canHandleResource(M))return;let W=$.exists,U=$.type;if(typeof W!="boolean"||typeof U!="number")try{U=(await O.resolve(M)).isDirectory?P.FileType.Directory:P.FileType.Unknown,W=!0}catch{W=!1}if(!W&&$.openOnlyIfExists||U===P.FileType.Directory)return;const j={selection:W?$.selection:void 0,pinned:!0,override:$.editorOverrideId};let Z;return W?Z={resource:M,options:j}:Z={resource:M,options:j,forceUntitled:!0},Z}));return(0,L.coalesce)(z)}e.pathsToEditors=N;var x;(function(F){F[F.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",F[F.SEQUENTIAL=1]="SEQUENTIAL"})(x=e.EditorsOrder||(e.EditorsOrder={}))}),define(ve[124],we([0,1,3,18,173]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,y,P,L){const D={command:I};if(y&&Object.keys(y).length>0&&(D.arguments=y),this.internalSend("request",D),typeof L=="number"){const c=setTimeout(()=>{clearTimeout(c);const b=this.pendingRequests.get(D.seq);if(b){this.pendingRequests.delete(D.seq);const p={type:"response",seq:0,request_seq:D.seq,success:!1,command:I,message:(0,k.localize)(0,null,L,I)};b(p)}},L)}return P&&this.pendingRequests.set(D.seq,P),D.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,y){return I.type!=="event"||y.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,i.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":{const y=I,P=this.pendingRequests.get(y.request_seq);P&&(this.pendingRequests.delete(y.request_seq),P(y));break}}}}internalSend(I,y){y.type=I,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((y,P)=>I.set(P,y)),await(0,i.timeout)(500),I.forEach((y,P)=>{y({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(ve[208],we([0,1,9,2,8,25,10]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function y(r,t,o){return r.replace(I,function(h,u){return t&&u.length>0&&u[0]!=="_"?h:o&&o.hasOwnProperty(u)?o[u]:h})}e.formatPII=y;function P(r){const t={};for(const o of Object.keys(r))o.startsWith("!")||(t[o]=r[o]);return t}e.filterExceptionsFromTelemetry=P;function L(r){return r.configuration.request==="attach"&&!D(r)&&(!r.parentSession||L(r.parentSession))}e.isSessionAttach=L;function D(r){let t=r.configuration.type;if(!!t)return t==="vslsShare"&&(t=r.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(t,"extensionhost")||(0,m.equalsIgnoreCase)(t,"pwa-extensionhost")?r:r.parentSession?D(r.parentSession):void 0}e.getExtensionHostDebugSession=D;function c(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=c;function b(r,t,o){let h,u=0;const d=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=d.exec(r);){const l=f.index+1,_=l+f[0].length;if(l<=t&&_>=o){h=f[0],u=l;break}}if(h){const l=/\w+/g;let _=null;for(;(_=l.exec(h))&&!(_.index+1+u+_[0].length>=o););_&&(h=h.substring(0,l.lastIndex))}return h?{start:u,end:u+h.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(r){return!!(r&&r.match(p))}e.isUri=v;function w(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(v(r.path))return i.URI.parse(r.path);if((0,k.isAbsolute)(r.path))return i.URI.file(r.path)}return r.path}function R(r){if(typeof r.path=="object"){const t=i.URI.revive(r.path);if(t)return t.scheme===T.Schemas.file?t.fsPath:t.toString()}return r.path}function S(r,t){const o=t?w:R,h=(0,C.deepClone)(r);return n(h,(u,d)=>{u&&d&&(d.path=o(d))}),h}e.convertToDAPaths=S;function s(r,t){const o=t?w:R,h=(0,C.deepClone)(r);return n(h,(u,d)=>{!u&&d&&(d.path=o(d))}),h}e.convertToVSCPaths=s;function n(r,t){switch(r.type){case"event":{const o=r;switch(o.event){case"output":t(!1,o.body.source);break;case"loadedSource":t(!1,o.body.source);break;case"breakpoint":t(!1,o.body.breakpoint.source);break;default:break}break}case"request":{const o=r;switch(o.command){case"setBreakpoints":t(!0,o.arguments.source);break;case"breakpointLocations":t(!0,o.arguments.source);break;case"source":t(!0,o.arguments.source);break;case"gotoTargets":t(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(h=>t(!1,h));break;default:break}break}case"response":{const o=r;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(h=>t(!1,h.source));break;case"loadedSources":o.body.sources.forEach(h=>t(!1,h));break;case"scopes":o.body.scopes.forEach(h=>t(!1,h.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(h=>t(!1,h.source));break;case"setBreakpoints":o.body.breakpoints.forEach(h=>t(!1,h.source));break;default:break}break}}}function g(r){return r.filter(t=>!t.presentation?.hidden).sort((t,o)=>t.presentation?o.presentation?t.presentation.group?o.presentation.group?t.presentation.group!==o.presentation.group?t.presentation.group.localeCompare(o.presentation.group):a(t.presentation.order,o.presentation.order):-1:o.presentation.group?1:a(t.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=g;function a(r,t){return typeof r!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:r-t}async function E(r,t){const o=r.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(o!=="none"&&(await t.saveAll(),o==="allEditorsInActiveGroup")){const h=t.activeEditorPane;h&&h.input.resource?.scheme===T.Schemas.untitled&&await t.save({editor:h.input,groupId:h.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=E}),define(ve[209],we([0,1,29,37,174,125,8,9,25,12,184,124]),function(X,e,m,i,k,C,T,I,y,P,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends D.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(S,s){this.outputStream=s,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,S.on("data",n=>this.handleData(n))}sendMessage(S){if(this.outputStream){const s=JSON.stringify(S);this.outputStream.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${c.TWO_CRLF}${s}`,"utf8")}}handleData(S){for(this.rawData=Buffer.concat([this.rawData,S]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const s=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(n){this._onError.fire(new Error((n.message||n)+`
`+s))}continue}}else{const s=this.rawData.indexOf(c.TWO_CRLF);if(s!==-1){const g=this.rawData.toString("utf8",0,s).split(c.HEADER_LINESEPARATOR);for(const a of g){const E=a.split(c.HEADER_FIELDSEPARATOR);E[0]==="Content-Length"&&(this.contentLength=Number(E[1]))}this.rawData=this.rawData.slice(s+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class b extends c{startSession(){return new Promise((S,s)=>{let n=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),S(),n=!0}),this.socket.on("close",()=>{n?this._onError.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.socket.on("error",g=>{n?this._onError.fire(g):s(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=b;class p extends b{constructor(S){super();this.adapterServer=S}createConnection(S){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",S)}}e.SocketDebugAdapter=p;class v extends b{constructor(S){super();this.adapterServer=S}createConnection(S){return C.createConnection(this.adapterServer.path,S)}}e.NamedPipeDebugAdapter=v;class w extends c{constructor(S,s,n){super();this.adapterExecutable=S,this.debugType=s,this.outputService=n}async startSession(){const S=this.adapterExecutable.command,s=this.adapterExecutable.args,n=this.adapterExecutable.options||{};try{if(S)if(T.isAbsolute(S)){if(!await m.Promises.exists(S))throw new Error(k.localize(0,null,S))}else S.indexOf("/")<0&&S.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let g=process.env;if(n.env&&Object.keys(n.env).length>0&&(g=y.mixin(y.deepClone(process.env),n.env)),S==="node")if(Array.isArray(s)&&s.length>0){const E=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:g,execArgv:E?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(r.cwd=n.cwd);const t=i.fork(s[0],s.slice(1),r);if(!t.pid)throw new Error(k.localize(2,null,s[0]));this.serverProcess=t}else throw new Error(k.localize(3,null));else{const E={env:g};n.cwd&&(E.cwd=n.cwd),this.serverProcess=i.spawn(S,s,E)}this.serverProcess.on("error",E=>{this._onError.fire(E)}),this.serverProcess.on("exit",(E,r)=>{this._onExit.fire(E)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",E=>{this._onError.fire(E)}),this.serverProcess.stdin.on("error",E=>{this._onError.fire(E)});const a=this.outputService;if(a){const E=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const t=a.getChannel(L.ExtensionsChannelId);t&&t.append(E(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((S,s)=>{const n=i.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,a,E){if(g)return s(g)});n.on("exit",S),n.on("error",s)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(S,s){if(!S)return;const n=Object.create(null);S.runtime&&(S.runtime.indexOf("./")===0?n.runtime=T.join(s,S.runtime):n.runtime=S.runtime),S.runtimeArgs&&(n.runtimeArgs=S.runtimeArgs),S.program&&(T.isAbsolute(S.program)?n.program=S.program:n.program=T.join(s,S.program)),S.args&&(n.args=S.args);const g=S;return g.win&&(n.win=w.extract(g.win,s)),g.winx86&&(n.winx86=w.extract(g.winx86,s)),g.windows&&(n.windows=w.extract(g.windows,s)),g.osx&&(n.osx=w.extract(g.osx,s)),g.linux&&(n.linux=w.extract(g.linux,s)),n}static platformAdapterExecutable(S,s){let n=Object.create(null);s=s.toLowerCase();for(const o of S)if(o.contributes){const h=o.contributes.debuggers;h&&h.length>0&&h.filter(u=>typeof u.type=="string"&&I.equalsIgnoreCase(u.type,s)).forEach(u=>{const d=w.extract(u,o.extensionLocation.fsPath);n=y.mixin(n,d,o.isBuiltin)})}let g;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=n.winx86||n.win||n.windows:P.isWindows?g=n.win||n.windows:P.isMacintosh?g=n.osx:P.isLinux&&(g=n.linux),g=g||n;const a=g.program||n.program,E=g.args||n.args,r=g.runtime||n.runtime,t=g.runtimeArgs||n.runtimeArgs;if(r)return{type:"executable",command:r,args:(t||[]).concat(typeof a=="string"?[a]:[]).concat(E||[])};if(a)return{type:"executable",command:a,args:E||[]}}}e.ExecutableDebugAdapter=w}),define(ve[210],we([0,1,37,12,28,186]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(c,b){return new Promise((p,v)=>{let w="";const R=m.spawn(c,b);R.pid&&R.stdout.on("data",S=>{w+=S.toString()}),R.on("error",S=>{v(S)}),R.on("close",S=>{p(w)})})}let I;function y(c,b){if(!I)if(i.isWindows)I=new C.WindowsExternalTerminalService;else if(i.isMacintosh)I=new C.MacExternalTerminalService;else if(i.isLinux)I=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const p=b.getConfiguration("terminal");return I.runInTerminal(c.title,c.cwd,c.args,c.env||{},p.external||{})}e.runInExternalTerminal=y;async function P(c){if(c)if(i.isWindows){const b=await new Promise((p,v)=>{X(["windows-process-tree"],p,v)});return new Promise(p=>{b.getProcessTree(c,v=>{p(v.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(c)]).then(b=>{const p=b.trim();return!(p.length===0||p.indexOf(" tmux")>=0)},b=>!0);return Promise.resolve(!0)}e.hasChildProcesses=P;var L;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(L||(L={}));function D(c,b,p,v){c=c.trim().toLowerCase();let w;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?w=1:c.indexOf("cmd.exe")>=0?w=0:c.indexOf("bash")>=0?w=2:i.isWindows?w=0:w=2;let R,S=" ";switch(w){case 1:if(R=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),p){const s=(0,k.getDriveLetter)(p);s&&(S+=`${s}:; `),S+=`cd ${R(p)}; `}if(v)for(const s in v){const n=v[s];n===null?S+=`Remove-Item env:${s}; `:S+=`\${env:${s}}='${n}'; `}if(b.length>0){const s=R(b.shift());S+=s[0]==="'"?`& ${s} `:`${s} `;for(const n of b)S+=`${R(n)} `}break;case 0:if(R=s=>(s=s.replace(/\"/g,'""'),s.indexOf(" ")>=0||s.indexOf('"')>=0||s.length===0?`"${s}"`:s),p){const s=(0,k.getDriveLetter)(p);s&&(S+=`${s}: && `),S+=`cd ${R(p)} && `}if(v){S+='cmd /C "';for(const s in v){let n=v[s];n===null?S+=`set "${s}=" && `:(n=n.replace(/[\^\&\|\<\>]/g,g=>`^${g}`),S+=`set "${s}=${n}" && `)}}for(const s of b)S+=`${R(s)} `;v&&(S+='"');break;case 2:{R=n=>(n=n.replace(/(["'\\\$])/g,"\\$1"),n.indexOf(" ")>=0||n.indexOf(";")>=0||n.length===0?`"${n}"`:n);const s=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if(p&&(S+=`cd ${R(p)} ; `),v){S+="/usr/bin/env";for(const n in v){const g=v[n];g===null?S+=` -u ${s(n)}`:S+=` ${s(`${n}=${g}`)}`}S+=" "}for(const n of b)S+=`${R(n)} `;break}}return S}e.prepareCommand=D}),define(ve[126],we([0,1,32,78,95,10,8,12,62]),function(X,e,m,i,k,C,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(l){l[l.Markup=1]="Markup",l[l.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",k.Mimes.latex,k.Mimes.markdown,"image/png","image/jpeg",k.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[k.Mimes.latex,k.Mimes.markdown,"application/json",k.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var L;(function(l){l[l.Running=1]="Running",l[l.Idle=2]="Idle"})(L=e.NotebookRunState||(e.NotebookRunState={}));var D;(function(l){l[l.Pending=2]="Pending",l[l.Executing=3]="Executing"})(D=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var c;(function(l){l[l.WithHardKernelDependency=0]="WithHardKernelDependency",l[l.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",l[l.Pure=2]="Pure",l[l.Never=3]="Never"})(c=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(l){l.Always="always",l.Never="never",l.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(l){l[l.ModelChange=1]="ModelChange",l[l.Move=2]="Move",l[l.ChangeLanguage=5]="ChangeLanguage",l[l.Initialize=6]="Initialize",l[l.ChangeCellMetadata=7]="ChangeCellMetadata",l[l.Output=8]="Output",l[l.OutputItem=9]="OutputItem",l[l.ChangeCellContent=10]="ChangeCellContent",l[l.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",l[l.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",l[l.ChangeCellMime=13]="ChangeCellMime",l[l.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var v;(function(l){l[l.Handle=0]="Handle",l[l.Index=1]="Index"})(v=e.SelectionStateType||(e.SelectionStateType={}));var w;(function(l){l[l.Replace=1]="Replace",l[l.Output=2]="Output",l[l.Metadata=3]="Metadata",l[l.CellLanguage=4]="CellLanguage",l[l.DocumentMetadata=5]="DocumentMetadata",l[l.Move=6]="Move",l[l.OutputItems=7]="OutputItems",l[l.PartialMetadata=8]="PartialMetadata",l[l.PartialInternalMetadata=9]="PartialInternalMetadata"})(w=e.CellEditType||(e.CellEditType={}));var R;(function(l){l.scheme=C.Schemas.vscodeNotebookCell;const _=/^ch(\d{7,})/;function A($,M){return $.with({scheme:l.scheme,fragment:`ch${M.toString().padStart(7,"0")}${$.scheme!==C.Schemas.file?$.scheme:""}`})}l.generate=A;function N($){if($.scheme!==l.scheme)return;const M=_.exec($.fragment);return M?{handle:Number(M[1]),notebook:$.with({scheme:$.fragment.substring(M[0].length)||C.Schemas.file,fragment:null})}:void 0}l.parse=N;function x($,M,B){return $.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`ch${M.toString().padStart(7,"0")},${B??""},${$.scheme!==C.Schemas.file?$.scheme:""}`})}l.generateCellOutputUri=x;function F($){if($.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const M=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($.fragment);if(!M)return;const B=Number(M[1]),W=M[2]&&M[2]!==""?M[2]:void 0,U=M[3];return{handle:B,outputId:W,notebook:$.with({scheme:U||C.Schemas.file,fragment:null})}}l.parseCellOutputUri=F;function O($,M,B){return $.with({scheme:B,fragment:`ch${M.toString().padStart(7,"0")}${$.scheme!==C.Schemas.file?$.scheme:""}`})}l.generateCellUri=O;function z($,M){if($.scheme!==M)return;const B=_.exec($.fragment);return B?{handle:Number(B[1]),notebook:$.with({scheme:$.fragment.substring(B[0].length)||C.Schemas.file,fragment:null})}:void 0}l.parseCellUri=z})(R=e.CellUri||(e.CellUri={}));const S=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[k.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[k.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function s(l){return S.get(l)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=s;function n(l){return S.get(l)?.supportedByCore??!1}e.mimeTypeSupportedByCore=n;function g(l){return S.get(l)?.mergeable??!1}e.mimeTypeIsMergeable=g;const a=l=>I.isWindows?l.replace(/\//g,"\\"):l;class E{constructor(_=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(_)].map(N=>({pattern:N,matches:m.parse(a(N))}))}sort(_){const A=new Map(i.Iterable.map(_,x=>[x,a(x)]));let N=[];for(const{matches:x}of this.order)for(const[F,O]of A)if(x(O)){N.push(F),A.delete(F);break}return A.size&&(N=N.concat([...A.keys()].sort((x,F)=>this.defaultOrder.indexOf(x)-this.defaultOrder.indexOf(F)))),N}prioritize(_,A){const N=this.findIndex(_);if(N===-1){this.order.unshift({pattern:_,matches:m.parse(a(_))});return}const x=new Set(A.map(O=>this.findIndex(O,N)));x.delete(-1);const F=Array.from(x).sort();this.order.splice(N+1,0,...F.map(O=>this.order[O]));for(let O=F.length-1;O>=0;O--)this.order.splice(F[O],1)}toArray(){return this.order.map(_=>_.pattern)}findIndex(_,A=this.order.length){const N=a(_);for(let x=0;x<A;x++)if(this.order[x].matches(N))return x;return-1}}e.MimeTypeDisplayOrder=E;function r(l,_,A,N=(x,F)=>x===F){const x=[];function F($,M,B){if(M===0&&B.length===0)return;const W=x[x.length-1];W&&W.start+W.deleteCount===$?(W.deleteCount+=M,W.toInsert.push(...B)):x.push({start:$,deleteCount:M,toInsert:B})}let O=0,z=0;for(;;){if(O===l.length){F(O,0,_.slice(z));break}if(z===_.length){F(O,l.length-O,[]);break}const $=l[O],M=_[z];if(N($,M)){O+=1,z+=1;continue}A(M)?(F(O,1,[]),O+=1):(F(O,0,[M]),z+=1)}return x}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(l){l.default="default",l.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(l){const _=l;return!!((typeof _.include=="string"||m.isRelativePattern(_.include))&&(typeof _.exclude=="string"||m.isRelativePattern(_.exclude)))}e.isDocumentExcludePattern=o;function h(l,_,A){if(Array.isArray(l.viewType)&&l.viewType.indexOf(_)>=0||l.viewType===_)return!0;if(l.filenamePattern){const N=o(l.filenamePattern)?l.filenamePattern.include:l.filenamePattern,x=o(l.filenamePattern)?l.filenamePattern.exclude:void 0;if(m.match(N,(0,T.basename)(A.fsPath).toLowerCase()))return!(x&&m.match(x,(0,T.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h;class u{constructor(_){this.textModel=_}getElements(){const _=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)_[A]=this.textModel.cells[A].getHashValue();return _}}e.CellSequence=u,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var d;(function(l){l[l.Left=1]="Left",l[l.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class f{static create(_){return`${f._prefix}${_}`}static parse(_){if(_.startsWith(f._prefix))return _.substring(f._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=f,f._prefix="notebook/"}),define(ve[211],we([0,1,4]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var i;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(i=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(ve[212],we([0,1,4,62]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new i.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new i.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new i.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,m.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ve[213],we([0,1,176,4,62]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,i.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[214],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=m;function i(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=i}),define(ve[127],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(D){D[D.Unset=0]="Unset",D[D.Queued=1]="Queued",D[D.Running=2]="Running",D[D.Passed=3]="Passed",D[D.Failed=4]="Failed",D[D.Skipped=5]="Skipped",D[D.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var i;(function(D){D[D.Run=2]="Run",D[D.Debug=4]="Debug",D[D.Coverage=8]="Coverage",D[D.HasNonDefaultProfile=16]="HasNonDefaultProfile",D[D.HasConfigurable=32]="HasConfigurable"})(i=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(D){D[D.Error=0]="Error",D[D.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var C;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(D,c)=>{c.expand!==void 0&&(D.expand=c.expand),c.item!==void 0&&(D.item=D.item?Object.assign(D.item,c.item):c.item)};e.applyTestItemUpdate=T;var I;(function(D){D[D.Function=0]="Function",D[D.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var y;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire",D[D.AddTag=5]="AddTag",D[D.RemoveTag=6]="RemoveTag"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(c){}update(c){}remove(c,b){}complete(){}}e.IncrementalChangeCollector=P;class L{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const b=this.createChangeCollector();for(const p of c)switch(p[0]){case 0:{const v=p[1];if(v.parent){if(this.items.has(v.parent)){const w=this.items.get(v.parent);w.children.add(v.item.extId);const R=this.createItem(v,w);this.items.set(v.item.extId,R),b.add(R)}}else{const w=this.createItem(v);this.roots.add(w),this.items.set(v.item.extId,w),b.add(w)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=p[1],w=this.items.get(v.extId);if(!w)break;v.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,v),b.update(w);break}case 2:{const v=this.items.get(p[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const w=[[p[1]]];for(;w.length;)for(const R of w.pop()){const S=this.items.get(R);S&&(w.push(S.children),this.items.delete(R),b.remove(S,S!==v),S.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(p[1]);break;case 3:this.updatePendingRoots(p[1]);break;case 5:this._tags.set(p[1].id,p[1]);break;case 6:this._tags.delete(p[1]);break}b.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=L}),define(ve[89],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(C){C.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var i;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(i=e.TestPosition||(e.TestPosition={}));class k{constructor(T,I=T.length){if(this.path=T,this.viewEnd=I,T.length===0||I<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,I,y=T.parent){if(T.id===I)return new k([I]);let P=[T.id];for(let L=y;L&&L.id!==I;L=L.parent)P.push(L.id);return P.push(I),new k(P.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const I=T.indexOf("\0");return I===-1?T:T.slice(0,I)}static fromString(T){return new k(T.split("\0"))}static join(T,I){return new k([...T.path,I])}static joinToString(T,I){return T.toString()+"\0"+I}static compare(T,I){return T===I?0:I.startsWith(T+"\0")?2:T.startsWith(I+"\0")?3:1}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new k(this.path,T)}compare(T){if(typeof T=="string")return k.compare(this.toString(),T);for(let I=0;I<T.viewEnd&&I<this.viewEnd;I++)if(T.path[I]!==this.path[I])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=k}),define(ve[215],we([0,1,8,40,13,25,12,81,177]),function(X,e,m,i,k,C,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(D,c,b){this._contributedVariables=new Map,this._context=D,this._labelService=c,b&&(this._envVariablesPromise=b.then(p=>this.prepareEnv(p)))}prepareEnv(D){if(T.isWindows){const c=Object.create(null);return Object.keys(D).forEach(b=>{c[b.toLowerCase()]=D[b]}),c}return D}resolveWithEnvironment(D,c,b){return this.recursiveResolve(this.prepareEnv(D),c?c.uri:void 0,b)}async resolveAsync(D,c){return this.recursiveResolve(await this._envVariablesPromise,D?D.uri:void 0,c)}async resolveAnyBase(D,c,b,p){const v=C.deepClone(c);return T.isWindows&&v.windows?Object.keys(v.windows).forEach(w=>v[w]=v.windows[w]):T.isMacintosh&&v.osx?Object.keys(v.osx).forEach(w=>v[w]=v.osx[w]):T.isLinux&&v.linux&&Object.keys(v.linux).forEach(w=>v[w]=v.linux[w]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,D?D.uri:void 0,v,b,p)}async resolveAnyAsync(D,c,b){return this.resolveAnyBase(D,c,b)}async resolveAnyMap(D,c,b){const p=new Map;return{newConfig:await this.resolveAnyBase(D,c,b,p),resolvedVariables:p}}resolveWithInteractionReplace(D,c,b,p){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,c,b,p){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,c){if(this._contributedVariables.has(D))throw new Error("Variable "+D+" is contributed twice.");this._contributedVariables.set(D,c)}recursiveResolve(D,c,b,p,v){if(k.isString(b))return this.resolveString(D,c,b,p,v);if(k.isArray(b))return b.map(w=>this.recursiveResolve(D,c,w,p,v));if(k.isObject(b)){let w=Object.create(null);return Object.keys(b).forEach(R=>{const S=this.resolveString(D,c,R,p,v);w[S]=this.recursiveResolve(D,c,b[R],p,v)}),w}return b}resolveString(D,c,b,p,v){return b.replace(P.VARIABLE_REGEXP,(R,S)=>{if(S.includes(P.VARIABLE_LHS))return R;let s=this.evaluateSingleVariable(D,R,S,c,p);return v&&v.set(S,s),s!==R&&k.isString(s)&&s.match(P.VARIABLE_REGEXP)&&(s=this.resolveString(D,c,s,p,v)),s})}fsPath(D){return this._labelService?this._labelService.getUriLabel(D,{noPrefix:!0}):D.fsPath}evaluateSingleVariable(D,c,b,p,v){let w;const R=b.split(":");R.length>1&&(b=R[0],w=R[1]);const S=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,y.localize)(0,null,c))},s=()=>{const g=S();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,y.localize)(1,null,c,m.basename(g)))},n=()=>{if(w){const g=this._context.getFolderUri(w);if(g)return g;throw new Error((0,y.localize)(2,null,c,w))}if(p)return p;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,c)):new Error((0,y.localize)(4,null,c))};switch(b){case"env":if(w){if(D){const g=D[T.isWindows?w.toLowerCase():w];if(k.isString(g))return g}return""}throw new Error((0,y.localize)(5,null,c));case"config":if(w){const g=this._context.getConfigurationValue(p,w);if(k.isUndefinedOrNull(g))throw new Error((0,y.localize)(6,null,c,w));if(k.isObject(g))throw new Error((0,y.localize)(7,null,c,w));return g}throw new Error((0,y.localize)(8,null,c));case"command":return this.resolveFromMap(c,w,v,"command");case"input":return this.resolveFromMap(c,w,v,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(n()));case"cwd":return p||w?(0,I.normalizeDriveLetter)(this.fsPath(n())):i.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(n()));case"lineNumber":{const g=this._context.getLineNumber();if(g)return g;throw new Error((0,y.localize)(9,null,c))}case"selectedText":{const g=this._context.getSelectedText();if(g)return g;throw new Error((0,y.localize)(10,null,c))}case"file":return S();case"fileWorkspaceFolder":return s();case"relativeFile":return p||w?m.relative(this.fsPath(n()),S()):S();case"relativeFileDirname":{const g=m.dirname(S());if(p||w){const a=m.relative(this.fsPath(n()),g);return a.length===0?".":a}return g}case"fileDirname":return m.dirname(S());case"fileExtname":return m.extname(S());case"fileBasename":return m.basename(S());case"fileBasenameNoExtension":{const g=m.basename(S());return g.slice(0,g.length-m.extname(g).length)}case"fileDirnameBasename":return m.basename(m.dirname(S()));case"execPath":{const g=this._context.getExecPath();return g||c}case"execInstallFolder":{const g=this._context.getAppRoot();return g||c}case"pathSeparator":return m.sep;default:try{const g=w?`${b}:${w}`:b;return this.resolveFromMap(c,g,v,void 0)}catch{return c}}}}resolveFromMap(D,c,b,p){if(c&&b){const v=p===void 0?b[c]:b[p+":"+c];if(typeof v=="string")return v;throw new Error((0,y.localize)(11,null,D))}return D}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[128],we([0,1,4,207]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var k;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var C;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var I;(function(p){p[p.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function P(p){const v=p;return(0,i.isEditorInput)(v?.editor)&&(0,i.isEditorInput)(v?.replacement)}e.isEditorReplacement=P;var L;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function c(p){const v=p;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.isEditorGroup=c;function b(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(ve[216],we([0,1,4,128]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(C){const T=C;return typeof C=="number"||(0,i.isEditorGroup)(T)}e.isPreferredGroup=k}),define(ve[17],we([0,1,16,22,99,292,59,25,13,2,41,84,178,117,64,126,89,216,7]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(he){function ye(K){const{selectionStartLineNumber:Ie,selectionStartColumn:Me,positionLineNumber:Ze,positionColumn:qe}=K,ht=new S.Position(Ie-1,Me-1),Et=new S.Position(Ze-1,qe-1);return new S.Selection(ht,Et)}he.to=ye;function de(K){const{anchor:Ie,active:Me}=K;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}he.from=de})(s=e.Selection||(e.Selection={}));var n;(function(he){function ye(K){if(!K)return;const{start:Ie,end:Me}=K;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}he.from=ye;function de(K){if(!K)return;const{startLineNumber:Ie,startColumn:Me,endLineNumber:Ze,endColumn:qe}=K;return new S.Range(Ie-1,Me-1,Ze-1,qe-1)}he.to=de})(n=e.Range||(e.Range={}));var g;(function(he){function ye(de){switch(de){case 1:return S.StandardTokenType.Comment;case 0:return S.StandardTokenType.Other;case 3:return S.StandardTokenType.RegEx;case 2:return S.StandardTokenType.String}}he.to=ye})(g=e.TokenType||(e.TokenType={}));var a;(function(he){function ye(K){return new S.Position(K.lineNumber-1,K.column-1)}he.to=ye;function de(K){return{lineNumber:K.line+1,column:K.character+1}}he.from=de})(a=e.Position||(e.Position={}));var E;(function(he){function ye(Ie,Me){return(0,m.coalesce)((0,m.asArray)(Ie).map(Ze=>de(Ze,Me)))}he.from=ye;function de(Ie,Me){if(typeof Ie=="string")return{$serialized:!0,language:Ie};if(Ie)return{$serialized:!0,language:Ie.language,scheme:K(Ie.scheme,Me),pattern:typeof Ie.pattern=="undefined"?void 0:ie.from(Ie.pattern),exclusive:Ie.exclusive}}function K(Ie,Me){return Me&&typeof Ie=="string"?Me.transformOutgoingScheme(Ie):Ie}})(E=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(he){function ye(K){switch(K){case S.DiagnosticTag.Unnecessary:return 1;case S.DiagnosticTag.Deprecated:return 2}}he.from=ye;function de(K){switch(K){case 1:return S.DiagnosticTag.Unnecessary;case 2:return S.DiagnosticTag.Deprecated;default:return}}he.to=de})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(he){function ye(K){let Ie;return K.code&&((0,y.isString)(K.code)||(0,y.isNumber)(K.code)?Ie=String(K.code):Ie={value:String(K.code.value),target:K.code.target}),{...n.from(K.range),message:K.message,source:K.source,code:Ie,severity:h.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(o.from),tags:Array.isArray(K.tags)?(0,m.coalesce)(K.tags.map(r.from)):void 0}}he.from=ye;function de(K){const Ie=new S.Diagnostic(n.to(K),K.message,h.to(K.severity));return Ie.source=K.source,Ie.code=(0,y.isString)(K.code)?K.code:K.code?.value,Ie.relatedInformation=K.relatedInformation&&K.relatedInformation.map(o.to),Ie.tags=K.tags&&(0,m.coalesce)(K.tags.map(r.to)),Ie}he.to=de})(t=e.Diagnostic||(e.Diagnostic={}));var o;(function(he){function ye(K){return{...n.from(K.location.range),message:K.message,resource:K.location.uri}}he.from=ye;function de(K){return new S.DiagnosticRelatedInformation(new S.Location(K.resource,n.to(K)),K.message)}he.to=de})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(he){function ye(K){switch(K){case S.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case S.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case S.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case S.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}he.from=ye;function de(K){switch(K){case b.MarkerSeverity.Info:return S.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return S.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return S.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return S.DiagnosticSeverity.Hint;default:return S.DiagnosticSeverity.Error}}he.to=de})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var u;(function(he){function ye(K){return typeof K=="number"&&K>=S.ViewColumn.One?K-1:K===S.ViewColumn.Beside?R.SIDE_GROUP:R.ACTIVE_GROUP}he.from=ye;function de(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}he.to=de})(u=e.ViewColumn||(e.ViewColumn={}));function d(he){return typeof he.range!="undefined"}function f(he){return he.length===0?!0:!!d(he[0])}e.isDecorationOptionsArr=f;var l;(function(he){function ye(qe){return qe.map(he.from)}he.fromMany=ye;function de(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function K(qe){let ht;if(de(qe)){const{language:mt,value:wt}=qe;ht={value:"```"+mt+`
`+wt+"\n```\n"}}else S.MarkdownString.isMarkdownString(qe)?ht={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml}:typeof qe=="string"?ht={value:qe}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const Dt=mt=>{try{let wt=P.URI.parse(mt,!0);wt=wt.with({query:Ie(wt.query,Et)}),Et[mt]=wt}catch{}return""},bt=new C.Renderer;return bt.link=Dt,bt.image=mt=>Dt(k.parseHrefAndDimensions(mt).href),C(ht.value,{renderer:bt}),ht}he.from=K;function Ie(qe,ht){if(!qe)return qe;let Et;try{Et=(0,T.parse)(qe)}catch{}if(!Et)return qe;let Dt=!1;return Et=(0,I.cloneAndChange)(Et,bt=>{if(P.URI.isUri(bt)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[mt]=bt,Dt=!0,mt}else return}),Dt?JSON.stringify(Et):qe}function Me(qe){const ht=new S.MarkdownString(qe.value,qe.supportThemeIcons);return ht.isTrusted=qe.isTrusted,ht.supportHtml=qe.supportHtml,ht}he.to=Me;function Ze(qe){if(!!qe)return typeof qe=="string"?qe:he.from(qe)}he.fromStrict=Ze})(l=e.MarkdownString||(e.MarkdownString={}));function _(he){return f(he)?he.map(ye=>({range:n.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?l.fromMany(ye.hoverMessage):ye.hoverMessage?l.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):he.map(ye=>({range:n.from(ye)}))}e.fromRangeOrRangeWithMessage=_;function A(he){return typeof he=="undefined"?he:typeof he=="string"?P.URI.file(he):he}e.pathOrURIToURI=A;var N;(function(he){function ye(de){return typeof de=="undefined"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?A(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}he.from=ye})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var x;(function(he){function ye(de){return typeof de=="undefined"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?A(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?N.from(de.before):void 0,after:de.after?N.from(de.after):void 0}}he.from=ye})(x=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(he){function ye(de){if(typeof de=="undefined")return de;switch(de){case S.DecorationRangeBehavior.OpenOpen:return 0;case S.DecorationRangeBehavior.ClosedClosed:return 1;case S.DecorationRangeBehavior.OpenClosed:return 2;case S.DecorationRangeBehavior.ClosedOpen:return 3}}he.from=ye})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(he){function ye(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?F.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?x.from(de.light):void 0,dark:de.dark?x.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?A(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?N.from(de.before):void 0,after:de.after?N.from(de.after):void 0}}he.from=ye})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(he){function ye(K){return{text:K.newText,eol:K.newEol&&ct.from(K.newEol),range:n.from(K.range)}}he.from=ye;function de(K){const Ie=new S.TextEdit(n.to(K.range),K.text);return Ie.newEol=typeof K.eol=="undefined"?void 0:ct.to(K.eol),Ie}he.to=de})(z=e.TextEdit||(e.TextEdit={}));var $;(function(he){function ye(K,Ie,Me){const Ze={edits:[]};if(K instanceof S.WorkspaceEdit)for(let qe of K._allEntries())if(qe._type===1)Ze.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const ht=Ie?.getDocument(qe.uri);Ze.edits.push({_type:2,resource:qe.uri,edit:z.from(qe.edit),modelVersionId:ht?.version,metadata:qe.metadata})}else qe._type===3?Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Me?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Me?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(ze.from)}});return Ze}he.from=ye;function de(K){const Ie=new S.WorkspaceEdit;for(const Me of K.edits)Me.edit?Ie.replace(P.URI.revive(Me.resource),n.to(Me.edit.range),Me.edit.text):Ie.renameFile(P.URI.revive(Me.oldUri),P.URI.revive(Me.newUri),Me.options);return Ie}he.to=de})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var M;(function(he){const ye=Object.create(null);ye[S.SymbolKind.File]=0,ye[S.SymbolKind.Module]=1,ye[S.SymbolKind.Namespace]=2,ye[S.SymbolKind.Package]=3,ye[S.SymbolKind.Class]=4,ye[S.SymbolKind.Method]=5,ye[S.SymbolKind.Property]=6,ye[S.SymbolKind.Field]=7,ye[S.SymbolKind.Constructor]=8,ye[S.SymbolKind.Enum]=9,ye[S.SymbolKind.Interface]=10,ye[S.SymbolKind.Function]=11,ye[S.SymbolKind.Variable]=12,ye[S.SymbolKind.Constant]=13,ye[S.SymbolKind.String]=14,ye[S.SymbolKind.Number]=15,ye[S.SymbolKind.Boolean]=16,ye[S.SymbolKind.Array]=17,ye[S.SymbolKind.Object]=18,ye[S.SymbolKind.Key]=19,ye[S.SymbolKind.Null]=20,ye[S.SymbolKind.EnumMember]=21,ye[S.SymbolKind.Struct]=22,ye[S.SymbolKind.Event]=23,ye[S.SymbolKind.Operator]=24,ye[S.SymbolKind.TypeParameter]=25;function de(Ie){return typeof ye[Ie]=="number"?ye[Ie]:6}he.from=de;function K(Ie){for(const Me in ye)if(ye[Me]===Ie)return Number(Me);return S.SymbolKind.Property}he.to=K})(M=e.SymbolKind||(e.SymbolKind={}));var B;(function(he){function ye(K){switch(K){case S.SymbolTag.Deprecated:return 1}}he.from=ye;function de(K){switch(K){case 1:return S.SymbolTag.Deprecated}}he.to=de})(B=e.SymbolTag||(e.SymbolTag={}));var W;(function(he){function ye(K){return{name:K.name,kind:M.from(K.kind),tags:K.tags&&K.tags.map(B.from),containerName:K.containerName,location:Q.from(K.location)}}he.from=ye;function de(K){const Ie=new S.SymbolInformation(K.name,M.to(K.kind),K.containerName,Q.to(K.location));return Ie.tags=K.tags&&K.tags.map(B.to),Ie}he.to=de})(W=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(he){function ye(K){const Ie={name:K.name||"!!MISSING: name!!",detail:K.detail,range:n.from(K.range),selectionRange:n.from(K.selectionRange),kind:M.from(K.kind),tags:K.tags?.map(B.from)??[]};return K.children&&(Ie.children=K.children.map(ye)),Ie}he.from=ye;function de(K){const Ie=new S.DocumentSymbol(K.name,K.detail,M.to(K.kind),n.to(K.range),n.to(K.selectionRange));return(0,m.isNonEmptyArray)(K.tags)&&(Ie.tags=K.tags.map(B.to)),K.children&&(Ie.children=K.children.map(de)),Ie}he.to=de})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var j;(function(he){function ye(K){const Ie=new S.CallHierarchyItem(M.to(K.kind),K.name,K.detail||"",P.URI.revive(K.uri),n.to(K.range),n.to(K.selectionRange));return Ie._sessionId=K._sessionId,Ie._itemId=K._itemId,Ie}he.to=ye;function de(K,Ie,Me){if(Ie=Ie??K._sessionId,Me=Me??K._itemId,Ie===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Me,name:K.name,detail:K.detail,kind:M.from(K.kind),uri:K.uri,range:n.from(K.range),selectionRange:n.from(K.selectionRange),tags:K.tags?.map(B.from)}}he.from=de})(j=e.CallHierarchyItem||(e.CallHierarchyItem={}));var Z;(function(he){function ye(de){return new S.CallHierarchyIncomingCall(j.to(de.from),de.fromRanges.map(K=>n.to(K)))}he.to=ye})(Z=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ce;(function(he){function ye(de){return new S.CallHierarchyOutgoingCall(j.to(de.to),de.fromRanges.map(K=>n.to(K)))}he.to=ye})(ce=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(he){function ye(K){return{range:K.range&&n.from(K.range),uri:K.uri}}he.from=ye;function de(K){return new S.Location(P.URI.revive(K.uri),n.to(K.range))}he.to=de})(Q=e.location||(e.location={}));var V;(function(he){function ye(K){const Ie=K,Me=K;return{originSelectionRange:Ie.originSelectionRange?n.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Me.uri,range:n.from(Ie.targetRange?Ie.targetRange:Me.range),targetSelectionRange:Ie.targetSelectionRange?n.from(Ie.targetSelectionRange):void 0}}he.from=ye;function de(K){return{targetUri:P.URI.revive(K.uri),targetRange:n.to(K.range),targetSelectionRange:K.targetSelectionRange?n.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?n.to(K.originSelectionRange):void 0}}he.to=de})(V=e.DefinitionLink||(e.DefinitionLink={}));var te;(function(he){function ye(K){return{range:n.from(K.range),contents:l.fromMany(K.contents)}}he.from=ye;function de(K){return new S.Hover(K.contents.map(l.to),n.to(K.range))}he.to=de})(te=e.Hover||(e.Hover={}));var me;(function(he){function ye(K){return{range:n.from(K.range),expression:K.expression}}he.from=ye;function de(K){return new S.EvaluatableExpression(n.to(K.range),K.expression)}he.to=de})(me=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ge;(function(he){function ye(K){if(K instanceof S.InlineValueText)return{type:"text",range:n.from(K.range),text:K.text};if(K instanceof S.InlineValueVariableLookup)return{type:"variable",range:n.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof S.InlineValueEvaluatableExpression)return{type:"expression",range:n.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}he.from=ye;function de(K){switch(K.type){case"text":return{range:n.to(K.range),text:K.text};case"variable":return{range:n.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:n.to(K.range),expression:K.expression}}}he.to=de})(ge=e.InlineValue||(e.InlineValue={}));var ke;(function(he){function ye(K){return{frameId:K.frameId,stoppedLocation:n.from(K.stoppedLocation)}}he.from=ye;function de(K){return new S.InlineValueContext(K.frameId,n.to(K.stoppedLocation))}he.to=de})(ke=e.InlineValueContext||(e.InlineValueContext={}));var Be;(function(he){function ye(K){return{range:n.from(K.range),kind:K.kind}}he.from=ye;function de(K){return new S.DocumentHighlight(n.to(K.range),K.kind)}he.to=de})(Be=e.DocumentHighlight||(e.DocumentHighlight={}));var xe;(function(he){function ye(de){switch(de){case 1:return S.CompletionTriggerKind.TriggerCharacter;case 2:return S.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return S.CompletionTriggerKind.Invoke}}he.to=ye})(xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var q;(function(he){function ye(de){return{triggerKind:xe.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}he.to=ye})(q=e.CompletionContext||(e.CompletionContext={}));var Y;(function(he){function ye(K){switch(K){case S.CompletionItemTag.Deprecated:return 1}}he.from=ye;function de(K){switch(K){case 1:return S.CompletionItemTag.Deprecated}}he.to=de})(Y=e.CompletionItemTag||(e.CompletionItemTag={}));var re;(function(he){const ye=new Map([[S.CompletionItemKind.Method,0],[S.CompletionItemKind.Function,1],[S.CompletionItemKind.Constructor,2],[S.CompletionItemKind.Field,3],[S.CompletionItemKind.Variable,4],[S.CompletionItemKind.Class,5],[S.CompletionItemKind.Interface,7],[S.CompletionItemKind.Struct,6],[S.CompletionItemKind.Module,8],[S.CompletionItemKind.Property,9],[S.CompletionItemKind.Unit,12],[S.CompletionItemKind.Value,13],[S.CompletionItemKind.Constant,14],[S.CompletionItemKind.Enum,15],[S.CompletionItemKind.EnumMember,16],[S.CompletionItemKind.Keyword,17],[S.CompletionItemKind.Snippet,27],[S.CompletionItemKind.Text,18],[S.CompletionItemKind.Color,19],[S.CompletionItemKind.File,20],[S.CompletionItemKind.Reference,21],[S.CompletionItemKind.Folder,23],[S.CompletionItemKind.Event,10],[S.CompletionItemKind.Operator,11],[S.CompletionItemKind.TypeParameter,24],[S.CompletionItemKind.Issue,26],[S.CompletionItemKind.User,25]]);function de(Me){return ye.get(Me)??9}he.from=de;const K=new Map([[0,S.CompletionItemKind.Method],[1,S.CompletionItemKind.Function],[2,S.CompletionItemKind.Constructor],[3,S.CompletionItemKind.Field],[4,S.CompletionItemKind.Variable],[5,S.CompletionItemKind.Class],[7,S.CompletionItemKind.Interface],[6,S.CompletionItemKind.Struct],[8,S.CompletionItemKind.Module],[9,S.CompletionItemKind.Property],[12,S.CompletionItemKind.Unit],[13,S.CompletionItemKind.Value],[14,S.CompletionItemKind.Constant],[15,S.CompletionItemKind.Enum],[16,S.CompletionItemKind.EnumMember],[17,S.CompletionItemKind.Keyword],[27,S.CompletionItemKind.Snippet],[18,S.CompletionItemKind.Text],[19,S.CompletionItemKind.Color],[20,S.CompletionItemKind.File],[21,S.CompletionItemKind.Reference],[23,S.CompletionItemKind.Folder],[10,S.CompletionItemKind.Event],[11,S.CompletionItemKind.Operator],[24,S.CompletionItemKind.TypeParameter],[25,S.CompletionItemKind.User],[26,S.CompletionItemKind.Issue]]);function Ie(Me){return K.get(Me)??S.CompletionItemKind.Property}he.to=Ie})(re=e.CompletionItemKind||(e.CompletionItemKind={}));var ue;(function(he){function ye(de,K){const Ie=new S.CompletionItem(de.label);return Ie.insertText=de.insertText,Ie.kind=re.to(de.kind),Ie.tags=de.tags?.map(Y.to),Ie.detail=de.detail,Ie.documentation=k.isMarkdownString(de.documentation)?l.to(de.documentation):de.documentation,Ie.sortText=de.sortText,Ie.filterText=de.filterText,Ie.preselect=de.preselect,Ie.commitCharacters=de.commitCharacters,L.Range.isIRange(de.range)?Ie.range=n.to(de.range):typeof de.range=="object"&&(Ie.range={inserting:n.to(de.range.insert),replacing:n.to(de.range.replace)}),Ie.keepWhitespace=typeof de.insertTextRules=="undefined"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules!="undefined"&&de.insertTextRules&4?Ie.insertText=new S.SnippetString(de.insertText):(Ie.insertText=de.insertText,Ie.textEdit=Ie.range instanceof S.Range?new S.TextEdit(Ie.range,Ie.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Ie.additionalTextEdits=de.additionalTextEdits.map(Me=>z.to(Me))),Ie.command=K&&de.command?K.fromInternal(de.command):void 0,Ie}he.to=ye})(ue=e.CompletionItem||(e.CompletionItem={}));var J;(function(he){function ye(K){return{label:K.label,documentation:K.documentation?l.fromStrict(K.documentation):void 0}}he.from=ye;function de(K){return{label:K.label,documentation:k.isMarkdownString(K.documentation)?l.to(K.documentation):K.documentation}}he.to=de})(J=e.ParameterInformation||(e.ParameterInformation={}));var ae;(function(he){function ye(K){return{label:K.label,documentation:K.documentation?l.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(J.from):[],activeParameter:K.activeParameter}}he.from=ye;function de(K){return{label:K.label,documentation:k.isMarkdownString(K.documentation)?l.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(J.to):[],activeParameter:K.activeParameter}}he.to=de})(ae=e.SignatureInformation||(e.SignatureInformation={}));var Ee;(function(he){function ye(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ae.from):[]}}he.from=ye;function de(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ae.to):[]}}he.to=de})(Ee=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(he){function ye(K){return{label:K.text,tooltip:K.tooltip&&l.from(K.tooltip),position:a.from(K.position),kind:Ve.from(K.kind??S.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}he.from=ye;function de(K){const Ie=new S.InlayHint(K.label,a.to(K.position),Ve.to(K.kind));return Ie.tooltip=k.isMarkdownString(K.tooltip)?l.to(K.tooltip):K.tooltip,Ie.whitespaceAfter=K.whitespaceAfter,Ie.whitespaceBefore=K.whitespaceBefore,Ie}he.to=de})(Oe=e.InlayHint||(e.InlayHint={}));var Ve;(function(he){function ye(K){return K}he.from=ye;function de(K){return K}he.to=de})(Ve=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(he){function ye(K){return{range:n.from(K.range),url:K.target,tooltip:K.tooltip}}he.from=ye;function de(K){let Ie;if(K.url)try{Ie=typeof K.url=="string"?P.URI.parse(K.url,!0):P.URI.revive(K.url)}catch{}return new S.DocumentLink(n.to(K.range),Ie)}he.to=de})(Ke=e.DocumentLink||(e.DocumentLink={}));var Je;(function(he){function ye(K){const Ie=new S.ColorPresentation(K.label);return K.textEdit&&(Ie.textEdit=z.to(K.textEdit)),K.additionalTextEdits&&(Ie.additionalTextEdits=K.additionalTextEdits.map(Me=>z.to(Me))),Ie}he.to=ye;function de(K){return{label:K.label,textEdit:K.textEdit?z.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Ie=>z.from(Ie)):void 0}}he.from=de})(Je=e.ColorPresentation||(e.ColorPresentation={}));var it;(function(he){function ye(K){return new S.Color(K[0],K[1],K[2],K[3])}he.to=ye;function de(K){return[K.red,K.green,K.blue,K.alpha]}he.from=de})(it=e.Color||(e.Color={}));var at;(function(he){function ye(K){return{range:n.from(K.range)}}he.from=ye;function de(K){return new S.SelectionRange(n.to(K.range))}he.to=de})(at=e.SelectionRange||(e.SelectionRange={}));var et;(function(he){function ye(de){switch(de){case 2:return S.TextDocumentSaveReason.AfterDelay;case 1:return S.TextDocumentSaveReason.Manual;case 3:case 4:return S.TextDocumentSaveReason.FocusOut}}he.to=ye})(et=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(he){function ye(K){switch(K){case S.TextEditorLineNumbersStyle.Off:return 0;case S.TextEditorLineNumbersStyle.Relative:return 2;case S.TextEditorLineNumbersStyle.On:default:return 1}}he.from=ye;function de(K){switch(K){case 0:return S.TextEditorLineNumbersStyle.Off;case 2:return S.TextEditorLineNumbersStyle.Relative;case 1:default:return S.TextEditorLineNumbersStyle.On}}he.to=de})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ct;(function(he){function ye(K){if(K===S.EndOfLine.CRLF)return 1;if(K===S.EndOfLine.LF)return 0}he.from=ye;function de(K){if(K===1)return S.EndOfLine.CRLF;if(K===0)return S.EndOfLine.LF}he.to=de})(ct=e.EndOfLine||(e.EndOfLine={}));var vt;(function(he){function ye(de){if(typeof de=="object")return de.viewId;switch(de){case S.ProgressLocation.SourceControl:return 3;case S.ProgressLocation.Window:return 10;case S.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}he.from=ye})(vt=e.ProgressLocation||(e.ProgressLocation={}));var We;(function(he){function ye(de){const K={start:de.start+1,end:de.end+1};return de.kind&&(K.kind=At.from(de.kind)),K}he.from=ye})(We=e.FoldingRange||(e.FoldingRange={}));var At;(function(he){function ye(de){if(de)switch(de){case S.FoldingRangeKind.Comment:return D.FoldingRangeKind.Comment;case S.FoldingRangeKind.Imports:return D.FoldingRangeKind.Imports;case S.FoldingRangeKind.Region:return D.FoldingRangeKind.Region}}he.from=ye})(At=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ee;(function(he){function ye(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?n.from(de.selection):void 0,override:typeof de.override=="boolean"?c.EditorResolution.DISABLED:void 0}}he.from=ye})(ee=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ie;(function(he){function ye(K){return K instanceof S.RelativePattern||typeof K=="string"?K:de(K)?new S.RelativePattern(K.base,K.pattern):K}he.from=ye;function de(K){const Ie=K;return Ie&&typeof Ie.base=="string"&&typeof Ie.pattern=="string"}})(ie=e.GlobPattern||(e.GlobPattern={}));var Se;(function(he){function ye(de){if(de){if(Array.isArray(de))return de.map(ye);if(typeof de=="string")return de;{const K=de;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:ie.from(K.pattern),exclusive:K.exclusive}}}else return}he.from=ye})(Se=e.LanguageSelector||(e.LanguageSelector={}));var ne;(function(he){function ye(K){return{start:K.start,end:K.end}}he.from=ye;function de(K){return new S.NotebookRange(K.start,K.end)}he.to=de})(ne=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(he){function ye(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}he.to=ye;function de(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}he.from=de})(Ce=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Fe;(function(he){function ye(K){switch(K){case S.NotebookCellKind.Markup:return v.CellKind.Markup;case S.NotebookCellKind.Code:default:return v.CellKind.Code}}he.from=ye;function de(K){switch(K){case v.CellKind.Markup:return S.NotebookCellKind.Markup;case v.CellKind.Code:default:return S.NotebookCellKind.Code}}he.to=de})(Fe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ge;(function(he){function ye(K){const Ie={metadata:K.metadata??Object.create(null),cells:[]};for(let Me of K.cells)S.NotebookCellData.validate(Me),Ie.cells.push(ze.from(Me));return Ie}he.from=ye;function de(K){const Ie=new S.NotebookData(K.cells.map(ze.to));return(0,y.isEmptyObject)(K.metadata)||(Ie.metadata=K.metadata),Ie}he.to=de})(Ge=e.NotebookData||(e.NotebookData={}));var ze;(function(he){function ye(K){return{cellKind:Fe.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ce.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Re.from):[]}}he.from=ye;function de(K){return new S.NotebookCellData(Fe.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Re.to):void 0,K.metadata,K.internalMetadata?Ce.to(K.internalMetadata):void 0)}he.to=de})(ze=e.NotebookCellData||(e.NotebookCellData={}));var ut;(function(he){function ye(K){return{mime:K.mime,valueBytes:i.VSBuffer.wrap(K.data)}}he.from=ye;function de(K){return new S.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}he.to=de})(ut=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Re;(function(he){function ye(K){return{outputId:K.id,items:K.items.map(ut.from),metadata:K.metadata}}he.from=ye;function de(K){const Ie=K.items.map(ut.to);return new S.NotebookCellOutput(Ie,K.outputId,K.metadata)}he.to=de})(Re=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Te;(function(he){function ye(Me){if(Me!=null){if(Me instanceof S.RelativePattern||typeof Me=="string")return Me;if(Ie(Me))return new S.RelativePattern(Me.base,Me.pattern);if(K(Me))return{include:ie.from(Me.include)||void 0,exclude:ie.from(Me.exclude)||void 0}}}he.from=ye;function de(Me){return typeof Me=="string"?Me:Ie(Me)?{base:Me.base,pattern:Me.pattern}:{include:Me.include,exclude:Me.exclude}}he.to=de;function K(Me){const Ze=Me,qe=ie.from(Ze.include);if(!(qe&&qe instanceof S.RelativePattern||typeof qe=="string"))return!1;const ht=ie.from(Ze.exclude);return!!(ht&&ht instanceof S.RelativePattern||typeof ht=="string")}function Ie(Me){const Ze=Me;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Te=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var De;(function(he){function ye(de){return{backgroundColor:de.backgroundColor,borderColor:de.borderColor,top:de.top?N.from(de.top):void 0}}he.from=ye})(De=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var se;(function(he){function ye(de,K,Ie){const Me=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===S.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Me,Ie),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}he.from=ye})(se=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var fe;(function(he){function ye(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{}}}he.from=ye})(fe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var be;(function(he){function ye(K){return{uri:K.uri,provides:K.provides}}he.from=ye;function de(K){return new S.NotebookRendererScript(P.URI.revive(K.uri),K.provides)}he.to=de})(be=e.NotebookRendererScript||(e.NotebookRendererScript={}));var _e;(function(he){function ye(K){return{message:l.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location?Q.from(K.location):void 0}}he.from=ye;function de(K){const Ie=new S.TestMessage(typeof K.message=="string"?K.message:l.to(K.message));return Ie.actualOutput=K.actual,Ie.expectedOutput=K.expected,Ie.location=K.location?Q.to(K.location):void 0,Ie}he.to=de})(_e=e.TestMessage||(e.TestMessage={}));var Ne;(function(he){let ye;(function(de){de.Delimiter="\0"})(ye||(ye={})),he.namespace=(de,K)=>de+"\0"+K,he.denamespace=de=>{const K=de.indexOf("\0");return{ctrlId:de.slice(0,K),tagId:de.slice(K+1)}}})(Ne=e.TestTag||(e.TestTag={}));var Qe;(function(he){function ye(Me){const Ze=(0,p.getPrivateApiFor)(Me).controllerId;return{extId:w.TestId.fromExtHostTestItem(Me,Ze).toString(),label:Me.label,uri:Me.uri,tags:Me.tags.map(qe=>Ne.namespace(Ze,qe.id)),range:n.from(Me.range)||null,description:Me.description||null,error:Me.error&&l.fromStrict(Me.error)||null}}he.from=ye;function de(Me){return{parent:void 0,error:void 0,id:w.TestId.fromString(Me.extId).localId,label:Me.label,uri:P.URI.revive(Me.uri),tags:(Me.tags||[]).map(Ze=>{const{tagId:qe}=Ne.denamespace(Ze);return new S.TestTag(qe)}),range:n.to(Me.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Me.description||void 0}}he.toPlain=de;function K(Me){const Ze=w.TestId.fromString(Me.extId),qe=new p.TestItemImpl(Ze.controllerId,Ze.localId,Me.label,P.URI.revive(Me.uri));return qe.range=n.to(Me.range||void 0),qe.description=Me.description||void 0,qe}function Ie(Me){let Ze;for(const qe of Me.tests){const ht=K(qe.item);(0,p.getPrivateApiFor)(ht).parent=Ze,Ze=ht}return Ze}he.toItemFromContext=Ie})(Qe=e.TestItem||(e.TestItem={})),function(he){function ye(K){return{id:K.id}}he.from=ye;function de(K){return new S.TestTag(K.id)}he.to=de}(Ne=e.TestTag||(e.TestTag={}));var $e;(function(he){const ye=(K,Ie)=>{const Me={...Qe.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(qe=>qe.type===0).map(_e.to)})),children:K.children.map(Ze=>Ie.get(Ze)).filter(y.isDefined).map(Ze=>ye(Ze,Ie))};for(const Ze of Me.children)Ze.parent=Me;return Me};function de(K){const Ie=[],Me=new Map;for(const Ze of K.items)Me.set(Ze.item.extId,Ze),K.request.targets.some(qe=>qe.controllerId===Ze.controllerId&&qe.testIds.includes(Ze.item.extId))&&Ie.push(Ze);return{completedAt:K.completedAt,results:Ie.map(Ze=>ye(Ze,Me))}}he.to=de})($e=e.TestResults||(e.TestResults={}));var Xe;(function(he){function ye(Me){return{covered:Me.covered,total:Me.covered}}function de(Me){return"line"in Me?a.from(Me):n.from(Me)}function K(Me){return"branches"in Me?{count:Me.executionCount,location:de(Me.location),type:1,branches:Me.branches.length?Me.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&de(Ze.location)})):void 0}:{type:0,count:Me.executionCount,location:de(Me.location)}}he.fromDetailed=K;function Ie(Me){return{uri:Me.uri,statement:ye(Me.statementCoverage),branch:Me.branchCoverage&&ye(Me.branchCoverage),function:Me.functionCoverage&&ye(Me.functionCoverage),details:Me.detailedCoverage?.map(K)}}he.fromFile=Ie})(Xe=e.TestCoverage||(e.TestCoverage={}));var st;(function(he){function ye(de){switch(de){case 1:return S.CodeActionTriggerKind.Invoke;case 2:return S.CodeActionTriggerKind.Automatic}}he.to=ye})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ot;(function(he){function ye(K){const Ie=new S.TypeHierarchyItem(M.to(K.kind),K.name,K.detail||"",P.URI.revive(K.uri),n.to(K.range),n.to(K.selectionRange));return Ie._sessionId=K._sessionId,Ie._itemId=K._itemId,Ie}he.to=ye;function de(K,Ie,Me){if(Ie=Ie??K._sessionId,Me=Me??K._itemId,Ie===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Me,kind:M.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:n.from(K.range),selectionRange:n.from(K.selectionRange),tags:K.tags?.map(B.from)}}he.from=de})(ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[217],we([0,1,2,15,7,17,94]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(P,L,D,c={timeout:1500,errors:3}){this._logService=P,this._documents=L,this._mainThreadBulkEdits=D,this._thresholds=c,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(L,D,c)=>{const p={dispose:this._callbacks.push([L,D,P])};return Array.isArray(c)&&c.push(p),p}}async $participateInSave(P,L){const D=m.URI.revive(P);let c=!1;const b=setTimeout(()=>c=!0,this._thresholds.timeout),p=[];try{for(let v of[...this._callbacks]){if(c)break;const w=this._documents.getDocument(D),R=await this._deliverEventAsyncAndBlameBadListeners(v,{document:w,reason:C.TextDocumentSaveReason.to(L)});p.push(R)}}finally{clearTimeout(b)}return p}_deliverEventAsyncAndBlameBadListeners([P,L,D],c){const b=this._badListeners.get(P);return typeof b=="number"&&b>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(D,P,L,c).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const v=this._badListeners.get(P);this._badListeners.set(P,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,L,D,c){const b=[],p=Date.now(),{document:v,reason:w}=c,{version:R}=v,S=Object.freeze({document:v,reason:w,waitUntil(s){if(Object.isFrozen(b))throw(0,i.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(s))}});try{L.apply(D,[S])}catch(s){return Promise.reject(s)}return Object.freeze(b),new Promise((s,n)=>{const g=setTimeout(()=>n(new Error("timeout")),this._thresholds.timeout);return Promise.all(b).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(g),s(a)}).catch(a=>{clearTimeout(g),n(a)})}).then(s=>{const n={edits:[]};for(const g of s)if(Array.isArray(g)&&g.every(a=>a instanceof k.TextEdit))for(const{newText:a,newEol:E,range:r}of g)n.edits.push({_type:2,resource:v.uri,edit:{range:r&&C.Range.from(r),text:a,eol:E&&C.EndOfLine.from(E)}});if(n.edits.length!==0)return R===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(n):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(ve[218],we([0,1,3,32,2,17,7]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(L,D,c,b,p){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,c&&(this._config+=1),b&&(this._config+=2),p&&(this._config+=4);const v=(0,i.parse)(D),w=L(R=>{if(!c)for(let S of R.created){const s=k.URI.revive(S);v(s.fsPath)&&this._onDidCreate.fire(s)}if(!b)for(let S of R.changed){const s=k.URI.revive(S);v(s.fsPath)&&this._onDidChange.fire(s)}if(!p)for(let S of R.deleted){const s=k.URI.revive(S);v(s.fsPath)&&this._onDidDelete.fire(s)}});this._disposable=T.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(L,D,c){this._logService=D,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(L,D,c,b){return new I(this._onFileSystemEvent.event,L,D,c,b)}$onFileEvent(L){this._onFileSystemEvent.fire(L)}$onDidRunFileOperation(L,D){switch(L){case 2:this._onDidRenameFile.fire(Object.freeze({files:D.map(c=>({oldUri:k.URI.revive(c.source),newUri:k.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:D.map(c=>k.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:D.map(c=>k.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(L){return this._createWillExecuteEvent(L,this._onWillRenameFile)}getOnWillCreateFileEvent(L){return this._createWillExecuteEvent(L,this._onWillCreateFile)}getOnWillDeleteFileEvent(L){return this._createWillExecuteEvent(L,this._onWillDeleteFile)}_createWillExecuteEvent(L,D){return(c,b,p)=>{const v=function(R){c.call(b,R)};return v.extension=L,D.event(v,void 0,p)}}async $onWillRunFileOperation(L,D,c,b){switch(L){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:D.map(p=>({oldUri:k.URI.revive(p.source),newUri:k.URI.revive(p.target)}))},c,b);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:D.map(p=>k.URI.revive(p.target))},c,b);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:D.map(p=>k.URI.revive(p.target))},c,b)}}async _fireWillEvent(L,D,c,b){const p=new Set,v=[];if(await L.fireAsync(D,b,async(R,S)=>{const s=Date.now(),n=await Promise.resolve(R);n instanceof T.WorkspaceEdit&&(v.push(n),p.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-s>c&&this._logService.warn("SLOW file-participant",S.extension.identifier)}),b.isCancellationRequested||v.length===0)return;const w={edits:[]};for(let R of v){let{edits:S}=C.WorkspaceEdit.from(R,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(S)}return{edit:w,extensionNames:Array.from(p)}}}e.ExtHostFileSystemEventService=y}),define(ve[219],we([0,1,10,25,2,17,126]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class I{constructor(D,c,b,p){this.start=D,this.deletedCount=c,this.deletedItems=b,this.items=p}static asApiEvents(D){return D.map(c=>({start:c.start,deletedCount:c.deletedCount,deletedItems:c.deletedItems,items:c.items.map(b=>b.apiCell)}))}}class y{constructor(D,c,b){this.notebook=D,this._extHostDocument=c,this._cellData=b,this.handle=b.handle,this.uri=k.URI.revive(b.uri),this.cellKind=b.cellKind,this._outputs=b.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=b.internalMetadata??{},this._metadata=Object.freeze(b.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}static asModelAddData(D,c){return{EOL:c.eol,lines:c.source,languageId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:D}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const D=this,c=this._extHostDocument.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:c.document,get mime(){return D._mime},set mime(b){D._mime=b},get outputs(){return D._outputs.slice(0)},get metadata(){return D._metadata},get executionSummary(){return D._previousResult}})}return this._apiCell}setOutputs(D){this._outputs=D.map(C.NotebookCellOutput.to)}setOutputItems(D,c,b){const p=b.map(C.NotebookCellOutputItem.to),v=this._outputs.find(w=>w.id===D);v&&(c||(v.items.length=0),v.items.push(...p))}setMetadata(D){this._metadata=Object.freeze(D)}setInternalMetadata(D){this._internalMetadata=D,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=y;class P{constructor(D,c,b,p,v,w){this._proxy=D,this._textDocumentsAndEditors=c,this._textDocuments=b,this._emitter=p,this.uri=v,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=Object.freeze(w.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const D=this;this._notebook={get uri(){return D.uri},get version(){return D._versionId},get notebookType(){return D._notebookType},get isDirty(){return D._isDirty},get isUntitled(){return D.uri.scheme===m.Schemas.untitled},get isClosed(){return D._disposed},get metadata(){return D._metadata},get cellCount(){return D._cells.length},cellAt(c){return c=D._validateIndex(c),D._cells[c].apiCell},getCells(c){return(c?D._getCells(c):D._cells).map(p=>p.apiCell)},save(){return D._save()}}}return this._notebook}updateBackup(D){this._backup?.delete(),this._backup=D}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(D){D.metadata&&(this._metadata=Object.freeze({...this._metadata,...D.metadata}))}acceptDirty(D){this._isDirty=D}acceptModelChanged(D,c){this._versionId=D.versionId,this._isDirty=c;for(const b of D.rawEvents)b.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(b.changes,!1):b.kind===T.NotebookCellsChangeType.Move?this._moveCell(b.index,b.newIdx):b.kind===T.NotebookCellsChangeType.Output?this._setCellOutputs(b.index,b.outputs):b.kind===T.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(b.index,b.outputId,b.append,b.outputItems):b.kind===T.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(b.index,b.language):b.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(b.index,b.mime):b.kind===T.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(b.index,b.metadata):b.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(b.index,b.internalMetadata)}_validateIndex(D){return D=D|0,D<0?0:D>=this._cells.length?this._cells.length-1:D}_validateRange(D){let c=D.start|0,b=D.end|0;return c<0&&(c=0),b>this._cells.length&&(b=this._cells.length),D.with({start:c,end:b})}_getCells(D){D=this._validateRange(D);const c=[];for(let b=D.start;b<D.end;b++)c.push(this._cells[b]);return c}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(D,c){if(this._disposed)return;const b=[],p=[],v=[];D.reverse().forEach(w=>{const S=w[2].map(g=>{const a=new y(this,this._textDocumentsAndEditors,g);return c||p.push(y.asModelAddData(this.apiNotebook,g)),a}),s=new I(w[0],w[1],[],S),n=this._cells.splice(w[0],w[1],...S);for(const g of n)v.push(g.uri),s.deletedItems.push(g.apiCell);b.push(s)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:v}),c||this._emitter.emitModelChange((0,i.deepFreeze)({document:this.apiNotebook,changes:I.asApiEvents(b)}))}_moveCell(D,c){const b=this._cells.splice(D,1);this._cells.splice(c,0,...b);const p=[new I(D,1,b.map(v=>v.apiCell),[]),new I(c,0,[],b)];this._emitter.emitModelChange((0,i.deepFreeze)({document:this.apiNotebook,changes:I.asApiEvents(p)}))}_setCellOutputs(D,c){const b=this._cells[D];b.setOutputs(c),this._emitter.emitCellOutputsChange((0,i.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_setCellOutputItems(D,c,b,p){const v=this._cells[D];v.setOutputItems(c,b,p),this._emitter.emitCellOutputsChange((0,i.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(D,c){const b=this._cells[D];b.apiCell.document.languageId!==c&&this._textDocuments.$acceptModelLanguageChanged(b.uri,c)}_changeCellMime(D,c){const b=this._cells[D];b.apiCell.mime=c}_changeCellMetadata(D,c){const b=this._cells[D],p=b.apiCell.metadata;b.setMetadata(c);const v=b.apiCell.metadata;(0,i.equals)(p,v)||this._emitter.emitCellMetadataChange((0,i.deepFreeze)({document:this.apiNotebook,cell:b.apiCell}))}_changeCellInternalMetadata(D,c){this._cells[D].setInternalMetadata(c)}getCellFromApiCell(D){return this._cells.find(c=>c.apiCell===D)}getCellFromIndex(D){return this._cells[D]}getCell(D){return this._cells.find(c=>c.handle===D)}getCellIndex(D){return this._cells.indexOf(D)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(ve[129],we([0,1,7,17,15]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:P})}replaceCells(y,P,L){this._throwIfFinalized(),!(y===P&&L.length===0)&&this._collectedEdits.push({editType:1,index:y,count:P-y,cells:L.map(i.NotebookCellData.from)})}}class T{constructor(y,P,L,D,c,b){this.id=y,this._proxy=P,this.notebookData=L,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=D,this._viewColumn=b}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(P){if(!Array.isArray(P)||!P.every(m.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");y._selections=P,y._trySetSelections(P)},get visibleRanges(){return y._visibleRanges},revealRange(P,L){y._proxy.$tryRevealRange(y.id,i.NotebookRange.from(P),L??m.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(P){const L=new C(this.document.version);return P(L),y._applyEdit(L.finalize())},setDecorations(P,L){return y.setDecorations(P,L)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(i.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const P=[];let L=-1;for(let D=0;D<y.cellEdits.length;D++){if(L<0){P.push(y.cellEdits[D]),L++;continue}const b=P[L],p=y.cellEdits[D];if(b.editType===1&&p.editType===1&&b.index===p.index){b.cells.push(...y.cellEdits[D].cells),b.count+=y.cellEdits[D].count;continue}P.push(y.cellEdits[D]),L++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,P)}setDecorations(y,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return P.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,i.NotebookRange.from(P),y.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(ve[220],we([0,1,17,118,165,21,57,15]),function(X,e,m,i,k,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(c){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=c}async withProgress(c,b,p){const v=this._handles++,{title:w,location:R,cancellable:S}=b,s={label:(0,k.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this._proxy.$startProgress(v,{location:m.ProgressLocation.from(R),title:w,source:s,cancellable:S},c).catch(I.onUnexpectedExternalError),this._withProgress(v,p,!!S)}_withProgress(c,b,p){let v;p&&(v=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(c,v));const w=S=>{this._proxy.$progressEnd(S),this._mapHandleToCancellationSource.delete(S),v&&v.dispose()};let R;try{R=b(new L(this._proxy,c),p&&v?v.token:C.CancellationToken.None)}catch(S){throw w(c),S}return R.then(S=>w(c),S=>w(c)),R}$acceptProgressCanceled(c){const b=this._mapHandleToCancellationSource.get(c);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(c))}}e.ExtHostProgress=y;function P(D,c){return D.message=c.message,typeof c.increment=="number"&&(typeof D.increment=="number"?D.increment+=c.increment:D.increment=c.increment),D}class L extends i.Progress{constructor(c,b){super(p=>this.throttledReport(p));this._proxy=c,this._handle=b}throttledReport(c){this._proxy.$progressReport(this._handle,c)}}je([(0,T.throttle)(100,(D,c)=>P(D,c),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ve[130],we([0,1,56,15,77,17,7]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(c,b,p){const v=I._Keys.nextId();c.$registerTextEditorDecorationType(b.identifier,v,C.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:v,dispose(){c.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=I,I._Keys=new k.IdGenerator("TextEditorDecorationType");class y{constructor(c,b){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=b.undoStopBefore,this._undoStopAfter=b.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,b){this._throwIfFinalized();let p=null;if(c instanceof T.Position)p=new T.Range(c,c);else if(c instanceof T.Range)p=c;else throw new Error("Unrecognized location");this._pushEdit(p,b,!1)}insert(c,b){this._throwIfFinalized(),this._pushEdit(new T.Range(c,c),b,!0)}delete(c){this._throwIfFinalized();let b=null;if(c instanceof T.Range)b=c;else throw new Error("Unrecognized location");this._pushEdit(b,null,!0)}_pushEdit(c,b,p){const v=this._document.validateRange(c);this._collectedEdits.push({range:v,text:b,forceMoveMarkers:p})}setEndOfLine(c){if(this._throwIfFinalized(),c!==T.EndOfLine.LF&&c!==T.EndOfLine.CRLF)throw(0,i.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=y;class P{constructor(c,b,p,v){this._proxy=c,this._id=b,this._accept(p),this._logService=v;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(R){w._setTabSize(R)},get insertSpaces(){return w._insertSpaces},set insertSpaces(R){w._setInsertSpaces(R)},get cursorStyle(){return w._cursorStyle},set cursorStyle(R){w._setCursorStyle(R)},get lineNumbers(){return w._lineNumbers},set lineNumbers(R){w._setLineNumbers(R)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const b=Math.floor(c);return b>0?b:null}if(typeof c=="string"){const b=parseInt(c,10);return isNaN(b)?null:b>0?b:null}return null}_setTabSize(c){const b=this._validateTabSize(c);if(b!==null){if(typeof b=="number"){if(this._tabSize===b)return;this._tabSize=b}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:b}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const b=this._validateInsertSpaces(c);if(typeof b=="boolean"){if(this._insertSpaces===b)return;this._insertSpaces=b}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:b}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(c)})))}assign(c){const b={};let p=!1;if(typeof c.tabSize!="undefined"){const v=this._validateTabSize(c.tabSize);v==="auto"?(p=!0,b.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,p=!0,b.tabSize=v)}if(typeof c.insertSpaces!="undefined"){const v=this._validateInsertSpaces(c.insertSpaces);v==="auto"?(p=!0,b.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,p=!0,b.insertSpaces=v)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,p=!0,b.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,p=!0,b.lineNumbers=C.TextEditorLineNumbersStyle.from(c.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,b))}_warnOnError(c,b){b.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=P;class L{constructor(c,b,p,v,w,R,S,s){this.id=c,this._proxy=b,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new P(this._proxy,this.id,R,p),this._visibleRanges=S,this._viewColumn=s;const n=this;this.value=Object.freeze({get document(){return v.getValue()},set document(g){throw(0,i.readonly)("document")},get selection(){return n._selections&&n._selections[0]},set selection(g){if(!(g instanceof T.Selection))throw(0,i.illegalArgument)("selection");n._selections=[g],n._trySetSelection()},get selections(){return n._selections},set selections(g){if(!Array.isArray(g)||g.some(a=>!(a instanceof T.Selection)))throw(0,i.illegalArgument)("selections");n._selections=g,n._trySetSelection()},get visibleRanges(){return n._visibleRanges},set visibleRanges(g){throw(0,i.readonly)("visibleRanges")},get options(){return n._options.value},set options(g){n._disposed||n._options.assign(g)},get viewColumn(){return n._viewColumn},set viewColumn(g){throw(0,i.readonly)("viewColumn")},edit(g,a={undoStopBefore:!0,undoStopAfter:!0}){if(n._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const E=new y(v.getValue(),a);return g(E),n._applyEdit(E)},insertSnippet(g,a,E={undoStopBefore:!0,undoStopAfter:!0}){if(n._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!a||Array.isArray(a)&&a.length===0)r=n._selections.map(t=>C.Range.from(t));else if(a instanceof T.Position){const{lineNumber:t,column:o}=C.Position.from(a);r=[{startLineNumber:t,startColumn:o,endLineNumber:t,endColumn:o}]}else if(a instanceof T.Range)r=[C.Range.from(a)];else{r=[];for(const t of a)if(t instanceof T.Range)r.push(C.Range.from(t));else{const{lineNumber:o,column:h}=C.Position.from(t);r.push({startLineNumber:o,startColumn:h,endLineNumber:o,endColumn:h})}}return b.$tryInsertSnippet(c,g.value,r,E)},setDecorations(g,a){const E=a.length===0;E&&!n._hasDecorationsForKey.has(g.key)||(E?n._hasDecorationsForKey.delete(g.key):n._hasDecorationsForKey.add(g.key),n._runOnProxy(()=>{if(C.isDecorationOptionsArr(a))return b.$trySetDecorations(c,g.key,C.fromRangeOrRangeWithMessage(a));{const r=new Array(4*a.length);for(let t=0,o=a.length;t<o;t++){const h=a[t];r[4*t]=h.start.line+1,r[4*t+1]=h.start.character+1,r[4*t+2]=h.end.line+1,r[4*t+3]=h.end.character+1}return b.$trySetDecorationsFast(c,g.key,r)}}))},revealRange(g,a){n._runOnProxy(()=>b.$tryRevealRange(c,C.Range.from(g),a||T.TextEditorRevealType.Default))},show(g){b.$tryShowEditor(c,C.ViewColumn.from(g))},hide(){b.$tryHideEditor(c)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,m.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,m.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,m.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,m.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const b=c.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const p=b.edits.map(w=>w.range);p.sort((w,R)=>w.end.line===R.end.line?w.end.character===R.end.character?w.start.line===R.start.line?w.start.character-R.start.character:w.start.line-R.start.line:w.end.character-R.end.character:w.end.line-R.end.line);for(let w=0,R=p.length-1;w<R;w++){const S=p[w].end;if(p[w+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=b.edits.map(w=>({range:C.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,v,{setEndOfLine:typeof b.setEndOfLine=="number"?C.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this._logService.warn(b),null))}}e.ExtHostTextEditor=L}),define(ve[221],we([0,1,18,3,6,13,64,17,127,89]),function(X,e,m,i,k,C,T,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class L extends k.Disposable{constructor(c){super();this.controllerId=c,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new i.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const b of this.tree.values())this.updateExpandability(b)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const b=this.diff[this.diff.length-1];if(b&&c[0]===1){if(b[0]===1&&b[1].extId===c[1].extId){(0,y.applyTestItemUpdate)(b[1],c[1]);return}if(b[0]===0&&b[1].item.extId===c[1].extId){(0,y.applyTestItemUpdate)(b[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,b){const p=this.tree.get(c);if(!!p){if((p.expandLevels===void 0||b>p.expandLevels)&&(p.expandLevels=b),p.expand===1){const v=this.resolveChildren(p);return v.isOpen()?this.expandChildren(p,b-1):v.wait().then(()=>this.expandChildren(p,b-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,b-1)):this.expandChildren(p,b-1)}}dispose(){for(const c of this.tree.values())(0,T.getPrivateApiFor)(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,b){switch(b.op){case 2:this.pushDiff([4,c.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(c.fullId,b.id));break;case 0:this.upsertItem(b.item,c);break;case 4:for(const p of b.ops)this.onTestItemEvent(c,p);break;case 3:{const{key:p,value:v,previous:w}=b,R=c.fullId.toString();switch(p){case"canResolveChildren":this.updateExpandability(c);break;case"tags":this.diffTagRefs(v,w,R);break;case"range":this.pushDiff([1,{extId:R,item:{range:I.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:R,item:{error:I.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:R,item:{[p]:v??null}}]);break}break}default:(0,C.assertNever)(b)}}upsertItem(c,b){if(!(c instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);const p=P.TestId.fromExtHostTestItem(c,this.root.id,b?.actual),v=(0,T.getPrivateApiFor)(c);v.parent&&v.parent!==b?.actual&&v.parent.children.delete(c.id);let w=this.tree.get(p.toString());if(!w){w={fullId:p,actual:c,parent:b?p.parentId:null,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(w.fullId.toString(),w),this.setItemParent(c,b),this.pushDiff([0,{parent:w.parent&&w.parent.toString(),controllerId:this.controllerId,expand:w.expand,item:I.TestItem.from(c)}]),this.connectItemAndChildren(c,w,b);return}if(w.actual===c){this.connectItem(c,w,b);return}const R=w.actual.children,S=w.actual,s=(0,T.diffTestItems)(S,c);(0,T.getPrivateApiFor)(S).listener=void 0,w.actual=c,w.expand=0;for(const[n,g]of s)this.onTestItemEvent(w,{op:3,key:n,value:g,previous:S[n]});this.connectItemAndChildren(c,w,b);for(const n of R)c.children.get(n.id)||this.removeItem(P.TestId.joinToString(p,n.id))}diffTagRefs(c,b,p){const v=new Set(b.map(w=>w.id));for(const w of c)v.delete(w.id)||this.incrementTagRefs(w);this.pushDiff([1,{extId:p,item:{tags:c.map(w=>I.TestTag.namespace(this.controllerId,w.id))}}]),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const b=this.tags.get(c.id);b?b.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff([5,{id:I.TestTag.namespace(this.controllerId,c.id),ctrlLabel:this.root.label}]))}decrementTagRefs(c){const b=this.tags.get(c);b&&!--b.refCount&&(this.tags.delete(c),this.pushDiff([6,I.TestTag.namespace(this.controllerId,c)]))}setItemParent(c,b){(0,T.getPrivateApiFor)(c).parent=b&&b.actual!==this.root?b.actual:void 0}connectItem(c,b,p){this.setItemParent(c,p);const v=(0,T.getPrivateApiFor)(c);v.parent=p?.actual,v.listener=w=>this.onTestItemEvent(b,w),this.updateExpandability(b)}connectItemAndChildren(c,b,p){this.connectItem(c,b,p);for(const v of c.children)this.upsertItem(v,b)}updateExpandability(c){let b;this._resolveHandler?c.resolveBarrier?b=c.resolveBarrier.isOpen()?3:2:b=c.actual.canResolveChildren?1:0:b=0,b!==c.expand&&(c.expand=b,this.pushDiff([1,{extId:c.fullId.toString(),expand:b}]),b===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,b){if(b<0)return;const p=[];for(const v of c.actual.children){const w=this.expand(P.TestId.joinToString(c.fullId,v.id),b);(0,m.isThenable)(w)&&p.push(w)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const w=new m.Barrier;return w.open(),w}c.expand=2,this.pushExpandStateUpdate(c);const b=c.resolveBarrier=new m.Barrier,p=w=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),c.actual!==this.root&&(c.actual.error=w.stack||w.message||String(w))};let v;try{v=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(w){p(w)}return(0,m.isThenable)(v)?v.catch(p).then(()=>{b.open(),this.updateExpandability(c)}):(b.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.fullId.toString(),expand:c.expand}])}removeItem(c){const b=this.tree.get(c);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff([2,c]);const p=[b];for(;p.length;){const v=p.pop();if(!!v){(0,T.getPrivateApiFor)(v.actual).listener=void 0;for(const w of v.actual.tags)this.decrementTagRefs(w.id);this.tree.delete(v.fullId.toString());for(const w of v.actual.children)p.push(this.tree.get(P.TestId.joinToString(v.fullId,w.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=L}),define(ve[222],we([0,1,4,183]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(i.IEnvironmentService)}),define(ve[223],we([0,1,27,3,8]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(L){this.removedDueToLooping=L}}e.DeltaExtensionsResult=C;class T{constructor(L){this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=L,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const L of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(L.identifier))){console.error("Extension `"+L.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(L.identifier),L),this._extensionsArr.push(L),Array.isArray(L.activationEvents))for(let D of L.activationEvents)D==="onUri"&&(D=`onUri:${m.ExtensionIdentifier.toKey(L.identifier)}`),this._activationMap.has(D)||this._activationMap.set(D,[]),this._activationMap.get(D).push(L)}}keepOnly(L){const D=new Set;L.forEach(c=>D.add(m.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>D.has(m.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(L,D){L.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(L));const c=T._findLoopingExtensions(this._extensionDescriptions);if(D=D.concat(c.map(b=>b.identifier)),D.length>0){const b=new Set;D.forEach(p=>b.add(m.ExtensionIdentifier.toKey(p))),this._extensionDescriptions=this._extensionDescriptions.filter(p=>!b.has(m.ExtensionIdentifier.toKey(p.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(c)}static _findLoopingExtensions(L){const D=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,R){this.addNode(w),this.addNode(R),this._arcs.has(w)?this._arcs.get(w).push(R):this._arcs.set(w,[R])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,R){const S=D.getArcs(w);for(let s=0;s<S.length;s++)if(!R.has(S[s]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let w of L){const R=m.ExtensionIdentifier.toKey(w.identifier);if(c.set(R,w),w.extensionDependencies)for(let S of w.extensionDependencies){const s=m.ExtensionIdentifier.toKey(S);D.addArc(R,s)}}let b=new Set;D.getNodes().filter(w=>D.getArcs(w).length===0).forEach(w=>b.add(w));let p=D.getNodes().filter(w=>!b.has(w)),v;do{v=!1;for(let w=0;w<p.length;w++){const R=p[w];D.hasOnlyGoodArcs(R,b)&&(p.splice(w,1),w--,b.add(R),v=!0)}}while(v);return p.map(w=>c.get(w))}containsActivationEvent(L){return this._activationMap.has(L)}containsExtension(L){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(L))}getExtensionDescriptionsForActivationEvent(L){const D=this._activationMap.get(L);return D?D.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(L){const D=this._extensionsMap.get(m.ExtensionIdentifier.toKey(L));return D||void 0}}e.ExtensionDescriptionRegistry=T;var I;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(I||(I={}));function y(P,L){const D=P.isBuiltin?0:P.isUnderDevelopment?2:1,c=L.isBuiltin?0:L.isUnderDevelopment?2:1;if(D!==c)return D-c;const b=k.posix.basename(P.extensionLocation.path),p=k.posix.basename(L.extensionLocation.path);return b<p?-1:b>p?1:0}}),define(ve[224],we([0,1,22]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var i;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(i=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function C(I){const y=m.VSBuffer.alloc(1);switch(I){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=C;function T(I,y){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=T}),define(ve[30],we([0,1,3,2,4,27,194]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:i.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");var I;(function(n){n[n.None=0]="None",n[n.LocalProcess=1]="LocalProcess",n[n.LocalWebWorker=2]="LocalWebWorker",n[n.Remote=3]="Remote"})(I=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function y(n){switch(n){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=y;class P{constructor(g){this.dependency=g}}e.MissingExtensionDependency=P;var L;(function(n){n[n.LocalProcess=0]="LocalProcess",n[n.LocalWebWorker=1]="LocalWebWorker",n[n.Remote=2]="Remote"})(L=e.ExtensionHostKind||(e.ExtensionHostKind={}));function D(n){switch(n){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=D;function c(n,g){return n.enabledApiProposals?n.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=c;function b(n,g){if(!c(n,g))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.checkProposedApiEnabled=b;class p{constructor(g,a,E,r){this.codeLoadingTime=g,this.activateCallTime=a,this.activateResolvedTime=E,this.activationReason=r}}e.ActivationTimes=p;class v{constructor(g,a){this.description=g,this.value=a}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var w;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(w=e.ActivationKind||(e.ActivationKind={}));function R(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation}}e.toExtension=R;function S(n,g){return{identifier:new C.ExtensionIdentifier(n.identifier.id),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!g,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid}}e.toExtensionDescription=S;class s{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(g){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(g,a){return Promise.resolve()}_onWillActivateExtension(g){}_onDidActivateExtension(g,a,E,r,t){}_onDidActivateExtensionError(g,a){}_onExtensionRuntimeError(g,a){}_onExtensionHostExit(g){}}e.NullExtensionService=s}),define(ve[225],we([0,1,15,27,30,11]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class I{constructor(v,w,R,S){this.startup=v,this.codeLoadingTime=w,this.activateCallTime=R,this.activateResolvedTime=S}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class y{constructor(v){this._startup=v,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(v,w){return v===-1||w===-1?-1:w-v}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class P{constructor(v,w,R,S,s,n){this.activationFailed=v,this.activationFailedError=w,this.activationTimes=R,this.module=S,this.exports=s,this.subscriptions=n}}e.ActivatedExtension=P;class L extends P{constructor(v){super(!1,null,v,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class D extends P{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=D;class c extends P{constructor(v){super(!0,v,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=c;let b=class{constructor(v,w,R,S,s){this._logService=s,this._isDisposed=!1,this._registry=v,this._resolvedExtensionsSet=new Set,w.forEach(n=>this._resolvedExtensionsSet.add(i.ExtensionIdentifier.toKey(n))),this._hostExtensionsMap=new Map,R.forEach(n=>this._hostExtensionsMap.set(i.ExtensionIdentifier.toKey(n),n)),this._host=S,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(v){const w=i.ExtensionIdentifier.toKey(v);return this._activatedExtensions.has(w)}getActivatedExtension(v){const w=i.ExtensionIdentifier.toKey(v),R=this._activatedExtensions.get(w);if(!R)throw new Error("Extension `"+v.value+"` is not known or not activated");return R}activateByEvent(v,w){if(this._alreadyActivatedEvents[v])return T;const R=this._registry.getExtensionDescriptionsForActivationEvent(v);return this._activateExtensions(R.map(S=>({id:S.identifier,reason:{startup:w,extensionId:S.identifier,activationEvent:v}}))).then(()=>{this._alreadyActivatedEvents[v]=!0})}activateById(v,w){const R=this._registry.getExtensionDescription(v);if(!R)throw new Error("Extension `"+v+"` is not known");return this._activateExtensions([{id:R.identifier,reason:w}])}_handleActivateRequest(v,w,R){if(this._hostExtensionsMap.has(i.ExtensionIdentifier.toKey(v.id))){w[i.ExtensionIdentifier.toKey(v.id)]=v;return}const S=this._registry.getExtensionDescription(v.id);if(!S){const g=new Error(`Cannot activate unknown extension '${v.id.value}'`);this._host.onExtensionActivationError(v.id,g,new k.MissingExtensionDependency(v.id.value)),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(v.id),new c(g));return}const s=typeof S.extensionDependencies=="undefined"?[]:S.extensionDependencies;let n=!0;for(let g=0,a=s.length;g<a;g++){const E=s[g];if(this._resolvedExtensionsSet.has(i.ExtensionIdentifier.toKey(E)))continue;const r=this._activatedExtensions.get(i.ExtensionIdentifier.toKey(E));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const u=S.displayName||S.identifier.value,d=this._registry.getExtensionDescription(E),f=d&&d.displayName||E,l=new Error(`Cannot activate the '${u}' extension because its dependency '${f}' failed to activate`);l.detail=r.activationFailedError,this._host.onExtensionActivationError(S.identifier,l,null),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(S.identifier),new c(l));return}if(this._hostExtensionsMap.has(i.ExtensionIdentifier.toKey(E))){n=!1,w[i.ExtensionIdentifier.toKey(E)]={id:this._hostExtensionsMap.get(i.ExtensionIdentifier.toKey(E)),reason:v.reason};continue}const t=this._registry.getExtensionDescription(E);if(t){if(!t.main&&!t.browser)continue;n=!1,w[i.ExtensionIdentifier.toKey(E)]={id:t.identifier,reason:v.reason};continue}const o=S.displayName||S.identifier.value,h=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${E}'`);this._host.onExtensionActivationError(S.identifier,h,new k.MissingExtensionDependency(E)),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(S.identifier),new c(h));return}n?w[i.ExtensionIdentifier.toKey(S.identifier)]=v:R.push(v)}_activateExtensions(v){if(v.length===0||(v=v.filter(s=>!this._activatedExtensions.has(i.ExtensionIdentifier.toKey(s.id))),v.length===0))return Promise.resolve(void 0);const w=Object.create(null),R=[];for(let s=0,n=v.length;s<n;s++)this._handleActivateRequest(v[s],w,R);for(let s=0,n=R.length;s<n;s++){const g=i.ExtensionIdentifier.toKey(R[s].id);w[g]&&delete w[g]}const S=Object.keys(w).map(s=>w[s]);return R.length===0?Promise.all(S.map(s=>this._activateExtension(s.id,s.reason))).then(s=>{}):this._activateExtensions(S).then(s=>this._activateExtensions(R))}_activateExtension(v,w){const R=i.ExtensionIdentifier.toKey(v);if(this._activatedExtensions.has(R))return Promise.resolve(void 0);const S=this._activatingExtensions.get(R);if(S)return S;const s=this._host.actualActivateExtension(v,w).then(void 0,n=>{const g=new Error;return n&&n.name&&(g.name=n.name),n&&n.message?g.message=`Activating extension '${v.value}' failed: ${n.message}.`:g.message=`Activating extension '${v.value}' failed: ${n}.`,n&&n.stack&&(g.stack=n.stack),this._isDisposed&&m.isPromiseCanceledError(n)?new c(n):(this._host.onExtensionActivationError(v,g,null),this._logService.error(`Activating extension ${v.value} failed due to an error:`),this._logService.error(n),new c(n))}).then(n=>{this._activatedExtensions.set(R,n),this._activatingExtensions.delete(R)});return this._activatingExtensions.set(R,s),s}};b=je([He(4,C.ILogService)],b),e.ExtensionsActivator=b}),define(ve[226],we([0,1,11,26,30]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends m.LogService{constructor(I,y){super(I.createLogger(y.logFile,{name:k.ExtensionHostLogFileName}))}};C=je([He(0,m.ILoggerService),He(1,i.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(ve[227],we([0,1,15]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class i{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,T)=>{this._actualOk=C,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,m.onUnexpectedError)(C))}then(C,T){return this._ensureActual().then(C,T)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=i}),define(ve[53],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(P,L){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=L,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const i=[];function k(y){const P=new m(!0,y);return i[P.nid]=P,P}e.createMainContextProxyIdentifier=k;function C(y){const P=new m(!1,y);return i[P.nid]=P,P}e.createExtHostContextProxyIdentifier=C;function T(y){return i[y].sid}e.getStringIdentifierForProxy=T;class I{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=I}),define(ve[5],we([0,1,59,2,53]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var T;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var L;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(L=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var D;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(D=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(s){s.name="$ident";function n(a,E){return Object.defineProperty(a,s.name,{value:E,enumerable:!0}),a}s.mixin=n;function g(a){return a[s.name]}s.of=g})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class b{static mixin(n){return n._id=b._n++,n}}e.IdObject=b,b._n=0;var p;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.command="m",s.kindModifier="n"})(p=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(s){s[s.File=1]="File",s[s.Text=2]="Text",s[s.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function R(s){if(s&&s.edits)for(const n of s.edits)typeof n.resource=="object"?n.resource=i.URI.revive(n.resource):(n.newUri=i.URI.revive(n.newUri),n.oldUri=i.URI.revive(n.oldUri)),n.metadata&&n.metadata.iconPath&&(n.metadata=(0,m.revive)(n.metadata));return s}e.reviveWorkspaceEditDto=R;var S;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,k.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ve[90],we([0,1,5,3,4]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(I){this._onDidChangePassword=new i.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,y){return this._proxy.$getPassword(I,y)}store(I,y,P){return this._proxy.$setPassword(I,y,P)}delete(I,y){return this._proxy.$deletePassword(I,y)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(ve[66],we([0,1,4,11,5,14]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(y,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(k.MainContext.MainThreadTelemetry)}report(y,P,L){const D=this.getUsageKey(y,P);this._reportedUsages.has(D)||(this._reportedUsages.add(D),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:y}))}getUsageKey(y,P){return`${y}-${P.identifier.value}`}};T=je([He(0,C.IExtHostRpcService),He(1,i.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(I,y,P){}})}),define(ve[228],we([0,1,3,5,7,27]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(i.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,P,L,D={}){const c=C.ExtensionIdentifier.toKey(y.identifier),b=this._inFlightRequests.get(c)||[],p=[...L].sort().join(" ");let v=b.find(w=>w.scopes===p);if(v)return v.result;{const w=this._getSession(y,c,P,L,D);v={scopes:p,result:w},b.push(v),this._inFlightRequests.set(c,b);try{await w}finally{const R=b.findIndex(S=>S.scopes===p);R>-1&&(b.splice(R),this._inFlightRequests.set(c,b))}return w}}async _getSession(y,P,L,D,c={}){await this._proxy.$ensureProvider(L);const b=y.displayName||y.name;return this._proxy.$getSession(L,D,P,b,c)}async removeSession(y,P){const L=this._authenticationProviders.get(y);return L?L.provider.removeSession(P):this._proxy.$removeSession(y,P)}registerAuthenticationProvider(y,P,L,D){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:P,provider:L,options:D??{supportsMultipleAccounts:!1}}),this._providers.find(b=>b.id===y)||this._providers.push({id:y,label:P});const c=L.onDidChangeSessions(b=>{this._proxy.$sendDidChangeSessions(y,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,P,D?.supportsMultipleAccounts??!1),new k.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(y);const b=this._providers.findIndex(p=>p.id===y);b>-1&&this._providers.splice(b),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,P){const L=this._authenticationProviders.get(y);if(L)return Promise.resolve(L.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,P){const L=this._authenticationProviders.get(y);if(L)return Promise.resolve(L.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,P){const L=this._authenticationProviders.get(y);if(L)return Promise.resolve(L.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,P){return this._onDidChangeSessions.fire({provider:{id:y,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(ve[229],we([0,1,5,14,17]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(I,y){this._extHostDocumentsAndEditors=y,this._proxy=I.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const y=k.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};C=je([He(0,i.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(ve[230],we([0,1,5]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class i{constructor(C){const T=C.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(I){return T.$writeText(I)}})}}e.ExtHostClipboard=i});var tt=this&&this.__classPrivateFieldSet||function(X,e,m,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,m):k?k.value=m:e.set(X,m),m},Le=this&&this.__classPrivateFieldGet||function(X,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(X):i?i.value:e.get(X)};define(ve[38],we([0,1,13,7,17,25,5,16,11,59,41,49,2,6,4,14,64,22,53,50]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S,s){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let g=class{constructor(h,u){n.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,tt(this,n,h.getProxy(T.MainContext.MainThreadCommands),"f"),this._logService=u,this.converter=new a(this,d=>{const f=this._apiCommands.get(d);return f?.result===r.Void?f:void 0},u),this._argumentProcessors=[{processArgument(d){return(0,P.revive)(d)}},{processArgument(d){return(0,C.cloneAndChange)(d,function(f){if(L.Range.isIRange(f))return k.Range.to(f);if(D.Position.isIPosition(f))return k.Position.to(f);if(L.Range.isIRange(f.range)&&c.URI.isUri(f.uri))return k.location.to(f);if(f instanceof R.VSBuffer)return f.buffer.buffer;if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(h){this._argumentProcessors.push(h)}registerApiCommand(h){const u=this.registerCommand(!1,h.id,async(...d)=>{const f=h.args.map((_,A)=>{if(!_.validate(d[A]))throw new Error(`Invalid argument '${_.name}' when running '${h.id}', received: ${d[A]}`);return _.convert(d[A])}),l=await this.executeCommand(h.internalId,...f);return h.result.convert(l,d,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this._apiCommands.set(h.id,h),new i.Disposable(()=>{u.dispose(),this._apiCommands.delete(h.id)})}registerCommand(h,u,d,f,l,_){if(this._logService.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this._commands.has(u))throw new Error(`command '${u}' already exists`);return this._commands.set(u,{callback:d,thisArg:f,description:l,extension:_}),h&&Le(this,n,"f").$registerCommand(u),new i.Disposable(()=>{this._commands.delete(u)&&h&&Le(this,n,"f").$unregisterCommand(u)})}executeCommand(h,...u){return this._logService.trace("ExtHostCommands#executeCommand",h),this._doExecuteCommand(h,u,!0)}async _doExecuteCommand(h,u,d){if(this._commands.has(h))return this._executeContributedCommand(h,u,!1);{let f=!1;const l=(0,C.cloneAndChange)(u,function(_){if(_ instanceof i.Position)return k.Position.from(_);if(_ instanceof i.Range)return k.Range.from(_);if(_ instanceof i.Location)return k.location.from(_);if(i.NotebookRange.isNotebookRange(_))return k.NotebookRange.from(_);if(_ instanceof ArrayBuffer)return f=!0,R.VSBuffer.wrap(new Uint8Array(_));if(_ instanceof Uint8Array)return f=!0,R.VSBuffer.wrap(_);if(!Array.isArray(_))return _});try{const _=await Le(this,n,"f").$executeCommand(h,f?new S.SerializableObjectWithBuffers(l):l,d);return(0,P.revive)(_)}catch(_){if(_ instanceof Error&&_.message==="$executeCommand:retry")return this._doExecuteCommand(h,u,!1);throw _}}}async _executeContributedCommand(h,u,d){const f=this._commands.get(h);if(!f)throw new Error("Unknown command");let{callback:l,thisArg:_,description:A}=f;if(A)for(let N=0;N<A.args.length;N++)try{(0,m.validateConstraint)(u[N],A.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${A.args[N].name}' - ${A.args[N].description}`)}try{return await l.apply(_,u)}catch(N){if(h===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...u);x&&(h=x.command)}throw this._logService.error(N,h,f.extension?.identifier),d?new class extends Error{constructor(){super((0,s.toErrorMessage)(N));this.id=h,this.source=f.extension?.displayName??f.extension?.name}}:N}}$executeContributedCommand(h,...u){return this._logService.trace("ExtHostCommands#$executeContributedCommand",h),this._commands.has(h)?(u=u.map(d=>this._argumentProcessors.reduce((f,l)=>l.processArgument(f),d)),this._executeContributedCommand(h,u,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this._logService.trace("ExtHostCommands#getCommands",h),Le(this,n,"f").$getCommands().then(u=>(h&&(u=u.filter(d=>d[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const h=Object.create(null);for(let[u,d]of this._commands){let{description:f}=d;f&&(h[u]=f)}return Promise.resolve(h)}};n=new WeakMap,g=je([He(0,v.IExtHostRpcService),He(1,y.ILogService)],g),e.ExtHostCommands=g,e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class a{constructor(h,u,d){this._commands=h,this._lookupApiCommand=u,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(h,u){if(!h)return;const d={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return d;const f=this._lookupApiCommand(h.command);if(f)d.id=f.internalId,d.arguments=f.args.map((l,_)=>l.convert(h.arguments&&h.arguments[_]));else if((0,I.isNonEmptyArray)(h.arguments)){const l=++this._cachIdPool;this._cache.set(l,h),u.add((0,b.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),d.$ident=l,d.id=this.delegatingCommandId,d.arguments=[l],this._logService.trace("CommandsConverter#CREATE",h.command,l)}return d}fromInternal(h){const u=T.ObjectIdentifier.of(h);return typeof u=="number"?this._cache.get(u):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this._cache.get(h[0])}_executeConvertedCommand(...h){const u=this.getActualCommand(...h);return this._logService.trace("CommandsConverter#EXECUTE",h[0],u?u.command:"MISSING"),u?this._commands.executeCommand(u.command,...u.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=a;class E{constructor(h,u,d,f){this.name=h,this.description=u,this.validate=d,this.convert=f}optional(){return new E(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,u){return new E(h??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",o=>c.URI.isUri(o),o=>o),E.Position=new E("position","A position in a text document",o=>i.Position.isPosition(o),k.Position.from),E.Range=new E("range","A range in a text document",o=>i.Range.isRange(o),k.Range.from),E.Selection=new E("selection","A selection in a text document",o=>i.Selection.isSelection(o),k.Selection.from),E.Number=new E("number","",o=>typeof o=="number",o=>o),E.String=new E("string","",o=>typeof o=="string",o=>o),E.CallHierarchyItem=new E("item","A call hierarchy item",o=>o instanceof i.CallHierarchyItem,k.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",o=>o instanceof i.TypeHierarchyItem,k.TypeHierarchyItem.from),E.TestItem=new E("testItem","A VS Code TestItem",o=>o instanceof w.TestItemImpl,k.TestItem.from);class r{constructor(h,u){this.description=h,this.convert=u}}e.ApiCommandResult=r,r.Void=new r("no result",o=>o);class t{constructor(h,u,d,f,l){this.id=h,this.internalId=u,this.description=d,this.args=f,this.result=l}}e.ApiCommand=t}),define(ve[231],we([0,1,17,7,84,38,16,111]),function(X,e,m,i,k,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",L(m.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,b)=>{if((0,T.isFalsyOrEmpty)(c))return;class p extends i.SymbolInformation{static to(w){const R=new p(w.name,m.SymbolKind.to(w.kind),w.containerName||"",new i.Location(b[0],m.Range.to(w.range)));return R.detail=w.detail,R.range=R.location.range,R.selectionRange=m.Range.to(w.selectionRange),R.children=w.children?w.children.map(p.to):[],R}}return c.map(p.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(m.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",D)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",D)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",D)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",D)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",L(m.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",L(m.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(b=>i.Position.isPosition(b)),c=>c.map(m.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(b=>{let p;for(const v of b.reverse())p=new i.SelectionRange(m.Range.to(v),p);return p}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(m.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(m.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(m.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(m.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",c=>{if(!!c)return{range:m.Range.to(c.range),placeholder:c.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return m.WorkspaceEdit.to(c)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(m.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new i.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const b=(0,I.decodeSemanticTokensDto)(c);if(b.type==="full")return new i.SemanticTokens(b.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new i.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const b=(0,I.decodeSemanticTokensDto)(c);if(b.type==="full")return new i.SemanticTokens(b.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,b,p)=>{if(!c)return new i.CompletionList([]);const v=c.suggestions.map(w=>m.CompletionItem.to(w,p));return new i.CompletionList(v,c.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return m.SignatureHelp.to(c)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,b,p)=>L(v=>new i.CodeLens(m.Range.to(v.range),v.command&&p.fromInternal(v.command)))(c))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>i.Range.isRange(c),c=>i.Selection.isSelection(c)?m.Selection.from(c):m.Range.from(c)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,b,p)=>L(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(v.command)}else{const w=new i.CodeAction(v.title,v.kind?new i.CodeActionKind(v.kind):void 0);return v.edit&&(w.edit=m.WorkspaceEdit.to(v.edit)),v.command&&(w.command=p.fromInternal(v.command)),w.isPreferred=v.isPreferred,w}})(c))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(b=>new i.ColorInformation(m.Range.to(b.range),m.Color.to(b.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",c=>c instanceof i.Color,m.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:m.Range.from(c.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(m.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(m.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",L(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(b=>m.NotebookExclusiveDocumentPattern.to(b))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(m.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[m.ViewColumn.from(c),void 0]:[m.ViewColumn.from(c.viewColumn),m.TextEditorOpenOptions.from(c)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[m.ViewColumn.from(c),void 0]:[m.ViewColumn.from(c.viewColumn),m.TextEditorOpenOptions.from(c)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[m.ViewColumn.from(c.viewColumn),m.TextEditorOpenOptions.from(c)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class P{static register(b){y.forEach(b.registerApiCommand,b)}}e.ExtHostApiCommands=P;function L(c){return b=>{if(Array.isArray(b))return b.map(c)}}function D(c){if(!Array.isArray(c))return;const b=[];for(const p of c)k.isLocationLink(p)?b.push(m.DefinitionLink.to(p)):b.push(m.location.to(p));return b}}),define(ve[232],we([0,1,18,57,3,6,2,84,27,17,7,5]),function(X,e,m,i,k,C,T,I,y,P,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(b,p,v){const w=b.getProxy(D.MainContext.MainThreadComments);class R{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,p.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const o=this._commentControllers.get(t.handle);return o||t}else if(t&&t.$mid===7){const o=this._commentControllers.get(t.commentControlHandle);if(!o)return t;const h=o.getCommentThread(t.commentThreadHandle);return h||t}else if(t&&t.$mid===8){const o=this._commentControllers.get(t.thread.commentControlHandle);if(!o)return t;const h=o.getCommentThread(t.thread.commentThreadHandle);return h?{thread:h,text:t.text}:t}else if(t&&t.$mid===9){const o=this._commentControllers.get(t.thread.commentControlHandle);if(!o)return t;const h=o.getCommentThread(t.thread.commentThreadHandle);if(!h)return t;let u=t.commentUniqueId,d=h.getCommentByUniqueId(u);return d||t}else if(t&&t.$mid===10){const o=this._commentControllers.get(t.thread.commentControlHandle);if(!o)return t;const h=o.getCommentThread(t.thread.commentThreadHandle);if(!h)return t;let u=t.text,d=t.commentUniqueId,f=h.getCommentByUniqueId(d);return f?(f.body=u,f):t}return t}})}createCommentController(t,o,h){const u=R.handlePool++,d=new s(t,u,o,h);this._commentControllers.set(d.handle,d);const f=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(t.identifier))||[];return f.push(d),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(t.identifier),f),d.value}$createCommentThreadTemplate(t,o,h){const u=this._commentControllers.get(t);!u||u.$createCommentThreadTemplate(o,h)}async $updateCommentThreadTemplate(t,o,h){const u=this._commentControllers.get(t);!u||u.$updateCommentThreadTemplate(o,h)}$deleteCommentThread(t,o){const h=this._commentControllers.get(t);h&&h.$deleteCommentThread(o)}$provideCommentingRanges(t,o,h){const u=this._commentControllers.get(t);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const d=v.getDocument(T.URI.revive(o));return(0,m.asPromise)(()=>u.commentingRangeProvider.provideCommentingRanges(d,h)).then(f=>f?f.map(l=>P.Range.from(l)):void 0)}$toggleReaction(t,o,h,u,d){const f=this._commentControllers.get(t);return!f||!f.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const l=f.getCommentThread(o);if(l){const _=l.getCommentByUniqueId(u.uniqueIdInThread);if(f!==void 0&&_&&f.reactionHandler)return f.reactionHandler(_,a(d))}return Promise.resolve(void 0)})}dispose(){}}R.handlePool=0;class S{constructor(t,o,h,u,d,f,l){this._commentControllerHandle=o,this._id=h,this._uri=u,this._range=d,this._comments=f,this.handle=S._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),w.$createCommentThread(o,this.handle,this._id,this._uri,P.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=f,this._localDisposables.push({dispose:()=>{w.$deleteCommentThread(o,this.handle)}});const _=this;this.value={get uri(){return _.uri},get range(){return _.range},set range(A){_.range=A},get comments(){return _.comments},set comments(A){_.comments=A},get collapsibleState(){return _.collapsibleState},set collapsibleState(A){_.collapsibleState=A},get canReply(){return _.canReply},set canReply(A){_.canReply=A},get contextValue(){return _.contextValue},set contextValue(A){_.contextValue=A},get label(){return _.label},set label(A){_.label=A},dispose:()=>{_.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const t=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),o={};t("range")&&(o.range=P.Range.from(this._range)),t("label")&&(o.label=this.label),t("contextValue")&&(o.contextValue=this.contextValue??null),t("comments")&&(o.comments=this._comments.map(h=>n(this,h,this._commentsMap))),t("collapsibleState")&&(o.collapseState=E(this._collapseState)),t("canReply")&&(o.canReply=this.canReply),this.modifications={},w.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(t){for(let o of this._commentsMap){let h=o[0],u=o[1];if(t===u)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}S._handlePool=0,je([(0,i.debounce)(100)],S.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(t,o,h,u){this._extension=t,this._handle=o,this._id=h,this._label=u,this._threads=new Map,w.$registerCommentController(this.handle,h,u);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(f){d.options=f},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(f){d.commentingRangeProvider=f},get reactionHandler(){return d.reactionHandler},set reactionHandler(f){d.reactionHandler=f},createCommentThread(f,l,_){return d.createCommentThread(f,l,_).value},dispose:()=>{d.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{w.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,w.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,w.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,w.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,o,h,u){if(typeof t=="string"){const d=new S(this.id,this.handle,t,o,h,u,this._extension.identifier);return this._threads.set(d.handle,d),d}else{const d=new S(this.id,this.handle,void 0,t,o,h,this._extension.identifier);return this._threads.set(d.handle,d),d}}$createCommentThreadTemplate(t,o){const h=new S(this.id,this.handle,void 0,T.URI.revive(t),P.Range.to(o),[],this._extension.identifier);return h.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(t,o){let h=this._threads.get(t);h&&(h.range=P.Range.to(o))}$deleteCommentThread(t){let o=this._threads.get(t);o&&o.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function n(r,t,o){let h=o.get(t);h||(h=++r.commentHandle,o.set(t,h));const u=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:h,body:P.MarkdownString.from(t.body),userName:t.author.name,userIconPath:u,label:t.label,commentReactions:t.reactions?t.reactions.map(d=>g(d)):void 0}}function g(r){return{label:r.label,iconPath:r.iconPath?P.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function a(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?T.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function E(r){if(r!==void 0)switch(r){case L.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new R}e.createExtHostComments=c}),define(ve[131],we([0,1,2,5,7,4,14,11,16,9,8]),function(X,e,m,i,k,C,T,I,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let D=class bi{constructor(b,p){this._logService=p,this._provider=new Map,this._proxy=b.getProxy(i.MainContext.MainThreadDecorations)}registerFileDecorationProvider(b,p){const v=bi._handlePool++;this._provider.set(v,{provider:b,extensionId:p}),this._proxy.$registerDecorationProvider(v,p.value);const w=b.onDidChangeFileDecorations&&b.onDidChangeFileDecorations(R=>{if(!R){this._proxy.$onDidChange(v,null);return}let S=(0,y.asArray)(R);if(S.length<=bi._maxEventSize){this._proxy.$onDidChange(v,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",p.value,S.length);const s=S.map(a=>({uri:a,rank:(0,P.count)(a.path,"/")})),n=(0,y.groupBy)(s,(a,E)=>a.rank-E.rank||(0,P.compare)(a.uri.path,E.uri.path));let g=[];e:for(let a of n){let E;for(let r of a){let t=(0,L.dirname)(r.uri.path);if(E!==t&&(E=t,g.push(r.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(v,g)});return new k.Disposable(()=>{w?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(b,p,v){if(!this._provider.has(b))return Object.create(null);const w=Object.create(null),{provider:R,extensionId:S}=this._provider.get(b);return await Promise.all(p.map(async s=>{try{const{uri:n,id:g}=s,a=await Promise.resolve(R.provideFileDecoration(m.URI.revive(n),v));if(!a)return;try{k.FileDecoration.validate(a),w[g]=[a.propagate,a.tooltip,a.badge,a.color]}catch(E){this._logService.warn(`INVALID decoration from extension '${S.value}': ${E}`)}}catch(n){this._logService.error(n)}})),w}};D._handlePool=0,D._maxEventSize=250,D=je([He(0,T.IExtHostRpcService),He(1,I.ILogService)],D),e.ExtHostDecorations=D,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(X,e,m,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,m):k?k.value=m:e.set(X,m),m},Le=this&&this.__classPrivateFieldGet||function(X,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(X):i?i.value:e.get(X)};define(ve[233],we([0,1,163,117,2,5,7,17,3,11,24,44]),function(X,e,m,i,k,C,T,I,y,P,L,D){"use strict";var c,b,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(S,s,n,g,a,E){this._name=S,this._owner=s,this._maxDiagnosticsPerFile=n,c.set(this,void 0),b.set(this,void 0),p.set(this,void 0),this._isDisposed=!1,tt(this,p,new L.ResourceMap(r=>g.getComparisonKey(r)),"f"),tt(this,c,a,"f"),tt(this,b,E,"f")}dispose(){this._isDisposed||(Le(this,b,"f").fire([...Le(this,p,"f").keys()]),Le(this,c,"f")&&Le(this,c,"f").$clear(this._owner),Le(this,p,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(S,s){if(!S){this.clear();return}this._checkDisposed();let n=[];if(k.URI.isUri(S)){if(!s){this.delete(S);return}Le(this,p,"f").set(S,s.slice()),n=[S]}else if(Array.isArray(S)){n=[];let a;S=[...S].sort(v._compareIndexedTuplesByUri);for(const E of S){const[r,t]=E;if((!a||r.toString()!==a.toString())&&(a&&Le(this,p,"f").get(a).length===0&&Le(this,p,"f").delete(a),a=r,n.push(r),Le(this,p,"f").set(r,[])),t){const o=Le(this,p,"f").get(r);o&&o.push(...t)}else{const o=Le(this,p,"f").get(r);o&&(o.length=0)}}}if(Le(this,b,"f").fire(n),!Le(this,c,"f"))return;const g=[];for(let a of n){let E=[];const r=Le(this,p,"f").get(a);if(r)if(r.length>this._maxDiagnosticsPerFile){E=[];const t=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(let h of r)if(h.severity===t[o]&&E.push(I.Diagnostic.from(h))===this._maxDiagnosticsPerFile)break e;E.push({severity:i.MarkerSeverity.Info,message:(0,m.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:E[E.length-1].startLineNumber,startColumn:E[E.length-1].startColumn,endLineNumber:E[E.length-1].endLineNumber,endColumn:E[E.length-1].endColumn})}else E=r.map(t=>I.Diagnostic.from(t));g.push([a,E])}Le(this,c,"f").$changeMany(this._owner,g)}delete(S){this._checkDisposed(),Le(this,b,"f").fire([S]),Le(this,p,"f").delete(S),Le(this,c,"f")&&Le(this,c,"f").$changeMany(this._owner,[[S,void 0]])}clear(){this._checkDisposed(),Le(this,b,"f").fire([...Le(this,p,"f").keys()]),Le(this,p,"f").clear(),Le(this,c,"f")&&Le(this,c,"f").$clear(this._owner)}forEach(S,s){this._checkDisposed();for(let n of Le(this,p,"f").keys())S.apply(s,[n,this.get(n),this])}get(S){this._checkDisposed();const s=Le(this,p,"f").get(S);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(S){return this._checkDisposed(),Array.isArray(Le(this,p,"f").get(S))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(S,s){return S[0].toString()<s[0].toString()?-1:S[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=v,c=new WeakMap,b=new WeakMap,p=new WeakMap;let w=class si{constructor(S,s,n){this._logService=s,this._fileSystemInfoService=n,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,si._mapper),this._proxy=S.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(S){const s=new L.ResourceMap;for(const n of S)s.set(n,n);return{uris:Object.freeze(Array.from(s.values()))}}createDiagnosticCollection(S,s){const{_collections:n,_proxy:g,_onDidChangeDiagnostics:a,_logService:E,_fileSystemInfoService:r}=this,t=new class{$changeMany(u,d){g.$changeMany(u,d),E.trace("[DiagnosticCollection] change many (extension, owner, uris)",S.value,u,d.length===0?"CLEARING":d)}$clear(u){g.$clear(u),E.trace("[DiagnosticCollection] remove all (extension, owner)",S.value,u)}dispose(){g.dispose()}};let o;if(!s)s="_generated_diagnostic_collection_name_#"+si._idPool++,o=s;else if(!n.has(s))o=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do o=s+si._idPool++;while(n.has(o))}return new class extends v{constructor(){super(s,o,si._maxDiagnosticsPerFile,r.extUri,t,a);n.set(o,this)}dispose(){super.dispose(),n.delete(o)}}}getDiagnostics(S){if(S)return this._getDiagnostics(S);{const s=new Map,n=[];for(const g of this._collections.values())g.forEach((a,E)=>{let r=s.get(a.toString());typeof r=="undefined"&&(r=n.length,s.set(a.toString(),r),n.push([a,[]])),n[r][1]=n[r][1].concat(...E)});return n}}_getDiagnostics(S){let s=[];for(let n of this._collections.values())n.has(S)&&(s=s.concat(n.get(S)));return s}$acceptMarkersChange(S){if(!this._mirrorCollection){const s="_generated_mirror",n=new v(s,s,si._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,n),this._mirrorCollection=n}for(const[s,n]of S)this._mirrorCollection.set(k.URI.revive(s),n.map(I.Diagnostic.to))}};w._idPool=0,w._maxDiagnosticsPerFile=1e3,w=je([He(1,P.ILogService),He(2,D.IExtHostFileSystemInfo)],w),e.ExtHostDiagnostics=w}),define(ve[234],we([0,1,2,5]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(T){this._proxy=T.getProxy(i.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(I=>I?I.map(y=>m.URI.revive(y)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(I=>I?m.URI.revive(I):void 0)}}e.ExtHostDialogs=k}),define(ve[235],we([0,1,15,2,7,5,10,21,9]),function(X,e,m,i,k,C,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(D,c,b){this._documentsAndEditors=c,this._logService=b,this._documentContentProviders=new Map,this._proxy=D.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,c){if(Object.keys(T.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=P._handlePool++;this._documentContentProviders.set(b,c),this._proxy.$registerTextContentProvider(b,D);let p;return typeof c.onDidChange=="function"&&(p=c.onDidChange(v=>{if(v.scheme!==D){this._logService.warn(`Provider for scheme '${D}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(b,v).then(w=>{if(!w&&typeof w!="string")return;const R=this._documentsAndEditors.getDocument(v);if(!R)return;const S=(0,y.splitLines)(w);if(!R.equalLines(S))return this._proxy.$onVirtualDocumentChange(v,w)},m.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(b)&&this._proxy.$unregisterTextContentProvider(b),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(D,c){const b=this._documentContentProviders.get(D);return b?Promise.resolve(b.provideTextDocumentContent(i.URI.revive(c),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(ve[236],we([0,1,3,6,2,5,123,17,13,25,7]),function(X,e,m,i,k,C,T,I,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(b,p){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new i.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const w of v)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const w of v)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!b)return;const p=this._documentsAndEditors.getDocument(b);if(p)return p}getDocument(b){const p=this.getDocumentData(b);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return p.document}ensureDocumentData(b){const p=this._documentsAndEditors.getDocument(b);if(p)return Promise.resolve(p);let v=this._documentLoader.get(b.toString());return v||(v=this._proxy.$tryOpenDocument(b).then(w=>{this._documentLoader.delete(b.toString());const R=k.URI.revive(w);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(R))},w=>(this._documentLoader.delete(b.toString()),Promise.reject(w))),this._documentLoader.set(b.toString(),v)),v}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(p=>k.URI.revive(p))}$acceptModelLanguageChanged(b,p){const v=k.URI.revive(b),w=this._documentsAndEditors.getDocument(v);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(p),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(b){const p=k.URI.revive(b),v=this._documentsAndEditors.getDocument(p);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(b,p){const v=k.URI.revive(b),w=this._documentsAndEditors.getDocument(v);if(!w)throw new Error("unknown document");w._acceptIsDirty(p),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,p,v){const w=k.URI.revive(b),R=this._documentsAndEditors.getDocument(w);if(!R)throw new Error("unknown document");R._acceptIsDirty(v),R.onEvents(p);let S;p.isUndoing?S=L.TextDocumentChangeReason.Undo:p.isRedoing&&(S=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:R.document,contentChanges:p.changes.map(s=>({range:I.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:S}))}setWordDefinitionFor(b,p){(0,T.setWordDefinitionFor)(b,p)}}e.ExtHostDocuments=D}),define(ve[45],we([0,1,56,3,6,2,4,5,123,14,130,17,11,24,10,78,93]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class R{constructor(n){this.value=n,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(n,g){this._extHostRpc=n,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new b.ResourceMap,this._onDidAddDocuments=new i.Emitter,this._onDidRemoveDocuments=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const g=[],a=[],E=[];if(n.removedDocuments)for(const r of n.removedDocuments){const t=C.URI.revive(r),o=this._documents.get(t);o?.unref()&&(this._documents.delete(t),g.push(o.value))}if(n.addedDocuments)for(const r of n.addedDocuments){const t=C.URI.revive(r.uri);let o=this._documents.get(t);if(o&&t.scheme!==p.Schemas.vscodeNotebookCell&&t.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);o||(o=new R(new y.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),t,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(t,o),a.push(o.value)),o.ref()}if(n.removedEditors)for(const r of n.removedEditors){const t=this._editors.get(r);this._editors.delete(r),t&&E.push(t)}if(n.addedEditors)for(const r of n.addedEditors){const t=C.URI.revive(r.documentUri);m.ok(this._documents.has(t),`document '${t}' does not exist`),m.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const o=this._documents.get(t).value,h=new L.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>o.document),r.selections.map(D.Selection.to),r.options,r.visibleRanges.map(u=>D.Range.to(u)),typeof r.editorPosition=="number"?D.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,h)}n.newActiveEditor!==void 0&&(m.ok(n.newActiveEditor===null||this._editors.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this._activeEditorId=n.newActiveEditor),(0,k.dispose)(g),(0,k.dispose)(E),n.removedDocuments&&this._onDidRemoveDocuments.fire(g),n.addedDocuments&&this._onDidAddDocuments.fire(a),(n.removedEditors||n.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),n.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(n){return this._documents.get(n)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),n=>n.value)}getEditor(n){return this._editors.get(n)}activeEditor(n){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return n?g:g?.value}allEditors(){return[...this._editors.values()]}};S=je([He(0,P.IExtHostRpcService),He(1,c.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[54],we([0,1,17,5,2,3,4,14,18]),function(X,e,m,i,k,C,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");let P=class{constructor(D){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=D.getProxy(i.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(D){let c=-1;this._tabs=D.map((p,v)=>(p.isActive&&(c=v),Object.freeze({label:p.label,viewColumn:m.ViewColumn.to(p.viewColumn),index:v,resource:k.URI.revive(p.resource),additionalResourcesAndViewIds:p.additionalResourcesAndViewIds.map(({resource:w,viewId:R})=>({resource:k.URI.revive(w),viewId:R})),viewId:p.editorId,isActive:p.isActive,move:async(w,R)=>{this._proxy.$moveTab(p,w,m.ViewColumn.from(R)),await(0,y.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(p),await(0,y.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((p,v)=>p.viewColumn===v.viewColumn?p.index-v.index:p.viewColumn-v.viewColumn);const b=this._activeTab;this._activeTab=c===-1?void 0:this._tabs[c],this._activeTab!==b&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};P=je([He(0,I.IExtHostRpcService)],P),e.ExtHostEditorTabs=P}),define(ve[237],we([0,1,2,5,6,7,17,147,9,22,30]),function(X,e,m,i,k,C,T,I,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const v=this._schemes.indexOf(p);v>=0&&(this._schemes.splice(v,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),v=[];let w,R,S=14,s=14;for(const n of p){let g=w?(0,y.commonPrefixLength)(w,n):0;for(g===0?R=1:R=s;g<n.length;g++)g+1===n.length?(S=s,s=9):s+=1,v.push([R,n.toUpperCase().charCodeAt(g),s]),v.push([R,n.toLowerCase().charCodeAt(g),s]),R=s;w=n,s=S}v.push([9,58,10]),v.push([10,47,12]),this._stateMachine=new I.StateMachine(v)}}provideDocumentLinks(p){this._initStateMachine();const v=[],w=I.LinkComputer.computeLinks({getLineContent(R){return p.lineAt(R-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const R of w){const S=T.DocumentLink.to(R);S.target&&v.push(S)}return v}}class c{constructor(p,v){this._extHostLanguageFeatures=v,this._linkProvider=new D,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(i.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(p,v,w,R={}){if(this._registeredSchemes.has(v))throw new Error(`a provider for the scheme '${v}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const S=this._handlePool++;this._linkProvider.add(v),this._registeredSchemes.add(v),this._fsProvider.set(S,w);let s=2;R.isCaseSensitive&&(s+=1024),R.isReadonly&&(s+=2048),typeof w.copy=="function"&&(s+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&((0,L.checkProposedApiEnabled)(p,"fsChunks"),s+=4),this._proxy.$registerFileSystemProvider(S,v,s).catch(g=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${v}`),console.error(g)});const n=w.onDidChangeFile(g=>{const a=[];for(const E of g){let{uri:r,type:t}=E;if(r.scheme!==v)continue;let o;switch(t){case C.FileChangeType.Changed:o=0;break;case C.FileChangeType.Created:o=1;break;case C.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:r,type:o})}this._proxy.$onFileSystemChange(S,a)});return(0,k.toDisposable)(()=>{n.dispose(),this._linkProvider.delete(v),this._registeredSchemes.delete(v),this._fsProvider.delete(S),this._proxy.$unregisterProvider(S)})}static _asIStat(p){const{type:v,ctime:w,mtime:R,size:S,permissions:s}=p;return{type:v,ctime:w,mtime:R,size:S,permissions:s}}$stat(p,v){return Promise.resolve(this._getFsProvider(p).stat(m.URI.revive(v))).then(w=>c._asIStat(w))}$readdir(p,v){return Promise.resolve(this._getFsProvider(p).readDirectory(m.URI.revive(v)))}$readFile(p,v){return Promise.resolve(this._getFsProvider(p).readFile(m.URI.revive(v))).then(w=>P.VSBuffer.wrap(w))}$writeFile(p,v,w,R){return Promise.resolve(this._getFsProvider(p).writeFile(m.URI.revive(v),w.buffer,R))}$delete(p,v,w){return Promise.resolve(this._getFsProvider(p).delete(m.URI.revive(v),w))}$rename(p,v,w,R){return Promise.resolve(this._getFsProvider(p).rename(m.URI.revive(v),m.URI.revive(w),R))}$copy(p,v,w,R){const S=this._getFsProvider(p);if(!S.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(S.copy(m.URI.revive(v),m.URI.revive(w),R))}$mkdir(p,v){return Promise.resolve(this._getFsProvider(p).createDirectory(m.URI.revive(v)))}$watch(p,v,w,R){const S=this._getFsProvider(p).watch(m.URI.revive(w),R);this._watches.set(v,S)}$unwatch(p,v){const w=this._watches.get(v);w&&(w.dispose(),this._watches.delete(v))}$open(p,v,w){const R=this._getFsProvider(p);if(!R.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(R.open(m.URI.revive(v),w))}$close(p,v){const w=this._getFsProvider(p);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(v))}$read(p,v,w,R){const S=this._getFsProvider(p);if(!S.read)throw new Error('FileSystemProvider does not implement "read"');const s=P.VSBuffer.alloc(R);return Promise.resolve(S.read(v,w,s.buffer,0,R)).then(n=>s.slice(0,n))}$write(p,v,w,R){const S=this._getFsProvider(p);if(!S.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(S.write(v,w,R.buffer,0,R.byteLength))}_getFsProvider(p){const v=this._fsProvider.get(p);if(!v){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return v}}e.ExtHostFileSystem=c}),define(ve[67],we([0,1,5,42,7,22,4,14,44,6]),function(X,e,m,i,k,C,T,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class $t{constructor(c,b){this._fileSystemProvider=new Map,this._proxy=c.getProxy(m.MainContext.MainThreadFileSystem);const p=this;this.value=Object.freeze({async stat(v){try{const w=p._fileSystemProvider.get(v.scheme);if(!w)return await p._proxy.$stat(v);await p._proxy.$ensureActivation(v.scheme);const R=await w.stat(v);return{type:R.type,ctime:R.ctime,mtime:R.mtime,size:R.size,permissions:R.permissions}}catch(w){$t._handleError(w)}},async readDirectory(v){try{const w=p._fileSystemProvider.get(v.scheme);return w?(await p._proxy.$ensureActivation(v.scheme),(await w.readDirectory(v)).slice()):await p._proxy.$readdir(v)}catch(w){return $t._handleError(w)}},async createDirectory(v){try{return await p._proxy.$mkdir(v)}catch(w){return $t._handleError(w)}},async readFile(v){try{const w=p._fileSystemProvider.get(v.scheme);return w?(await p._proxy.$ensureActivation(v.scheme),(await w.readFile(v)).slice()):(await p._proxy.$readFile(v)).buffer}catch(w){return $t._handleError(w)}},async writeFile(v,w){try{return await p._proxy.$writeFile(v,C.VSBuffer.wrap(w))}catch(R){return $t._handleError(R)}},async delete(v,w){try{const R=p._fileSystemProvider.get(v.scheme);return R?(await p._proxy.$ensureActivation(v.scheme),await R.delete(v,{recursive:!1,...w})):await p._proxy.$delete(v,{recursive:!1,useTrash:!1,...w})}catch(R){return $t._handleError(R)}},async rename(v,w,R){try{return await p._proxy.$rename(v,w,{overwrite:!1,...R})}catch(S){return $t._handleError(S)}},async copy(v,w,R){try{return await p._proxy.$copy(v,w,{overwrite:!1,...R})}catch(S){return $t._handleError(S)}},isWritableFileSystem(v){const w=b.getCapabilities(v);if(typeof w=="number")return!(w&2048)}})}static _handleError(c){if(c instanceof k.FileSystemError)throw c;if(!(c instanceof Error))throw new k.FileSystemError(String(c));if(c.name==="ENOPRO")throw k.FileSystemError.Unavailable(c.message);switch(c.name){case i.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(c.message);case i.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(c.message);case i.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(c.message);case i.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(c.message);case i.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(c.message);case i.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(c.message);default:throw new k.FileSystemError(c.message,c.name)}}addFileSystemProvider(c,b){return this._fileSystemProvider.set(c,b),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(c))}};L=je([He(0,I.IExtHostRpcService),He(1,y.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[238],we([0,1,2,38]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(T,I,y,P){this._extHostNotebooks=I,this._textDocumentsAndEditors=y,this._commands=P;const L=new i.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new i.ApiCommandArgument("showOptions","Show Options",D=>!0,D=>D),new i.ApiCommandArgument("resource","Interactive resource Uri",D=>!0,D=>D),new i.ApiCommandArgument("controllerId","Notebook controller Id",D=>!0,D=>D),new i.ApiCommandArgument("title","Interactive editor title",D=>!0,D=>D)],new i.ApiCommandResult("Notebook and input URI",D=>{if(D.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(D.notebookEditorId);return{notebookUri:m.URI.revive(D.notebookUri),inputUri:m.URI.revive(D.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:m.URI.revive(D.notebookUri),inputUri:m.URI.revive(D.inputUri)}}));this._commands.registerApiCommand(L)}$willAddInteractiveDocument(T,I,y,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],languageId:y,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=k}),define(ve[239],we([0,1,6,5]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(T){this._handlePool=0,this._proxy=T.getProxy(i.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,T),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=k}),define(ve[240],we([0,1,2,25,17,7,5,9,41,16,13,145,6,111,77,87,46,15,3]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(q,Y){this._documents=q,this._provider=Y}async provideDocumentSymbols(q,Y){const re=this._documents.getDocument(q),ue=await this._provider.provideDocumentSymbols(re,Y);if(!(0,P.isFalsyOrEmpty)(ue))return ue[0]instanceof C.DocumentSymbol?ue.map(k.DocumentSymbol.from):s._asDocumentSymbolTree(ue)}static _asDocumentSymbolTree(q){q=q.slice(0).sort((ue,J)=>{let ae=ue.location.range.start.compareTo(J.location.range.start);return ae===0&&(ae=J.location.range.end.compareTo(ue.location.range.end)),ae});const Y=[],re=[];for(const ue of q){const J={name:ue.name||"!!MISSING: name!!",kind:k.SymbolKind.from(ue.kind),tags:ue.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:ue.containerName,range:k.Range.from(ue.location.range),selectionRange:k.Range.from(ue.location.range),children:[]};for(;;){if(re.length===0){re.push(J),Y.push(J);break}const ae=re[re.length-1];if(y.Range.containsRange(ae.range,J.range)&&!y.Range.equalsRange(ae.range,J.range)){ae.children&&ae.children.push(J),re.push(J);break}re.pop()}}return Y}}class n{constructor(q,Y,re){this._documents=q,this._commands=Y,this._provider=re,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,Y){const re=this._documents.getDocument(q),ue=await this._provider.provideCodeLenses(re,Y);if(!ue||Y.isCancellationRequested)return;const J=this._cache.add(ue),ae=new c.DisposableStore;this._disposables.set(J,ae);const Ee={cacheId:J,lenses:[]};for(let Oe=0;Oe<ue.length;Oe++)Ee.lenses.push({cacheId:[J,Oe],range:k.Range.from(ue[Oe].range),command:this._commands.toInternal(ue[Oe].command,ae)});return Ee}async resolveCodeLens(q,Y){const re=q.cacheId&&this._cache.get(...q.cacheId);if(!re)return;let ue;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?ue=re:ue=await this._provider.resolveCodeLens(re,Y),ue||(ue=re),Y.isCancellationRequested)return;const J=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!J)return q.command=this._commands.toInternal(ue.command??n._badCmd,J),q}releaseCodeLenses(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}}n._badCmd={command:"missing",title:"!!MISSING: command!!"};function g(xe){return Array.isArray(xe)?xe.map(k.DefinitionLink.from):xe?[k.DefinitionLink.from(xe)]:[]}class a{constructor(q,Y){this._documents=q,this._provider=Y}async provideDefinition(q,Y,re){const ue=this._documents.getDocument(q),J=k.Position.to(Y),ae=await this._provider.provideDefinition(ue,J,re);return g(ae)}}class E{constructor(q,Y){this._documents=q,this._provider=Y}async provideDeclaration(q,Y,re){const ue=this._documents.getDocument(q),J=k.Position.to(Y),ae=await this._provider.provideDeclaration(ue,J,re);return g(ae)}}class r{constructor(q,Y){this._documents=q,this._provider=Y}async provideImplementation(q,Y,re){const ue=this._documents.getDocument(q),J=k.Position.to(Y),ae=await this._provider.provideImplementation(ue,J,re);return g(ae)}}class t{constructor(q,Y){this._documents=q,this._provider=Y}async provideTypeDefinition(q,Y,re){const ue=this._documents.getDocument(q),J=k.Position.to(Y),ae=await this._provider.provideTypeDefinition(ue,J,re);return g(ae)}}class o{constructor(q,Y){this._documents=q,this._provider=Y}async provideHover(q,Y,re){const ue=this._documents.getDocument(q),J=k.Position.to(Y),ae=await this._provider.provideHover(ue,J,re);if(!(!ae||(0,P.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=ue.getWordRangeAtPosition(J)),ae.range||(ae.range=new C.Range(J,J)),k.Hover.from(ae)}}class h{constructor(q,Y){this._documents=q,this._provider=Y}async provideEvaluatableExpression(q,Y,re){const ue=this._documents.getDocument(q),J=k.Position.to(Y),ae=await this._provider.provideEvaluatableExpression(ue,J,re);if(ae)return k.EvaluatableExpression.from(ae)}}class u{constructor(q,Y){this._documents=q,this._provider=Y}async provideInlineValues(q,Y,re,ue){const J=this._documents.getDocument(q),ae=await this._provider.provideInlineValues(J,k.Range.to(Y),k.InlineValueContext.to(re),ue);if(Array.isArray(ae))return ae.map(Ee=>k.InlineValue.from(Ee))}}class d{constructor(q,Y){this._documents=q,this._provider=Y}async provideDocumentHighlights(q,Y,re){const ue=this._documents.getDocument(q),J=k.Position.to(Y),ae=await this._provider.provideDocumentHighlights(ue,J,re);if(Array.isArray(ae))return ae.map(k.DocumentHighlight.from)}}class f{constructor(q,Y){this._documents=q,this._provider=Y}async provideLinkedEditingRanges(q,Y,re){const ue=this._documents.getDocument(q),J=k.Position.to(Y),ae=await this._provider.provideLinkedEditingRanges(ue,J,re);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,P.coalesce)(ae.ranges.map(k.Range.from)),wordPattern:ae.wordPattern}}}class l{constructor(q,Y){this._documents=q,this._provider=Y}async provideReferences(q,Y,re,ue){const J=this._documents.getDocument(q),ae=k.Position.to(Y),Ee=await this._provider.provideReferences(J,ae,re,ue);if(Array.isArray(Ee))return Ee.map(k.location.from)}}class _{constructor(q,Y,re,ue,J,ae,Ee){this._documents=q,this._commands=Y,this._diagnostics=re,this._provider=ue,this._logService=J,this._extension=ae,this._apiDeprecation=Ee,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(q,Y,re,ue){const J=this._documents.getDocument(q),ae=D.Selection.isISelection(Y)?k.Selection.to(Y):k.Range.to(Y),Ee=[];for(const at of this._diagnostics.getDiagnostics(q))if(ae.intersection(at.range)&&Ee.push(at)>_._maxCodeActionsPerFile)break;const Oe={diagnostics:Ee,only:re.only?new C.CodeActionKind(re.only):void 0,triggerKind:k.CodeActionTriggerKind.to(re.trigger)},Ve=await this._provider.provideCodeActions(J,ae,Oe,ue);if(!(0,P.isNonEmptyArray)(Ve)||ue.isCancellationRequested)return;const Ke=this._cache.add(Ve),Je=new c.DisposableStore;this._disposables.set(Ke,Je);const it=[];for(let at=0;at<Ve.length;at++){const et=Ve[at];!et||(_._isCommand(et)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:et.title,command:this._commands.toInternal(et,Je)})):(Oe.only&&(et.kind?Oe.only.contains(et.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[Ke,at],title:et.title,command:et.command&&this._commands.toInternal(et.command,Je),diagnostics:et.diagnostics&&et.diagnostics.map(k.Diagnostic.from),edit:et.edit&&k.WorkspaceEdit.from(et.edit),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,disabled:et.disabled?.reason})))}return{cacheId:Ke,actions:it}}async resolveCodeAction(q,Y){const[re,ue]=q,J=this._cache.get(re,ue);if(!J||_._isCommand(J)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(J,Y)??J;return ae?.edit?k.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}_._maxCodeActionsPerFile=1e3;class A{constructor(q,Y){this._documents=q,this._provider=Y}async provideDocumentFormattingEdits(q,Y,re){const ue=this._documents.getDocument(q),J=await this._provider.provideDocumentFormattingEdits(ue,Y,re);if(Array.isArray(J))return J.map(k.TextEdit.from)}}class N{constructor(q,Y){this._documents=q,this._provider=Y}async provideDocumentRangeFormattingEdits(q,Y,re,ue){const J=this._documents.getDocument(q),ae=k.Range.to(Y),Ee=await this._provider.provideDocumentRangeFormattingEdits(J,ae,re,ue);if(Array.isArray(Ee))return Ee.map(k.TextEdit.from)}}class x{constructor(q,Y){this._documents=q,this._provider=Y,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,Y,re,ue,J){const ae=this._documents.getDocument(q),Ee=k.Position.to(Y),Oe=await this._provider.provideOnTypeFormattingEdits(ae,Ee,re,ue,J);if(Array.isArray(Oe))return Oe.map(k.TextEdit.from)}}class F{constructor(q,Y){this._provider=q,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(q,Y){const re=T.IdObject.mixin({symbols:[]}),ue=await this._provider.provideWorkspaceSymbols(q,Y);if((0,P.isNonEmptyArray)(ue))for(const J of ue){if(!J)continue;if(!J.name){this._logService.warn("INVALID SymbolInformation, lacks name",J);continue}const ae=T.IdObject.mixin(k.WorkspaceSymbol.from(J));this._symbolCache.set(ae._id,J),re.symbols.push(ae)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(q,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return q;const re=this._symbolCache.get(q._id);if(re){const ue=await this._provider.resolveWorkspaceSymbol(re,Y);return ue&&(0,i.mixin)(q,k.WorkspaceSymbol.from(ue),!0)}}releaseWorkspaceSymbols(q){const Y=this._resultCache.get(q);if(Y){for(let[re,ue]=Y;re<=ue;re++)this._symbolCache.delete(re);this._resultCache.delete(q)}}}class O{constructor(q,Y,re){this._documents=q,this._provider=Y,this._logService=re}static supportsResolving(q){return typeof q.prepareRename=="function"}async provideRenameEdits(q,Y,re,ue){const J=this._documents.getDocument(q),ae=k.Position.to(Y);try{const Ee=await this._provider.provideRenameEdits(J,ae,re,ue);return Ee?k.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Oe=O._asMessage(Ee);return Oe?{rejectReason:Oe,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(q,Y,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ue=this._documents.getDocument(q),J=k.Position.to(Y);try{const ae=await this._provider.prepareRename(ue,J,re);let Ee,Oe;if(C.Range.isRange(ae)?(Ee=ae,Oe=ue.getText(ae)):(0,L.isObject)(ae)&&(Ee=ae.range,Oe=ae.placeholder),!Ee||!Oe)return;if(Ee.start.line>J.line||Ee.end.line<J.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(Ee),text:Oe}}catch(ae){const Ee=O._asMessage(ae);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class z{constructor(q,Y){this.resultId=q,this.tokens=Y}}class ${constructor(q,Y){this._documents=q,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(q,Y,re){const ue=this._documents.getDocument(q),J=Y!==0?this._previousResults.get(Y):null;let ae=typeof J?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ue,J.resultId,re):await this._provider.provideDocumentSemanticTokens(ue,re);return J&&this._previousResults.delete(Y),ae?(ae=$._fixProvidedSemanticTokens(ae),this._send($._convertToEdits(J,ae),ae)):null}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return $._isSemanticTokens(q)?$._isCorrectSemanticTokens(q)?q:new C.SemanticTokens(new Uint32Array(q.data),q.resultId):$._isSemanticTokensEdits(q)?$._isCorrectSemanticTokensEdits(q)?q:new C.SemanticTokensEdits(q.edits.map(Y=>new C.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const Y of q.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,Y){if(!$._isSemanticTokens(Y)||!q||!q.tokens)return Y;const re=q.tokens,ue=re.length,J=Y.data,ae=J.length;let Ee=0;const Oe=Math.min(ue,ae);for(;Ee<Oe&&re[Ee]===J[Ee];)Ee++;if(Ee===ue&&Ee===ae)return new C.SemanticTokensEdits([],Y.resultId);let Ve=0;const Ke=Oe-Ee;for(;Ve<Ke&&re[ue-Ve-1]===J[ae-Ve-1];)Ve++;return new C.SemanticTokensEdits([{start:Ee,deleteCount:ue-Ee-Ve,data:J.subarray(Ee,ae-Ve)}],Y.resultId)}_send(q,Y){if($._isSemanticTokens(q)){const re=this._nextResultId++;return this._previousResults.set(re,new z(q.resultId,q.data)),(0,b.encodeSemanticTokensDto)({id:re,type:"full",data:q.data})}if($._isSemanticTokensEdits(q)){const re=this._nextResultId++;return $._isSemanticTokens(Y)?this._previousResults.set(re,new z(Y.resultId,Y.data)):this._previousResults.set(re,new z(q.resultId)),(0,b.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(q.edits||[]).map(ue=>({start:ue.start,deleteCount:ue.deleteCount,data:ue.data}))})}return null}}e.DocumentSemanticTokensAdapter=$;class M{constructor(q,Y){this._documents=q,this._provider=Y}async provideDocumentRangeSemanticTokens(q,Y,re){const ue=this._documents.getDocument(q),J=await this._provider.provideDocumentRangeSemanticTokens(ue,k.Range.to(Y),re);return J?this._send(J):null}_send(q){return(0,b.encodeSemanticTokensDto)({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=M;class B{constructor(q,Y,re,ue,J){this._documents=q,this._commands=Y,this._provider=re,this._apiDeprecation=ue,this._extension=J,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,Y,re,ue){const J=this._documents.getDocument(q),ae=k.Position.to(Y),Ee=J.getWordRangeAtPosition(ae)||new C.Range(ae,ae),Oe=Ee.with({end:ae}),Ve=new w.StopWatch(!0),Ke=await this._provider.provideCompletionItems(J,ae,ue,k.CompletionContext.to(re));if(!Ke||ue.isCancellationRequested)return;const Je=Array.isArray(Ke)?new C.CompletionList(Ke):Ke,it=B.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),at=new c.DisposableStore;this._disposables.set(it,at);const et=[],nt={x:it,b:et,a:{replace:k.Range.from(Ee),insert:k.Range.from(Oe)},c:Je.isIncomplete||void 0,d:Ve.elapsed()};for(let ct=0;ct<Je.items.length;ct++){const vt=Je.items[ct],We=this._convertCompletionItem(vt,[it,ct],Oe,Ee);et.push(We)}return nt}async resolveCompletionItem(q,Y){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...q);if(!re)return;const ue=await this._provider.resolveCompletionItem(re,Y);if(!!ue)return this._convertCompletionItem(ue,q)}releaseCompletionItems(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,Y,re,ue){const J=this._disposables.get(Y[0]);if(!J)throw Error("DisposableStore is missing...");const ae={x:Y,a:q.label,b:q.kind!==void 0?k.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(k.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(q.command,J)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=q.textEdit.newText):typeof q.insertText=="string"?ae.h=q.insertText:q.insertText instanceof C.SnippetString&&(ae.h=q.insertText.value,ae.i|=4);let Ee;return q.textEdit?Ee=q.textEdit.range:q.range&&(Ee=q.range),C.Range.isRange(Ee)?ae.j=k.Range.from(Ee):Ee&&(!re?.isEqual(Ee.inserting)||!ue?.isEqual(Ee.replacing))&&(ae.j={insert:k.Range.from(Ee.inserting),replace:k.Range.from(Ee.replacing)}),ae}}class W{constructor(q,Y,re){this._documents=q,this._provider=Y,this._commands=re,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,Y,re,ue){const J=this._documents.getDocument(q),ae=k.Position.to(Y),Ee=await this._provider.provideInlineCompletionItems(J,ae,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:k.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text,isSnippetText:re.selectedSuggestionInfo.isSnippetText,completionKind:k.CompletionItemKind.to(re.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:re.triggerKind},ue);if(!Ee||ue.isCancellationRequested)return;const Oe=(0,L.isArray)(Ee)?{items:Ee}:Ee,Ve=this._cache.add(Oe.items);let Ke;return{pid:Ve,items:Oe.items.map((Je,it)=>{let at;return Je.command&&(Ke||(Ke=new c.DisposableStore,this._disposables.set(Ve,Ke)),at=this._commands.toInternal(Je.command,Ke)),{text:Je.text,range:Je.range?k.Range.from(Je.range):void 0,command:at,idx:it}})}}disposeCompletions(q){this._cache.delete(q);const Y=this._disposables.get(q);Y&&Y.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,Y){const re=this._cache.get(q,Y);re&&U.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class U{constructor(){this._onDidShowCompletionItemEmitter=new S.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let Y=U.map.get(q);return Y||(Y=new U,U.map.set(q,Y)),Y}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=U,U.map=new WeakMap;class j{constructor(q,Y){this._documents=q,this._provider=Y,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(q,Y,re,ue){const J=this._documents.getDocument(q),ae=k.Position.to(Y),Ee=this.reviveContext(re),Oe=await this._provider.provideSignatureHelp(J,ae,ue,Ee);if(Oe){const Ve=this._cache.add([Oe]);return{...k.SignatureHelp.from(Oe),id:Ve}}}reviveContext(q){let Y;if(q.activeSignatureHelp){const re=k.SignatureHelp.to(q.activeSignatureHelp),ue=this._cache.get(q.activeSignatureHelp.id,0);ue?(Y=ue,Y.activeSignature=re.activeSignature,Y.activeParameter=re.activeParameter):Y=re}return{...q,activeSignatureHelp:Y}}releaseSignatureHelp(q){this._cache.delete(q)}}class Z{constructor(q,Y){this._documents=q,this._provider=Y,this._cache=new v.Cache("InlayHints")}async provideInlayHints(q,Y,re){const ue=this._documents.getDocument(q),J=await this._provider.provideInlayHints(ue,k.Range.to(Y),re);if(!(!Array.isArray(J)||J.length===0)&&!re.isCancellationRequested){if(typeof this._provider.resolveInlayHint!="function")return{hints:J.map(k.InlayHint.from)};{const ae=this._cache.add(J),Ee={hints:[],cacheId:ae};for(let Oe=0;Oe<J.length;Oe++){const Ve=k.InlayHint.from(J[Oe]);Ve.cacheId=[ae,Oe],Ee.hints.push(Ve)}return Ee}}}async resolveInlayHint(q,Y){if(typeof this._provider.resolveInlayHint!="function")return;const re=this._cache.get(...q);if(!re)return;const ue=await this._provider.resolveInlayHint(re,Y);if(!!ue)return k.InlayHint.from(ue)}releaseHints(q){this._cache.delete(q)}}class ce{constructor(q,Y){this._documents=q,this._provider=Y,this._cache=new v.Cache("DocumentLink")}async provideLinks(q,Y){const re=this._documents.getDocument(q),ue=await this._provider.provideDocumentLinks(re,Y);if(!(!Array.isArray(ue)||ue.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ue.filter(ce._validateLink).map(k.DocumentLink.from)};{const J=this._cache.add(ue),ae={links:[],id:J};for(let Ee=0;Ee<ue.length;Ee++){if(!ce._validateLink(ue[Ee]))continue;const Oe=k.DocumentLink.from(ue[Ee]);Oe.cacheId=[J,Ee],ae.links.push(Oe)}return ae}}}static _validateLink(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,Y){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...q);if(!re)return;const ue=await this._provider.resolveDocumentLink(re,Y);if(!(!ue||!ce._validateLink(ue)))return k.DocumentLink.from(ue)}releaseLinks(q){this._cache.delete(q)}}class Q{constructor(q,Y){this._documents=q,this._provider=Y}async provideColors(q,Y){const re=this._documents.getDocument(q),ue=await this._provider.provideDocumentColors(re,Y);return Array.isArray(ue)?ue.map(ae=>({color:k.Color.from(ae.color),range:k.Range.from(ae.range)})):[]}async provideColorPresentations(q,Y,re){const ue=this._documents.getDocument(q),J=k.Range.to(Y.range),ae=k.Color.to(Y.color),Ee=await this._provider.provideColorPresentations(ae,{document:ue,range:J},re);if(!!Array.isArray(Ee))return Ee.map(k.ColorPresentation.from)}}class V{constructor(q,Y){this._documents=q,this._provider=Y}async provideFoldingRanges(q,Y,re){const ue=this._documents.getDocument(q),J=await this._provider.provideFoldingRanges(ue,Y,re);if(!!Array.isArray(J))return J.map(k.FoldingRange.from)}}class te{constructor(q,Y,re){this._documents=q,this._provider=Y,this._logService=re}async provideSelectionRanges(q,Y,re){const ue=this._documents.getDocument(q),J=Y.map(k.Position.to),ae=await this._provider.provideSelectionRanges(ue,J,re);if(!(0,P.isNonEmptyArray)(ae))return[];if(ae.length!==J.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Oe=0;Oe<J.length;Oe++){const Ve=[];Ee.push(Ve);let Ke=J[Oe],Je=ae[Oe];for(;;){if(!Je.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(k.SelectionRange.from(Je)),!Je.parent)break;Ke=Je.range,Je=Je.parent}}return Ee}}class me{constructor(q,Y){this._documents=q,this._provider=Y,this._idPool=new p.IdGenerator(""),this._cache=new Map}async prepareSession(q,Y,re){const ue=this._documents.getDocument(q),J=k.Position.to(Y),ae=await this._provider.prepareCallHierarchy(ue,J,re);if(!ae)return;const Ee=this._idPool.nextId();return this._cache.set(Ee,new Map),Array.isArray(ae)?ae.map(Oe=>this._cacheAndConvertItem(Ee,Oe)):[this._cacheAndConvertItem(Ee,ae)]}async provideCallsTo(q,Y,re){const ue=this._itemFromCache(q,Y);if(!ue)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyIncomingCalls(ue,re);if(!!J)return J.map(ae=>({from:this._cacheAndConvertItem(q,ae.from),fromRanges:ae.fromRanges.map(Ee=>k.Range.from(Ee))}))}async provideCallsFrom(q,Y,re){const ue=this._itemFromCache(q,Y);if(!ue)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyOutgoingCalls(ue,re);if(!!J)return J.map(ae=>({to:this._cacheAndConvertItem(q,ae.to),fromRanges:ae.fromRanges.map(Ee=>k.Range.from(Ee))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,Y){const re=this._cache.get(q),ue=k.CallHierarchyItem.from(Y,q,re.size.toString(36));return re.set(ue._itemId,Y),ue}_itemFromCache(q,Y){return this._cache.get(q)?.get(Y)}}class ge{constructor(q,Y){this._documents=q,this._provider=Y,this._idPool=new p.IdGenerator(""),this._cache=new Map}async prepareSession(q,Y,re){const ue=this._documents.getDocument(q),J=k.Position.to(Y),ae=await this._provider.prepareTypeHierarchy(ue,J,re);if(!ae)return;const Ee=this._idPool.nextId();return this._cache.set(Ee,new Map),Array.isArray(ae)?ae.map(Oe=>this._cacheAndConvertItem(Ee,Oe)):[this._cacheAndConvertItem(Ee,ae)]}async provideSupertypes(q,Y,re){const ue=this._itemFromCache(q,Y);if(!ue)throw new Error("missing type hierarchy item");const J=await this._provider.provideTypeHierarchySupertypes(ue,re);if(!!J)return J.map(ae=>this._cacheAndConvertItem(q,ae))}async provideSubtypes(q,Y,re){const ue=this._itemFromCache(q,Y);if(!ue)throw new Error("missing type hierarchy item");const J=await this._provider.provideTypeHierarchySubtypes(ue,re);if(!!J)return J.map(ae=>this._cacheAndConvertItem(q,ae))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,Y){const re=this._cache.get(q),ue=k.TypeHierarchyItem.from(Y,q,re.size.toString(36));return re.set(ue._itemId,Y),ue}_itemFromCache(q,Y){return this._cache.get(q)?.get(Y)}}class ke{constructor(q,Y){this.adapter=q,this.extension=Y}}class Be{constructor(q,Y,re,ue,J,ae,Ee){this._adapter=new Map,this._uriTransformer=Y,this._proxy=q.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=ue,this._diagnostics=J,this._logService=ae,this._apiDeprecation=Ee}_transformDocumentSelector(q){return k.DocumentSelector.from(q,this._uriTransformer)}_createDisposable(q){return new C.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return Be._handlePool++}_withAdapter(q,Y,re,ue,J=!1){const ae=this._adapter.get(q);if(!ae)return Promise.resolve(ue);if(ae.adapter instanceof Y){let Ee;ae.extension&&(Ee=Date.now(),this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${Y.name}'`));const Oe=re(ae.adapter,ae.extension),Ve=ae.extension;return Ve&&Promise.resolve(Oe).then(()=>this._logService.trace(`[${Ve.identifier.value}] provider DONE after ${Date.now()-Ee}ms`),Ke=>{J&&Ke instanceof R.CancellationError||(this._logService.error(`[${Ve.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Oe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(q,Y){const re=this._nextHandle();return this._adapter.set(re,new ke(q,Y)),re}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,Y,re,ue){const J=this._addNewAdapter(new s(this._documents,re),q),ae=ue&&ue.label||Be._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(J,this._transformDocumentSelector(Y),ae),this._createDisposable(J)}$provideDocumentSymbols(q,Y,re){return this._withAdapter(q,s,ue=>ue.provideDocumentSymbols(m.URI.revive(Y),re),void 0)}registerCodeLensProvider(q,Y,re){const ue=this._nextHandle(),J=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ue,new ke(new n(this._documents,this._commands.converter,re),q)),this._proxy.$registerCodeLensSupport(ue,this._transformDocumentSelector(Y),J);let ae=this._createDisposable(ue);if(J!==void 0){const Ee=re.onDidChangeCodeLenses(Oe=>this._proxy.$emitCodeLensEvent(J));ae=C.Disposable.from(ae,Ee)}return ae}$provideCodeLenses(q,Y,re){return this._withAdapter(q,n,ue=>ue.provideCodeLenses(m.URI.revive(Y),re),void 0)}$resolveCodeLens(q,Y,re){return this._withAdapter(q,n,ue=>ue.resolveCodeLens(Y,re),void 0)}$releaseCodeLenses(q,Y){this._withAdapter(q,n,re=>Promise.resolve(re.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(q,Y,re){const ue=this._addNewAdapter(new a(this._documents,re),q);return this._proxy.$registerDefinitionSupport(ue,this._transformDocumentSelector(Y)),this._createDisposable(ue)}$provideDefinition(q,Y,re,ue){return this._withAdapter(q,a,J=>J.provideDefinition(m.URI.revive(Y),re,ue),[])}registerDeclarationProvider(q,Y,re){const ue=this._addNewAdapter(new E(this._documents,re),q);return this._proxy.$registerDeclarationSupport(ue,this._transformDocumentSelector(Y)),this._createDisposable(ue)}$provideDeclaration(q,Y,re,ue){return this._withAdapter(q,E,J=>J.provideDeclaration(m.URI.revive(Y),re,ue),[])}registerImplementationProvider(q,Y,re){const ue=this._addNewAdapter(new r(this._documents,re),q);return this._proxy.$registerImplementationSupport(ue,this._transformDocumentSelector(Y)),this._createDisposable(ue)}$provideImplementation(q,Y,re,ue){return this._withAdapter(q,r,J=>J.provideImplementation(m.URI.revive(Y),re,ue),[])}registerTypeDefinitionProvider(q,Y,re){const ue=this._addNewAdapter(new t(this._documents,re),q);return this._proxy.$registerTypeDefinitionSupport(ue,this._transformDocumentSelector(Y)),this._createDisposable(ue)}$provideTypeDefinition(q,Y,re,ue){return this._withAdapter(q,t,J=>J.provideTypeDefinition(m.URI.revive(Y),re,ue),[])}registerHoverProvider(q,Y,re,ue){const J=this._addNewAdapter(new o(this._documents,re),q);return this._proxy.$registerHoverProvider(J,this._transformDocumentSelector(Y)),this._createDisposable(J)}$provideHover(q,Y,re,ue){return this._withAdapter(q,o,J=>J.provideHover(m.URI.revive(Y),re,ue),void 0)}registerEvaluatableExpressionProvider(q,Y,re,ue){const J=this._addNewAdapter(new h(this._documents,re),q);return this._proxy.$registerEvaluatableExpressionProvider(J,this._transformDocumentSelector(Y)),this._createDisposable(J)}$provideEvaluatableExpression(q,Y,re,ue){return this._withAdapter(q,h,J=>J.provideEvaluatableExpression(m.URI.revive(Y),re,ue),void 0)}registerInlineValuesProvider(q,Y,re,ue){const J=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new u(this._documents,re),q);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(Y),J);let Ee=this._createDisposable(ae);if(J!==void 0){const Oe=re.onDidChangeInlineValues(Ve=>this._proxy.$emitInlineValuesEvent(J));Ee=C.Disposable.from(Ee,Oe)}return Ee}$provideInlineValues(q,Y,re,ue,J){return this._withAdapter(q,u,ae=>ae.provideInlineValues(m.URI.revive(Y),re,ue,J),void 0)}registerDocumentHighlightProvider(q,Y,re){const ue=this._addNewAdapter(new d(this._documents,re),q);return this._proxy.$registerDocumentHighlightProvider(ue,this._transformDocumentSelector(Y)),this._createDisposable(ue)}$provideDocumentHighlights(q,Y,re,ue){return this._withAdapter(q,d,J=>J.provideDocumentHighlights(m.URI.revive(Y),re,ue),void 0)}registerLinkedEditingRangeProvider(q,Y,re){const ue=this._addNewAdapter(new f(this._documents,re),q);return this._proxy.$registerLinkedEditingRangeProvider(ue,this._transformDocumentSelector(Y)),this._createDisposable(ue)}$provideLinkedEditingRanges(q,Y,re,ue){return this._withAdapter(q,f,async J=>{const ae=await J.provideLinkedEditingRanges(m.URI.revive(Y),re,ue);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?Be._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(q,Y,re){const ue=this._addNewAdapter(new l(this._documents,re),q);return this._proxy.$registerReferenceSupport(ue,this._transformDocumentSelector(Y)),this._createDisposable(ue)}$provideReferences(q,Y,re,ue,J){return this._withAdapter(q,l,ae=>ae.provideReferences(m.URI.revive(Y),re,ue,J),void 0)}registerCodeActionProvider(q,Y,re,ue){const J=new c.DisposableStore,ae=this._addNewAdapter(new _(this._documents,this._commands.converter,this._diagnostics,re,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(Y),{providedKinds:ue?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:ue?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this._commands.converter.toInternal(Ee.command,J)}))},Be._extLabel(q),Boolean(re.resolveCodeAction)),J.add(this._createDisposable(ae)),J}$provideCodeActions(q,Y,re,ue,J){return this._withAdapter(q,_,ae=>ae.provideCodeActions(m.URI.revive(Y),re,ue,J),void 0)}$resolveCodeAction(q,Y,re){return this._withAdapter(q,_,ue=>ue.resolveCodeAction(Y,re),void 0)}$releaseCodeActions(q,Y){this._withAdapter(q,_,re=>Promise.resolve(re.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(q,Y,re){const ue=this._addNewAdapter(new A(this._documents,re),q);return this._proxy.$registerDocumentFormattingSupport(ue,this._transformDocumentSelector(Y),q.identifier,q.displayName||q.name),this._createDisposable(ue)}$provideDocumentFormattingEdits(q,Y,re,ue){return this._withAdapter(q,A,J=>J.provideDocumentFormattingEdits(m.URI.revive(Y),re,ue),void 0)}registerDocumentRangeFormattingEditProvider(q,Y,re){const ue=this._addNewAdapter(new N(this._documents,re),q);return this._proxy.$registerRangeFormattingSupport(ue,this._transformDocumentSelector(Y),q.identifier,q.displayName||q.name),this._createDisposable(ue)}$provideDocumentRangeFormattingEdits(q,Y,re,ue,J){return this._withAdapter(q,N,ae=>ae.provideDocumentRangeFormattingEdits(m.URI.revive(Y),re,ue,J),void 0)}registerOnTypeFormattingEditProvider(q,Y,re,ue){const J=this._addNewAdapter(new x(this._documents,re),q);return this._proxy.$registerOnTypeFormattingSupport(J,this._transformDocumentSelector(Y),ue,q.identifier),this._createDisposable(J)}$provideOnTypeFormattingEdits(q,Y,re,ue,J,ae){return this._withAdapter(q,x,Ee=>Ee.provideOnTypeFormattingEdits(m.URI.revive(Y),re,ue,J,ae),void 0)}registerWorkspaceSymbolProvider(q,Y){const re=this._addNewAdapter(new F(Y,this._logService),q);return this._proxy.$registerNavigateTypeSupport(re,typeof Y.resolveWorkspaceSymbol=="function"),this._createDisposable(re)}$provideWorkspaceSymbols(q,Y,re){return this._withAdapter(q,F,ue=>ue.provideWorkspaceSymbols(Y,re),{symbols:[]})}$resolveWorkspaceSymbol(q,Y,re){return this._withAdapter(q,F,ue=>ue.resolveWorkspaceSymbol(Y,re),void 0)}$releaseWorkspaceSymbols(q,Y){this._withAdapter(q,F,re=>re.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(q,Y,re){const ue=this._addNewAdapter(new O(this._documents,re,this._logService),q);return this._proxy.$registerRenameSupport(ue,this._transformDocumentSelector(Y),O.supportsResolving(re)),this._createDisposable(ue)}$provideRenameEdits(q,Y,re,ue,J){return this._withAdapter(q,O,ae=>ae.provideRenameEdits(m.URI.revive(Y),re,ue,J),void 0)}$resolveRenameLocation(q,Y,re,ue){return this._withAdapter(q,O,J=>J.resolveRenameLocation(m.URI.revive(Y),re,ue),void 0)}registerDocumentSemanticTokensProvider(q,Y,re,ue){const J=this._nextHandle(),ae=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(J,new ke(new $(this._documents,re),q)),this._proxy.$registerDocumentSemanticTokensProvider(J,this._transformDocumentSelector(Y),ue,ae);let Ee=this._createDisposable(J);if(ae){const Oe=re.onDidChangeSemanticTokens(Ve=>this._proxy.$emitDocumentSemanticTokensEvent(ae));Ee=C.Disposable.from(Ee,Oe)}return Ee}$provideDocumentSemanticTokens(q,Y,re,ue){return this._withAdapter(q,$,J=>J.provideDocumentSemanticTokens(m.URI.revive(Y),re,ue),null,!0)}$releaseDocumentSemanticTokens(q,Y){this._withAdapter(q,$,re=>re.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(q,Y,re,ue){const J=this._addNewAdapter(new M(this._documents,re),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(J,this._transformDocumentSelector(Y),ue),this._createDisposable(J)}$provideDocumentRangeSemanticTokens(q,Y,re,ue){return this._withAdapter(q,M,J=>J.provideDocumentRangeSemanticTokens(m.URI.revive(Y),re,ue),null,!0)}registerCompletionItemProvider(q,Y,re,ue){const J=this._addNewAdapter(new B(this._documents,this._commands.converter,re,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(J,this._transformDocumentSelector(Y),ue,B.supportsResolving(re),`${q.identifier.value}(${ue.join("")})`),this._createDisposable(J)}$provideCompletionItems(q,Y,re,ue,J){return this._withAdapter(q,B,ae=>ae.provideCompletionItems(m.URI.revive(Y),re,ue,J),void 0)}$resolveCompletionItem(q,Y,re){return this._withAdapter(q,B,ue=>ue.resolveCompletionItem(Y,re),void 0)}$releaseCompletionItems(q,Y){this._withAdapter(q,B,re=>re.releaseCompletionItems(Y),void 0)}registerInlineCompletionsProvider(q,Y,re){const ue=this._addNewAdapter(new W(this._documents,re,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(ue,this._transformDocumentSelector(Y)),this._createDisposable(ue)}$provideInlineCompletions(q,Y,re,ue,J){return this._withAdapter(q,W,ae=>ae.provideInlineCompletions(m.URI.revive(Y),re,ue,J),void 0)}$handleInlineCompletionDidShow(q,Y,re){this._withAdapter(q,W,async ue=>{ue.handleDidShowCompletionItem(Y,re)},void 0)}$freeInlineCompletionsList(q,Y){this._withAdapter(q,W,async re=>{re.disposeCompletions(Y)},void 0)}registerSignatureHelpProvider(q,Y,re,ue){const J=Array.isArray(ue)?{triggerCharacters:ue,retriggerCharacters:[]}:ue,ae=this._addNewAdapter(new j(this._documents,re),q);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(Y),J),this._createDisposable(ae)}$provideSignatureHelp(q,Y,re,ue,J){return this._withAdapter(q,j,ae=>ae.provideSignatureHelp(m.URI.revive(Y),re,ue,J),void 0)}$releaseSignatureHelp(q,Y){this._withAdapter(q,j,re=>re.releaseSignatureHelp(Y),void 0)}registerInlayHintsProvider(q,Y,re){const ue=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,J=this._addNewAdapter(new Z(this._documents,re),q);this._proxy.$registerInlayHintsProvider(J,this._transformDocumentSelector(Y),typeof re.resolveInlayHint=="function",ue);let ae=this._createDisposable(J);if(ue!==void 0){const Ee=re.onDidChangeInlayHints(Oe=>this._proxy.$emitInlayHintsEvent(ue));ae=C.Disposable.from(ae,Ee)}return ae}$provideInlayHints(q,Y,re,ue){return this._withAdapter(q,Z,J=>J.provideInlayHints(m.URI.revive(Y),re,ue),void 0)}$resolveInlayHint(q,Y,re){return this._withAdapter(q,Z,ue=>ue.resolveInlayHint(Y,re),void 0)}$releaseInlayHints(q,Y){this._withAdapter(q,Z,re=>re.releaseHints(Y),void 0)}registerDocumentLinkProvider(q,Y,re){const ue=this._addNewAdapter(new ce(this._documents,re),q);return this._proxy.$registerDocumentLinkProvider(ue,this._transformDocumentSelector(Y),typeof re.resolveDocumentLink=="function"),this._createDisposable(ue)}$provideDocumentLinks(q,Y,re){return this._withAdapter(q,ce,ue=>ue.provideLinks(m.URI.revive(Y),re),void 0)}$resolveDocumentLink(q,Y,re){return this._withAdapter(q,ce,ue=>ue.resolveLink(Y,re),void 0)}$releaseDocumentLinks(q,Y){this._withAdapter(q,ce,re=>re.releaseLinks(Y),void 0)}registerColorProvider(q,Y,re){const ue=this._addNewAdapter(new Q(this._documents,re),q);return this._proxy.$registerDocumentColorProvider(ue,this._transformDocumentSelector(Y)),this._createDisposable(ue)}$provideDocumentColors(q,Y,re){return this._withAdapter(q,Q,ue=>ue.provideColors(m.URI.revive(Y),re),[])}$provideColorPresentations(q,Y,re,ue){return this._withAdapter(q,Q,J=>J.provideColorPresentations(m.URI.revive(Y),re,ue),void 0)}registerFoldingRangeProvider(q,Y,re){const ue=this._nextHandle(),J=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ue,new ke(new V(this._documents,re),q)),this._proxy.$registerFoldingRangeProvider(ue,this._transformDocumentSelector(Y),J);let ae=this._createDisposable(ue);if(J!==void 0){const Ee=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(J));ae=C.Disposable.from(ae,Ee)}return ae}$provideFoldingRanges(q,Y,re,ue){return this._withAdapter(q,V,J=>J.provideFoldingRanges(m.URI.revive(Y),re,ue),void 0)}registerSelectionRangeProvider(q,Y,re){const ue=this._addNewAdapter(new te(this._documents,re,this._logService),q);return this._proxy.$registerSelectionRangeProvider(ue,this._transformDocumentSelector(Y)),this._createDisposable(ue)}$provideSelectionRanges(q,Y,re,ue){return this._withAdapter(q,te,J=>J.provideSelectionRanges(m.URI.revive(Y),re,ue),[])}registerCallHierarchyProvider(q,Y,re){const ue=this._addNewAdapter(new me(this._documents,re),q);return this._proxy.$registerCallHierarchyProvider(ue,this._transformDocumentSelector(Y)),this._createDisposable(ue)}$prepareCallHierarchy(q,Y,re,ue){return this._withAdapter(q,me,J=>Promise.resolve(J.prepareSession(m.URI.revive(Y),re,ue)),void 0)}$provideCallHierarchyIncomingCalls(q,Y,re,ue){return this._withAdapter(q,me,J=>J.provideCallsTo(Y,re,ue),void 0)}$provideCallHierarchyOutgoingCalls(q,Y,re,ue){return this._withAdapter(q,me,J=>J.provideCallsFrom(Y,re,ue),void 0)}$releaseCallHierarchy(q,Y){this._withAdapter(q,me,re=>Promise.resolve(re.releaseSession(Y)),void 0)}registerTypeHierarchyProvider(q,Y,re){const ue=this._addNewAdapter(new ge(this._documents,re),q);return this._proxy.$registerTypeHierarchyProvider(ue,this._transformDocumentSelector(Y)),this._createDisposable(ue)}$prepareTypeHierarchy(q,Y,re,ue){return this._withAdapter(q,ge,J=>Promise.resolve(J.prepareSession(m.URI.revive(Y),re,ue)),void 0)}$provideTypeHierarchySupertypes(q,Y,re,ue){return this._withAdapter(q,ge,J=>J.provideSupertypes(Y,re,ue),void 0)}$provideTypeHierarchySubtypes(q,Y,re,ue){return this._withAdapter(q,ge,J=>J.provideSubtypes(Y,re,ue),void 0)}$releaseTypeHierarchy(q,Y){this._withAdapter(q,ge,re=>Promise.resolve(re.releaseSession(Y)),void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:(0,I.regExpFlags)(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:Be._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:Be._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Be._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Be._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:Be._serializeRegExp(q.beforeText),afterText:q.afterText?Be._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?Be._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(Be._serializeOnEnterRule)}setLanguageConfiguration(q,Y,re){let{wordPattern:ue}=re;if(ue&&(0,I.regExpLeadsToEndlessLoop)(ue))throw new Error(`Invalid language configuration: wordPattern '${ue}' is not allowed to match the empty string.`);ue?this._documents.setWordDefinitionFor(Y,ue):this._documents.setWordDefinitionFor(Y,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const J=this._nextHandle(),ae={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?Be._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?Be._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?Be._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(J,Y,ae),this._createDisposable(J)}$setWordDefinitions(q){for(const Y of q)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=Be,Be._handlePool=0}),define(ve[241],we([0,1,5,17,7,48,18,6]),function(X,e,m,i,k,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(L,D,c,b){this._documents=D,this._commands=c,this._uriTransformer=b,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,D){await this._proxy.$changeLanguage(L,D);const c=this._documents.getDocumentData(L);if(!c)throw new Error(`document '${L.toString}' NOT found`);return c.document}async tokenAtPosition(L,D){const c=L.version,b=i.Position.from(D),p=await this._proxy.$tokensAtPosition(L.uri,b),v={type:k.StandardTokenType.Other,range:L.getWordRangeAtPosition(D)??new k.Range(D.line,D.character,D.line,D.character)};if(!p)return v;const w={range:i.Range.to(p.range),type:i.TokenType.to(p.type)};return!w.range.contains(D)||c!==L.version?v:w}createLanguageStatusItem(L,D,c){const b=this._handlePool++,p=this._proxy,v=this._ids,w=`${L.identifier.value}/${D}`;if(v.has(w))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);v.add(w);const R={selector:c,id:D,name:L.displayName??L.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let S,s=new I.DisposableStore;const n=()=>{S?.dispose(),S=(0,T.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(b,{id:w,name:R.name??L.displayName??L.name,source:L.displayName??L.name,selector:i.DocumentSelector.from(R.selector,this._uriTransformer),label:R.text,detail:R.detail??"",severity:R.severity===k.LanguageStatusSeverity.Error?C.default.Error:R.severity===k.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:R.command&&this._commands.toInternal(R.command,s),accessibilityInfo:R.accessibilityInformation,busy:R.busy})},0)},g={dispose(){s.dispose(),S?.dispose(),p.$removeLanguageStatus(b),v.delete(w)},get id(){return R.id},get name(){return R.name},set name(a){R.name=a,n()},get selector(){return R.selector},set selector(a){R.selector=a,n()},get text(){return R.text},set text(a){R.text=a,n()},get detail(){return R.detail},set detail(a){R.detail=a,n()},get severity(){return R.severity},set severity(a){R.severity=a,n()},get accessibilityInformation(){return R.accessibilityInformation},set accessibilityInformation(a){R.accessibilityInformation=a,n()},get command(){return R.command},set command(a){R.command=a,n()},get busy(){return R.busy},set busy(a){R.busy=a,n()}};return n(),g}}e.ExtHostLanguages=y}),define(ve[132],we([0,1,11,5,26,14,3]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let I=class extends m.AbstractLoggerService{constructor(L,D){const c=new T.Emitter;super(D.logLevel,c.event);this._proxy=L.getProxy(i.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(c)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,D,c){return new y(this._proxy,L,D,c)}};I=je([He(0,C.IExtHostRpcService),He(1,k.IExtHostInitDataService)],I),e.ExtHostLoggerService=I;class y extends m.AbstractMessageLogger{constructor(L,D,c,b){super(b?.always);this.proxy=L,this.file=D,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.proxy.$createLogger(D,b).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,D){const c=[[L,D]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(L){this.proxy.$log(this.file,L)}}}),define(ve[242],we([0,1,5,11,30]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(I){return I&&I.title}let T=class{constructor(y,P){this._logService=P,this._proxy=y.getProxy(m.MainContext.MainThreadMessageService)}showMessage(y,P,L,D,c){const b={extension:y};let p;typeof D=="string"||C(D)?p=[D,...c]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,p=c),b.useCustom&&(0,k.checkProposedApiEnabled)(y,"resolvers");const v=[];for(let w=0;w<p.length;w++){const R=p[w];if(typeof R=="string")v.push({title:R,handle:w,isCloseAffordance:!1});else if(typeof R=="object"){let{title:S,isCloseAffordance:s}=R;v.push({title:S,isCloseAffordance:!!s,handle:w})}else this._logService.warn("Invalid message item:",R)}return this._proxy.$showMessage(P,L,b,v).then(w=>{if(typeof w=="number")return p[w]})}};T=je([He(1,i.ILogService)],T),e.ExtHostMessageService=T}),define(ve[243],we([0,1,22,3,47,6,24,9,13,2,87,5,17,7,53,219,129]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class R{constructor(s,n,g,a,E){this._textDocumentsAndEditors=g,this._textDocuments=a,this._extensionStoragePaths=E,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new i.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new i.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new i.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new i.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new i.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new i.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new i.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new L.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(D.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(D.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(D.MainContext.MainThreadNotebookEditors),this._commandsConverter=n.converter,n.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const t=r.notebookEditor?.notebookUri,o=r.cell.handle,u=this._documents.get(t)?.getCell(o);if(u)return u.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){const n=this._editors.get(s);if(!n)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return n}getIdByEditor(s){for(const[n,g]of this._editors)if(g.apiEditor===s)return n}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,n){const g=this._documents.get(s);if(!g&&!n)throw new Error(`NO notebook document for '${s}'`);return g}_getProviderData(s){const n=this._notebookContentProviders.get(s);if(!n)throw new Error(`NO provider for '${s}'`);return n}registerNotebookContentProvider(s,n,g,a,E){if((0,I.isFalsyOrWhitespace)(n))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(n))throw new Error(`Notebook provider for '${n}' already registered`);this._notebookContentProviders.set(n,{extension:s,provider:g});let r;return g.onDidChangeNotebookContentOptions&&(r=g.onDidChangeNotebookContentOptions(()=>{const t=c.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(n,t)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},n,c.NotebookDocumentContentOptions.from(a),R._convertNotebookRegistrationData(s,E)),new b.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(n),this._notebookProxy.$unregisterNotebookProvider(n)})}static _convertNotebookRegistrationData(s,n){if(!n)return;const g=n.filenamePattern.map(a=>c.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(n.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${n.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:n.displayName,filenamePattern:g,exclusive:n.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,n,g){const a=R._notebookStatusBarItemProviderHandlePool++,E=typeof g.onDidChangeCellStatusBarItems=="function"?R._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,E,n);let r;return E!==void 0&&(r=g.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(E))),new b.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,E),r&&r.dispose()})}async createNotebookDocument(s){const n=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&c.NotebookData.from(s.content)});return P.URI.revive(n)}async openNotebookDocument(s){const n=this._documents.get(s);if(n)return n.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(s),a=this._documents.get(P.URI.revive(g));return(0,y.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(s,n){P.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let g;typeof n=="object"?g={position:c.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus,selections:n.selections&&n.selections.map(c.NotebookRange.from),pinned:typeof n.preview=="boolean"?!n.preview:void 0}:g={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,g),E=a&&this._editors.get(a)?.apiEditor;if(E)return E;throw a?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,n,g,a){const E=this._notebookStatusBarItemProviders.get(s),r=P.URI.revive(n),t=this._documents.get(r);if(!t||!E)return;const o=t.getCellFromIndex(g);if(!o)return;const h=await E.provideCellStatusBarItems(o.apiCell,a);if(!h)return;const u=new C.DisposableStore,d=this._statusBarCache.add([u]),l=(Array.isArray(h)?h:[h]).map(_=>c.NotebookStatusBarItem.from(_,this._commandsConverter,u));return{cacheId:d,items:l}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,n,g,a,E){if((0,I.isFalsyOrWhitespace)(n))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,g),this._notebookProxy.$registerNotebookSerializer(r,{id:s.identifier,location:s.extensionLocation},n,c.NotebookDocumentContentOptions.from(a),R._convertNotebookRegistrationData(s,E)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(s,n,g){const a=this._notebookSerializer.get(s);if(!a)throw new Error("NO serializer found");const E=await a.deserializeNotebook(n.buffer,g);return new p.SerializableObjectWithBuffers(c.NotebookData.from(E))}async $notebookToData(s,n,g){const a=this._notebookSerializer.get(s);if(!a)throw new Error("NO serializer found");const E=await a.serializeNotebook(c.NotebookData.to(n.value),g);return m.VSBuffer.wrap(E)}async $openNotebook(s,n,g,a,E){const{provider:r}=this._getProviderData(s),t=await r.openNotebook(P.URI.revive(n),{backupId:g,untitledDocumentData:a?.buffer},E);return new p.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(c.NotebookCellData.from)})}async $saveNotebook(s,n,g){const a=this.getNotebookDocument(P.URI.revive(n)),{provider:E}=this._getProviderData(s);return await E.saveNotebook(a.apiNotebook,g),!0}async $saveNotebookAs(s,n,g,a){const E=this.getNotebookDocument(P.URI.revive(n)),{provider:r}=this._getProviderData(s);return await r.saveNotebookAs(P.URI.revive(g),E.apiNotebook,a),!0}async $backupNotebook(s,n,g){const a=this.getNotebookDocument(P.URI.revive(n)),E=this._getProviderData(s),r=this._extensionStoragePaths.workspaceValue(E.extension)??this._extensionStoragePaths.globalValue(E.extension),t=String((0,k.hash)([a.uri.toString(),this._backupIdPool++])),o=P.URI.joinPath(r,t),h=await E.provider.backupNotebook(a.apiNotebook,{destination:o},g);return a.updateBackup(h),h.id}_createExtHostEditor(s,n,g){if(this._editors.has(n))throw new Error(`editor with id ALREADY EXSIST: ${n}`);const a=new w.ExtHostNotebookEditor(n,this._notebookEditorsProxy,s,g.visibleRanges.map(c.NotebookRange.to),g.selections.map(c.NotebookRange.to),typeof g.viewColumn=="number"?c.ViewColumn.to(g.viewColumn):void 0);this._editors.set(n,a)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const g of s.value.removedDocuments){const a=P.URI.revive(g),E=this._documents.get(a);E&&(E.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(E.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===a.toString()&&this._editors.delete(r.id)}if(s.value.addedDocuments){const g=[];for(const a of s.value.addedDocuments){const E=P.URI.revive(a.uri);if(this._documents.has(E))throw new Error(`adding EXISTING notebook ${E} `);const r=this,t=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(o){r._onDidChangeNotebookCells.fire(o)},emitCellOutputsChange(o){r._onDidChangeCellOutputs.fire(o)},emitCellMetadataChange(o){r._onDidChangeCellMetadata.fire(o)}},E,a);g.push(...a.cells.map(o=>v.ExtHostCell.asModelAddData(t.apiNotebook,o))),this._documents.get(E)?.dispose(),this._documents.set(E,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(s.value.addedEditors)for(const g of s.value.addedEditors){if(this._editors.has(g.id))return;const a=P.URI.revive(g.documentUri),E=this._documents.get(a);E&&this._createExtHostEditor(E,g.id,g)}const n=[];if(s.value.removedEditors)for(const g of s.value.removedEditors){const a=this._editors.get(g);a&&(this._editors.delete(g),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),n.push(a))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const g=new Set;this._visibleNotebookEditors.forEach(a=>g.add(a.id));for(const a of this._editors.values()){const E=g.has(a.id);a._acceptVisibility(E)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=R,R._notebookStatusBarItemProviderHandlePool=0}),define(ve[244],we([0,1,3,77,11,5,14,17]),function(X,e,m,i,k,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(D,c){const b=y._Keys.nextId();D.$registerNotebookEditorDecorationType(b,I.NotebookDecorationRenderOptions.from(c)),this.value={key:b,dispose(){D.$removeNotebookEditorDecorationType(b)}}}}y._Keys=new i.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(D,c,b){this._logService=D,this._extHostRpc=c,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(D){return new y(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),D).value}$acceptEditorPropertiesChanged(D,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,c);const b=this._notebooksAndEditors.getEditorById(D);c.visibleRanges&&b._acceptVisibleRanges(c.visibleRanges.ranges.map(I.NotebookRange.to)),c.selections&&b._acceptSelections(c.selections.selections.map(I.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const c in D)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(I.ViewColumn.to(D[c]))}};P=je([He(0,k.ILogService),He(1,T.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(ve[245],we([0,1,16,18,21,3,6,24,2,27,11,5,38,17,7,88,211,30,53]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let s=class{constructor(r,t,o,h,u){this._initData=t,this._extHostNotebook=o,this._commands=h,this._logService=u,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new C.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=r.getProxy(D.MainContext.MainThreadNotebookKernels);const d=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",f=>!0,f=>{if(f&&"notebookEditor"in f&&"id"in f){const l=this._extHostNotebook.getIdByEditor(f.notebookEditor);return{id:f.id,extension:f.extension,notebookEditorId:l}}else if(f&&"notebookEditor"in f){const l=this._extHostNotebook.getIdByEditor(f.notebookEditor);if(l===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${f.notebookEditor.document.uri.toString()}`);return{notebookEditorId:l}}return f})],c.ApiCommandResult.Void);this._commands.registerApiCommand(d)}createNotebookController(r,t,o,h,u,d){for(const j of this._kernelData.values())if(j.controller.id===t&&P.ExtensionIdentifier.equals(r.identifier,j.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const f=this._handlePool++,l=this;this._logService.trace(`NotebookController[${f}], CREATED by ${r.identifier.value}, ${t}`);const _=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${r.identifier}'`);let A=!1;const N=new T.DisposableStore,x=new C.Emitter,F=new C.Emitter,O={id:`${r.identifier.value}/${t}`,notebookType:o,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:h||r.identifier.value,preloads:d?d.map(b.NotebookRendererScript.from):[]};let z=u??_,$;this._proxy.$addKernel(f,O).catch(j=>{console.log(j),A=!0});let M=0;const B=()=>{if(A)return;const j=++M;Promise.resolve().then(()=>{j===M&&this._proxy.$updateKernel(f,O)})},W=new I.ResourceMap,U={get id(){return t},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return O.label},set label(j){O.label=j??r.displayName??r.name,B()},get detail(){return O.detail??""},set detail(j){O.detail=j,B()},get description(){return O.description??""},set description(j){O.description=j,B()},get kind(){return(0,R.checkProposedApiEnabled)(r,"notebookControllerKind"),O.kind??""},set kind(j){(0,R.checkProposedApiEnabled)(r,"notebookControllerKind"),O.kind=j,B()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(j){O.supportedLanguages=j,B()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(j){O.supportsExecutionOrder=j,B()},get rendererScripts(){return O.preloads?O.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(j){z=j??_},get interruptHandler(){return $},set interruptHandler(j){$=j,O.supportsInterrupt=Boolean(j),B()},createNotebookCellExecution(j){if(A)throw new Error("notebook controller is DISPOSED");if(!W.has(j.notebook.uri))throw l._logService.trace(`NotebookController[${f}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(W.keys()).map(Z=>Z.toString())),new Error(`notebook controller is NOT associated to notebook: ${j.notebook.uri.toString()}`);return l._createNotebookCellExecution(j)},dispose:()=>{A||(this._logService.trace(`NotebookController[${f}], DISPOSED`),A=!0,this._kernelData.delete(f),N.dispose(),x.dispose(),F.dispose(),this._proxy.$removeKernel(f))},updateNotebookAffinity(j,Z){l._proxy.$updateNotebookPriority(f,j.uri,Z)},onDidReceiveMessage:F.event,postMessage(j,Z){return(0,R.checkProposedApiEnabled)(r,"notebookMessaging"),l._proxy.$postMessage(f,Z&&l._extHostNotebook.getIdByEditor(Z),j)},asWebviewUri(j){return(0,R.checkProposedApiEnabled)(r,"notebookMessaging"),(0,v.asWebviewUri)(j,l._initData.remote)}};return this._kernelData.set(f,{extensionId:r.identifier,controller:U,onDidReceiveMessage:F,onDidChangeSelection:x,associatedNotebooks:W}),U}$acceptNotebookAssociation(r,t,o){const h=this._kernelData.get(r);if(h){const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(t));o?h.associatedNotebooks.set(u.uri,!0):h.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,u.uri.toString(),o),h.onDidChangeSelection.fire({selected:o,notebook:u.apiNotebook})}}async $executeCells(r,t,o){const h=this._kernelData.get(r);if(!h)return;const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(t)),d=[];for(const f of o){const l=u.getCell(f);l&&d.push(l.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,u.uri.toString(),d.length),await h.controller.executeHandler.call(h.controller,d,u.apiNotebook,h.controller)}catch(f){this._logService.error(`NotebookController[${r}] execute cells FAILED`,f),console.error(f)}}async $cancelCells(r,t,o){const h=this._kernelData.get(r);if(!h)return;const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(t));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,u.apiNotebook);else for(const d of o){const f=u.getCell(d);f&&this._activeExecutions.get(f.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,t,o){const h=this._kernelData.get(r);if(!h)return;const u=this._extHostNotebook.getEditorById(t);h.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:o}))}$cellExecutionChanged(r,t,o){const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(r)).getCell(t);u&&this._onDidChangeCellExecutionState.fire({cell:u.apiCell,state:o??p.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const h=new g(o.notebook,o,this._proxy);this._activeExecutions.set(o.uri,h);const u=h.onDidChangeState(()=>{h.state===n.Resolved&&(h.dispose(),u.dispose(),this._activeExecutions.delete(o.uri))});return h.asApiObject()}};s=je([He(4,L.ILogService)],s),e.ExtHostNotebookKernels=s;var n;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(n||(n={}));class g extends T.Disposable{constructor(r,t,o){super();this._document=r,this._cell=t,this._proxy=o,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=n.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._collector=new a(10,h=>this.update(h)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const t=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new S.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===n.Init)throw new Error("Must call start before modifying cell output");if(this._state===n.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let t=this._cell;if(r&&(t=this._document.getCellFromApiCell(r)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(r){return r.map(t=>{const o=p.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return o===t.items?b.NotebookCellOutput.from(t):b.NotebookCellOutput.from({items:o,id:t.id,metadata:t.metadata})})}async updateOutputs(r,t,o){const h=this.cellIndexToHandle(t),u=this.validateAndConvertOutputs((0,m.asArray)(r));return this.updateSoon({editType:w.CellExecutionUpdateType.Output,uri:this._document.uri,cellHandle:h,append:o,outputs:u})}async updateOutputItems(r,t,o){return r=p.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(r),!0),this.updateSoon({editType:w.CellExecutionUpdateType.OutputItems,uri:this._document.uri,cellHandle:this._cell.handle,items:r.map(b.NotebookCellOutputItem.from),outputId:t.id,append:o})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(o){r._executionOrder=o,r.update([{editType:w.CellExecutionUpdateType.ExecutionState,uri:r._document.uri,cellHandle:r._cell.handle,executionOrder:r._executionOrder}])},start(o){if(r._state===n.Resolved||r._state===n.Started)throw new Error("Cannot call start again");r._state=n.Started,r._onDidChangeState.fire(),r.update({editType:w.CellExecutionUpdateType.ExecutionState,uri:r._document.uri,cellHandle:r._cell.handle,runStartTime:o})},end(o,h){if(r._state===n.Resolved)throw new Error("Cannot call resolve twice");r._state=n.Resolved,r._onDidChangeState.fire(),r._collector.flush(),r._proxy.$completeExecution(r._document.uri,r._cell.handle,new S.SerializableObjectWithBuffers({uri:r._document.uri,cellHandle:r._cell.handle,runEndTime:h,lastRunSuccess:o}))},clearOutput(o){return r.verifyStateForOutput(),r.updateOutputs([],o,!1)},appendOutput(o,h){return r.verifyStateForOutput(),r.updateOutputs(o,h,!0)},replaceOutput(o,h){return r.verifyStateForOutput(),r.updateOutputs(o,h,!1)},appendOutputItems(o,h){return r.verifyStateForOutput(),r.updateOutputItems(o,h,!0)},replaceOutputItems(o,h){return r.verifyStateForOutput(),r.updateOutputItems(o,h,!1)}})}}class a{constructor(r,t){this.delay=r,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new i.DeferredPromise,this.startedTimer=Date.now(),(0,i.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>r.complete())}}}),define(ve[246],we([0,1,3,5,129,30]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(y,P){this._extHostNotebook=P,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(i.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,P,L){const D=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(P)?.fire({editor:D.apiEditor,message:L})}createRendererMessaging(y,P){if(!y.contributes?.notebookRenderer?.some(b=>b.id===P))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${P})`);const L=(0,C.isProposedApiEnabled)(y,"notebookEditor"),D=new WeakMap;return{onDidReceiveMessage:(b,p,v)=>{const w=L?b:R=>{const S={};D.set(S,R.editor),b({editor:S,message:R.message})};return this.getOrCreateEmitterFor(P).event(w,p,v)},postMessage:(b,p)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(b)&&([b,p]=[p,b]);const v=L?p:D.get(p),w=v&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(v);return this.proxy.$postMessage(w?.id,P,b)}}}getOrCreateEmitterFor(y){let P=this._rendererMessageEmitters.get(y);return P||(P=new m.Emitter({onLastListenerRemove:()=>{P?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,P),P)}}e.ExtHostNotebookRenderers=T}),define(ve[133],we([0,1,5,6,4,14,11,212,67,26,44,152,22]),function(X,e,m,i,k,C,T,I,y,P,L,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class b extends i.Disposable{constructor(w,R,S,s){super();this.id=w,this.name=R,this.logger=S,this.proxy=s,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(w){this.append(w+`
`)}append(w){this.write(w),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Append))}clear(){const w=this.offset;this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Clear,w)}replace(w){const R=this.offset;this.write(w),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Replace,R),this.visible&&this.logger.flush()}show(w,R){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof w=="boolean"?w:R))}hide(){this.proxy.$close(this.id)}write(w){this.offset+=c.VSBuffer.fromString(w).byteLength,this.logger.info(w)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=b;let p=class{constructor(w,R,S,s,n){this.extHostFileSystem=S,this.extHostFileSystemInfo=s,this.loggerService=n,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=w.getProxy(m.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(R.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.visibleChannelId=w;for(const[R,S]of this.channels)S.visible=R===this.visibleChannelId}createOutputChannel(w,R){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const S=this.doCreateOutputChannel(w,R);return S.then(s=>{this.channels.set(s.id,s),s.visible=s.id===this.visibleChannelId}),this.createExtHostOutputChannel(w,S)}async doCreateOutputChannel(w,R){const S=await this.createOutputDirectory(),s=this.extHostFileSystemInfo.extUri.joinPath(S,`${this.namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),n=this.loggerService.createLogger(s,{always:!0,donotRotate:!0,donotUseFormatters:!0}),g=await this.proxy.$register(w,!1,s,R.identifier.value);return new b(g,w,n,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(w,R){let S=!1;const s=()=>{if(S)throw new Error("Channel has been closed")};return{get name(){return w},append(n){s(),R.then(g=>g.append(n))},appendLine(n){s(),R.then(g=>g.appendLine(n))},clear(){s(),R.then(n=>n.clear())},replace(n){s(),R.then(g=>g.replace(n))},show(n,g){s(),R.then(a=>a.show(n,g))},hide(){s(),R.then(n=>n.hide())},dispose(){S=!0,R.then(n=>n.dispose())}}}};p=je([He(0,C.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,y.IExtHostConsumerFileSystem),He(3,L.IExtHostFileSystemInfo),He(4,T.ILoggerService)],p),e.ExtHostOutputService=p,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(ve[247],we([0,1,18,21,3,6,5,2,7,15,16,48,86,30]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(v,w,R){const S=v.getProxy(T.MainContext.MainThreadQuickOpen);class s{constructor(u,d){this._sessions=new Map,this._instances=0,this._workspace=u,this._commands=d}showQuickPick(u,d,f=i.CancellationToken.None){this._onDidSelectItem=void 0;const l=Promise.resolve(u),_=++this._instances,A=S.$show(_,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},f),N={},x=A.then(()=>N);return Promise.race([x,l]).then(F=>{if(F!==N)return l.then(O=>{const z=[];for(let $=0;$<O.length;$++){const M=O[$];typeof M=="string"?z.push({label:M,handle:$}):M.kind===y.QuickPickItemKind.Separator?z.push({type:"separator",label:M.label}):z.push({label:M.label,description:M.description,detail:M.detail,picked:M.picked,alwaysShow:M.alwaysShow,handle:$})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{d.onDidSelectItem(O[$])}),S.$setItems(_,z),A.then($=>{if(typeof $=="number")return O[$];if(Array.isArray($))return $.map(M=>O[M])})})}).then(void 0,F=>{if(!(0,P.isPromiseCanceledError)(F))return S.$setError(_,F),Promise.reject(F)})}$onItemSelected(u){this._onDidSelectItem&&this._onDidSelectItem(u)}showInput(u,d=i.CancellationToken.None){return this._validateInput=u?u.validateInput:void 0,S.$input(u,typeof this._validateInput=="function",d).then(void 0,f=>{if(!(0,P.isPromiseCanceledError)(f))return Promise.reject(f)})}$validateInput(u){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(u)):Promise.resolve(void 0)}async showWorkspaceFolderPick(u,d=i.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[u]);if(!f)return;const l=await this._workspace.getWorkspaceFolders2();if(!!l)return l.find(_=>_.uri.toString()===f.uri.toString())}createQuickPick(u){const d=new t(u,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(u){const d=new o(u,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(u,d){const f=this._sessions.get(u);f&&f._fireDidChangeValue(d)}$onDidAccept(u){const d=this._sessions.get(u);d&&d._fireDidAccept()}$onDidChangeActive(u,d){const f=this._sessions.get(u);f instanceof t&&f._fireDidChangeActive(d)}$onDidChangeSelection(u,d){const f=this._sessions.get(u);f instanceof t&&f._fireDidChangeSelection(d)}$onDidTriggerButton(u,d){const f=this._sessions.get(u);f&&f._fireDidTriggerButton(d)}$onDidTriggerItemButton(u,d,f){const l=this._sessions.get(u);l instanceof t&&l._fireDidTriggerItemButton(d,f)}$onDidHide(u){const d=this._sessions.get(u);d&&d._fireDidHide()}}class n{constructor(u,d){this._extensionId=u,this._onDidDispose=d,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(u){this._title=u,this.update({title:u})}get step(){return this._steps}set step(u){this._steps=u,this.update({step:u})}get totalSteps(){return this._totalSteps}set totalSteps(u){this._totalSteps=u,this.update({totalSteps:u})}get enabled(){return this._enabled}set enabled(u){this._enabled=u,this.update({enabled:u})}get busy(){return this._busy}set busy(u){this._busy=u,this.update({busy:u})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(u){this._ignoreFocusOut=u,this.update({ignoreFocusOut:u})}get value(){return this._value}set value(u){this._value=u,this.update({value:u})}get placeholder(){return this._placeholder}set placeholder(u){this._placeholder=u,this.update({placeholder:u})}get buttons(){return this._buttons}set buttons(u){this._buttons=u.slice(),this._handlesToButtons.clear(),u.forEach((d,f)=>{const l=d===y.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(l,d)}),this.update({buttons:u.map((d,f)=>({...r(d),tooltip:d.tooltip,handle:d===y.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(u){this._value=u,this._onDidChangeValueEmitter.fire(u)}_fireDidTriggerButton(u){const d=this._handlesToButtons.get(u);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(u){if(!this._disposed){for(const d of Object.keys(u)){const f=u[d];this._pendingUpdate[d]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}n._nextId=1;function g(h){if(h instanceof y.ThemeIcon)return{id:h.id};const u=E(h),d=a(h);return{dark:typeof u=="string"?I.URI.file(u):u,light:typeof d=="string"?I.URI.file(d):d}}function a(h){return typeof h=="object"&&"light"in h?h.light:h}function E(h){return typeof h=="object"&&"dark"in h?h.dark:h}function r(h){const u=g(h.iconPath);let d,f;return"id"in u?f=c.ThemeIcon.asClassName(u):d=u,{iconPath:d,iconClass:f}}class t extends n{constructor(u,d){super(u.identifier,d);this.extension=u,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(u){u.some(f=>f.kind!==void 0)&&(0,b.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=u.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),u.forEach((f,l)=>{this._handlesToItems.set(l,f),this._itemsToHandles.set(f,l)});const d=[];for(let f=0;f<u.length;f++){const l=u[f];l.kind===y.QuickPickItemKind.Separator?d.push({type:"separator",label:l.label}):d.push({handle:f,label:l.label,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,buttons:l.buttons?.map((_,A)=>({...r(_),tooltip:_.tooltip,handle:A}))})}this.update({items:d})}get canSelectMany(){return this._canSelectMany}set canSelectMany(u){this._canSelectMany=u,this.update({canSelectMany:u})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(u){this._matchOnDescription=u,this.update({matchOnDescription:u})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(u){this._matchOnDetail=u,this.update({matchOnDetail:u})}get sortByLabel(){return this._sortByLabel}set sortByLabel(u){this._sortByLabel=u,this.update({sortByLabel:u})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(u){this._keepScrollPosition=u,this.update({keepScrollPosition:u})}get activeItems(){return this._activeItems}set activeItems(u){this._activeItems=u.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(u){this._selectedItems=u.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(u){const d=(0,L.coalesce)(u.map(f=>this._handlesToItems.get(f)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(u){const d=(0,L.coalesce)(u.map(f=>this._handlesToItems.get(f)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(u,d){const f=this._handlesToItems.get(u);if(!f||!f.buttons||!f.buttons.length)return;const l=f.buttons[d];l&&this._onDidTriggerItemButtonEmitter.fire({button:l,item:f})}}class o extends n{constructor(u,d){super(u,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(u){this._password=u,this.update({password:u})}get prompt(){return this._prompt}set prompt(u){this._prompt=u,this.update({prompt:u})}get validationMessage(){return this._validationMessage}set validationMessage(u){this._validationMessage=u,this.update({validationMessage:u,severity:u?D.default.Error:D.default.Ignore})}}return new s(w,R)}e.createExtHostQuickOpen=p});var tt=this&&this.__classPrivateFieldSet||function(X,e,m,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,m):k?k.value=m:e.set(X,m),m},Le=this&&this.__classPrivateFieldGet||function(X,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(X):i?i.value:e.get(X)};define(ve[248],we([0,1,2,3,57,6,18,5,16,101,11,27,86,17,30]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p){"use strict";var v,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function R(d){if(d)return typeof d.iconPath=="string"?m.URI.file(d.iconPath):m.URI.isUri(d.iconPath)||c.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function S(d,f){if(!d.iconPath&&!f.iconPath)return 0;if(d.iconPath){if(!f.iconPath)return 1}else return-1;const l=typeof d.iconPath=="string"?d.iconPath:m.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,_=typeof f.iconPath=="string"?f.iconPath:m.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,P.comparePaths)(l,_)}function s(d,f){let l=0;if(d.strikeThrough!==f.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==f.faded)return d.faded?1:-1;if(d.tooltip!==f.tooltip)return(d.tooltip||"").localeCompare(f.tooltip||"");if(l=S(d,f),l!==0)return l;if(d.light&&f.light)l=S(d.light,f.light);else{if(d.light)return 1;if(f.light)return-1}if(l!==0)return l;if(d.dark&&f.dark)l=S(d.dark,f.dark);else{if(d.dark)return 1;if(f.dark)return-1}return l}function n(d,f){if(d.command!==f.command)return d.command<f.command?-1:1;if(d.title!==f.title)return d.title<f.title?-1:1;if(d.tooltip!==f.tooltip){if(d.tooltip!==void 0&&f.tooltip!==void 0)return d.tooltip<f.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(d.arguments===f.arguments)return 0;if(d.arguments)if(f.arguments){if(d.arguments.length!==f.arguments.length)return d.arguments.length-f.arguments.length}else return 1;else return-1;for(let l=0;l<d.arguments.length;l++){const _=d.arguments[l],A=f.arguments[l];if(_!==A)return _<A?-1:1}return 0}function g(d,f){let l=(0,P.comparePaths)(d.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(l!==0)return l;if(d.command&&f.command)l=n(d.command,f.command);else{if(d.command)return 1;if(f.command)return-1}if(l!==0)return l;if(d.decorations&&f.decorations)l=s(d.decorations,f.decorations);else{if(d.decorations)return 1;if(f.decorations)return-1}return l}function a(d,f){for(let l=0;l<d.length;l++)if(d[l]!==f[l])return!1;return!0}function E(d,f){return d.command===f.command&&d.title===f.title&&d.tooltip===f.tooltip&&(d.arguments&&f.arguments?a(d.arguments,f.arguments):d.arguments===f.arguments)}function r(d,f){return(0,y.equals)(d,f,E)}class t{constructor(f,l,_){this._extension=f,this._sourceControlHandle=_,v.set(this,void 0),this._value="",this._onDidChange=new i.Emitter,this._placeholder="",this._visible=!0,tt(this,v,l,"f")}get value(){return this._value}set value(f){f=f??"",Le(this,v,"f").$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){Le(this,v,"f").$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,Le(this,v,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,Le(this,v,"f").$setInputBoxVisibility(this._sourceControlHandle,f))}showValidationMessage(f,l){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),Le(this,v,"f").$showValidationMessage(this._sourceControlHandle,f,l)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=t,v=new WeakMap;class o{constructor(f,l,_,A,N){this._proxy=f,this._commands=l,this._sourceControlHandle=_,this._id=A,this._label=N,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new i.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,l){const _=this._resourceStatesCommandsMap.get(f);return _?(0,T.asPromise)(()=>this._commands.executeCommand(_.command,..._.arguments||[],l)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(g),_=(0,y.sortedDiff)(this._resourceSnapshot,f,g).map(x=>{const F=x.toInsert.map(O=>{const z=this._resourceHandlePool++;this._resourceStatesMap.set(z,O);const $=O.resourceUri;let M;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const me=new C.DisposableStore;M=this._commands.converter.toInternal(O.command,me),this._resourceStatesDisposablesMap.set(z,me)}else this._resourceStatesCommandsMap.set(z,O.command);const B=R(O.decorations),W=O.decorations&&R(O.decorations.light)||B,U=O.decorations&&R(O.decorations.dark)||B,j=[W,U],Z=O.decorations&&O.decorations.tooltip||"",ce=O.decorations&&!!O.decorations.strikeThrough,Q=O.decorations&&!!O.decorations.faded,V=O.contextValue||"";return{rawResource:[z,$,j,Z,ce,Q,V,M],handle:z}});return{start:x.start,deleteCount:x.deleteCount,toInsert:F}}),A=_.map(({start:x,deleteCount:F,toInsert:O})=>[x,F,O.map(z=>z.rawResource)]),N=_.reverse();for(const{start:x,deleteCount:F,toInsert:O}of N){const z=O.map(M=>M.handle),$=this._handlesSnapshot.splice(x,F,...z);for(const M of $)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=f,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class h{constructor(f,l,_,A,N,x){this._extension=f,this._commands=_,this._id=A,this._label=N,this._rootUri=x,w.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new i.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=h._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,w,l,"f"),this._inputBox=new t(f,Le(this,w,"f"),this.handle),Le(this,w,"f").$registerSourceControl(this.handle,A,N,x)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,Le(this,w,"f").$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,Le(this,w,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,Le(this,w,"f").$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=f;const l=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);Le(this,w,"f").$updateSourceControl(this.handle,{acceptInputCommand:l})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=f;const l=f!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Le(this,w,"f").$updateSourceControl(this.handle,{actionButton:l??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&r(this._statusBarCommands,f))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=f;const l=(f||[]).map(_=>this._commands.converter.toInternal(_,this._statusBarDisposables.value));Le(this,w,"f").$updateSourceControl(this.handle,{statusBarCommands:l})}get selected(){return this._selected}createResourceGroup(f,l){const _=new o(Le(this,w,"f"),this._commands,this.handle,f,l),A=i.Event.once(_.onDidDispose)(()=>this.createdResourceGroups.delete(_));return this.createdResourceGroups.set(_,A),this.eventuallyAddResourceGroups(),_}eventuallyAddResourceGroups(){const f=[],l=[];for(const[_,A]of this.createdResourceGroups){A.dispose();const N=_.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(_),this.eventuallyUpdateResourceStates()});i.Event.once(_.onDidDispose)(()=>{this.updatedResourceGroups.delete(_),N.dispose(),this._groups.delete(_.handle),Le(this,w,"f").$unregisterGroup(this.handle,_.handle)}),f.push([_.handle,_.id,_.label,_.features]);const x=_._takeResourceStateSnapshot();x.length>0&&l.push([_.handle,x]),this._groups.set(_.handle,_)}Le(this,w,"f").$registerGroups(this.handle,f,l),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(l=>{const _=l._takeResourceStateSnapshot();_.length!==0&&f.push([l.handle,_])}),f.length>0&&Le(this,w,"f").$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),Le(this,w,"f").$unregisterSourceControl(this.handle)}}w=new WeakMap,h._handlePool=0,je([(0,k.debounce)(100)],h.prototype,"eventuallyAddResourceGroups",null),je([(0,k.debounce)(100)],h.prototype,"eventuallyUpdateResourceStates",null);let u=class Hi{constructor(f,l,_){this._commands=l,this.logService=_,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new i.Emitter,this._proxy=f.getProxy(I.MainContext.MainThreadSCM),this._telemetry=f.getProxy(I.MainContext.MainThreadTelemetry),l.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const N=this._sourceControls.get(A.sourceControlHandle);if(!N)return A;const x=N.getResourceGroup(A.groupHandle);return x?x.getResourceState(A.handle):A}else if(A&&A.$mid===4){const N=this._sourceControls.get(A.sourceControlHandle);return N?N.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const N=this._sourceControls.get(A.handle);return N||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,l,_,A){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,l,_,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const N=Hi._handlePool++,x=new h(f,this._proxy,this._commands,l,_,A);this._sourceControls.set(N,x);const F=this._sourceControlsByExtension.get(D.ExtensionIdentifier.toKey(f.identifier))||[];return F.push(x),this._sourceControlsByExtension.set(D.ExtensionIdentifier.toKey(f.identifier),F),x}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const l=this._sourceControlsByExtension.get(D.ExtensionIdentifier.toKey(f.identifier)),_=l&&l[l.length-1];return _&&_.inputBox}$provideOriginalResource(f,l,_){const A=m.URI.revive(l);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,A.toString());const N=this._sourceControls.get(f);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>N.quickDiffProvider.provideOriginalResource(A,_)).then(x=>x||null)}$onInputBoxValueChange(f,l){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const _=this._sourceControls.get(f);return _&&_.inputBox.$onInputBoxValueChange(l),Promise.resolve(void 0)}$executeResourceCommand(f,l,_,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,l,_);const N=this._sourceControls.get(f);if(!N)return Promise.resolve(void 0);const x=N.getResourceGroup(l);return x?x.$executeResourceCommand(_,A):Promise.resolve(void 0)}$validateInput(f,l,_){this.logService.trace("ExtHostSCM#$validateInput",f);const A=this._sourceControls.get(f);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>A.inputBox.validateInput(l,_)).then(N=>{if(!N)return Promise.resolve(void 0);const x=b.MarkdownString.fromStrict(N.message);return x?Promise.resolve([x,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};u._handlePool=0,u=je([He(2,L.ILogService)],u),e.ExtHostSCM=u});var tt=this&&this.__classPrivateFieldSet||function(X,e,m,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,m):k?k.value=m:e.set(X,m),m},Le=this&&this.__classPrivateFieldGet||function(X,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(X):i?i.value:e.get(X)};define(ve[249],we([0,1,7,5,166,6,17,13]),function(X,e,m,i,k,C,T,I){"use strict";var y,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(p,v,w,R,S=m.StatusBarAlignment.Left,s){y.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,tt(this,y,p,"f"),tt(this,P,v,"f"),this._entryId=L.ID_GEN++,this._extension=w,this._id=R,this._alignment=S,this._priority=this.validatePriority(s)}validatePriority(p){if(!!(0,I.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!L.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._internalCommandRegistration.clear(),typeof p=="string"?this._command={fromApi:p,internal:Le(this,P,"f").toInternal({title:"",command:p},this._internalCommandRegistration)}:p?this._command={fromApi:p,internal:Le(this,P,"f").toInternal(p,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Le(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let v;this._name?v=this._name:v=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let w=this._color;this._backgroundColor&&(w=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const R=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;Le(this,y,"f").$setEntry(this._entryId,p,v,this._text,R,this._command?.internal,w,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,y=new WeakMap,P=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class D{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const v={message:p};return this._messages.unshift(v),this._update(),new m.Disposable(()=>{const w=this._messages.indexOf(v);w>=0&&(this._messages.splice(w,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class c{constructor(p,v){this._proxy=p.getProxy(i.MainContext.MainThreadStatusBar),this._commands=v,this._statusMessage=new D(this)}createStatusBarEntry(p,v,w,R){return new L(this._proxy,this._commands,p,v,w,R)}setStatusBarMessage(p,v){const w=this._statusMessage.setMessage(p);let R;return typeof v=="number"?R=setTimeout(()=>w.dispose(),v):typeof v!="undefined"&&v.then(()=>w.dispose(),()=>w.dispose()),new m.Disposable(()=>{w.dispose(),clearTimeout(R)})}}e.ExtHostStatusBar=c}),define(ve[91],we([0,1,5,3,4]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(I){this._onDidChangeStorage=new i.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,y){this._proxy.$registerExtensionStorageKeysToSync(I,y)}getValue(I,y,P){return this._proxy.$getValue(I,y).then(L=>L||P)}setValue(I,y,P){return this._proxy.$setValue(I,y,P)}$acceptValue(I,y,P){this._onDidChangeStorage.fire({shared:I,key:y,value:P})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(ve[68],we([0,1,4,26,11,67,2]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let I=class{constructor(P,L,D){this._logService=L,this._extHostFileSystem=D,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(P){return T.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,L=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(D){this._logService.error("[ExtHostStorage]",D);return}}workspaceValue(P){if(this._value)return T.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return T.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=je([He(0,i.IExtHostInitDataService),He(1,k.ILogService),He(2,C.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(ve[34],we([0,1,3,5,4,2,14,6,7,167,15,214,21,33,196,86,13,18]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class S{constructor(h,u,d,f){this._proxy=h,this._id=u,this._creationOptions=d,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(_=>this._pidPromiseComplete=_);const l=this;this.value={get name(){return l._name||""},get processId(){return l._pidPromise},get creationOptions(){return l._creationOptions},get exitStatus(){return l._exitStatus},get state(){return l._state},sendText(_,A=!0){l._checkDisposed(),l._proxy.$sendText(l._id,_,A)},show(_){l._checkDisposed(),l._proxy.$show(l._id,_)},hide(){l._checkDisposed(),l._proxy.$hide(l._id)},dispose(){l._disposed||(l._disposed=!0,l._proxy.$dispose(l._id))},get dimensions(){if(!(l._cols===void 0||l._rows===void 0))return{columns:l._cols,rows:l._rows}}}}async create(h,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:h.name,shellPath:(0,w.withNullAsUndefined)(h.shellPath),shellArgs:(0,w.withNullAsUndefined)(h.shellArgs),cwd:(0,w.withNullAsUndefined)(h.cwd),env:(0,w.withNullAsUndefined)(h.env),icon:(0,w.withNullAsUndefined)(r(h.iconPath)),color:v.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:(0,w.withNullAsUndefined)(h.message),strictEnv:(0,w.withNullAsUndefined)(h.strictEnv),hideFromUser:(0,w.withNullAsUndefined)(h.hideFromUser),isFeatureTerminal:(0,w.withNullAsUndefined)(u?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,w.withNullAsUndefined)(u?.useShellEnvironment),location:u?.location||this._serializeParentTerminal(h.location,u?.resolvedExtHostIdentifier),disablePersistence:(0,w.withNullAsUndefined)(h.disablePersistence)})}async createExtensionTerminal(h,u,d,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:v.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(h,u),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(h,u){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&u?{parentTerminal:u}:"viewColumn"in h?{viewColumn:h.viewColumn,preserveFocus:h.preserveFocus}:void 0:h}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(h){this._name=h}setExitCode(h){this._exitStatus=Object.freeze({code:h})}setDimensions(h,u){return h===this._cols&&u===this._rows||h===0||u===0?!1:(this._cols=h,this._rows=u,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(h){this._pidPromiseComplete?(this._pidPromiseComplete(h),this._pidPromiseComplete=void 0):this._pidPromise.then(u=>{u!==h&&(this._pidPromise=Promise.resolve(h))})}}e.ExtHostTerminal=S;class s{constructor(h){this._pty=h,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new m.Emitter,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,u){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${u}`)}async start(){}shutdown(){this._pty.close()}input(h){this._pty.handleInput?.(h)}resize(h,u){this._pty.setDimensions?.({columns:h,rows:u})}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(h){this._pty.onDidWrite(u=>this._onProcessData.fire(u)),this._pty.onDidClose?.((u=void 0)=>{this._onProcessExit.fire(u===void 0?void 0:u)}),this._pty.onDidOverrideDimensions?.(u=>{u&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:u.columns,rows:u.rows}})}),this._pty.onDidChangeName?.(u=>{this._onDidChangeProperty.fire({type:"title",value:u})}),this._pty.open(h||void 0),h&&this._pty.setDimensions?.(h),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=s;let n=1,g=class extends I.Disposable{constructor(h,u){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=u.getProxy(i.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(h),this._register({dispose:()=>{for(const[d,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(h=>h.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(h){return(h?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(h){return(h?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(h,u){const d=new S(this._proxy,(0,b.generateUuid)(),h,h.name),f=new s(h.pty);return d.createExtensionTerminal(h.location,this._serializeParentTerminal(h,u).resolvedExtHostIdentifier,r(h.iconPath),t(h.color)).then(l=>{const _=this._setupExtHostProcessListeners(l,f);this._terminalProcessDisposables[l]=_}),this._terminals.push(d),d.value}_serializeParentTerminal(h,u){if(u=u||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const d=h.location.parentTerminal;if(d){const f=this._terminals.find(l=>l.value===d);f&&(u.resolvedExtHostIdentifier=f._id)}}else h.location&&typeof h.location!="object"?u.location=h.location:u.location&&typeof u.location=="object"&&"splitActiveTerminal"in u.location&&(u.location={splitActiveTerminal:!0});return u}attachPtyToTerminal(h,u){if(!this._getTerminalById(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const f=new s(u),l=this._setupExtHostProcessListeners(h,f);this._terminalProcessDisposables[h]=l}async $acceptActiveTerminalChanged(h){const u=this._activeTerminal;if(h===null){this._activeTerminal=void 0,u!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(h);d&&(this._activeTerminal=d,u!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(h,u){const d=this._getTerminalById(h);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:u})}async $acceptTerminalDimensions(h,u,d){const f=this._getTerminalById(h);f&&f.setDimensions(u,d)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(h,u,d){this._terminalProcesses.get(h)?.resize(u,d)}async $acceptTerminalTitleChange(h,u){const d=this._getTerminalById(h);d&&(d.name=u)}async $acceptTerminalClosed(h,u){const d=this._getTerminalObjectIndexById(this._terminals,h);if(d!==null){const f=this._terminals.splice(d,1)[0];f.setExitCode(u),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(h,u,d,f){if(u){const A=this._getTerminalObjectIndexById(this._terminals,u);if(A!==null){this._terminals[A]._id=h,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const l={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:C.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},_=new S(this._proxy,h,l,d);this._terminals.push(_),this._onDidOpenTerminal.fire(_.value),_.isOpen=!0}async $acceptTerminalProcessId(h,u){const d=this._getTerminalById(h);d&&d._setProcessId(u)}async $startExtensionTerminal(h,u){const d=this._getTerminalById(h);if(!d)return{message:(0,P.localize)(0,null,h)};d.isOpen||await new Promise(l=>{const _=this.onDidOpenTerminal(async A=>{A===d.value&&(_.dispose(),l())})});const f=this._terminalProcesses.get(h);f?f.startSendingEvents(u):this._extensionTerminalAwaitingStart[h]={initialDimensions:u}}_setupExtHostProcessListeners(h,u){const d=new I.DisposableStore;d.add(u.onProcessReady(l=>this._proxy.$sendProcessReady(h,l.pid,l.cwd))),d.add(u.onDidChangeProperty(l=>this._proxy.$sendProcessProperty(h,l))),this._bufferer.startBuffering(h,u.onProcessData),d.add(u.onProcessExit(l=>this._onProcessExit(h,l))),this._terminalProcesses.set(h,u);const f=this._extensionTerminalAwaitingStart[h];return f&&u instanceof s&&(u.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[h]),d}$acceptProcessAckDataEvent(h,u){this._terminalProcesses.get(h)?.acknowledgeDataEvent(u)}$acceptProcessInput(h,u){this._terminalProcesses.get(h)?.input(u)}$acceptTerminalInteraction(h){const u=this._getTerminalById(h);u?.setInteractedWith()&&this._onDidChangeTerminalState.fire(u.value)}$acceptProcessResize(h,u,d){try{this._terminalProcesses.get(h)?.resize(u,d)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(h,u){this._terminalProcesses.get(h)?.shutdown(u)}$acceptProcessRequestInitialCwd(h){this._terminalProcesses.get(h)?.getInitialCwd().then(u=>this._proxy.$sendProcessProperty(h,{type:"initialCwd",value:u}))}$acceptProcessRequestCwd(h){this._terminalProcesses.get(h)?.getCwd().then(u=>this._proxy.$sendProcessProperty(h,{type:"cwd",value:u}))}$acceptProcessRequestLatency(h){return h}registerLinkProvider(h){return this._linkProviders.add(h),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(h),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(h,u,d){if(this._profileProviders.has(u))throw new Error(`Terminal profile provider "${u}" already registered`);return this._profileProviders.set(u,d),this._proxy.$registerProfileProvider(u,h.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(u),this._proxy.$unregisterProfileProvider(u)})}async $createContributedProfileTerminal(h,u){const d=new c.CancellationTokenSource().token;let f=await this._profileProviders.get(h)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(f&&!("options"in f)&&(f={options:f}),!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,u);return}this.createTerminalFromOptions(f.options,u)}}async $provideLinks(h,u){const d=this._getTerminalById(h);if(!d)return[];this._terminalLinkCache.delete(h);const f=this._terminalLinkCancellationSource.get(h);f&&f.dispose(!0);const l=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(h,l);const _=[],A={terminal:d.value,line:u},N=[];for(const O of this._linkProviders)N.push(R.Promises.withAsyncBody(async z=>{l.token.onCancellationRequested(()=>z({provider:O,links:[]}));const $=await O.provideTerminalLinks(A,l.token)||[];l.token.isCancellationRequested||z({provider:O,links:$})}));const x=await Promise.all(N);if(l.token.isCancellationRequested)return[];const F=new Map;for(const O of x)O&&O.links.length>0&&_.push(...O.links.map(z=>{const $={id:n++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return F.set($.id,{provider:O.provider,link:z}),$}));return this._terminalLinkCache.set(h,F),_}$activateLink(h,u){const d=this._terminalLinkCache.get(h)?.get(u);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(h,u){this._bufferer.stopBuffering(h),this._terminalProcesses.delete(h),delete this._extensionTerminalAwaitingStart[h];const d=this._terminalProcessDisposables[h];d&&(d.dispose(),delete this._terminalProcessDisposables[h]),this._proxy.$sendProcessExit(h,u)}_getTerminalById(h){return this._getTerminalObjectById(this._terminals,h)}_getTerminalObjectById(h,u){const d=this._getTerminalObjectIndexById(h,u);return d!==null?h[d]:null}_getTerminalObjectIndexById(h,u){let d=null;return h.some((f,l)=>f._id===u?(d=l,!0):!1),d}getEnvironmentVariableCollection(h){let u=this._environmentVariableCollections.get(h.identifier.value);return u||(u=new a,this._setEnvironmentVariableCollection(h.identifier.value,u)),u}_syncEnvironmentVariableCollection(h,u){const d=(0,D.serializeEnvironmentVariableCollection)(u.map);this._proxy.$setEnvironmentVariableCollection(h,u.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(h){h.forEach(u=>{const d=u[0],f=new a(u[1]);this._setEnvironmentVariableCollection(d,f)})}$acceptDefaultProfile(h,u){this._defaultProfile=h,this._defaultAutomationProfile=u}_setEnvironmentVariableCollection(h,u){this._environmentVariableCollections.set(h,u),u.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(h,u)})}};g=je([He(1,T.IExtHostRpcService)],g),e.BaseExtHostTerminalService=g;class a{constructor(h){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(h)}get persistent(){return this._persistent}set persistent(h){this._persistent=h,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(h,u){this._setIfDiffers(h,{value:u,type:y.EnvironmentVariableMutatorType.Replace})}append(h,u){this._setIfDiffers(h,{value:u,type:y.EnvironmentVariableMutatorType.Append})}prepend(h,u){this._setIfDiffers(h,{value:u,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(h,u){const d=this.map.get(h);(!d||d.value!==u.value||d.type!==u.type)&&(this.map.set(h,u),this._onDidChangeCollection.fire())}get(h){return this.map.get(h)}forEach(h,u){this.map.forEach((d,f)=>h.call(u,f,d,this))}delete(h){this.map.delete(h),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let E=class extends g{constructor(h){super(!1,h)}createTerminal(h,u,d){throw new L.NotSupportedError}createTerminalFromOptions(h,u){throw new L.NotSupportedError}};E=je([He(0,T.IExtHostRpcService)],E),e.WorkerExtHostTerminalService=E;function r(o){if(!(!o||typeof o=="string"))return"id"in o?{id:o.id,color:o.color}:o}function t(o){return v.ThemeColor.isThemeColor(o)?o:void 0}});var tt=this&&this.__classPrivateFieldSet||function(X,e,m,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,m):k?k.value=m:e.set(X,m),m},Le=this&&this.__classPrivateFieldGet||function(X,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(X):i?i.value:e.get(X)};define(ve[250],we([0,1,16,22,21,3,76,47,6,25,13,33,5,14,64,17,7,221,127,89]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S,s){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(A,N){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(c.MainContext.MainThreadTesting),this.observer=new d(this.proxy),this.runTracker=new E(this.proxy),N.registerArgumentProcessor({processArgument:x=>x?.$mid===13?v.TestItem.toItemFromContext(x):x})}createTestController(A,N,x){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const F=new y.DisposableStore,O=F.add(new R.SingleUseTestCollection(A));O.root.label=N;const z=new Map,$=this.proxy,M={items:O.root.children,get label(){return N},set label(W){N=W,O.root.label=W,$.$updateController(A,{label:N})},get refreshHandler(){return x},set refreshHandler(W){x=W,$.$updateController(A,{canRefresh:!!W})},get id(){return A},createRunProfile:(W,U,j,Z,ce)=>{let Q=(0,I.hash)(W);for(;z.has(Q);)Q++;const V=new f(this.proxy,A,Q,W,U,j,Z,ce);return z.set(Q,V),V},createTestItem(W,U,j){return new p.TestItemImpl(A,W,U,j)},createTestRun:(W,U,j=!0)=>this.runTracker.createTestRun(A,O,W,U,j),set resolveHandler(W){O.resolveHandler=W},get resolveHandler(){return O.resolveHandler},dispose:()=>{F.dispose()}};$.$registerTestController(A,N,!!x),F.add((0,y.toDisposable)(()=>$.$unregisterTestController(A)));const B={controller:M,collection:O,profiles:z};return this.controllers.set(A,B),F.add((0,y.toDisposable)(()=>this.controllers.delete(A))),F.add(O.onDidGenerateDiff(W=>$.$publishDiff(A,W))),M}createTestObserver(){return this.observer.checkout()}async runTests(A,N=k.CancellationToken.None){const x=r(A);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(x.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:A.include?.map(O=>O.id)??[F.collection.root.id],profileGroup:l[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:A.exclude?.map(O=>O.id)},N)}$provideFileCoverage(A,N,x){return(0,m.mapFind)(this.runTracker.trackers,O=>O.id===A?O.getCoverage(N):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(A,N,x,F){return(0,m.mapFind)(this.runTracker.trackers,z=>z.id===A?z.getCoverage(N):void 0)?.resolveFileCoverage(x,F)??Promise.resolve([])}$configureRunProfile(A,N){this.controllers.get(A)?.profiles.get(N)?.configureHandler?.()}async $refreshTests(A){await this.controllers.get(A)?.controller.refreshHandler?.()}$publishTestResults(A){this.results=Object.freeze(A.map(N=>(0,P.deepFreeze)(v.TestResults.to(N))).concat(this.results).sort((N,x)=>x.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,N){const x=this.controllers.get(s.TestId.fromString(A).controllerId)?.collection;x&&(await x.expand(A,N<0?1/0:N),x.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A)}async $runControllerTests(A,N){const x=this.controllers.get(A.controllerId);if(!x)return;const{collection:F,profiles:O}=x,z=O.get(A.profileId);if(!z)return;const $=A.testIds.map(U=>F.tree.get(U)).filter(L.isDefined),M=A.excludeExtIds.map(U=>x.collection.tree.get(U)).filter(L.isDefined).filter(U=>$.some(j=>j.fullId.compare(U.fullId)===2));if(!$.length)return;const B=new w.TestRunRequest($.some(U=>U.actual instanceof p.TestItemRootImpl)?void 0:$.map(U=>U.actual),M.map(U=>U.actual),z),W=this.runTracker.prepareForMainThreadTestRun(B,t.fromInternal(A,x.collection),N);try{await z.runHandler(B,N)}finally{W.isRunning&&!N.isCancellationRequested&&await C.Event.toPromise(W.onEnd),W.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};g=je([He(0,b.IExtHostRpcService)],g),e.ExtHostTesting=g;class a extends y.Disposable{constructor(A,N,x){super();this.dto=A,this.proxy=N,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new k.CancellationTokenSource(x)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const N=this.dto.id,x=this.dto.controllerId,F=(0,D.generateUuid)(),O=new o(this.proxy,N,F),z=W=>(U,...j)=>{if(M){console.warn(`Setting the state of test "${U.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(U)||(this.ensureTestIsKnown(U),W(U,...j))},$=(W,U)=>{const j=U instanceof Array?U.map(v.TestMessage.from):[v.TestMessage.from(U)];if(W.uri&&W.range){const Z={range:v.Range.from(W.range),uri:W.uri};for(const ce of j)ce.location=ce.location||Z}this.proxy.$appendTestMessagesInRun(N,F,s.TestId.fromExtHostTestItem(W,x).toString(),j)};let M=!1;const B={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return O.coverageProvider},set coverageProvider(W){O.coverageProvider=W},enqueued:z(W=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(W,x).toString(),1)}),skipped:z(W=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(W,x).toString(),5)}),started:z(W=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(W,x).toString(),2)}),errored:z((W,U,j)=>{$(W,U),this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(W,x).toString(),6,j)}),failed:z((W,U,j)=>{$(W,U),this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(W,x).toString(),4,j)}),passed:z((W,U)=>{this.proxy.$updateTestStateInRun(N,F,s.TestId.fromExtHostTestItem(W,this.dto.controllerId).toString(),3,U)}),appendOutput:(W,U,j)=>{M||(j&&(this.dto.isIncluded(j)?this.ensureTestIsKnown(j):j=void 0),this.proxy.$appendOutputToRun(N,F,i.VSBuffer.fromString(W),U&&v.location.from(U),j&&s.TestId.fromExtHostTestItem(j,x).toString()))},end:()=>{M||(M=!0,this.proxy.$finishedTestRunTask(N,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:B,coverage:O}),this.proxy.$startedTestRunTask(N,{id:F,name:A,running:!0}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof p.TestItemImpl))throw new p.InvalidTestItemError(A.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const N=[],x=this.dto.colllection.root;for(;;){const F=v.TestItem.from(A);if(N.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),A===x))break;A=A.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,N)}}class E{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,N,x){return this.getTracker(A,N,x)}cancelRunById(A){for(const N of this.tracked.values())if(N.id===A){N.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,N,x,F,O){const z=this.tracked.get(x);if(z)return z.createRun(F);const $=t.fromPublic(A,N,x,O),M=r(x);this.proxy.$startedExtensionTestRun({controllerId:A,profile:M&&{group:l[M.kind],id:M.profileId},exclude:x.exclude?.map(W=>W.id)??[],id:$.id,include:x.include?.map(W=>W.id)??[N.root.id],persist:O});const B=this.getTracker(x,$);return B.onEnd(()=>this.proxy.$finishedExtensionTestRun($.id)),B.createRun(F)}getTracker(A,N,x){const F=new a(N,this.proxy,x);return this.tracked.set(A,F),F.onEnd(()=>this.tracked.delete(A)),F}}e.TestRunCoordinator=E;const r=_=>{if(!!_.profile){if(!(_.profile instanceof f))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return _.profile}};class t{constructor(A,N,x,F,O,z){this.controllerId=A,this.id=N,this.isPersisted=O,this.colllection=z,this.includePrefix=x.map($=>$+"\0"),this.excludePrefix=F.map($=>$+"\0")}static fromPublic(A,N,x,F){return new t(A,(0,D.generateUuid)(),x.include?.map(O=>s.TestId.fromExtHostTestItem(O,A).toString())??[A],x.exclude?.map(O=>s.TestId.fromExtHostTestItem(O,A).toString())??[],F,N)}static fromInternal(A,N){return new t(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,N)}isIncluded(A){const N=s.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(N===x||N.startsWith(x))return!1;for(const x of this.includePrefix)if(N===x||N.startsWith(x))return!0;return!1}}e.TestRunDto=t;class o{constructor(A,N,x){this.proxy=A,this.runId=N,this.taskId=x}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(N){throw this.fileCoverage=void 0,N}}async resolveFileCoverage(A,N){const x=await this.fileCoverage;let F=x?.[A];return!this._coverageProvider||!x||!F?[]:(F.detailedCoverage||(F=x[A]=await this._coverageProvider.resolveFileCoverage?.(F,N)??F),F.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class h extends S.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,v.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:N,removed:x}=this;return{get added(){return[...A].map(F=>F.revived)},get updated(){return[...N].map(F=>F.revived)},get removed(){return[...x].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class u extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,N){return{...A,revived:v.TestItem.toPlain(A.item),depth:N?N.depth+1:0,children:new Set}}createChangeCollector(){return new h(this.changeEmitter)}}e.MirroredTestCollection=u;class d{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(N=>N.revived)},dispose:(0,T.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new u;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class f{constructor(A,N,x,F,O,z,$=!1,M=void 0){this.controllerId=N,this.profileId=x,this._label=F,this.kind=O,this.runHandler=z,this._isDefault=$,this._tag=M,n.set(this,void 0),tt(this,n,A,"f");const B=l[O];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${O}`);Le(this,n,"f").$publishTestRunProfile({profileId:x,controllerId:N,tag:M?v.TestTag.namespace(this.controllerId,M.id):null,label:F,group:B,isDefault:$,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,Le(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,Le(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Le(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?v.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,Le(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){Le(this,n,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=f,n=new WeakMap;const l={[w.TestRunProfileKind.Coverage]:8,[w.TestRunProfileKind.Debug]:4,[w.TestRunProfileKind.Run]:2}}),define(ve[251],we([0,1,3,16,5,130,17,7]),function(X,e,m,i,k,C,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(L,D){this._extHostDocumentsAndEditors=D,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const D=this._extHostDocumentsAndEditors.allEditors();return L?D:D.map(c=>c.value)}async showTextDocument(L,D,c){let b;typeof D=="number"?b={position:T.ViewColumn.from(D),preserveFocus:c}:typeof D=="object"?b={position:T.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?T.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:b={preserveFocus:!1};const p=await this._proxy.$tryShowTextDocument(L.uri,b),v=p&&this._extHostDocumentsAndEditors.getEditor(p);if(v)return v.value;throw p?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,D){return new C.TextEditorDecorationType(this._proxy,L,D).value}$acceptEditorPropertiesChanged(L,D){const c=this._extHostDocumentsAndEditors.getEditor(L);if(!c)throw new Error("unknown text editor");if(D.options&&c._acceptOptions(D.options),D.selections){const b=D.selections.selections.map(T.Selection.to);c._acceptSelections(b)}if(D.visibleRanges){const b=i.coalesce(D.visibleRanges.map(T.Range.to));c._acceptVisibleRanges(b)}if(D.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...D.options,lineNumbers:T.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const b=I.TextEditorSelectionChangeKind.fromValue(D.selections.source),p=D.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:p,kind:b})}if(D.visibleRanges){const b=i.coalesce(D.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:b})}}$acceptEditorPositionData(L){for(const D in L){const c=this._extHostDocumentsAndEditors.getEditor(D);if(!c)throw new Error("Unknown text editor");const b=T.ViewColumn.to(L[D]);c.value.viewColumn!==b&&(c._acceptViewColumn(b),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:b}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=y}),define(ve[252],we([0,1,2,4,5,6,7]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,i.createDecorator)("IExtHostTimeline");class I{constructor(L,D){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=L.getProxy(k.MainContext.MainThreadTimeline),D.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const b=c.uri===void 0?void 0:m.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(y(b))?.get(c.handle)}return c}})}async $getTimeline(L,D,c,b,p){return this._providers.get(L)?.provideTimeline(m.URI.revive(D),c,b,p)}registerTimelineProvider(L,D,c,b){const p=new C.DisposableStore,v=this.convertTimelineItem(D.id,b,p).bind(this);let w;D.onDidChange&&(w=D.onDidChange(S=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...S,id:D.id}),this));const R=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...D,scheme:L,onDidChange:void 0,async provideTimeline(S,s,n,g){g?.resetCache&&(p.clear(),R.get(D.id)?.clear());const a=await D.provideTimeline(S,s,n);if(a==null)return;const E=v(S,g);return{...a,source:D.id,items:a.items.map(E)}},dispose(){for(const S of R.values())S.get(D.id)?.clear();w?.dispose(),p.dispose()}})}convertTimelineItem(L,D,c){return(b,p)=>{let v;if(p?.cacheResults){let w=this._itemsBySourceAndUriMap.get(L);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(L,w));const R=y(b);v=w.get(R),v===void 0&&(v=new Map,w.set(R,v))}return w=>{const{iconPath:R,...S}=w,s=`${L}|${w.id??w.timestamp}`;v?.set(s,w);let n,g,a;return w.iconPath&&(R instanceof T.ThemeIcon?a={id:R.id,color:R.color}:m.URI.isUri(R)?(n=R,g=R):{light:n,dark:g}=R),{...S,id:S.id??void 0,handle:s,source:L,command:w.command?D.toInternal(w.command,c):void 0,icon:n,iconDark:g,themeIcon:a,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(L){if(this._providers.get(L.id))throw new Error(`Timeline Provider ${L.id} already exists.`);return this._proxy.$registerTimelineProvider({id:L.id,label:L.label,scheme:L.scheme}),this._providers.set(L.id,L),(0,C.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(L.id)?.clear();this._providers.delete(L.id),this._proxy.$unregisterTimelineProvider(L.id),L.dispose()})}}e.ExtHostTimeline=I;function y(P){return P?.toString()}}),define(ve[253],we([0,1,6,10,2,5]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(y){this._openers=new Map,this._proxy=y.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,P,L,D){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const c=D.schemes.find(b=>!T.supportedSchemes.has(b));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,L),this._proxy.$registerUriOpener(P,D.schemes,y,D.label),(0,m.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(y,P,L){const D=this._openers.get(y);if(!D)throw new Error(`Unknown opener with id: ${y}`);const c=k.URI.revive(P);return D.canOpenExternalUri(c,L)}async $openUri(y,P,L){const D=this._openers.get(y);if(!D)throw new Error(`Unknown opener id: '${y}'`);return D.openExternalUri(k.URI.revive(P.resolvedUri),{sourceUri:k.URI.revive(P.sourceUri)},L)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([i.Schemas.http,i.Schemas.https])}),define(ve[254],we([0,1,5,2,6,15,27]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(P,L){if(this.handles.has(T.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const D=I.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(P)),this.handlers.set(D,L),this._proxy.$registerUriHandler(D,P),(0,k.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(P)),this.handlers.delete(D),this._proxy.$unregisterUriHandler(D)})}$handleExternalUri(P,L){const D=this.handlers.get(P);if(!D)return Promise.resolve(void 0);try{D.handleUri(i.URI.revive(L))}catch(c){(0,C.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(P){return i.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=I,I.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(X,e,m,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,m):k?k.value=m:e.set(X,m),m},Le=this&&this.__classPrivateFieldGet||function(X,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(X):i?i.value:e.get(X)};define(ve[69],we([0,1,3,10,2,179,204,88,5]),function(X,e,m,i,k,C,T,I,y){"use strict";var P,L,D,c,b,p,v,w,R,S,s,n;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(d,f,l,_,A,N,x){P.set(this,void 0),L.set(this,void 0),D.set(this,void 0),c.set(this,void 0),b.set(this,void 0),p.set(this,void 0),v.set(this,""),w.set(this,void 0),R.set(this,!1),S.set(this,!1),s.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,n.set(this,new m.Emitter),this._onDidDispose=Le(this,n,"f").event,tt(this,P,d,"f"),tt(this,L,f,"f"),tt(this,w,l,"f"),tt(this,c,_,"f"),tt(this,b,A,"f"),tt(this,p,N,"f"),tt(this,s,a(N),"f"),tt(this,D,x,"f")}dispose(){tt(this,R,!0,"f"),Le(this,n,"f").fire(),Le(this,n,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return tt(this,S,!0,"f"),(0,I.asWebviewUri)(d,Le(this,c,"f").remote)}get cspSource(){const d=Le(this,p,"f").extensionLocation;if(d.scheme===i.Schemas.https||d.scheme===i.Schemas.http){let f=d.toString();return f.endsWith("/")||(f+="/"),f+" "+I.webviewGenericCspSource}return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Le(this,v,"f")}set html(d){this.assertNotDisposed(),Le(this,v,"f")!==d&&(tt(this,v,d,"f"),!Le(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(tt(this,S,!0,"f"),Le(this,D,"f").report("Webview vscode-resource: uris",Le(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,L,"f").$setHtml(Le(this,P,"f"),d))}get options(){return this.assertNotDisposed(),Le(this,w,"f")}set options(d){this.assertNotDisposed(),Le(this,L,"f").$setOptions(Le(this,P,"f"),t(Le(this,p,"f"),Le(this,b,"f"),d)),tt(this,w,d,"f")}async postMessage(d){if(Le(this,R,"f"))return!1;const f=(0,T.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:Le(this,s,"f")});return Le(this,L,"f").$postMessage(Le(this,P,"f"),f.message,...f.buffers)}assertNotDisposed(){if(Le(this,R,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,P=new WeakMap,L=new WeakMap,D=new WeakMap,c=new WeakMap,b=new WeakMap,p=new WeakMap,v=new WeakMap,w=new WeakMap,R=new WeakMap,S=new WeakMap,s=new WeakMap,n=new WeakMap;function a(u){try{const d=(0,C.normalizeVersion)((0,C.parseVersion)(u.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class E{constructor(d,f,l,_,A){this.initData=f,this.workspace=l,this._logService=_,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=d.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(d,f,l){const _=this.getWebview(d);if(_){const{message:A}=(0,T.deserializeWebviewMessage)(f,l.value);_._onMessageEmitter.fire(A)}}$onMissingCsp(d,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,f,l){const _=new g(d,this._webviewProxy,o(f),this.initData,this.workspace,l,this._deprecationService);return this._webviews.set(d,_),_._onDidDispose(()=>{this._webviews.delete(d)}),_}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=E;function r(u){return{id:u.identifier,location:u.extensionLocation}}e.toExtensionData=r;function t(u,d,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||h(u,d)}}e.serializeWebviewOptions=t;function o(u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots?.map(d=>k.URI.from(d))}}e.reviveOptions=o;function h(u,d){return[...(d?.getWorkspaceFolders()||[]).map(f=>f.uri),u.extensionLocation]}}),define(ve[255],we([0,1,21,47,6,10,23,2,17,69,87,5,7]),function(X,e,m,i,k,C,T,I,y,P,L,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(a,E){this.document=a,this._storagePath=E,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,E){await this.getEdit(a).undo(),E||this.disposeBackup()}async redo(a,E){await this.getEdit(a).redo(),E||this.disposeBackup()}disposeEdits(a){for(const E of a)this._edits.delete(E)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=n(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const E=this._edits.get(a,0);if(!E)throw new Error("No edit found");return E}}class p{constructor(){this._documents=new Map}get(a,E){return this._documents.get(this.key(a,E))}add(a,E,r){const t=this.key(a,E.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${a} resource:${E.uri}`);const o=new b(E,r);return this._documents.set(t,o),o}delete(a,E){const r=this.key(a,E.uri);this._documents.delete(r)}key(a,E){return`${a}@@@${E}`}}var v;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(v||(v={}));class w{constructor(){this._providers=new Map}addTextProvider(a,E,r){return this.add(0,a,E,r)}addCustomProvider(a,E,r){return this.add(1,a,E,r)}get(a){return this._providers.get(a)}add(a,E,r,t){if(this._providers.has(E))throw new Error(`Provider for viewType:${E} already registered`);return this._providers.set(E,{type:a,extension:r,provider:t}),new c.Disposable(()=>this._providers.delete(E))}}class R{constructor(a,E,r,t,o){this._extHostDocuments=E,this._extensionStoragePaths=r,this._extHostWebview=t,this._extHostWebviewPanels=o,this._editorProviders=new w,this._documents=new p,this._proxy=a.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,E,r,t){const o=new k.DisposableStore;return S(r)?(o.add(this._editorProviders.addTextProvider(E,a,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(a),E,t.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(a))):(o.add(this._editorProviders.addCustomProvider(E,a,r)),this.supportEditing(r)&&o.add(r.onDidChangeCustomDocument(h=>{const u=this.getCustomDocumentEntry(E,h.document.uri);if(s(h)){const d=u.addEdit(h);this._proxy.$onDidEdit(h.document.uri,E,d,h.label)}else this._proxy.$onContentChange(h.document.uri,E)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(a),E,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(a))),c.Disposable.from(o,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(E)}))}async $createCustomDocument(a,E,r,t,o){const h=this._editorProviders.get(E);if(!h)throw new Error(`No provider found for '${E}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${E}'`);const u=I.URI.revive(a),d=await h.provider.openCustomDocument(u,{backupId:r,untitledDocumentData:t?.buffer},o);let f;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(E,d,f),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(a,E){const r=this._editorProviders.get(E);if(!r)throw new Error(`No provider found for '${E}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${E}'`);const t=I.URI.revive(a),{document:o}=this.getCustomDocumentEntry(E,t);this._documents.delete(E,o),o.dispose()}async $resolveWebviewEditor(a,E,r,t,o,h){const u=this._editorProviders.get(r);if(!u)throw new Error(`No provider found for '${r}'`);const d=y.ViewColumn.to(o),f=this._extHostWebview.createNewWebview(E,t.webviewOptions,u.extension),l=this._extHostWebviewPanels.createNewWebviewPanel(E,r,t.title,d,t.panelOptions,f),_=I.URI.revive(a);switch(u.type){case 1:{const{document:A}=this.getCustomDocumentEntry(r,_);return u.provider.resolveCustomEditor(A,l,h)}case 0:{const A=this._extHostDocuments.getDocument(_);return u.provider.resolveCustomTextEditor(A,l,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,E,r){this.getCustomDocumentEntry(E,a).disposeEdits(r)}async $onMoveCustomEditor(a,E,r){const t=this._editorProviders.get(r);if(!t)throw new Error(`No provider found for '${r}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const o=this._extHostWebviewPanels.getWebviewPanel(a);if(!o)throw new Error("No webview found");const h=I.URI.revive(E),u=this._extHostDocuments.getDocument(h);await t.provider.moveCustomTextEditor(u,o,m.CancellationToken.None)}async $undo(a,E,r,t){return this.getCustomDocumentEntry(E,a).undo(r,t)}async $redo(a,E,r,t){return this.getCustomDocumentEntry(E,a).redo(r,t)}async $revert(a,E,r){const t=this.getCustomDocumentEntry(E,a);await this.getCustomEditorProvider(E).revertCustomDocument(t.document,r),t.disposeBackup()}async $onSave(a,E,r){const t=this.getCustomDocumentEntry(E,a);await this.getCustomEditorProvider(E).saveCustomDocument(t.document,r),t.disposeBackup()}async $onSaveAs(a,E,r,t){const o=this.getCustomDocumentEntry(E,a);return this.getCustomEditorProvider(E).saveCustomDocumentAs(o.document,I.URI.revive(r),t)}async $backup(a,E,r){const t=this.getCustomDocumentEntry(E,a),h=await this.getCustomEditorProvider(E).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},r);return t.updateBackup(h),h.id}getCustomDocumentEntry(a,E){const r=this._documents.get(a,I.URI.revive(E));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(a){const r=this._editorProviders.get(a)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=R;function S(g){return typeof g.resolveCustomTextEditor=="function"}function s(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function n(g){const a=g.scheme===C.Schemas.file||g.scheme===C.Schemas.untitled?g.fsPath:g.toString();return(0,i.hash)(a)+""}});var tt=this&&this.__classPrivateFieldSet||function(X,e,m,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,m):k?k.value=m:e.set(X,m),m},Le=this&&this.__classPrivateFieldGet||function(X,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(X):i?i.value:e.get(X)};define(ve[256],we([0,1,3,6,2,33,17,69,5,7]),function(X,e,m,i,k,C,T,I,y,P){"use strict";var L,D,c,b,p,v,w,R,S,s,n,g,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class E extends i.Disposable{constructor(h,u,d,f,l,_,A){super();L.set(this,void 0),D.set(this,void 0),c.set(this,void 0),b.set(this,void 0),p.set(this,void 0),v.set(this,void 0),w.set(this,void 0),R.set(this,void 0),S.set(this,!0),s.set(this,!0),n.set(this,!1),g.set(this,this._register(new m.Emitter)),this.onDidDispose=Le(this,g,"f").event,a.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Le(this,a,"f").event,tt(this,L,h,"f"),tt(this,D,u,"f"),tt(this,c,d,"f"),tt(this,p,_,"f"),tt(this,R,l,"f"),tt(this,v,f,"f"),tt(this,b,A,"f")}dispose(){Le(this,n,"f")||(tt(this,n,!0,"f"),Le(this,g,"f").fire(),Le(this,D,"f").$disposeWebview(Le(this,L,"f")),Le(this,b,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Le(this,b,"f")}get viewType(){return this.assertNotDisposed(),Le(this,c,"f")}get title(){return this.assertNotDisposed(),Le(this,v,"f")}set title(h){this.assertNotDisposed(),Le(this,v,"f")!==h&&(tt(this,v,h,"f"),Le(this,D,"f").$setTitle(Le(this,L,"f"),h))}get iconPath(){return this.assertNotDisposed(),Le(this,w,"f")}set iconPath(h){this.assertNotDisposed(),Le(this,w,"f")!==h&&(tt(this,w,h,"f"),Le(this,D,"f").$setIconPath(Le(this,L,"f"),k.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Le(this,p,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Le(this,R,"f")=="number"&&Le(this,R,"f")<0))return Le(this,R,"f")}get active(){return this.assertNotDisposed(),Le(this,s,"f")}get visible(){return this.assertNotDisposed(),Le(this,S,"f")}_updateViewState(h){Le(this,n,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(tt(this,s,h.active,"f"),tt(this,S,h.visible,"f"),tt(this,R,h.viewColumn,"f"),Le(this,a,"f").fire({webviewPanel:this}))}reveal(h,u){this.assertNotDisposed(),Le(this,D,"f").$reveal(Le(this,L,"f"),{viewColumn:h?T.ViewColumn.from(h):void 0,preserveFocus:!!u})}assertNotDisposed(){if(Le(this,n,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,D=new WeakMap,c=new WeakMap,b=new WeakMap,p=new WeakMap,v=new WeakMap,w=new WeakMap,R=new WeakMap,S=new WeakMap,s=new WeakMap,n=new WeakMap,g=new WeakMap,a=new WeakMap;class r{constructor(h,u,d){this.webviews=u,this.workspace=d,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(h,u,d,f,l={}){const _=typeof f=="object"?f.viewColumn:f,A={viewColumn:T.ViewColumn.from(_),preserveFocus:typeof f=="object"&&!!f.preserveFocus},N=(0,I.shouldSerializeBuffersForPostMessage)(h),x=r.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(h),x,u,{title:d,panelOptions:t(l),webviewOptions:(0,I.serializeWebviewOptions)(h,this.workspace,l),serializeBuffersForPostMessage:N},A);const F=this.webviews.createNewWebview(x,l,h);return this.createNewWebviewPanel(x,u,d,_,l,F)}$onDidChangeWebviewPanelViewStates(h){const u=Object.keys(h);u.sort((d,f)=>{const l=h[d],_=h[f];return l.active?1:_.active?-1:+l.visible-+_.visible});for(const d of u){const f=this.getWebviewPanel(d);if(!f)continue;const l=h[d];f._updateViewState({active:l.active,visible:l.visible,viewColumn:T.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,u,d){if(this._serializers.has(u))throw new Error(`Serializer for '${u}' already registered`);return this._serializers.set(u,{serializer:d,extension:h}),this._proxy.$registerSerializer(u,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(h)}),new P.Disposable(()=>{this._serializers.delete(u),this._proxy.$unregisterSerializer(u)})}async $deserializeWebviewPanel(h,u,d,f){const l=this._serializers.get(u);if(!l)throw new Error(`No serializer found for '${u}'`);const{serializer:_,extension:A}=l,N=this.webviews.createNewWebview(h,d.webviewOptions,A),x=this.createNewWebviewPanel(h,u,d.title,f,d.panelOptions,N);await _.deserializeWebviewPanel(x,d.state)}createNewWebviewPanel(h,u,d,f,l,_){const A=new E(h,this._proxy,u,d,f,l,_);return this._webviewPanels.set(h,A),A}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=r;function t(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(X,e,m,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,m):k?k.value=m:e.set(X,m),m},Le=this&&this.__classPrivateFieldGet||function(X,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(X):i?i.value:e.get(X)};define(ve[257],we([0,1,3,6,69,5,7]),function(X,e,m,i,k,C,T){"use strict";var I,y,P,L,D,c,b,p,v,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class R extends i.Disposable{constructor(n,g,a,E,r,t){super();I.set(this,void 0),y.set(this,void 0),P.set(this,void 0),L.set(this,void 0),D.set(this,!1),c.set(this,void 0),b.set(this,void 0),p.set(this,void 0),v.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Le(this,v,"f").event,w.set(this,this._register(new m.Emitter)),this.onDidDispose=Le(this,w,"f").event,tt(this,P,a,"f"),tt(this,b,E,"f"),tt(this,I,n,"f"),tt(this,y,g,"f"),tt(this,L,r,"f"),tt(this,c,t,"f")}dispose(){Le(this,D,"f")||(tt(this,D,!0,"f"),Le(this,w,"f").fire(),Le(this,L,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Le(this,b,"f")}set title(n){this.assertNotDisposed(),Le(this,b,"f")!==n&&(tt(this,b,n,"f"),Le(this,y,"f").$setWebviewViewTitle(Le(this,I,"f"),n))}get description(){return this.assertNotDisposed(),Le(this,p,"f")}set description(n){this.assertNotDisposed(),Le(this,p,"f")!==n&&(tt(this,p,n,"f"),Le(this,y,"f").$setWebviewViewDescription(Le(this,I,"f"),n))}get visible(){return Le(this,c,"f")}get webview(){return Le(this,L,"f")}get viewType(){return Le(this,P,"f")}_setVisible(n){n===Le(this,c,"f")||Le(this,D,"f")||(tt(this,c,n,"f"),Le(this,v,"f").fire())}show(n){this.assertNotDisposed(),Le(this,y,"f").$show(Le(this,I,"f"),!!n)}assertNotDisposed(){if(Le(this,D,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,y=new WeakMap,P=new WeakMap,L=new WeakMap,D=new WeakMap,c=new WeakMap,b=new WeakMap,p=new WeakMap,v=new WeakMap,w=new WeakMap;class S{constructor(n,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=n.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,g,a,E){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:a,extension:n}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(n),g,{retainContextWhenHidden:E?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(n,g,a,E,r){const t=this._viewProviders.get(g);if(!t)throw new Error(`No view provider found for '${g}'`);const{provider:o,extension:h}=t,u=this._extHostWebview.createNewWebview(n,{},h),d=new R(n,this._proxy,g,a,u,!0);this._webviewViews.set(n,d),await o.resolveWebviewView(d,{state:E},r)}async $onDidChangeWebviewViewVisibility(n,g){this.getWebviewView(n)._setVisible(g)}async $disposeWebviewView(n){const g=this.getWebviewView(n);this._webviewViews.delete(n),g.dispose(),this._extHostWebview.deleteWebview(n)}getWebviewView(n){const g=this._webviewViews.get(n);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=S}),define(ve[134],we([0,1,3,5,2,10,9,4,14]),function(X,e,m,i,k,C,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class zi{constructor(D){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=zi.InitialState,this._proxy=D.getProxy(i.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(D){D!==this._state.focused&&(this._state={...this._state,focused:D},this._onDidChangeWindowState.fire(this._state))}openUri(D,c){let b;if(typeof D=="string"){b=D;try{D=k.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,T.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this._proxy.$openUri(D,b,c)}async asExternalUri(D,c){if((0,T.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this._proxy.$asExternalUri(D,c);return k.URI.from(b)}};P.InitialState={focused:!0},P=je([He(0,y.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(ve[258],we([0,1,8,82,33,38,6,5,2,14]),function(X,e,m,i,k,C,T,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends T.Disposable{constructor(c,b){super();const p=c.getProxy(I.MainContext.MainThreadDownloadService);b.registerCommand(!1,"_workbench.downloadResource",async v=>{const w=y.URI.file((0,m.join)((0,i.tmpdir)(),(0,k.generateUuid)()));return await p.$download(v,w),w})}};L=je([He(0,P.IExtHostRpcService),He(1,C.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ve[259],we([0,1,132,10,188,33]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class T extends m.ExtHostLoggerService{doCreateLogger(y,P,L){return y.scheme===i.Schemas.file?new k.SpdLogLogger(L?.name||(0,C.generateUuid)(),y.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,P):super.doCreateLogger(y,P,L)}}e.ExtHostLoggerService=T}),define(ve[260],we([0,1,60,8,2,68,6,10,18,29]),function(X,e,m,i,k,C,T,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(a){const E=await super._getWorkspaceStorageURI(a);if(E.scheme!==I.Schemas.file)return E;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${E.fsPath}.`),E;const r=E.fsPath;let t=0;do{let o;t===0?o=r:o=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${t}`:`${r}-${t}`,await D(o);const h=i.join(o,"vscode.lock"),u=await v(this._logService,h,!1);if(u)return this._workspaceStorageLock=u,process.on("exit",()=>{u.dispose()}),k.URI.file(o);t++}while(t<10);return E}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function D(g){try{await P.Promises.stat(g);return}catch{}try{await P.Promises.mkdir(g,{recursive:!0})}catch{}}const c=1e3,b=10*60*1e3;class p extends T.Disposable{constructor(a,E){super();this.logService=a,this.filename=E,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await w(a,E);(!r||r.pid!==process.pid)&&(a.info(`Lock '${E}': The lock was lost unexpectedly.`),this._timer.cancel());try{await P.Promises.utimes(E,new Date,new Date)}catch(t){a.error(t),a.info(`Lock '${E}': Could not update mtime.`)}},c)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch{}}async setWillRelease(a){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${a} ms.`);try{const E={pid:process.pid,willReleaseAt:Date.now()+a};await P.Promises.writeFile(this.filename,JSON.stringify(E),{flag:"w"})}catch(E){this.logService.error(E)}}}async function v(g,a,E){try{const t={pid:process.pid,willReleaseAt:0};await P.Promises.writeFile(a,JSON.stringify(t),{flag:"wx"})}catch(t){g.error(t)}const r=await w(g,a);return!r||r.pid!==process.pid?E?(g.info(`Lock '${a}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${a}': Could not acquire lock, checking if the file is stale.`),s(g,a)):(g.info(`Lock '${a}': Lock acquired.`),new p(g,a))}async function w(g,a){let E;try{E=await P.Promises.readFile(a)}catch(r){return g.error(r),null}try{return JSON.parse(String(E))}catch(r){return g.error(r),null}}async function R(g,a){let E;try{E=await P.Promises.stat(a)}catch(r){return g.error(r),0}return E.mtime.getTime()}function S(g){try{return process.kill(g,0),!0}catch{return!1}}async function s(g,a){const E=await w(g,a);if(!E)return g.info(`Lock '${a}': Could not read pid of lock holder.`),n(g,a);if(E.willReleaseAt){let u=E.willReleaseAt-Date.now();if(u<5e3){for(u>0?g.info(`Lock '${a}': The lockfile is scheduled to be released in ${u} ms.`):g.info(`Lock '${a}': The lockfile is scheduled to have been released.`);u>0;){if(await(0,y.timeout)(Math.min(100,u)),await R(g,a)===0)return n(g,a);u=E.willReleaseAt-Date.now()}return n(g,a)}}if(!S(E.pid))return g.info(`Lock '${a}': The pid ${E.pid} appears to be gone.`),n(g,a);const r=await R(g,a),t=Date.now()-r;if(t<=b)return g.info(`Lock '${a}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;g.info(`Lock '${a}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const o=await R(g,a),h=Date.now()-o;return h<=b?(g.info(`Lock '${a}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(g.info(`Lock '${a}': The lock looks stale even after waiting for 2s.`),n(g,a))}async function n(g,a){g.info(`Lock '${a}': Deleting a stale lock.`);try{await P.Promises.unlink(a)}catch{}return v(g,a,!0)}}),define(ve[261],we([0,1,33,14,34]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends k.BaseExtHostTerminalService{constructor(I){super(!0,I)}createTerminal(I,y,P){return this.createTerminalFromOptions({name:I,shellPath:y,shellArgs:P})}createTerminalFromOptions(I,y){const P=new k.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),I,I.name);return this._terminals.push(P),P.create(I,this._serializeParentTerminal(I,y)),P.value}};C=je([He(0,i.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(ve[262],we([0,1,5,14,171,6,26,2,37,23,29,7,12,52,3,121,79,11]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class S{constructor(d,f,l){this.remoteAddress=d,this.localAddress=f,this._dispose=l,this._onDispose=new p.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function s(u){const d=u.trim().split(`
`),f=[];return d.forEach(_=>{const A=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(_);A&&A.length>=3&&f.push({pid:parseInt(A[1],10),socket:parseInt(A[2],10)})}),f.reduce((_,A)=>(_[A.socket]=A,_),{})}e.getSockets=s;function n(...u){const d=[].concat(...u.map(a));return[...new Map(d.filter(f=>f.st==="0A").map(f=>{const l=f.local_address.split(":");return{socket:parseInt(f.inode,10),ip:g(l[0]),port:parseInt(l[1],16)}}).map(f=>[f.ip+":"+f.port,f])).values()]}e.loadListeningPorts=n;function g(u){let d="";if(u.length===8)for(let f=u.length-2;f>=0;f-=2)d+=parseInt(u.substr(f,2),16),f!==0&&(d+=".");else for(let f=u.length-4;f>=0;f-=4)d+=parseInt(u.substr(f,4),16).toString(16),f!==0&&(d+=":");return d}e.parseIpAddress=g;function a(u){const d=u.trim().split(`
`),f=d.shift().trim().split(/\s+/).filter(_=>_!=="rx_queue"&&_!=="tm->when");return d.map(_=>_.trim().split(/\s+/).reduce((A,N,x)=>(A[f[x]||x]=N,A),{}))}e.loadConnectionTable=a;function E(u){return!!u.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||u.indexOf("out/vs/server/main.js")!==-1||u.indexOf("_productName=VSCode")!==-1}function r(u){const d=u.trim().split(`
`),f=[];return d.forEach(l=>{const _=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(l);_&&_.length>=4&&f.push({pid:parseInt(_[1],10),ppid:parseInt(_[2]),cmd:_[3]})}),f}e.getRootProcesses=r;async function t(u,d,f){const l=f.reduce((A,N)=>(A[N.pid]=N,A),{}),_=[];return u.forEach(({socket:A,ip:N,port:x})=>{const F=d[A]?d[A].pid:void 0,O=F?l[F]?.cmd:void 0;F&&O&&!E(O)&&_.push({host:N,port:x,detail:O,pid:F})}),_}e.findPorts=t;function o(u,d,f){const l=new Map,_=r(d);for(const A of u){const N=f.get(A.port);if(N){l.set(A.port,N);continue}const x=_.find(F=>F.cmd.includes(`${A.port}`));if(x){let F=x,O;do O=_.find(z=>z.ppid===F.pid),O&&(F=O);while(O);l.set(A.port,{host:A.ip,port:A.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else l.set(A.port,{host:A.ip,port:A.port,ppid:Number.MAX_VALUE})}return l}e.tryFindRootPorts=o;let h=class extends C.Disposable{constructor(d,f,l){super();this.logService=l,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new p.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=d.getProxy(m.MainContext.MainThreadTunnelService),c.isLinux&&f.remote.isRemote&&f.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(d,f){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const l=await this._proxy.$openTunnel(f,d.displayName);if(l){const _=new S(l.remoteAddress,l.localAddress,()=>this._proxy.$closeTunnel(l.remoteAddress));return this._register(_),_}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(d){return Math.max(d*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(d,f){const l=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(l,{selector:d,provider:f}),this._proxy.$registerPortsAttributesProvider(d,l),new D.Disposable(()=>{this._portAttributesProviders.delete(l),this._proxy.$unregisterPortsAttributesProvider(l)})}async $providePortAttributes(d,f,l,_,A){const N=[];for(const F of d){const O=this._portAttributesProviders.get(F);if(!O)return[];N.push(...await Promise.all(f.map(async z=>O.provider.providePortAttributes(z,l,_,A))))}const x=N.filter(F=>!!F);return x.length>0?x.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(d){if(d&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=d;let f=new w.MovingAverage,l;for(;this._candidateFindingEnabled;){const _=new Date().getTime(),A=(await this.findCandidatePorts()).filter(x=>(0,v.isLocalhost)(x.host)||(0,v.isAllInterfaces)(x.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${A.map(x=>x.port).join(", ")}`);const N=new Date().getTime()-_;f.update(N),(!l||JSON.stringify(l)!==JSON.stringify(A))&&(l=A,await this._proxy.$onFoundNewCandidates(l)),await new Promise(x=>setTimeout(()=>x(),this.calculateDelay(f.value)))}}async setTunnelExtensionFunctions(d){if(d){if(d.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this._showCandidatePort=d.showCandidatePort,this._proxy.$setCandidateFilter()),d.tunnelFactory){this._forwardPortProvider=d.tunnelFactory;let f=d.tunnelFeatures?.privacyOptions??[];d.tunnelFeatures?.public&&f.length===0&&(f=[{id:"private",label:k.localize(0,null),themeIcon:"lock"},{id:"public",label:k.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!d.tunnelFeatures?.elevation,public:!!d.tunnelFeatures?.public,privacyOptions:f})}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(d,f){if(this._extensionTunnels.has(d.host)){const l=this._extensionTunnels.get(d.host);l.has(d.port)&&(f&&l.get(d.port).disposeListener.dispose(),await l.get(d.port).tunnel.dispose(),l.delete(d.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(d,f){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const l=this._forwardPortProvider(d,f);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),l!==void 0){const _=await l;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(d.remoteAddress.host)||this._extensionTunnels.set(d.remoteAddress.host,new Map);const A=this._register(_.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(_.remoteAddress))));return this._extensionTunnels.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:_,disposeListener:A}),b.TunnelDto.fromApiTunnel(_)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(d){const f=await Promise.all(d.map(_=>this._showCandidatePort(_.host,_.port,_.detail??""))),l=d.filter((_,A)=>f[A]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(_=>_.port).join(", ")} to ${l.map(_=>_.port).join(", ")}`),l}async findCandidatePorts(){let d="",f="";try{d=await L.Promises.readFile("/proc/net/tcp","utf8"),f=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const l=n(d,f),_=await new Promise(M=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(B,W,U)=>{M(W)})}),A=s(_),N=await L.Promises.readdir("/proc"),x=[];for(let M of N)try{const B=Number(M),W=P.joinPath(I.URI.file("/proc"),M);if((await L.Promises.stat(W.fsPath)).isDirectory()&&!isNaN(B)){const j=await L.Promises.readlink(P.joinPath(W,"cwd").fsPath),Z=await L.Promises.readFile(P.joinPath(W,"cmdline").fsPath,"utf8");x.push({pid:B,cwd:j,cmd:Z})}}catch{}const F=[],O=l.filter(M=>{const B=A[M.socket];return B||F.push(M),B}),z=t(O,A,x);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const M=await new Promise(B=>{(0,y.exec)("ps -F -A -l | grep root",(W,U,j)=>{B(U)})});this._foundRootPorts=o(F,M,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return z.then(M=>$?M.concat($):M)}};h=je([He(0,i.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,R.ILogService)],h),e.ExtHostTunnelService=h}),define(ve[263],we([0,1,18,22,21,15,3,6,103,227,53]),function(X,e,m,i,k,C,T,I,y,P,L){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(l,_){try{return JSON.stringify(l,_)}catch{return"null"}}const b="$$ref$$",p={[b]:-1};class v{constructor(_,A){this.jsonString=_,this.referencedBuffers=A}}function w(l,_=null,A=!1){const N=[];return{jsonString:(A?c:JSON.stringify)(l,(F,O)=>{if(typeof O=="undefined")return p;if(typeof O=="object"){if(O instanceof i.VSBuffer){const z=N.push(O)-1;return{[b]:z}}if(_)return _(F,O)}return O}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=w;function R(l,_,A){return JSON.parse(l,(N,x)=>{if(x){const F=x[b];if(typeof F=="number")return _[F];if(A&&x.$mid===1)return A.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=R;function S(l,_){return JSON.stringify(l,_)}function s(l){return l?(_,A)=>A&&A.$mid===1?l.transformOutgoing(A):A:null}var n;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(n=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},E=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class t extends I.Disposable{constructor(_,A=null,N=null){super();this[D]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=_,this._logger=A,this._uriTransformer=N,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let x=0,F=L.ProxyIdentifier.count;x<F;x++)this._locals[x]=null,this._proxies[x]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(x=>this._receiveOneMessage(x))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(_=>{this._pendingRPCReplies[_].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(_){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(_){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(_){this._responsiveState!==_&&(this._responsiveState=_,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(_){return this._uriTransformer?(0,y.transformIncomingURIs)(_,this._uriTransformer):_}getProxy(_){const{nid:A,sid:N}=_;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,N)),this._proxies[A]}_createProxy(_,A){let N={get:(x,F)=>(typeof F=="string"&&!x[F]&&F.charCodeAt(0)===36&&(x[F]=(...O)=>this._remoteCall(_,F,O)),F===r?A:x[F])};return new Proxy(Object.create(null),N)}set(_,A){return this._locals[_.nid]=A,A}assertRegistered(_){for(let A=0,N=_.length;A<N;A++){const x=_[A];if(!this._locals[x.nid])throw new Error(`Missing actor ${x.sid} (isMain: ${x.isMain})`)}}_receiveOneMessage(_){if(this._isDisposed)return;const A=_.byteLength,N=o.read(_,0),x=N.readUInt8(),F=N.readUInt32();switch(x){case 1:case 2:{let{rpcId:O,method:z,args:$}=u.deserializeRequestJSONArgs(N);this._uriTransformer&&($=(0,y.transformIncomingURIs)($,this._uriTransformer)),this._receiveRequest(A,F,O,z,$,x===2);break}case 3:case 4:{let{rpcId:O,method:z,args:$}=u.deserializeRequestMixedArgs(N);this._uriTransformer&&($=(0,y.transformIncomingURIs)($,this._uriTransformer)),this._receiveRequest(A,F,O,z,$,x===4);break}case 5:{this._logger&&this._logger.logIncoming(A,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(A,F);break}case 7:{this._receiveReply(A,F,void 0);break}case 9:{let O=u.deserializeReplyOKJSON(N);this._uriTransformer&&(O=(0,y.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReply(A,F,O);break}case 10:{const O=u.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(A,F,O);break}case 8:{let O=u.deserializeReplyOKVSBuffer(N);this._receiveReply(A,F,O);break}case 11:{let O=u.deserializeReplyErrError(N);this._uriTransformer&&(O=(0,y.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReplyErr(A,F,O);break}case 12:{this._receiveReplyErr(A,F,void 0);break}default:console.error("received unexpected message"),console.error(_)}}_receiveRequest(_,A,N,x,F,O){this._logger&&this._logger.logIncoming(_,A,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(N)}.${x}(`,F);const z=String(A);let $,M;if(O){const W=new k.CancellationTokenSource;F.push(W.token),$=this._invokeHandler(N,x,F),M=()=>W.cancel()}else $=this._invokeHandler(N,x,F),M=a;this._cancelInvokedHandlers[z]=M;const B=u.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing(B.byteLength,A,1,"ack"),this._protocol.send(B),$.then(W=>{delete this._cancelInvokedHandlers[z];const U=u.serializeReplyOK(A,W,this._uriReplacer);this._logger&&this._logger.logOutgoing(U.byteLength,A,1,"reply:",W),this._protocol.send(U)},W=>{delete this._cancelInvokedHandlers[z];const U=u.serializeReplyErr(A,W);this._logger&&this._logger.logOutgoing(U.byteLength,A,1,"replyErr:",W),this._protocol.send(U)})}_receiveCancel(_,A){this._logger&&this._logger.logIncoming(_,A,1,"receiveCancel");const N=String(A);this._cancelInvokedHandlers[N]&&this._cancelInvokedHandlers[N]()}_receiveReply(_,A,N){this._logger&&this._logger.logIncoming(_,A,0,"receiveReply:",N);const x=String(A);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const F=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x],F.resolveOk(N)}_receiveReplyErr(_,A,N){this._logger&&this._logger.logIncoming(_,A,0,"receiveReplyErr:",N);const x=String(A);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const F=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x];let O;N&&(N.$isError?(O=new Error,O.name=N.name,O.message=N.message,O.stack=N.stack):O=N),F.resolveErr(O)}_invokeHandler(_,A,N){try{return Promise.resolve(this._doInvokeHandler(_,A,N))}catch(x){return Promise.reject(x)}}_doInvokeHandler(_,A,N){const x=this._locals[_];if(!x)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(_));let F=x[A];if(typeof F!="function")throw new Error("Unknown method "+A+" on actor "+(0,L.getStringIdentifierForProxy)(_));return F.apply(x,N)}_remoteCall(_,A,N){if(this._isDisposed)return Promise.reject(C.canceled());let x=null;if(N.length>0&&k.CancellationToken.isCancellationToken(N[N.length-1])&&(x=N.pop()),x&&x.isCancellationRequested)return Promise.reject(C.canceled());const F=u.serializeRequestArguments(N,this._uriReplacer),O=++this._lastMessageId,z=String(O),$=new P.LazyPromise;x&&x.onCancellationRequested(()=>{const B=u.serializeCancel(O);this._logger&&this._logger.logOutgoing(B.byteLength,O,0,"cancel"),this._protocol.send(u.serializeCancel(O))}),this._pendingRPCReplies[z]=$,this._onWillSendRequest(O);const M=u.serializeRequest(O,_,A,F,!!x);return this._logger&&this._logger.logOutgoing(M.byteLength,O,0,`request: ${(0,L.getStringIdentifierForProxy)(_)}.${A}(`,N),this._protocol.send(M),$}}e.RPCProtocol=t,D=E,t.UNRESPONSIVE_TIME=3*1e3;class o{constructor(_,A){this._buff=_,this._offset=A}static alloc(_,A,N){let x=new o(i.VSBuffer.alloc(N+1+4),0);return x.writeUInt8(_),x.writeUInt32(A),x}static read(_,A){return new o(_,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(_){this._buff.writeUInt8(_,this._offset),this._offset+=1}readUInt8(){const _=this._buff.readUInt8(this._offset);return this._offset+=1,_}writeUInt32(_){this._buff.writeUInt32BE(_,this._offset),this._offset+=4}readUInt32(){const _=this._buff.readUInt32BE(this._offset);return this._offset+=4,_}static sizeShortString(_){return 1+_.byteLength}writeShortString(_){this._buff.writeUInt8(_.byteLength,this._offset),this._offset+=1,this._buff.set(_,this._offset),this._offset+=_.byteLength}readShortString(){const _=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+_).toString();return this._offset+=_,N}static sizeLongString(_){return 4+_.byteLength}writeLongString(_){this._buff.writeUInt32BE(_.byteLength,this._offset),this._offset+=4,this._buff.set(_,this._offset),this._offset+=_.byteLength}readLongString(){const _=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+_).toString();return this._offset+=_,N}writeBuffer(_){this._buff.writeUInt32BE(_.byteLength,this._offset),this._offset+=4,this._buff.set(_,this._offset),this._offset+=_.byteLength}static sizeVSBuffer(_){return 4+_.byteLength}writeVSBuffer(_){this._buff.writeUInt32BE(_.byteLength,this._offset),this._offset+=4,this._buff.set(_,this._offset),this._offset+=_.byteLength}readVSBuffer(){const _=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+_);return this._offset+=_,A}static sizeMixedArray(_){let A=0;A+=1;for(let N=0,x=_.length;N<x;N++){const F=_[N];switch(A+=1,F.type){case 1:A+=this.sizeLongString(F.value);break;case 2:A+=this.sizeVSBuffer(F.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(F.value);for(let O=0;O<F.buffers.length;++O)A+=this.sizeVSBuffer(F.buffers[O]);break;case 4:break}}return A}writeMixedArray(_){this._buff.writeUInt8(_.length,this._offset),this._offset+=1;for(let A=0,N=_.length;A<N;A++){const x=_[A];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let F=0;F<x.buffers.length;++F)this.writeBuffer(x.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const _=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(_);for(let N=0;N<_;N++)switch(this.readUInt8()){case 1:A[N]=this.readLongString();break;case 2:A[N]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),O=this.readLongString(),z=[];for(let $=0;$<F;++$)z.push(this.readVSBuffer());A[N]=new L.SerializableObjectWithBuffers(R(O,z,null));break}case 4:A[N]=void 0;break}return A}}o.sizeUInt32=4;var h;(function(l){l[l.Simple=0]="Simple",l[l.Mixed=1]="Mixed"})(h||(h={}));class u{static _useMixedArgSerialization(_){for(let A=0,N=_.length;A<N;A++)if(_[A]instanceof i.VSBuffer||_[A]instanceof L.SerializableObjectWithBuffers||typeof _[A]=="undefined")return!0;return!1}static serializeRequestArguments(_,A){if(this._useMixedArgSerialization(_)){const N=[];for(let x=0,F=_.length;x<F;x++){const O=_[x];if(O instanceof i.VSBuffer)N[x]={type:2,value:O};else if(typeof O=="undefined")N[x]={type:4};else if(O instanceof L.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:$}=w(O.value,A);N[x]={type:3,value:i.VSBuffer.fromString(z),buffers:$}}else N[x]={type:1,value:i.VSBuffer.fromString(S(O,A))}}return{type:1,args:N}}return{type:0,args:S(_,A)}}static serializeRequest(_,A,N,x,F){switch(x.type){case 0:return this._requestJSONArgs(_,A,N,x.args,F);case 1:return this._requestMixedArgs(_,A,N,x.args,F)}}static _requestJSONArgs(_,A,N,x,F){const O=i.VSBuffer.fromString(N),z=i.VSBuffer.fromString(x);let $=0;$+=o.sizeUInt8(),$+=o.sizeShortString(O),$+=o.sizeLongString(z);let M=o.alloc(F?2:1,_,$);return M.writeUInt8(A),M.writeShortString(O),M.writeLongString(z),M.buffer}static deserializeRequestJSONArgs(_){const A=_.readUInt8(),N=_.readShortString(),x=_.readLongString();return{rpcId:A,method:N,args:JSON.parse(x)}}static _requestMixedArgs(_,A,N,x,F){const O=i.VSBuffer.fromString(N);let z=0;z+=o.sizeUInt8(),z+=o.sizeShortString(O),z+=o.sizeMixedArray(x);let $=o.alloc(F?4:3,_,z);return $.writeUInt8(A),$.writeShortString(O),$.writeMixedArray(x),$.buffer}static deserializeRequestMixedArgs(_){const A=_.readUInt8(),N=_.readShortString(),x=_.readMixedArray(),F=new Array(x.length);for(let O=0,z=x.length;O<z;O++){const $=x[O];typeof $=="string"?F[O]=JSON.parse($):F[O]=$}return{rpcId:A,method:N,args:F}}static serializeAcknowledged(_){return o.alloc(5,_,0).buffer}static serializeCancel(_){return o.alloc(6,_,0).buffer}static serializeReplyOK(_,A,N){if(typeof A=="undefined")return this._serializeReplyOKEmpty(_);if(A instanceof i.VSBuffer)return this._serializeReplyOKVSBuffer(_,A);if(A instanceof L.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:F}=w(A.value,N,!0);return this._serializeReplyOKJSONWithBuffers(_,x,F)}else return this._serializeReplyOKJSON(_,c(A,N))}static _serializeReplyOKEmpty(_){return o.alloc(7,_,0).buffer}static _serializeReplyOKVSBuffer(_,A){let N=0;N+=o.sizeVSBuffer(A);let x=o.alloc(8,_,N);return x.writeVSBuffer(A),x.buffer}static deserializeReplyOKVSBuffer(_){return _.readVSBuffer()}static _serializeReplyOKJSON(_,A){const N=i.VSBuffer.fromString(A);let x=0;x+=o.sizeLongString(N);let F=o.alloc(9,_,x);return F.writeLongString(N),F.buffer}static _serializeReplyOKJSONWithBuffers(_,A,N){const x=i.VSBuffer.fromString(A);let F=0;F+=o.sizeUInt32,F+=o.sizeLongString(x);for(const z of N)F+=o.sizeVSBuffer(z);let O=o.alloc(10,_,F);O.writeUInt32(N.length),O.writeLongString(x);for(const z of N)O.writeBuffer(z);return O.buffer}static deserializeReplyOKJSON(_){const A=_.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(_,A){const N=_.readUInt32(),x=_.readLongString(),F=[];for(let O=0;O<N;++O)F.push(_.readVSBuffer());return new L.SerializableObjectWithBuffers(R(x,F,A))}static serializeReplyErr(_,A){return A?this._serializeReplyErrEror(_,A):this._serializeReplyErrEmpty(_)}static _serializeReplyErrEror(_,A){const N=i.VSBuffer.fromString(c(C.transformErrorForSerialization(A),null));let x=0;x+=o.sizeLongString(N);let F=o.alloc(11,_,x);return F.writeLongString(N),F.buffer}static deserializeReplyErrError(_){const A=_.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(_){return o.alloc(12,_,0).buffer}}var d;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",l[l.ReplyErrError=11]="ReplyErrError",l[l.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var f;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",l[l.Undefined=4]="Undefined"})(f||(f={}))}),define(ve[264],we([0,1,4]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(ve[265],we([0,1,28,10,8,12,23,2,4,63,43,222,264]),function(X,e,m,i,k,C,T,I,y,P,L,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let b=class Vi{constructor(v,w,R,S){this.localUserHome=v,this.remoteAgentService=w,this.environmentService=R,this.contextService=S,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||C.OS)(),this.resolveUserHome=(async()=>{const s=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=s?.userHome||v})()}hasValidBasename(v,w,R){return typeof w=="string"||typeof w=="undefined"?this.resolveOS.then(S=>this.doHasValidBasename(v,S,w)):this.doHasValidBasename(v,w,R)}doHasValidBasename(v,w,R){return v.scheme===i.Schemas.file||v.scheme===i.Schemas.vscodeRemote?(0,m.isValidBasename)(R??(0,T.basename)(v),w===1):!0}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(v,w){if(v.remoteAuthority)return i.Schemas.vscodeRemote;const R=(0,P.getVirtualWorkspaceScheme)(w.getWorkspace());if(R)return R;const S=w.getWorkspace().folders[0];if(S)return S.uri.scheme;const s=w.getWorkspace().configuration;return s?s.scheme:i.Schemas.file}async userHome(v){return v?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(v=>v===1?k.win32:k.posix)}async fileURI(v){let w="";if(await this.resolveOS===1&&(v=v.replace(/\\/g,"/")),v[0]==="/"&&v[1]==="/"){const S=v.indexOf("/",2);S===-1?(w=v.substring(2),v="/"):(w=v.substring(2,S),v=v.substring(S)||"/")}return I.URI.from({scheme:i.Schemas.file,authority:w,path:v,query:"",fragment:""})}};b=je([He(1,c.IRemoteAgentService),He(2,D.IWorkbenchEnvironmentService),He(3,L.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(ve[70],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(T,I){this.line=T,this.character=I}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,I){return new m(0,0)}with(T){return new m(0,0)}}e.Position=m;class i{constructor(T,I,y,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(T,I),this.end=new m(y,P)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new i(0,0,0,0)}with(T){return new i(0,0,0,0)}}e.Range=i;var k;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[31],we([0,1,16,32,25,28,9,4,8,15,70,13]),function(X,e,m,i,k,C,T,I,y,P,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",b=" characters skipped \u27EB",p=(c.length+b.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var v;(function(B){B[B.file=0]="file",B[B.text=1]="text"})(v=e.SearchProviderType||(e.SearchProviderType={}));var w;(function(B){B[B.File=1]="File",B[B.Text=2]="Text"})(w=e.QueryType||(e.QueryType={}));function R(B){return!!B.preview}e.resultIsMatch=R;function S(B){return!!B.resource}e.isFileMatch=S;function s(B){return!!B.message}e.isProgressMessage=s;var n;(function(B){B[B.Normal=0]="Normal",B[B.NewSearchStarted=1]="NewSearchStarted"})(n=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(W){this.resource=W,this.results=[]}}e.FileMatch=g;class a{constructor(W,U,j){this.ranges=U;const Z=Array.isArray(U)?U:[U];if(j&&j.matchLines===1&&E(Z)){W=(0,T.getNLines)(W,j.matchLines);let ce="",Q=0,V=0;const te=Math.floor(j.charsPerLine/5),me=[];for(const ge of Z){const ke=Math.max(ge.startColumn-te,0),Be=ge.startColumn+j.charsPerLine;if(ke>V+te+p){const xe=c+(ke-V)+b;ce+=xe+W.slice(ke,Be),Q+=ke-(V+xe.length)}else ce+=W.slice(V,Be);me.push(new t(0,ge.startColumn-Q,ge.endColumn-Q)),V=Be}this.preview={text:ce,matches:Array.isArray(this.ranges)?me:me[0]}}else{const ce=Array.isArray(U)?U[0].startLineNumber:U.startLineNumber;this.preview={text:W,matches:(0,m.mapArrayOrNot)(U,Q=>new r(Q.startLineNumber-ce,Q.startColumn,Q.endLineNumber-ce,Q.endColumn))}}}}e.TextSearchMatch=a;function E(B){const W=B[0].startLineNumber;for(const U of B)if(U.startLineNumber!==W||U.endLineNumber!==W)return!1;return!0}class r{constructor(W,U,j,Z){this.startLineNumber=W,this.startColumn=U,this.endLineNumber=j,this.endColumn=Z}}e.SearchRange=r;class t extends r{constructor(W,U,j){super(W,U,W,j)}}e.OneLineRange=t;var o;(function(B){B.Default="default",B.FileNames="fileNames",B.Type="type",B.Modified="modified",B.CountDescending="countDescending",B.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function h(B,W=!0){const U=B&&B.files&&B.files.exclude,j=W&&B&&B.search&&B.search.exclude;if(!U&&!j)return;if(!U||!j)return U||j;let Z=Object.create(null);return Z=k.mixin(Z,k.deepClone(U)),Z=k.mixin(Z,k.deepClone(j),!0),Z}e.getExcludes=h;function u(B,W){return B.excludePattern&&i.match(B.excludePattern,W)?!1:B.includePattern||B.usingSearchPaths?B.includePattern&&i.match(B.includePattern,W)?!0:B.usingSearchPaths?!!B.folderQueries&&B.folderQueries.some(U=>{const j=U.folder.fsPath;if(C.isEqualOrParent(W,j)){const Z=y.relative(j,W);return!U.includePattern||!!i.match(U.includePattern,Z)}else return!1}):!1:!0}e.pathIncludedInQuery=u;var d;(function(B){B[B.unknownEncoding=1]="unknownEncoding",B[B.regexParseError=2]="regexParseError",B[B.globParseError=3]="globParseError",B[B.invalidLiteral=4]="invalidLiteral",B[B.rgProcessError=5]="rgProcessError",B[B.other=6]="other",B[B.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class f extends Error{constructor(W,U){super(W);this.code=U}}e.SearchError=f;function l(B){const W=B.message;if((0,P.isPromiseCanceledError)(B))return new f(W,d.canceled);try{const U=JSON.parse(W);return new f(U.message,U.code)}catch{return new f(W,d.other)}}e.deserializeSearchError=l;function _(B){const W={message:B.message,code:B.code};return new Error(JSON.stringify(W))}e.serializeSearchError=_;function A(B){return B.type==="error"?!0:B.type==="success"}e.isSerializedSearchComplete=A;function N(B){return B.type==="success"}e.isSerializedSearchSuccess=N;function x(B){return!!B.path}e.isSerializedFileMatch=x;function F(B,W){const U=B.searchPath?B.searchPath:B.relativePath;return(0,T.fuzzyContains)(U,W)}e.isFilePatternMatch=F;class O{constructor(W){this.path=W,this.results=[]}addMatch(W){this.results.push(W)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function z(B,W){const U={...B||{},...W||{}};return Object.keys(U).filter(j=>{const Z=U[j];return typeof Z=="boolean"&&Z})}e.resolvePatternsForProvider=z;class ${constructor(W,U){this._parsedIncludeExpression=null,this._excludeExpression={...W.excludePattern||{},...U.excludePattern||{}},this._parsedExcludeExpression=i.parse(this._excludeExpression);let j=W.includePattern;U.includePattern&&(j?j={...j,...U.includePattern}:j=U.includePattern),j&&(this._parsedIncludeExpression=i.parse(j))}matchesExcludesSync(W,U,j){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(W,U,j))}includedInQuerySync(W,U,j){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(W,U,j)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(W,U,j))}includedInQuery(W,U,j){const Z=this._parsedExcludeExpression(W,U,j),ce=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(W,U,j):!0;return(0,D.isPromise)(Z)?Z.then(Q=>Q?!1:ce()):ce()}hasSiblingExcludeClauses(){return M(this._excludeExpression)}}e.QueryGlobTester=$;function M(B){for(const W in B)if(typeof B[W]!="boolean")return!0;return!1}}),define(ve[35],we([0,1,16,18,21,3,24,10,79,23,9,13,2,169,4,11,189,43,44,26,14,7,31,5]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S,s,n,g,a,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(_,A,N){return new P.ExtUri(x=>u(x,N)).isEqual(_,A)}function t(_,A,N){return r(_.uri,A.uri,N)?0:(0,L.compare)(_.uri.toString(),A.uri.toString())}function o(_,A,N){return _.index!==A.index?_.index<A.index?-1:1:r(_.uri,A.uri,N)?(0,L.compare)(_.name,A.name):(0,L.compare)(_.uri.toString(),A.uri.toString())}function h(_,A,N,x){const F=_.slice(0).sort((z,$)=>N(z,$,x)),O=A.slice(0).sort((z,$)=>N(z,$,x));return(0,m.delta)(F,O,(z,$)=>N(z,$,x))}function u(_,A){const N=A.getCapabilities(_.scheme);return!(N&&N&1024)}class d extends R.Workspace{constructor(A,N,x,F,O,z,$){super(A,x.map(M=>new R.WorkspaceFolder(M)),F,O,$);this._name=N,this._isUntitled=z,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris($),x.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(A,N,x,F){if(!A)return{workspace:null,added:[],removed:[]};const{id:O,name:z,folders:$,configuration:M,transient:B,isUntitled:W}=A,U=[],j=N;N?$.forEach((V,te)=>{const me=c.URI.revive(V.uri),ge=d._findFolder(x||N,me,F);ge?(ge.name=V.name,ge.index=V.index,U.push(ge)):U.push({uri:me,name:V.name,index:te})}):U.push(...$.map(({uri:V,name:te,index:me})=>({uri:c.URI.revive(V),name:te,index:me}))),U.sort((V,te)=>V.index<te.index?-1:1);const Z=new d(O,z,U,!!B,M?c.URI.revive(M):null,!!W,V=>u(V,F)),{added:ce,removed:Q}=h(j?j.workspaceFolders:[],Z.workspaceFolders,t,F);return{workspace:Z,added:ce,removed:Q}}static _findFolder(A,N,x){for(let F=0;F<A.folders.length;F++){const O=A.workspaceFolders[F];if(r(O.uri,N,x))return O}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(A,N){return N&&this._structure.get(A)&&(A=(0,P.dirname)(A)),this._structure.findSubstr(A)}resolveWorkspaceFolder(A){return this._structure.get(A)}}let f=class{constructor(A,N,x,F){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=x,this._requestIdProvider=new y.Counter,this._barrier=new i.Barrier,this._proxy=A.getProxy(E.MainContext.MainThreadWorkspace),this._messageService=A.getProxy(E.MainContext.MainThreadMessageService);const O=N.workspace;this._confirmedWorkspace=O?new d(O.id,O.name,[],!!O.transient,O.configuration?c.URI.revive(O.configuration):null,!!O.isUntitled,z=>u(z,x)):void 0}$initializeWorkspace(A,N){this._trusted=N,this.$acceptWorkspaceData(A),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:I.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(A,N,x,...F){const O=[];if(Array.isArray(F)&&F.forEach(W=>{c.URI.isUri(W.uri)&&!O.some(U=>r(U.uri,W.uri,this._extHostFileSystemInfo))&&O.push({uri:W.uri,name:W.name||(0,P.basenameOrAuthority)(W.uri)})}),this._unconfirmedWorkspace||[N,x].some(W=>typeof W!="number"||W<0)||x===0&&O.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+x>z.length)return!1;const $=z.slice(0);$.splice(N,x,...O.map(W=>({uri:W.uri,name:W.name||(0,P.basenameOrAuthority)(W.uri),index:void 0})));for(let W=0;W<$.length;W++){const U=$[W];if($.some((j,Z)=>Z!==W&&r(U.uri,j.uri,this._extHostFileSystemInfo)))return!1}$.forEach((W,U)=>W.index=U);const{added:M,removed:B}=h(z,$,o,this._extHostFileSystemInfo);if(M.length===0&&B.length===0)return!1;if(this._proxy){const W=A.displayName||A.name;this._proxy.$updateWorkspaceFolders(W,N,x,O).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,(0,b.localize)(0,null,W,U.toString()),{extension:A},[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(A,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,N)}async getWorkspaceFolder2(A,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,N)}async resolveWorkspaceFolder(A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(A)}getPath(){if(!this._actualWorkspace)return;const{folders:A}=this._actualWorkspace;if(A.length!==0)return A[0].uri.fsPath}getRelativePath(A,N){let x,F="";if(typeof A=="string"?(x=c.URI.file(A),F=A):typeof A!="undefined"&&(x=A,F=A.fsPath),!x)return F;const O=this.getWorkspaceFolder(x,!0);if(!O)return F;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let z=(0,P.relativePath)(O.uri,x);return N&&O.name&&(z=`${O.name}/${z}`),z}trySetWorkspaceFolders(A){this._actualWorkspace&&(this._unconfirmedWorkspace=d.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:A,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(A){const{workspace:N,added:x,removed:F}=d.toExtHostWorkspace(A,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:x,removed:F}))}findFiles(A,N,x,F,O=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let z;if(N===null?z=!1:N&&(typeof N=="string"?z=N:z=N.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:$,folder:M}=l(A);return this._proxy.$startFileSearch((0,D.withUndefinedAsNull)($),(0,D.withUndefinedAsNull)(M),(0,D.withUndefinedAsNull)(z),(0,D.withUndefinedAsNull)(x),O).then(B=>Array.isArray(B)?B.map(W=>c.URI.revive(W)):[])}async findTextInFiles(A,N,x,F,O=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),$=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:M,folder:B}=l(N.include),W=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,U={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:$,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:M,excludePattern:W},j=!1;if(this._activeSearchCallbacks[z]=Z=>{if(j)return;const ce=c.URI.revive(Z.resource);Z.results.forEach(Q=>{(0,a.resultIsMatch)(Q)?x({uri:ce,preview:{text:Q.preview.text,matches:(0,m.mapArrayOrNot)(Q.preview.matches,V=>new g.Range(V.startLineNumber,V.startColumn,V.endLineNumber,V.endColumn))},ranges:(0,m.mapArrayOrNot)(Q.ranges,V=>new g.Range(V.startLineNumber,V.startColumn,V.endLineNumber,V.endColumn))}):x({uri:ce,text:Q.text,lineNumber:Q.lineNumber})})},O.isCancellationRequested)return{};try{const Z=await this._proxy.$startTextSearch(A,(0,D.withUndefinedAsNull)(B),U,z,O);return delete this._activeSearchCallbacks[z],Z||{}}catch(Z){throw delete this._activeSearchCallbacks[z],Z}}$handleTextSearchResult(A,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](A)}saveAll(A){return this._proxy.$saveAll(A)}resolveProxy(A){return this._proxy.$resolveProxy(A)}get trusted(){return this._trusted}requestWorkspaceTrust(A){return this._proxy.$requestWorkspaceTrust(A)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};f=je([He(0,n.IExtHostRpcService),He(1,s.IExtHostInitDataService),He(2,S.IExtHostFileSystemInfo),He(3,v.ILogService)],f),e.ExtHostWorkspace=f,e.IExtHostWorkspace=(0,p.createDecorator)("IExtHostWorkspace");function l(_){let A,N;return _&&(typeof _=="string"?A=_:(A=_.pattern,N=_.baseFolder||c.URI.file(_.base))),{includePattern:A,folder:N}}}),define(ve[36],we([0,1,25,3,35,5,7,193,119,13,18,4,14,11,2]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(E,r){if(r){const t=r.split(".");let o=E;for(let h=0;o&&h<t.length;h++)o=o[t[h]];return o}}function w(E){return E instanceof p.URI}function R(E){return E&&E.uri instanceof p.URI&&E.languageId&&typeof E.languageId=="string"}function S(E){return E&&!E.uri&&E.languageId&&typeof E.languageId=="string"}function s(E){return E&&E.uri instanceof p.URI&&(!E.name||typeof E.name=="string")&&(!E.index||typeof E.index=="number")}function n(E){if(w(E))return{resource:E};if(R(E))return{resource:E.uri,overrideIdentifier:E.languageId};if(S(E))return{overrideIdentifier:E.languageId};if(s(E))return{resource:E.uri};if(E===null)return{resource:null}}let g=class{constructor(r,t,o){this._proxy=r.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=o,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new a(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,t){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(r,t))}};g=je([He(0,c.IExtHostRpcService),He(1,k.IExtHostWorkspace),He(2,b.ILogService)],g),e.ExtHostConfiguration=g;class a{constructor(r,t,o,h){this._onDidChangeConfiguration=new i.Emitter,this._proxy=r,this._logService=h,this._extHostWorkspace=t,this._configuration=I.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,t){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,o))}getConfiguration(r,t,o){const h=n(t)||{},u=this._toReadonlyValue(r?v(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,h,o?.identifier);function d(l){if(l==null)return null;if(typeof l=="boolean")return l?1:4;switch(l){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(l){return typeof v(u,l)!="undefined"},get:(l,_)=>{this._validateConfigurationAccess(r?`${r}.${l}`:l,h,o?.identifier);let A=v(u,l);if(typeof A=="undefined")A=_;else{let N;const x=(F,O)=>{let z;const $=()=>{N=N||(0,m.deepClone)(u),z=z||v(N,O)};return(0,P.isObject)(F)?new Proxy(F,{get:(M,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return $(),()=>z;if(N)return z=z||v(N,O),z[B];const W=M[B];return typeof B=="string"?x(W,`${O}.${B}`):W},set:(M,B,W)=>($(),z&&(z[B]=W),!0),deleteProperty:(M,B)=>($(),z&&delete z[B],!0),defineProperty:(M,B,W)=>($(),z&&Object.defineProperty(z,B,W),!0)}):F};A=x(A,l)}return A},update:(l,_,A,N)=>{l=r?`${r}.${l}`:l;const x=d(A);return _!==void 0?this._proxy.$updateConfigurationOption(x,l,_,h,N):this._proxy.$removeConfigurationOption(x,l,h,N)},inspect:l=>{l=r?`${r}.${l}`:l;const _=(0,m.deepClone)(this._configuration.inspect(l,h,this._extHostWorkspace.workspace));if(_)return{key:l,defaultValue:_.default?.value,globalValue:_.user?.value,workspaceValue:_.workspace?.value,workspaceFolderValue:_.workspaceFolder?.value,defaultLanguageValue:_.default?.override,globalLanguageValue:_.user?.override,workspaceLanguageValue:_.workspace?.override,workspaceFolderLanguageValue:_.workspaceFolder?.override,languageIds:_.overrideIdentifiers}}};return typeof u=="object"&&(0,m.mixin)(f,u,!1),Object.freeze(f)}_toReadonlyValue(r){const t=o=>(0,P.isObject)(o)?new Proxy(o,{get:(h,u)=>t(h[u]),set:(h,u,d)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(u)}' of object`)},deleteProperty:(h,u)=>{throw new Error(`TypeError: Cannot delete read only property '${String(u)}' of object`)},defineProperty:(h,u)=>{throw new Error(`TypeError: Cannot define property '${String(u)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return t(r)}_validateConfigurationAccess(r,t,o){const h=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),u=o?`[${o.value}] `:"";if(h===4){typeof t?.resource=="undefined"&&this._logService.warn(`${u}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){t?.resource&&this._logService.warn(`${u}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,t){const o=new I.ConfigurationChangeEvent(r,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,u)=>o.affectsConfiguration(h,n(u))})}_toMap(r){return r.reduce((t,o)=>(t.set(o[0],o[1]),t),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(X,e,m,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,m):k?k.value=m:e.set(X,m),m},Le=this&&this.__classPrivateFieldGet||function(X,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(X):i?i.value:e.get(X)};define(ve[71],we([0,1,2,18,3,5,7,35,45,36,21,34,14,26,4,10,12,11,66,213,15]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S,s,n){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(O){function z(M){if(M!=null)return M}O.from=z;function $(M){if(M!=null)return M}O.to=$})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var E;(function(O){function z(M){if(M!=null)return M}O.from=z;function $(M){if(M!=null)return M}O.to=$})(E=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(O){function z(M){if(M!=null)return M}O.from=z;function $(M){if(M!=null)return M}O.to=$})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(O){function z(B){if(B){const W=B;return W&&!!W.process}else return!1}O.is=z;function $(B){if(B==null)return;const W={process:B.process,args:B.args};return B.options&&(W.options=r.from(B.options)),W}O.from=$;function M(B){if(B!=null)return new T.ProcessExecution(B.process,B.args,B.options)}O.to=M})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(O){function z(M){if(M!=null)return M}O.from=z;function $(M){if(M!=null)return M}O.to=$})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(O){function z(B){if(B){const W=B;return W&&(!!W.commandLine||!!W.command)}else return!1}O.is=z;function $(B){if(B==null)return;const W={};return B.commandLine!==void 0?W.commandLine=B.commandLine:(W.command=B.command,W.args=B.args),B.options&&(W.options=o.from(B.options)),W}O.from=$;function M(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new T.ShellExecution(B.commandLine,B.options):new T.ShellExecution(B.command,B.args?B.args:[],B.options)}O.to=M})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var u;(function(O){function z(B){if(B){let W=B;return W&&W.customExecution==="customExecution"}else return!1}O.is=z;function $(B){return{customExecution:"customExecution"}}O.from=$;function M(B,W){return W.get(B)}O.to=M})(u=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var d;(function(O){function z($,M){let B;return $.scope!==void 0&&typeof $.scope!="number"?B=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===T.TaskScope.Workspace&&M&&M.workspaceFile?B=M.workspaceFile:B=s.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:B}}O.from=z})(d=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(O){function z($){if($!=null)return{_id:$.id,isDefault:$.isDefault}}O.from=z})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var l;(function(O){function z(B,W){if(B==null)return[];const U=[];for(let j of B){const Z=$(j,W);Z&&U.push(Z)}return U}O.fromMany=z;function $(B,W){if(B==null)return;let U;B.execution instanceof T.ProcessExecution?U=t.from(B.execution):B.execution instanceof T.ShellExecution?U=h.from(B.execution):B.execution&&B.execution instanceof T.CustomExecution&&(U=u.from(B.execution));const j=a.from(B.definition);let Z;return B.scope?typeof B.scope=="number"?Z=B.scope:Z=B.scope.uri:Z=T.TaskScope.Workspace,!j||!Z?void 0:{_id:B._id,definition:j,name:B.name,source:{extensionId:W.identifier.value,label:B.source,scope:Z},execution:U,isBackground:B.isBackground,group:f.from(B.group),presentationOptions:E.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}O.from=$;async function M(B,W,U){if(B==null)return;let j;t.is(B.execution)?j=t.to(B.execution):h.is(B.execution)?j=h.to(B.execution):u.is(B.execution)&&(j=u.to(B._id,U));const Z=a.to(B.definition);let ce;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?ce=B.source.scope:ce=await W.resolveWorkspaceFolder(m.URI.revive(B.source.scope)):ce=T.TaskScope.Workspace),!Z||!ce)return;const Q=new T.Task(Z,ce,B.name,B.source.label,j,B.problemMatchers);return B.isBackground!==void 0&&(Q.isBackground=B.isBackground),B.group!==void 0&&(Q.group=T.TaskGroup.from(B.group._id),Q.group&&B.group.isDefault&&(Q.group=new T.TaskGroup(Q.group.id,Q.group.label),B.group.isDefault&&(Q.group.isDefault=B.group.isDefault))),B.presentationOptions&&(Q.presentationOptions=E.to(B.presentationOptions)),B._id&&(Q._id=B._id),B.detail&&(Q.detail=B.detail),Q}O.to=M})(l=e.TaskDTO||(e.TaskDTO={}));var _;(function(O){function z(M){return M}O.from=z;function $(M){if(!!M)return Object.assign(Object.create(null),M)}O.to=$})(_=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(z,$,M){this._id=$,this._task=M,g.set(this,void 0),tt(this,g,z,"f")}get task(){return this._task}terminate(){Le(this,g,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}g=new WeakMap;var N;(function(O){function z($){return{id:$._id,task:void 0}}O.from=z})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let x=class{constructor(z,$,M,B,W,U,j,Z){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=z.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=M,this._editorService=B,this._configurationService=W,this._terminalService=U,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=j,this._deprecationService=Z,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,$,M){if(!M)return new T.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:$,provider:M,extension:z}),this._proxy.$registerTaskProvider(B,$),new T.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(z,$){this._proxy.$registerTaskSystem(z,$)}fetchTasks(z){return this._proxy.$fetchTasks(_.from(z)).then(async $=>{const M=[];for(let B of $){const W=await l.to(B,this._workspaceProvider,this._providedCustomExecutions2);W&&M.push(W)}return M})}get taskExecutions(){const z=[];return this._taskExecutions.forEach($=>z.push($)),z}terminateTask(z){if(!(z instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,$,M){const B=this._providedCustomExecutions2.get(z.id);B&&(this._activeCustomExecutions2.set(z.id,B),this._terminalService.attachPtyToTerminal($,await B.callback(M))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const $=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const $=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:$,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const $=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:z.exitCode})}$provideTasks(z,$){const M=this._handlers.get(z);if(!M)return Promise.reject(new Error("no handler found"));const B=[],W=(0,i.asPromise)(()=>M.provider.provideTasks(L.CancellationToken.None)).then(U=>this.provideTasksInternal($,B,M,U));return new Promise(U=>{W.then(j=>{Promise.all(B).then(()=>{U(j)})})})}async $resolveTask(z,$){const M=this._handlers.get(z);if(!M)return Promise.reject(new Error("no handler found"));if($.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${M.type}].`);const B=await l.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const W=await M.provider.resolveTask(B,L.CancellationToken.None);if(!W)return;this.checkDeprecation(W,M);const U=l.from(W,M.extension);if(!U)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(U.execution)&&await this.addCustomExecution(U,W,!0),await this.resolveTaskInternal(U)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,$,M){const B=await this._proxy.$createTaskId(z);!M&&!this._providedCustomExecutions2.has(B)&&(this._notProvidedCustomExecutions.add(B),this._activeCustomExecutions2.set(B,$.execution)),this._providedCustomExecutions2.set(B,$.execution)}async getTaskExecution(z,$){if(typeof z=="string"){const W=this._taskExecutionPromises.get(z);if(!W)throw new Error("Unexpected: The specified task is missing an execution");return W}let M=this._taskExecutionPromises.get(z.id);if(M)return M;const B=new Promise((W,U)=>{function j(Z,ce,Q){Q?W(new A(Z,ce.id,Q)):U("Unexpected: Task does not exist.")}$?j(this,z,$):l.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(Z=>j(this,z,Z))});return this._taskExecutionPromises.set(z.id,B),B.then(W=>(this._taskExecutions.set(z.id,W),W),W=>Promise.reject(W))}checkDeprecation(z,$){z._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let M=this._notProvidedCustomExecutions.values(),B=M.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=M.next()}};x=je([He(0,c.IExtHostRpcService),He(1,b.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,y.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,D.IExtHostTerminalService),He(6,R.ILogService),He(7,S.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let F=class extends x{constructor(z,$,M,B,W,U,j,Z){super(z,$,M,B,W,U,j,Z);this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(z,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const M=l.from($,z);if(M===void 0)throw new Error("Task is not valid");if(u.is(M.execution))await this.addCustomExecution(M,$,!1);else throw new n.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(M),$);return this._proxy.$executeTask(M).catch(W=>{throw new Error(W)}),B}provideTasksInternal(z,$,M,B){const W=[];if(B)for(let U of B){this.checkDeprecation(U,M),(!U.definition||!z[U.definition.type])&&this._logService.warn(`The task [${U.source}, ${U.name}] uses an undefined task type. The task will be ignored in the future.`);const j=l.from(U,M.extension);j&&u.is(j.execution)?(W.push(j),$.push(this.addCustomExecution(j,U,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:W,extension:M.extension}}async resolveTaskInternal(z){if(u.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,$){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,$,M){}};F=je([He(0,c.IExtHostRpcService),He(1,b.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,y.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,D.IExtHostTerminalService),He(6,R.ILogService),He(7,S.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(ve[266],we([0,1,16,75,32,81,24,10,8,23,9,13,2,149,175,116,43,128,265,31]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let n=class{constructor(d,f,l,_){this.configurationService=d,this.workspaceContextService=f,this.editorGroupsService=l,this.pathService=_}text(d,f,l={}){d=this.getContentPattern(d,l);const _=this.configurationService.getValue(),A=f&&f.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(f?.map(w.toWorkspaceFolder),l),type:2,contentPattern:d,previewOptions:l.previewOptions,maxFileSize:l.maxFileSize,usePCRE2:_.search.usePCRE2||A||!1,beforeContext:l.beforeContext,afterContext:l.afterContext,userDisabledExcludesAndIgnoreFiles:l.disregardExcludeSettings&&l.disregardIgnoreFiles}}getContentPattern(d,f){const l=this.configurationService.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const _={...d,wordSeparators:l.editor.wordSeparators};return this.isCaseSensitive(d,f)&&(_.isCaseSensitive=!0),this.isMultiline(d)&&(_.isMultiline=!0),_}file(d,f={}){return{...this.commonQuery(d,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}handleIncludeExclude(d,f){return d?(d=Array.isArray(d)?d.map(t):t(d),f?this.parseSearchPaths(d):{pattern:a(...Array.isArray(d)?d:[d])}):{}}commonQuery(d=[],f={}){const l=this.handleIncludeExclude(f.includePattern,f.expandPatterns),_=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),A=d.length>1,N=(l.searchPaths&&l.searchPaths.length?l.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,f,_)):d.map(O=>this.getFolderQueryForRoot(O,f,_,A))).filter(O=>!!O),x={_reason:f._reason,folderQueries:N,usingSearchPaths:!!(l.searchPaths&&l.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:_.pattern,includePattern:l.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const z=m.coalesce(m.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(B=>B.resource)))).filter(M=>(0,s.pathIncludedInQuery)(x,M.fsPath)),$=this.commonQueryFromFileList(z);return{...x,...$}}const F=f.extraFileResources&&f.extraFileResources.filter(O=>(0,s.pathIncludedInQuery)(x,O.fsPath));return x.extraFileResources=F&&F.length?F:void 0,x}commonQueryFromFileList(d){const f=[],l=new T.ResourceMap,_={};let A=!1;return d.forEach(N=>{if(N.scheme===I.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(N)){const F=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:y.dirname(N.fsPath)});let O=l.get(F);O||(A=!0,O={folder:F,includePattern:{}},f.push(O),l.set(F,O));const z=y.relative(F.fsPath,N.fsPath);(0,D.assertIsDefined)(O.includePattern)[z.replace(/\\/g,"/")]=!0}else N.fsPath&&(A=!0,_[N.fsPath]=!0)}),{folderQueries:f,includePattern:_,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(d,f){if(f.isSmartCase){if(d.isRegExp){if(L.containsUppercaseCharacter(d.pattern,!0))return!0}else if(L.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}isMultiline(d){return d.isMultiline||d.isRegExp&&(0,b.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const f=$=>y.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),_=(Array.isArray(d)?d:E(d)).map($=>{const M=this.pathService.resolvedUserHome;return M?(0,C.untildify)($,M.scheme===I.Schemas.file?M.fsPath:M.path):$}),A=i.groupBy(_,$=>f($)?"searchPaths":"exprSegments"),N=(A.exprSegments||[]).map($=>L.rtrim($,"/")).map($=>L.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),r($))),x={},F=this.expandSearchPathPatterns(A.searchPaths||[]);F&&F.length&&(x.searchPaths=F);const O=m.flatten(N),z=a(...O);return z&&(x.pattern=z),x}getExcludesForFolder(d,f){return f.disregardExcludeSettings?void 0:(0,s.getExcludes)(d,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(d){if(!d||!d.length)return[];const f=m.flatten(d.map(_=>{let{pathPortion:A,globPortion:N}=g(_);N&&(N=o(N));const x=this.expandOneSearchPath(A);return m.flatten(x.map(F=>this.resolveOneSearchPathPattern(F,N)))})),l=new Map;return f.forEach(_=>{const A=_.searchPath.toString(),N=l.get(A);N?_.pattern&&(N.pattern=N.pattern||{},N.pattern[_.pattern]=!0):l.set(A,{searchPath:_.searchPath,pattern:_.pattern?a(_.pattern):void 0})}),Array.from(l.values())}expandOneSearchPath(d){if(y.isAbsolute(d)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==I.Schemas.file?[{searchPath:f[0].uri.with({path:d})}]:[{searchPath:c.URI.file(y.normalize(d))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(d=t(d),d.startsWith("../")||d===".."){const _=y.posix.resolve(f.path,d);return[{searchPath:f.with({path:_})}]}const l=o(d);return[{searchPath:f,pattern:l}]}else{if(d==="./"||d===".\\")return[];{const f=d.replace(/^\.[\/\\]/,""),_=this.workspaceContextService.getWorkspace().folders.map(A=>{const N=f.match(new RegExp(`^${L.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return N?{match:N,folder:A}:null}).filter(D.isDefined);if(_.length)return _.map(A=>{const N=A.match[1];return{searchPath:A.folder.uri,pattern:N&&o(N)}});{const A=d.match(/\.[\/\\](.+)[\/\\]?/),N=A?A[1]:d,x=p.localize(0,null,N);throw new Error(x)}}}}resolveOneSearchPathPattern(d,f){const l=d.pattern&&f?`${d.pattern}/${f}`:d.pattern||f,_=[{searchPath:d.searchPath,pattern:l}];return l&&!l.endsWith("**")&&_.push({searchPath:d.searchPath,pattern:l+"/**"}),_}getFolderQueryForSearchPath(d,f,l){const _=this.getFolderQueryForRoot((0,w.toWorkspaceFolder)(d.searchPath),f,l,!1);return _?{..._,includePattern:d.pattern}:null}getFolderQueryForRoot(d,f,l,_){let A;const N=c.URI.isUri(d)?d:d.uri;if(l.searchPaths){const $=l.searchPaths.filter(M=>(0,P.isEqual)(M.searchPath,N))[0];if($&&!$.pattern)return null;$&&(A=$.pattern)}const x=this.configurationService.getValue({resource:N}),O={...this.getExcludesForFolder(x,f)||{},...A||{}},z=c.URI.isUri(d)?(0,P.basename)(d):d.name;return{folder:N,folderName:_?z:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!x.search.followSymlinks}}};n=je([He(0,v.IConfigurationService),He(1,w.IWorkspaceContextService),He(2,R.IEditorGroupsService),He(3,S.IPathService)],n),e.QueryBuilder=n;function g(u){const d=u.match(/[\*\{\}\(\)\[\]\?]/);if(d){const f=d.index,l=u.substr(0,f).match(/[/|\\][^/\\]*$/);if(l){let _=u.substr(0,l.index);return _.match(/[/\\]/)||(_+="/"),{pathPortion:_,globPortion:u.substr((l.index||0)+1)}}}return{pathPortion:u}}function a(...u){return u.length?u.reduce((d,f)=>(d[f]=!0,d),Object.create(null)):void 0}function E(u){return k.splitGlobAware(u,",").map(d=>d.trim()).filter(d=>!!d.length)}function r(u){return[`**/${u}/**`,`**/${u}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function t(u){return u.replace(/\\/g,"/")}function o(u){return t(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(u,d){u=m.distinct(u,_=>_.toString());const f=[],l=d.getWorkspace();return u&&u.forEach(_=>{let A;if(d.getWorkbenchState()===2)A=(0,P.relativePath)(l.folders[0].uri,_),A&&A!=="."&&(A="./"+A);else{const N=d.getWorkspaceFolder(_);if(N){const x=N.name;if(l.folders.filter(O=>O.name===x).length===1){const O=(0,P.relativePath)(N.uri,_);O===""?A=`./${N.name}`:A=`./${N.name}/${O}`}else A=_.fsPath}}A&&f.push(A)}),f}e.resolveResourcesForSearchIncludes=h}),define(ve[267],we([0,1,23,2,21,15,4,266,31,43]),function(X,e,m,i,k,C,T,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function D(v,w){const R=w.activationEvents;if(!R)return Promise.resolve(void 0);const S=[],s=[];for(const t of R)if(/^workspaceContains:/.test(t)){const o=t.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||v.forceUsingSearch?s.push(o):S.push(o)}if(S.length===0&&s.length===0)return Promise.resolve(void 0);let n;const g=new Promise((t,o)=>{n=t}),a=t=>n({activationEvent:t}),E=Promise.all(S.map(t=>c(v,t,a))).then(()=>{}),r=b(v,w.identifier,s,a);return Promise.all([E,r]).then(()=>{n(void 0)}),g}e.checkActivateWorkspaceContainsExtension=D;async function c(v,w,R){for(const S of v.folders)if(await v.exists(m.joinPath(i.URI.revive(S),w))){R(`workspaceContains:${w}`);return}}async function b(v,w,R,S){if(R.length===0)return Promise.resolve(void 0);const s=new k.CancellationTokenSource,n=v.checkExists(v.folders,R,s.token),g=setTimeout(async()=>{s.cancel(),v.logService.info(`Not activating extension '${w.value}': Timed out while searching for 'workspaceContains' pattern ${R.join(",")}`)},L);let a=!1;try{a=await n}catch(E){C.isPromiseCanceledError(E)||C.onUnexpectedError(E)}s.dispose(),clearTimeout(g),a&&S(`workspaceContains:${R.join(",")}`)}function p(v,w,R,S){const s=v.get(T.IInstantiationService),n=v.get(y.ISearchService),a=s.createInstance(I.QueryBuilder).file(w.map(E=>(0,P.toWorkspaceFolder)(i.URI.revive(E))),{_reason:"checkExists",includePattern:R,exists:!0});return n.fileSearch(a,S).then(E=>!!E.limitHit,E=>C.isPromiseCanceledError(E)?!1:Promise.reject(E))}e.checkGlobFileExists=p});var tt=this&&this.__classPrivateFieldSet||function(X,e,m,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,m):k?k.value=m:e.set(X,m),m},Le=this&&this.__classPrivateFieldGet||function(X,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(X):i?i.value:e.get(X)};define(ve[39],we([0,1,164,8,72,23,18,6,24,2,11,5,36,225,91,35,30,223,15,27,22,199,7,120,4,26,68,14,85,52,34,3,267,90,201,10]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S,s,n,g,a,E,r,t,o,h,u,d,f,l,_,A,N,x){"use strict";var F,O,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let $=class ji extends I.Disposable{constructor(U,j,Z,ce,Q,V,te,me,ge,ke){super();this._onDidChangeRemoteConnectionData=this._register(new l.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=j,this._extHostContext=Z,this._initData=te,this._extHostWorkspace=ce,this._extHostConfiguration=Q,this._logService=V,this._extHostTunnelService=ge,this._extHostTerminalService=ke,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(D.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(D.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(D.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new R.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new p.ExtHostStorage(this._extHostContext),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=me,this._instaService=U.createChild(new u.ServiceCollection([p.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState]));const Be=new Set;this._initData.hostExtensions.forEach(xe=>Be.add(s.ExtensionIdentifier.toKey(xe))),this._activator=this._register(new b.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(xe,q,Y)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(xe,S.transformErrorForSerialization(q),Y)},actualActivateExtension:async(xe,q)=>{if(Be.has(s.ExtensionIdentifier.toKey(xe)))return await this._mainThreadExtensionsProxy.$activateExtension(xe,q),new b.HostExtension;const Y=this._registry.getExtensionDescription(xe);return this._activateExtension(Y,q)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(U){S.onUnexpectedError(U)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let U=[];try{U=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch{}await Promise.all(U)}isActivated(U){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(U):!1}_activateByEvent(U,j){return this._activator.activateByEvent(U,j)}_activateById(U,j){return this._activator.activateById(U,j)}activateByIdWithErrors(U,j){return this._activateById(U,j).then(()=>{const Z=this._activator.getActivatedExtension(U);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(U=>this._registry)}getExtensionExports(U){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(U).exports:null}async _realPathExtensionUri(U){if(U.scheme!==x.Schemas.file)return U;const j=await this._hostUtils.realpath(U.fsPath);return P.URI.file(j)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const U=y.TernarySearchTree.forUris(j=>C.extUriBiasedIgnorePathCase.ignorePathCasing(j));for(const j of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(j)){const Z=await this._realPathExtensionUri(j.extensionLocation);U.set(Z,j)}return U})()),this._extensionPathIndex}_deactivate(U){let j=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(U))return j;const Z=this._activator.getActivatedExtension(U);if(!Z)return j;try{typeof Z.module.deactivate=="function"&&(j=Promise.resolve(Z.module.deactivate()).then(void 0,ce=>(this._logService.error(ce),Promise.resolve(void 0))))}catch(ce){this._logService.error(`An error occurred when deactivating the extension '${U.value}':`),this._logService.error(ce)}try{(0,I.dispose)(Z.subscriptions)}catch(ce){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this._logService.error(ce)}return j}async _activateExtension(U,j){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier),this._doActivateExtension(U,j).then(Z=>{const ce=Z.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(U.identifier,ce.codeLoadingTime,ce.activateCallTime,ce.activateResolvedTime,j),this._logExtensionActivationTimes(U,j,"success",ce),Z},Z=>{throw this._logExtensionActivationTimes(U,j,"failure"),Z})}_logExtensionActivationTimes(U,j,Z,ce){const Q=M(U,j);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...ce||{},outcome:Z})}_doActivateExtension(U,j){const Z=M(U,j);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Z);const ce=this._getEntryPoint(U);if(!ce)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${j.startup}, activationEvent: '${j.activationEvent}'${U.identifier.value!==j.extensionId.value?`, root cause: ${j.extensionId.value}`:""}`),this._logService.flush();const Q=new b.ExtensionActivationTimesBuilder(j.startup);return Promise.all([this._loadCommonJSModule(U.identifier,(0,C.joinPath)(U.extensionLocation,ce),Q),this._loadExtensionContext(U)]).then(V=>(k.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),ji._callActivate(this._logService,U.identifier,V[0],V[1],Q))).then(V=>(k.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),V))}_loadExtensionContext(U){const j=new g.ExtensionGlobalMemento(U,this._storage),Z=new g.ExtensionMemento(U.identifier.value,!1,this._storage),ce=new N.ExtensionSecrets(U,this._secretState),Q=U.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,V=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([j.whenReady,Z.whenReady,this._storagePath.whenReady]).then(()=>{const te=this;let me;const ge=(0,w.isProposedApiEnabled)(U,"ipc")?this._initData.messagePorts?.get(s.ExtensionIdentifier.toKey(U.identifier)):void 0;return Object.freeze({globalState:j,workspaceState:Z,secrets:ce,subscriptions:[],get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(ke){return i.join(U.extensionLocation.fsPath,ke)},get storagePath(){return te._storagePath.workspaceValue(U)?.fsPath},get globalStoragePath(){return te._storagePath.globalValue(U).fsPath},get logPath(){return i.join(te._initData.logsLocation.fsPath,U.identifier.value)},get logUri(){return P.URI.joinPath(te._initData.logsLocation,U.identifier.value)},get storageUri(){return te._storagePath.workspaceValue(U)},get globalStorageUri(){return te._storagePath.globalValue(U)},get extensionMode(){return Q},get extension(){return me===void 0&&(me=new B(te,U.identifier,U,V)),me},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(U,"extensionRuntime"),te.extensionRuntime},get environmentVariableCollection(){return te._extHostTerminalService.getEnvironmentVariableCollection(U)},messagePassingProtocol:ge&&{onDidReceiveMessage:l.Event.fromDOMEventEmitter(ge,"message",ke=>ke.data),postMessage:ge.postMessage.bind(ge)}})})}static _callActivate(U,j,Z,ce,Q){return Z=Z||{activate:void 0,deactivate:void 0},this._callActivateOptional(U,j,Z,ce,Q).then(V=>new b.ActivatedExtension(!1,null,Q.build(),Z,V,ce.subscriptions))}static _callActivateOptional(U,j,Z,ce,Q){if(typeof Z.activate=="function")try{Q.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${j.value}`);const V=typeof global=="object"?global:self,te=Z.activate.apply(V,[ce]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(te).then(me=>(Q.activateResolveStop(),me))}catch(V){return Promise.reject(V)}else return Promise.resolve(Z)}_activateOneStartupFinished(U,j){this._activateById(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:j}).then(void 0,Z=>{this._logService.error(Z)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const U of this._registry.getAllExtensionDescriptions())if(U.activationEvents)for(const j of U.activationEvents)j==="onStartupFinished"&&this._activateOneStartupFinished(U,j)}_handleEagerExtensions(){const U=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const j=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Z=this._handleWorkspaceContainsEagerExtensions(j),ce=Promise.all([U,Z]).then(()=>{});return Promise.race([ce,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ce}_handleWorkspaceContainsEagerExtensions(U){return U.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(j=>this._handleWorkspaceContainsEagerExtension(U,j))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(U,j){if(this.isActivated(j.identifier))return;const Z=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ce={logService:this._logService,folders:U.map(V=>V.uri),forceUsingSearch:Z,exists:V=>this._hostUtils.exists(V.fsPath),checkExists:(V,te,me)=>this._mainThreadWorkspaceProxy.$checkExists(V,te,me)},Q=await(0,_.checkActivateWorkspaceContainsExtension)(ce,j);if(!!Q)return this._activateById(j.identifier,{startup:!0,extensionId:j.identifier,activationEvent:Q.activationEvent}).then(void 0,V=>this._logService.error(V))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(U){throw console.error(U),U}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:j}=this._initData.environment;if(!U||!j)throw new Error(m.localize(0,null));const Z=await this._loadCommonJSModule(null,j,new b.ExtensionActivationTimesBuilder(!1));if(!Z||typeof Z.run!="function")throw new Error(m.localize(1,null,j.toString()));return new Promise((ce,Q)=>{const V=(ge,ke)=>{ge?Q(ge):ce(typeof ke=="number"&&ke>0?1:0)},te=(0,C.originalFSPath)(j),me=Z.run(te,V);me&&me.then&&me.then(()=>{ce(0)}).catch(ge=>{Q(ge instanceof Error&&ge.stack?ge.stack:String(ge))})})}async $extensionTestsExit(U){this._logService.info(`Extension host terminating: test runner requested exit with code ${U}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${U}`),this._logService.flush(),this._hostUtils.exit(U)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,j){return this._resolvers[U]=j,(0,I.toDisposable)(()=>{delete this._resolvers[U]})}async _activateAndGetResolver(U){const j=U.indexOf("+");if(j===-1)throw new Error("Not an authority that can be resolved!");const Z=U.substr(0,j);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Z}`,!1),{authorityPrefix:Z,resolver:this._resolvers[Z]}}async $resolveAuthority(U,j){const{authorityPrefix:Z,resolver:ce}=await this._activateAndGetResolver(U);if(!ce)return{type:"error",error:{code:E.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Z}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(ce)),k.mark(`code/extHost/willResolveAuthority/${Z}`);const Q=await ce.resolve(U,{resolveAttempt:j});k.mark(`code/extHost/didResolveAuthorityOK/${Z}`);const V={authority:U,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},te={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted,authenticationSession:Q.authenticationSessionForInitializingExtensions?{id:Q.authenticationSessionForInitializingExtensions.id,providerId:Q.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:V,options:te,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(k.mark(`code/extHost/didResolveAuthorityError/${Z}`),Q instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(U,j){const{authorityPrefix:Z,resolver:ce}=await this._activateAndGetResolver(U);if(!ce)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${Z}`);const Q=P.URI.revive(j);if(typeof ce.getCanonicalURI=="undefined")return Q;const V=await(0,T.asPromise)(()=>ce.getCanonicalURI(Q));return V||Q}$startExtensionHost(U){return this._registry.keepOnly(U),this._startExtensionHost()}$activateByEvent(U,j){return j===1?this._activateByEvent(U,!1):this._readyToRunExtensions.wait().then(Z=>this._activateByEvent(U,!1))}async $activate(U,j){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(U)?(await this._activateById(U,j),!0):!1}async $deltaExtensions(U,j){U.forEach(ce=>ce.extensionLocation=P.URI.revive(ce.extensionLocation));const Z=await this.getExtensionPathIndex();return await Promise.all(j.map(async ce=>{const Q=this._registry.getExtensionDescription(ce);Q&&Z.delete(await this._realPathExtensionUri(Q.extensionLocation))})),await Promise.all(U.map(async ce=>{const Q=await this._realPathExtensionUri(ce.extensionLocation);Z.set(Q,ce)})),this._registry.deltaExtensions(U,j),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){let j=n.VSBuffer.alloc(U),Z=Math.random()%256;for(let ce=0;ce<U;ce++)j.writeUInt8(Z,ce);return j}async $updateRemoteConnectionData(U){this._remoteConnectionData=U,this._onDidChangeRemoteConnectionData.fire()}};$=je([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,h.IExtHostRpcService),He(3,v.IExtHostWorkspace),He(4,c.IExtHostConfiguration),He(5,L.ILogService),He(6,t.IExtHostInitDataService),He(7,o.IExtensionStoragePaths),He(8,d.IExtHostTunnelService),He(9,f.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function M(W,U){return{id:W.identifier.value,name:W.name,extensionVersion:W.version,publisherDisplayName:W.publisher,activationEvents:W.activationEvents?W.activationEvents.join(","):null,isBuiltin:W.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class B{constructor(U,j,Z,ce){F.set(this,void 0),O.set(this,void 0),z.set(this,void 0),tt(this,F,U,"f"),tt(this,O,j,"f"),tt(this,z,Z.identifier,"f"),this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=i.normalize((0,C.originalFSPath)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=ce}get isActive(){return Le(this,F,"f").isActivated(Le(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return Le(this,F,"f").getExtensionExports(Le(this,z,"f"))}activate(){return Le(this,F,"f").activateByIdWithErrors(Le(this,z,"f"),{startup:!1,extensionId:Le(this,O,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=B,F=new WeakMap,O=new WeakMap,z=new WeakMap}),define(ve[55],we([0,1,8,2,3,18,5,7,124,35,39,45,215,36,208,14,4,13,40,54]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let n=class{constructor(u,d,f,l,_,A){this._workspaceService=d,this._extensionService=f,this._editorsService=l,this._configurationService=_,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=u.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(N=>{N.onDidChange(x=>{this.registerAllDebugTypes(N)}),this.registerAllDebugTypes(N)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(u,d){const f=u;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let l=`debug:${encodeURIComponent(f.path||"")}`,_="?";return d&&(l+=`${_}session=${encodeURIComponent(d.id)}`,_="&"),l+=`${_}ref=${f.sourceReference}`,i.URI.parse(l)}else{if(f.path)return i.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(u){const d=[];for(const f of u.getAllExtensionDescriptions())if(f.contributes){const l=f.contributes.debuggers;if(l&&l.length>0)for(const _ of l)(0,p.isDebuggerMainContribution)(_)&&d.push(_.type)}this._debugServiceProxy.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const u=[];return this._breakpoints.forEach(d=>u.push(d)),u}addBreakpoints(u){this.startBreakpoints();const d=u.filter(_=>{const A=_.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,_),!0)});this.fireBreakpointChanges(d,[],[]);const f=[],l=new Map;for(const _ of d)if(_ instanceof I.SourceBreakpoint){let A=l.get(_.location.uri.toString());A||(A={type:"sourceMulti",uri:_.location.uri,lines:[]},l.set(_.location.uri.toString(),A),f.push(A)),A.lines.push({id:_.id,enabled:_.enabled,condition:_.condition,hitCondition:_.hitCondition,logMessage:_.logMessage,line:_.location.range.start.line,character:_.location.range.start.character})}else _ instanceof I.FunctionBreakpoint&&f.push({type:"function",id:_.id,enabled:_.enabled,hitCondition:_.hitCondition,logMessage:_.logMessage,condition:_.condition,functionName:_.functionName});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(u){this.startBreakpoints();const d=u.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],d,[]);const f=d.filter(A=>A instanceof I.SourceBreakpoint).map(A=>A.id),l=d.filter(A=>A instanceof I.FunctionBreakpoint).map(A=>A.id),_=d.filter(A=>A instanceof I.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(f,l,_)}startDebugging(u,d,f){return this._debugServiceProxy.$startDebugging(u?u.uri:void 0,d,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,debugUI:f.debugUI,suppressSaveBeforeStart:f.suppressSaveBeforeStart})}stopDebugging(u){return this._debugServiceProxy.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,d,f){if(!d)return new I.Disposable(()=>{});const l=this._configProviderHandleCounter++;return this._configProviders.push({type:u,handle:l,provider:d}),this._debugServiceProxy.$registerDebugConfigurationProvider(u,f,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,l),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(_=>_.provider!==d),this._debugServiceProxy.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(u,d,f){if(!f)return new I.Disposable(()=>{});if(!this.definesDebugType(u,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.getAdapterDescriptorFactoryByType(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:d,handle:l,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(d,l),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(_=>_.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(u,d){if(!d)return new I.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:u,handle:f,factory:d}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(l=>l.factory!==d)})}async $runInTerminal(u,d){return Promise.resolve(void 0)}async $substituteVariables(u,d){if(!this._variableResolver){const[_,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(_||[],this._editorsService,A)}let f;const l=await this.getFolder(u);return l&&(f={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(f,d)}createDebugAdapter(u,d){if(u.type==="implementation")return new t(u.implementation)}createSignService(){}async $startDASession(u,d){const f=this,l=await this.getSession(d);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(l.type),l).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const A=this.convertToDto(_),N=this.createDebugAdapter(A,l);if(!N)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const x=N;return this._debugAdapters.set(u,x),this.getDebugAdapterTrackers(l).then(F=>(F&&this._debugAdaptersTrackers.set(u,F),x.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const z=O,$={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(z.arguments.value);$.body={signature:M},x.sendResponse($)}else throw new Error("no signer")}catch(M){$.success=!1,$.message=M.message,x.sendResponse($)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(O),O=(0,p.convertToVSCPaths)(O,!0),f._debugServiceProxy.$acceptDAMessage(u,O)}),x.onError(O=>{F&&F.onError&&F.onError(O),this._debugServiceProxy.$acceptDAError(u,O.name,O.message,O.stack)}),x.onExit(O=>{F&&F.onExit&&F.onExit((0,R.withNullAsUndefined)(O),void 0),this._debugServiceProxy.$acceptDAExit(u,(0,R.withNullAsUndefined)(O),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),x.startSession()))})}$sendDAMessage(u,d){d=(0,p.convertToDAPaths)(d,!1);const f=this._debugAdaptersTrackers.get(u);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(d);const l=this._debugAdapters.get(u);l&&l.sendMessage(d)}$stopDASession(u){const d=this._debugAdaptersTrackers.get(u);this._debugAdaptersTrackers.delete(u),d&&d.onWillStopSession&&d.onWillStopSession();const f=this._debugAdapters.get(u);return this._debugAdapters.delete(u),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const d=[],f=[],l=[];if(u.added)for(const _ of u.added){const A=_.id;if(A&&!this._breakpoints.has(A)){let N;if(_.type==="function")N=new I.FunctionBreakpoint(_.functionName,_.enabled,_.condition,_.hitCondition,_.logMessage);else if(_.type==="data")N=new I.DataBreakpoint(_.label,_.dataId,_.canPersist,_.enabled,_.hitCondition,_.condition,_.logMessage);else{const x=i.URI.revive(_.uri);N=new I.SourceBreakpoint(new I.Location(x,new I.Position(_.line,_.character)),_.enabled,_.condition,_.hitCondition,_.logMessage)}N._id=A,this._breakpoints.set(A,N),d.push(N)}}if(u.removed)for(const _ of u.removed){const A=this._breakpoints.get(_);A&&(this._breakpoints.delete(_),f.push(A))}if(u.changed){for(const _ of u.changed)if(_.id){const A=this._breakpoints.get(_.id);if(A){if(A instanceof I.FunctionBreakpoint&&_.type==="function"){const N=A;N.enabled=_.enabled,N.condition=_.condition,N.hitCondition=_.hitCondition,N.logMessage=_.logMessage,N.functionName=_.functionName}else if(A instanceof I.SourceBreakpoint&&_.type==="source"){const N=A;N.enabled=_.enabled,N.condition=_.condition,N.hitCondition=_.hitCondition,N.logMessage=_.logMessage,N.location=new I.Location(i.URI.revive(_.uri),new I.Position(_.line,_.character))}l.push(A)}}}this.fireBreakpointChanges(d,f,l)}$provideDebugConfigurations(u,d,f){return(0,C.asPromise)(async()=>{const l=this.getConfigProviderByHandle(u);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const _=await this.getFolder(d);return l.provideDebugConfigurations(_,f)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(u,d,f,l){return(0,C.asPromise)(async()=>{const _=this.getConfigProviderByHandle(u);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(d);return _.resolveDebugConfiguration(A,f,l)})}$resolveDebugConfigurationWithSubstitutedVariables(u,d,f,l){return(0,C.asPromise)(async()=>{const _=this.getConfigProviderByHandle(u);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(d);return _.resolveDebugConfigurationWithSubstitutedVariables(A,f,l)})}async $provideDebugAdapter(u,d){const f=this.getAdapterDescriptorFactoryByHandle(u);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.getSession(d);return this.getAdapterDescriptor(f,l).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.convertToDto(_)})}async $acceptDebugSessionStarted(u){const d=await this.getSession(u);this._onDidStartDebugSession.fire(d)}async $acceptDebugSessionTerminated(u){const d=await this.getSession(u);d&&(this._onDidTerminateDebugSession.fire(d),this._debugSessions.delete(d.id))}async $acceptDebugSessionActiveChanged(u){this._activeDebugSession=u?await this.getSession(u):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(u,d){const f=await this.getSession(u);f&&f._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(u,d){const l={session:await this.getSession(u),event:d.event,body:d.body};this._onDidReceiveDebugSessionCustomEvent.fire(l)}convertToDto(u){if(u instanceof I.DebugAdapterExecutable)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof I.DebugAdapterServer)return{type:"server",port:u.port,host:u.host};if(u instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:u.path};if(u instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(u){const d=this._adapterFactories.filter(f=>f.type===u);if(d.length>0)return d[0].factory}getAdapterDescriptorFactoryByHandle(u){const d=this._adapterFactories.filter(f=>f.handle===u);if(d.length>0)return d[0].factory}getConfigProviderByHandle(u){const d=this._configProviders.filter(f=>f.handle===u);if(d.length>0)return d[0].provider}definesDebugType(u,d){if(u.contributes){const f=u.contributes.debuggers;if(f&&f.length>0){for(const l of f)if(l.label&&l.type&&l.type===d)return!0}}return!1}getDebugAdapterTrackers(u){const f=u.configuration.type,l=this._trackerFactories.filter(_=>_.type===f||_.type==="*").map(_=>(0,C.asPromise)(()=>_.factory.createDebugAdapterTracker(u)).then(A=>A,A=>null));return Promise.race([Promise.all(l).then(_=>{const A=_.filter(N=>!!N);if(A.length>0)return new r(A)}),new Promise((_,A)=>{const N=setTimeout(()=>{clearTimeout(N),A(new Error("timeout"))},1e3)})]).catch(_=>{})}async getAdapterDescriptor(u,d){const f=d.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new I.DebugAdapterServer(f));if(u){const _=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>u.createDebugAdapterDescriptor(d,this.daExecutableFromPackage(d,_))).then(A=>{if(A)return A})}const l=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(d,l))}daExecutableFromPackage(u,d){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(u,d,f){(u.length>0||d.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:u,removed:d,changed:f}))}async getSession(u){if(u)if(typeof u=="string"){const d=this._debugSessions.get(u);if(d)return d}else{let d=this._debugSessions.get(u.id);if(!d){const f=await this.getFolder(u.folderUri),l=u.parent?this._debugSessions.get(u.parent):void 0;d=new g(this._debugServiceProxy,u.id,u.type,u.name,f,u.configuration,l),this._debugSessions.set(d.id,d),this._debugServiceProxy.$sessionCached(d.id)}return d}throw new Error("cannot find session")}getFolder(u){if(u){const d=i.URI.revive(u);return this._workspaceService.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};n=je([He(0,v.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,L.IExtHostExtensionService),He(3,D.IExtHostDocumentsAndEditors),He(4,b.IExtHostConfiguration),He(5,s.IExtHostEditorTabs)],n),e.ExtHostDebugServiceBase=n;class g{constructor(u,d,f,l,_,A,N){this._debugServiceProxy=u,this._id=d,this._type=f,this._name=l,this._workspaceFolder=_,this._configuration=A,this._parentSession=N}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(u){this._name=u,this._debugServiceProxy.$setDebugSessionName(this._id,u)}get parentSession(){return this._parentSession}_acceptNameChanged(u){this._name=u}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(u,d){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,u,d)}getDebugProtocolBreakpoint(u){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,u.id)}}e.ExtHostDebugSession=g;class a{constructor(u){this.value=Object.freeze({append(d){u.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=a;class E extends c.AbstractVariableResolverService{constructor(u,d,f,l,_){function A(){if(d){const N=d.activeEditor();if(N)return N.document.uri;const x=l.tabs.filter(F=>F.isActive);if(x.length>0){const F=x[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:x[0].resource}}}super({getFolderUri:N=>{const x=u.filter(F=>F.name===N);if(x&&x.length>0)return x[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(N,x)=>f.getConfiguration(void 0,N).get(x),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{const N=A();if(N)return m.normalize(N.fsPath)},getWorkspaceFolderPathForFile:()=>{if(_){const N=A();if(N){const x=_.getWorkspaceFolder(N);if(x)return m.normalize(x.uri.fsPath)}}},getSelectedText:()=>{if(d){const N=d.activeEditor();if(N&&!N.selection.isEmpty)return N.document.getText(N.selection)}},getLineNumber:()=>{if(d){const N=d.activeEditor();if(N)return String(N.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=E;class r{constructor(u){this.trackers=u}onWillStartSession(){this.trackers.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.trackers.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.trackers.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(u):void 0)}onWillStopSession(){this.trackers.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.trackers.forEach(d=>d.onError?d.onError(u):void 0)}onExit(u,d){this.trackers.forEach(f=>f.onExit?f.onExit(u,d):void 0)}}class t extends y.AbstractDebugAdapter{constructor(u){super();this.implementation=u,u.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.implementation.handleMessage(u)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends n{constructor(u,d,f,l,_,A){super(u,d,f,l,_,A)}createVariableResolver(u,d,f){return new E(u,d,f,this._editorTabs)}};o=je([He(0,v.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,L.IExtHostExtensionService),He(3,D.IExtHostDocumentsAndEditors),He(4,b.IExtHostConfiguration),He(5,s.IExtHostEditorTabs)],o),e.WorkerExtHostDebugService=o}),define(ve[268],we([0,1,72,2,5,36,30,27,14,26,4,39,40,11]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let p=class{constructor(s,n,g,a,E,r,t){this._apiFactory=s,this._extensionRegistry=n,this._instaService=g,this._extHostConfiguration=a,this._extHostExtensionService=E,this._initData=r,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const n=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,n,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(w,n)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(R,n,this._initData.environment.appUriScheme))}register(s){if(Array.isArray(s.nodeModuleName))for(let n of s.nodeModuleName)this._factories.set(n,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(n=>s.alternativeModuleName(n))}};p=je([He(2,L.IInstantiationService),He(3,C.IExtHostConfiguration),He(4,D.IExtHostExtensionService),He(5,P.IExtHostInitDataService),He(6,b.ILogService)],p),e.RequireInterceptor=p;class v{constructor(s,n,g,a,E){this._apiFactory=s,this._extensionPaths=n,this._extensionRegistry=g,this._configProvider=a,this._logService=E,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(s,n){const g=this._extensionPaths.findSubstr(n);if(g){let a=this._extApiImpl.get(I.ExtensionIdentifier.toKey(g.identifier));return a||(a=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(g.identifier),a)),a}if(!this._defaultApiImpl){let a="";this._extensionPaths.forEach((E,r)=>a+=`	${r} -> ${E.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${a}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(s,n,g){this._extensionPaths=s,this.nodeModuleName="keytar",this._mainThreadTelemetry=n.getProxy(k.MainContext.MainThreadTelemetry);const{environment:a}=g,E=n.getProxy(k.MainContext.MainThreadKeytar);if(a.appRoot){let r=a.appRoot.fsPath;c.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,t)=>E.$getPassword(r,t),setPassword:(r,t,o)=>E.$setPassword(r,t,o),deletePassword:(r,t)=>E.$deletePassword(r,t),findPassword:r=>E.$findPassword(r),findCredentials(r){return E.$findCredentials(r)}}}load(s,n){const g=this._extensionPaths.findSubstr(n);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:g?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(s){const n=s.length;if(n<=7||!this.alternativeNames)return;const g=n-7;if((s.charAt(g)==="/"||s.charAt(g)==="\\")&&s.endsWith("keytar")&&(s=s.replace(/\\/g,"/"),this.alternativeNames.has(s)))return"keytar"}};w=je([He(1,y.IExtHostRpcService),He(2,P.IExtHostInitDataService)],w);let R=class{constructor(s,n,g){this._extensionPaths=s,this._appUriScheme=n,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(k.MainContext.MainThreadTelemetry);const a=g.getProxy(k.MainContext.MainThreadWindow);this._impl=(E,r)=>{const t=i.URI.parse(E);return r?this.callOriginal(E,r):t.scheme==="http"||t.scheme==="https"?a.$openUri(t,E,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?a.$openUri(t,E,{}):this.callOriginal(E,r)}}load(s,n,g){const a=this._extensionPaths.findSubstr(n);return a&&(this._extensionId=a.identifier.value,this.sendShimmingTelemetry()),this._original=g(s),this._impl}callOriginal(s,n){return this.sendNoForwardTelemetry(),this._original(s,n)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};R=je([He(2,y.IExtHostRpcService)],R)}),define(ve[269],we([0,1,170,12,7,209,35,39,45,36,34,14,55,195,18,210,54]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let R=class extends c.ExtHostDebugServiceBase{constructor(n,g,a,E,r,t,o){super(n,g,a,E,r,o);this._terminalService=t,this._integratedTerminalInstances=new S}createDebugAdapter(n,g){switch(n.type){case"server":return new C.SocketDebugAdapter(n);case"pipeServer":return new C.NamedPipeDebugAdapter(n);case"executable":return new C.ExecutableDebugAdapter(n,g.type)}return super.createDebugAdapter(n,g)}daExecutableFromPackage(n,g){const a=C.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),n.type);if(a)return new k.DebugAdapterExecutable(a.command,a.args,a.options)}createSignService(){return new b.SignService}async $runInTerminal(n,g){if(n.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(A=>{this._integratedTerminalInstances.onTerminalClosed(A)}));const a=await this._configurationService.getConfigProvider(),E=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),t=n.title||m.localize(0,null),o=JSON.stringify({shell:E,shellArgs:r});let h=await this._integratedTerminalInstances.checkout(o,t),u,d=!1;if(h)u=n.cwd;else{const A={shellPath:E,shellArgs:r,cwd:n.cwd,name:t,iconPath:new k.ThemeIcon("debug")};d=!0,h=this._terminalService.createTerminalFromOptions(A,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(h,o)}h.show(!0);const f=await h.processId;d?await new Promise(A=>setTimeout(A,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0||E.indexOf("cmd.exe")>=0?h.sendText("cls"):E.indexOf("bash")>=0?h.sendText("clear"):i.isWindows?h.sendText("cls"):h.sendText("clear"));const l=(0,v.prepareCommand)(E,n.args,u,n.env);h.sendText(l);const _=this.onDidTerminateDebugSession(A=>{A.id===g&&(this._integratedTerminalInstances.free(h),_.dispose())});return f}else if(n.kind==="external")return(0,v.runInExternalTerminal)(n,await this._configurationService.getConfigProvider());return super.$runInTerminal(n,g)}createVariableResolver(n,g,a){return new c.ExtHostVariableResolverService(n,g,a,this._editorTabs,this._workspaceService)}};R=je([He(0,D.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,I.IExtHostExtensionService),He(3,y.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,L.IExtHostTerminalService),He(6,w.IExtHostEditorTabs)],R),e.ExtHostDebugService=R;class S{constructor(){this._terminalInstances=new Map}async checkout(n,g){const E=[...this._terminalInstances.entries()].map(([r,t])=>(0,p.createCancelablePromise)(async o=>{if(r.name!==g||t.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await r.processId))return null;const h=Date.now();return t.lastUsedAt+S.minUseDelay>h||o.isCancellationRequested||t.config!==n?null:(t.lastUsedAt=h,r)}));return await(0,p.firstParallel)(E,r=>!!r)}insert(n,g){this._terminalInstances.set(n,{lastUsedAt:Date.now(),config:g})}free(n){const g=this._terminalInstances.get(n);g&&(g.lastUsedAt=-1)}onTerminalClosed(n){this._terminalInstances.delete(n)}}S.minUseDelay=1e3}),define(ve[270],we([0,1,8,2,113,35,55,45,36,43,34,14,26,71,10,11,66,54,23,82]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let n=class extends b.ExtHostTaskBase{constructor(a,E,r,t,o,h,u,d,f){super(a,E,r,t,o,h,u,d);this.workspaceService=r,this.editorTabs=f,E.remote.isRemote&&E.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:E.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,E){const r=E;if(!E.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const t=b.TaskHandleDTO.from(r,this.workspaceService),o=await this._proxy.$getTaskExecution(t);if(o.task===void 0)throw new Error("Task from execution DTO is undefined");const h=await this.getTaskExecution(o,E);return this._proxy.$executeTask(t).catch(()=>{}),h}else{const t=b.TaskDTO.from(E,a);if(t===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,E,!1);const o=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),E);return this._proxy.$executeTask(t).catch(()=>{}),o}}provideTasksInternal(a,E,r,t){const o=[];if(t)for(let h of t){this.checkDeprecation(h,r),(!h.definition||!a[h.definition.type])&&this._logService.warn(`The task [${h.source}, ${h.name}] uses an undefined task type. The task will be ignored in the future.`);const u=b.TaskDTO.from(h,r.extension);u&&(o.push(u),b.CustomExecutionDTO.is(u.execution)&&E.push(this.addCustomExecution(u,h,!0)))}return{tasks:o,extension:r.extension}}async resolveTaskInternal(a){return a}async getVariableResolver(a){if(this._variableResolver===void 0){const E=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(a,this._editorService,E,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(a){let E=a&&a.length>0?a[0]:void 0;if(!E){const r=i.URI.file((0,s.homedir)());E=new P.WorkspaceFolder({uri:r,name:S.basename(r),index:0})}return{uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,E){const r=i.URI.revive(a),t={process:void 0,variables:Object.create(null)},o=await this._workspaceProvider.resolveWorkspaceFolder(r),h=await this._workspaceProvider.getWorkspaceFolders2()??[],u=await this.getVariableResolver(h),d=o?{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(h);for(let f of E.variables)t.variables[f]=await u.resolveAsync(d,f);if(E.process!==void 0){let f;if(E.process.path!==void 0){f=E.process.path.split(m.delimiter);for(let l=0;l<f.length;l++)f[l]=await u.resolveAsync(d,f[l])}t.process=await k.win32.findExecutable(await u.resolveAsync(d,E.process.name),E.process.cwd!==void 0?await u.resolveAsync(d,E.process.cwd):void 0,f)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(a,E,r){return k.win32.findExecutable(a,E,r)}};n=je([He(0,D.IExtHostRpcService),He(1,c.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,I.IExtHostDocumentsAndEditors),He(4,y.IExtHostConfiguration),He(5,L.IExtHostTerminalService),He(6,v.ILogService),He(7,w.IExtHostApiDeprecationService),He(8,R.IExtHostEditorTabs)],n),e.ExtHostTask=n}),define(ve[271],we([0,1,18,15,72,6,2,5,263,11,61,85,26,187,14,65,39,34]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(n,g,a,E,r){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new y.RPCProtocol(n,null,E),g=S._transform(g,this._rpcProtocol);const t=new D.ServiceCollection(...(0,L.getSingletonServiceDescriptors)());t.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...g,messagePorts:r}),t.set(p.IExtHostRpcService,new p.ExtHostRpcService(this._rpcProtocol)),t.set(v.IURITransformerService,new v.URITransformerService(E)),t.set(w.IHostUtils,a);const o=new b.InstantiationService(t,!0);this._disposables.add(o.invokeFunction(f=>f.get(R.IExtHostTerminalService))),this._disposables.add(o.invokeFunction(f=>f.get(w.IExtHostExtensionService))),this._logService=o.invokeFunction(f=>f.get(P.ILogService)),k.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=o.invokeFunction(f=>f.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(l,_)=>{let A="",N,x;for(const F of _)A+=`
	at ${F.toString()}`,x=F.getFileName(),!N&&x&&(N=f.findSubstr(T.URI.file(x)));return h.set(l,N),`${l.name||"Error"}: ${l.message||""}${A}`}});const u=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),d=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(f=>{const l=i.transformErrorForSerialization(f),_=h.get(f);_?u.$onExtensionRuntimeError(_.identifier,l):d.$onUnexpectedError(l)})}terminate(n){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${n}`),this._logService.flush(),this._disposables.dispose(),i.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();Promise.race([(0,m.timeout)(5e3),g]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(n,g){n.extensions.forEach(E=>E.extensionLocation=T.URI.revive(g.transformIncomingURIs(E.extensionLocation))),n.environment.appRoot=T.URI.revive(g.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(E=>T.URI.revive(g.transformIncomingURIs(E)))),n.environment.extensionTestsLocationURI=T.URI.revive(g.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=T.URI.revive(g.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=T.URI.revive(g.transformIncomingURIs(n.environment.workspaceStorageHome)),n.logsLocation=T.URI.revive(g.transformIncomingURIs(n.logsLocation)),n.logFile=T.URI.revive(g.transformIncomingURIs(n.logFile)),n.workspace=g.transformIncomingURIs(n.workspace),n}}e.ExtensionHostMain=S}),define(ve[272],we([0,1,8,21,50,32,23,46,31]),function(X,e,m,i,k,C,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(c,b,p){this.config=c,this.provider=b,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&C.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&C.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const b=this.config.folderQueries||[];return new Promise((p,v)=>{const w=R=>{this.resultCount++,c(R)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(R=>{const S=R.toString(),s=m.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,s)||this.matchFile(w,{base:R,basename:s})}),Promise.all(b.map(R=>this.searchInFolder(R,w))).then(R=>{p({limitHit:this.isLimitHit,stats:R[0]||void 0})},R=>{v(new Error((0,k.toErrorMessage)(R)))})})}async searchInFolder(c,b){const p=new i.CancellationTokenSource,v=this.getSearchOptionsForFolder(c),w=this.initDirectoryTree(),R=new y.QueryGlobTester(this.config,c),S=!R.hasSiblingExcludeClauses();let s;try{this.activeCancellationTokens.add(p),s=I.StopWatch.create();const n=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,p.token),g=s.elapsed(),a=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(n&&n.forEach(E=>{const r=m.posix.relative(c.folder.path,E.path);if(S){const t=m.basename(E.path);this.matchFile(b,{base:c.folder,relativePath:r,basename:t});return}this.addDirectoryEntries(w,c.folder,r,b)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,R,b),{providerTime:g,postProcessTime:a.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(c){const b=(0,y.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),p=(0,y.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:p,includes:b,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},b,p,v){if(p===this.filePattern){const R=m.basename(this.filePattern);this.matchFile(v,{base:b,relativePath:this.filePattern,basename:R})}function w(R){const S=m.basename(R),s=m.dirname(R);let n=c[s];n||(n=c[s]=[],w(s)),n.push({base:b,relativePath:R,basename:S})}w(p)}matchDirectoryTree({rootEntries:c,pathToEntries:b},p,v){const w=this,R=this.filePattern;function S(s){const n=C.hasSiblingFn(()=>s.map(g=>g.basename));for(let g=0,a=s.length;g<a;g++){const E=s[g],{relativePath:r,basename:t}=E;if(p.matchesExcludesSync(r,t,R!==t?n:void 0))continue;const o=b[r];if(o)S(o);else{if(r===R)continue;w.matchFile(v,E)}if(w.isLimitHit)break}}S(c)}matchFile(c,b){(!this.includePattern||b.relativePath&&this.includePattern(b.relativePath,b.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(b))}}class L{constructor(){this.sessions=new Map}fileSearch(c,b,p,v){const w=this.getSessionTokenSource(c.cacheKey),R=new P(c,b,w&&w.token);let S=0;const s=n=>{S+=n.length,p(n.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(R,L.BATCH_SIZE,s,v).then(n=>({limitHit:n.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:n.stats}}))}clearCache(c){const b=this.getSessionTokenSource(c);b&&b.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new i.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:T.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,b,p,v){v.onCancellationRequested(()=>{c.cancel()});const w=S=>{S&&(R.push(S),b>0&&R.length>=b&&(p(R),R=[]))};let R=[];return c.search(w).then(S=>(R.length&&p(R),S),S=>(R.length&&p(R),Promise.reject(S)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(ve[135],we([0,1,16,21,50,32,10,8,23,13,2,31]),function(X,e,m,i,k,C,T,I,y,P,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(s,n,g,a){this.query=s,this.provider=n,this.fileUtils=g,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,n){const g=this.query.folderQueries||[],a=new i.CancellationTokenSource;return n.onCancellationRequested(()=>a.cancel()),new Promise((E,r)=>{this.collector=new p(s);let t=!1;const o=(h,u)=>{if(!t&&!this.isLimitHit){const d=this.resultSize(h);w(h)&&typeof this.query.maxResults=="number"&&this.resultCount+d>this.query.maxResults&&(this.isLimitHit=!0,t=!0,a.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const f=this.resultSize(h);this.resultCount+=f,(f>0||!w(h))&&this.collector.add(h,u)}};Promise.all(g.map((h,u)=>this.searchInFolder(h,d=>o(d,u),a.token))).then(h=>{a.dispose(),this.collector.flush();const u=h.some(d=>!!d&&!!d.limitHit);E({limitHit:this.isLimitHit||u,messages:(0,m.flatten)(h.map(d=>d?.message?(0,P.isArray)(d.message)?d.message:[d.message]:[])),stats:{type:this.processType}})},h=>{a.dispose();const u=(0,k.toErrorMessage)(h);r(new Error(u))})})}resultSize(s){return w(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,n){const g=Array.isArray(s.ranges)?s.ranges:[s.ranges],a=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:g.slice(0,n),preview:{matches:a.slice(0,n),text:s.preview.text},uri:s.uri}}async searchInFolder(s,n,g){const a=new D.QueryGlobTester(this.query,s),E=[],r={report:h=>{if(!this.validateProviderResult(h))return;const u=s.folder.scheme===T.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(h.uri))):void 0,d=y.relativePath(s.folder,h.uri);if(d){const f=a.includedInQuery(d,I.basename(d),u);(0,P.isPromise)(f)?E.push(f.then(l=>{l&&n(h)})):f&&n(h)}}},t=this.getSearchOptionsForFolder(s),o=await this.provider.provideTextSearchResults(b(this.query.contentPattern),t,r,g);return E.length&&await Promise.all(E),o}validateProviderResult(s){if(w(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const n=(0,D.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),g=(0,D.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),a={folder:L.URI.from(s.folder),excludes:g,includes:n,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!s.disregardParentIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=c;function b(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class p{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new R(512,n=>this.sendItems(n))}add(s,n){this._currentFileMatch&&(this._currentFolderIdx!==n||!y.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=n,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(v(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=p;function v(S){return w(S)?{preview:{matches:(0,m.mapArrayOrNot)(S.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:S.preview.text},ranges:(0,m.mapArrayOrNot)(S.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function w(S){return!!S.preview}e.extensionResultIsMatch=w;class R{constructor(s,n){this.maxBatchSize=s,this.cb=n,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,n){!s||this.addItemToBatch(s,n)}addItems(s,n){!s||this.addItemsToBatch(s,n)}addItemToBatch(s,n){this.batch.push(s),this.batchSize+=n,this.onUpdate()}addItemsToBatch(s,n){this.batch=this.batch.concat(s),this.batchSize+=n,this.onUpdate()}onUpdate(){this.totalNumberCompleted<R.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},R.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=R,R.TIMEOUT=4e3,R.START_BATCH_AFTER_COUNT=50}),define(ve[73],we([0,1,6,5,4,272,14,65,11,2,135]),function(X,e,m,i,k,C,T,I,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let D=class{constructor(v,w,R){this.extHostRpc=v,this._uriTransformer=w,this._logService=R,this._proxy=this.extHostRpc.getProxy(i.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,w){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const R=this._handlePool++;return this._textSearchProvider.set(R,w),this._proxy.$registerTextSearchProvider(R,this._transformScheme(v)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(R),this._proxy.$unregisterProvider(R)})}registerFileSearchProvider(v,w){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const R=this._handlePool++;return this._fileSearchProvider.set(R,w),this._proxy.$registerFileSearchProvider(R,this._transformScheme(v)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(R),this._proxy.$unregisterProvider(R)})}$provideFileSearchResults(v,w,R,S){const s=c(R),n=this._fileSearchProvider.get(v);if(n)return this._fileSearchManager.fileSearch(s,n,g=>{this._proxy.$handleFileMatch(v,w,g.map(a=>a.resource))},S);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,w,R,S){const s=this._textSearchProvider.get(v);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const n=c(R);return this.createTextSearchManager(n,s).search(a=>this._proxy.$handleTextMatch(v,w,a),S)}$enableExtensionHostSearch(){}createTextSearchManager(v,w){return new L.TextSearchManager(v,w,{readdir:R=>Promise.resolve([]),toCanonicalName:R=>R},"textSearchProvider")}};D=je([He(0,T.IExtHostRpcService),He(1,I.IURITransformerService),He(2,y.ILogService)],D),e.ExtHostSearch=D;function c(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(b),extraFileResources:p.extraFileResources&&p.extraFileResources.map(v=>P.URI.revive(v))}}e.reviveQuery=c;function b(p){return{...p,folder:P.URI.revive(p.folder)}}}),define(ve[273],we([0,1,61,133,35,131,36,38,45,34,71,55,73,91,52,66,134,67,44,90,122,54,132,11,226]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S,s,n,g,a,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(E.ILoggerService,a.ExtHostLoggerService),(0,m.registerSingleton)(E.ILogService,r.ExtHostLogService),(0,m.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,m.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,m.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,m.registerSingleton)(R.IExtHostConsumerFileSystem,R.ExtHostConsumerFileSystem),(0,m.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService),(0,m.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,m.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(S.IExtHostFileSystemInfo,S.ExtHostFileSystemInfo),(0,m.registerSingleton)(i.IExtHostOutputService,i.ExtHostOutputService),(0,m.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,m.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage),(0,m.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask),(0,m.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,m.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService),(0,m.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,m.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,m.registerSingleton)(s.IExtHostSecretState,s.ExtHostSecretState),(0,m.registerSingleton)(n.IExtHostTelemetry,n.ExtHostTelemetry),(0,m.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs)}),define(ve[92],we([0,1,16,11,31,70]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(D){return D.startsWith("**")||D.startsWith("/")?D:`/${D}`}e.anchorGlob=T;function I(D,c,b,p){const v=(0,m.mapArrayOrNot)(b,y),w=new k.TextSearchMatch(c,v,p),R=w.preview.matches;return{ranges:(0,m.mapArrayOrNot)(v,P),uri:D,preview:{text:w.preview.text,matches:(0,m.mapArrayOrNot)(R,P)}}}e.createTextSearchResult=I;function y(D){return new k.SearchRange(D.start.line,D.start.character,D.end.line,D.end.character)}function P(D){return new C.Range(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn)}let L=class{constructor(c,b){this.prefix=c,this.logService=b}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};L=je([He(1,i.ILogService)],L),e.OutputChannel=L}),define(ve[274],we([0,1,97,22]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(t=>t===r)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,T=512,I=512*8,y=512*128;var P;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(t,o){super(t);this.decodeStreamErrorKind=o}}e.DecodeStreamError=L;class D{constructor(t){this.iconvLiteDecoder=t}static async create(t){let o;if(t!==e.UTF8)o=(await new Promise((u,d)=>{X(["iconv-lite-umd"],u,d)})).getDecoder(v(t));else{const h=new TextDecoder;o={write(u){return h.decode(u,{stream:!0})},end(){return h.decode()}}}return new D(o)}write(t){return this.iconvLiteDecoder.write(t)}end(){return this.iconvLiteDecoder.end()}}function c(r,t){const o=t.minBytesRequiredForDetection??t.guessEncoding?I:T;return new Promise((h,u)=>{const d=(0,m.newWriteableStream)(x=>x.join("")),f=[];let l=0,_,A;const N=async()=>{try{const x=await E({buffer:i.VSBuffer.concat(f),bytesRead:l},t.guessEncoding);if(x.seemsBinary&&t.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);x.encoding=await t.overwriteEncoding(x.encoding),_=await D.create(x.encoding);const F=_.write(i.VSBuffer.concat(f).buffer);d.write(F),f.length=0,l=0,h({stream:d,detected:x})}catch(x){A?.dispose(),d.destroy(),u(x)}};A=(0,m.listenStream)(r,{onData:async x=>{_?d.write(_.write(x.buffer)):(f.push(x),l+=x.byteLength,l>=o&&(r.pause(),await N(),setTimeout(()=>r.resume())))},onError:x=>d.error(x),onEnd:async()=>{_||await N(),d.end(_?.end())}})})}e.toDecodeStream=c;async function b(r,t,o){const u=(await new Promise((l,_)=>{X(["iconv-lite-umd"],l,_)})).getEncoder(v(t),o);let d=!1,f=!1;return{read(){if(f)return null;const l=r.read();if(typeof l!="string"){if(f=!0,!d&&o?.addBOM)switch(t){case e.UTF8:case e.UTF8_with_bom:return i.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const _=u.end();return _&&_.length>0?(d=!0,i.VSBuffer.wrap(_)):null}return d=!0,i.VSBuffer.wrap(u.write(l))}}}e.toEncodeReadable=b;async function p(r){return(await new Promise((o,h)=>{X(["iconv-lite-umd"],o,h)})).encodingExists(v(r))}e.encodingExists=p;function v(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=v;function w(r,t){if(!r||t<e.UTF16be_BOM.length)return null;const o=r.readUInt8(0),h=r.readUInt8(1);if(o===e.UTF16be_BOM[0]&&h===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&h===e.UTF16le_BOM[1])return e.UTF16le;if(t<e.UTF8_BOM.length)return null;const u=r.readUInt8(2);return o===e.UTF8_BOM[0]&&h===e.UTF8_BOM[1]&&u===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=w;const R=["ascii","utf-16","utf-32"];async function S(r){const t=await new Promise((f,l)=>{X(["jschardet"],f,l)}),o=r.slice(0,y),h=g(o.buffer),u=t.detect(h);if(!u||!u.encoding)return null;const d=u.encoding.toLowerCase();return 0<=R.indexOf(d)?null:n(u.encoding)}const s={ibm866:"cp866",big5:"cp950"};function n(r){const t=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[t]||t}function g(r){let t="";for(let o=0;o<r.length;o++)t+=String.fromCharCode(r[o]);return t}function a(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const t=r.match(/windows(\d+)/);return t?"windows-"+t[1]:r}}}e.toCanonicalName=a;function E({buffer:r,bytesRead:t},o){let h=w(r,t),u=!1;if(h!==e.UTF16be&&h!==e.UTF16le&&r){let d=!0,f=!0,l=!1;for(let _=0;_<t&&_<C;_++){const A=_%2==1,N=r.readUInt8(_)===0;if(N&&(l=!0),d&&(A&&!N||!A&&N)&&(d=!1),f&&(A&&N||!A&&!N)&&(f=!1),N&&!d&&!f)break}l&&(d?h=e.UTF16le:f?h=e.UTF16be:u=!0)}return o&&!u&&!h&&r?S(r.slice(0,t)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:u,encoding:h}}e.detectEncodingFromBuffer=E,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ve[136],we([0,1,274,29,135]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends k.TextSearchManager{constructor(I,y,P=i,L="searchProcess"){super(I,y,{readdir:D=>P.Promises.readdir(D.fsPath),toCanonicalName:D=>(0,m.toCanonicalName)(D)},L)}}e.NativeTextSearchManager=C}),define(ve[275],we([0,1,61,4]),function(X,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,i.createDecorator)("treeViewsDragAndDropService");class k{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(T){if(T&&this._dragOperations.has(T)){const I=this._dragOperations.get(T);return this._dragOperations.delete(T),I}}addDragOperationTransfer(T,I){this._dragOperations.set(T,I)}}e.TreeViewsDragAndDropService=k,(0,m.registerSingleton)(e.ITreeViewsDragAndDropService,k)}),define(ve[276],we([0,1,168,23,2,3,6,18,7,13,16,17,21,205,275]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(S,s){if((0,P.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let n;return Array.isArray(S.highlights)&&(n=S.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),n=n.length?n:void 0),{label:S.label,highlights:n}}}class w{constructor(s,n,g){this._proxy=s,this.commands=n,this.logService=g,this.treeViews=new Map,this.treeDragAndDropService=new p.TreeViewsDragAndDropService;function a(E){return E&&E.$treeViewId&&E.$treeItemHandle}n.registerArgumentProcessor({processArgument:E=>a(E)?this.convertArgument(E):Array.isArray(E)&&E.length>0?E.map(r=>a(r)?this.convertArgument(r):r):E})}registerTreeDataProvider(s,n,g){const a=this.createTreeView(s,{treeDataProvider:n},g);return{dispose:()=>a.dispose()}}createTreeView(s,n,g){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=n.dragAndDropController?.supportedMimeTypes,E=!!n.dragAndDropController?.onWillDrop,r=this._proxy.$registerTreeViewDataProvider(s,{showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dragAndDropMimeTypes:a,hasWillDrop:E}),t=this.createExtHostTreeView(s,n,g);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(o){t.message=o},get title(){return t.title},set title(o){t.title=o},get description(){return t.description},set description(o){t.description=o},reveal:(o,h)=>t.reveal(o,h),dispose:async()=>{await r,this.treeViews.delete(s),t.dispose()}}}$getChildren(s,n){const g=this.treeViews.get(s);return g?g.getChildren(n):Promise.reject(new Error((0,m.localize)(0,null,s)))}async $onDrop(s,n,g,a,E,r){const t=this.treeViews.get(s);if(!t)return Promise.reject(new Error((0,m.localize)(1,null,s)));const o=b.TreeDataTransferConverter.toITreeDataTransfer(n);return E===s&&r&&await this.addAdditionalTransferItems(o,t,r,a),t.onDrop(o,g)}async addAdditionalTransferItems(s,n,g,a){const E=this.treeDragAndDropService.removeDragOperationTransfer(a);let r;if(E)r=await E;else if(a&&n.onWillDrop){const t=n.onWillDrop(g);this.treeDragAndDropService.addDragOperationTransfer(a,t),r=await t}return r&&r.forEach((t,o)=>{t&&s.set(o,t)}),s}async $onWillDrop(s,n,g){const a=this.treeViews.get(s);if(!a)return Promise.reject(new Error((0,m.localize)(2,null,s)));const E=await this.addAdditionalTransferItems(new Map,a,n,g);if(!!E)return b.TreeDataTransferConverter.toTreeDataTransferDTO(E)}async $hasResolve(s){const n=this.treeViews.get(s);if(!n)throw new Error((0,m.localize)(3,null,s));return n.hasResolve}$resolve(s,n,g){const a=this.treeViews.get(s);if(!a)throw new Error((0,m.localize)(4,null,s));return a.resolveTreeItem(n,g)}$setExpanded(s,n,g){const a=this.treeViews.get(s);if(!a)throw new Error((0,m.localize)(5,null,s));a.setExpanded(n,g)}$setSelection(s,n){const g=this.treeViews.get(s);if(!g)throw new Error((0,m.localize)(6,null,s));g.setSelection(n)}$setVisible(s,n){const g=this.treeViews.get(s);if(!g)throw new Error((0,m.localize)(7,null,s));g.setVisible(n)}createExtHostTreeView(s,n,g){const a=new R(s,n,this._proxy,this.commands.converter,this.logService,g);return this.treeViews.set(s,a),a}convertArgument(s){const n=this.treeViews.get(s.$treeViewId);return n?n.getExtensionElement(s.$treeItemHandle):null}}e.ExtHostTreeViews=w;class R extends T.Disposable{constructor(s,n,g,a,E,r){super();if(this.viewId=s,this.proxy=g,this.commands=a,this.logService=E,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,r.contributes&&r.contributes.views)for(const h in r.contributes.views)for(const u of r.contributes.views[h])u.id===s&&(this._title=u.name);this.dataProvider=n.treeDataProvider,this.dndController=n.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(h=>this._onDidChangeData.fire({message:!1,element:h}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let t,o;this._register(C.Event.debounce(this._onDidChangeData.event,(h,u)=>(h||(h={message:!1,elements:[]}),u.element!==!1&&(t||(t=new Promise(d=>o=d),this.refreshPromise=this.refreshPromise.then(()=>t)),Array.isArray(u.element)?h.elements.push(...u.element):h.elements.push(u.element)),u.message&&(h.message=!0),h),200,!0)(({message:h,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const d=o;return t=null,this.refresh(u).then(()=>d())})),h&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(s=>this.getExtensionElement(s)).filter(s=>!(0,P.isUndefinedOrNull)(s))}async getChildren(s){const n=s?this.getExtensionElement(s):void 0;if(s&&!n)return this.logService.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let g=this.getChildrenNodes(s);return g||(g=await this.fetchChildrenNodes(n)),g?g.map(a=>a.item):void 0}getExtensionElement(s){return this.elements.get(s)}reveal(s,n){n=n||{select:!0,focus:!1};const g=(0,P.isUndefinedOrNull)(n.select)?!0:n.select,a=(0,P.isUndefinedOrNull)(n.focus)?!1:n.focus,E=(0,P.isUndefinedOrNull)(n.expand)?!1:n.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.refreshPromise.then(()=>this.resolveUnknownParentChain(s)).then(r=>this.resolveTreeNode(s,r[r.length-1]).then(t=>this.proxy.$reveal(this.viewId,{item:t.item,parentChain:r.map(o=>o.item)},{select:g,focus:a,expand:E})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:g,focus:a,expand:E})}get message(){return this._message}set message(s){this._message=s,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(s){this._title=s,this.proxy.$setTitle(this.viewId,s,this._description)}get description(){return this._description}set description(s){this._description=s,this.proxy.$setTitle(this.viewId,this._title,s)}setExpanded(s,n){const g=this.getExtensionElement(s);g&&(n?this._onDidExpandElement.fire(Object.freeze({element:g})):this._onDidCollapseElement.fire(Object.freeze({element:g})))}setSelection(s){(0,L.equals)(this._selectedHandles,s)||(this._selectedHandles=s,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(s){s!==this._visible&&(this._visible=s,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(s){const n=[];for(const g of s){const a=this.getExtensionElement(g);a&&n.push(a)}if(!(!this.dndController?.onWillDrop||n.length===0))return this.dndController.onWillDrop(n)}get hasOnWillDrop(){return!!this.dndController?.onWillDrop}async onDrop(s,n){const g=this.getExtensionElement(n);if(!!g)return(0,I.asPromise)(()=>this.dndController?.onDrop(s,g))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(s,n){if(!this.dataProvider.resolveTreeItem)return;const g=this.elements.get(s);if(g){const a=this.nodes.get(g);if(a){const E=await this.dataProvider.resolveTreeItem(a.extensionItem,g,n)??a.extensionItem;return a.item.tooltip=this.getTooltip(E.tooltip),a.item.command=this.getCommand(a.disposableStore,E.command),a.item}}}resolveUnknownParentChain(s){return this.resolveParent(s).then(n=>n?this.resolveUnknownParentChain(n).then(g=>this.resolveTreeNode(n,g[g.length-1]).then(a=>(g.push(a),g))):Promise.resolve([]))}resolveParent(s){const n=this.nodes.get(s);return n?Promise.resolve(n.parent?this.elements.get(n.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(s))}resolveTreeNode(s,n){const g=this.nodes.get(s);return g?Promise.resolve(g):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(a=>this.createHandle(s,a,n,!0)).then(a=>this.getChildren(n?n.item.handle:void 0).then(()=>{const E=this.getExtensionElement(a);if(E){const r=this.nodes.get(E);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(s){if(s){let n;if(typeof s=="string"){const g=this.getExtensionElement(s);n=g?this.nodes.get(g):void 0}else n=s;return n&&n.children||void 0}return this.roots}async fetchChildrenNodes(s){this.clearChildren(s);const n=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const g=s?this.nodes.get(s):void 0,a=await this.dataProvider.getChildren(s);if(n.token.isCancellationRequested)return;const E=await Promise.all((0,L.coalesce)(a||[]).map(async r=>{const t=await this.dataProvider.getTreeItem(r);return t&&!n.token.isCancellationRequested?this.createAndRegisterTreeNode(r,t,g):null}));return n.token.isCancellationRequested?void 0:(0,L.coalesce)(E)}finally{n.dispose()}}refresh(s){if(s.some(g=>!g))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const g=this.getHandlesToRefresh(s);if(g.length)return this.refreshHandles(g)}return Promise.resolve(void 0)}getHandlesToRefresh(s){const n=new Set,g=s.map(E=>this.nodes.get(E));for(const E of g)if(E&&!n.has(E.item.handle)){let r=E;for(;r&&r.parent&&g.findIndex(t=>r&&r.parent&&t&&t.item.handle===r.parent.item.handle)===-1;){const t=this.elements.get(r.parent.item.handle);r=t?this.nodes.get(t):void 0}r&&!r.parent&&n.add(E.item.handle)}const a=[];return n.forEach(E=>{const r=this.elements.get(E);if(r){const t=this.nodes.get(r);t&&(!t.parent||!n.has(t.parent.item.handle))&&a.push(E)}}),a}refreshHandles(s){const n={};return Promise.all(s.map(g=>this.refreshNode(g).then(a=>{a&&(n[g]=a.item)}))).then(()=>Object.keys(n).length?this.proxy.$refresh(this.viewId,n):void 0)}refreshNode(s){const n=this.getExtensionElement(s);if(n){const g=this.nodes.get(n);if(g)return this.clearChildren(n),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(n)).then(a=>{if(a){const E=this.createTreeNode(n,a,g.parent);return this.updateNodeCache(n,E,g,g.parent),g.dispose(),E}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(s,n,g){const a=this.createTreeNode(s,n,g);if(n.id&&this.elements.has(a.item.handle))throw new Error((0,m.localize)(8,null,n.id));return this.addNodeToCache(s,a),this.addNodeToParentCache(a,g),a}getTooltip(s){return y.MarkdownString.isMarkdownString(s)?D.MarkdownString.from(s):s}getCommand(s,n){return n?this.commands.toInternal(n,s):void 0}createTreeNode(s,n,g){const a=new T.DisposableStore,E=this.createHandle(s,n,g),r=this.getLightIconPath(n);return{item:{handle:E,parentHandle:g?g.item.handle:void 0,label:v(n.label,this.extension),description:n.description,resourceUri:n.resourceUri,tooltip:this.getTooltip(n.tooltip),command:this.getCommand(a,n.command),contextValue:n.contextValue,icon:r,iconDark:this.getDarkIconPath(n)||r,themeIcon:this.getThemeIcon(n),collapsibleState:(0,P.isUndefinedOrNull)(n.collapsibleState)?y.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation},extensionItem:n,parent:g,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(s){return s.iconPath instanceof y.ThemeIcon?s.iconPath:void 0}createHandle(s,{id:n,label:g,resourceUri:a},E,r){if(n)return`${R.ID_HANDLE_PREFIX}/${n}`;const t=v(g,this.extension),o=E?E.item.handle:R.LABEL_HANDLE_PREFIX;let h=t?t.label:a?(0,i.basename)(a):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const u=this.nodes.has(s)?this.nodes.get(s).item.handle:void 0,d=this.getChildrenNodes(E)||[];let f,l=0;do{if(f=`${o}/${l}:${h}`,r||!this.elements.has(f)||u===f)break;l++}while(l<=d.length);return f}getLightIconPath(s){if(s.iconPath&&!(s.iconPath instanceof y.ThemeIcon))return typeof s.iconPath=="string"||k.URI.isUri(s.iconPath)?this.getIconPath(s.iconPath):this.getIconPath(s.iconPath.light)}getDarkIconPath(s){if(s.iconPath&&!(s.iconPath instanceof y.ThemeIcon)&&s.iconPath.dark)return this.getIconPath(s.iconPath.dark)}getIconPath(s){return k.URI.isUri(s)?s:k.URI.file(s)}addNodeToCache(s,n){this.elements.set(n.item.handle,s),this.nodes.set(s,n)}updateNodeCache(s,n,g,a){this.elements.delete(n.item.handle),this.nodes.delete(s),n.item.handle!==g.item.handle&&this.elements.delete(g.item.handle),this.addNodeToCache(s,n);const E=this.getChildrenNodes(a)||[],r=E.filter(t=>t.item.handle===g.item.handle)[0];r&&E.splice(E.indexOf(r),1,n)}addNodeToParentCache(s,n){n?(n.children||(n.children=[]),n.children.push(s)):(this.roots||(this.roots=[]),this.roots.push(s))}clearChildren(s){if(s){const n=this.nodes.get(s);if(n){if(n.children)for(const g of n.children){const a=this.elements.get(g.item.handle);a&&this.clear(a)}n.children=void 0}}else this.clearAll()}clear(s){const n=this.nodes.get(s);if(n){if(n.children)for(const g of n.children){const a=this.elements.get(g.item.handle);a&&this.clear(a)}this.nodes.delete(s),this.elements.delete(n.item.handle),n.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(s=>s.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}R.LABEL_HANDLE_PREFIX="0",R.ID_HANDLE_PREFIX="1"}),define(ve[277],we([0,1,21,15,3,48,2,114,109,146,83,42,5,231,230,38,232,36,233,234,235,217,236,45,39,237,218,240,241,242,133,220,247,248,249,91,34,251,276,17,7,254,69,134,35,75,206,239,63,131,71,55,73,11,65,14,26,243,203,52,66,228,252,202,68,67,257,255,256,229,44,250,253,90,54,122,245,70,246,10,190,244,200,238,6,30]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S,s,n,g,a,E,r,t,o,h,u,d,f,l,_,A,N,x,F,O,z,$,M,B,W,U,j,Z,ce,Q,V,te,me,ge,ke,Be,xe,q,Y,re,ue,J,ae,Ee,Oe,Ve,Ke,Je,it,at,et,nt,ct,vt,We,At,ee,ie,Se,ne,Ce,Fe,Ge,ze,ut,Re,Te,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function se(fe){const be=fe.get(Y.IExtHostInitDataService),_e=fe.get(ct.IExtHostFileSystemInfo),Ne=fe.get(Je.IExtHostConsumerFileSystem),Qe=fe.get(r.IExtHostExtensionService),$e=fe.get(j.IExtHostWorkspace),Xe=fe.get(ie.IExtHostTelemetry),st=fe.get(R.IExtHostConfiguration),ot=fe.get(xe.IURITransformerService),he=fe.get(q.IExtHostRpcService),ye=fe.get(x.IExtHostStorage),de=fe.get(Ke.IExtensionStoragePaths),K=fe.get(Be.ILoggerService),Ie=fe.get(Be.ILogService),Me=fe.get(J.IExtHostTunnelService),Ze=fe.get(ae.IExtHostApiDeprecationService),qe=fe.get(U.IExtHostWindow),ht=fe.get(At.IExtHostSecretState),Et=fe.get(ee.IExtHostEditorTabs);he.set(c.ExtHostContext.ExtHostFileSystemInfo,_e),he.set(c.ExtHostContext.ExtHostLogLevelServiceShape,K),he.set(c.ExtHostContext.ExtHostWorkspace,$e),he.set(c.ExtHostContext.ExtHostConfiguration,st),he.set(c.ExtHostContext.ExtHostExtensionService,Qe),he.set(c.ExtHostContext.ExtHostStorage,ye),he.set(c.ExtHostContext.ExtHostTunnelService,Me),he.set(c.ExtHostContext.ExtHostWindow,qe),he.set(c.ExtHostContext.ExtHostSecretState,ht),he.set(c.ExtHostContext.ExtHostTelemetry,Xe),he.set(c.ExtHostContext.ExtHostEditorTabs,Et);const Dt=he.set(c.ExtHostContext.ExtHostDecorations,fe.get(te.IExtHostDecorations)),bt=he.set(c.ExtHostContext.ExtHostDocumentsAndEditors,fe.get(E.IExtHostDocumentsAndEditors)),mt=he.set(c.ExtHostContext.ExtHostCommands,fe.get(v.IExtHostCommands)),wt=he.set(c.ExtHostContext.ExtHostTerminalService,fe.get(F.IExtHostTerminalService)),_t=he.set(c.ExtHostContext.ExtHostDebugService,fe.get(ge.IExtHostDebugService)),Mt=he.set(c.ExtHostContext.ExtHostSearch,fe.get(ke.IExtHostSearch)),It=he.set(c.ExtHostContext.ExtHostTask,fe.get(me.IExtHostTask)),Pt=he.set(c.ExtHostContext.ExtHostOutputService,fe.get(f.IExtHostOutputService)),Rt=he.set(c.ExtHostContext.ExtHostUrls,new B.ExtHostUrls(he)),yt=he.set(c.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(he,bt)),Ht=he.set(c.ExtHostContext.ExtHostDocumentContentProviders,new n.ExtHostDocumentContentProvider(he,bt,Ie)),Ot=he.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(Ie,yt,he.getProxy(c.MainContext.MainThreadBulkEdits))),St=he.set(c.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(he,mt,bt,yt,de)),Qt=he.set(c.ExtHostContext.ExtHostNotebookDocuments,new ut.ExtHostNotebookDocuments(Ie,St)),Vt=he.set(c.ExtHostContext.ExtHostNotebookEditors,new ze.ExtHostNotebookEditors(Ie,he,St)),Xt=he.set(c.ExtHostContext.ExtHostNotebookKernels,new Se.ExtHostNotebookKernels(he,be,St,mt,Ie)),oi=he.set(c.ExtHostContext.ExtHostNotebookRenderers,new Ce.ExtHostNotebookRenderers(he,St)),Lt=he.set(c.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(he,bt)),Yt=he.set(c.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(he.getProxy(c.MainContext.MainThreadTreeViews),mt,Ie)),ai=he.set(c.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(he.getProxy(c.MainContext.MainThreadEditorInsets),Lt,be)),Jt=he.set(c.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(he,Ie,_e)),zt=he.set(c.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(he,yt,mt.converter,ot)),pt=he.set(c.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(he,ot,yt,mt,Jt,Ie,Ze)),ci=he.set(c.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(he,pt)),Nt=he.set(c.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(he,Ie,bt)),jt=he.set(c.ExtHostContext.ExtHostQuickOpen,(0,_.createExtHostQuickOpen)(he,$e,mt)),Zt=he.set(c.ExtHostContext.ExtHostSCM,new A.ExtHostSCM(he,mt,Ie)),li=he.set(c.ExtHostContext.ExtHostComments,(0,w.createExtHostComments)(he,mt,yt)),fi=he.set(c.ExtHostContext.ExtHostProgress,new l.ExtHostProgress(he.getProxy(c.MainContext.MainThreadProgress))),Ei=he.set(c.ExtHostContext.ExtHosLabelService,new Q.ExtHostLabelService(he)),mi=he.set(c.ExtHostContext.ExtHostTheming,new ue.ExtHostTheming(he)),ei=he.set(c.ExtHostContext.ExtHostAuthentication,new Ee.ExtHostAuthentication(he)),Si=he.set(c.ExtHostContext.ExtHostTimeline,new Oe.ExtHostTimeline(he,mt)),qt=he.set(c.ExtHostContext.ExtHostWebviews,new W.ExtHostWebviews(he,{remote:be.remote},$e,Ie,Ze)),Gt=he.set(c.ExtHostContext.ExtHostWebviewPanels,new et.ExtHostWebviewPanels(he,qt,$e)),_i=he.set(c.ExtHostContext.ExtHostCustomEditors,new at.ExtHostCustomEditors(he,yt,de,qt,Gt)),Ci=he.set(c.ExtHostContext.ExtHostWebviewViews,new it.ExtHostWebviewViews(he,qt)),Kt=he.set(c.ExtHostContext.ExtHostTesting,new vt.ExtHostTesting(he,mt)),yi=he.set(c.ExtHostContext.ExtHostUriOpeners,new We.ExtHostUriOpeners(he));he.set(c.ExtHostContext.ExtHostInteractive,new Re.ExtHostInteractive(he,St,bt,mt));const ti=(0,Z.values)(c.ExtHostContext);he.assertRegistered(ti);const Di=new nt.ExtHostBulkEdits(he,bt),ki=new p.ExtHostClipboard(he),ui=new d.ExtHostMessageService(he,Ie),ii=new s.ExtHostDialogs(he),gi=new N.ExtHostStatusBar(he,mt.converter);return b.ExtHostApiCommands.register(mt),function(Ue,Ut,pi){const gt=function(){let oe=!Ue.isUnderDevelopment;function pe(){oe||(Ie.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),oe=!0)}return function Ae(dt){if(Array.isArray(dt))dt.forEach(Ae);else if(typeof dt=="string")pe();else{const Ct=dt;typeof Ct.scheme=="undefined"&&pe(),typeof Ct.exclusive=="boolean"&&(0,De.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return dt}}(),ni={getSession(oe,pe,Ae){return ei.getSession(Ue,oe,pe,Ae)},async hasSession(oe,pe){return(0,De.checkProposedApiEnabled)(Ue,"authSession"),!!await ei.getSession(Ue,oe,pe,{silent:!0})},get onDidChangeSessions(){return ei.onDidChangeSessions},registerAuthenticationProvider(oe,pe,Ae,dt){return ei.registerAuthenticationProvider(oe,pe,Ae,dt)}},Ii={registerCommand(oe,pe,Ae){return mt.registerCommand(!0,oe,pe,Ae,void 0,Ue)},registerTextEditorCommand(oe,pe,Ae){return mt.registerCommand(!0,oe,(...dt)=>{const Ct=Lt.getActiveTextEditor();if(!Ct){Ie.warn("Cannot execute "+oe+" because there is no active text editor.");return}return Ct.edit(kt=>{pe.apply(Ae,[Ct,kt,...dt])}).then(kt=>{kt||Ie.warn("Edits from command "+oe+" were not applied.")},kt=>{Ie.warn("An error occurred while running command "+oe,kt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(oe,pe,Ae)=>((0,De.checkProposedApiEnabled)(Ue,"diffCommand"),mt.registerCommand(!0,oe,async(...dt)=>{const Ct=bt.activeEditor(!0);if(!Ct){Ie.warn("Cannot execute "+oe+" because there is no active text editor.");return}const kt=await Lt.getDiffInformation(Ct.id);pe.apply(Ae,[kt,...dt])},void 0,void 0,Ue)),executeCommand(oe,...pe){return mt.executeCommand(oe,...pe)},getCommands(oe=!1){return mt.getCommands(oe)}},vi={get machineId(){return be.telemetryInfo.machineId},get sessionId(){return be.telemetryInfo.sessionId},get language(){return be.environment.appLanguage},get appName(){return be.environment.appName},get appRoot(){return be.environment.appRoot?.fsPath??""},get appHost(){return be.environment.appHost},get uriScheme(){return be.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return wt.getDefaultShell(!1)},get isTelemetryEnabled(){return Xe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Xe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const oe=Date.now()-new Date(be.telemetryInfo.firstSessionDate).getTime();return isNaN(oe)?!1:oe<1e3*60*60*24},openExternal(oe,pe){return qe.openUri(oe,{allowTunneling:!!be.remote.authority,allowContributedOpeners:pe?.allowContributedOpeners})},async asExternalUri(oe){if(oe.scheme===be.environment.appUriScheme)return Rt.createAppUri(oe);try{return await qe.asExternalUri(oe,{allowTunneling:!!be.remote.authority})}catch(pe){if((0,Ge.matchesScheme)(oe,Fe.Schemas.http)||(0,Ge.matchesScheme)(oe,Fe.Schemas.https))return oe;throw pe}},get remoteName(){return(0,V.getRemoteName)(be.remote.authority)},get remoteAuthority(){return(0,De.checkProposedApiEnabled)(Ue,"resolvers"),be.remote.authority},get uiKind(){return be.uiKind}};be.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=be.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Pi={createTestController(oe,pe,Ae){return Kt.createTestController(oe,pe,Ae)},createTestObserver(){return(0,De.checkProposedApiEnabled)(Ue,"testObserver"),Kt.createTestObserver()},runTests(oe){return(0,De.checkProposedApiEnabled)(Ue,"testObserver"),Kt.runTests(oe)},get onDidChangeTestResults(){return(0,De.checkProposedApiEnabled)(Ue,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,De.checkProposedApiEnabled)(Ue,"testObserver"),Kt.results}},Ti={getExtension(oe){const pe=Ut.getExtensionDescription(oe);if(pe)return new r.Extension(Qe,Ue.identifier,pe,wi)},get all(){return Ut.getAllExtensionDescriptions().map(oe=>new r.Extension(Qe,Ue.identifier,oe,wi))},get onDidChange(){return Ut.onDidChange}},Ai={createDiagnosticCollection(oe){return Jt.createDiagnosticCollection(Ue.identifier,oe)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:oe=>Jt.getDiagnostics(oe),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(oe,pe){return zt.changeLanguage(oe.uri,pe)},match(oe,pe){return(0,L.score)($.LanguageSelector.from(oe),pe.uri,pe.languageId,!0)},registerCodeActionsProvider(oe,pe,Ae){return pt.registerCodeActionProvider(Ue,gt(oe),pe,Ae)},registerCodeLensProvider(oe,pe){return pt.registerCodeLensProvider(Ue,gt(oe),pe)},registerDefinitionProvider(oe,pe){return pt.registerDefinitionProvider(Ue,gt(oe),pe)},registerDeclarationProvider(oe,pe){return pt.registerDeclarationProvider(Ue,gt(oe),pe)},registerImplementationProvider(oe,pe){return pt.registerImplementationProvider(Ue,gt(oe),pe)},registerTypeDefinitionProvider(oe,pe){return pt.registerTypeDefinitionProvider(Ue,gt(oe),pe)},registerHoverProvider(oe,pe){return pt.registerHoverProvider(Ue,gt(oe),pe,Ue.identifier)},registerEvaluatableExpressionProvider(oe,pe){return pt.registerEvaluatableExpressionProvider(Ue,gt(oe),pe,Ue.identifier)},registerInlineValuesProvider(oe,pe){return pt.registerInlineValuesProvider(Ue,gt(oe),pe,Ue.identifier)},registerDocumentHighlightProvider(oe,pe){return pt.registerDocumentHighlightProvider(Ue,gt(oe),pe)},registerLinkedEditingRangeProvider(oe,pe){return pt.registerLinkedEditingRangeProvider(Ue,gt(oe),pe)},registerReferenceProvider(oe,pe){return pt.registerReferenceProvider(Ue,gt(oe),pe)},registerRenameProvider(oe,pe){return pt.registerRenameProvider(Ue,gt(oe),pe)},registerDocumentSymbolProvider(oe,pe,Ae){return pt.registerDocumentSymbolProvider(Ue,gt(oe),pe,Ae)},registerWorkspaceSymbolProvider(oe){return pt.registerWorkspaceSymbolProvider(Ue,oe)},registerDocumentFormattingEditProvider(oe,pe){return pt.registerDocumentFormattingEditProvider(Ue,gt(oe),pe)},registerDocumentRangeFormattingEditProvider(oe,pe){return pt.registerDocumentRangeFormattingEditProvider(Ue,gt(oe),pe)},registerOnTypeFormattingEditProvider(oe,pe,Ae,...dt){return pt.registerOnTypeFormattingEditProvider(Ue,gt(oe),pe,[Ae].concat(dt))},registerDocumentSemanticTokensProvider(oe,pe,Ae){return pt.registerDocumentSemanticTokensProvider(Ue,gt(oe),pe,Ae)},registerDocumentRangeSemanticTokensProvider(oe,pe,Ae){return pt.registerDocumentRangeSemanticTokensProvider(Ue,gt(oe),pe,Ae)},registerSignatureHelpProvider(oe,pe,Ae,...dt){return typeof Ae=="object"?pt.registerSignatureHelpProvider(Ue,gt(oe),pe,Ae):pt.registerSignatureHelpProvider(Ue,gt(oe),pe,typeof Ae=="undefined"?[]:[Ae,...dt])},registerCompletionItemProvider(oe,pe,...Ae){return pt.registerCompletionItemProvider(Ue,gt(oe),pe,Ae)},registerInlineCompletionItemProvider(oe,pe){return(0,De.checkProposedApiEnabled)(Ue,"inlineCompletions"),pt.registerInlineCompletionsProvider(Ue,gt(oe),pe)},registerDocumentLinkProvider(oe,pe){return pt.registerDocumentLinkProvider(Ue,gt(oe),pe)},registerColorProvider(oe,pe){return pt.registerColorProvider(Ue,gt(oe),pe)},registerFoldingRangeProvider(oe,pe){return pt.registerFoldingRangeProvider(Ue,gt(oe),pe)},registerSelectionRangeProvider(oe,pe){return pt.registerSelectionRangeProvider(Ue,oe,pe)},registerCallHierarchyProvider(oe,pe){return pt.registerCallHierarchyProvider(Ue,oe,pe)},registerTypeHierarchyProvider(oe,pe){return pt.registerTypeHierarchyProvider(Ue,oe,pe)},setLanguageConfiguration:(oe,pe)=>pt.setLanguageConfiguration(Ue,oe,pe),getTokenInformationAtPosition(oe,pe){return(0,De.checkProposedApiEnabled)(Ue,"tokenInformation"),zt.tokenAtPosition(oe,pe)},registerInlayHintsProvider(oe,pe){return(0,De.checkProposedApiEnabled)(Ue,"inlayHints"),pt.registerInlayHintsProvider(Ue,oe,pe)},createLanguageStatusItem(oe,pe){return(0,De.checkProposedApiEnabled)(Ue,"languageStatus"),zt.createLanguageStatusItem(Ue,oe,pe)}},Ri={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(oe,pe,Ae){const dt=await(T.URI.isUri(oe)?Promise.resolve(ri.openTextDocument(oe)):Promise.resolve(oe));return Lt.showTextDocument(dt,pe,Ae)},createTextEditorDecorationType(oe){return Lt.createTextEditorDecorationType(Ue,oe)},onDidChangeActiveTextEditor(oe,pe,Ae){return Lt.onDidChangeActiveTextEditor(oe,pe,Ae)},onDidChangeVisibleTextEditors(oe,pe,Ae){return Lt.onDidChangeVisibleTextEditors(oe,pe,Ae)},onDidChangeTextEditorSelection(oe,pe,Ae){return Lt.onDidChangeTextEditorSelection(oe,pe,Ae)},onDidChangeTextEditorOptions(oe,pe,Ae){return Lt.onDidChangeTextEditorOptions(oe,pe,Ae)},onDidChangeTextEditorVisibleRanges(oe,pe,Ae){return Lt.onDidChangeTextEditorVisibleRanges(oe,pe,Ae)},onDidChangeTextEditorViewColumn(oe,pe,Ae){return Lt.onDidChangeTextEditorViewColumn(oe,pe,Ae)},onDidCloseTerminal(oe,pe,Ae){return wt.onDidCloseTerminal(oe,pe,Ae)},onDidOpenTerminal(oe,pe,Ae){return wt.onDidOpenTerminal(oe,pe,Ae)},onDidChangeActiveTerminal(oe,pe,Ae){return wt.onDidChangeActiveTerminal(oe,pe,Ae)},onDidChangeTerminalDimensions(oe,pe,Ae){return(0,De.checkProposedApiEnabled)(Ue,"terminalDimensions"),wt.onDidChangeTerminalDimensions(oe,pe,Ae)},onDidChangeTerminalState(oe,pe,Ae){return wt.onDidChangeTerminalState(oe,pe,Ae)},onDidWriteTerminalData(oe,pe,Ae){return(0,De.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),wt.onDidWriteTerminalData(oe,pe,Ae)},get state(){return qe.state},onDidChangeWindowState(oe,pe,Ae){return qe.onDidChangeWindowState(oe,pe,Ae)},showInformationMessage(oe,...pe){return ui.showMessage(Ue,C.default.Info,oe,pe[0],pe.slice(1))},showWarningMessage(oe,...pe){return ui.showMessage(Ue,C.default.Warning,oe,pe[0],pe.slice(1))},showErrorMessage(oe,...pe){return ui.showMessage(Ue,C.default.Error,oe,pe[0],pe.slice(1))},showQuickPick(oe,pe,Ae){return Array.isArray(oe)&&oe.some(dt=>dt.kind===M.QuickPickItemKind.Separator)&&(0,De.checkProposedApiEnabled)(Ue,"quickPickSeparators"),jt.showQuickPick(oe,pe,Ae)},showWorkspaceFolderPick(oe){return jt.showWorkspaceFolderPick(oe)},showInputBox(oe,pe){return jt.showInput(oe,pe)},showOpenDialog(oe){return ii.showOpenDialog(oe)},showSaveDialog(oe){return ii.showSaveDialog(oe)},createStatusBarItem(oe,pe,Ae){let dt,Ct,kt;return typeof oe=="string"?(dt=oe,Ct=pe,kt=Ae):(Ct=oe,kt=pe),gi.createStatusBarEntry(Ue,dt,Ct,kt)},setStatusBarMessage(oe,pe){return gi.setStatusBarMessage(oe,pe)},withScmProgress(oe){return Ze.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),fi.withProgress(Ue,{location:M.ProgressLocation.SourceControl},(pe,Ae)=>oe({report(dt){}}))},withProgress(oe,pe){return fi.withProgress(Ue,oe,pe)},createOutputChannel(oe){return Pt.createOutputChannel(oe,Ue)},createWebviewPanel(oe,pe,Ae,dt){return Gt.createWebviewPanel(Ue,oe,pe,Ae,dt)},createWebviewTextEditorInset(oe,pe,Ae,dt){return(0,De.checkProposedApiEnabled)(Ue,"editorInsets"),ai.createWebviewEditorInset(oe,pe,Ae,dt,Ue)},createTerminal(oe,pe,Ae){return typeof oe=="object"?"pty"in oe?wt.createExtensionTerminal(oe):wt.createTerminalFromOptions(oe):wt.createTerminal(oe,pe,Ae)},registerTerminalLinkProvider(oe){return wt.registerLinkProvider(oe)},registerTerminalProfileProvider(oe,pe){return wt.registerProfileProvider(Ue,oe,pe)},registerTreeDataProvider(oe,pe){return Yt.registerTreeDataProvider(oe,pe,Ue)},createTreeView(oe,pe){return Yt.createTreeView(oe,pe,Ue)},registerWebviewPanelSerializer:(oe,pe)=>Gt.registerWebviewPanelSerializer(Ue,oe,pe),registerCustomEditorProvider:(oe,pe,Ae={})=>_i.registerCustomEditorProvider(Ue,oe,pe,Ae),registerFileDecorationProvider(oe){return Dt.registerFileDecorationProvider(oe,Ue.identifier)},registerUriHandler(oe){return Rt.registerUriHandler(Ue.identifier,oe)},createQuickPick(){return jt.createQuickPick(Ue)},createInputBox(){return jt.createInputBox(Ue.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(oe,pe,Ae){return mi.onDidChangeActiveColorTheme(oe,pe,Ae)},registerWebviewViewProvider(oe,pe,Ae){return Ci.registerWebviewViewProvider(Ue,oe,pe,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),St.activeNotebookEditor},onDidChangeActiveNotebookEditor(oe,pe,Ae){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),St.onDidChangeActiveNotebookEditor(oe,pe,Ae)},get visibleNotebookEditors(){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(oe,pe,Ae){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),Vt.onDidChangeNotebookEditorSelection(oe,pe,Ae)},onDidChangeNotebookEditorVisibleRanges(oe,pe,Ae){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),Vt.onDidChangeNotebookEditorVisibleRanges(oe,pe,Ae)},showNotebookDocument(oe,pe){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),St.showNotebookDocument(oe,pe)},registerExternalUriOpener(oe,pe,Ae){return(0,De.checkProposedApiEnabled)(Ue,"externalUriOpener"),yi.registerExternalUriOpener(Ue.identifier,oe,pe,Ae)},get tabs(){return(0,De.checkProposedApiEnabled)(Ue,"tabs"),Et.tabs},get activeTab(){return(0,De.checkProposedApiEnabled)(Ue,"tabs"),Et.activeTab},get onDidChangeTabs(){return(0,De.checkProposedApiEnabled)(Ue,"tabs"),Et.onDidChangeTabs},get onDidChangeActiveTab(){return(0,De.checkProposedApiEnabled)(Ue,"tabs"),Et.onDidChangeActiveTab},getInlineCompletionItemController(oe){return(0,De.checkProposedApiEnabled)(Ue,"inlineCompletions"),h.InlineCompletionController.get(oe)}},ri={get rootPath(){return Ze.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),$e.getPath()},set rootPath(oe){throw i.readonly()},getWorkspaceFolder(oe){return $e.getWorkspaceFolder(oe)},get workspaceFolders(){return $e.getWorkspaceFolders()},get name(){return $e.name},set name(oe){throw i.readonly()},get workspaceFile(){return $e.workspaceFile},set workspaceFile(oe){throw i.readonly()},updateWorkspaceFolders:(oe,pe,...Ae)=>$e.updateWorkspaceFolders(Ue,oe,pe||0,...Ae),onDidChangeWorkspaceFolders:function(oe,pe,Ae){return $e.onDidChangeWorkspace(oe,pe,Ae)},asRelativePath:(oe,pe)=>$e.getRelativePath(oe,pe),findFiles:(oe,pe,Ae,dt)=>$e.findFiles($.GlobPattern.from(oe),$.GlobPattern.from(pe),Ae,Ue.identifier,dt),findTextInFiles:(oe,pe,Ae,dt)=>{(0,De.checkProposedApiEnabled)(Ue,"findTextInFiles");let Ct,kt;return typeof pe=="object"?(Ct=pe,kt=Ae):(Ct={},kt=pe,dt=Ae),$e.findTextInFiles(oe,Ct||{},kt,Ue.identifier,dt)},saveAll:oe=>$e.saveAll(oe),applyEdit(oe){return Di.applyWorkspaceEdit(oe)},createFileSystemWatcher:(oe,pe,Ae,dt)=>Nt.createFileSystemWatcher($.GlobPattern.from(oe),pe,Ae,dt),get textDocuments(){return yt.getAllDocumentData().map(oe=>oe.document)},set textDocuments(oe){throw i.readonly()},openTextDocument(oe){let pe;const Ae=oe;if(typeof oe=="string")pe=Promise.resolve(T.URI.file(oe));else if(T.URI.isUri(oe))pe=Promise.resolve(oe);else if(!Ae||typeof Ae=="object")pe=yt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return pe.then(dt=>yt.ensureDocumentData(dt).then(Ct=>Ct.document))},onDidOpenTextDocument:(oe,pe,Ae)=>yt.onDidAddDocument(oe,pe,Ae),onDidCloseTextDocument:(oe,pe,Ae)=>yt.onDidRemoveDocument(oe,pe,Ae),onDidChangeTextDocument:(oe,pe,Ae)=>yt.onDidChangeDocument(oe,pe,Ae),onDidSaveTextDocument:(oe,pe,Ae)=>yt.onDidSaveDocument(oe,pe,Ae),onWillSaveTextDocument:(oe,pe,Ae)=>Ot.getOnWillSaveTextDocumentEvent(Ue)(oe,pe,Ae),get notebookDocuments(){return St.notebookDocuments.map(oe=>oe.apiNotebook)},async openNotebookDocument(oe,pe){let Ae;if(T.URI.isUri(oe))Ae=oe,await St.openNotebookDocument(oe);else if(typeof oe=="string")Ae=T.URI.revive(await St.createNotebookDocument({viewType:oe,content:pe}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(oe,pe,Ae,dt){return St.registerNotebookSerializer(Ue,oe,pe,Ae,(0,De.isProposedApiEnabled)(Ue,"notebookLiveShare")?dt:void 0)},registerNotebookContentProvider:(oe,pe,Ae,dt)=>((0,De.checkProposedApiEnabled)(Ue,"notebookContentProvider"),St.registerNotebookContentProvider(Ue,oe,pe,Ae,(0,De.isProposedApiEnabled)(Ue,"notebookLiveShare")?dt:void 0)),onDidChangeConfiguration:(oe,pe,Ae)=>pi.onDidChangeConfiguration(oe,pe,Ae),getConfiguration(oe,pe){return pe=arguments.length===1?void 0:pe,pi.getConfiguration(oe,pe,Ue)},registerTextDocumentContentProvider(oe,pe){return Ht.registerTextDocumentContentProvider(oe,pe)},registerTaskProvider:(oe,pe)=>(Ze.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Ue,oe,pe)),registerFileSystemProvider(oe,pe,Ae){return(0,Te.combinedDisposable)(ci.registerFileSystemProvider(Ue,oe,pe,Ae),Ne.addFileSystemProvider(oe,pe))},get fs(){return Ne.value},registerFileSearchProvider:(oe,pe)=>((0,De.checkProposedApiEnabled)(Ue,"fileSearchProvider"),Mt.registerFileSearchProvider(oe,pe)),registerTextSearchProvider:(oe,pe)=>((0,De.checkProposedApiEnabled)(Ue,"textSearchProvider"),Mt.registerTextSearchProvider(oe,pe)),registerRemoteAuthorityResolver:(oe,pe)=>((0,De.checkProposedApiEnabled)(Ue,"resolvers"),Qe.registerRemoteAuthorityResolver(oe,pe)),registerResourceLabelFormatter:oe=>((0,De.checkProposedApiEnabled)(Ue,"resolvers"),Ei.$registerResourceLabelFormatter(oe)),onDidCreateFiles:(oe,pe,Ae)=>Nt.onDidCreateFile(oe,pe,Ae),onDidDeleteFiles:(oe,pe,Ae)=>Nt.onDidDeleteFile(oe,pe,Ae),onDidRenameFiles:(oe,pe,Ae)=>Nt.onDidRenameFile(oe,pe,Ae),onWillCreateFiles:(oe,pe,Ae)=>Nt.getOnWillCreateFileEvent(Ue)(oe,pe,Ae),onWillDeleteFiles:(oe,pe,Ae)=>Nt.getOnWillDeleteFileEvent(Ue)(oe,pe,Ae),onWillRenameFiles:(oe,pe,Ae)=>Nt.getOnWillRenameFileEvent(Ue)(oe,pe,Ae),openTunnel:oe=>((0,De.checkProposedApiEnabled)(Ue,"resolvers"),Me.openTunnel(Ue,oe).then(pe=>{if(!pe)throw new Error("cannot open tunnel");return pe})),get tunnels(){return(0,De.checkProposedApiEnabled)(Ue,"resolvers"),Me.getTunnels()},onDidChangeTunnels:(oe,pe,Ae)=>((0,De.checkProposedApiEnabled)(Ue,"resolvers"),Me.onDidChangeTunnels(oe,pe,Ae)),registerPortAttributesProvider:(oe,pe)=>((0,De.checkProposedApiEnabled)(Ue,"portsAttributes"),Me.registerPortsAttributesProvider(oe,pe)),registerTimelineProvider:(oe,pe)=>((0,De.checkProposedApiEnabled)(Ue,"timeline"),Si.registerTimelineProvider(oe,pe,Ue.identifier,mt.converter)),get isTrusted(){return $e.trusted},requestWorkspaceTrust:oe=>((0,De.checkProposedApiEnabled)(Ue,"workspaceTrust"),$e.requestWorkspaceTrust(oe)),onDidGrantWorkspaceTrust:(oe,pe,Ae)=>$e.onDidGrantWorkspaceTrust(oe,pe,Ae)},Li={get inputBox(){return Ze.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Zt.getLastInputBox(Ue)},createSourceControl(oe,pe,Ae){return Zt.createSourceControl(Ue,oe,pe,Ae)}},Fi={createCommentController(oe,pe){return li.createCommentController(Ue,oe,pe)}},Mi={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(oe,pe,Ae){return _t.onDidStartDebugSession(oe,pe,Ae)},onDidTerminateDebugSession(oe,pe,Ae){return _t.onDidTerminateDebugSession(oe,pe,Ae)},onDidChangeActiveDebugSession(oe,pe,Ae){return _t.onDidChangeActiveDebugSession(oe,pe,Ae)},onDidReceiveDebugSessionCustomEvent(oe,pe,Ae){return _t.onDidReceiveDebugSessionCustomEvent(oe,pe,Ae)},onDidChangeBreakpoints(oe,pe,Ae){return _t.onDidChangeBreakpoints(oe,pe,Ae)},registerDebugConfigurationProvider(oe,pe,Ae){return _t.registerDebugConfigurationProvider(oe,pe,Ae||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(oe,pe){return _t.registerDebugAdapterDescriptorFactory(Ue,oe,pe)},registerDebugAdapterTrackerFactory(oe,pe){return _t.registerDebugAdapterTrackerFactory(oe,pe)},startDebugging(oe,pe,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?_t.startDebugging(oe,pe,{parentSession:Ae}):_t.startDebugging(oe,pe,Ae||{})},stopDebugging(oe){return _t.stopDebugging(oe)},addBreakpoints(oe){return _t.addBreakpoints(oe)},removeBreakpoints(oe){return _t.removeBreakpoints(oe)},asDebugSourceUri(oe,pe){return _t.asDebugSourceUri(oe,pe)}},Oi={registerTaskProvider:(oe,pe)=>It.registerTaskProvider(Ue,oe,pe),fetchTasks:oe=>It.fetchTasks(oe),executeTask:oe=>It.executeTask(Ue,oe),get taskExecutions(){return It.taskExecutions},onDidStartTask:(oe,pe,Ae)=>It.onDidStartTask(oe,pe,Ae),onDidEndTask:(oe,pe,Ae)=>It.onDidEndTask(oe,pe,Ae),onDidStartTaskProcess:(oe,pe,Ae)=>It.onDidStartTaskProcess(oe,pe,Ae),onDidEndTaskProcess:(oe,pe,Ae)=>It.onDidEndTaskProcess(oe,pe,Ae)},Ni={createNotebookController(oe,pe,Ae,dt,Ct){return Xt.createNotebookController(Ue,oe,pe,Ae,dt,(0,De.isProposedApiEnabled)(Ue,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(oe,pe)=>St.registerNotebookCellStatusBarItemProvider(Ue,oe,pe),get onDidSaveNotebookDocument(){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(oe){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditorDecorationType"),Vt.createNotebookEditorDecorationType(oe)},createRendererMessaging(oe){return oi.createRendererMessaging(Ue,oe)},onDidChangeNotebookDocumentMetadata(oe,pe,Ae){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(oe,pe,Ae)},onDidChangeNotebookCells(oe,pe,Ae){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),St.onDidChangeNotebookCells(oe,pe,Ae)},onDidChangeNotebookCellExecutionState(oe,pe,Ae){return(0,De.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Xt.onDidChangeNotebookCellExecutionState(oe,pe,Ae)},onDidChangeCellOutputs(oe,pe,Ae){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),St.onDidChangeCellOutputs(oe,pe,Ae)},onDidChangeCellMetadata(oe,pe,Ae){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),St.onDidChangeCellMetadata(oe,pe,Ae)},createConcatTextDocument(oe,pe){return(0,De.checkProposedApiEnabled)(Ue,"notebookConcatTextDocument"),new Ve.ExtHostNotebookConcatDocument(St,yt,oe,pe)}};return{version:be.version,authentication:ni,commands:Ii,comments:Fi,debug:Mi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Li,tasks:Oi,tests:Pi,window:Ri,workspace:ri,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:i.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:P.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalLocation:M.TerminalLocation,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,TextDocumentChangeReason:M.TextDocumentChangeReason,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,TypeHierarchyItem:M.TypeHierarchyItem,UIKind:c.UIKind,Uri:T.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TestTag:M.TestTag,TestRunProfileKind:M.TestRunProfileKind,TextSearchCompleteMessageType:ne.TextSearchCompleteMessageType,TreeDataTransfer:M.TreeDataTransfer,TreeDataTransferItem:M.TreeDataTransferItem,CoveredCount:M.CoveredCount,FileCoverage:M.FileCoverage,StatementCoverage:M.StatementCoverage,BranchCoverage:M.BranchCoverage,FunctionCoverage:M.FunctionCoverage,WorkspaceTrustState:M.WorkspaceTrustState,LanguageStatusSeverity:M.LanguageStatusSeverity,QuickPickItemKind:M.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=se}),define(ve[278],we([0,1,279,293,294,2,295]),function(X,e,m,i,k,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function I(D,c,b,p,v,w){const R=w.environment.useHostProxy,S=typeof R=="boolean"?R:!w.remote.isRemote,s=(0,T.createProxyResolver)({resolveProxy:g=>D.resolveProxy(g),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(g,a,...E)=>{switch(g){case T.LogLevel.Trace:p.trace(a,...E);break;case T.LogLevel.Debug:p.debug(a,...E);break;case T.LogLevel.Info:p.info(a,...E);break;case T.LogLevel.Warning:p.warn(a,...E);break;case T.LogLevel.Error:p.error(a,...E);break;case T.LogLevel.Critical:p.critical(a,...E);break;case T.LogLevel.Off:break;default:r(g,a,E);break}function r(t,o,...h){p.error("Unknown log level",t),p.error(o,...h)}},getLogLevel:()=>p.getLevel(),proxyResolveTelemetry:g=>{v.$publicLog2("resolveProxy",g)},useHostProxy:S,env:process.env}),n=y(c,s);return L(b,n)}e.connectProxyResolver=I;function y(D,c){const b={config:D.getConfiguration("http").get("proxySupport")||"off"};D.onDidChangeConfiguration(v=>{b.config=D.getConfiguration("http").get("proxySupport")||"off"});const p={config:!!D.getConfiguration("http").get("systemCertificates")};return D.onDidChangeConfiguration(v=>{p.config=!!D.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,T.createHttpPatch)(m,c,{config:"off"},p,!0)),on:Object.assign({},m,(0,T.createHttpPatch)(m,c,{config:"on"},p,!0)),override:Object.assign({},m,(0,T.createHttpPatch)(m,c,{config:"override"},p,!0)),onRequest:Object.assign({},m,(0,T.createHttpPatch)(m,c,b,p,!0)),default:Object.assign(m,(0,T.createHttpPatch)(m,c,b,p,!1))},https:{off:Object.assign({},i,(0,T.createHttpPatch)(i,c,{config:"off"},p,!0)),on:Object.assign({},i,(0,T.createHttpPatch)(i,c,{config:"on"},p,!0)),override:Object.assign({},i,(0,T.createHttpPatch)(i,c,{config:"override"},p,!0)),onRequest:Object.assign({},i,(0,T.createHttpPatch)(i,c,b,p,!0)),default:Object.assign(i,(0,T.createHttpPatch)(i,c,b,p,!1))},tls:Object.assign(k,(0,T.createTlsPatch)(k))}}const P=new Map;function L(D,c){return D.getExtensionPathIndex().then(b=>{const p=X.__$__nodeRequire("module"),v=p._load;p._load=function(R,S,s){if(R==="tls")return c.tls;if(R!=="http"&&R!=="https")return v.apply(this,arguments);const n=c[R],g=b.findSubstr(C.URI.file(S.filename));let a=P.get(g);if(a||P.set(g,a={}),!a[R]){let E=n.default;a[R]={...E}}return a[R]}})}}),define(ve[280],we([0,1,37,8,80,28,12,9,92,281]),function(X,e,m,i,k,C,T,I,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function D(s,n,g,a){const E=c(s,n,g,a),r=n.folder.fsPath;return{cmd:m.spawn(L,E.args,{cwd:r}),rgDiskPath:L,siblingClauses:E.siblingClauses,rgArgs:E,cwd:r}}e.spawnRipgrepCmd=D;function c(s,n,g,a){const E=["--files","--hidden","--case-sensitive"];p([n],g,!1).forEach(t=>{const o=(0,y.anchorGlob)(t);if(E.push("-g",o),T.isMacintosh){const h=(0,k.normalizeNFD)(o);h!==o&&E.push("-g",h)}});const r=b([n],a,void 0,!1);return r.globArgs.forEach(t=>{const o=`!${(0,y.anchorGlob)(t)}`;if(E.push("-g",o),T.isMacintosh){const h=(0,k.normalizeNFD)(o);h!==o&&E.push("-g",h)}}),n.disregardIgnoreFiles!==!1?E.push("--no-ignore"):n.disregardParentIgnoreFiles!==!1&&E.push("--no-ignore-parent"),n.ignoreSymlinks||E.push("--follow"),s.exists&&E.push("--quiet"),E.push("--no-config"),n.disregardGlobalIgnoreFiles&&E.push("--no-ignore-global"),{args:E,siblingClauses:r.siblingClauses}}function b(s,n,g,a=!0){const E=[];let r={};return s.forEach(t=>{const o=Object.assign({},t.excludePattern||{},n||{}),h=v(o,a?t.folder.fsPath:void 0,g);E.push(...h.globArgs),h.siblingClauses&&(r=Object.assign(r,h.siblingClauses))}),{globArgs:E,siblingClauses:r}}e.foldersToRgExcludeGlobs=b;function p(s,n,g=!0){const a=[];return s.forEach(E=>{const r=Object.assign({},n||{},E.includePattern||{}),t=v(r,g?E.folder.fsPath:void 0);a.push(...t.globArgs)}),a}e.foldersToIncludeGlobs=p;function v(s,n,g){const a=[],E={};return Object.keys(s).forEach(r=>{if(g&&g.has(r)||!r)return;const t=s[r];r=R(n?w(n,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof t=="boolean"&&t?(r.startsWith("\\\\")&&(r+="**"),a.push(S(r))):t&&t.when&&(E[r]=t)}),{globArgs:a,siblingClauses:E}}function w(s,n){return i.isAbsolute(n)?n:i.join(s,n)}e.getAbsoluteGlob=w;function R(s){return s=I.rtrim(s,"\\"),I.rtrim(s,"/")}function S(s){return C.getRoot(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.fixDriveC=S}),define(ve[282],we([0,1,37,60,8,104,16,50,32,80,28,12,46,9,13,29,31,280,102]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const s=new Set;process.on("exit",()=>{s.forEach(r=>r())});class n{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&y.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,S.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&y.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(o=>{const h=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),u=o.folder.fsPath;t.folderQueries.map(d=>d.folder.fsPath).filter(d=>d!==u).forEach(d=>{(0,L.isEqualOrParent)(d,u)&&(h[k.relative(u,d)]=!0)}),this.folderExcludePatterns.set(u,new a(h,u))})}cancel(){this.isCanceled=!0,s.forEach(t=>t())}walk(t,o,h,u,d){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return d(null,this.isLimitHit);o.forEach(f=>{const l=k.basename(f.fsPath);this.globalExcludePattern&&this.globalExcludePattern(f.fsPath,l)||this.matchFile(h,{relativePath:f.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(t,(f,l)=>{this.call(this.cmdTraversal,this,f,h,u,_=>{if(_){const A=(0,I.toErrorMessage)(_);console.error(A),this.errors.push(A),l(_,void 0)}else l(null,void 0)})},(f,l)=>{this.fileWalkSW.stop();const _=f?T.coalesce(f)[0]:null;d(_,this.isLimitHit)})}parallel(t,o,h){const u=new Array(t.length),d=new Array(t.length);let f=!1,l=0;if(t.length===0)return h(null,[]);t.forEach((_,A)=>{o(_,(N,x)=>{if(N?(f=!0,u[A]=null,d[A]=N):(u[A]=x,d[A]=null),++l===t.length)return h(f?d:null,u)})})}call(t,o,...h){try{t.apply(o,h)}catch(u){h[h.length-1](u)}}cmdTraversal(t,o,h,u){const d=t.folder.fsPath,f=D.isMacintosh;let l;const _=()=>l&&l.kill();s.add(_);let A=M=>{s.delete(_),A=()=>{},u(M)},N="";const x=this.initDirectoryTree();let F;const O=(0,R.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);l=O.cmd,F=!Object.keys(O.siblingClauses).length;const z=O.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let $=`${O.rgDiskPath} ${z}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&($+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),h({message:$}),this.cmdResultCount=0,this.collectStdout(l,"utf8",h,(M,B,W)=>{if(M){A(M);return}if(this.isLimitHit){A();return}const j=(N+(f?P.normalizeNFC(B||""):B)).split(`
`);if(W){const Z=j.length;j[Z-1]=j[Z-1].trim(),j[Z-1]||j.pop()}else N=j.pop()||"";if(j.length&&j[0].indexOf(`
`)!==-1){A(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=j.length,F){for(const Z of j)if(this.matchFile(o,{base:d,relativePath:Z,searchPath:this.getSearchPath(t,Z)}),this.isLimitHit){_();break}(W||this.isLimitHit)&&A();return}this.addDirectoryEntries(t,x,d,j,o),W&&(this.matchDirectoryTree(x,d,o),A())})}spawnFindCmd(t){const o=this.folderExcludePatterns.get(t.folder.fsPath),h=o.getBasenameTerms(),u=o.getPathTerms(),d=["-L","."];if(h.length||u.length){d.push("-not","(","(");for(const f of h)d.push("-name",f),d.push("-o");for(const f of u)d.push("-path",f),d.push("-o");d.pop(),d.push(")","-prune",")")}return d.push("-type","f"),m.spawn("find",d,{cwd:t.folder.fsPath})}readStdout(t,o,h){let u="";this.collectStdout(t,o,()=>{},(d,f,l)=>{if(d){h(d);return}u+=f,l&&h(null,u)})}collectStdout(t,o,h,u){let d=(_,A,N)=>{(_||N)&&(d=()=>{},this.cmdSW&&this.cmdSW.stop()),u(_,A,N)},f=!1;t.stdout?(this.forwardData(t.stdout,o,d),t.stdout.once("data",()=>f=!0)):h({message:"stdout is null"});let l;t.stderr?l=this.collectData(t.stderr):h({message:"stderr is null"}),t.on("error",_=>{d(_)}),t.on("close",_=>{let A;!f&&(A=this.decodeData(l,o))&&E(A)?d(new Error(`command failed with error code ${_}: ${this.decodeData(l,o)}`)):(this.exists&&_===0&&(this.isLimitHit=!0),d(null,"",!0))})}forwardData(t,o,h){const u=new C.StringDecoder(o);return t.on("data",d=>{h(null,u.write(d))}),u}collectData(t){const o=[];return t.on("data",h=>{o.push(h)}),o}decodeData(t,o){const h=new C.StringDecoder(o);return t.map(u=>h.write(u)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:o},h,u,d){u.indexOf(this.filePattern)!==-1&&this.matchFile(d,{base:h,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const f=l=>{const _=k.basename(l),A=k.dirname(l);let N=o[A];N||(N=o[A]=[],f(A)),N.push({base:h,relativePath:l,basename:_,searchPath:this.getSearchPath(t,l)})};u.forEach(f)}matchDirectoryTree({rootEntries:t,pathToEntries:o},h,u){const d=this,f=this.folderExcludePatterns.get(h),l=this.filePattern;function _(A){d.directoriesWalked++;const N=y.hasSiblingFn(()=>A.map(x=>x.basename));for(let x=0,F=A.length;x<F;x++){const O=A[x],{relativePath:z,basename:$}=O;if(f.test(z,$,l!==$?N:void 0))continue;const M=o[z];if(M)_(M);else{if(d.filesWalked++,z===l)continue;d.matchFile(u,O)}if(d.isLimitHit)break}}_(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,o,h,u,d){const f=t.folder,l=y.hasSiblingFn(()=>h);this.parallel(h,(_,A)=>{if(this.isCanceled||this.isLimitHit)return A(null);const N=o?[o,_].join(k.sep):_;if(this.folderExcludePatterns.get(t.folder.fsPath).test(N,_,this.config.filePattern!==_?l:void 0))return A(null);const x=[f.fsPath,N].join(k.sep);i.lstat(x,(F,O)=>{if(F||this.isCanceled||this.isLimitHit)return A(null);this.statLinkIfNeeded(x,O,(z,$)=>z||this.isCanceled||this.isLimitHit?A(null):$.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(x,O,(M,B)=>M||this.isCanceled||this.isLimitHit||(B=B||"",this.walkedPaths[B])?A(null):(this.walkedPaths[B]=!0,v.Promises.readdir(x).then(W=>{if(this.isCanceled||this.isLimitHit)return A(null);this.doWalk(t,N,W,u,U=>A(U||null))},W=>{A(null)})))):(this.filesWalked++,N===this.filePattern||this.maxFilesize&&p.isNumber($.size)&&$.size>this.maxFilesize||this.matchFile(u,{base:f.fsPath,relativePath:N,searchPath:this.getSearchPath(t,N)}),A(null,void 0)))})},_=>{const A=_&&T.coalesce(_);return d(A&&A.length>0?A[0]:void 0)})}matchFile(t,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,k.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(o))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,w.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,o,h){return o.isSymbolicLink()?i.stat(t,h):h(null,o)}realPathIfNeeded(t,o,h){return o.isSymbolicLink()?i.realpath(t,(u,d)=>u?h(u):h(null,d)):h(null,t)}getSearchPath(t,o){return t.folderName?k.join(t.folderName,o):o}}e.FileWalker=n;class g{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new n(t)}search(t,o,h){this.walker.walk(this.folderQueries,this.extraFiles,t,o,(u,d)=>{h(u,{limitHit:d,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class a{constructor(t,o){this.expression=t,this.root=o,this.init(t)}init(t){let o,h;Object.keys(t).filter(u=>t[u]).forEach(u=>{k.isAbsolute(u)?(o=o||y.getEmptyExpression(),o[u]=t[u]):(h=h||y.getEmptyExpression(),h[u]=t[u])}),this.absoluteParsedExpr=o&&y.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=h&&y.parse(h,{trimForExclusions:!0})}test(t,o,h){return this.relativeParsedExpr&&this.relativeParsedExpr(t,o,h)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,t),o,h)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...y.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...y.getPathTerms(this.relativeParsedExpr)),t}}function E(r){const t=r.trim().split(`
`),o=t[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return b.uppercaseFirstLetter(t[t.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=E}),define(ve[137],we([0,1,37,296,104,16,75,32,8,9,2,31,70,297,281,92]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const w=p.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class R{constructor(f){this.outputChannel=f}provideTextSearchResults(f,l,_,A){return this.outputChannel.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...l,folder:l.folder.toString()})}`),new Promise((N,x)=>{A.onCancellationRequested(()=>U());const F=E(f,l),O=l.folder.fsPath,z=F.map(V=>V.match(/^-/)?V:`'${V}'`).join(" ");this.outputChannel.appendLine(`${w} ${z}
 - cwd: ${O}`);let $=m.spawn(w,F,{cwd:O});$.on("error",V=>{console.error(V),this.outputChannel.appendLine("Error: "+(V&&V.message)),x((0,D.serializeSearchError)(new D.SearchError(V&&V.message,D.SearchErrorCode.rgProcessError)))});let M=!1;const B=new n(l.maxResults,O,l.previewOptions);B.on("result",V=>{M=!0,Z="",_.report(V)});let W=!1;const U=()=>{W=!0,$&&$.kill(),B&&B.cancel()};let j=!1;B.on("hitLimit",()=>{j=!0,U()});let Z="";$.stdout.on("data",V=>{B.handleData(V),M||(Z+=V)});let ce=!1;$.stdout.once("data",()=>ce=!0);let Q="";$.stderr.on("data",V=>{const te=V.toString();this.outputChannel.appendLine(te),Q+=te}),$.on("close",()=>{if(this.outputChannel.appendLine(ce?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),Z&&this.outputChannel.appendLine(`Got data without result: ${Z}`),this.outputChannel.appendLine(""),W)N({limitHit:j});else{B.flush(),$=null;let V;Q&&!ce&&(V=S(Q))?x((0,D.serializeSearchError)(new D.SearchError(V.message,V.code))):N({limitHit:j})}})})}}e.RipgrepTextSearchEngine=R;function S(d){const f=d.split(`
`),l=f[0].trim();if(f.some(A=>A.startsWith("regex parse error")))return new D.SearchError(s(f),D.SearchErrorCode.regexParseError);const _=l.match(/grep config error: unknown encoding: (.*)/);if(_)return new D.SearchError(`Unknown encoding: ${_[1]}`,D.SearchErrorCode.unknownEncoding);if(l.startsWith("error parsing glob"))return new D.SearchError(l.charAt(0).toUpperCase()+l.substr(1),D.SearchErrorCode.globParseError);if(l.startsWith("the literal"))return new D.SearchError(l.charAt(0).toUpperCase()+l.substr(1),D.SearchErrorCode.invalidLiteral);if(l.startsWith("PCRE2: error compiling pattern"))return new D.SearchError(l,D.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=S;function s(d){const f=["Regex parse error"],l=d.filter(_=>_.startsWith("PCRE2:"));if(l.length>=1){const _=l[0].replace("PCRE2:","");if(_.indexOf(":")!==-1&&_.split(":").length>=2){const A=_.split(":")[1];f.push(":"+A)}}return f.join("")}e.buildRegexParseError=s;class n extends i.EventEmitter{constructor(f,l,_){super();this.maxResults=f,this.rootFolder=l,this.previewOptions=_,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(f,l){return super.on(f,l),this}handleData(f){if(this.isDone)return;const l=typeof f=="string"?f:this.stringDecoder.write(f);this.handleDecodedData(l)}handleDecodedData(f){let l=f.indexOf(`
`);const _=this.remainder+f;if(l>=0)l+=this.remainder.length;else{this.remainder=_;return}let A=0;for(;l>=0;)this.handleLine(_.substring(A,l).trim()),A=l+1,l=_.indexOf(`
`,A);this.remainder=_.substring(A)}handleLine(f){if(this.isDone||!f)return;let l;try{l=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(l.type==="match"){const _=g(l.data.path),A=L.URI.file(y.join(this.rootFolder,_)),N=this.createTextSearchMatch(l.data,A);this.onResult(N),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(l.type==="context"){const _=g(l.data.path),A=L.URI.file(y.join(this.rootFolder,_));this.createTextSearchContext(l.data,A).forEach(x=>this.onResult(x))}}createTextSearchMatch(f,l){const _=f.line_number-1,A=g(f.lines),N=Buffer.from(A);let x=0,F=0,O=_;f.submatches.length===0&&f.submatches.push(A.length?{start:0,end:1,match:{text:A[0]}}:{start:0,end:0,match:{text:""}});const z=(0,C.coalesce)(f.submatches.map(($,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const B=g($.match),W=N.slice(x,$.start).toString().length,U=F+W,j=a(B),Z=O,ce=j.numLines+Z,Q=j.numLines>0?j.lastLineLength:j.lastLineLength+U;return x=$.end,F=Q,O=ce,new c.Range(Z,U,ce,Q)}));return(0,v.createTextSearchResult)(l,A,z,this.previewOptions)}createTextSearchContext(f,l){const _=g(f.lines),A=f.line_number;return _.replace(/\r?\n$/,"").split(`
`).map((N,x)=>({text:N,uri:l,lineNumber:A+x}))}onResult(f){this.emit("result",f)}}e.RipgrepParser=n;function g(d){return d.bytes?Buffer.from(d.bytes,"base64").toString():d.text}function a(d){const f=/\n/g;let l=0,_=-1,A;for(;A=f.exec(d);)l++,_=A.index;const N=_>=0?d.length-_-1:d.length;return{numLines:l,lastLineLength:N}}function E(d,f){const l=["--hidden"];l.push(d.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:_,otherIncludes:A}=(0,T.groupBy)(f.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(A&&A.length){const x=new Set;A.forEach(F=>{x.add(F)}),l.push("-g","!*"),x.forEach(F=>{r(F).map(v.anchorGlob).forEach(O=>{l.push("-g",O)})})}_&&_.length&&_.forEach(x=>{l.push("-g",x)}),f.excludes.map(v.anchorGlob).forEach(x=>l.push("-g",`!${x}`)),f.maxFileSize&&l.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||l.push("--no-ignore-parent"):l.push("--no-ignore"),f.followSymlinks&&l.push("--follow"),f.encoding&&f.encoding!=="utf8"&&l.push("--encoding",f.encoding),d.pattern==="--"&&(d.isRegExp=!0,d.pattern="\\-\\-"),d.isMultiline&&!d.isRegExp&&(d.pattern=(0,P.escapeRegExpCharacters)(d.pattern),d.isRegExp=!0),f.usePCRE2&&l.push("--pcre2"),l.push("--crlf"),d.isRegExp&&(d.pattern=t(d.pattern),l.push("--engine","auto"));let N;if(d.isWordMatch){const F=(0,P.createRegExp)(d.pattern,!!d.isRegExp,{wholeWord:d.isWordMatch}).source.replace(/\\\//g,"/");l.push("--regexp",F)}else if(d.isRegExp){let x=h(d.pattern);x=u(x),l.push("--regexp",x)}else N=d.pattern,l.push("--fixed-strings");return l.push("--no-config"),f.useGlobalIgnoreFiles||l.push("--no-ignore-global"),l.push("--json"),d.isMultiline&&l.push("--multiline"),f.beforeContext&&l.push("--before-context",f.beforeContext+""),f.afterContext&&l.push("--after-context",f.afterContext+""),l.push("--"),N&&l.push(N),l.push("."),l}function r(d){const f=(0,I.splitGlobAware)(d,"/");return f.map((l,_)=>f.slice(0,_+1).join("/"))}e.spreadGlobComponents=r;function t(d){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;d.match(f);)d=d.replace(f,"$1\\x{$2}");const l=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;d.match(l);)d=d.replace(l,"$1\\x{$2}");return d}e.unicodeEscapesToPCRE2=t;const o=d=>d.type==="Assertion"&&d.kind==="lookbehind";function h(d){let f;try{f=new b.RegExpParser().parsePattern(d)}catch{return d}let l="",_=0;const A=(F,O,z)=>{l+=d.slice(_,F)+z,_=O},N=[];return new b.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const O=N[0];if(!O)A(F.start,F.end,"\\r?\\n");else if(!N.some(o))if(O.type==="CharacterClass")if(O.negate){const z=d.slice(O.start+2,F.start)+d.slice(F.end,O.end-1);if(O.parent?.type==="Quantifier"){const $=O.parent;A($.start,$.end,(z?`[^${z}]`:".")+($.greedy?"+":"*"))}else A(O.start,O.end,"(?!\\r?\\n"+(z?`|[${z}]`:"")+")")}else{const z=d.slice(O.start+1,F.start)+d.slice(F.end,O.end-1);A(O.start,O.end,z===""?"\\r?\\n":`(?:[${z}]|\\r?\\n)`)}else O.type==="Quantifier"&&A(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){N.unshift(F)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(F){N.unshift(F)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(F){N.unshift(F)},onCharacterClassLeave(){N.shift()},onAssertionEnter(F){o(F)&&N.push(F)},onAssertionLeave(F){N[0]===F&&N.shift()}}).visit(f),l+=d.slice(_),l}e.fixRegexNewline=h;function u(d){return d.replace(/\n/g,"\\r?\\n")}e.fixNewline=u}),define(ve[283],we([0,1,21,137,118,10]),function(X,e,m,i,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,L,D,c){const b=new i.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===C.Schemas.userData){const p={...L,folder:L.folder.with({scheme:C.Schemas.file})},v=new k.Progress(w=>D.report({...w,uri:w.uri.with({scheme:L.folder.scheme})}));return this.withToken(c,w=>b.provideTextSearchResults(P,p,v,w))}else return this.withToken(c,p=>b.provideTextSearchResults(P,L,D,p))}async withToken(P,L){const D=I(P);this.inProgress.add(D);const c=await L(D.token);return this.inProgress.delete(D),c}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=T;function I(y){const P=new m.CancellationTokenSource;return y.onCancellationRequested(()=>P.cancel()),P}}),define(ve[284],we([0,1,29,137,136]),function(X,e,m,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(y){this.query=y}search(y,P,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const D={appendLine(b){L({message:b})}},c=new k.NativeTextSearchManager(this.query,new i.RipgrepTextSearchEngine(D),m);return new Promise((b,p)=>c.search(v=>{P(v.map(T))},y).then(v=>b({limitHit:v.limitHit,type:"success",stats:v.stats}),p))}}e.TextSearchEngineAdapter=C;function T(I){return{path:I.resource&&I.resource.fsPath,results:I.results,numMatches:(I.results||[]).reduce((y,P)=>{if(P.ranges){const L=P;return y+(Array.isArray(L.ranges)?L.ranges.length:1)}else return y+1},0)}}}),define(ve[285],we([0,1,16,18,15,3,102,8,46,2,42,31,282,284]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class p{constructor(n="searchProcess"){this.processType=n,this.caches=Object.create(null)}fileSearch(n){let g;const a=R(n),E=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,i.createCancelablePromise)(r=>this.doFileSearchWithEngine(c.Engine,a,t=>E.fire(t),r)),g.then(r=>E.fire(r),r=>E.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return E.event}textSearch(n){let g;const a=R(n),E=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,i.createCancelablePromise)(r=>this.ripgrepTextSearch(a,t=>E.fire(t),r)),g.then(r=>E.fire(r),r=>E.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return E.event}ripgrepTextSearch(n,g,a){return n.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new b.TextSearchEngineAdapter(n).search(a,g,g)}doFileSearch(n,g,a){return this.doFileSearchWithEngine(c.Engine,n,g,a)}doFileSearchWithEngine(n,g,a,E,r=p.BATCH_SIZE){let t=0;const o=u=>{Array.isArray(u)?(t+=u.length,a(u.map(d=>this.rawMatchToSearchItem(d)))):u.relativePath?(t++,a(this.rawMatchToSearchItem(u))):a(u)};if(g.sortByScore){let u=this.trySortedSearchFromCache(g,o,E);if(!u){const d=g.maxResults?Object.assign({},g,{maxResults:null}):g,f=new n(d);u=this.doSortedSearch(f,g,a,o,E)}return new Promise((d,f)=>{u.then(([l,_])=>{const A=_.map(N=>this.rawMatchToSearchItem(N));this.sendProgress(A,a,r),d(l)},f)})}const h=new n(g);return this.doSearch(h,o,r,E).then(u=>({limitHit:u.limitHit,type:"success",stats:{detailStats:u.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(n){return{path:n.base?(0,I.join)(n.base,n.relativePath):n.relativePath}}doSortedSearch(n,g,a,E,r){const t=new C.Emitter;let o=(0,i.createCancelablePromise)(u=>{let d=[];const f=l=>{Array.isArray(l)?d=l:(E(l),t.fire(l))};return this.doSearch(n,f,-1,u).then(l=>[l,d])}),h;if(g.cacheKey){h=this.getOrCreateCache(g.cacheKey);const u={promise:o,event:t.event,resolved:!1};h.resultsToSearchCache[g.filePattern||""]=u,o.then(()=>{u.resolved=!0},d=>{delete h.resultsToSearchCache[g.filePattern||""]}),o=this.preventCancellation(o)}return o.then(([u,d])=>{const f=h?h.scorerCache:Object.create(null),l=(typeof g.maxResults!="number"||g.maxResults>0)&&y.StopWatch.create(!1);return this.sortResults(g,d,f,r).then(_=>{const A=l?l.elapsed():-1;return[{type:"success",stats:{detailStats:u.stats,sortingTime:A,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:_.length},messages:u.messages,limitHit:u.limitHit||typeof g.maxResults=="number"&&d.length>g.maxResults},_]})})}getOrCreateCache(n){const g=this.caches[n];return g||(this.caches[n]=new v)}trySortedSearchFromCache(n,g,a){const E=n.cacheKey&&this.caches[n.cacheKey];if(!E)return;const r=this.getResultsFromCache(E,n.filePattern||"",g,a);if(r)return r.then(([t,o,h])=>{const u=y.StopWatch.create(!1);return this.sortResults(n,o,E.scorerCache,a).then(d=>{const f=u.elapsed(),l={fromCache:!0,detailStats:h,type:this.processType,resultCount:o.length,sortingTime:f};return[{type:"success",limitHit:t.limitHit||typeof n.maxResults=="number"&&o.length>n.maxResults,stats:l},d]})})}sortResults(n,g,a,E){const r=(0,T.prepareQuery)(n.filePattern||""),t=(h,u)=>(0,T.compareItemsByFuzzyScore)(h,u,r,!0,w,a),o=typeof n.maxResults=="number"?n.maxResults:Number.MAX_VALUE;return m.topAsync(g,t,o,1e4,E)}sendProgress(n,g,a){if(a&&a>0)for(let E=0;E<n.length;E+=a)g(n.slice(E,E+a));else g(n)}getResultsFromCache(n,g,a,E){const r=y.StopWatch.create(!1),t=g.indexOf(I.sep)>=0;let o;for(const f in n.resultsToSearchCache)if(g.startsWith(f)){if(t&&f.indexOf(I.sep)<0&&f!=="")continue;const l=n.resultsToSearchCache[f];o={promise:this.preventCancellation(l.promise),event:l.event,resolved:l.resolved};break}if(!o)return null;const h=r.elapsed(),u=y.StopWatch.create(!1),d=o.event(a);return E&&E.onCancellationRequested(()=>{d.dispose()}),o.promise.then(([f,l])=>{if(E&&E.isCancellationRequested)throw(0,k.canceled)();const _=[],A=(0,T.prepareQuery)(g).normalizedLowercase;for(const N of l)!(0,D.isFilePatternMatch)(N,A)||_.push(N);return[f,_,{cacheWasResolved:o.resolved,cacheLookupTime:h,cacheFilterTime:u.elapsed(),cacheEntryCount:l.length}]})}doSearch(n,g,a,E){return new Promise((r,t)=>{let o=[];E&&E.onCancellationRequested(()=>n.cancel()),n.search(h=>{h&&(a?(o.push(h),a>0&&o.length>=a&&(g(o),o=[])):g(h))},h=>{g(h)},(h,u)=>{o.length&&g(o),h?t(h):r(u)})})}clearCache(n){return delete this.caches[n],Promise.resolve(void 0)}preventCancellation(n){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,a){return n.then(g,a)}catch(g){return this.then(void 0,g)}finally(g){return n.finally(g)}}}}e.SearchService=p,p.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const w=new class{getItemLabel(s){return(0,I.basename)(s.relativePath)}getItemDescription(s){return(0,I.dirname)(s.relativePath)}getItemPath(s){return s.relativePath}};function R(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(S),extraFileResources:s.extraFileResources&&s.extraFileResources.map(n=>P.URI.revive(n))}}function S(s){return{...s,folder:P.URI.revive(s.folder)}}}),define(ve[286],we([0,1,6,10,2,29,11,26,14,73,65,31,285,283,92,136]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let w=class extends P.ExtHostSearch{constructor(S,s,n,g){super(S,n,g);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const a=new p.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(i.Schemas.userData,new b.RipgrepSearchProvider(a)),s.remote.isRemote&&s.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const S=new p.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(i.Schemas.file,new b.RipgrepSearchProvider(S)),this.registerInternalFileSearchProvider(i.Schemas.file,new c.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(S,s){const n=this._handlePool++;return this._internalFileSearchProvider=s,this._internalFileSearchHandle=n,this._proxy.$registerFileSearchProvider(n,this._transformScheme(S)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(n)})}$provideFileSearchResults(S,s,n,g){const a=(0,P.reviveQuery)(n);return S===this._internalFileSearchHandle?this.doInternalFileSearch(S,s,a,g):super.$provideFileSearchResults(S,s,n,g)}doInternalFileSearch(S,s,n,g){const a=E=>{if((0,D.isSerializedFileMatch)(E)&&(E=[E]),Array.isArray(E)){this._proxy.$handleFileMatch(S,s,E.map(r=>k.URI.file(r.path)));return}E.message&&this._logService.debug("ExtHostSearch",E.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(n,a,g)}$clearCache(S){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(S),super.$clearCache(S)}createTextSearchManager(S,s){return new v.NativeTextSearchManager(S,s,void 0,"textSearchProvider")}};w=je([He(0,y.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,L.IURITransformerService),He(3,T.ILogService)],w),e.NativeExtHostSearch=w}),define(ve[138],we([0,1,298,125,82,22,15,3,6,8,12,33,106,107,299]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(l,_=""){this.debugLabel=_,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,T.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}traceSocketEvent(l,_){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(l){const _=A=>{this.traceSocketEvent("read",A),l(C.VSBuffer.wrap(A))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(l){const _=A=>{this.traceSocketEvent("close",{hadError:A}),l({type:0,hadError:A,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(l){const _=()=>{this.traceSocketEvent("nodeEndReceived"),l()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(l){if(!this.socket.destroyed)try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,T.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,T.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=v;var w;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var R;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(R||(R={}));class S extends y.Disposable{constructor(l,_,A,N){super();this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:A?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new s(this,_,A,N,this._onData,(x,F)=>this._write(x,F))),this._register(this._flowManager.onError(x=>{console.error(x),(0,T.onUnexpectedError)(x),this._onClose.fire({type:0,hadError:!0,error:x})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(x=>this._acceptChunk(x))),this._register(this.socket.onClose(x=>this._onClose.fire(x)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,_){this.socket.traceSocketEvent(l,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._flowManager.writeMessage(l)}_write(l,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let A=2;l.byteLength<126?A+=0:l.byteLength<2**16?A+=2:A+=8;const N=C.VSBuffer.alloc(A);if(_?N.writeUInt8(194,0):N.writeUInt8(130,0),l.byteLength<126)N.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){N.writeUInt8(126,1);let x=1;N.writeUInt8(l.byteLength>>>8&255,++x),N.writeUInt8(l.byteLength>>>0&255,++x)}else{N.writeUInt8(127,1);let x=1;N.writeUInt8(0,++x),N.writeUInt8(0,++x),N.writeUInt8(0,++x),N.writeUInt8(0,++x),N.writeUInt8(l.byteLength>>>24&255,++x),N.writeUInt8(l.byteLength>>>16&255,++x),N.writeUInt8(l.byteLength>>>8&255,++x),N.writeUInt8(l.byteLength>>>0&255,++x)}this.socket.write(C.VSBuffer.concat([N,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),A=_.readUInt8(0),N=(A&128)>>>7,x=(A&64)>>>6,F=_.readUInt8(1),O=(F&128)>>>7,z=F&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(z===126?2:0)+(z===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(x)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),A=_.readUInt8(1),N=(A&128)>>>7;let x=A&127,F=1;x===126?x=_.readUInt8(++F)*2**8+_.readUInt8(++F):x===127&&(x=_.readUInt8(++F)*0+_.readUInt8(++F)*0+_.readUInt8(++F)*0+_.readUInt8(++F)*0+_.readUInt8(++F)*2**24+_.readUInt8(++F)*2**16+_.readUInt8(++F)*2**8+_.readUInt8(++F));let O=0;N&&(O=_.readUInt8(++F)*2**24+_.readUInt8(++F)*2**16+_.readUInt8(++F)*2**8+_.readUInt8(++F)),this._state.state=3,this._state.readLen=x,this._state.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),a(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class s extends y.Disposable{constructor(l,_,A,N,x,F){super();this._tracer=l,this._onData=x,this._writeFn=F,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new n(this._tracer,N,A,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(O=>this._onError.fire(O))),this._register(this._zlibDeflateStream.onError(O=>this._onError.fire(O)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(l){this._writeQueue.push(l),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const l=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(_,!0)}else this._writeFn(l,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,_){return new Promise((A,N)=>{l.write(_),l.flush(x=>A(x))})}acceptFrame(l,_,A){this._readQueue.push({data:l,isCompressed:_,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1}}_inflateFrame(l,_,A){return new Promise((N,x)=>{l.write(_),A&&l.write(C.VSBuffer.fromByteArray([0,0,255,255])),l.flush(F=>N(F))})}}class n extends y.Disposable{constructor(l,_,A,N){super();this._tracer=l,this._recordInflateBytes=_,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=p.createInflateRaw(N),this._zlibInflate.on("error",x=>{this._tracer.traceSocketEvent("zlibInflateError",{message:x?.message,code:x?.code}),this._onError.fire(x)}),this._zlibInflate.on("data",x=>{this._tracer.traceSocketEvent("zlibInflateData",x),this._pendingInflateData.push(C.VSBuffer.wrap(x))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(_)})}}class g extends y.Disposable{constructor(l,_){super();this._tracer=l,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=p.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(C.VSBuffer.wrap(A))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),l(_)})}}function a(f,l){if(l===0)return;let _=f.byteLength>>>2;for(let z=0;z<_;z++){const $=f.readUInt32BE(z*4);f.writeUInt32BE($^l,z*4)}let A=_*4,N=f.byteLength-A;const x=l>>>24&255,F=l>>>16&255,O=l>>>8&255;N>=1&&f.writeUInt8(f.readUInt8(A)^x,A),N>=2&&f.writeUInt8(f.readUInt8(A+1)^F,A+1),N>=3&&f.writeUInt8(f.readUInt8(A+2)^O,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const E={[2]:107,[1]:103};function r(){const f=(0,D.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):l=(0,P.join)((0,k.tmpdir)(),`vscode-ipc-${f}.sock`),o(l),l}e.createRandomIPCHandle=r;function t(f,l,_){const A=(0,m.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${_}-${l}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${_}-${l}.sock`):N=(0,P.join)(f,`${_}-${l}.sock`),o(N),N}e.createStaticIPCHandle=t;function o(f){const l=E[L.platform];typeof l=="number"&&f.length>=l&&console.warn(`WARNING: IPC handle "${f}" is longer than ${l} chars, try a shorter --user-data-dir`)}class h extends c.IPCServer{constructor(l){super(h.toClientConnectionEvent(l));this.server=l}static toClientConnectionEvent(l){const _=I.Event.fromNodeEventEmitter(l,"connection");return I.Event.map(_,A=>({protocol:new b.Protocol(new v(A,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=h;function u(f){return new Promise((l,_)=>{const A=(0,i.createServer)();A.on("error",_),A.listen(f,()=>{A.removeListener("error",_),l(new h(A))})})}e.serve=u;function d(f,l){return new Promise((_,A)=>{const N=(0,i.createConnection)(f,()=>{N.removeListener("error",A),_(b.Client.fromSocket(new v(N,`ipc-client${l}`),l))});N.once("error",A)})}e.connect=d}),define(ve[287],we([0,1,138,279,60,38,2,198,11]),function(X,e,m,i,k,C,T,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(c,b,p){this._commands=c,this.logService=b,this._ipcHandlePath=p,this._server=i.createServer((v,w)=>this.onRequest(v,w)),this.setup().catch(v=>(b.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,b){const p=[];c.setEncoding("utf8"),c.on("data",v=>p.push(v)),c.on("end",()=>{const v=JSON.parse(p.join(""));switch(v.type){case"open":this.open(v,b);break;case"openExternal":this.openExternal(v,b);break;case"status":this.getStatus(v,b);break;case"extensionManagement":this.manageExtensions(v,b).catch(this.logService.error);break;default:b.writeHead(404),b.write(`Unknown message type: ${v.type}`,w=>{w&&this.logService.error(w)}),b.end();break}})}open(c,b){const{fileURIs:p,folderURIs:v,forceNewWindow:w,diffMode:R,addMode:S,forceReuseWindow:s,gotoLineMode:n,waitMarkerFilePath:g,remoteAuthority:a}=c,E=[];if(Array.isArray(v))for(const h of v)try{E.push({folderUri:T.URI.parse(h)})}catch{}if(Array.isArray(p))for(const h of p)try{(0,I.hasWorkspaceFileExtension)(h)?E.push({workspaceUri:T.URI.parse(h)}):E.push({fileUri:T.URI.parse(h)})}catch{}const r=g?T.URI.file(g):void 0,o={forceNewWindow:w,diffMode:R,addMode:S,gotoLineMode:n,forceReuseWindow:s,preferNewWindow:!s&&!r&&!S,waitMarkerFileURI:r,remoteAuthority:a};this._commands.executeCommand("_remoteCLI.windowOpen",E,o),b.writeHead(200),b.end()}async openExternal(c,b){for(const p of c.uris){const v=T.URI.parse(p),w=v.scheme==="file"?v:p;await this._commands.executeCommand("_remoteCLI.openExternal",w)}b.writeHead(200),b.end()}async manageExtensions(c,b){try{const p=R=>R?.map(S=>/\.vsix$/i.test(S)?T.URI.parse(S):S),v={list:c.list,install:p(c.install),uninstall:p(c.uninstall),force:c.force},w=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);b.writeHead(200),b.write(w)}catch(p){b.writeHead(500),b.write(String(p),v=>{v&&this.logService.error(v)})}b.end()}async getStatus(c,b){try{const p=await this._commands.executeCommand("_remoteCLI.getSystemStatus");b.writeHead(200),b.write(p),b.end()}catch(p){b.writeHead(500),b.write(String(p),v=>{v&&this.logService.error(v)}),b.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let L=class extends P{constructor(c,b){super(c,b,(0,m.createRandomIPCHandle)())}};L=je([He(0,C.IExtHostCommands),He(1,y.ILogService)],L),e.CLIServer=L}),define(ve[288],we([0,1,72,277,268,5,278,39,258,2,10,7,287,105]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class p extends k.RequireInterceptor{_installInterceptor(){const R=this,S=X.__$__nodeRequire("module"),s=S._load;S._load=function(g,a,E){for(let r of R._alternatives){let t=r(g);if(t){g=t;break}}return R._factories.has(g)?R._factories.get(g).load(g,P.URI.file((0,b.realpathSync)(a.filename)),r=>s.apply(this,[r,a,E])):s.apply(this,arguments)}}}class v extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=D.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const R=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}await this._instaService.createInstance(p,R,this._registry).install(),m.mark("code/extHost/didInitAPI");const s=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,s,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const n=process.send,g=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...a)=>a.length===0||!a[0]||a[0].type!=="__$console"?n.apply(process,a):(g.$logExtensionHostMessage(a[0]),!1)}_getEntryPoint(R){return R.main}_loadCommonJSModule(R,S,s){if(S.scheme!==L.Schemas.file)throw new Error(`Cannot load URI: '${S}', must be of file-scheme`);let n=null;s.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${S.toString(!0)}`),this._logService.flush();try{R&&m.mark(`code/extHost/willLoadExtensionCode/${R.value}`),n=X.__$__nodeRequire(S.fsPath)}catch(g){return Promise.reject(g)}finally{R&&m.mark(`code/extHost/didLoadExtensionCode/${R.value}`),s.codeLoadingStop()}return Promise.resolve(n)}async $setRemoteEnvironment(R){if(!!this._initData.remote.isRemote)for(const S in R){const s=R[S];s===null?delete process.env[S]:process.env[S]=s}}}e.ExtHostExtensionService=v}),define(ve[289],we([0,1,61,261,270,269,286,288,262,55,39,73,71,34,52,68,260,259,11]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(L.IExtHostExtensionService,I.ExtHostExtensionService),(0,m.registerSingleton)(S.ILoggerService,R.ExtHostLoggerService),(0,m.registerSingleton)(v.IExtensionStoragePaths,w.ExtensionStoragePaths),(0,m.registerSingleton)(P.IExtHostDebugService,C.ExtHostDebugService),(0,m.registerSingleton)(D.IExtHostSearch,T.NativeExtHostSearch),(0,m.registerSingleton)(c.IExtHostTask,k.ExtHostTask),(0,m.registerSingleton)(b.IExtHostTerminalService,i.ExtHostTerminalService),(0,m.registerSingleton)(p.IExtHostTunnelService,y.ExtHostTunnelService)}),define(ve[290],we([0,1,125,300,72,15,107,138,191,224,271,22,103,29,105,18,114,273,289]),function(X,e,m,i,k,C,T,I,y,P,L,D,c,b,p,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let o=0;o<process.execArgv.length;o++)process.execArgv[o]==="--inspect-port=0"&&(process.execArgv.splice(o,1),o--)}();const R=i(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=X.__$__nodeRequire("module"),o=t._load;t._load=function(h){if(h==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return o.apply(this,arguments)}})();const S=process.exit.bind(process);function s(t){process.exit=function(o){if(t)S(o);else{const h=new Error("An extension called process.exit() and this was prevented.");console.warn(h.stack)}},process.crash=function(){const o=new Error("An extension called process.crash() and this was prevented.");console.warn(o.stack)}}let n=function(t){S()};function g(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,o)=>{let h=null,u=setTimeout(()=>{n("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const d=108e5,f=3e5,l=new v.ProcessTimeRunOnceScheduler(()=>n("renderer disconnected for too long (1)"),d),_=new v.ProcessTimeRunOnceScheduler(()=>n("renderer disconnected for too long (2)"),f);process.on("message",(N,x)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){x.setNoDelay(!0);const F=D.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let O;if(N.skipWebSocketFrames)O=new I.NodeSocket(x,"extHost-socket");else{const z=D.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));O=new I.WebSocketNodeSocket(new I.NodeSocket(x,"extHost-socket"),N.permessageDeflate,z,!1)}h?(l.cancel(),_.cancel(),h.beginAcceptReconnection(O,F),h.endAcceptReconnection(),h.sendResume()):(clearTimeout(u),h=new T.PersistentProtocol(O,F),h.sendResume(),h.onDidDispose(()=>n("renderer disconnected")),t(h),h.onSocketClose(()=>{l.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(_.isScheduled())return;l.isScheduled()&&_.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((o,h)=>{const u=m.createConnection(t,()=>{u.removeListener("error",h),o(new T.PersistentProtocol(new I.NodeSocket(u,"extHost-renderer")))});u.once("error",h),u.on("close",()=>{n("renderer closed the socket")})})}}async function a(){const t=await g();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(o=>{(0,P.isMessageOfType)(o,2)?(this._terminating=!0,n("received terminate message from renderer")):this._onMessage.fire(o)})}send(o){this._terminating||t.send(o)}drain(){return t.drain()}}}function E(t){return new Promise(o=>{const h=t.onMessage(u=>{h.dispose();const d=JSON.parse(u.toString()),f=d.commit,l=y.default.commit;f&&l&&f!==l&&S(55);let _=0;setInterval(function(){try{process.kill(d.parentPid,0),_=0}catch(N){N&&N.code==="EPERM"?(_++,_>=3&&n(`parent process ${d.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):n(`parent process ${d.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let A;try{A=X.__$__nodeRequire("native-watchdog"),A.start(d.parentPid)}catch(N){(0,C.onUnexpectedError)(N)}t.send((0,P.createMessageOfType)(0)),o({protocol:t,initData:d})});t.send((0,P.createMessageOfType)(1))})}async function r(){const t=[];process.on("unhandledRejection",(_,A)=>{t.push(A),setTimeout(()=>{const N=t.indexOf(A);N>=0&&A.catch(x=>{t.splice(N,1),(0,C.isPromiseCanceledError)(x)||(console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),_&&(0,C.onUnexpectedError)(_))})},1e3)}),process.on("rejectionHandled",_=>{const A=t.indexOf(_);A>=0&&t.splice(A,1)}),process.on("uncaughtException",function(_){(0,C.onUnexpectedError)(_)}),k.mark("code/extHost/willConnectToRenderer");const o=await a();k.mark("code/extHost/didConnectToRenderer");const h=await E(o);k.mark("code/extHost/didWaitForInitData");const{initData:u}=h;s(!!u.environment.extensionTestsLocationURI),u.environment.useHostProxy=R.useHostProxy!==void 0?R.useHostProxy!=="false":void 0,u.environment.skipWorkspaceStorageLock=(0,w.boolean)(R.skipWorkspaceStorageLock,!1);const d=new class{constructor(){this.pid=process.pid}exit(A){S(A)}exists(A){return b.Promises.exists(A)}realpath(A){return(0,p.realpath)(A)}};let f=null;if(u.remote.authority&&R.uriTransformerPath)try{const A=X.__$__nodeRequire(R.uriTransformerPath)(u.remote.authority);f=new c.URITransformer(A)}catch(_){console.error(_)}const l=new L.ExtensionHostMain(h.protocol,u,d,f);n=_=>l.terminate(_)}e.startExtensionHostProcess=r}),define(ve[301],we([0,1,290]),function(X,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(i=>console.log(i))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ea2afbaf90cb6d9672d8a681e90492d23c687064/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
