/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/codicons","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/languages/languageSelector","vs/base/common/hash","vs/editor/common/languages","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/model","vs/editor/common/languages/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],ye=function(ee){for(var e=[],s=0,t=ee.length;s<t;s++)e[s]=Ee[ee[s]];return e};define(Ee[42],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function s(t,E){if(!t)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=s}),define(Ee[52],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function s(k){return k?k.replace(/\$\((.*?)\)/g,(P,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=s;class t{constructor(P,C,A){this.id=P,this.definition=C,this.description=A,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function E(k,P){const C=["codicon","codicon-"+k];return P&&C.push("codicon-modifier-"+P),C}e.getClassNamesArray=E;var T;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function C(w){if(w instanceof t)return["codicon","codicon-"+w.id];const i=P.exec(w.id);if(!i)return C(t.error);let[,p,o]=i;const u=["codicon","codicon-"+p];return o&&u.push("codicon-modifier-"+o.substr(1)),u}k.asClassNameArray=C;function A(w){return C(w).join(" ")}k.asClassName=A;function R(w){return"."+C(w).join(".")}k.asCSSSelector=R})(T=e.CSSIcon||(e.CSSIcon={}))}),define(Ee[74],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const s=Object.prototype.hasOwnProperty;function t(R){const w=[];for(let i in R)s.call(R,i)&&w.push(R[i]);return w}e.values=t;function E(R,w){for(let i in R)if(s.call(R,i)&&w({key:i,value:R[i]},function(){delete R[i]})===!1)return}e.forEach=E;function T(R,w){const i=Object.create(null);for(const p of R){const o=w(p);let u=i[o];u||(u=i[o]=[]),u.push(p)}return i}e.groupBy=T;function k(R){const w=Object.create(null);return R&&R.forEach((i,p)=>{w[p]=i}),w}e.fromMap=k;function P(R,w){const i=[],p=[];for(let o of R)w.has(o)||i.push(o);for(let o of w)R.has(o)||p.push(o);return{removed:i,added:p}}e.diffSets=P;function C(R,w){const i=[],p=[];for(let[o,u]of R)w.has(o)||i.push(u);for(let[o,u]of w)R.has(o)||p.push(u);return{removed:i,added:p}}e.diffMaps=C;class A{constructor(){this.map=new Map}add(w,i){let p=this.map.get(w);p||(p=new Set,this.map.set(w,p)),p.add(i)}delete(w,i){const p=this.map.get(w);!p||(p.delete(i),p.size===0&&this.map.delete(w))}forEach(w,i){const p=this.map.get(w);!p||p.forEach(i)}}e.SetMap=A}),define(Ee[53],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function s(k){return(P,C,A)=>{let R=null,w=null;if(typeof A.value=="function"?(R="value",w=A.value):typeof A.get=="function"&&(R="get",w=A.get),!w)throw new Error("not supported");A[R]=k(w,C)}}e.createDecorator=s;function t(k,P,C){let A=null,R=null;if(typeof C.value=="function"?(A="value",R=C.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(A="get",R=C.get),!R)throw new Error("not supported");const w=`$memoize$${P}`;C[A]=function(...i){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,i)}),this[w]}}e.memoize=t;function E(k,P,C){return s((A,R)=>{const w=`$debounce$${R}`,i=`$debounce$result$${R}`;return function(...p){this[i]||(this[i]=C?C():void 0),clearTimeout(this[w]),P&&(this[i]=P(this[i],...p),p=[this[i]]),this[w]=setTimeout(()=>{A.apply(this,p),this[i]=C?C():void 0},k)}})}e.debounce=E;function T(k,P,C){return s((A,R)=>{const w=`$throttle$timer$${R}`,i=`$throttle$result$${R}`,p=`$throttle$lastRun$${R}`,o=`$throttle$pending$${R}`;return function(...u){if(this[i]||(this[i]=C?C():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),P&&(this[i]=P(this[i],...u)),this[o])return;const d=this[p]+k;d<=Date.now()?(this[p]=Date.now(),A.apply(this,[this[i]]),this[i]=C?C():void 0):(this[o]=!0,this[w]=setTimeout(()=>{this[o]=!1,this[p]=Date.now(),A.apply(this,[this[i]]),this[i]=C?C():void 0},d-Date.now()))}})}e.throttle=T}),define(Ee[54],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class s{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=s,e.defaultGenerator=new s("id#")}),define(Ee[100],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var s;(function(l){l[l.None=0]="None",l[l.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=2]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",l[l.InvalidUnicode=4]="InvalidUnicode",l[l.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",l[l.InvalidCharacter=6]="InvalidCharacter"})(s=e.ScanError||(e.ScanError={}));var t;(function(l){l[l.OpenBraceToken=1]="OpenBraceToken",l[l.CloseBraceToken=2]="CloseBraceToken",l[l.OpenBracketToken=3]="OpenBracketToken",l[l.CloseBracketToken=4]="CloseBracketToken",l[l.CommaToken=5]="CommaToken",l[l.ColonToken=6]="ColonToken",l[l.NullKeyword=7]="NullKeyword",l[l.TrueKeyword=8]="TrueKeyword",l[l.FalseKeyword=9]="FalseKeyword",l[l.StringLiteral=10]="StringLiteral",l[l.NumericLiteral=11]="NumericLiteral",l[l.LineCommentTrivia=12]="LineCommentTrivia",l[l.BlockCommentTrivia=13]="BlockCommentTrivia",l[l.LineBreakTrivia=14]="LineBreakTrivia",l[l.Trivia=15]="Trivia",l[l.Unknown=16]="Unknown",l[l.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(l){l[l.InvalidSymbol=1]="InvalidSymbol",l[l.InvalidNumberFormat=2]="InvalidNumberFormat",l[l.PropertyNameExpected=3]="PropertyNameExpected",l[l.ValueExpected=4]="ValueExpected",l[l.ColonExpected=5]="ColonExpected",l[l.CommaExpected=6]="CommaExpected",l[l.CloseBraceExpected=7]="CloseBraceExpected",l[l.CloseBracketExpected=8]="CloseBracketExpected",l[l.EndOfFileExpected=9]="EndOfFileExpected",l[l.InvalidCommentToken=10]="InvalidCommentToken",l[l.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=12]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",l[l.InvalidUnicode=14]="InvalidUnicode",l[l.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",l[l.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(l){l.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function k(l,M=!1){let r=0,n=l.length,b="",g=0,c=16,f=0;function v(O){let z=0,U=0;for(;z<O;){const $=l.charCodeAt(r);if($>=48&&$<=57)U=U*16+$-48;else if($>=65&&$<=70)U=U*16+$-65+10;else if($>=97&&$<=102)U=U*16+$-97+10;else break;r++,z++}return z<O&&(U=-1),U}function a(O){r=O,b="",g=0,c=16,f=0}function S(){const O=r;if(l.charCodeAt(r)===48)r++;else for(r++;r<l.length&&A(l.charCodeAt(r));)r++;if(r<l.length&&l.charCodeAt(r)===46)if(r++,r<l.length&&A(l.charCodeAt(r)))for(r++;r<l.length&&A(l.charCodeAt(r));)r++;else return f=3,l.substring(O,r);let z=r;if(r<l.length&&(l.charCodeAt(r)===69||l.charCodeAt(r)===101))if(r++,(r<l.length&&l.charCodeAt(r)===43||l.charCodeAt(r)===45)&&r++,r<l.length&&A(l.charCodeAt(r))){for(r++;r<l.length&&A(l.charCodeAt(r));)r++;z=r}else f=3;return l.substring(O,z)}function I(){let O="",z=r;for(;;){if(r>=n){O+=l.substring(z,r),f=2;break}const U=l.charCodeAt(r);if(U===34){O+=l.substring(z,r),r++;break}if(U===92){if(O+=l.substring(z,r),r++,r>=n){f=2;break}switch(l.charCodeAt(r++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const W=v(4);W>=0?O+=String.fromCharCode(W):f=4;break}default:f=5}z=r;continue}if(U>=0&&U<=31)if(C(U)){O+=l.substring(z,r),f=2;break}else f=6;r++}return O}function N(){if(b="",f=0,g=r,r>=n)return g=n,c=17;let O=l.charCodeAt(r);if(P(O)){do r++,b+=String.fromCharCode(O),O=l.charCodeAt(r);while(P(O));return c=15}if(C(O))return r++,b+=String.fromCharCode(O),O===13&&l.charCodeAt(r)===10&&(r++,b+=`
`),c=14;switch(O){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,b=I(),c=10;case 47:{const z=r-1;if(l.charCodeAt(r+1)===47){for(r+=2;r<n&&!C(l.charCodeAt(r));)r++;return b=l.substring(z,r),c=12}if(l.charCodeAt(r+1)===42){r+=2;const U=n-1;let $=!1;for(;r<U;){if(l.charCodeAt(r)===42&&l.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,f=1),b=l.substring(z,r),c=13}return b+=String.fromCharCode(O),r++,c=16}case 45:if(b+=String.fromCharCode(O),r++,r===n||!A(l.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=S(),c=11;default:for(;r<n&&B(O);)r++,O=l.charCodeAt(r);if(g!==r){switch(b=l.substring(g,r),b){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return b+=String.fromCharCode(O),r++,c=16}}function B(O){if(P(O)||C(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function y(){let O;do O=N();while(O>=12&&O<=15);return O}return{setPosition:a,getPosition:()=>r,scan:M?y:N,getToken:()=>c,getTokenValue:()=>b,getTokenOffset:()=>g,getTokenLength:()=>r-g,getTokenError:()=>f}}e.createScanner=k;function P(l){return l===32||l===9||l===11||l===12||l===160||l===5760||l>=8192&&l<=8203||l===8239||l===8287||l===12288||l===65279}function C(l){return l===10||l===13||l===8232||l===8233}function A(l){return l>=48&&l<=57}var R;(function(l){l[l.nullCharacter=0]="nullCharacter",l[l.maxAsciiCharacter=127]="maxAsciiCharacter",l[l.lineFeed=10]="lineFeed",l[l.carriageReturn=13]="carriageReturn",l[l.lineSeparator=8232]="lineSeparator",l[l.paragraphSeparator=8233]="paragraphSeparator",l[l.nextLine=133]="nextLine",l[l.space=32]="space",l[l.nonBreakingSpace=160]="nonBreakingSpace",l[l.enQuad=8192]="enQuad",l[l.emQuad=8193]="emQuad",l[l.enSpace=8194]="enSpace",l[l.emSpace=8195]="emSpace",l[l.threePerEmSpace=8196]="threePerEmSpace",l[l.fourPerEmSpace=8197]="fourPerEmSpace",l[l.sixPerEmSpace=8198]="sixPerEmSpace",l[l.figureSpace=8199]="figureSpace",l[l.punctuationSpace=8200]="punctuationSpace",l[l.thinSpace=8201]="thinSpace",l[l.hairSpace=8202]="hairSpace",l[l.zeroWidthSpace=8203]="zeroWidthSpace",l[l.narrowNoBreakSpace=8239]="narrowNoBreakSpace",l[l.ideographicSpace=12288]="ideographicSpace",l[l.mathematicalSpace=8287]="mathematicalSpace",l[l.ogham=5760]="ogham",l[l._=95]="_",l[l.$=36]="$",l[l._0=48]="_0",l[l._1=49]="_1",l[l._2=50]="_2",l[l._3=51]="_3",l[l._4=52]="_4",l[l._5=53]="_5",l[l._6=54]="_6",l[l._7=55]="_7",l[l._8=56]="_8",l[l._9=57]="_9",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.ampersand=38]="ampersand",l[l.asterisk=42]="asterisk",l[l.at=64]="at",l[l.backslash=92]="backslash",l[l.bar=124]="bar",l[l.caret=94]="caret",l[l.closeBrace=125]="closeBrace",l[l.closeBracket=93]="closeBracket",l[l.closeParen=41]="closeParen",l[l.colon=58]="colon",l[l.comma=44]="comma",l[l.dot=46]="dot",l[l.doubleQuote=34]="doubleQuote",l[l.equals=61]="equals",l[l.exclamation=33]="exclamation",l[l.greaterThan=62]="greaterThan",l[l.lessThan=60]="lessThan",l[l.minus=45]="minus",l[l.openBrace=123]="openBrace",l[l.openBracket=91]="openBracket",l[l.openParen=40]="openParen",l[l.percent=37]="percent",l[l.plus=43]="plus",l[l.question=63]="question",l[l.semicolon=59]="semicolon",l[l.singleQuote=39]="singleQuote",l[l.slash=47]="slash",l[l.tilde=126]="tilde",l[l.backspace=8]="backspace",l[l.formFeed=12]="formFeed",l[l.byteOrderMark=65279]="byteOrderMark",l[l.tab=9]="tab",l[l.verticalTab=11]="verticalTab"})(R||(R={}));function w(l,M){const r=[],n=new Object;let b;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function f(v,a,S,I){g.value=v,g.offset=a,g.length=S,g.type=I,g.colonOffset=void 0,b=g}try{m(l,{onObjectBegin:(v,a)=>{if(M<=v)throw n;b=void 0,c=M>v,r.push("")},onObjectProperty:(v,a,S)=>{if(M<a||(f(v,a,S,"property"),r[r.length-1]=v,M<=a+S))throw n},onObjectEnd:(v,a)=>{if(M<=v)throw n;b=void 0,r.pop()},onArrayBegin:(v,a)=>{if(M<=v)throw n;b=void 0,r.push(0)},onArrayEnd:(v,a)=>{if(M<=v)throw n;b=void 0,r.pop()},onLiteralValue:(v,a,S)=>{if(M<a||(f(v,a,S,D(v)),M<=a+S))throw n},onSeparator:(v,a,S)=>{if(M<=a)throw n;if(v===":"&&b&&b.type==="property")b.colonOffset=a,c=!1,b=void 0;else if(v===","){const I=r[r.length-1];typeof I=="number"?r[r.length-1]=I+1:(c=!0,r[r.length-1]=""),b=void 0}}})}catch(v){if(v!==n)throw v}return{path:r,previousNode:b,isAtPropertyKey:c,matches:v=>{let a=0;for(let S=0;a<v.length&&S<r.length;S++)if(v[a]===r[S]||v[a]==="*")a++;else if(v[a]!=="**")return!1;return a===v.length}}}e.getLocation=w;function i(l,M=[],r=T.DEFAULT){let n=null,b=[];const g=[];function c(v){Array.isArray(b)?b.push(v):n!==null&&(b[n]=v)}return m(l,{onObjectBegin:()=>{const v={};c(v),g.push(b),b=v,n=null},onObjectProperty:v=>{n=v},onObjectEnd:()=>{b=g.pop()},onArrayBegin:()=>{const v=[];c(v),g.push(b),b=v,n=null},onArrayEnd:()=>{b=g.pop()},onLiteralValue:c,onError:(v,a,S)=>{M.push({error:v,offset:a,length:S})}},r),b[0]}e.parse=i;function p(l,M=[],r=T.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(v){n.type==="property"&&(n.length=v-n.offset,n=n.parent)}function g(v){return n.children.push(v),v}m(l,{onObjectBegin:v=>{n=g({type:"object",offset:v,length:-1,parent:n,children:[]})},onObjectProperty:(v,a,S)=>{n=g({type:"property",offset:a,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:v,offset:a,length:S,parent:n})},onObjectEnd:(v,a)=>{n.length=v+a-n.offset,n=n.parent,b(v+a)},onArrayBegin:(v,a)=>{n=g({type:"array",offset:v,length:-1,parent:n,children:[]})},onArrayEnd:(v,a)=>{n.length=v+a-n.offset,n=n.parent,b(v+a)},onLiteralValue:(v,a,S)=>{g({type:D(v),offset:a,length:S,parent:n,value:v}),b(a+S)},onSeparator:(v,a,S)=>{n.type==="property"&&(v===":"?n.colonOffset=a:v===","&&b(a))},onError:(v,a,S)=>{M.push({error:v,offset:a,length:S})}},r);const f=n.children[0];return f&&delete f.parent,f}e.parseTree=p;function o(l,M){if(!l)return;let r=l;for(let n of M)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let b=!1;for(const g of r.children)if(Array.isArray(g.children)&&g.children[0].value===n){r=g.children[1],b=!0;break}if(!b)return}else{const b=n;if(r.type!=="array"||b<0||!Array.isArray(r.children)||b>=r.children.length)return;r=r.children[b]}return r}e.findNodeAtLocation=o;function u(l){if(!l.parent||!l.parent.children)return[];const M=u(l.parent);if(l.parent.type==="property"){const r=l.parent.children[0].value;M.push(r)}else if(l.parent.type==="array"){const r=l.parent.children.indexOf(l);r!==-1&&M.push(r)}return M}e.getNodePath=u;function d(l){switch(l.type){case"array":return l.children.map(d);case"object":{const M=Object.create(null);for(let r of l.children){const n=r.children[1];n&&(M[r.children[0].value]=d(n))}return M}case"null":case"string":case"number":case"boolean":return l.value;default:return}}e.getNodeValue=d;function F(l,M,r=!1){return M>=l.offset&&M<l.offset+l.length||r&&M===l.offset+l.length}e.contains=F;function _(l,M,r=!1){if(F(l,M,r)){const n=l.children;if(Array.isArray(n))for(let b=0;b<n.length&&n[b].offset<=M;b++){const g=_(n[b],M,r);if(g)return g}return l}}e.findNodeAtOffset=_;function m(l,M,r=T.DEFAULT){const n=k(l,!1);function b(ce){return ce?()=>ce(n.getTokenOffset(),n.getTokenLength()):()=>!0}function g(ce){return ce?oe=>ce(oe,n.getTokenOffset(),n.getTokenLength()):()=>!0}const c=b(M.onObjectBegin),f=g(M.onObjectProperty),v=b(M.onObjectEnd),a=b(M.onArrayBegin),S=b(M.onArrayEnd),I=g(M.onLiteralValue),N=g(M.onSeparator),B=b(M.onComment),y=g(M.onError),O=r&&r.disallowComments,z=r&&r.allowTrailingComma;function U(){for(;;){const ce=n.scan();switch(n.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:O||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ce){case 12:case 13:O?$(10):B();break;case 16:$(1);break;case 15:case 14:break;default:return ce}}}function $(ce,oe=[],be=[]){if(y(ce),oe.length+be.length>0){let Pe=n.getToken();for(;Pe!==17;){if(oe.indexOf(Pe)!==-1){U();break}else if(be.indexOf(Pe)!==-1)break;Pe=U()}}}function W(ce){const oe=n.getTokenValue();return ce?I(oe):f(oe),U(),!0}function J(){switch(n.getToken()){case 11:{let ce=0;try{ce=JSON.parse(n.getTokenValue()),typeof ce!="number"&&($(2),ce=0)}catch{$(2)}I(ce);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return U(),!0}function G(){return n.getToken()!==10?($(3,[],[2,5]),!1):(W(!1),n.getToken()===6?(N(":"),U(),Se()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function ae(){c(),U();let ce=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ce||$(4,[],[]),N(","),U(),n.getToken()===2&&z)break}else ce&&$(6,[],[]);G()||$(4,[],[2,5]),ce=!0}return v(),n.getToken()!==2?$(7,[2],[]):U(),!0}function we(){a(),U();let ce=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ce||$(4,[],[]),N(","),U(),n.getToken()===4&&z)break}else ce&&$(6,[],[]);Se()||$(4,[],[4,5]),ce=!0}return S(),n.getToken()!==4?$(8,[4],[]):U(),!0}function Se(){switch(n.getToken()){case 3:return we();case 1:return ae();case 10:return W(!0);default:return J()}}return U(),n.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):Se()?(n.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=m;function h(l,M){let r=k(l),n=[],b,g=0,c;do switch(c=r.getPosition(),b=r.scan(),b){case 12:case 13:case 17:g!==c&&n.push(l.substring(g,c)),M!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,M)),g=r.getPosition();break}while(b!==17);return n.join("")}e.stripComments=h;function D(l){switch(typeof l){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(l){if(Array.isArray(l))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(Re,Ce){for(var pe=0;pe<Ce.length;pe++){var ne=Ce[pe];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Re,ne.key,ne)}}function e(Re,Ce,pe){return Ce&&ee(Re.prototype,Ce),pe&&ee(Re,pe),Re}function s(Re,Ce){if(!!Re){if(typeof Re=="string")return t(Re,Ce);var pe=Object.prototype.toString.call(Re).slice(8,-1);if(pe==="Object"&&Re.constructor&&(pe=Re.constructor.name),pe==="Map"||pe==="Set")return Array.from(Re);if(pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(pe))return t(Re,Ce)}}function t(Re,Ce){(Ce==null||Ce>Re.length)&&(Ce=Re.length);for(var pe=0,ne=new Array(Ce);pe<Ce;pe++)ne[pe]=Re[pe];return ne}function E(Re,Ce){var pe=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(pe)return(pe=pe.call(Re)).next.bind(pe);if(Array.isArray(Re)||(pe=s(Re))||Ce&&Re&&typeof Re.length=="number"){pe&&(Re=pe);var ne=0;return function(){return ne>=Re.length?{done:!0}:{done:!1,value:Re[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var T={exports:{}};function k(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function P(Re){T.exports.defaults=Re}T.exports={defaults:k(),getDefaults:k,changeDefaults:P};var C=/[&<>"']/,A=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,i={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(Ce){return i[Ce]};function o(Re,Ce){if(Ce){if(C.test(Re))return Re.replace(A,p)}else if(R.test(Re))return Re.replace(w,p);return Re}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Re){return Re.replace(u,function(Ce,pe){return pe=pe.toLowerCase(),pe==="colon"?":":pe.charAt(0)==="#"?pe.charAt(1)==="x"?String.fromCharCode(parseInt(pe.substring(2),16)):String.fromCharCode(+pe.substring(1)):""})}var F=/(^|[^\[])\^/g;function _(Re,Ce){Re=Re.source||Re,Ce=Ce||"";var pe={replace:function(le,de){return de=de.source||de,de=de.replace(F,"$1"),Re=Re.replace(le,de),pe},getRegex:function(){return new RegExp(Re,Ce)}};return pe}var m=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(Re,Ce,pe){if(Re){var ne;try{ne=decodeURIComponent(d(pe)).replace(m,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}Ce&&!h.test(pe)&&(pe=b(Ce,pe));try{pe=encodeURI(pe).replace(/%25/g,"%")}catch{return null}return pe}var l={},M=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(Re,Ce){l[" "+Re]||(M.test(Re)?l[" "+Re]=Re+"/":l[" "+Re]=v(Re,"/",!0)),Re=l[" "+Re];var pe=Re.indexOf(":")===-1;return Ce.substring(0,2)==="//"?pe?Ce:Re.replace(r,"$1")+Ce:Ce.charAt(0)==="/"?pe?Ce:Re.replace(n,"$1")+Ce:Re+Ce}var g={exec:function(){}};function c(Re){for(var Ce=1,pe,ne;Ce<arguments.length;Ce++){pe=arguments[Ce];for(ne in pe)Object.prototype.hasOwnProperty.call(pe,ne)&&(Re[ne]=pe[ne])}return Re}function f(Re,Ce){var pe=Re.replace(/\|/g,function(de,me,Te){for(var We=!1,Le=me;--Le>=0&&Te[Le]==="\\";)We=!We;return We?"|":" |"}),ne=pe.split(/ \|/),le=0;if(ne[0].trim()||ne.shift(),ne[ne.length-1].trim()||ne.pop(),ne.length>Ce)ne.splice(Ce);else for(;ne.length<Ce;)ne.push("");for(;le<ne.length;le++)ne[le]=ne[le].trim().replace(/\\\|/g,"|");return ne}function v(Re,Ce,pe){var ne=Re.length;if(ne===0)return"";for(var le=0;le<ne;){var de=Re.charAt(ne-le-1);if(de===Ce&&!pe)le++;else if(de!==Ce&&pe)le++;else break}return Re.substr(0,ne-le)}function a(Re,Ce){if(Re.indexOf(Ce[1])===-1)return-1;for(var pe=Re.length,ne=0,le=0;le<pe;le++)if(Re[le]==="\\")le++;else if(Re[le]===Ce[0])ne++;else if(Re[le]===Ce[1]&&(ne--,ne<0))return le;return-1}function S(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(Re,Ce){if(Ce<1)return"";for(var pe="";Ce>1;)Ce&1&&(pe+=Re),Ce>>=1,Re+=Re;return pe+Re}var N={escape:o,unescape:d,edit:_,cleanUrl:D,resolveUrl:b,noopTest:g,merge:c,splitCells:f,rtrim:v,findClosingBracket:a,checkSanitizeDeprecation:S,repeatString:I},B=T.exports.defaults,y=N.rtrim,O=N.splitCells,z=N.escape,U=N.findClosingBracket;function $(Re,Ce,pe,ne){var le=Ce.href,de=Ce.title?z(Ce.title):null,me=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){ne.state.inLink=!0;var Te={type:"link",raw:pe,href:le,title:de,text:me,tokens:ne.inlineTokens(me,[])};return ne.state.inLink=!1,Te}else return{type:"image",raw:pe,href:le,title:de,text:z(me)}}function W(Re,Ce){var pe=Re.match(/^(\s+)(?:```)/);if(pe===null)return Ce;var ne=pe[1];return Ce.split(`
`).map(function(le){var de=le.match(/^\s+/);if(de===null)return le;var me=de[0];return me.length>=ne.length?le.slice(ne.length):le}).join(`
`)}var J=function(){function Re(pe){this.options=pe||B}var Ce=Re.prototype;return Ce.space=function(ne){var le=this.rules.block.newline.exec(ne);if(le)return le[0].length>1?{type:"space",raw:le[0]}:{raw:`
`}},Ce.code=function(ne){var le=this.rules.block.code.exec(ne);if(le){var de=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?de:y(de,`
`)}}},Ce.fences=function(ne){var le=this.rules.block.fences.exec(ne);if(le){var de=le[0],me=W(de,le[3]||"");return{type:"code",raw:de,lang:le[2]?le[2].trim():le[2],text:me}}},Ce.heading=function(ne){var le=this.rules.block.heading.exec(ne);if(le){var de=le[2].trim();if(/#$/.test(de)){var me=y(de,"#");(this.options.pedantic||!me||/ $/.test(me))&&(de=me.trim())}var Te={type:"heading",raw:le[0],depth:le[1].length,text:de,tokens:[]};return this.lexer.inline(Te.text,Te.tokens),Te}},Ce.hr=function(ne){var le=this.rules.block.hr.exec(ne);if(le)return{type:"hr",raw:le[0]}},Ce.blockquote=function(ne){var le=this.rules.block.blockquote.exec(ne);if(le){var de=le[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(de,[]),text:de}}},Ce.list=function(ne){var le=this.rules.block.list.exec(ne);if(le){var de,me,Te,We,Le,je,it,rt,re,ge,ie=le[1].trim(),V=ie.length>1,ve={type:"list",raw:"",ordered:V,start:V?+ie.slice(0,-1):"",loose:!1,items:[]};ie=V?"\\d{1,9}\\"+ie.slice(-1):"\\"+ie,this.options.pedantic&&(ie=V?ie:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+ie+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ne&&!(this.rules.block.hr.test(ne)||!(le=Ie.exec(ne)));){re=le[2].split(`
`),this.options.pedantic?(We=2,ge=re[0].trimLeft()):(We=le[2].search(/[^ ]/),We=le[1].length+(We>4?1:We),ge=re[0].slice(We-le[1].length)),je=!1,de=le[0],!re[0]&&/^ *$/.test(re[1])&&(de=le[1]+re.slice(0,2).join(`
`)+`
`,ve.loose=!0,re=[]);var Ke=new RegExp("^ {0,"+Math.min(3,We-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<re.length;Le++){if(rt=re[Le],this.options.pedantic&&(rt=rt.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ke.test(rt)){de=le[1]+re.slice(0,Le).join(`
`)+`
`;break}if(!je){rt.trim()||(je=!0),rt.search(/[^ ]/)>=We?ge+=`
`+rt.slice(We):ge+=`
`+rt;continue}if(rt.search(/[^ ]/)>=We||!rt.trim()){ge+=`
`+rt.slice(We);continue}else{de=le[1]+re.slice(0,Le).join(`
`)+`
`;break}}ve.loose||(it?ve.loose=!0:/\n *\n *$/.test(de)&&(it=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ge),me&&(Te=me[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),ve.items.push({type:"list_item",raw:de,task:!!me,checked:Te,loose:!1,text:ge}),ve.raw+=de,ne=ne.slice(de.length)}ve.items[ve.items.length-1].raw=de.trimRight(),ve.items[ve.items.length-1].text=ge.trimRight(),ve.raw=ve.raw.trimRight();var xe=ve.items.length;for(Le=0;Le<xe;Le++)this.lexer.state.top=!1,ve.items[Le].tokens=this.lexer.blockTokens(ve.items[Le].text,[]),ve.items[Le].tokens.some(function(ut){return ut.type==="space"})&&(ve.loose=!0,ve.items[Le].loose=!0);return ve}},Ce.html=function(ne){var le=this.rules.block.html.exec(ne);if(le){var de={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};return this.options.sanitize&&(de.type="paragraph",de.text=this.options.sanitizer?this.options.sanitizer(le[0]):z(le[0]),de.tokens=[],this.lexer.inline(de.text,de.tokens)),de}},Ce.def=function(ne){var le=this.rules.block.def.exec(ne);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var de=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:de,raw:le[0],href:le[2],title:le[3]}}},Ce.table=function(ne){var le=this.rules.block.table.exec(ne);if(le){var de={type:"table",header:O(le[1]).map(function(it){return{text:it}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]?le[3].replace(/\n$/,"").split(`
`):[]};if(de.header.length===de.align.length){de.raw=le[0];var me=de.align.length,Te,We,Le,je;for(Te=0;Te<me;Te++)/^ *-+: *$/.test(de.align[Te])?de.align[Te]="right":/^ *:-+: *$/.test(de.align[Te])?de.align[Te]="center":/^ *:-+ *$/.test(de.align[Te])?de.align[Te]="left":de.align[Te]=null;for(me=de.rows.length,Te=0;Te<me;Te++)de.rows[Te]=O(de.rows[Te],de.header.length).map(function(it){return{text:it}});for(me=de.header.length,We=0;We<me;We++)de.header[We].tokens=[],this.lexer.inlineTokens(de.header[We].text,de.header[We].tokens);for(me=de.rows.length,We=0;We<me;We++)for(je=de.rows[We],Le=0;Le<je.length;Le++)je[Le].tokens=[],this.lexer.inlineTokens(je[Le].text,je[Le].tokens);return de}}},Ce.lheading=function(ne){var le=this.rules.block.lheading.exec(ne);if(le){var de={type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},Ce.paragraph=function(ne){var le=this.rules.block.paragraph.exec(ne);if(le){var de={type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},Ce.text=function(ne){var le=this.rules.block.text.exec(ne);if(le){var de={type:"text",raw:le[0],text:le[0],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},Ce.escape=function(ne){var le=this.rules.inline.escape.exec(ne);if(le)return{type:"escape",raw:le[0],text:z(le[1])}},Ce.tag=function(ne){var le=this.rules.inline.tag.exec(ne);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):z(le[0]):le[0]}},Ce.link=function(ne){var le=this.rules.inline.link.exec(ne);if(le){var de=le[2].trim();if(!this.options.pedantic&&/^</.test(de)){if(!/>$/.test(de))return;var me=y(de.slice(0,-1),"\\");if((de.length-me.length)%2==0)return}else{var Te=U(le[2],"()");if(Te>-1){var We=le[0].indexOf("!")===0?5:4,Le=We+le[1].length+Te;le[2]=le[2].substring(0,Te),le[0]=le[0].substring(0,Le).trim(),le[3]=""}}var je=le[2],it="";if(this.options.pedantic){var rt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(je);rt&&(je=rt[1],it=rt[3])}else it=le[3]?le[3].slice(1,-1):"";return je=je.trim(),/^</.test(je)&&(this.options.pedantic&&!/>$/.test(de)?je=je.slice(1):je=je.slice(1,-1)),$(le,{href:je&&je.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},Ce.reflink=function(ne,le){var de;if((de=this.rules.inline.reflink.exec(ne))||(de=this.rules.inline.nolink.exec(ne))){var me=(de[2]||de[1]).replace(/\s+/g," ");if(me=le[me.toLowerCase()],!me||!me.href){var Te=de[0].charAt(0);return{type:"text",raw:Te,text:Te}}return $(de,me,de[0],this.lexer)}},Ce.emStrong=function(ne,le,de){de===void 0&&(de="");var me=this.rules.inline.emStrong.lDelim.exec(ne);if(!!me&&!(me[3]&&de.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=me[1]||me[2]||"";if(!Te||Te&&(de===""||this.rules.inline.punctuation.exec(de))){var We=me[0].length-1,Le,je,it=We,rt=0,re=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(re.lastIndex=0,le=le.slice(-1*ne.length+We);(me=re.exec(le))!=null;)if(Le=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Le){if(je=Le.length,me[3]||me[4]){it+=je;continue}else if((me[5]||me[6])&&We%3&&!((We+je)%3)){rt+=je;continue}if(it-=je,!(it>0)){if(je=Math.min(je,je+it+rt),Math.min(We,je)%2){var ge=ne.slice(1,We+me.index+je);return{type:"em",raw:ne.slice(0,We+me.index+je+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var ie=ne.slice(2,We+me.index+je-1);return{type:"strong",raw:ne.slice(0,We+me.index+je+1),text:ie,tokens:this.lexer.inlineTokens(ie,[])}}}}}},Ce.codespan=function(ne){var le=this.rules.inline.code.exec(ne);if(le){var de=le[2].replace(/\n/g," "),me=/[^ ]/.test(de),Te=/^ /.test(de)&&/ $/.test(de);return me&&Te&&(de=de.substring(1,de.length-1)),de=z(de,!0),{type:"codespan",raw:le[0],text:de}}},Ce.br=function(ne){var le=this.rules.inline.br.exec(ne);if(le)return{type:"br",raw:le[0]}},Ce.del=function(ne){var le=this.rules.inline.del.exec(ne);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2],[])}},Ce.autolink=function(ne,le){var de=this.rules.inline.autolink.exec(ne);if(de){var me,Te;return de[2]==="@"?(me=z(this.options.mangle?le(de[1]):de[1]),Te="mailto:"+me):(me=z(de[1]),Te=me),{type:"link",raw:de[0],text:me,href:Te,tokens:[{type:"text",raw:me,text:me}]}}},Ce.url=function(ne,le){var de;if(de=this.rules.inline.url.exec(ne)){var me,Te;if(de[2]==="@")me=z(this.options.mangle?le(de[0]):de[0]),Te="mailto:"+me;else{var We;do We=de[0],de[0]=this.rules.inline._backpedal.exec(de[0])[0];while(We!==de[0]);me=z(de[0]),de[1]==="www."?Te="http://"+me:Te=me}return{type:"link",raw:de[0],text:me,href:Te,tokens:[{type:"text",raw:me,text:me}]}}},Ce.inlineText=function(ne,le){var de=this.rules.inline.text.exec(ne);if(de){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):z(de[0]):de[0]:me=z(this.options.smartypants?le(de[0]):de[0]),{type:"text",raw:de[0],text:me}}},Re}(),G=N.noopTest,ae=N.edit,we=N.merge,Se={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:G,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Se._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Se._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Se.def=ae(Se.def).replace("label",Se._label).replace("title",Se._title).getRegex(),Se.bullet=/(?:[*+-]|\d{1,9}[.)])/,Se.listItemStart=ae(/^( *)(bull) */).replace("bull",Se.bullet).getRegex(),Se.list=ae(Se.list).replace(/bull/g,Se.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Se.def.source+")").getRegex(),Se._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Se._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Se.html=ae(Se.html,"i").replace("comment",Se._comment).replace("tag",Se._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Se.paragraph=ae(Se._paragraph).replace("hr",Se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Se._tag).getRegex(),Se.blockquote=ae(Se.blockquote).replace("paragraph",Se.paragraph).getRegex(),Se.normal=we({},Se),Se.gfm=we({},Se.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Se.gfm.table=ae(Se.gfm.table).replace("hr",Se.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Se._tag).getRegex(),Se.pedantic=we({},Se.normal,{html:ae(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Se._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:G,paragraph:ae(Se.normal._paragraph).replace("hr",Se.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Se.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ce={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:G,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:G,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ce._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ce.punctuation=ae(ce.punctuation).replace(/punctuation/g,ce._punctuation).getRegex(),ce.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ce.escapedEmSt=/\\\*|\\_/g,ce._comment=ae(Se._comment).replace("(?:-->|$)","-->").getRegex(),ce.emStrong.lDelim=ae(ce.emStrong.lDelim).replace(/punct/g,ce._punctuation).getRegex(),ce.emStrong.rDelimAst=ae(ce.emStrong.rDelimAst,"g").replace(/punct/g,ce._punctuation).getRegex(),ce.emStrong.rDelimUnd=ae(ce.emStrong.rDelimUnd,"g").replace(/punct/g,ce._punctuation).getRegex(),ce._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ce._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ce._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ce.autolink=ae(ce.autolink).replace("scheme",ce._scheme).replace("email",ce._email).getRegex(),ce._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ce.tag=ae(ce.tag).replace("comment",ce._comment).replace("attribute",ce._attribute).getRegex(),ce._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ce._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ce._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ce.link=ae(ce.link).replace("label",ce._label).replace("href",ce._href).replace("title",ce._title).getRegex(),ce.reflink=ae(ce.reflink).replace("label",ce._label).getRegex(),ce.reflinkSearch=ae(ce.reflinkSearch,"g").replace("reflink",ce.reflink).replace("nolink",ce.nolink).getRegex(),ce.normal=we({},ce),ce.pedantic=we({},ce.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ae(/^!?\[(label)\]\((.*?)\)/).replace("label",ce._label).getRegex(),reflink:ae(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ce._label).getRegex()}),ce.gfm=we({},ce.normal,{escape:ae(ce.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ce.gfm.url=ae(ce.gfm.url,"i").replace("email",ce.gfm._extended_email).getRegex(),ce.breaks=we({},ce.gfm,{br:ae(ce.br).replace("{2,}","*").getRegex(),text:ae(ce.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var oe={block:Se,inline:ce},be=J,Pe=T.exports.defaults,Me=oe.block,He=oe.inline,Ye=N.repeatString;function Qe(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Re){var Ce="",pe,ne,le=Re.length;for(pe=0;pe<le;pe++)ne=Re.charCodeAt(pe),Math.random()>.5&&(ne="x"+ne.toString(16)),Ce+="&#"+ne+";";return Ce}var K=function(){function Re(pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=pe||Pe,this.options.tokenizer=this.options.tokenizer||new be,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:Me.normal,inline:He.normal};this.options.pedantic?(ne.block=Me.pedantic,ne.inline=He.pedantic):this.options.gfm&&(ne.block=Me.gfm,this.options.breaks?ne.inline=He.breaks:ne.inline=He.gfm),this.tokenizer.rules=ne}Re.lex=function(ne,le){var de=new Re(le);return de.lex(ne)},Re.lexInline=function(ne,le){var de=new Re(le);return de.inlineTokens(ne)};var Ce=Re.prototype;return Ce.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},Ce.blockTokens=function(ne,le){var de=this;le===void 0&&(le=[]),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var me,Te,We,Le;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(me=it.call({lexer:de},ne,le))?(ne=ne.substring(me.raw.length),le.push(me),!0):!1}))){if(me=this.tokenizer.space(ne)){ne=ne.substring(me.raw.length),me.type&&le.push(me);continue}if(me=this.tokenizer.code(ne)){ne=ne.substring(me.raw.length),Te=le[le.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):le.push(me);continue}if(me=this.tokenizer.fences(ne)){ne=ne.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.heading(ne)){ne=ne.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.hr(ne)){ne=ne.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.blockquote(ne)){ne=ne.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.list(ne)){ne=ne.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.html(ne)){ne=ne.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.def(ne)){ne=ne.substring(me.raw.length),Te=le[le.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(ne)){ne=ne.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.lheading(ne)){ne=ne.substring(me.raw.length),le.push(me);continue}if(We=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=1/0,rt=ne.slice(1),re=void 0;de.options.extensions.startBlock.forEach(function(ge){re=ge.call({lexer:this},rt),typeof re=="number"&&re>=0&&(it=Math.min(it,re))}),it<1/0&&it>=0&&(We=ne.substring(0,it+1))}(),this.state.top&&(me=this.tokenizer.paragraph(We))){Te=le[le.length-1],Le&&Te.type==="paragraph"?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):le.push(me),Le=We.length!==ne.length,ne=ne.substring(me.raw.length);continue}if(me=this.tokenizer.text(ne)){ne=ne.substring(me.raw.length),Te=le[le.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):le.push(me);continue}if(ne){var je="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return this.state.top=!0,le},Ce.inline=function(ne,le){this.inlineQueue.push({src:ne,tokens:le})},Ce.inlineTokens=function(ne,le){var de=this;le===void 0&&(le=[]);var me,Te,We,Le=ne,je,it,rt;if(this.tokens.links){var re=Object.keys(this.tokens.links);if(re.length>0)for(;(je=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)re.includes(je[0].slice(je[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,je.index)+"["+Ye("a",je[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(je=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,je.index)+"["+Ye("a",je[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(je=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,je.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(it||(rt=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ie){return(me=ie.call({lexer:de},ne,le))?(ne=ne.substring(me.raw.length),le.push(me),!0):!1}))){if(me=this.tokenizer.escape(ne)){ne=ne.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.tag(ne)){ne=ne.substring(me.raw.length),Te=le[le.length-1],Te&&me.type==="text"&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):le.push(me);continue}if(me=this.tokenizer.link(ne)){ne=ne.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(me.raw.length),Te=le[le.length-1],Te&&me.type==="text"&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):le.push(me);continue}if(me=this.tokenizer.emStrong(ne,Le,rt)){ne=ne.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.codespan(ne)){ne=ne.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.br(ne)){ne=ne.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.del(ne)){ne=ne.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.autolink(ne,H)){ne=ne.substring(me.raw.length),le.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(ne,H))){ne=ne.substring(me.raw.length),le.push(me);continue}if(We=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var ie=1/0,V=ne.slice(1),ve=void 0;de.options.extensions.startInline.forEach(function(Ie){ve=Ie.call({lexer:this},V),typeof ve=="number"&&ve>=0&&(ie=Math.min(ie,ve))}),ie<1/0&&ie>=0&&(We=ne.substring(0,ie+1))}(),me=this.tokenizer.inlineText(We,Qe)){ne=ne.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(rt=me.raw.slice(-1)),it=!0,Te=le[le.length-1],Te&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):le.push(me);continue}if(ne){var ge="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return le},e(Re,null,[{key:"rules",get:function(){return{block:Me,inline:He}}}]),Re}(),X=T.exports.defaults,se=N.cleanUrl,q=N.escape,te=function(){function Re(pe){this.options=pe||X}var Ce=Re.prototype;return Ce.code=function(ne,le,de){var me=(le||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(ne,me);Te!=null&&Te!==ne&&(de=!0,ne=Te)}return ne=ne.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+q(me,!0)+'">'+(de?ne:q(ne,!0))+`</code></pre>
`:"<pre><code>"+(de?ne:q(ne,!0))+`</code></pre>
`},Ce.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},Ce.html=function(ne){return ne},Ce.heading=function(ne,le,de,me){return this.options.headerIds?"<h"+le+' id="'+this.options.headerPrefix+me.slug(de)+'">'+ne+"</h"+le+`>
`:"<h"+le+">"+ne+"</h"+le+`>
`},Ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ce.list=function(ne,le,de){var me=le?"ol":"ul",Te=le&&de!==1?' start="'+de+'"':"";return"<"+me+Te+`>
`+ne+"</"+me+`>
`},Ce.listitem=function(ne){return"<li>"+ne+`</li>
`},Ce.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ce.paragraph=function(ne){return"<p>"+ne+`</p>
`},Ce.table=function(ne,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+le+`</table>
`},Ce.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},Ce.tablecell=function(ne,le){var de=le.header?"th":"td",me=le.align?"<"+de+' align="'+le.align+'">':"<"+de+">";return me+ne+"</"+de+`>
`},Ce.strong=function(ne){return"<strong>"+ne+"</strong>"},Ce.em=function(ne){return"<em>"+ne+"</em>"},Ce.codespan=function(ne){return"<code>"+ne+"</code>"},Ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ce.del=function(ne){return"<del>"+ne+"</del>"},Ce.link=function(ne,le,de){if(ne=se(this.options.sanitize,this.options.baseUrl,ne),ne===null)return de;var me='<a href="'+q(ne)+'"';return le&&(me+=' title="'+le+'"'),me+=">"+de+"</a>",me},Ce.image=function(ne,le,de){if(ne=se(this.options.sanitize,this.options.baseUrl,ne),ne===null)return de;var me='<img src="'+ne+'" alt="'+de+'"';return le&&(me+=' title="'+le+'"'),me+=this.options.xhtml?"/>":">",me},Ce.text=function(ne){return ne},Re}(),he=function(){function Re(){}var Ce=Re.prototype;return Ce.strong=function(ne){return ne},Ce.em=function(ne){return ne},Ce.codespan=function(ne){return ne},Ce.del=function(ne){return ne},Ce.html=function(ne){return ne},Ce.text=function(ne){return ne},Ce.link=function(ne,le,de){return""+de},Ce.image=function(ne,le,de){return""+de},Ce.br=function(){return""},Re}(),Ae=function(){function Re(){this.seen={}}var Ce=Re.prototype;return Ce.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ce.getNextSafeSlug=function(ne,le){var de=ne,me=0;if(this.seen.hasOwnProperty(de)){me=this.seen[ne];do me++,de=ne+"-"+me;while(this.seen.hasOwnProperty(de))}return le||(this.seen[ne]=me,this.seen[de]=0),de},Ce.slug=function(ne,le){le===void 0&&(le={});var de=this.serialize(ne);return this.getNextSafeSlug(de,le.dryrun)},Re}(),Ue=te,ze=he,Ge=Ae,et=T.exports.defaults,st=N.unescape,Xe=function(){function Re(pe){this.options=pe||et,this.options.renderer=this.options.renderer||new Ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ze,this.slugger=new Ge}Re.parse=function(ne,le){var de=new Re(le);return de.parse(ne)},Re.parseInline=function(ne,le){var de=new Re(le);return de.parseInline(ne)};var Ce=Re.prototype;return Ce.parse=function(ne,le){le===void 0&&(le=!0);var de="",me,Te,We,Le,je,it,rt,re,ge,ie,V,ve,Ie,Ke,xe,ut,wt,Ct,bt,ft=ne.length;for(me=0;me<ft;me++){if(ie=ne[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ie.type]&&(bt=this.options.extensions.renderers[ie.type].call({parser:this},ie),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ie.type))){de+=bt||"";continue}switch(ie.type){case"space":continue;case"hr":{de+=this.renderer.hr();continue}case"heading":{de+=this.renderer.heading(this.parseInline(ie.tokens),ie.depth,st(this.parseInline(ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{de+=this.renderer.code(ie.text,ie.lang,ie.escaped);continue}case"table":{for(re="",rt="",Le=ie.header.length,Te=0;Te<Le;Te++)rt+=this.renderer.tablecell(this.parseInline(ie.header[Te].tokens),{header:!0,align:ie.align[Te]});for(re+=this.renderer.tablerow(rt),ge="",Le=ie.rows.length,Te=0;Te<Le;Te++){for(it=ie.rows[Te],rt="",je=it.length,We=0;We<je;We++)rt+=this.renderer.tablecell(this.parseInline(it[We].tokens),{header:!1,align:ie.align[We]});ge+=this.renderer.tablerow(rt)}de+=this.renderer.table(re,ge);continue}case"blockquote":{ge=this.parse(ie.tokens),de+=this.renderer.blockquote(ge);continue}case"list":{for(V=ie.ordered,ve=ie.start,Ie=ie.loose,Le=ie.items.length,ge="",Te=0;Te<Le;Te++)xe=ie.items[Te],ut=xe.checked,wt=xe.task,Ke="",xe.task&&(Ct=this.renderer.checkbox(ut),Ie?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=Ct+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=Ct+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:Ct}):Ke+=Ct),Ke+=this.parse(xe.tokens,Ie),ge+=this.renderer.listitem(Ke,wt,ut);de+=this.renderer.list(ge,V,ve);continue}case"html":{de+=this.renderer.html(ie.text);continue}case"paragraph":{de+=this.renderer.paragraph(this.parseInline(ie.tokens));continue}case"text":{for(ge=ie.tokens?this.parseInline(ie.tokens):ie.text;me+1<ft&&ne[me+1].type==="text";)ie=ne[++me],ge+=`
`+(ie.tokens?this.parseInline(ie.tokens):ie.text);de+=le?this.renderer.paragraph(ge):ge;continue}default:{var pt='Token with "'+ie.type+'" type was not found.';if(this.options.silent){console.error(pt);return}else throw new Error(pt)}}}return de},Ce.parseInline=function(ne,le){le=le||this.renderer;var de="",me,Te,We,Le=ne.length;for(me=0;me<Le;me++){if(Te=ne[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(We=this.options.extensions.renderers[Te.type].call({parser:this},Te),We!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){de+=We||"";continue}switch(Te.type){case"escape":{de+=le.text(Te.text);break}case"html":{de+=le.html(Te.text);break}case"link":{de+=le.link(Te.href,Te.title,this.parseInline(Te.tokens,le));break}case"image":{de+=le.image(Te.href,Te.title,Te.text);break}case"strong":{de+=le.strong(this.parseInline(Te.tokens,le));break}case"em":{de+=le.em(this.parseInline(Te.tokens,le));break}case"codespan":{de+=le.codespan(Te.text);break}case"br":{de+=le.br();break}case"del":{de+=le.del(this.parseInline(Te.tokens,le));break}case"text":{de+=le.text(Te.text);break}default:{var je='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return de},Re}(),nt=K,lt=Xe,vt=J,Oe=te,Rt=he,j=Ae,Q=N.merge,fe=N.checkSanitizeDeprecation,Ne=N.escape,Ve=T.exports.getDefaults,ot=T.exports.changeDefaults,ht=T.exports.defaults;function Je(Re,Ce,pe){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof Ce=="function"&&(pe=Ce,Ce=null),Ce=Q({},Je.defaults,Ce||{}),fe(Ce),pe){var ne=Ce.highlight,le;try{le=nt.lex(Re,Ce)}catch(We){return pe(We)}var de=function(Le){var je;if(!Le)try{Ce.walkTokens&&Je.walkTokens(le,Ce.walkTokens),je=lt.parse(le,Ce)}catch(it){Le=it}return Ce.highlight=ne,Le?pe(Le):pe(null,je)};if(!ne||ne.length<3||(delete Ce.highlight,!le.length))return de();var me=0;Je.walkTokens(le,function(We){We.type==="code"&&(me++,setTimeout(function(){ne(We.text,We.lang,function(Le,je){if(Le)return de(Le);je!=null&&je!==We.text&&(We.text=je,We.escaped=!0),me--,me===0&&de()})},0))}),me===0&&de();return}try{var Te=nt.lex(Re,Ce);return Ce.walkTokens&&Je.walkTokens(Te,Ce.walkTokens),lt.parse(Te,Ce)}catch(We){if(We.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+Ne(We.message+"",!0)+"</pre>";throw We}}Je.options=Je.setOptions=function(Re){return Q(Je.defaults,Re),ot(Je.defaults),Je},Je.getDefaults=Ve,Je.defaults=ht,Je.use=function(){for(var Re=this,Ce=arguments.length,pe=new Array(Ce),ne=0;ne<Ce;ne++)pe[ne]=arguments[ne];var le=Q.apply(void 0,[{}].concat(pe)),de=Je.defaults.extensions||{renderers:{},childTokens:{}},me;pe.forEach(function(Te){if(Te.extensions&&(me=!0,Te.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var je=de.renderers?de.renderers[Le.name]:null;je?de.renderers[Le.name]=function(){for(var it=arguments.length,rt=new Array(it),re=0;re<it;re++)rt[re]=arguments[re];var ge=Le.renderer.apply(this,rt);return ge===!1&&(ge=je.apply(this,rt)),ge}:de.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Le.level]?de[Le.level].unshift(Le.tokenizer):de[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?de.startBlock?de.startBlock.push(Le.start):de.startBlock=[Le.start]:Le.level==="inline"&&(de.startInline?de.startInline.push(Le.start):de.startInline=[Le.start]))}Le.childTokens&&(de.childTokens[Le.name]=Le.childTokens)})),Te.renderer&&function(){var Le=Je.defaults.renderer||new Oe,je=function(re){var ge=Le[re];Le[re]=function(){for(var ie=arguments.length,V=new Array(ie),ve=0;ve<ie;ve++)V[ve]=arguments[ve];var Ie=Te.renderer[re].apply(Le,V);return Ie===!1&&(Ie=ge.apply(Le,V)),Ie}};for(var it in Te.renderer)je(it);le.renderer=Le}(),Te.tokenizer&&function(){var Le=Je.defaults.tokenizer||new vt,je=function(re){var ge=Le[re];Le[re]=function(){for(var ie=arguments.length,V=new Array(ie),ve=0;ve<ie;ve++)V[ve]=arguments[ve];var Ie=Te.tokenizer[re].apply(Le,V);return Ie===!1&&(Ie=ge.apply(Le,V)),Ie}};for(var it in Te.tokenizer)je(it);le.tokenizer=Le}(),Te.walkTokens){var We=Je.defaults.walkTokens;le.walkTokens=function(Le){Te.walkTokens.call(Re,Le),We&&We(Le)}}me&&(le.extensions=de),Je.setOptions(le)})},Je.walkTokens=function(Re,Ce){for(var pe=function(){var me=le.value;switch(Ce(me),me.type){case"table":{for(var Te=E(me.header),We;!(We=Te()).done;){var Le=We.value;Je.walkTokens(Le.tokens,Ce)}for(var je=E(me.rows),it;!(it=je()).done;)for(var rt=it.value,re=E(rt),ge;!(ge=re()).done;){var ie=ge.value;Je.walkTokens(ie.tokens,Ce)}break}case"list":{Je.walkTokens(me.items,Ce);break}default:Je.defaults.extensions&&Je.defaults.extensions.childTokens&&Je.defaults.extensions.childTokens[me.type]?Je.defaults.extensions.childTokens[me.type].forEach(function(V){Je.walkTokens(me[V],Ce)}):me.tokens&&Je.walkTokens(me.tokens,Ce)}},ne=E(Re),le;!(le=ne()).done;)pe()},Je.parseInline=function(Re,Ce){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");Ce=Q({},Je.defaults,Ce||{}),fe(Ce);try{var pe=nt.lexInline(Re,Ce);return Ce.walkTokens&&Je.walkTokens(pe,Ce.walkTokens),lt.parseInline(pe,Ce)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+Ne(ne.message+"",!0)+"</pre>";throw ne}},Je.Parser=lt,Je.parser=lt.parse,Je.Renderer=Oe,Je.TextRenderer=Rt,Je.Lexer=nt,Je.lexer=nt.lex,Je.Tokenizer=vt,Je.Slugger=j,Je.parse=Je;var Tt=Je;return Tt}),define(Ee[75],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function s(k,P,C){return Math.min(Math.max(k,P),C)}e.clamp=s;function t(k,P){return(P+k%P)%P}e.rot=t;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class T{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function ee(E){const T=[];typeof E=="number"&&T.push("code/timeOrigin",E);function k(C){T.push(C,Date.now())}function P(){const C=[];for(let A=0;A<T.length;A+=2)C.push({name:T[A],startTime:T[A+1]});return C}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const k of performance.getEntriesByType("mark"))T.push({name:k.name,startTime:Math.round(E+k.startTime)});return T}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function s(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=s(t))}(),define(Ee[76],ye([0,1,17]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(w){w.text="text/plain",w.binary="application/octet-stream",w.unknown="application/unknown",w.markdown="text/markdown",w.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const E={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(w){const i=(0,s.extname)(w),p=E[i.toLowerCase()];return p!==void 0?p:P(w)}e.getMediaOrTextMime=k;function P(w){const i=(0,s.extname)(w);return T[i.toLowerCase()]}e.getMediaMime=P;function C(w){for(const i in T)if(T[i]===w)return i}e.getExtensionForMimeType=C;const A=/^(.+)\/(.+?)(;.+)?$/;function R(w,i){const p=A.exec(w);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:i?void 0:w}e.normalizeMimeType=R}),define(Ee[101],ye([0,1,15,6]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(m){const h=m;return h?[h.on,h.pause,h.resume,h.destroy].every(D=>typeof D=="function"):!1}e.isReadableStream=E;function T(m){const h=m;return h?E(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=T;function k(m,h){return new P(m,h)}e.newWriteableStream=k;class P{constructor(h,D){this.reducer=h,this.options=D,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(D=>this.pendingWritePromises.push(D))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(D=>D(h))}emitError(h){this.listeners.error.length===0?(0,s.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(D=>D(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,D){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(D),this.resume();break;case"end":this.listeners.end.push(D),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(D),this.state.flowing&&this.flowErrors();break}}removeListener(h,D){if(this.state.destroyed)return;let l;switch(h){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const M=l.indexOf(D);M>=0&&l.splice(M,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const D=[...this.pendingWritePromises];this.pendingWritePromises.length=0,D.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(m,h){const D=[];let l;for(;(l=m.read())!==null;)D.push(l);return h(D)}e.consumeReadable=C;function A(m,h,D){const l=[];let M;for(;(M=m.read())!==null&&l.length<D;)l.push(M);return M===null&&l.length>0?h(l):{read:()=>{if(l.length>0)return l.shift();if(typeof M!="undefined"){const r=M;return M=void 0,r}return m.read()}}}e.peekReadable=A;function R(m,h){return new Promise((D,l)=>{const M=[];w(m,{onData:r=>{h&&M.push(r)},onError:r=>{h?l(r):D(void 0)},onEnd:()=>{D(h?h(M):void 0)}})})}e.consumeStream=R;function w(m,h){let D=!1;return m.on("error",l=>{D||h.onError(l)}),m.on("end",()=>{D||h.onEnd()}),m.on("data",l=>{D||h.onData(l)}),(0,t.toDisposable)(()=>D=!0)}e.listenStream=w;function i(m,h){return new Promise((D,l)=>{const M=new t.DisposableStore,r=[],n=c=>{if(r.push(c),r.length>h)return M.dispose(),m.pause(),D({stream:m,buffer:r,ended:!1})},b=c=>l(c),g=()=>D({stream:m,buffer:r,ended:!0});M.add((0,t.toDisposable)(()=>m.removeListener("error",b))),m.on("error",b),M.add((0,t.toDisposable)(()=>m.removeListener("end",g))),m.on("end",g),M.add((0,t.toDisposable)(()=>m.removeListener("data",n))),m.on("data",n)})}e.peekStream=i;function p(m,h){const D=k(h);return D.end(m),D}e.toStream=p;function o(){const m=k(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=o;function u(m){let h=!1;return{read:()=>h?null:(h=!0,m)}}e.toReadable=u;function d(m,h,D){const l=k(D);return w(m,{onData:M=>l.write(h.data(M)),onError:M=>l.error(h.error?h.error(M):M),onEnd:()=>l.end()}),l}e.transform=d;function F(m,h,D){let l=!1;return{read:()=>{const M=h.read();return l?M:(l=!0,M!==null?D([m,M]):m)}}}e.prefixedReadable=F;function _(m,h,D){let l=!1;const M=k(D);return w(h,{onData:r=>l?M.write(r):(l=!0,M.write(D([m,r]))),onError:r=>M.error(r),onEnd:()=>{l||(l=!0,M.write(m)),M.end()}}),M}e.prefixedStream=_}),define(Ee[22],ye([0,1,101]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let E,T;class k{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return t?new k(Buffer.allocUnsafe(f)):new k(new Uint8Array(f))}static wrap(f){return t&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new k(f)}static fromString(f,v){return!(v?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(f)):(E||(E=new TextEncoder),new k(E.encode(f)))}static fromByteArray(f){const v=k.alloc(f.length);for(let a=0,S=f.length;a<S;a++)v.buffer[a]=f[a];return v}static concat(f,v){if(typeof v=="undefined"){v=0;for(let I=0,N=f.length;I<N;I++)v+=f[I].byteLength}const a=k.alloc(v);let S=0;for(let I=0,N=f.length;I<N;I++){const B=f[I];a.set(B,S),S+=B.byteLength}return a}clone(){const f=k.alloc(this.byteLength);return f.set(this),f}toString(){return t?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(f,v){return new k(this.buffer.subarray(f,v))}set(f,v){if(f instanceof k)this.buffer.set(f.buffer,v);else if(f instanceof Uint8Array)this.buffer.set(f,v);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),v);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),v);else throw new Error("Unkown argument 'array'")}readUInt32BE(f){return A(this.buffer,f)}writeUInt32BE(f,v){R(this.buffer,f,v)}readUInt32LE(f){return w(this.buffer,f)}writeUInt32LE(f,v){i(this.buffer,f,v)}readUInt8(f){return p(this.buffer,f)}writeUInt8(f,v){o(this.buffer,f,v)}}e.VSBuffer=k;function P(c,f){return c[f+0]<<0>>>0|c[f+1]<<8>>>0}e.readUInt16LE=P;function C(c,f,v){c[v+0]=f&255,f=f>>>8,c[v+1]=f&255}e.writeUInt16LE=C;function A(c,f){return c[f]*2**24+c[f+1]*2**16+c[f+2]*2**8+c[f+3]}e.readUInt32BE=A;function R(c,f,v){c[v+3]=f,f=f>>>8,c[v+2]=f,f=f>>>8,c[v+1]=f,f=f>>>8,c[v]=f}e.writeUInt32BE=R;function w(c,f){return c[f+0]<<0>>>0|c[f+1]<<8>>>0|c[f+2]<<16>>>0|c[f+3]<<24>>>0}e.readUInt32LE=w;function i(c,f,v){c[v+0]=f&255,f=f>>>8,c[v+1]=f&255,f=f>>>8,c[v+2]=f&255,f=f>>>8,c[v+3]=f&255}e.writeUInt32LE=i;function p(c,f){return c[f]}e.readUInt8=p;function o(c,f,v){c[v]=f}e.writeUInt8=o;function u(c){return s.consumeReadable(c,f=>k.concat(f))}e.readableToBuffer=u;function d(c){return s.toReadable(c)}e.bufferToReadable=d;function F(c){return s.consumeStream(c,f=>k.concat(f))}e.streamToBuffer=F;async function _(c){return c.ended?k.concat(c.buffer):k.concat([...c.buffer,await F(c.stream)])}e.bufferedStreamToBuffer=_;function m(c){return s.toStream(c,f=>k.concat(f))}e.bufferToStream=m;function h(c){return s.transform(c,{data:f=>typeof f=="string"?k.fromString(f):k.wrap(f)},f=>k.concat(f))}e.streamToBufferReadableStream=h;function D(c){return s.newWriteableStream(f=>k.concat(f),c)}e.newWriteableBufferStream=D;function l(c,f){return s.prefixedReadable(c,f,v=>k.concat(v))}e.prefixedBufferReadable=l;function M(c,f){return s.prefixedStream(c,f,v=>k.concat(v))}e.prefixedBufferStream=M;function r(c){let f=0,v=0,a=0;const S=new Uint8Array(Math.floor(c.length/4*3)),I=B=>{switch(v){case 3:S[a++]=f|B,v=0;break;case 2:S[a++]=f|B>>>2,f=B<<6,v=3;break;case 1:S[a++]=f|B>>>4,f=B<<4,v=2;break;default:f=B<<2,v=1}};for(let B=0;B<c.length;B++){const y=c.charCodeAt(B);if(y>=65&&y<=90)I(y-65);else if(y>=97&&y<=122)I(y-97+26);else if(y>=48&&y<=57)I(y-48+52);else if(y===43||y===45)I(62);else if(y===47||y===95)I(63);else{if(y===61)break;throw new SyntaxError(`Unexpected base64 character ${c[B]}`)}}const N=a;for(;v>0;)I(0);return k.wrap(S).slice(0,N)}e.decodeBase64=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:c},f=!0,v=!1){const a=v?b:n;let S="";const I=c.byteLength%3;let N=0;for(;N<c.byteLength-I;N+=3){const B=c[N+0],y=c[N+1],O=c[N+2];S+=a[B>>>2],S+=a[(B<<4|y>>>4)&63],S+=a[(y<<2|O>>>6)&63],S+=a[O&63]}if(I===1){const B=c[N+0];S+=a[B>>>2],S+=a[B<<4&63],f&&(S+="==")}else if(I===2){const B=c[N+0],y=c[N+1];S+=a[B>>>2],S+=a[(B<<4|y>>>4)&63],S+=a[y<<2&63],f&&(S+="=")}return S}e.encodeBase64=g});var Ze=this&&this.__classPrivateFieldSet||function(ee,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!E:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(ee,s):E?E.value=s:e.set(ee,s),s},ke=this&&this.__classPrivateFieldGet||function(ee,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(ee):t?t.value:e.get(ee)};define(Ee[21],ye([0,1,16,9]),function(ee,e,s,t){"use strict";var E,T,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(r,n,b){let g=r.get(n);return g===void 0&&(g=b,r.set(n,g)),g}e.getOrSet=P;function C(r){const n=[];return r.forEach((b,g)=>{n.push(`${g} => ${b}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=C;function A(r){const n=[];return r.forEach(b=>{n.push(b)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=A;class R{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const b=n.charCodeAt(0),g=this._value.charCodeAt(this._pos);return b-g}value(){return this._value[this._pos]}}e.StringIterator=R;class w{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class i{constructor(n=!0,b=!0){this._splitOnBackslash=n,this._caseSensitive=b}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let b=n.length-1;b>=0;b--,this._valueLen--){const g=this._value.charCodeAt(b);if(!(g===47||this._splitOnBackslash&&g===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const b=this._value.charCodeAt(this._to);if(b===47||this._splitOnBackslash&&b===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=i;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class o{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new i(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(d||(d={}));class F{constructor(n){this._iter=n}static forUris(n=()=>!1){return new F(new o(n))}static forPaths(n=!1){return new F(new i(void 0,!n))}static forStrings(){return new F(new R)}static forConfigKeys(){return new F(new w)}clear(){this._root=void 0}fill(n,b){if(b){const g=b.slice(0);(0,s.shuffle)(g);for(let c of g)this.set(c,n)}else{const g=n.slice(0);(0,s.shuffle)(g);for(let c of g)this.set(c[0],c[1])}}set(n,b){const g=this._iter.reset(n);let c;this._root||(this._root=new u,this._root.segment=g.value());const f=[];for(c=this._root;;){const a=g.cmp(c.segment);if(a>0)c.left||(c.left=new u,c.left.segment=g.value()),f.push([-1,c]),c=c.left;else if(a<0)c.right||(c.right=new u,c.right.segment=g.value()),f.push([1,c]),c=c.right;else if(g.hasNext())g.next(),c.mid||(c.mid=new u,c.mid.segment=g.value()),f.push([0,c]),c=c.mid;else break}const v=c.value;c.value=b,c.key=n;for(let a=f.length-1;a>=0;a--){const S=f[a][1];S.updateHeight();const I=S.balanceFactor();if(I<-1||I>1){const N=f[a][0],B=f[a+1][0];if(N===1&&B===1)f[a][1]=S.rotateLeft();else if(N===-1&&B===-1)f[a][1]=S.rotateRight();else if(N===1&&B===-1)S.right=f[a+1][1]=f[a+1][1].rotateRight(),f[a][1]=S.rotateLeft();else if(N===-1&&B===1)S.left=f[a+1][1]=f[a+1][1].rotateLeft(),f[a][1]=S.rotateRight();else throw new Error;if(a>0)switch(f[a-1][0]){case-1:f[a-1][1].left=f[a][1];break;case 1:f[a-1][1].right=f[a][1];break;case 0:f[a-1][1].mid=f[a][1];break}else this._root=f[0][1]}}return v}get(n){return this._getNode(n)?.value}_getNode(n){const b=this._iter.reset(n);let g=this._root;for(;g;){const c=b.cmp(g.segment);if(c>0)g=g.left;else if(c<0)g=g.right;else if(b.hasNext())b.next(),g=g.mid;else break}return g}has(n){const b=this._getNode(n);return!(b?.value===void 0&&b?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,b){const g=this._iter.reset(n),c=[];let f=this._root;for(;f;){const v=g.cmp(f.segment);if(v>0)c.push([-1,f]),f=f.left;else if(v<0)c.push([1,f]),f=f.right;else if(g.hasNext())g.next(),c.push([0,f]),f=f.mid;else break}if(!!f){if(b?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const v=this._min(f.right),{key:a,value:S,segment:I}=v;this._delete(v.key,!1),f.key=a,f.value=S,f.segment=I}else{const v=f.left??f.right;if(c.length>0){const[a,S]=c[c.length-1];switch(a){case-1:S.left=v;break;case 0:S.mid=v;break;case 1:S.right=v;break}}else this._root=v}for(let v=c.length-1;v>=0;v--){const a=c[v][1];a.updateHeight();const S=a.balanceFactor();if(S>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),c[v][1]=a.rotateLeft()):S<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),c[v][1]=a.rotateRight()),v>0)switch(c[v-1][0]){case-1:c[v-1][1].left=c[v][1];break;case 1:c[v-1][1].right=c[v][1];break;case 0:c[v-1][1].mid=c[v][1];break}else this._root=c[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const b=this._iter.reset(n);let g=this._root,c;for(;g;){const f=b.cmp(g.segment);if(f>0)g=g.left;else if(f<0)g=g.right;else if(b.hasNext())b.next(),c=g.value||c,g=g.mid;else break}return g&&g.value||c}findSuperstr(n){const b=this._iter.reset(n);let g=this._root;for(;g;){const c=b.cmp(g.segment);if(c>0)g=g.left;else if(c<0)g=g.right;else if(b.hasNext())b.next(),g=g.mid;else return g.mid?this._entries(g.mid):void 0}}forEach(n){for(const[b,g]of this)n(g,b)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=b=>{if(!b)return!0;const g=b.balanceFactor();return g<-1||g>1?!1:n(b.left)&&n(b.right)};return n(this._root)}}e.TernarySearchTree=F;class _{constructor(n,b){this.uri=n,this.value=b}}class m{constructor(n,b){this[E]="ResourceMap",n instanceof m?(this.map=new Map(n.map),this.toKey=b??m.defaultToKey):(this.map=new Map,this.toKey=n??m.defaultToKey)}set(n,b){return this.map.set(this.toKey(n),new _(n,b)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,b){typeof b!="undefined"&&(n=n.bind(b));for(let[g,c]of this.map)n(c.value,c.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=m,m.defaultToKey=r=>r.toString();var h;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class D{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,b=0){const g=this._map.get(n);if(!!g)return b!==0&&this.touch(g,b),g.value}set(n,b,g=0){let c=this._map.get(n);if(c)c.value=b,g!==0&&this.touch(c,g);else{switch(c={key:n,value:b,next:void 0,previous:void 0},g){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(n,c),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const b=this._map.get(n);if(!!b)return this._map.delete(n),this.removeItem(b),this._size--,b.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,b){const g=this._state;let c=this._head;for(;c;){if(b?n.bind(b)(c.value,c.key,this):n(c.value,c.key,this),this._state!==g)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,b=this._state;let g=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==b)throw new Error("LinkedMap got modified during iteration.");if(g){const f={value:g.key,done:!1};return g=g.next,f}else return{value:void 0,done:!0}}};return c}values(){const n=this,b=this._state;let g=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==b)throw new Error("LinkedMap got modified during iteration.");if(g){const f={value:g.value,done:!1};return g=g.next,f}else return{value:void 0,done:!0}}};return c}entries(){const n=this,b=this._state;let g=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==b)throw new Error("LinkedMap got modified during iteration.");if(g){const f={value:[g.key,g.value],done:!1};return g=g.next,f}else return{value:void 0,done:!0}}};return c}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let b=this._head,g=this.size;for(;b&&g>n;)this._map.delete(b.key),b=b.next,g--;this._head=b,this._size=g,b&&(b.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const b=n.next,g=n.previous;if(!b||!g)throw new Error("Invalid list");b.previous=g,g.next=b}n.next=void 0,n.previous=void 0,this._state++}touch(n,b){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(n===this._head)return;const g=n.next,c=n.previous;n===this._tail?(c.next=void 0,this._tail=c):(g.previous=c,c.next=g),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(b===2){if(n===this._tail)return;const g=n.next,c=n.previous;n===this._head?(g.previous=void 0,this._head=g):(g.previous=c,c.next=g),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((b,g)=>{n.push([g,b])}),n}fromJSON(n){this.clear();for(const[b,g]of n)this.set(b,g)}}e.LinkedMap=D;class l extends D{constructor(n,b=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,b),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,b=2){return super.get(n,b)}peek(n){return super.get(n,0)}set(n,b){return super.set(n,b,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class M{constructor(n){k.set(this,void 0),Ze(this,k,n,"f")}get size(){return ke(this,k,"f").size}forEach(n,b){ke(this,k,"f").forEach(n,b)}get(n){return ke(this,k,"f").get(n)}has(n){return ke(this,k,"f").has(n)}entries(){return ke(this,k,"f").entries()}keys(){return ke(this,k,"f").keys()}values(){return ke(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return ke(this,k,"f").entries()}}e.ReadonlyMapView=M}),define(Ee[102],ye([0,1,21,9]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...q){return function(te,he){for(let Ae=0,Ue=q.length;Ae<Ue;Ae++){const ze=q[Ae](te,he);if(ze)return ze}return null}}e.or=E,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(q,te,he){if(!he||he.length<te.length)return null;let Ae;return q?Ae=t.startsWithIgnoreCase(he,te):Ae=he.indexOf(te)===0,Ae?te.length>0?[{start:0,end:te.length}]:[]:null}function k(q,te){const he=te.toLowerCase().indexOf(q.toLowerCase());return he===-1?null:[{start:he,end:he+q.length}]}e.matchesContiguousSubString=k;function P(q,te){return C(q.toLowerCase(),te.toLowerCase(),0,0)}e.matchesSubString=P;function C(q,te,he,Ae){if(he===q.length)return[];if(Ae===te.length)return null;if(q[he]===te[Ae]){let Ue=null;return(Ue=C(q,te,he+1,Ae+1))?F({start:Ae,end:Ae+1},Ue):null}return C(q,te,he,Ae+1)}function A(q){return 97<=q&&q<=122}function R(q){return 65<=q&&q<=90}e.isUpper=R;function w(q){return 48<=q&&q<=57}function i(q){return q===32||q===9||q===10||q===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(q=>p.add(q.charCodeAt(0)));function o(q){return i(q)||p.has(q)}function u(q,te){return q===te||o(q)&&o(te)}function d(q){return A(q)||R(q)||w(q)}function F(q,te){return te.length===0?te=[q]:q.end===te[0].start?te[0].start=q.start:te.unshift(q),te}function _(q,te){for(let he=te;he<q.length;he++){const Ae=q.charCodeAt(he);if(R(Ae)||w(Ae)||he>0&&!d(q.charCodeAt(he-1)))return he}return q.length}function m(q,te,he,Ae){if(he===q.length)return[];if(Ae===te.length)return null;if(q[he]!==te[Ae].toLowerCase())return null;{let Ue=null,ze=Ae+1;for(Ue=m(q,te,he+1,Ae+1);!Ue&&(ze=_(te,ze))<te.length;)Ue=m(q,te,he+1,ze),ze++;return Ue===null?null:F({start:Ae,end:Ae+1},Ue)}}function h(q){let te=0,he=0,Ae=0,Ue=0,ze=0;for(let nt=0;nt<q.length;nt++)ze=q.charCodeAt(nt),R(ze)&&te++,A(ze)&&he++,d(ze)&&Ae++,w(ze)&&Ue++;const Ge=te/q.length,et=he/q.length,st=Ae/q.length,Xe=Ue/q.length;return{upperPercent:Ge,lowerPercent:et,alphaPercent:st,numericPercent:Xe}}function D(q){const{upperPercent:te,lowerPercent:he}=q;return he===0&&te>.6}function l(q){const{upperPercent:te,lowerPercent:he,alphaPercent:Ae,numericPercent:Ue}=q;return he>.2&&te<.8&&Ae>.6&&Ue<.2}function M(q){let te=0,he=0,Ae=0,Ue=0;for(let ze=0;ze<q.length;ze++)Ae=q.charCodeAt(ze),R(Ae)&&te++,A(Ae)&&he++,i(Ae)&&Ue++;return(te===0||he===0)&&Ue===0?q.length<=30:te<=5}function r(q,te){if(!te||(te=te.trim(),te.length===0)||!M(q)||te.length>60)return null;const he=h(te);if(!l(he)){if(!D(he))return null;te=te.toLowerCase()}let Ae=null,Ue=0;for(q=q.toLowerCase();Ue<te.length&&(Ae=m(q,te,0,Ue))===null;)Ue=_(te,Ue+1);return Ae}e.matchesCamelCase=r;function n(q,te,he=!1){if(!te||te.length===0)return null;let Ae=null,Ue=0;for(q=q.toLowerCase(),te=te.toLowerCase();Ue<te.length&&(Ae=b(q,te,0,Ue,he))===null;)Ue=g(te,Ue+1);return Ae}e.matchesWords=n;function b(q,te,he,Ae,Ue){if(he===q.length)return[];if(Ae===te.length)return null;if(u(q.charCodeAt(he),te.charCodeAt(Ae))){let ze=null,Ge=Ae+1;if(ze=b(q,te,he+1,Ae+1,Ue),!Ue)for(;!ze&&(Ge=g(te,Ge))<te.length;)ze=b(q,te,he+1,Ge,Ue),Ge++;return ze===null?null:F({start:Ae,end:Ae+1},ze)}else return null}function g(q,te){for(let he=te;he<q.length;he++)if(o(q.charCodeAt(he))||he>0&&o(q.charCodeAt(he-1)))return he;return q.length}const c=E(e.matchesPrefix,r,k),f=E(e.matchesPrefix,r,P),v=new s.LRUCache(1e4);function a(q,te,he=!1){if(typeof q!="string"||typeof te!="string")return null;let Ae=v.get(q);Ae||(Ae=new RegExp(t.convertSimple2RegExpPattern(q),"i"),v.set(q,Ae));const Ue=Ae.exec(te);return Ue?[{start:Ue.index,end:Ue.index+Ue[0].length}]:he?f(q,te):c(q,te)}e.matchesFuzzy=a;function S(q,te){const he=He(q,q.toLowerCase(),0,te,te.toLowerCase(),0,!0);return he?N(he):null}e.matchesFuzzy2=S;function I(q,te,he,Ae,Ue,ze){const Ge=Math.min(13,q.length);for(;he<Ge;he++){const et=He(q,te,he,Ae,Ue,ze,!1);if(et)return et}return[0,ze]}e.anyScore=I;function N(q){if(typeof q=="undefined")return[];const te=[],he=q[1];for(let Ae=q.length-1;Ae>1;Ae--){const Ue=q[Ae]+he,ze=te[te.length-1];ze&&ze.end===Ue?ze.end=Ue+1:te.push({start:Ue,end:Ue+1})}return te}e.createMatches=N;const B=128;function y(){const q=[],te=[];for(let he=0;he<=B;he++)te[he]=0;for(let he=0;he<=B;he++)q.push(te.slice(0));return q}function O(q){const te=[];for(let he=0;he<=q;he++)te[he]=0;return te}const z=O(2*B),U=O(2*B),$=y(),W=y(),J=y(),G=!1;function ae(q,te,he,Ae,Ue){function ze(et,st,Xe=" "){for(;et.length<st;)et=Xe+et;return et}let Ge=` |   |${Ae.split("").map(et=>ze(et,3)).join("|")}
`;for(let et=0;et<=he;et++)et===0?Ge+=" |":Ge+=`${te[et-1]}|`,Ge+=q[et].slice(0,Ue+1).map(st=>ze(st.toString(),3)).join("|")+`
`;return Ge}function we(q,te,he,Ae){q=q.substr(te),he=he.substr(Ae),console.log(ae(W,q,q.length,he,he.length)),console.log(ae(J,q,q.length,he,he.length)),console.log(ae($,q,q.length,he,he.length))}function Se(q,te){if(te<0||te>=q.length)return!1;const he=q.codePointAt(te);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(he)}}function ce(q,te){if(te<0||te>=q.length)return!1;switch(q.charCodeAt(te)){case 32:case 9:return!0;default:return!1}}function oe(q,te,he){return te[q]!==he[q]}function be(q,te,he,Ae,Ue,ze,Ge=!1){for(;te<he&&Ue<ze;)q[te]===Ae[Ue]&&(Ge&&(z[te]=Ue),te+=1),Ue+=1;return te===he}e.isPatternInWord=be;var Pe;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Pe||(Pe={}));var Me;(function(q){q.Default=[-100,0];function te(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}q.isDefault=te})(Me=e.FuzzyScore||(e.FuzzyScore={}));function He(q,te,he,Ae,Ue,ze,Ge){const et=q.length>B?B:q.length,st=Ae.length>B?B:Ae.length;if(he>=et||ze>=st||et-he>st-ze||!be(te,he,et,Ue,ze,st,!0))return;Ye(et,st,he,ze,te,Ue);let Xe=1,nt=1,lt=he,vt=ze;const Oe=[!1];for(Xe=1,lt=he;lt<et;Xe++,lt++){const Ne=z[lt],Ve=U[lt],ot=lt+1<et?U[lt+1]:st;for(nt=Ne-ze+1,vt=Ne;vt<ot;nt++,vt++){let ht=Number.MIN_SAFE_INTEGER,Je=!1;vt<=Ve&&(ht=Qe(q,te,lt,he,Ae,Ue,vt,st,ze,$[Xe-1][nt-1]===0,Oe));let Tt=0;ht!==Number.MAX_SAFE_INTEGER&&(Je=!0,Tt=ht+W[Xe-1][nt-1]);const Re=vt>Ne,Ce=Re?W[Xe][nt-1]+($[Xe][nt-1]>0?-5:0):0,pe=vt>Ne+1&&$[Xe][nt-1]>0,ne=pe?W[Xe][nt-2]+($[Xe][nt-2]>0?-5:0):0;if(pe&&(!Re||ne>=Ce)&&(!Je||ne>=Tt))W[Xe][nt]=ne,J[Xe][nt]=3,$[Xe][nt]=0;else if(Re&&(!Je||Ce>=Tt))W[Xe][nt]=Ce,J[Xe][nt]=2,$[Xe][nt]=0;else if(Je)W[Xe][nt]=Tt,J[Xe][nt]=1,$[Xe][nt]=$[Xe-1][nt-1]+1;else throw new Error("not possible")}}if(G&&we(q,he,Ae,ze),!Oe[0]&&!Ge)return;Xe--,nt--;const Rt=[W[Xe][nt],ze];let j=0,Q=0;for(;Xe>=1;){let Ne=nt;do{const Ve=J[Xe][Ne];if(Ve===3)Ne=Ne-2;else if(Ve===2)Ne=Ne-1;else break}while(Ne>=1);j>1&&te[he+Xe-1]===Ue[ze+nt-1]&&!oe(Ne+ze-1,Ae,Ue)&&j+1>$[Xe][Ne]&&(Ne=nt),Ne===nt?j++:j=1,Q||(Q=Ne),Xe--,nt=Ne-1,Rt.push(nt)}st===et&&(Rt[0]+=2);const fe=Q-et;return Rt[0]-=fe,Rt}e.fuzzyScore=He;function Ye(q,te,he,Ae,Ue,ze){let Ge=q-1,et=te-1;for(;Ge>=he&&et>=Ae;)Ue[Ge]===ze[et]&&(U[Ge]=et,Ge--),et--}function Qe(q,te,he,Ae,Ue,ze,Ge,et,st,Xe,nt){if(te[he]!==ze[Ge])return Number.MIN_SAFE_INTEGER;let lt=1,vt=!1;return Ge===he-Ae?lt=q[he]===Ue[Ge]?7:5:oe(Ge,Ue,ze)&&(Ge===0||!oe(Ge-1,Ue,ze))?(lt=q[he]===Ue[Ge]?7:5,vt=!0):Se(ze,Ge)&&(Ge===0||!Se(ze,Ge-1))?lt=5:(Se(ze,Ge-1)||ce(ze,Ge-1))&&(lt=5,vt=!0),lt>1&&he===Ae&&(nt[0]=!0),vt||(vt=oe(Ge,Ue,ze)||Se(ze,Ge-1)||ce(ze,Ge-1)),he===Ae?Ge>st&&(lt-=vt?3:5):Xe?lt+=vt?2:0:lt+=vt?0:1,Ge+1===et&&(lt-=vt?3:5),lt}function H(q,te,he,Ae,Ue,ze,Ge){return X(q,te,he,Ae,Ue,ze,!0,Ge)}e.fuzzyScoreGracefulAggressive=H;function K(q,te,he,Ae,Ue,ze,Ge){return X(q,te,he,Ae,Ue,ze,!1,Ge)}e.fuzzyScoreGraceful=K;function X(q,te,he,Ae,Ue,ze,Ge,et){let st=He(q,te,he,Ae,Ue,ze,et);if(st&&!Ge)return st;if(q.length>=3){const Xe=Math.min(7,q.length-1);for(let nt=he+1;nt<Xe;nt++){const lt=se(q,nt);if(lt){const vt=He(lt,lt.toLowerCase(),he,Ae,Ue,ze,et);vt&&(vt[0]-=3,(!st||vt[0]>st[0])&&(st=vt))}}}return st}function se(q,te){if(te+1>=q.length)return;const he=q[te],Ae=q[te+1];if(he!==Ae)return q.slice(0,te)+Ae+he+q.slice(te+2)}}),define(Ee[103],ye([0,1,52,102,9]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(s.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${T.source}`,"g");function C(d){return d.replace(P,(F,_)=>_?F:`\\${F}`)}e.escapeIcons=C;const A=new RegExp(`\\\\${T.source}`,"g");function R(d){return d.replace(A,F=>`\\${F}`)}e.markdownEscapeEscapedIcons=R;const w=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function i(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(w,(F,_,m,h)=>m?F:_||h||"")}e.stripIcons=i;function p(d){const F=d.indexOf(e.iconStartMarker);return F===-1?{text:d}:o(d,F)}e.parseLabelWithIcons=p;function o(d,F){const _=[];let m="";function h(c){if(c){m+=c;for(const f of c)_.push(M)}}let D=-1,l="",M=0,r,n,b=F;const g=d.length;for(h(d.substr(0,F));b<g;)r=d[b],n=d[b+1],r===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(D=b,h(l),l=e.iconStartMarker,b++):r===")"&&D!==-1?(M+=b-D+1,D=-1,l=""):D!==-1?k.test(r)?l+=r:(h(l),D=-1,l=""):h(r),b++;return h(l),{text:m,iconOffsets:_}}function u(d,F,_=!1){const{text:m,iconOffsets:h}=F;if(!h||h.length===0)return(0,t.matchesFuzzy)(d,m,_);const D=(0,E.ltrim)(m," "),l=m.length-D.length,M=(0,t.matchesFuzzy)(d,D,_);if(M)for(const r of M){const n=h[r.start+l]+l;r.start+=n,r.end+=n}return M}e.matchesFuzzyIconAware=u}),define(Ee[77],ye([0,1,15,103]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class T{constructor(p="",o=!1){if(this.value=p,typeof this.value!="string")throw(0,s.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(p,o=0){return this.value+=A(this.supportThemeIcons?(0,t.escapeIcons)(p):p).replace(/([ \t]+)/g,(u,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,o){return this.value+="\n```",this.value+=p,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=T;function k(i){return P(i)?!i.value:Array.isArray(i)?i.every(k):!0}e.isEmptyMarkdownString=k;function P(i){return i instanceof T?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function C(i,p){return i===p?!0:!i||!p?!1:i.value===p.value&&i.isTrusted===p.isTrusted&&i.supportThemeIcons===p.supportThemeIcons}e.markdownStringEqual=C;function A(i){return i.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function R(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function w(i){const p=[],o=i.split("|").map(d=>d.trim());i=o[0];const u=o[1];if(u){const d=/height=(\d+)/.exec(u),F=/width=(\d+)/.exec(u),_=d?d[1]:"",m=F?F[1]:"",h=isFinite(parseInt(m)),D=isFinite(parseInt(_));h&&p.push(`width="${m}"`),D&&p.push(`height="${_}"`)}return{href:i,dimensions:p}}e.parseHrefAndDimensions=w}),define(Ee[34],ye([0,1,9]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(t||(t={})),function(E){const T="error",k="warning",P="warn",C="info",A="ignore";function R(i){return i?s.equalsIgnoreCase(T,i)?E.Error:s.equalsIgnoreCase(k,i)||s.equalsIgnoreCase(P,i)?E.Warning:s.equalsIgnoreCase(C,i)?E.Info:E.Ignore:E.Ignore}E.fromValue=R;function w(i){switch(i){case E.Error:return T;case E.Warning:return k;case E.Info:return C;default:return A}}E.toString=w}(t||(t={})),e.default=t}),define(Ee[35],ye([0,1,17,23,9,10]),function(ee,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(b){return b===47||b===92}e.isPathSeparator=k;function P(b){return b.replace(/[\\/]/g,s.posix.sep)}e.toSlashes=P;function C(b){return b.indexOf("/")===-1&&(b=P(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}e.toPosixPath=C;function A(b,g=s.posix.sep){if(!b)return"";const c=b.length,f=b.charCodeAt(0);if(k(f)){if(k(b.charCodeAt(1))&&!k(b.charCodeAt(2))){let a=3;const S=a;for(;a<c&&!k(b.charCodeAt(a));a++);if(S!==a&&!k(b.charCodeAt(a+1))){for(a+=1;a<c;a++)if(k(b.charCodeAt(a)))return b.slice(0,a+1).replace(/[\\/]/g,g)}}return g}else if(F(f)&&b.charCodeAt(1)===58)return k(b.charCodeAt(2))?b.slice(0,2)+g:b.slice(0,2);let v=b.indexOf("://");if(v!==-1){for(v+=3;v<c;v++)if(k(b.charCodeAt(v)))return b.slice(0,v+1)}return""}e.getRoot=A;function R(b){if(!t.isWindows||!b||b.length<5)return!1;let g=b.charCodeAt(0);if(g!==92||(g=b.charCodeAt(1),g!==92))return!1;let c=2;const f=c;for(;c<b.length&&(g=b.charCodeAt(c),g!==92);c++);return!(f===c||(g=b.charCodeAt(c+1),isNaN(g)||g===92))}e.isUNC=R;const w=/[\\/:\*\?"<>\|]/g,i=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(b,g=t.isWindows){const c=g?w:i;return!(!b||b.length===0||/^\s+$/.test(b)||(c.lastIndex=0,c.test(b))||g&&p.test(b)||b==="."||b===".."||g&&b[b.length-1]==="."||g&&b.length!==b.trim().length||b.length>255)}e.isValidBasename=o;function u(b,g,c){const f=b===g;return!c||f?f:!b||!g?!1:(0,E.equalsIgnoreCase)(b,g)}e.isEqual=u;function d(b,g,c,f=s.sep){if(b===g)return!0;if(!b||!g||g.length>b.length)return!1;if(c){if(!(0,E.startsWithIgnoreCase)(b,g))return!1;if(g.length===b.length)return!0;let a=g.length;return g.charAt(g.length-1)===f&&a--,b.charAt(a)===f}return g.charAt(g.length-1)!==f&&(g+=f),b.indexOf(g)===0}e.isEqualOrParent=d;function F(b){return b>=65&&b<=90||b>=97&&b<=122}e.isWindowsDriveLetter=F;function _(b,g){return t.isWindows&&b.endsWith(":")&&(b+=s.sep),(0,s.isAbsolute)(b)||(b=(0,s.join)(g,b)),b=(0,s.normalize)(b),t.isWindows?(b=(0,E.rtrim)(b,s.sep),b.endsWith(":")&&(b+=s.sep)):(b=(0,E.rtrim)(b,s.sep),b||(b=s.sep)),b}e.sanitizeFilePath=_;function m(b){const g=(0,s.normalize)(b);return t.isWindows?b.length>3?!1:h(g)&&(b.length===2||g.charCodeAt(2)===92):g===s.posix.sep}e.isRootOrDriveLetter=m;function h(b,g){return(g!==void 0?g:t.isWindows)?F(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function D(b){return h(b)?b[0]:void 0}e.getDriveLetter=D;function l(b,g,c){return g.length>b.length?-1:b===g?0:(c&&(b=b.toLowerCase(),g=g.toLowerCase()),b.indexOf(g))}e.indexOfPath=l;function M(b){const g=b.split(":");let c,f,v;for(const a of g){const S=Number(a);(0,T.isNumber)(S)?f===void 0?f=S:v===void 0&&(v=S):c=c?[c,a].join(":"):a}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:f!==void 0?f:void 0,column:v!==void 0?v:f!==void 0?1:void 0}}e.parseLineAndColumnAware=M;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(b,g,c=8){let f="";for(let a=0;a<c;a++)f+=r.charAt(Math.floor(Math.random()*r.length));let v;return g?v=`${g}-${f}`:v=f,b?(0,s.join)(b,v):v}e.randomPath=n}),define(Ee[55],ye([0,1,22,9,2]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(R){return JSON.stringify(R,C)}e.stringify=T;function k(R){let w=JSON.parse(R);return w=A(w),w}e.parse=k;var P;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function C(R,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,t.regExpFlags)(w)}:w}function A(R,w=0){if(!R||w>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return E.URI.revive(R);case 2:return new RegExp(R.source,R.flags)}if(R instanceof s.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let i=0;i<R.length;++i)R[i]=A(R[i],w+1);else for(const i in R)Object.hasOwnProperty.call(R,i)&&(R[i]=A(R[i],w+1))}return R}e.revive=A}),define(Ee[11],ye([0,1,23,2]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(E=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,A,R){this._hosts[C]=A,this._ports[C]=R}setConnectionToken(C,A){this._connectionTokens[C]=A}rewrite(C){if(this._delegate)return this._delegate(C);const A=C.authority;let R=this._hosts[A];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const w=this._ports[A],i=this._connectionTokens[A];let p=`path=${encodeURIComponent(C.path)}`;return typeof i=="string"&&(p+=`&tkn=${encodeURIComponent(i)}`),t.URI.from({scheme:s.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${R}:${w}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new T;class k{asBrowserUri(C,A){const R=this.toUri(C,A);return R.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===E.file&&(s.isNative||typeof s.globals.importScripts=="function"&&s.globals.origin===`${E.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?R.with({scheme:E.vscodeFileResource,authority:R.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(C,A){const R=this.toUri(C,A);return R.scheme===E.vscodeFileResource?R.with({scheme:E.file,authority:R.authority!==k.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(C,A){return t.URI.isUri(C)?C:t.URI.parse(A.toUrl(C))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(Ee[24],ye([0,1,35,11,17,23,9,2]),function(ee,e,s,t,E,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(p){return(0,P.uriToFsPath)(p,!0)}e.originalFSPath=C;class A{constructor(o){this._ignorePathCasing=o}compare(o,u,d=!1){return o===u?0:(0,k.compare)(this.getComparisonKey(o,d),this.getComparisonKey(u,d))}isEqual(o,u,d=!1){return o===u?!0:!o||!u?!1:this.getComparisonKey(o,d)===this.getComparisonKey(u,d)}getComparisonKey(o,u=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,u,d=!1){if(o.scheme===u.scheme){if(o.scheme===t.Schemas.file)return s.isEqualOrParent(C(o),C(u),this._ignorePathCasing(o))&&o.query===u.query&&(d||o.fragment===u.fragment);if((0,e.isEqualAuthority)(o.authority,u.authority))return s.isEqualOrParent(o.path,u.path,this._ignorePathCasing(o),"/")&&o.query===u.query&&(d||o.fragment===u.fragment)}return!1}joinPath(o,...u){return P.URI.joinPath(o,...u)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return E.posix.basename(o.path)}extname(o){return E.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let u;return o.scheme===t.Schemas.file?u=P.URI.file(E.dirname(C(o))).path:(u=E.posix.dirname(o.path),o.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),u="/")),o.with({path:u})}normalizePath(o){if(!o.path.length)return o;let u;return o.scheme===t.Schemas.file?u=P.URI.file(E.normalize(C(o))).path:u=E.posix.normalize(o.path),o.with({path:u})}relativePath(o,u){if(o.scheme!==u.scheme||!(0,e.isEqualAuthority)(o.authority,u.authority))return;if(o.scheme===t.Schemas.file){const _=E.relative(C(o),C(u));return T.isWindows?s.toSlashes(_):_}let d=o.path||"/",F=u.path||"/";if(this._ignorePathCasing(o)){let _=0;for(const m=Math.min(d.length,F.length);_<m&&!(d.charCodeAt(_)!==F.charCodeAt(_)&&d.charAt(_).toLowerCase()!==F.charAt(_).toLowerCase());_++);d=F.substr(0,_)+d.substr(_)}return E.posix.relative(d,F)}resolvePath(o,u){if(o.scheme===t.Schemas.file){const d=P.URI.file(E.resolve(C(o),u));return o.with({authority:d.authority,path:d.path})}return u=s.toPosixPath(u),o.with({path:E.posix.resolve(o.path,u)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,u){return o===u||o!==void 0&&u!==void 0&&(0,k.equalsIgnoreCase)(o,u)}hasTrailingPathSeparator(o,u=E.sep){if(o.scheme===t.Schemas.file){const d=C(o);return d.length>s.getRoot(d).length&&d[d.length-1]===u}else{const d=o.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,u=E.sep){return(0,e.hasTrailingPathSeparator)(o,u)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,u=E.sep){let d=!1;if(o.scheme===t.Schemas.file){const F=C(o);d=F!==void 0&&F.length===s.getRoot(F).length&&F[F.length-1]===u}else{u="/";const F=o.path;d=F.length===1&&F.charCodeAt(F.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(o,u)?o.with({path:o.path+"/"}):o}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(p=>p.scheme===t.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new A(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(p,o){const u=[];for(let d=0;d<p.length;d++){const F=o(p[d]);p.some((_,m)=>m===d?!1:(0,e.isEqualOrParent)(F,o(_)))||u.push(p[d])}return u}e.distinctParents=R;var w;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function o(u){const d=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(m=>{const[h,D]=m.split(":");h&&D&&d.set(h,D)});const _=u.path.substring(0,u.path.indexOf(";"));return _&&d.set(p.META_DATA_MIME,_),d}p.parseMetaData=o})(w=e.DataUri||(e.DataUri={}));function i(p,o,u){if(o){let d=p.path;return d&&d[0]!==E.posix.sep&&(d=E.posix.sep+d),p.with({scheme:u,authority:o,path:d})}return p.with({scheme:u})}e.toLocalResource=i}),define(Ee[14],ye([0,1,20,15,4,6,24,23]),function(ee,e,s,t,E,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(ce){return!!ce&&typeof ce.then=="function"}e.isThenable=C;function A(ce){const oe=new s.CancellationTokenSource,be=ce(oe.token),Pe=new Promise((Me,He)=>{const Ye=oe.token.onCancellationRequested(()=>{Ye.dispose(),oe.dispose(),He((0,t.canceled)())});Promise.resolve(be).then(Qe=>{Ye.dispose(),oe.dispose(),Me(Qe)},Qe=>{Ye.dispose(),oe.dispose(),He(Qe)})});return new class{cancel(){oe.cancel()}then(Me,He){return Pe.then(Me,He)}catch(Me){return this.then(void 0,Me)}finally(Me){return Pe.finally(Me)}}}e.createCancelablePromise=A;function R(ce,oe,be){return Promise.race([ce,new Promise(Pe=>oe.onCancellationRequested(()=>Pe(be)))])}e.raceCancellation=R;async function w(ce){let oe=-1;const be=ce.map((Me,He)=>Me.then(Ye=>(oe=He,Ye))),Pe=await Promise.race(be);return ce.forEach((Me,He)=>{He!==oe&&Me.cancel()}),Pe}e.raceCancellablePromises=w;function i(ce,oe,be){let Pe;const Me=setTimeout(()=>{Pe?.(void 0),be?.()},oe);return Promise.race([ce.finally(()=>clearTimeout(Me)),new Promise(He=>Pe=He)])}e.raceTimeout=i;function p(ce){return new Promise((oe,be)=>{const Pe=ce();C(Pe)?Pe.then(oe,be):oe(Pe)})}e.asPromise=p;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(oe){if(this.activePromise){if(this.queuedPromiseFactory=oe,!this.queuedPromise){const be=()=>{this.queuedPromise=null;const Pe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Pe};this.queuedPromise=new Promise(Pe=>{this.activePromise.then(be,be).then(Pe)})}return new Promise((be,Pe)=>{this.queuedPromise.then(be,Pe)})}return this.activePromise=oe(),new Promise((be,Pe)=>{this.activePromise.then(Me=>{this.activePromise=null,be(Me)},Me=>{this.activePromise=null,Pe(Me)})})}}e.Throttler=o;class u{constructor(){this.current=Promise.resolve(null)}queue(oe){return this.current=this.current.then(()=>oe(),()=>oe())}}e.Sequencer=u;class d{constructor(){this.promiseMap=new Map}queue(oe,be){const Me=(this.promiseMap.get(oe)??Promise.resolve()).catch(()=>{}).then(be).finally(()=>{this.promiseMap.get(oe)===Me&&this.promiseMap.delete(oe)});return this.promiseMap.set(oe,Me),Me}}e.SequencerByKey=d;const F=(ce,oe)=>{let be=!0;const Pe=setTimeout(()=>{be=!1,oe()},ce);return{isTriggered:()=>be,dispose:()=>{clearTimeout(Pe),be=!1}}},_=ce=>{let oe=!0;return queueMicrotask(()=>{oe&&(oe=!1,ce())}),{isTriggered:()=>oe,dispose:()=>{oe=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class m{constructor(oe){this.defaultDelay=oe,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(oe,be=this.defaultDelay){this.task=oe,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Me,He)=>{this.doResolve=Me,this.doReject=He}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Me=this.task;return this.task=null,Me()}}));const Pe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=be===e.MicrotaskDelay?_(Pe):F(be,Pe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,t.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=m;class h{constructor(oe){this.delayer=new m(oe),this.throttler=new o}trigger(oe,be){return this.delayer.trigger(()=>this.throttler.queue(oe),be)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=h;class D{constructor(){this._isOpen=!1,this._promise=new Promise((oe,be)=>{this._completePromise=oe})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=D;class l extends D{constructor(oe){super();this._timeout=setTimeout(()=>this.open(),oe)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function M(ce,oe){return oe?new Promise((be,Pe)=>{const Me=setTimeout(()=>{He.dispose(),be()},ce),He=oe.onCancellationRequested(()=>{clearTimeout(Me),He.dispose(),Pe((0,t.canceled)())})}):A(be=>M(ce,be))}e.timeout=M;function r(ce,oe=0){const be=setTimeout(ce,oe);return(0,T.toDisposable)(()=>clearTimeout(be))}e.disposableTimeout=r;function n(ce){const oe=[];let be=0;const Pe=ce.length;function Me(){return be<Pe?ce[be++]():null}function He(Ye){Ye!=null&&oe.push(Ye);const Qe=Me();return Qe?Qe.then(He):Promise.resolve(oe)}return Promise.resolve(null).then(He)}e.sequence=n;function b(ce,oe=Pe=>!!Pe,be=null){let Pe=0;const Me=ce.length,He=()=>{if(Pe>=Me)return Promise.resolve(be);const Ye=ce[Pe++];return Promise.resolve(Ye()).then(H=>oe(H)?Promise.resolve(H):He())};return He()}e.first=b;function g(ce,oe=Pe=>!!Pe,be=null){if(ce.length===0)return Promise.resolve(be);let Pe=ce.length;const Me=()=>{Pe=-1;for(const He of ce)He.cancel?.()};return new Promise((He,Ye)=>{for(const Qe of ce)Qe.then(H=>{--Pe>=0&&oe(H)?(Me(),He(H)):Pe===0&&He(be)}).catch(H=>{--Pe>=0&&(Me(),Ye(H))})})}e.firstParallel=g;class c{constructor(oe){this._size=0,this.maxDegreeOfParalellism=oe,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(oe){return this._size++,new Promise((be,Pe)=>{this.outstandingPromises.push({factory:oe,c:be,e:Pe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const oe=this.outstandingPromises.shift();this.runningPromises++;const be=oe.factory();be.then(oe.c,oe.e),be.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class f extends c{constructor(){super(1)}}e.Queue=f;class v{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const oe=new W;return this.drainers.add(oe),oe.p}isDrained(){for(const[,oe]of this.queues)if(oe.size>0)return!1;return!0}queueFor(oe,be=k.extUri){const Pe=be.getComparisonKey(oe);let Me=this.queues.get(Pe);return Me||(Me=new f,E.Event.once(Me.onFinished)(()=>{Me?.dispose(),this.queues.delete(Pe),this.onDidQueueFinish()}),this.queues.set(Pe,Me)),Me}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const oe of this.drainers)oe.complete();this.drainers.clear()}dispose(){for(const[,oe]of this.queues)oe.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=v;class a{constructor(oe,be){this._token=-1,typeof oe=="function"&&typeof be=="number"&&this.setIfNotSet(oe,be)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(oe,be){this.cancel(),this._token=setTimeout(()=>{this._token=-1,oe()},be)}setIfNotSet(oe,be){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,oe()},be))}}e.TimeoutTimer=a;class S{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(oe,be){this.cancel(),this._token=setInterval(()=>{oe()},be)}}e.IntervalTimer=S;class I{constructor(oe,be){this.timeoutToken=-1,this.runner=oe,this.timeout=be,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(oe=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,oe)}get delay(){return this.timeout}set delay(oe){this.timeout=oe}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=I;class N{constructor(oe,be){be%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${be}ms is not a multiple of 1000ms.`),this.runner=oe,this.timeout=be,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(oe=this.timeout){oe%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(oe/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class B extends I{constructor(oe,be){super(oe,be);this.units=[]}work(oe){this.units.push(oe),this.isScheduled()||this.schedule()}doRun(){const oe=this.units;this.units=[],this.runner&&this.runner(oe)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B;class y extends T.Disposable{constructor(oe,be,Pe,Me){super();this.maxWorkChunkSize=oe,this.maxPendingWork=be,this.throttleDelay=Pe,this.handler=Me,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(oe){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+oe.length>this.maxPendingWork)return!1}else if(this.pending+oe.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...oe),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new I(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=y,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ce=>{(0,P.setTimeout0)(()=>{if(oe)return;const be=Date.now()+15;ce(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,be-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e.runWhenIdle=(ce,oe)=>{const be=requestIdleCallback(ce,typeof oe=="number"?{timeout:oe}:void 0);let Pe=!1;return{dispose(){Pe||(Pe=!0,cancelIdleCallback(be))}}}}();class O{constructor(oe){this._didRun=!1,this._executor=()=>{try{this._value=oe()}catch(be){this._error=be}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function z(ce,oe,be){let Pe;for(let Me=0;Me<be;Me++)try{return await ce()}catch(He){Pe=He,await M(oe)}throw Pe}e.retry=z;class U{hasPending(oe){return this._pending?typeof oe=="number"?this._pending.taskId===oe:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(oe,be,Pe){return this._pending={taskId:oe,cancel:()=>Pe?.(),promise:be},be.then(()=>this.donePending(oe),()=>this.donePending(oe)),be}donePending(oe){this._pending&&oe===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const oe=this._next;this._next=void 0,oe.run().then(oe.promiseResolve,oe.promiseReject)}}setNext(oe){if(this._next)this._next.run=oe;else{let be,Pe;const Me=new Promise((He,Ye)=>{be=He,Pe=Ye});this._next={run:oe,promise:Me,promiseResolve:be,promiseReject:Pe}}return this._next.promise}}e.TaskSequentializer=U;class ${constructor(oe,be=()=>Date.now()){this.interval=oe,this.nowFn=be,this.lastIncrementTime=0,this.value=0}increment(){const oe=this.nowFn();return oe-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=oe,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((oe,be)=>{this.completeCallback=oe,this.errorCallback=be})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(oe){return new Promise(be=>{this.completeCallback(oe),this.resolved=!0,be()})}error(oe){return new Promise(be=>{this.errorCallback(oe),this.rejected=!0,be()})}cancel(){new Promise(oe=>{this.errorCallback((0,t.canceled)()),this.rejected=!0,oe()})}}e.DeferredPromise=W;var J;(function(ce){async function oe(Pe){let Me;const He=await Promise.all(Pe.map(Ye=>Ye.then(Qe=>Qe,Qe=>{Me||(Me=Qe)})));if(typeof Me!="undefined")throw Me;return He}ce.settled=oe;function be(Pe){return new Promise(async(Me,He)=>{try{await Pe(Me,He)}catch(Ye){He(Ye)}})}ce.withAsyncBody=be})(J=e.Promises||(e.Promises={}));var G;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(G||(G={}));class ae{constructor(oe){this._state=0,this._results=[],this._error=null,this._onStateChanged=new E.Emitter,queueMicrotask(async()=>{const be={emitOne:Pe=>this.emitOne(Pe),emitMany:Pe=>this.emitMany(Pe),reject:Pe=>this.reject(Pe)};try{await Promise.resolve(oe(be)),this.resolve()}catch(Pe){this.reject(Pe)}finally{be.emitOne=void 0,be.emitMany=void 0,be.reject=void 0}})}static fromArray(oe){return new ae(be=>{be.emitMany(oe)})}static fromPromise(oe){return new ae(async be=>{be.emitMany(await oe)})}static fromPromises(oe){return new ae(async be=>{await Promise.all(oe.map(async Pe=>be.emitOne(await Pe)))})}static merge(oe){return new ae(async be=>{await Promise.all(oe.map(async Pe=>{for await(const Me of Pe)be.emitOne(Me)}))})}[Symbol.asyncIterator](){let oe=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(oe<this._results.length)return{done:!1,value:this._results[oe++]};if(this._state===1)return{done:!0,value:void 0};await E.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(oe,be){return new ae(async Pe=>{for await(const Me of oe)Pe.emitOne(be(Me))})}map(oe){return ae.map(this,oe)}static filter(oe,be){return new ae(async Pe=>{for await(const Me of oe)be(Me)&&Pe.emitOne(Me)})}filter(oe){return ae.filter(this,oe)}static coalesce(oe){return ae.filter(oe,be=>!!be)}coalesce(){return ae.coalesce(this)}static async toPromise(oe){const be=[];for await(const Pe of oe)be.push(Pe);return be}toPromise(){return ae.toPromise(this)}emitOne(oe){this._state===0&&(this._results.push(oe),this._onStateChanged.fire())}emitMany(oe){this._state===0&&(this._results=this._results.concat(oe),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(oe){this._state===0&&(this._state=2,this._error=oe,this._onStateChanged.fire())}}e.AsyncIterableObject=ae,ae.EMPTY=ae.fromArray([]);class we extends ae{constructor(oe,be){super(be);this._source=oe}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=we;function Se(ce){const oe=new s.CancellationTokenSource,be=ce(oe.token);return new we(oe,async Pe=>{const Me=oe.token.onCancellationRequested(()=>{Me.dispose(),oe.dispose(),Pe.reject((0,t.canceled)())});try{for await(const He of be){if(oe.token.isCancellationRequested)return;Pe.emitOne(He)}Me.dispose(),oe.dispose()}catch(He){Me.dispose(),oe.dispose(),Pe.reject(He)}})}e.createCancelableAsyncIterable=Se}),define(Ee[104],ye([0,1,14,17]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new s.IdleValue(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),T=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(v,a,S=!1){const I=v||"",N=a||"",B=E.value.collator.compare(I,N);return E.value.collatorIsNumeric&&B===0&&I!==N?I<N?-1:1:B}e.compareFileNames=P;function C(v,a){const S=T.value.collator;return v=v||"",a=a||"",D(S,v,a)}e.compareFileNamesDefault=C;function A(v,a){const S=T.value.collator;return v=v||"",a=a||"",n(v,a)||D(S,v,a)}e.compareFileNamesUpper=A;function R(v,a){const S=T.value.collator;return v=v||"",a=a||"",r(v,a)||D(S,v,a)}e.compareFileNamesLower=R;function w(v,a){return v=v||"",a=a||"",v===a?0:v<a?-1:1}e.compareFileNamesUnicode=w;function i(v,a,S=!1){S||(v=v&&v.toLowerCase(),a=a&&a.toLowerCase());const[I,N]=m(v),[B,y]=m(a);return I!==B?I<B?-1:1:N===y?0:N<y?-1:1}e.noIntlCompareFileNames=i;function p(v,a){const[S,I]=m(v),[N,B]=m(a);let y=E.value.collator.compare(I,B);if(y===0){if(E.value.collatorIsNumeric&&I!==B)return I<B?-1:1;if(y=E.value.collator.compare(S,N),E.value.collatorIsNumeric&&y===0&&S!==N)return S<N?-1:1}return y}e.compareFileExtensions=p;function o(v,a){v=v||"",a=a||"";const S=h(v),I=h(a),N=T.value.collator,B=k.value.collator;return D(B,S,I)||D(N,v,a)}e.compareFileExtensionsDefault=o;function u(v,a){v=v||"",a=a||"";const S=h(v),I=h(a),N=T.value.collator,B=k.value.collator;return D(B,S,I)||n(v,a)||D(N,v,a)}e.compareFileExtensionsUpper=u;function d(v,a){v=v||"",a=a||"";const S=h(v),I=h(a),N=T.value.collator,B=k.value.collator;return D(B,S,I)||r(v,a)||D(N,v,a)}e.compareFileExtensionsLower=d;function F(v,a){v=v||"",a=a||"";const S=h(v).toLowerCase(),I=h(a).toLowerCase();return S!==I?S<I?-1:1:v!==a?v<a?-1:1:0}e.compareFileExtensionsUnicode=F;const _=/^(.*?)(\.([^.]*))?$/;function m(v,a=!1){const S=v?_.exec(v):[];let I=[S&&S[1]||"",S&&S[3]||""];return a&&(!I[0]&&I[1]||I[0]&&I[0].charAt(0)===".")&&(I=[I[0]+"."+I[1],""]),I}function h(v){const a=v?_.exec(v):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function D(v,a,S){let I=v.compare(a,S);return I!==0?I:a.length!==S.length?a.length<S.length?-1:1:0}function l(v){const a=v.charAt(0);return a.toLocaleUpperCase()!==a}function M(v){const a=v.charAt(0);return a.toLocaleLowerCase()!==a}function r(v,a){return l(v)&&M(a)?-1:M(v)&&l(a)?1:0}function n(v,a){return M(v)&&l(a)?-1:l(v)&&M(a)?1:0}function b(v,a,S=!1){return S||(v=v&&v.toLowerCase(),a=a&&a.toLowerCase()),v===a?0:v<a?-1:1}function g(v,a,S=!1){const I=v.split(t.sep),N=a.split(t.sep),B=I.length-1,y=N.length-1;let O,z;for(let U=0;;U++){if(O=B===U,z=y===U,O&&z)return P(I[U],N[U],S);if(O)return-1;if(z)return 1;const $=b(I[U],N[U],S);if($!==0)return $}}e.comparePaths=g;function c(v,a,S){const I=v.toLowerCase(),N=a.toLowerCase(),B=f(v,a,S);if(B)return B;const y=I.endsWith(S),O=N.endsWith(S);if(y!==O)return y?-1:1;const z=P(I,N);return z!==0?z:I.localeCompare(N)}e.compareAnything=c;function f(v,a,S){const I=v.toLowerCase(),N=a.toLowerCase(),B=I.startsWith(S),y=N.startsWith(S);if(B!==y)return B?-1:1;if(B&&y){if(I.length<N.length)return-1;if(I.length>N.length)return 1}return 0}e.compareByPrefix=f}),define(Ee[29],ye([0,1,14,35,21,17,9]),function(ee,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",A="[^/\\\\]",R=/\//g;function w(W){switch(W){case 0:return"";case 1:return`${A}*?`;default:return`(?:${C}|${A}+${C}|${C}${A}+)*?`}}function i(W,J){if(!W)return[];const G=[];let ae=!1,we=!1,Se="";for(const ce of W){switch(ce){case J:if(!ae&&!we){G.push(Se),Se="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":we=!0;break;case"]":we=!1;break}Se+=ce}return Se&&G.push(Se),G}e.splitGlobAware=i;function p(W){if(!W)return"";let J="";const G=i(W,e.GLOB_SPLIT);if(G.every(ae=>ae===e.GLOBSTAR))J=".*";else{let ae=!1;G.forEach((we,Se)=>{if(we===e.GLOBSTAR){ae||(J+=w(2),ae=!0);return}let ce=!1,oe="",be=!1,Pe="";for(const Me of we){if(Me!=="}"&&ce){oe+=Me;continue}if(be&&(Me!=="]"||!Pe)){let He;Me==="-"?He=Me:(Me==="^"||Me==="!")&&!Pe?He="^":Me===e.GLOB_SPLIT?He="":He=k.escapeRegExpCharacters(Me),Pe+=He;continue}switch(Me){case"{":ce=!0;continue;case"[":be=!0;continue;case"}":{J+=`(?:${i(oe,",").map(Qe=>p(Qe)).join("|")})`,ce=!1,oe="";break}case"]":J+="["+Pe+"]",be=!1,Pe="";break;case"?":J+=A;continue;case"*":J+=w(1);continue;default:J+=k.escapeRegExpCharacters(Me)}}Se<G.length-1&&(G[Se+1]!==e.GLOBSTAR||Se+2<G.length)&&(J+=C),ae=!1})}return J}const o=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,F=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,_=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,h=new E.LRUCache(1e4),D=function(){return!1},l=function(){return null};function M(W,J){if(!W)return l;let G;typeof W!="string"?G=W.pattern:G=W,G=G.trim();const ae=`${G}_${!!J.trimForExclusions}`;let we=h.get(ae);if(we)return r(we,W);let Se;if(o.test(G)){const ce=G.substr(4);we=function(oe,be){return typeof oe=="string"&&oe.endsWith(ce)?G:null}}else(Se=u.exec(n(G,J)))?we=b(Se[1],G):(J.trimForExclusions?F:d).test(G)?we=g(G,J):(Se=_.exec(n(G,J)))?we=c(Se[1].substr(1),G,!0):(Se=m.exec(n(G,J)))?we=c(Se[1],G,!1):we=f(G);return h.set(ae,we),r(we,W)}function r(W,J){return typeof J=="string"?W:function(G,ae){return t.isEqualOrParent(G,J.base)?W(T.relative(J.base,G),ae):null}}function n(W,J){return J.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function b(W,J){const G=`/${W}`,ae=`\\${W}`,we=function(ce,oe){return typeof ce!="string"?null:oe?oe===W?J:null:ce===W||ce.endsWith(G)||ce.endsWith(ae)?J:null},Se=[W];return we.basenames=Se,we.patterns=[J],we.allBasenames=Se,we}function g(W,J){const G=$(W.slice(1,-1).split(",").map(oe=>M(oe,J)).filter(oe=>oe!==l),W),ae=G.length;if(!ae)return l;if(ae===1)return G[0];const we=function(oe,be){for(let Pe=0,Me=G.length;Pe<Me;Pe++)if(G[Pe](oe,be))return W;return null},Se=G.find(oe=>!!oe.allBasenames);Se&&(we.allBasenames=Se.allBasenames);const ce=G.reduce((oe,be)=>be.allPaths?oe.concat(be.allPaths):oe,[]);return ce.length&&(we.allPaths=ce),we}function c(W,J,G){const ae=T.sep===T.posix.sep,we=ae?W:W.replace(R,T.sep),Se=T.sep+we,ce=T.posix.sep+W,oe=G?function(be,Pe){return typeof be=="string"&&(be===we||be.endsWith(Se)||!ae&&(be===W||be.endsWith(ce)))?J:null}:function(be,Pe){return typeof be=="string"&&(be===we||!ae&&be===W)?J:null};return oe.allPaths=[(G?"*/":"./")+W],oe}function f(W){try{const J=new RegExp(`^${p(W)}$`);return function(G){return J.lastIndex=0,typeof G=="string"&&J.test(G)?W:null}}catch{return l}}function v(W,J,G){return!W||typeof J!="string"?!1:a(W)(J,void 0,G)}e.match=v;function a(W,J={}){if(!W)return D;if(typeof W=="string"||B(W)){const G=M(W,J);if(G===l)return D;const ae=function(we,Se){return!!G(we,Se)};return G.allBasenames&&(ae.allBasenames=G.allBasenames),G.allPaths&&(ae.allPaths=G.allPaths),ae}return z(W,J)}e.parse=a;function S(W){if(!W)return;let J;return G=>(J||(J=(W()||Promise.resolve([])).then(ae=>ae?N(ae):{})),J.then(ae=>!!ae[G]))}e.hasSiblingPromiseFn=S;function I(W){if(!W)return;let J;return G=>{if(!J){const ae=W();J=ae?N(ae):{}}return!!J[G]}}e.hasSiblingFn=I;function N(W){const J={};for(const G of W)J[G]=!0;return J}function B(W){const J=W;return J&&typeof J.base=="string"&&typeof J.pattern=="string"}e.isRelativePattern=B;function y(W){return W.allBasenames||[]}e.getBasenameTerms=y;function O(W){return W.allPaths||[]}e.getPathTerms=O;function z(W,J){const G=$(Object.getOwnPropertyNames(W).map(oe=>U(oe,W[oe],J)).filter(oe=>oe!==l)),ae=G.length;if(!ae)return l;if(!G.some(oe=>!!oe.requiresSiblings)){if(ae===1)return G[0];const oe=function(Me,He){for(let Ye=0,Qe=G.length;Ye<Qe;Ye++){const H=G[Ye](Me,He);if(H)return H}return null},be=G.find(Me=>!!Me.allBasenames);be&&(oe.allBasenames=be.allBasenames);const Pe=G.reduce((Me,He)=>He.allPaths?Me.concat(He.allPaths):Me,[]);return Pe.length&&(oe.allPaths=Pe),oe}const we=function(oe,be,Pe){let Me;for(let He=0,Ye=G.length;He<Ye;He++){const Qe=G[He];Qe.requiresSiblings&&Pe&&(be||(be=T.basename(oe)),Me||(Me=be.substr(0,be.length-T.extname(oe).length)));const H=Qe(oe,be,Me,Pe);if(H)return H}return null},Se=G.find(oe=>!!oe.allBasenames);Se&&(we.allBasenames=Se.allBasenames);const ce=G.reduce((oe,be)=>be.allPaths?oe.concat(be.allPaths):oe,[]);return ce.length&&(we.allPaths=ce),we}function U(W,J,G){if(J===!1)return l;const ae=M(W,G);if(ae===l)return l;if(typeof J=="boolean")return ae;if(J){const we=J.when;if(typeof we=="string"){const Se=(ce,oe,be,Pe)=>{if(!Pe||!ae(ce,oe))return null;const Me=we.replace("$(basename)",be),He=Pe(Me);return(0,s.isThenable)(He)?He.then(Ye=>Ye?W:null):He?W:null};return Se.requiresSiblings=!0,Se}}return ae}function $(W,J){const G=W.filter(oe=>!!oe.basenames);if(G.length<2)return W;const ae=G.reduce((oe,be)=>{const Pe=be.basenames;return Pe?oe.concat(Pe):oe},[]);let we;if(J){we=[];for(let oe=0,be=ae.length;oe<be;oe++)we.push(J)}else we=G.reduce((oe,be)=>{const Pe=be.patterns;return Pe?oe.concat(Pe):oe},[]);const Se=function(oe,be){if(typeof oe!="string")return null;if(!be){let Me;for(Me=oe.length;Me>0;Me--){const He=oe.charCodeAt(Me-1);if(He===47||He===92)break}be=oe.substr(Me)}const Pe=ae.indexOf(be);return Pe!==-1?we[Pe]:null};Se.basenames=ae,Se.patterns=we,Se.allBasenames=ae;const ce=W.filter(oe=>!oe.basenames);return ce.push(Se),ce}}),define(Ee[78],ye([0,1,35,11,17,23,24,9,2]),function(ee,e,s,t,E,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function A(n,b,g){if(typeof n=="string"&&(n=C.URI.file(n)),g){const f=g.getWorkspaceFolder(n);if(f){const v=g.getWorkspace().folders.length>1;let a;if((0,k.isEqual)(f.uri,n)?a="":a=(0,k.relativePath)(f.uri,n),v){const S=f.name?f.name:(0,k.basename)(f.uri);a=a?S+" \u2022 "+a:S}return a}}if(n.scheme!==t.Schemas.file&&n.scheme!==t.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,s.hasDriveLetter)(n.fsPath))return(0,E.normalize)(w(n.fsPath));let c=(0,E.normalize)(n.fsPath);return!T.isWindows&&b?.userHome&&(c=p(c,b.userHome.fsPath)),c}e.getPathLabel=A;function R(n){if(!n)return;typeof n=="string"&&(n=C.URI.file(n));const b=(0,k.basename)(n)||(n.scheme===t.Schemas.file?n.fsPath:n.path);return T.isWindows&&(0,s.isRootOrDriveLetter)(b)?w(b):b}e.getBaseLabel=R;function w(n,b){return(0,s.hasDriveLetter)(n,b)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=w;let i=Object.create(null);function p(n,b){if(T.isWindows||!n||!b)return n;let g=i.original===b?i.normalized:void 0;return g||(g=`${(0,P.rtrim)(b,E.posix.sep)}${E.posix.sep}`,i={original:b,normalized:g}),(T.isLinux?n.startsWith(g):(0,P.startsWithIgnoreCase)(n,g))&&(n=`~/${n.substr(g.length)}`),n}e.tildify=p;function o(n,b){return n.replace(/^~($|\/|\\)/,`${b}$1`)}e.untildify=o;const u="\u2026",d="\\\\",F="~";function _(n,b=E.sep){const g=new Array(n.length);let c=!1;for(let f=0;f<n.length;f++){let v=n[f];if(v===""){g[f]=`.${b}`;continue}if(!v){g[f]=v;continue}c=!0;let a="";v.indexOf(d)===0?(a=v.substr(0,v.indexOf(d)+d.length),v=v.substr(v.indexOf(d)+d.length)):v.indexOf(b)===0?(a=v.substr(0,v.indexOf(b)+b.length),v=v.substr(v.indexOf(b)+b.length)):v.indexOf(F)===0&&(a=v.substr(0,v.indexOf(F)+F.length),v=v.substr(v.indexOf(F)+F.length));const S=v.split(b);for(let I=1;c&&I<=S.length;I++)for(let N=S.length-I;c&&N>=0;N--){c=!1;let B=S.slice(N,N+I).join(b);for(let y=0;!c&&y<n.length;y++)if(y!==f&&n[y]&&n[y].indexOf(B)>-1){const O=N+I===S.length,z=N>0&&n[y].indexOf(b)>-1?b+B:B,U=n[y].endsWith(z);c=!O||U}if(!c){let y="";(S[0].endsWith(":")||a!=="")&&(N===1&&(N=0,I++,B=S[0]+b+B),N>0&&(y=S[0]+b),y=a+y),N>0&&(y=y+u+b),y=y+B,N+I<S.length&&(y=y+b+u),g[f]=y}}c&&(g[f]=v)}return g}e.shorten=_;var m;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function h(n,b=Object.create(null)){const g=[];let c=!1,f="";for(const v of n)if(v==="$"||c&&v==="{")f&&g.push({value:f,type:m.TEXT}),f="",c=!0;else if(v==="}"&&c){const a=b[f];if(typeof a=="string")a.length&&g.push({value:a,type:m.VARIABLE});else if(a){const S=g[g.length-1];(!S||S.type!==m.SEPARATOR)&&g.push({value:a.label,type:m.SEPARATOR})}f="",c=!1}else f+=v;return f&&!c&&g.push({value:f,type:m.TEXT}),g.filter((v,a)=>{if(v.type===m.SEPARATOR){const S=g[a-1],I=g[a+1];return[S,I].every(N=>N&&(N.type===m.VARIABLE||N.type===m.TEXT)&&N.value.length>0)}return!0}).map(v=>v.value).join("")}e.template=h;function D(n,b){return T.isMacintosh||b?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):n.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function l(n,b){return T.isMacintosh||b?n.replace(/\(&&\w\)|&&/g,""):T.isWindows?n.replace(/&&|&/g,g=>g==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function M(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=M;function r(n){const b=n.indexOf("/")!==-1?E.posix:E.win32,g=b.basename(n),c=b.dirname(n);return g.length?{name:g,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(Ee[105],ye([0,1,2]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class E{constructor(w){this._uriTransformer=w}transformIncoming(w){const i=this._uriTransformer.transformIncoming(w);return i===w?w:t(s.URI.from(i))}transformOutgoing(w){const i=this._uriTransformer.transformOutgoing(w);return i===w?w:t(s.URI.from(i))}transformOutgoingURI(w){const i=this._uriTransformer.transformOutgoing(w);return i===w?w:s.URI.from(i)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function T(R,w,i){if(!R||i>200)return null;if(typeof R=="object"){if(R instanceof s.URI)return w.transformOutgoing(R);for(let p in R)if(Object.hasOwnProperty.call(R,p)){const o=T(R[p],w,i+1);o!==null&&(R[p]=o)}}return null}function k(R,w){const i=T(R,w,0);return i===null?R:i}e.transformOutgoingURIs=k;function P(R,w,i,p){if(!R||p>200)return null;if(typeof R=="object"){if(R.$mid===1)return i?s.URI.revive(w.transformIncoming(R)):w.transformIncoming(R);for(let o in R)if(Object.hasOwnProperty.call(R,o)){const u=P(R[o],w,i,p+1);u!==null&&(R[o]=u)}}return null}function C(R,w){const i=P(R,w,!1,0);return i===null?R:i}e.transformIncomingURIs=C;function A(R,w){const i=P(R,w,!0,0);return i===null?R:i}e.transformAndReviveIncomingURIs=A}),define(Ee[36],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return s.test(C)}e.isUUID=t;const E=new Uint8Array(16),T=[];for(let C=0;C<256;C++)T.push(C.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(C){for(let A=0;A<C.length;A++)C[A]=Math.floor(Math.random()*256);return C};function P(){k(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let C=0,A="";return A+=T[E[C++]],A+=T[E[C++]],A+=T[E[C++]],A+=T[E[C++]],A+="-",A+=T[E[C++]],A+=T[E[C++]],A+="-",A+=T[E[C++]],A+=T[E[C++]],A+="-",A+=T[E[C++]],A+=T[E[C++]],A+="-",A+=T[E[C++]],A+=T[E[C++]],A+=T[E[C++]],A+=T[E[C++]],A+=T[E[C++]],A+=T[E[C++]],A}e.generateUuid=P}),define(Ee[106],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var s;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(s=e.IndentAction||(e.IndentAction={}));class t{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let C=0,A=P.notIn.length;C<A;C++)switch(P.notIn[C]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,C){if(P.getTokenCount()===0)return!0;const A=P.findTokenIndexAtOffset(C-2),R=P.getStandardTokenType(A);return this.isOK(R)}_findNeutralCharacterInRange(P,C){for(let A=P;A<=C;A++){const R=String.fromCharCode(A);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class E{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of P)T(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),T(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),T(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),T(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&T(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=E;function T(k,P,C){k.has(P)?k.get(P).push(C):k.set(P,[C])}}),define(Ee[56],ye([0,1,29,17]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(T,k,P,C){if(Array.isArray(T)){let A=0;for(const R of T){const w=E(R,k,P,C);if(w===10)return w;w>A&&(A=w)}return A}else{if(typeof T=="string")return C?T==="*"?5:T===P?10:0:0;if(T){const{language:A,pattern:R,scheme:w,hasAccessToAllModels:i}=T;if(!C&&!i)return 0;let p=0;if(w)if(w===k.scheme)p=10;else if(w==="*")p=5;else return 0;if(A)if(A===P)p=10;else if(A==="*")p=Math.max(p,5);else return 0;if(R){let o;if(typeof R=="string"?o=R:o={...R,base:(0,t.normalize)(R.base)},o===k.fsPath||(0,s.match)(o,k.fsPath))p=10;else return 0}return p}else return 0}}e.score=E}),define(Ee[107],ye([0,1,4,6]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class E{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new s.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,C){return this._map.set(P,C),this.fire([P]),(0,t.toDisposable)(()=>{this._map.get(P)===C&&(this._map.delete(P),this.fire([P]))})}registerFactory(P,C){this._factories.get(P)?.dispose();const A=new T(this,P,C);return this._factories.set(P,A),(0,t.toDisposable)(()=>{const R=this._factories.get(P);!R||R!==A||(this._factories.delete(P),R.dispose())})}async getOrCreate(P){const C=this.get(P);if(C)return C;const A=this._factories.get(P);return!A||A.isResolved?null:(await A.resolve(),this.get(P))}get(P){return this._map.get(P)||null}isResolved(P){if(this.get(P))return!0;const A=this._factories.get(P);return!!(!A||A.isResolved)}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=E;class T extends t.Disposable{constructor(P,C,A){super();this._registry=P,this._languageId=C,this._factory=A,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const P=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,P&&!this._isDisposed&&this._register(this._registry.register(this._languageId,P))}}}),define(Ee[79],ye([0,1,22,23]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(E||(E={}));function T(w){for(let i=0,p=w.length;i<p;i+=4){const o=w[i+0],u=w[i+1],d=w[i+2],F=w[i+3];w[i+0]=F,w[i+1]=d,w[i+2]=u,w[i+3]=o}}function k(w){const i=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return t.isLittleEndian()||T(i),s.VSBuffer.wrap(i)}function P(w){const i=w.buffer;if(t.isLittleEndian()||T(i),i.byteOffset%4==0)return new Uint32Array(i.buffer,i.byteOffset,i.length/4);{const p=new Uint8Array(i.byteLength);return p.set(i),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function C(w){const i=new Uint32Array(A(w));let p=0;if(i[p++]=w.id,w.type==="full")i[p++]=1,i[p++]=w.data.length,i.set(w.data,p),p+=w.data.length;else{i[p++]=2,i[p++]=w.deltas.length;for(const o of w.deltas)i[p++]=o.start,i[p++]=o.deleteCount,o.data?(i[p++]=o.data.length,i.set(o.data,p),p+=o.data.length):i[p++]=0}return k(i)}e.encodeSemanticTokensDto=C;function A(w){let i=0;if(i+=1+1,w.type==="full")i+=1+w.data.length;else{i+=1,i+=(1+1+1)*w.deltas.length;for(const p of w.deltas)p.data&&(i+=p.data.length)}return i}function R(w){const i=P(w);let p=0;const o=i[p++];if(i[p++]===1){const _=i[p++],m=i.subarray(p,p+_);return p+=_,{id:o,type:"full",data:m}}const d=i[p++],F=[];for(let _=0;_<d;_++){const m=i[p++],h=i[p++],D=i[p++];let l;D>0&&(l=i.subarray(p,p+D),p+=D),F[_]={start:m,deleteCount:h,data:l}}return{id:o,type:"delta",deltas:F}}e.decodeSemanticTokensDto=R}),define(Ee[108],ye([18,19]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Ee[109],ye([0,1,108]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,E=t*60,T=E*24,k=T*7,P=T*30,C=T*365;function A(w,i){typeof w!="number"&&(w=w.getTime());const p=Math.round((new Date().getTime()-w)/1e3);if(p<-30)return(0,s.localize)(0,null,A(new Date().getTime()+p*1e3,!1));if(p<30)return(0,s.localize)(1,null);let o;return p<t?(o=p,i?o===1?(0,s.localize)(2,null,o):(0,s.localize)(3,null,o):o===1?(0,s.localize)(4,null,o):(0,s.localize)(5,null,o)):p<E?(o=Math.floor(p/t),i?o===1?(0,s.localize)(6,null,o):(0,s.localize)(7,null,o):o===1?(0,s.localize)(8,null,o):(0,s.localize)(9,null,o)):p<T?(o=Math.floor(p/E),i?o===1?(0,s.localize)(10,null,o):(0,s.localize)(11,null,o):o===1?(0,s.localize)(12,null,o):(0,s.localize)(13,null,o)):p<k?(o=Math.floor(p/T),i?o===1?(0,s.localize)(14,null,o):(0,s.localize)(15,null,o):o===1?(0,s.localize)(16,null,o):(0,s.localize)(17,null,o)):p<P?(o=Math.floor(p/k),i?o===1?(0,s.localize)(18,null,o):(0,s.localize)(19,null,o):o===1?(0,s.localize)(20,null,o):(0,s.localize)(21,null,o)):p<C?(o=Math.floor(p/P),i?o===1?(0,s.localize)(22,null,o):(0,s.localize)(23,null,o):o===1?(0,s.localize)(24,null,o):(0,s.localize)(25,null,o)):(o=Math.floor(p/C),i?o===1?(0,s.localize)(26,null,o):(0,s.localize)(27,null,o):o===1?(0,s.localize)(28,null,o):(0,s.localize)(29,null,o))}e.fromNow=A;function R(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Ee[110],ye([18,19]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ee[43],ye([0,1,16,10,110]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(A,R){return R&&(A.stack||A.stacktrace)?E.localize(0,null,P(A),k(A.stack)||k(A.stacktrace)):P(A)}function k(A){return Array.isArray(A)?A.join(`
`):A}function P(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?E.localize(1,null,A.message):A.message||E.localize(2,null)}function C(A=null,R=!1){if(!A)return E.localize(3,null);if(Array.isArray(A)){const w=s.coalesce(A),i=C(w[0],R);return w.length>1?E.localize(4,null,i,w.length):i}if(t.isString(A))return A;if(A.detail){const w=A.detail;if(w.error)return T(w.error,R);if(w.exception)return T(w.exception,R)}return A.stack?T(A,R):A.message?A.message:E.localize(5,null)}e.toErrorMessage=C}),define(Ee[111],ye([18,19]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ee[112],ye([0,1,111,23,113,16,26]),function(ee,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(j){j[j.None=0]="None",j[j.Keep=1]="Keep",j[j.Brackets=2]="Brackets",j[j.Advanced=3]="Advanced",j[j.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=C;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class R{constructor(Q,fe,Ne,Ve){this.id=Q,this.name=fe,this.defaultValue=Ne,this.schema=Ve}applyUpdate(Q,fe){return i(Q,fe)}compute(Q,fe,Ne){return Ne}}class w{constructor(Q,fe){this.newValue=Q,this.didChange=fe}}e.ApplyUpdateResult=w;function i(j,Q){if(typeof j!="object"||typeof Q!="object"||!j||!Q)return new w(Q,j!==Q);if(Array.isArray(j)||Array.isArray(Q)){const Ne=Array.isArray(j)&&Array.isArray(Q)&&T.equals(j,Q);return new w(Q,Ne)}let fe=!1;for(const Ne in Q)if(Q.hasOwnProperty(Ne)){const Ve=i(j[Ne],Q[Ne]);Ve.didChange&&(j[Ne]=Ve.newValue,fe=!0)}return new w(j,fe)}class p{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,fe){return i(Q,fe)}validate(Q){return this.defaultValue}}class o{constructor(Q,fe,Ne,Ve){this.id=Q,this.name=fe,this.defaultValue=Ne,this.schema=Ve}applyUpdate(Q,fe){return i(Q,fe)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,fe,Ne){return Ne}}function u(j,Q){return typeof j=="undefined"?Q:j==="false"?!1:Boolean(j)}e.boolean=u;class d extends o{constructor(Q,fe,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Ne);super(Q,fe,Ne,Ve)}validate(Q){return u(Q,this.defaultValue)}}function F(j,Q,fe,Ne){if(typeof j=="undefined")return Q;let Ve=parseInt(j,10);return isNaN(Ve)?Q:(Ve=Math.max(fe,Ve),Ve=Math.min(Ne,Ve),Ve|0)}e.clampedInt=F;class _ extends o{constructor(Q,fe,Ne,Ve,ot,ht=void 0){typeof ht!="undefined"&&(ht.type="integer",ht.default=Ne,ht.minimum=Ve,ht.maximum=ot);super(Q,fe,Ne,ht);this.minimum=Ve,this.maximum=ot}static clampedInt(Q,fe,Ne,Ve){return F(Q,fe,Ne,Ve)}validate(Q){return _.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class m extends o{constructor(Q,fe,Ne,Ve,ot){typeof ot!="undefined"&&(ot.type="number",ot.default=Ne);super(Q,fe,Ne,ot);this.validationFn=Ve}static clamp(Q,fe,Ne){return Q<fe?fe:Q>Ne?Ne:Q}static float(Q,fe){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return fe;const Ne=parseFloat(Q);return isNaN(Ne)?fe:Ne}validate(Q){return this.validationFn(m.float(Q,this.defaultValue))}}class h extends o{static string(Q,fe){return typeof Q!="string"?fe:Q}constructor(Q,fe,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Ne);super(Q,fe,Ne,Ve)}validate(Q){return h.string(Q,this.defaultValue)}}function D(j,Q,fe){return typeof j!="string"||fe.indexOf(j)===-1?Q:j}e.stringSet=D;class l extends o{constructor(Q,fe,Ne,Ve,ot=void 0){typeof ot!="undefined"&&(ot.type="string",ot.enum=Ve,ot.default=Ne);super(Q,fe,Ne,ot);this._allowedValues=Ve}validate(Q){return D(Q,this.defaultValue,this._allowedValues)}}class M extends R{constructor(Q,fe,Ne,Ve,ot,ht,Je=void 0){typeof Je!="undefined"&&(Je.type="string",Je.enum=ot,Je.default=Ve);super(Q,fe,Ne,Je);this._allowedValues=ot,this._convert=ht}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function r(j){switch(j){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends R{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(0,null),s.localize(1,null),s.localize(2,null)],default:"auto",description:s.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,fe,Ne){return Ne===0?Q.accessibilitySupport:Ne}}class b extends R{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:s.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:s.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{insertSpace:u(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var g;(function(j){j[j.Hidden=0]="Hidden",j[j.Blink=1]="Blink",j[j.Smooth=2]="Smooth",j[j.Phase=3]="Phase",j[j.Expand=4]="Expand",j[j.Solid=5]="Solid"})(g=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(j){switch(j){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(j){j[j.Line=1]="Line",j[j.Block=2]="Block",j[j.Underline=3]="Underline",j[j.LineThin=4]="LineThin",j[j.BlockOutline=5]="BlockOutline",j[j.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function v(j){switch(j){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function a(j){switch(j){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class S extends p{constructor(){super(127)}compute(Q,fe,Ne){const Ve=["monaco-editor"];return fe.get(33)&&Ve.push(fe.get(33)),Q.extraEditorClassName&&Ve.push(Q.extraEditorClassName),fe.get(65)==="default"?Ve.push("mouse-default"):fe.get(65)==="copy"&&Ve.push("mouse-copy"),fe.get(99)&&Ve.push("showUnused"),fe.get(125)&&Ve.push("showDeprecated"),Ve.join(" ")}}class I extends d{constructor(){super(32,"emptySelectionClipboard",!0,{description:s.localize(6,null)})}compute(Q,fe,Ne){return Ne&&Q.emptySelectionClipboard}}class N extends R{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:s.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[s.localize(8,null),s.localize(9,null),s.localize(10,null)],description:s.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[s.localize(12,null),s.localize(13,null),s.localize(14,null)],description:s.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:s.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:s.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:s.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{cursorMoveOnType:u(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":D(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":D(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(fe.loop,this.defaultValue.loop)}}}class B extends R{constructor(){super(44,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:s.localize(19,null)},{type:"string",description:s.localize(20,null)}],description:s.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?B.OFF:Q==="true"?B.ON:Q:Boolean(Q)?B.ON:B.OFF}}e.EditorFontLigatures=B,B.OFF='"liga" off, "calt" off',B.ON='"liga" on, "calt" on';class y extends p{constructor(){super(43)}compute(Q,fe,Ne){return Q.fontInfo}}class O extends o{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(22,null)})}validate(Q){const fe=m.float(Q,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(fe,6,100)}compute(Q,fe,Ne){return Q.fontInfo.fontSize}}class z extends R{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:s.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(_.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class U extends R{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[s.localize(25,null),s.localize(26,null),s.localize(27,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:s.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:s.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:s.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ne,description:s.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ne,description:s.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ne,description:s.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ne,description:s.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ne,description:s.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{multiple:D(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??D(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??D(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??D(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??D(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??D(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:h.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:h.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:h.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:h.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:h.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends R{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:s.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,description:s.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:s.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:s.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),delay:_.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:u(fe.sticky,this.defaultValue.sticky),above:u(fe.above,this.defaultValue.above)}}}var W;(function(j){j[j.None=0]="None",j[j.Text=1]="Text",j[j.Blocks=2]="Blocks"})(W=e.RenderMinimap||(e.RenderMinimap={}));class J extends p{constructor(){super(130)}compute(Q,fe,Ne){return J.computeLayout(fe,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const fe=Q.height/Q.lineHeight,Ne=Q.scrollBeyondLastLine?fe-1:0,Ve=(Q.viewLineCount+Ne)/(Q.pixelRatio*Q.height),ot=Math.floor(Q.viewLineCount/Ve);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:Ne,desiredRatio:Ve,minimapLineCount:ot}}static _computeMinimapLayout(Q,fe){const Ne=Q.outerWidth,Ve=Q.outerHeight,ot=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const ht=fe.stableMinimapLayoutInput,Je=ht&&Q.outerHeight===ht.outerHeight&&Q.lineHeight===ht.lineHeight&&Q.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&Q.pixelRatio===ht.pixelRatio&&Q.scrollBeyondLastLine===ht.scrollBeyondLastLine&&Q.minimap.enabled===ht.minimap.enabled&&Q.minimap.side===ht.minimap.side&&Q.minimap.size===ht.minimap.size&&Q.minimap.showSlider===ht.minimap.showSlider&&Q.minimap.renderCharacters===ht.minimap.renderCharacters&&Q.minimap.maxColumn===ht.minimap.maxColumn&&Q.minimap.scale===ht.minimap.scale&&Q.verticalScrollbarWidth===ht.verticalScrollbarWidth&&Q.isViewportWrapping===ht.isViewportWrapping,Tt=Q.lineHeight,Re=Q.typicalHalfwidthCharacterWidth,Ce=Q.scrollBeyondLastLine,pe=Q.minimap.renderCharacters;let ne=ot>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const le=Q.minimap.maxColumn,de=Q.minimap.size,me=Q.minimap.side,Te=Q.verticalScrollbarWidth,We=Q.viewLineCount,Le=Q.remainingWidth,je=Q.isViewportWrapping,it=pe?2:3;let rt=Math.floor(ot*Ve);const re=rt/ot;let ge=!1,ie=!1,V=it*ne,ve=ne/ot,Ie=1;if(de==="fill"||de==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:pt,desiredRatio:yt,minimapLineCount:Ot}=J.computeContainedMinimapLineCount({viewLineCount:We,scrollBeyondLastLine:Ce,height:Ve,lineHeight:Tt,pixelRatio:ot});if(We/Ot>1)ge=!0,ie=!0,ne=1,V=1,ve=ne/ot;else{let It=!1,At=ne+1;if(de==="fit"){const St=Math.ceil((We+pt)*V);je&&Je&&Le<=fe.stableFitRemainingWidth?(It=!0,At=fe.stableFitMaxMinimapScale):It=St>rt}if(de==="fill"||It){ge=!0;const St=ne;V=Math.min(Tt*ot,Math.max(1,Math.floor(1/yt))),je&&Je&&Le<=fe.stableFitRemainingWidth&&(At=fe.stableFitMaxMinimapScale),ne=Math.min(At,Math.max(1,Math.floor(V/it))),ne>St&&(Ie=Math.min(2,ne/St)),ve=ne/ot/Ie,rt=Math.ceil(Math.max(ft,We+pt)*V),je?(fe.stableMinimapLayoutInput=Q,fe.stableFitRemainingWidth=Le,fe.stableFitMaxMinimapScale=ne):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const Ke=Math.floor(le*ve),xe=Math.min(Ke,Math.max(0,Math.floor((Le-Te-2)*ve/(Re+ve)))+e.MINIMAP_GUTTER_WIDTH);let ut=Math.floor(ot*xe);const wt=ut/ot;ut=Math.floor(ut*Ie);const Ct=pe?1:2,bt=me==="left"?0:Ne-xe-Te;return{renderMinimap:Ct,minimapLeft:bt,minimapWidth:xe,minimapHeightIsEditorHeight:ge,minimapIsSampling:ie,minimapScale:ne,minimapLineHeight:V,minimapCanvasInnerWidth:ut,minimapCanvasInnerHeight:rt,minimapCanvasOuterWidth:wt,minimapCanvasOuterHeight:re}}static computeLayout(Q,fe){const Ne=fe.outerWidth|0,Ve=fe.outerHeight|0,ot=fe.lineHeight|0,ht=fe.lineNumbersDigitCount|0,Je=fe.typicalHalfwidthCharacterWidth,Tt=fe.maxDigitWidth,Re=fe.pixelRatio,Ce=fe.viewLineCount,pe=Q.get(122),ne=pe==="inherit"?Q.get(121):pe,le=ne==="inherit"?Q.get(117):ne,de=Q.get(120),me=Q.get(2),Te=fe.isDominatedByLongLines,We=Q.get(49),Le=Q.get(59).renderType!==0,je=Q.get(60),it=Q.get(93),rt=Q.get(64),re=Q.get(91),ge=re.verticalScrollbarSize,ie=re.verticalHasArrows,V=re.arrowSize,ve=re.horizontalScrollbarSize,Ie=Q.get(57),Ke=Q.get(37);let xe;if(typeof Ie=="string"&&/^\d+(\.\d+)?ch$/.test(Ie)){const Et=parseFloat(Ie.substr(0,Ie.length-2));xe=_.clampedInt(Et*Je,0,0,1e3)}else xe=_.clampedInt(Ie,0,0,1e3);Ke&&(xe+=16);let ut=0;if(Le){const Et=Math.max(ht,je);ut=Math.round(Et*Tt)}let wt=0;We&&(wt=ot);let Ct=0,bt=Ct+wt,ft=bt+ut,pt=ft+xe;const yt=Ne-wt-ut-xe;let Ot=!1,kt=!1,It=-1;me!==2&&(ne==="inherit"&&Te?(Ot=!0,kt=!0):le==="on"||le==="bounded"?kt=!0:le==="wordWrapColumn"&&(It=de));const At=J._computeMinimapLayout({outerWidth:Ne,outerHeight:Ve,lineHeight:ot,typicalHalfwidthCharacterWidth:Je,pixelRatio:Re,scrollBeyondLastLine:it,minimap:rt,verticalScrollbarWidth:ge,viewLineCount:Ce,remainingWidth:yt,isViewportWrapping:kt},fe.memory||new A);At.renderMinimap!==0&&At.minimapLeft===0&&(Ct+=At.minimapWidth,bt+=At.minimapWidth,ft+=At.minimapWidth,pt+=At.minimapWidth);const St=yt-At.minimapWidth,zt=Math.max(1,Math.floor((St-ge-2)/Je)),Lt=ie?V:0;return kt&&(It=Math.max(1,zt),le==="bounded"&&(It=Math.min(It,de))),{width:Ne,height:Ve,glyphMarginLeft:Ct,glyphMarginWidth:wt,lineNumbersLeft:bt,lineNumbersWidth:ut,decorationsLeft:ft,decorationsWidth:xe,contentLeft:pt,contentWidth:St,minimap:At,viewportColumn:zt,isWordWrapMinified:Ot,isViewportWrapping:kt,wrappingColumn:It,verticalScrollbarWidth:ge,horizontalScrollbarHeight:ve,overviewRuler:{top:Lt,width:ge,height:Ve-2*Lt,right:0}}}}e.EditorLayoutInfoComputer=J;class G extends R{constructor(){const Q={enabled:!0};super(56,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:s.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}class ae extends R{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:s.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:s.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:s.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),fontSize:_.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:h.string(fe.fontFamily,this.defaultValue.fontFamily)}}}class we extends m{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>m.clamp(Q,0,150),{markdownDescription:s.localize(47,null)})}compute(Q,fe,Ne){return Q.fontInfo.lineHeight}}class Se extends R{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:s.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(49,null),s.localize(50,null),s.localize(51,null)],default:Q.size,description:s.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:s.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:s.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:s.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:s.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),size:D(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:D(fe.side,this.defaultValue.side,["right","left"]),showSlider:D(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(fe.renderCharacters,this.defaultValue.renderCharacters),scale:_.clampedInt(fe.scale,1,1,3),maxColumn:_.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ce(j){return j==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class oe extends R{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{top:_.clampedInt(fe.top,0,0,1e3),bottom:_.clampedInt(fe.bottom,0,0,1e3)}}}class be extends R{constructor(){const Q={enabled:!0,cycle:!1};super(75,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:s.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:s.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),cycle:u(fe.cycle,this.defaultValue.cycle)}}}class Pe extends p{constructor(){super(128)}compute(Q,fe,Ne){return Q.pixelRatio}}class Me extends R{constructor(){const Q={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:s.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:s.localize(63,null)},other:{type:"boolean",default:Q.other,description:s.localize(64,null)}}}],default:Q,description:s.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const fe=Q,Ne={other:u(fe.other,this.defaultValue.other),comments:u(fe.comments,this.defaultValue.comments),strings:u(fe.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var He;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval",j[j.Custom=4]="Custom"})(He=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ye extends R{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(66,null),s.localize(67,null),s.localize(68,null),s.localize(69,null)],default:"on",description:s.localize(70,null)})}validate(Q){let fe=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(fe=4,Ne=Q):Q==="interval"?fe=3:Q==="relative"?fe=2:Q==="on"?fe=1:fe=0),{renderType:fe,renderFn:Ne}}}function Qe(j){const Q=j.get(86);return Q==="editable"?j.get(80):Q!=="on"}e.filterValidationDecorations=Qe;class H extends R{constructor(){const Q=[],fe={type:"number",description:s.localize(71,null)};super(90,"rulers",Q,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:s.localize(72,null),format:"color-hex"}}}]},default:Q,description:s.localize(73,null)})}validate(Q){if(Array.isArray(Q)){const fe=[];for(let Ne of Q)if(typeof Ne=="number")fe.push({column:_.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Ve=Ne;fe.push({column:_.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return fe.sort((Ne,Ve)=>Ne.column-Ve.column),fe}return this.defaultValue}}function K(j,Q){if(typeof j!="string")return Q;switch(j){case"hidden":return 2;case"visible":return 3;default:return 1}}class X extends R{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(74,null),s.localize(75,null),s.localize(76,null)],default:"auto",description:s.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(78,null),s.localize(79,null),s.localize(80,null)],default:"auto",description:s.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:s.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:s.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:s.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q,Ne=_.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=_.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:_.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:K(fe.vertical,this.defaultValue.vertical),horizontal:K(fe.horizontal,this.defaultValue.horizontal),useShadows:u(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:_.clampedInt(fe.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:_.clampedInt(fe.verticalSliderSize,Ve,0,1e3),scrollByPage:u(fe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class se extends R{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(112,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:s.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:s.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:s.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:s.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:s.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:s.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:s.localize(91,null)}})}applyUpdate(Q,fe){let Ne=!1;fe.allowedCharacters&&(k.equals(Q.allowedCharacters,fe.allowedCharacters)||(Q={...Q,allowedCharacters:fe.allowedCharacters},Ne=!0)),fe.allowedLocales&&(k.equals(Q.allowedLocales,fe.allowedLocales)||(Q={...Q,allowedLocales:fe.allowedLocales},Ne=!0));const Ve=super.applyUpdate(Q,fe);return Ne?new w(Ve.newValue,!0):Ve}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{nonBasicASCII:Ae(fe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(fe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(fe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(fe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(fe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,fe){if(typeof Q!="object"||!Q)return fe;const Ne={};for(const[Ve,ot]of Object.entries(Q))ot===!0&&(Ne[Ve]=!0);return Ne}}class q extends R{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:s.localize(92,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),mode:D(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class te extends R{constructor(){const Q={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:s.localize(93,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}class he extends R{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(94,null),s.localize(95,null),s.localize(96,null)],default:Q.bracketPairs,description:s.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(98,null),s.localize(99,null),s.localize(100,null)],default:Q.bracketPairsHorizontal,description:s.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:s.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:s.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:s.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{bracketPairs:Ae(fe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(fe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(fe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(fe.indentation,this.defaultValue.indentation),highlightActiveIndentation:u(fe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Ae(j,Q,fe){const Ne=fe.indexOf(j);return Ne===-1?Q:fe[Ne]}class Ue extends R{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(105,null),s.localize(106,null)],default:Q.insertMode,description:s.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:s.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:s.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:s.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:s.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:s.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:s.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:s.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:s.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(146,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{insertMode:D(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(fe.showIcons,this.defaultValue.showIcons),showStatusBar:u(fe.showStatusBar,this.defaultValue.showStatusBar),preview:u(fe.preview,this.defaultValue.preview),previewMode:D(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(fe.showMethods,this.defaultValue.showMethods),showFunctions:u(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:u(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(fe.showDeprecated,this.defaultValue.showDeprecated),showFields:u(fe.showFields,this.defaultValue.showFields),showVariables:u(fe.showVariables,this.defaultValue.showVariables),showClasses:u(fe.showClasses,this.defaultValue.showClasses),showStructs:u(fe.showStructs,this.defaultValue.showStructs),showInterfaces:u(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:u(fe.showModules,this.defaultValue.showModules),showProperties:u(fe.showProperties,this.defaultValue.showProperties),showEvents:u(fe.showEvents,this.defaultValue.showEvents),showOperators:u(fe.showOperators,this.defaultValue.showOperators),showUnits:u(fe.showUnits,this.defaultValue.showUnits),showValues:u(fe.showValues,this.defaultValue.showValues),showConstants:u(fe.showConstants,this.defaultValue.showConstants),showEnums:u(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:u(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(fe.showKeywords,this.defaultValue.showKeywords),showWords:u(fe.showWords,this.defaultValue.showWords),showColors:u(fe.showColors,this.defaultValue.showColors),showFiles:u(fe.showFiles,this.defaultValue.showFiles),showReferences:u(fe.showReferences,this.defaultValue.showReferences),showFolders:u(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:u(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(fe.showSnippets,this.defaultValue.showSnippets),showUsers:u(fe.showUsers,this.defaultValue.showUsers),showIssues:u(fe.showIssues,this.defaultValue.showIssues)}}}class ze extends R{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(147,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ge extends p{constructor(){super(129)}compute(Q,fe,Ne){return fe.get(80)?!0:Q.tabFocusMode}}var et;(function(j){j[j.None=0]="None",j[j.Same=1]="Same",j[j.Indent=2]="Indent",j[j.DeepIndent=3]="DeepIndent"})(et=e.WrappingIndent||(e.WrappingIndent={}));function st(j){switch(j){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Xe extends p{constructor(){super(131)}compute(Q,fe,Ne){const Ve=fe.get(130);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const nt="Consolas, 'Courier New', monospace",lt="Menlo, Monaco, 'Courier New', monospace",vt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?lt:t.isLinux?vt:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Oe(j){return e.editorOptionsRegistry[j.id]=j,j}var Rt;(function(j){j[j.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",j[j.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",j[j.accessibilitySupport=2]="accessibilitySupport",j[j.accessibilityPageSize=3]="accessibilityPageSize",j[j.ariaLabel=4]="ariaLabel",j[j.autoClosingBrackets=5]="autoClosingBrackets",j[j.autoClosingDelete=6]="autoClosingDelete",j[j.autoClosingOvertype=7]="autoClosingOvertype",j[j.autoClosingQuotes=8]="autoClosingQuotes",j[j.autoIndent=9]="autoIndent",j[j.automaticLayout=10]="automaticLayout",j[j.autoSurround=11]="autoSurround",j[j.bracketPairColorization=12]="bracketPairColorization",j[j.guides=13]="guides",j[j.codeLens=14]="codeLens",j[j.codeLensFontFamily=15]="codeLensFontFamily",j[j.codeLensFontSize=16]="codeLensFontSize",j[j.colorDecorators=17]="colorDecorators",j[j.columnSelection=18]="columnSelection",j[j.comments=19]="comments",j[j.contextmenu=20]="contextmenu",j[j.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",j[j.cursorBlinking=22]="cursorBlinking",j[j.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",j[j.cursorStyle=24]="cursorStyle",j[j.cursorSurroundingLines=25]="cursorSurroundingLines",j[j.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",j[j.cursorWidth=27]="cursorWidth",j[j.disableLayerHinting=28]="disableLayerHinting",j[j.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",j[j.domReadOnly=30]="domReadOnly",j[j.dragAndDrop=31]="dragAndDrop",j[j.emptySelectionClipboard=32]="emptySelectionClipboard",j[j.extraEditorClassName=33]="extraEditorClassName",j[j.fastScrollSensitivity=34]="fastScrollSensitivity",j[j.find=35]="find",j[j.fixedOverflowWidgets=36]="fixedOverflowWidgets",j[j.folding=37]="folding",j[j.foldingStrategy=38]="foldingStrategy",j[j.foldingHighlight=39]="foldingHighlight",j[j.foldingImportsByDefault=40]="foldingImportsByDefault",j[j.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",j[j.fontFamily=42]="fontFamily",j[j.fontInfo=43]="fontInfo",j[j.fontLigatures=44]="fontLigatures",j[j.fontSize=45]="fontSize",j[j.fontWeight=46]="fontWeight",j[j.formatOnPaste=47]="formatOnPaste",j[j.formatOnType=48]="formatOnType",j[j.glyphMargin=49]="glyphMargin",j[j.gotoLocation=50]="gotoLocation",j[j.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",j[j.hover=52]="hover",j[j.inDiffEditor=53]="inDiffEditor",j[j.inlineSuggest=54]="inlineSuggest",j[j.letterSpacing=55]="letterSpacing",j[j.lightbulb=56]="lightbulb",j[j.lineDecorationsWidth=57]="lineDecorationsWidth",j[j.lineHeight=58]="lineHeight",j[j.lineNumbers=59]="lineNumbers",j[j.lineNumbersMinChars=60]="lineNumbersMinChars",j[j.linkedEditing=61]="linkedEditing",j[j.links=62]="links",j[j.matchBrackets=63]="matchBrackets",j[j.minimap=64]="minimap",j[j.mouseStyle=65]="mouseStyle",j[j.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",j[j.mouseWheelZoom=67]="mouseWheelZoom",j[j.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",j[j.multiCursorModifier=69]="multiCursorModifier",j[j.multiCursorPaste=70]="multiCursorPaste",j[j.occurrencesHighlight=71]="occurrencesHighlight",j[j.overviewRulerBorder=72]="overviewRulerBorder",j[j.overviewRulerLanes=73]="overviewRulerLanes",j[j.padding=74]="padding",j[j.parameterHints=75]="parameterHints",j[j.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",j[j.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",j[j.quickSuggestions=78]="quickSuggestions",j[j.quickSuggestionsDelay=79]="quickSuggestionsDelay",j[j.readOnly=80]="readOnly",j[j.renameOnType=81]="renameOnType",j[j.renderControlCharacters=82]="renderControlCharacters",j[j.renderFinalNewline=83]="renderFinalNewline",j[j.renderLineHighlight=84]="renderLineHighlight",j[j.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",j[j.renderValidationDecorations=86]="renderValidationDecorations",j[j.renderWhitespace=87]="renderWhitespace",j[j.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",j[j.roundedSelection=89]="roundedSelection",j[j.rulers=90]="rulers",j[j.scrollbar=91]="scrollbar",j[j.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",j[j.scrollBeyondLastLine=93]="scrollBeyondLastLine",j[j.scrollPredominantAxis=94]="scrollPredominantAxis",j[j.selectionClipboard=95]="selectionClipboard",j[j.selectionHighlight=96]="selectionHighlight",j[j.selectOnLineNumbers=97]="selectOnLineNumbers",j[j.showFoldingControls=98]="showFoldingControls",j[j.showUnused=99]="showUnused",j[j.snippetSuggestions=100]="snippetSuggestions",j[j.smartSelect=101]="smartSelect",j[j.smoothScrolling=102]="smoothScrolling",j[j.stickyTabStops=103]="stickyTabStops",j[j.stopRenderingLineAfter=104]="stopRenderingLineAfter",j[j.suggest=105]="suggest",j[j.suggestFontSize=106]="suggestFontSize",j[j.suggestLineHeight=107]="suggestLineHeight",j[j.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",j[j.suggestSelection=109]="suggestSelection",j[j.tabCompletion=110]="tabCompletion",j[j.tabIndex=111]="tabIndex",j[j.unicodeHighlighting=112]="unicodeHighlighting",j[j.unusualLineTerminators=113]="unusualLineTerminators",j[j.useShadowDOM=114]="useShadowDOM",j[j.useTabStops=115]="useTabStops",j[j.wordSeparators=116]="wordSeparators",j[j.wordWrap=117]="wordWrap",j[j.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",j[j.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",j[j.wordWrapColumn=120]="wordWrapColumn",j[j.wordWrapOverride1=121]="wordWrapOverride1",j[j.wordWrapOverride2=122]="wordWrapOverride2",j[j.wrappingIndent=123]="wrappingIndent",j[j.wrappingStrategy=124]="wrappingStrategy",j[j.showDeprecated=125]="showDeprecated",j[j.inlayHints=126]="inlayHints",j[j.editorClassName=127]="editorClassName",j[j.pixelRatio=128]="pixelRatio",j[j.tabFocusMode=129]="tabFocusMode",j[j.layoutInfo=130]="layoutInfo",j[j.wrappingInfo=131]="wrappingInfo"})(Rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(148,null)})),acceptSuggestionOnEnter:Oe(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(149,null),""],markdownDescription:s.localize(150,null)})),accessibilitySupport:Oe(new n),accessibilityPageSize:Oe(new _(3,"accessibilityPageSize",10,1,1073741824,{description:s.localize(151,null)})),ariaLabel:Oe(new h(4,"ariaLabel",s.localize(152,null))),autoClosingBrackets:Oe(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(153,null),s.localize(154,null),""],description:s.localize(155,null)})),autoClosingDelete:Oe(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(156,null),""],description:s.localize(157,null)})),autoClosingOvertype:Oe(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(158,null),""],description:s.localize(159,null)})),autoClosingQuotes:Oe(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(160,null),s.localize(161,null),""],description:s.localize(162,null)})),autoIndent:Oe(new M(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[s.localize(163,null),s.localize(164,null),s.localize(165,null),s.localize(166,null),s.localize(167,null)],description:s.localize(168,null)})),automaticLayout:Oe(new d(10,"automaticLayout",!1)),autoSurround:Oe(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(169,null),s.localize(170,null),s.localize(171,null),""],description:s.localize(172,null)})),bracketPairColorization:Oe(new te),bracketPairGuides:Oe(new he),stickyTabStops:Oe(new d(103,"stickyTabStops",!1,{description:s.localize(173,null)})),codeLens:Oe(new d(14,"codeLens",!0,{description:s.localize(174,null)})),codeLensFontFamily:Oe(new h(15,"codeLensFontFamily","",{description:s.localize(175,null)})),codeLensFontSize:Oe(new _(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(176,null)})),colorDecorators:Oe(new d(17,"colorDecorators",!0,{description:s.localize(177,null)})),columnSelection:Oe(new d(18,"columnSelection",!1,{description:s.localize(178,null)})),comments:Oe(new b),contextmenu:Oe(new d(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new d(21,"copyWithSyntaxHighlighting",!0,{description:s.localize(179,null)})),cursorBlinking:Oe(new M(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:s.localize(180,null)})),cursorSmoothCaretAnimation:Oe(new d(23,"cursorSmoothCaretAnimation",!1,{description:s.localize(181,null)})),cursorStyle:Oe(new M(24,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],a,{description:s.localize(182,null)})),cursorSurroundingLines:Oe(new _(25,"cursorSurroundingLines",0,0,1073741824,{description:s.localize(183,null)})),cursorSurroundingLinesStyle:Oe(new l(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(184,null),s.localize(185,null)],description:s.localize(186,null)})),cursorWidth:Oe(new _(27,"cursorWidth",0,0,1073741824,{markdownDescription:s.localize(187,null)})),disableLayerHinting:Oe(new d(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new d(29,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new d(30,"domReadOnly",!1)),dragAndDrop:Oe(new d(31,"dragAndDrop",!0,{description:s.localize(188,null)})),emptySelectionClipboard:Oe(new I),extraEditorClassName:Oe(new h(33,"extraEditorClassName","")),fastScrollSensitivity:Oe(new m(34,"fastScrollSensitivity",5,j=>j<=0?5:j,{markdownDescription:s.localize(189,null)})),find:Oe(new N),fixedOverflowWidgets:Oe(new d(36,"fixedOverflowWidgets",!1)),folding:Oe(new d(37,"folding",!0,{description:s.localize(190,null)})),foldingStrategy:Oe(new l(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(191,null),s.localize(192,null)],description:s.localize(193,null)})),foldingHighlight:Oe(new d(39,"foldingHighlight",!0,{description:s.localize(194,null)})),foldingImportsByDefault:Oe(new d(40,"foldingImportsByDefault",!1,{description:s.localize(195,null)})),unfoldOnClickAfterEndOfLine:Oe(new d(41,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(196,null)})),fontFamily:Oe(new h(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(197,null)})),fontInfo:Oe(new y),fontLigatures2:Oe(new B),fontSize:Oe(new O),fontWeight:Oe(new z),formatOnPaste:Oe(new d(47,"formatOnPaste",!1,{description:s.localize(198,null)})),formatOnType:Oe(new d(48,"formatOnType",!1,{description:s.localize(199,null)})),glyphMargin:Oe(new d(49,"glyphMargin",!0,{description:s.localize(200,null)})),gotoLocation:Oe(new U),hideCursorInOverviewRuler:Oe(new d(51,"hideCursorInOverviewRuler",!1,{description:s.localize(201,null)})),hover:Oe(new $),inDiffEditor:Oe(new d(53,"inDiffEditor",!1)),letterSpacing:Oe(new m(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,j=>m.clamp(j,-5,20),{description:s.localize(202,null)})),lightbulb:Oe(new G),lineDecorationsWidth:Oe(new o(57,"lineDecorationsWidth",10)),lineHeight:Oe(new we),lineNumbers:Oe(new Ye),lineNumbersMinChars:Oe(new _(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new d(61,"linkedEditing",!1,{description:s.localize(203,null)})),links:Oe(new d(62,"links",!0,{description:s.localize(204,null)})),matchBrackets:Oe(new l(63,"matchBrackets","always",["always","near","never"],{description:s.localize(205,null)})),minimap:Oe(new Se),mouseStyle:Oe(new l(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new m(66,"mouseWheelScrollSensitivity",1,j=>j===0?1:j,{markdownDescription:s.localize(206,null)})),mouseWheelZoom:Oe(new d(67,"mouseWheelZoom",!1,{markdownDescription:s.localize(207,null)})),multiCursorMergeOverlapping:Oe(new d(68,"multiCursorMergeOverlapping",!0,{description:s.localize(208,null)})),multiCursorModifier:Oe(new M(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ce,{markdownEnumDescriptions:[s.localize(209,null),s.localize(210,null)],markdownDescription:s.localize(211,null)})),multiCursorPaste:Oe(new l(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(212,null),s.localize(213,null)],markdownDescription:s.localize(214,null)})),occurrencesHighlight:Oe(new d(71,"occurrencesHighlight",!0,{description:s.localize(215,null)})),overviewRulerBorder:Oe(new d(72,"overviewRulerBorder",!0,{description:s.localize(216,null)})),overviewRulerLanes:Oe(new _(73,"overviewRulerLanes",3,0,3)),padding:Oe(new oe),parameterHints:Oe(new be),peekWidgetDefaultFocus:Oe(new l(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(217,null),s.localize(218,null)],description:s.localize(219,null)})),definitionLinkOpensInPeek:Oe(new d(77,"definitionLinkOpensInPeek",!1,{description:s.localize(220,null)})),quickSuggestions:Oe(new Me),quickSuggestionsDelay:Oe(new _(79,"quickSuggestionsDelay",10,0,1073741824,{description:s.localize(221,null)})),readOnly:Oe(new d(80,"readOnly",!1)),renameOnType:Oe(new d(81,"renameOnType",!1,{description:s.localize(222,null),markdownDeprecationMessage:s.localize(223,null)})),renderControlCharacters:Oe(new d(82,"renderControlCharacters",!0,{description:s.localize(224,null),restricted:!0})),renderFinalNewline:Oe(new d(83,"renderFinalNewline",!0,{description:s.localize(225,null)})),renderLineHighlight:Oe(new l(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(226,null)],description:s.localize(227,null)})),renderLineHighlightOnlyWhenFocus:Oe(new d(85,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(228,null)})),renderValidationDecorations:Oe(new l(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new l(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(229,null),s.localize(230,null),s.localize(231,null),""],description:s.localize(232,null)})),revealHorizontalRightPadding:Oe(new _(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Oe(new d(89,"roundedSelection",!0,{description:s.localize(233,null)})),rulers:Oe(new H),scrollbar:Oe(new X),scrollBeyondLastColumn:Oe(new _(92,"scrollBeyondLastColumn",5,0,1073741824,{description:s.localize(234,null)})),scrollBeyondLastLine:Oe(new d(93,"scrollBeyondLastLine",!0,{description:s.localize(235,null)})),scrollPredominantAxis:Oe(new d(94,"scrollPredominantAxis",!0,{description:s.localize(236,null)})),selectionClipboard:Oe(new d(95,"selectionClipboard",!0,{description:s.localize(237,null),included:t.isLinux})),selectionHighlight:Oe(new d(96,"selectionHighlight",!0,{description:s.localize(238,null)})),selectOnLineNumbers:Oe(new d(97,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new l(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[s.localize(239,null),s.localize(240,null)],description:s.localize(241,null)})),showUnused:Oe(new d(99,"showUnused",!0,{description:s.localize(242,null)})),showDeprecated:Oe(new d(125,"showDeprecated",!0,{description:s.localize(243,null)})),inlayHints:Oe(new ae),snippetSuggestions:Oe(new l(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(244,null),s.localize(245,null),s.localize(246,null),s.localize(247,null)],description:s.localize(248,null)})),smartSelect:Oe(new ze),smoothScrolling:Oe(new d(102,"smoothScrolling",!1,{description:s.localize(249,null)})),stopRenderingLineAfter:Oe(new _(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new Ue),inlineSuggest:Oe(new q),suggestFontSize:Oe(new _(106,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(250,null)})),suggestLineHeight:Oe(new _(107,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(251,null)})),suggestOnTriggerCharacters:Oe(new d(108,"suggestOnTriggerCharacters",!0,{description:s.localize(252,null)})),suggestSelection:Oe(new l(109,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(253,null),s.localize(254,null),s.localize(255,null)],description:s.localize(256,null)})),tabCompletion:Oe(new l(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(257,null),s.localize(258,null),s.localize(259,null)],description:s.localize(260,null)})),tabIndex:Oe(new _(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new se),unusualLineTerminators:Oe(new l(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(261,null),s.localize(262,null),s.localize(263,null)],description:s.localize(264,null)})),useShadowDOM:Oe(new d(114,"useShadowDOM",!0)),useTabStops:Oe(new d(115,"useTabStops",!0,{description:s.localize(265,null)})),wordSeparators:Oe(new h(116,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:s.localize(266,null)})),wordWrap:Oe(new l(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(267,null),s.localize(268,null),s.localize(269,null),s.localize(270,null)],description:s.localize(271,null)})),wordWrapBreakAfterCharacters:Oe(new h(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new h(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new _(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:s.localize(272,null)})),wordWrapOverride1:Oe(new l(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new l(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Oe(new M(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],st,{enumDescriptions:[s.localize(273,null),s.localize(274,null),s.localize(275,null),s.localize(276,null)],description:s.localize(277,null)})),wrappingStrategy:Oe(new l(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[s.localize(278,null),s.localize(279,null)],description:s.localize(280,null)})),editorClassName:Oe(new S),pixelRatio:Oe(new Pe),tabFocusMode:Oe(new Ge),layoutInfo:Oe(new J),wrappingInfo:Oe(new Xe)}}),define(Ee[114],ye([18,19]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[115],ye([18,19]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[116],ye([18,19]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ee[117],ye([18,19]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ee[118],ye([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[119],ye([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[120],ye([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[121],ye([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[122],ye([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[123],ye([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[124],ye([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[125],ye([18,19]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ee[126],ye([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[127],ye([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Ee[128],ye([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[129],ye([18,19]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[130],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var s;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(s=e.EditorActivation||(e.EditorActivation={}));var t;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var E;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[131],ye([0,1,115]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function T(i){return i=i.trim(),i==="*"||t.test(i)}e.isValidVersionStr=T;function k(i){if(!T(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=i.match(t);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=k;function P(i){if(!i)return null;let p=i.majorBase,o=i.majorMustEqual,u=i.minorBase,d=i.minorMustEqual,F=i.patchBase,_=i.patchMustEqual;i.hasCaret&&(p===0||(d=!1),_=!1);let m=0;if(i.preRelease){const h=E.exec(i.preRelease);if(h){const[,D,l,M]=h;m=Date.UTC(Number(D),Number(l)-1,Number(M))}}return{majorBase:p,majorMustEqual:o,minorBase:u,minorMustEqual:d,patchBase:F,patchMustEqual:_,isMinimum:i.hasGreaterEquals,notBefore:m}}e.normalizeVersion=P;function C(i,p,o){let u;typeof i=="string"?u=P(k(i)):u=i;let d;p instanceof Date?d=p.getTime():typeof p=="string"&&(d=new Date(p).getTime());let F;if(typeof o=="string"?F=P(k(o)):F=o,!u||!F)return!1;let _=u.majorBase,m=u.minorBase,h=u.patchBase,D=F.majorBase,l=F.minorBase,M=F.patchBase,r=F.notBefore,n=F.majorMustEqual,b=F.minorMustEqual,g=F.patchMustEqual;return F.isMinimum?_>D?!0:_<D?!1:m>l?!0:m<l||d&&d<r?!1:h>=M:(_===1&&D===0&&(!n||!b||!g)&&(D=1,l=0,M=0,n=!0,b=!1,g=!1),_<D?!1:_>D?!n:m<l?!1:m>l?!b:h<M?!1:h>M?!g:!(d&&d<r))}e.isValidVersion=C;function A(i,p,o,u){return o.isBuiltin||typeof o.main=="undefined"?!0:w(i,p,o.engines.vscode,u)}e.isValidExtensionVersion=A;function R(i,p,o){return i==="*"||w(p,o,i)}e.isEngineValid=R;function w(i,p,o,u=[]){let d=P(k(o));if(!d)return u.push(s.localize(0,null,o)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return u.push(s.localize(1,null,o)),!1}else if(!d.majorMustEqual)return u.push(s.localize(2,null,o)),!1;return C(i,p,d)?!0:(u.push(s.localize(3,null,i,o)),!1)}}),define(Ee[80],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class s{constructor(E,T=[],k=!1){this.ctor=E,this.staticArguments=T,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=s}),define(Ee[44],ye([0,1,80]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function E(k,P,C){P instanceof s.SyncDescriptor||(P=new s.SyncDescriptor(P,[],C)),t.push([k,P])}e.registerSingleton=E;function T(){return t}e.getSingletonServiceDescriptors=T}),define(Ee[132],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class s{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=s;class t{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let k of this._nodes.values())k.outgoing.size===0&&T.push(k);return T}insertEdge(T,k){const P=this.lookupOrInsertNode(T),C=this.lookupOrInsertNode(k);P.outgoing.set(this._hashFn(k),C),C.incoming.set(this._hashFn(T),P)}removeNode(T){const k=this._hashFn(T);this._nodes.delete(k);for(let P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(T){const k=this._hashFn(T);let P=this._nodes.get(k);return P||(P=new s(T),this._nodes.set(k,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[k,P]of this._nodes)T.push(`${k}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,k]of this._nodes){const P=new Set([T]),C=this._findCycle(k,P);if(C)return C}}_findCycle(T,k){for(let[P,C]of T.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const A=this._findCycle(C,k);if(A)return A;k.delete(P)}}}e.Graph=t}),define(Ee[3],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var s;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function P(C){return C[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=P})(s=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function t(k,P,C,A){P[s.DI_TARGET]===P?P[s.DI_DEPENDENCIES].push({id:k,index:C,optional:A}):(P[s.DI_DEPENDENCIES]=[{id:k,index:C,optional:A}],P[s.DI_TARGET]=P)}function E(k){if(s.serviceIds.has(k))return s.serviceIds.get(k);const P=function(C,A,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,C,R,!1)};return P.toString=()=>k,s.serviceIds.set(k,P),P}e.createDecorator=E;function T(k){return k}e.refineServiceDecorator=T}),define(Ee[133],ye([0,1,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,s.createDecorator)("modelService");function t(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(Ee[134],ye([0,1,4,57,6,21,75,56,133]),function(ee,e,s,t,E,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function A(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(A):!!u.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new s.Emitter}get onDidChange(){return this._onDidChange.event}register(d,F){let _={selector:d,provider:F,_score:-1,_time:this._clock++};return this._entries.push(_),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(_){const m=this._entries.indexOf(_);m>=0&&(this._entries.splice(m,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),_=void 0)}})}has(d){return this.all(d).length>0}all(d){if(!d)return[];this._updateScores(d);const F=[];for(let _ of this._entries)_._score>0&&F.push(_.provider);return F}ordered(d){const F=[];return this._orderedForEach(d,_=>F.push(_.provider)),F}orderedGroups(d){const F=[];let _,m;return this._orderedForEach(d,h=>{_&&m===h._score?_.push(h.provider):(m=h._score,_=[h.provider],F.push(_))}),F}_orderedForEach(d,F){if(!!d){this._updateScores(d);for(const _ of this._entries)_._score>0&&F(_)}}_updateScores(d){const F={uri:d.uri.toString(),language:d.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===F.language&&this._lastCandidate.uri===F.uri)){this._lastCandidate=F;for(let _ of this._entries)if(_._score=(0,P.score)(_.selector,d.uri,d.getLanguageId(),(0,C.shouldSynchronizeModel)(d)),A(_.selector)&&_._score>0){for(let m of this._entries)m._score=0;_._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(d,F){return d._score<F._score?1:d._score>F._score?-1:d._time<F._time?1:d._time>F._time?-1:0}}e.LanguageFeatureRegistry=R;const w=new WeakMap;let i=0;function p(u){let d=w.get(u);return d===void 0&&(d=++i,w.set(u,d)),d}class o{constructor(d,F,_=Number.MAX_SAFE_INTEGER){this._registry=d,this.min=F,this.max=_,this._cache=new T.LRUCache(50,.7)}_key(d){return d.id+this._registry.all(d).reduce((F,_)=>(0,t.doHash)(p(_),F),0)}_clamp(d){return d===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(d*1.3)))}get(d){const F=this._key(d),_=this._cache.get(F);return this._clamp(_?.value)}update(d,F){const _=this._key(d);let m=this._cache.get(_);return m||(m=new k.MovingAverage,this._cache.set(_,m)),m.update(F),this.get(d)}}e.LanguageFeatureRequestDelays=o}),define(Ee[58],ye([0,1,2,59,134,107,52]),function(ee,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));var C;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline",a[a.Strikethrough=8]="Strikethrough"})(C=e.FontStyle||(e.FontStyle={}));var A;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(A=e.ColorId||(e.ColorId={}));var R;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var w;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=1024]="ITALIC_MASK",a[a.BOLD_MASK=2048]="BOLD_MASK",a[a.UNDERLINE_MASK=4096]="UNDERLINE_MASK",a[a.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",a[a.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(w=e.MetadataConsts||(e.MetadataConsts={}));class i{static getLanguageId(S){return(S&255)>>>0}static getTokenType(S){return(S&768)>>>8}static getFontStyle(S){return(S&15360)>>>10}static getForeground(S){return(S&8372224)>>>14}static getBackground(S){return(S&4286578688)>>>23}static getClassNameFromMetadata(S){const I=this.getForeground(S);let N="mtk"+I;const B=this.getFontStyle(S);return B&1&&(N+=" mtki"),B&2&&(N+=" mtkb"),B&4&&(N+=" mtku"),B&8&&(N+=" mtks"),N}static getInlineStyleFromMetadata(S,I){const N=this.getForeground(S),B=this.getFontStyle(S);let y=`color: ${I[N]};`;B&1&&(y+="font-style: italic;"),B&2&&(y+="font-weight: bold;");let O="";return B&4&&(O+=" underline"),B&8&&(O+=" line-through"),O&&(y+=`text-decoration:${O};`),y}}e.TokenMetadata=i;var p;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(p=e.CompletionItemKind||(e.CompletionItemKind={}));var o;(function(a){const S=new Map;S.set(0,k.Codicon.symbolMethod),S.set(1,k.Codicon.symbolFunction),S.set(2,k.Codicon.symbolConstructor),S.set(3,k.Codicon.symbolField),S.set(4,k.Codicon.symbolVariable),S.set(5,k.Codicon.symbolClass),S.set(6,k.Codicon.symbolStruct),S.set(7,k.Codicon.symbolInterface),S.set(8,k.Codicon.symbolModule),S.set(9,k.Codicon.symbolProperty),S.set(10,k.Codicon.symbolEvent),S.set(11,k.Codicon.symbolOperator),S.set(12,k.Codicon.symbolUnit),S.set(13,k.Codicon.symbolValue),S.set(15,k.Codicon.symbolEnum),S.set(14,k.Codicon.symbolConstant),S.set(15,k.Codicon.symbolEnum),S.set(16,k.Codicon.symbolEnumMember),S.set(17,k.Codicon.symbolKeyword),S.set(27,k.Codicon.symbolSnippet),S.set(18,k.Codicon.symbolText),S.set(19,k.Codicon.symbolColor),S.set(20,k.Codicon.symbolFile),S.set(21,k.Codicon.symbolReference),S.set(22,k.Codicon.symbolCustomColor),S.set(23,k.Codicon.symbolFolder),S.set(24,k.Codicon.symbolTypeParameter),S.set(25,k.Codicon.account),S.set(26,k.Codicon.issues);function I(y){let O=S.get(y);return O||(console.info("No codicon found for CompletionItemKind "+y),O=k.Codicon.symbolProperty),O}a.toIcon=I;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function B(y,O){let z=N.get(y);return typeof z=="undefined"&&!O&&(z=9),z}a.fromString=B})(o=e.CompletionItemKinds||(e.CompletionItemKinds={}));var u;(function(a){a[a.Deprecated=1]="Deprecated"})(u=e.CompletionItemTag||(e.CompletionItemTag={}));var d;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(d=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var F;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(F=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var m;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(m=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var D;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(D=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function l(a){return a&&s.URI.isUri(a.uri)&&t.Range.isIRange(a.range)&&(t.Range.isIRange(a.originSelectionRange)||t.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=l;var M;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(M=e.SymbolKind||(e.SymbolKind={}));var r;(function(a){a[a.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var n;(function(a){const S=new Map;S.set(0,k.Codicon.symbolFile),S.set(1,k.Codicon.symbolModule),S.set(2,k.Codicon.symbolNamespace),S.set(3,k.Codicon.symbolPackage),S.set(4,k.Codicon.symbolClass),S.set(5,k.Codicon.symbolMethod),S.set(6,k.Codicon.symbolProperty),S.set(7,k.Codicon.symbolField),S.set(8,k.Codicon.symbolConstructor),S.set(9,k.Codicon.symbolEnum),S.set(10,k.Codicon.symbolInterface),S.set(11,k.Codicon.symbolFunction),S.set(12,k.Codicon.symbolVariable),S.set(13,k.Codicon.symbolConstant),S.set(14,k.Codicon.symbolString),S.set(15,k.Codicon.symbolNumber),S.set(16,k.Codicon.symbolBoolean),S.set(17,k.Codicon.symbolArray),S.set(18,k.Codicon.symbolObject),S.set(19,k.Codicon.symbolKey),S.set(20,k.Codicon.symbolNull),S.set(21,k.Codicon.symbolEnumMember),S.set(22,k.Codicon.symbolStruct),S.set(23,k.Codicon.symbolEvent),S.set(24,k.Codicon.symbolOperator),S.set(25,k.Codicon.symbolTypeParameter);function I(N){let B=S.get(N);return B||(console.info("No codicon found for SymbolKind "+N),B=k.Codicon.symbolProperty),B}a.toIcon=I})(n=e.SymbolKinds||(e.SymbolKinds={}));class b{constructor(S){this.value=S}}e.FoldingRangeKind=b,b.Comment=new b("comment"),b.Imports=new b("imports"),b.Region=new b("region");var g;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(g=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var f;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(f=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistry;var v;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(v=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ee[81],ye([0,1,10,2,3]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationOverrides=T;function k(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||s.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var P;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function A(d,F){const _=Object.create(null);for(let m in d)R(_,m,d[m],F);return _}e.toValuesTree=A;function R(d,F,_,m){const h=F.split("."),D=h.pop();let l=d;for(let M=0;M<h.length;M++){let r=h[M],n=l[r];switch(typeof n){case"undefined":n=l[r]=Object.create(null);break;case"object":break;default:m(`Ignoring ${F} as ${h.slice(0,M+1).join(".")} is ${JSON.stringify(n)}`);return}l=n}if(typeof l=="object"&&l!==null)try{l[D]=_}catch{m(`Ignoring ${F} as ${h.join(".")} is ${JSON.stringify(l)}`)}else m(`Ignoring ${F} as ${h.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=R;function w(d,F){const _=F.split(".");i(d,_)}e.removeFromValueTree=w;function i(d,F){const _=F.shift();if(F.length===0){delete d[_];return}if(Object.keys(d).indexOf(_)!==-1){const m=d[_];typeof m=="object"&&!Array.isArray(m)&&(i(m,F),Object.keys(m).length===0&&delete d[_])}}function p(d,F,_){function m(l,M){let r=l;for(const n of M){if(typeof r!="object"||r===null)return;r=r[n]}return r}const h=F.split("."),D=m(d,h);return typeof D=="undefined"?_:D}e.getConfigurationValue=p;function o(d,F,_){Object.keys(F).forEach(m=>{m!=="__proto__"&&(m in d?s.isObject(d[m])&&s.isObject(F[m])?o(d[m],F[m],_):_&&(d[m]=F[m]):d[m]=F[m])})}e.merge=o;function u(d,F,_){const m=d.inspect(F),h=d.inspect(_);return typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:m.defaultValue}e.getMigratedSettingValue=u}),define(Ee[45],ye([0,1,23,9,3]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=s.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",s.isMacintosh),k.set("isLinux",s.isLinux),k.set("isWindows",s.isWindows),k.set("isWeb",s.isWeb),k.set("isMacNative",s.isMacintosh&&!s.isWeb),k.set("isEdge",T.indexOf("Edg/")>=0),k.set("isFirefox",T.indexOf("Firefox")>=0),k.set("isChrome",T.indexOf("Chrome")>=0),k.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var C;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class A{static false(){return i.INSTANCE}static true(){return p.INSTANCE}static has(y){return o.create(y)}static equals(y,O){return u.create(y,O)}static notEquals(y,O){return _.create(y,O)}static regex(y,O){return n.create(y,O)}static in(y,O){return d.create(y,O)}static not(y){return m.create(y)}static and(...y){return c.create(y,null)}static or(...y){return f.create(y,null,!0)}static greater(y,O){return D.create(y,O)}static greaterEquals(y,O){return l.create(y,O)}static smaller(y,O){return M.create(y,O)}static smallerEquals(y,O){return r.create(y,O)}static deserialize(y,O=!1){if(!!y)return this._deserializeOrExpression(y,O)}static _deserializeOrExpression(y,O){let z=y.split("||");return f.create(z.map(U=>this._deserializeAndExpression(U,O)),null,!0)}static _deserializeAndExpression(y,O){let z=y.split("&&");return c.create(z.map(U=>this._deserializeOne(U,O)),null)}static _deserializeOne(y,O){if(y=y.trim(),y.indexOf("!=")>=0){let z=y.split("!=");return _.create(z[0].trim(),this._deserializeValue(z[1],O))}if(y.indexOf("==")>=0){let z=y.split("==");return u.create(z[0].trim(),this._deserializeValue(z[1],O))}if(y.indexOf("=~")>=0){let z=y.split("=~");return n.create(z[0].trim(),this._deserializeRegexValue(z[1],O))}if(y.indexOf(" in ")>=0){let z=y.split(" in ");return d.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const z=y.split(">=");return l.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const z=y.split(">");return D.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const z=y.split("<=");return r.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const z=y.split("<");return M.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(y)?m.create(y.substr(1).trim()):o.create(y)}static _deserializeValue(y,O){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let z=/^'([^']*)'$/.exec(y);return z?z[1].trim():y}static _deserializeRegexValue(y,O){if((0,t.isFalsyOrWhitespace)(y)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=y.indexOf("/"),U=y.lastIndexOf("/");if(z===U||z<0){if(O)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let $=y.slice(z+1,U),W=y[U+1]==="i"?"i":"";try{return new RegExp($,W)}catch(J){if(O)throw new Error(`bad regexp-value '${y}', parse error: ${J}`);return console.warn(`bad regexp-value '${y}', parse error: ${J}`),null}}}e.ContextKeyExpr=A;function R(B,y){const O=B?B.substituteConstants():void 0,z=y?y.substituteConstants():void 0;return!O&&!z?!0:!O||!z?!1:O.equals(z)}e.expressionsAreEqualWithConstantSubstitution=R;function w(B,y){return B.cmp(y)}class i{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=i,i.INSTANCE=new i;class p{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return i.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class o{constructor(y,O){this.key=y,this.negated=O,this.type=2}static create(y,O=null){const z=k.get(y);return typeof z=="boolean"?z?p.INSTANCE:i.INSTANCE:new o(y,O)}cmp(y){return y.type!==this.type?this.type-y.type:a(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=k.get(this.key);return typeof y=="boolean"?y?p.INSTANCE:i.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=o;class u{constructor(y,O,z){this.key=y,this.value=O,this.negated=z,this.type=4}static create(y,O,z=null){if(typeof O=="boolean")return O?o.create(y,z):m.create(y,z);const U=k.get(y);return typeof U=="boolean"?O===(U?"true":"false")?p.INSTANCE:i.INSTANCE:new u(y,O,z)}cmp(y){return y.type!==this.type?this.type-y.type:S(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=k.get(this.key);if(typeof y=="boolean"){const O=y?"true":"false";return this.value===O?p.INSTANCE:i.INSTANCE}return this}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class d{constructor(y,O){this.key=y,this.valueKey=O,this.type=10,this.negated=null}static create(y,O){return new d(y,O)}cmp(y){return y.type!==this.type?this.type-y.type:S(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}substituteConstants(){return this}evaluate(y){const O=y.getValue(this.valueKey),z=y.getValue(this.key);return Array.isArray(O)?O.indexOf(z)>=0:typeof z=="string"&&typeof O=="object"&&O!==null?P.call(O,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=F.create(this)),this.negated}}e.ContextKeyInExpr=d;class F{constructor(y){this._actual=y,this.type=11}static create(y){return new F(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new F(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=F;class _{constructor(y,O,z){this.key=y,this.value=O,this.negated=z,this.type=5}static create(y,O,z=null){if(typeof O=="boolean")return O?m.create(y,z):o.create(y,z);const U=k.get(y);return typeof U=="boolean"?O===(U?"true":"false")?i.INSTANCE:p.INSTANCE:new _(y,O,z)}cmp(y){return y.type!==this.type?this.type-y.type:S(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=k.get(this.key);if(typeof y=="boolean"){const O=y?"true":"false";return this.value===O?i.INSTANCE:p.INSTANCE}return this}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=_;class m{constructor(y,O){this.key=y,this.negated=O,this.type=3}static create(y,O=null){const z=k.get(y);return typeof z=="boolean"?z?i.INSTANCE:p.INSTANCE:new m(y,O)}cmp(y){return y.type!==this.type?this.type-y.type:a(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=k.get(this.key);return typeof y=="boolean"?y?i.INSTANCE:p.INSTANCE:this}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function h(B,y){if(typeof B=="string"){const O=parseFloat(B);isNaN(O)||(B=O)}return typeof B=="string"||typeof B=="number"?y(B):i.INSTANCE}class D{constructor(y,O,z){this.key=y,this.value=O,this.negated=z,this.type=12}static create(y,O,z=null){return h(O,U=>new D(y,U,z))}cmp(y){return y.type!==this.type?this.type-y.type:S(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=D;class l{constructor(y,O,z){this.key=y,this.value=O,this.negated=z,this.type=13}static create(y,O,z=null){return h(O,U=>new l(y,U,z))}cmp(y){return y.type!==this.type?this.type-y.type:S(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class M{constructor(y,O,z){this.key=y,this.value=O,this.negated=z,this.type=14}static create(y,O,z=null){return h(O,U=>new M(y,U,z))}cmp(y){return y.type!==this.type?this.type-y.type:S(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=M;class r{constructor(y,O,z){this.key=y,this.value=O,this.negated=z,this.type=15}static create(y,O,z=null){return h(O,U=>new r(y,U,z))}cmp(y){return y.type!==this.type?this.type-y.type:S(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class n{constructor(y,O){this.key=y,this.regexp=O,this.type=7,this.negated=null}static create(y,O){return new n(y,O)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const O=this.regexp?this.regexp.source:"",z=y.regexp?y.regexp.source:"";return O<z?-1:O>z?1:0}equals(y){if(y.type===this.type){const O=this.regexp?this.regexp.source:"",z=y.regexp?y.regexp.source:"";return this.key===y.key&&O===z}return!1}substituteConstants(){return this}evaluate(y){let O=y.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=b.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class b{constructor(y){this._actual=y,this.type=8}static create(y){return new b(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new b(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=b;function g(B){let y=null;for(let O=0,z=B.length;O<z;O++){const U=B[O].substituteConstants();if(B[O]!==U&&y===null){y=[];for(let $=0;$<O;$++)y[$]=B[$]}y!==null&&(y[O]=U)}return y===null?B:y}class c{constructor(y,O){this.expr=y,this.negated=O,this.type=6}static create(y,O){return c._normalizeArr(y,O)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const U=w(this.expr[O],y.expr[O]);if(U!==0)return U}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(y.expr[O]))return!1;return!0}return!1}substituteConstants(){const y=g(this.expr);return y===this.expr?this:c.create(y,this.negated)}evaluate(y){for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].evaluate(y))return!1;return!0}static _normalizeArr(y,O){const z=[];let U=!1;for(const $ of y)if(!!$){if($.type===1){U=!0;continue}if($.type===0)return i.INSTANCE;if($.type===6){z.push(...$.expr);continue}z.push($)}if(z.length===0&&U)return p.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(w);for(let $=1;$<z.length;$++)z[$-1].equals(z[$])&&(z.splice($,1),$--);if(z.length===1)return z[0];for(;z.length>1;){const $=z[z.length-1];if($.type!==9)break;z.pop();const W=z.pop(),J=z.length===0,G=f.create($.expr.map(ae=>c.create([ae,W],null)),null,J);G&&(z.push(G),z.sort(w))}return z.length===1?z[0]:new c(z,O)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let O of this.expr)y.push(...O.keys());return y}map(y){return new c(this.expr.map(O=>O.map(y)),null)}negate(){if(!this.negated){const y=[];for(let O of this.expr)y.push(O.negate());this.negated=f.create(y,this,!0)}return this.negated}}class f{constructor(y,O){this.expr=y,this.negated=O,this.type=9}static create(y,O,z){return f._normalizeArr(y,O,z)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const U=w(this.expr[O],y.expr[O]);if(U!==0)return U}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(y.expr[O]))return!1;return!0}return!1}substituteConstants(){const y=g(this.expr);return y===this.expr?this:f.create(y,this.negated,!1)}evaluate(y){for(let O=0,z=this.expr.length;O<z;O++)if(this.expr[O].evaluate(y))return!0;return!1}static _normalizeArr(y,O,z){let U=[],$=!1;if(y){for(let W=0,J=y.length;W<J;W++){const G=y[W];if(!!G){if(G.type===0){$=!0;continue}if(G.type===1)return p.INSTANCE;if(G.type===9){U=U.concat(G.expr);continue}U.push(G)}}if(U.length===0&&$)return i.INSTANCE;U.sort(w)}if(U.length!==0){if(U.length===1)return U[0];for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];if(z){for(let W=0;W<U.length;W++)for(let J=W+1;J<U.length;J++)I(U[W],U[J])&&(U.splice(J,1),J--);if(U.length===1)return U[0]}return new f(U,O)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let O of this.expr)y.push(...O.keys());return y}map(y){return new f(this.expr.map(O=>O.map(y)),null)}negate(){if(!this.negated){let y=[];for(let O of this.expr)y.push(O.negate());for(;y.length>1;){const O=y.shift(),z=y.shift(),U=[];for(const W of N(O))for(const J of N(z))U.push(c.create([W,J],null));const $=y.length===0;y.unshift(f.create(U,null,$))}this.negated=y[0]}return this.negated}}class v extends o{constructor(y,O,z){super(y,null);this._defaultValue=O,typeof z=="object"?v._info.push({...z,key:y}):z!==!0&&v._info.push({key:y,description:z,type:O!=null?typeof O:void 0})}static all(){return v._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return u.create(this.key,y)}notEqualsTo(y){return _.create(this.key,y)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function a(B,y){return B<y?-1:B>y?1:0}function S(B,y,O,z){return B<O?-1:B>O?1:y<z?-1:y>z?1:0}function I(B,y){if(y.type===6&&B.type!==9&&B.type!==6){for(const U of y.expr)if(B.equals(U))return!0}const O=B.negate(),z=N(O).concat(N(y));z.sort(w);for(let U=0;U<z.length;U++){const W=z[U].negate();for(let J=U+1;J<z.length;J++){const G=z[J];if(W.equals(G))return!0}}return!1}e.implies=I;function N(B){return B.type===9?B.expr:[B]}}),define(Ee[135],ye([0,1,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,s.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,s.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[46],ye([0,1,21,17,9,10,2,116,3]),function(ee,e,s,t,E,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function A(U){return U.create===!0}e.isFileOpenForWriteOptions=A;var R;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var w;(function(U){U[U.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var i;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead"})(i=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=p;function o(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=o;function u(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function d(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=d;function F(U){return p(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=F;var _;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(_=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor($,W){super($);this.code=W}}e.FileSystemProviderError=m;function h(U,$){const W=new m(U.toString(),$);return l(W,$),W}e.createFileSystemProviderError=h;function D(U){return U||h((0,P.localize)(0,null),_.Unknown)}e.ensureFileSystemProviderError=D;function l(U,$){return U.name=$?`${$} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=l;function M(U){if(!U)return _.Unknown;if(U instanceof m)return U.code;const $=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!$)return _.Unknown;switch($[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileExceedsMemoryLimit:return _.FileExceedsMemoryLimit;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}e.toFileSystemProviderErrorCode=M;function r(U){if(U instanceof v)return U.fileOperationResult;switch(M(U)){case _.FileNotFound:return 1;case _.FileIsADirectory:return 0;case _.FileNotADirectory:return 10;case _.FileWriteLocked:return 5;case _.NoPermissions:return 6;case _.FileExists:return 4;case _.FileExceedsMemoryLimit:return 9;case _.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var n;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class b{constructor($,W,J){this.resource=$,this.operation=W,this.target=J}isOperation($){return this.operation===$}}e.FileOperationEvent=b;var g;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(g=e.FileChangeType||(e.FileChangeType={}));class c{constructor($,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;const J=new Map;for(const G of $){const ae=J.get(G.type);ae?ae.push([G.resource,G]):J.set(G.type,[[G.resource,G]])}for(const[G,ae]of J)switch(G){case 1:this.added=s.TernarySearchTree.forUris(()=>W),this.added.fill(ae);break;case 0:this.updated=s.TernarySearchTree.forUris(()=>W),this.updated.fill(ae);break;case 2:this.deleted=s.TernarySearchTree.forUris(()=>W),this.deleted.fill(ae);break}}contains($,...W){return this.doContains($,{includeChildren:!1},...W)}affects($,...W){return this.doContains($,{includeChildren:!0},...W)}doContains($,W,...J){if(!$)return!1;const G=J.length>0;return!!((!G||J.includes(1))&&(this.added?.get($)||W.includeChildren&&this.added?.findSuperstr($))||(!G||J.includes(0))&&(this.updated?.get($)||W.includeChildren&&this.updated?.findSuperstr($))||(!G||J.includes(2))&&(this.deleted?.findSubstr($)||W.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawUpdated(){return this.updated}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function f(U,$,W){return!U||!$||U===$||$.length>U.length?!1:($.charAt($.length-1)!==t.sep&&($+=t.sep),W?(0,E.startsWithIgnoreCase)(U,$):U.indexOf($)===0)}e.isParent=f;class v extends Error{constructor($,W,J){super($);this.fileOperationResult=W,this.options=J}}e.FileOperationError=v;class a extends v{constructor($,W,J){super($,2,J);this.stat=W}}e.NotModifiedSinceFileOperationError=a;var S;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(S=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var I;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(I=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=N;async function B(U,$){if(!$.hasProvider(k.URI.from({scheme:U.scheme})))return new Promise(W=>{const J=$.onDidChangeFileSystemProviderRegistrations(G=>{G.scheme===U.scheme&&G.added&&(J.dispose(),W())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class y{static formatSize($){return(0,T.isNumber)($)||($=0),$<y.KB?(0,P.localize)(1,null,$.toFixed(0)):$<y.MB?(0,P.localize)(2,null,($/y.KB).toFixed(2)):$<y.GB?(0,P.localize)(3,null,($/y.MB).toFixed(2)):$<y.TB?(0,P.localize)(4,null,($/y.GB).toFixed(2)):(0,P.localize)(5,null,($/y.TB).toFixed(2))}}e.ByteSize=y,y.KB=1024,y.MB=y.KB*y.KB,y.GB=y.MB*y.KB,y.TB=y.GB*y.KB;var O;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function z(U){return{maxFileSize:U===0?300*y.MB:16*y.GB,maxHeapSize:U===0?700*y.MB:2*700*y.MB}}e.getPlatformLimits=z}),define(Ee[60],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class s{constructor(...E){this._entries=new Map;for(let[T,k]of E)this.set(T,k)}set(E,T){const k=this._entries.get(E);return this._entries.set(E,T),k}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=s}),define(Ee[136],ye([0,1,14,15,80,132,3,60]),function(ee,e,s,t,E,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class A extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class R{constructor(o=new P.ServiceCollection,u=!1,d){this._activeInstantiations=new Set,this._services=o,this._strict=u,this._parent=d,this._services.set(k.IInstantiationService,this)}createChild(o){return new R(o,this._strict,this)}invokeFunction(o,...u){let d=i.traceInvocation(o),F=!1;try{return o({get:m=>{if(F)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(m,d);if(!h)throw new Error(`[invokeFunction] unknown service '${m}'`);return h}},...u)}finally{F=!0,d.stop()}}createInstance(o,...u){let d,F;return o instanceof E.SyncDescriptor?(d=i.traceCreation(o.ctor),F=this._createInstance(o.ctor,o.staticArguments.concat(u),d)):(d=i.traceCreation(o),F=this._createInstance(o,u,d)),d.stop(),F}_createInstance(o,u=[],d){let F=k._util.getServiceDependencies(o).sort((h,D)=>h.index-D.index),_=[];for(const h of F){let D=this._getOrCreateServiceInstance(h.id,d);if(!D&&this._strict&&!h.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${h.id}.`);_.push(D)}let m=F.length>0?F[0].index:u.length;if(u.length!==m){console.warn(`[createInstance] First service dependency of ${o.name} at position ${m+1} conflicts with ${u.length} static arguments`);let h=m-u.length;h>0?u=u.concat(new Array(h)):u=u.slice(0,m)}return new o(...[...u,..._])}_setServiceInstance(o,u){if(this._services.get(o)instanceof E.SyncDescriptor)this._services.set(o,u);else if(this._parent)this._parent._setServiceInstance(o,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let u=this._services.get(o);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):u}_getOrCreateServiceInstance(o,u){let d=this._getServiceInstanceOrDescriptor(o);return d instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,d,u.branch(o,!0)):(u.branch(o,!1),d)}_safeCreateAndCacheServiceInstance(o,u,d){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,u,d)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,u,d){const F=new T.Graph(h=>h.id.toString());let _=0;const m=[{id:o,desc:u,_trace:d}];for(;m.length;){const h=m.pop();if(F.lookupOrInsertNode(h),_++>1e3)throw new A(F);for(let D of k._util.getServiceDependencies(h.desc.ctor)){let l=this._getServiceInstanceOrDescriptor(D.id);if(!l&&!D.optional&&console.warn(`[createInstance] ${o} depends on ${D.id} which is NOT registered.`),l instanceof E.SyncDescriptor){const M={id:D.id,desc:l,_trace:h._trace.branch(D.id,!0)};F.insertEdge(h,M),m.push(M)}}}for(;;){const h=F.roots();if(h.length===0){if(!F.isEmpty())throw new A(F);break}for(const{data:D}of h){if(this._getServiceInstanceOrDescriptor(D.id)instanceof E.SyncDescriptor){const M=this._createServiceInstanceWithOwner(D.id,D.desc.ctor,D.desc.staticArguments,D.desc.supportsDelayedInstantiation,D._trace);this._setServiceInstance(D.id,M)}F.removeNode(D)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,u,d=[],F,_){if(this._services.get(o)instanceof E.SyncDescriptor)return this._createServiceInstance(u,d,F,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,u,d,F,_);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(o,u=[],d,F){if(d){const _=new s.IdleValue(()=>this._createInstance(o,u,F));return new Proxy(Object.create(null),{get(m,h){if(h in m)return m[h];let D=_.value,l=D[h];return typeof l!="function"||(l=l.bind(D),m[h]=l),l},set(m,h,D){return _.value[h]=D,!0}})}else return this._createInstance(o,u,F)}}e.InstantiationService=R;var w;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(w||(w={}));class i{constructor(o,u){this.type=o,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return C?new i(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):i._None}static traceCreation(o){return C?new i(0,o.name):i._None}branch(o,u){let d=new i(2,o.toString());return this._dep.push([o,u,d]),d}stop(){let o=Date.now()-this._start;i._totals+=o;let u=!1;function d(_,m){let h=[],D=new Array(_+1).join("	");for(const[l,M,r]of m._dep)if(M&&r){u=!0,h.push(`${D}CREATES -> ${l}`);let n=d(_+1,r);n&&h.push(n)}else h.push(`${D}uses -> ${l}`);return h.join(`
`)}let F=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${i._totals.toFixed(2)}ms)`];(o>2||u)&&console.log(F.join(`
`))}}i._None=new class extends i{constructor(){super(-1,null)}stop(){}branch(){return this}},i._totals=0}),define(Ee[12],ye([0,1,43,4,6,23,3]),function(ee,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function P(){return new Date().toISOString()}var C;(function(M){M[M.Trace=0]="Trace",M[M.Debug=1]="Debug",M[M.Info=2]="Info",M[M.Warning=3]="Warning",M[M.Error=4]="Error",M[M.Critical=5]="Critical",M[M.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function A(M,r,n){switch(r){case C.Trace:M.trace(n);break;case C.Debug:M.debug(n);break;case C.Info:M.info(n);break;case C.Warning:M.warn(n);break;case C.Error:M.error(n);break;case C.Critical:M.critical(n);break;default:throw new Error("Invalid log level")}}e.log=A;function R(M){let r="";for(let n=0;n<M.length;n++){let b=M[n];if(typeof b=="object")try{b=JSON.stringify(b)}catch{}r+=(n>0?" ":"")+b}return r}e.format=R;class w extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class i extends w{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...n){this.checkLogLevel(C.Trace)&&this.log(C.Trace,R([r,...n]))}debug(r,...n){this.checkLogLevel(C.Debug)&&this.log(C.Debug,R([r,...n]))}info(r,...n){this.checkLogLevel(C.Info)&&this.log(C.Info,R([r,...n]))}warn(r,...n){this.checkLogLevel(C.Warning)&&this.log(C.Warning,R([r,...n]))}error(r,...n){if(this.checkLogLevel(C.Error))if(r instanceof Error){const b=Array.prototype.slice.call(arguments);b[0]=r.stack,this.log(C.Error,R(b))}else this.log(C.Error,R([r,...n]))}critical(r,...n){this.checkLogLevel(C.Critical)&&this.log(C.Critical,R([r,...n]))}flush(){}}e.AbstractMessageLogger=i;class p extends w{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!T.isWindows}trace(r,...n){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...n):console.log(`[main ${P()}]`,r,...n))}debug(r,...n){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...n):console.log(`[main ${P()}]`,r,...n))}info(r,...n){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...n):console.log(`[main ${P()}]`,r,...n))}warn(r,...n){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,r,...n):console.warn(`[main ${P()}]`,r,...n))}error(r,...n){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,r,...n):console.error(`[main ${P()}]`,r,...n))}critical(r,...n){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,r,...n):console.error(`[main ${P()}]`,r,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class o extends w{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...n){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",r,...n)}debug(r,...n){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...n)}info(r,...n){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",r,...n)}warn(r,...n){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",r,...n)}error(r,...n){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",r,...n)}critical(r,...n){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...n)}dispose(){}flush(){}}e.ConsoleLogger=o;class u extends w{constructor(r,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(n)}trace(r,...n){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(r),...n])}debug(r,...n){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(r),...n])}info(r,...n){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(r),...n])}warn(r,...n){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(r),...n])}error(r,...n){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(r),...n])}critical(r,...n){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(r),...n])}extractMessage(r){return typeof r=="string"?r:(0,s.toErrorMessage)(r,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class d extends w{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const n of this.logServices)n.setLevel(r);super.setLevel(r)}trace(r,...n){for(const b of this.logServices)b.trace(r,...n)}debug(r,...n){for(const b of this.logServices)b.debug(r,...n)}info(r,...n){for(const b of this.logServices)b.info(r,...n)}warn(r,...n){for(const b of this.logServices)b.warn(r,...n)}error(r,...n){for(const b of this.logServices)b.error(r,...n)}critical(r,...n){for(const b of this.logServices)b.critical(r,...n)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=d;class F extends E.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...n){this.logger.trace(r,...n)}debug(r,...n){this.logger.debug(r,...n)}info(r,...n){this.logger.info(r,...n)}warn(r,...n){this.logger.warn(r,...n)}error(r,...n){this.logger.error(r,...n)}critical(r,...n){this.logger.critical(r,...n)}flush(){this.logger.flush()}}e.LogService=F;class _ extends E.Disposable{constructor(r,n){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(b=>{this.logLevel=b,this.logLevelChangeableLoggers.forEach(g=>g.setLevel(b))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,n){let b=this.loggers.get(r.toString());return b||(b=this.doCreateLogger(r,n?.always?C.Trace:this.logLevel,n),this.loggers.set(r.toString(),b),n?.always||this.logLevelChangeableLoggers.push(b)),b}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class m{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return C.Info}trace(r,...n){}debug(r,...n){}info(r,...n){}warn(r,...n){}error(r,...n){}critical(r,...n){}dispose(){}flush(){}}e.NullLogService=m;function h(M){if(M.verbose)return C.Trace;if(typeof M.logLevel=="string"){const r=D(M.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function D(M){switch(M){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=D;function l(M){switch(M){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=l}),define(Ee[82],ye([0,1,34,117,3]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var k;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function A(o,u){return u-o}C.compare=A;const R=Object.create(null);R[C.Error]=(0,t.localize)(0,null),R[C.Warning]=(0,t.localize)(1,null),R[C.Info]=(0,t.localize)(2,null);function w(o){return R[o]||""}C.toString=w;function i(o){switch(o){case s.default.Error:return C.Error;case s.default.Warning:return C.Warning;case s.default.Info:return C.Info;case s.default.Ignore:return C.Hint}}C.fromSeverity=i;function p(o){switch(o){case C.Error:return s.default.Error;case C.Warning:return s.default.Warning;case C.Info:return s.default.Info;case C.Hint:return s.default.Ignore}}C.toSeverity=p}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(C){const A="";function R(i){return w(i,!0)}C.makeKey=R;function w(i,p){let o=[A];return i.source?o.push(i.source.replace("\xA6","\\\xA6")):o.push(A),i.code?typeof i.code=="string"?o.push(i.code.replace("\xA6","\\\xA6")):o.push(i.code.value.replace("\xA6","\\\xA6")):o.push(A),i.severity!==void 0&&i.severity!==null?o.push(k.toString(i.severity)):o.push(A),i.message&&p?o.push(i.message.replace("\xA6","\\\xA6")):o.push(A),i.startLineNumber!==void 0&&i.startLineNumber!==null?o.push(i.startLineNumber.toString()):o.push(A),i.startColumn!==void 0&&i.startColumn!==null?o.push(i.startColumn.toString()):o.push(A),i.endLineNumber!==void 0&&i.endLineNumber!==null?o.push(i.endLineNumber.toString()):o.push(A),i.endColumn!==void 0&&i.endColumn!==null?o.push(i.endColumn.toString()):o.push(A),o.push(A),o.join("\xA6")}C.makeKeyOptionalMessage=w})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(Ee[137],ye([0,1,4,34,3]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,E.createDecorator)("notificationService");var T;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new C,this.onDidClose=s.Event.None,this.onDidChangeVisibility=s.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=P;class C{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=C}),define(Ee[138],ye([0,1,6,9,2,3]),function(ee,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return s.Disposable.None},registerValidator(){return s.Disposable.None},registerExternalUriResolver(){return s.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return s.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function k(C,A){return E.URI.isUri(C)?(0,t.equalsIgnoreCase)(C.scheme,A):(0,t.startsWithIgnoreCase)(C,A+":")}e.matchesScheme=k;function P(C,...A){return A.some(R=>k(C,R))}e.matchesSomeScheme=P});var Be=this&&this.__decorate||function(ee,e,s,t){var E=arguments.length,T=E<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,s):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ee,e,s,t);else for(var P=ee.length-1;P>=0;P--)(k=ee[P])&&(T=(E<3?k(T):E>3?k(e,s,T):k(e,s))||T);return E>3&&T&&Object.defineProperty(e,s,T),T},$e=this&&this.__param||function(ee,e){return function(s,t){e(s,t,ee)}};define(Ee[139],ye([0,1,14,20,6,3]),function(ee,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var k;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(w){this.callback=w}get value(){return this._value}report(w){this._value=w,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let C=class extends E.Disposable{constructor(w,i){super();this.deferred=new s.DeferredPromise,i.withProgress(w,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(w){this.reporter?this.reporter.report(w):this.lastStep=w}};C=Be([$e(1,e.IProgressService)],C),e.UnmanagedProgress=C;class A extends E.Disposable{constructor(w){super();this.progressIndicator=w,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(w){this.stop();const i=++this.currentOperationId,p=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{i===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},w),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:i,token:p.token,stop:()=>this.doStop(i),isCurrent:()=>this.currentOperationId===i}}stop(){this.doStop(this.currentOperationId)}doStop(w){this.currentOperationId===w&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(Ee[37],ye([0,1,42,10]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(k,P){s.ok(t.isString(k)),s.ok(t.isObject(P)),s.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new E}),define(Ee[140],ye([0,1,4,37]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new s.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,A){this.schemasById[E(C)]=A,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new T;t.Registry.add(e.Extensions.JSONContribution,k)}),define(Ee[83],ye([0,1,16,4,10,114,140,37]),function(ee,e,s,t,E,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=P.Registry.as(k.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(D,l=!0){this.registerConfigurations([D],l)}registerConfigurations(D,l=!0){const M=this.doRegisterConfigurations(D,l);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:M})}deregisterConfigurations(D){const l=this.doDeregisterConfigurations(D);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:D,remove:l}){const M=[];M.push(...this.doDeregisterConfigurations(l)),M.push(...this.doRegisterConfigurations(D,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,s.distinct)(M)})}registerDefaultConfigurations(D){const l=[],M=[];for(const{overrides:r,source:n}of D)for(const b in r)if(l.push(b),e.OVERRIDE_PROPERTY_REGEX.test(b)){const g={...this.configurationDefaultsOverrides.get(b)?.value||{},...r[b]};this.configurationDefaultsOverrides.set(b,{source:n,value:g});const c={type:"object",default:g,description:T.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:E.isString(n)?void 0:n};M.push(...o(b)),this.configurationProperties[b]=c,this.defaultLanguageConfigurationOverridesNode.properties[b]=c}else{this.configurationDefaultsOverrides.set(b,{value:r[b],source:n});const g=this.configurationProperties[b];g&&(this.updatePropertyDefaultValue(b,g),this.updateSchema(b,g))}this.registerOverrideIdentifiers(M),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(D){const l=[];for(const{overrides:M,source:r}of D)for(const n in M){const b=this.configurationDefaultsOverrides.get(n),g=E.isString(r)?r:r?.id,c=E.isString(b?.source)?b?.source:b?.source?.id;if(g===c)if(l.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const f=this.configurationProperties[n];f&&(this.updatePropertyDefaultValue(n,f),this.updateSchema(n,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...D){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(D){for(const l of D)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(D,l){const M=[];return D.forEach(r=>{M.push(...this.validateAndRegisterProperties(r,l,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),M}doDeregisterConfigurations(D){const l=[],M=r=>{if(r.properties)for(const n in r.properties)l.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,r.properties[n]);r.allOf&&r.allOf.forEach(n=>M(n))};for(const r of D){M(r);const n=this.configurationContributors.indexOf(r);n!==-1&&this.configurationContributors.splice(n,1)}return l}validateAndRegisterProperties(D,l=!0,M,r,n=3){n=E.isUndefinedOrNull(D.scope)?n:D.scope;let b=[],g=D.properties;if(g)for(let f in g){if(l&&_(f)){delete g[f];continue}const v=g[f];if(v.source=M,v.defaultDefaultValue=g[f].default,this.updatePropertyDefaultValue(f,v),e.OVERRIDE_PROPERTY_REGEX.test(f)?v.scope=void 0:(v.scope=E.isUndefinedOrNull(v.scope)?n:v.scope,v.restricted=E.isUndefinedOrNull(v.restricted)?!!r?.includes(f):v.restricted),g[f].hasOwnProperty("included")&&!g[f].included){this.excludedConfigurationProperties[f]=g[f],delete g[f];continue}else this.configurationProperties[f]=g[f];!g[f].deprecationMessage&&g[f].markdownDeprecationMessage&&(g[f].deprecationMessage=g[f].markdownDeprecationMessage),b.push(f)}let c=D.allOf;if(c)for(let f of c)b.push(...this.validateAndRegisterProperties(f,l,M,r,n));return b}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(D){const l=M=>{let r=M.properties;if(r)for(const b in r)this.updateSchema(b,r[b]);let n=M.allOf;n&&n.forEach(l)};l(D)}updateSchema(D,l){switch(e.allSettings.properties[D]=l,l.scope){case 1:e.applicationSettings.properties[D]=l;break;case 2:e.machineSettings.properties[D]=l;break;case 6:e.machineOverridableSettings.properties[D]=l;break;case 3:e.windowSettings.properties[D]=l;break;case 4:e.resourceSettings.properties[D]=l;break;case 5:e.resourceSettings.properties[D]=l,this.resourceLanguageSettingsSchema.properties[D]=l;break}}removeFromSchema(D,l){switch(delete e.allSettings.properties[D],l.scope){case 1:delete e.applicationSettings.properties[D];break;case 2:delete e.machineSettings.properties[D];break;case 6:delete e.machineOverridableSettings.properties[D];break;case 3:delete e.windowSettings.properties[D];break;case 4:case 5:delete e.resourceSettings.properties[D],delete this.resourceLanguageSettingsSchema.properties[D];break}}updateOverridePropertyPatternKey(){for(const D of this.overrideIdentifiers.values()){const l=`[${D}]`,M={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,M),e.allSettings.properties[l]=M,e.applicationSettings.properties[l]=M,e.machineSettings.properties[l]=M,e.machineOverridableSettings.properties[l]=M,e.windowSettings.properties[l]=M,e.resourceSettings.properties[l]=M}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const D={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(D,l){const M=this.configurationDefaultsOverrides.get(D);let r=M?.value,n=M?.source;E.isUndefined(r)&&(r=l.defaultDefaultValue,n=void 0),E.isUndefined(r)&&(r=d(l.type)),l.default=r,l.defaultValueSource=n}}const i="\\[([^\\]]+)\\]",p=new RegExp(i,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${i})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function o(h){const D=[];if(e.OVERRIDE_PROPERTY_REGEX.test(h)){let l=p.exec(h);for(;l?.length;){const M=l[1].trim();M&&D.push(M),l=p.exec(h)}}return(0,s.distinct)(D)}e.overrideIdentifiersFromKey=o;function u(h){return h.reduce((D,l)=>`${D}[${l}]`,"")}e.keyFromOverrideIdentifiers=u;function d(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const F=new w;P.Registry.add(e.Extensions.Configuration,F);function _(h){return h.trim()?e.OVERRIDE_PROPERTY_REGEX.test(h)?T.localize(7,null,h):F.getConfigurationProperties()[h]!==void 0?T.localize(8,null,h):null:T.localize(6,null)}e.validateProperty=_;function m(){const h=[],D=F.getConfigurationProperties();for(const l of Object.keys(D))h.push([l,D[l].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.getScopes=m}),define(Ee[141],ye([0,1,16,4,100,6,21,26,10,2,81,83,37]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(r={},n=[],b=[]){this._contents=r,this._keys=n,this._overrides=b,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,n){const b=this.getContentsForOverrideIdentifer(n);return b?r?(0,R.getConfigurationValue)(b,r):b:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const b of this.overrides)b.identifiers.includes(r)&&n.push(...b.keys);return s.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return s.distinct(r)}override(r){let n=this.overrideConfigurations.get(r);return n||(n=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,n)),n}merge(...r){const n=P.deepClone(this.contents),b=P.deepClone(this.overrides),g=[...this.keys];for(const c of r){this.mergeContents(n,c.contents);for(const f of c.overrides){const[v]=b.filter(a=>s.equals(a.identifiers,f.identifiers));v?(this.mergeContents(v.contents,f.contents),v.keys.push(...f.keys),v.keys=s.distinct(v.keys)):b.push(P.deepClone(f))}for(const f of c.keys)g.indexOf(f)===-1&&g.push(f)}return new p(n,g,b)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const n=this.getContentsForOverrideIdentifer(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let b={};for(const g of s.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[g],f=n[g];f&&(typeof c=="object"&&typeof f=="object"?(c=P.deepClone(c),this.mergeContents(c,f)):c=f),b[g]=c}return new p(b,this.keys,this.overrides)}mergeContents(r,n){for(const b of Object.keys(n)){if(b in r&&C.isObject(r[b])&&C.isObject(n[b])){this.mergeContents(r[b],n[b]);continue}r[b]=P.deepClone(n[b])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?P.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let n=null,b=null;const g=c=>{c&&(b?this.mergeContents(b,c):b=P.deepClone(c))};for(const c of this.overrides)s.equals(c.identifiers,[r])?n=c.contents:c.identifiers.includes(r)&&g(c.contents);return g(n),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,n){this.addKey(r),(0,R.addToValueTree)(this.contents,r,n,b=>{throw new Error(b)})}removeValue(r){this.removeKey(r)&&(0,R.removeFromValueTree)(this.contents,r)}addKey(r){let n=this.keys.length;for(let b=0;b<n;b++)r.indexOf(this.keys[b])===0&&(n=b);this.keys.splice(n,1,r)}removeKey(r){let n=this.keys.indexOf(r);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=p;class o extends p{constructor(r={}){const n=i.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),b=Object.keys(n),g=Object.create(null),c=[];for(const f in n){const v=r[f],a=v!==void 0?v:n[f].default;(0,R.addToValueTree)(g,f,a,S=>console.error(`Conflict in default settings: ${S}`))}for(const f of Object.keys(g))w.OVERRIDE_PROPERTY_REGEX.test(f)&&c.push({identifiers:(0,w.overrideIdentifiersFromKey)(f),keys:Object.keys(g[f]),contents:(0,R.toValuesTree)(g[f],v=>console.error(`Conflict in default settings file: ${v}`))});super(g,b,c)}}e.DefaultConfigurationModel=o;class u{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,n){if(!C.isUndefinedOrNull(r)){const b=this.doParseContent(r);this.parseRaw(b,n)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,n){this._raw=r;const{contents:b,keys:g,overrides:c,restricted:f}=this.doParseRaw(r,n);this._configurationModel=new p(b,g,c),this._restrictedConfigurations=f||[]}doParseContent(r){let n={},b=null,g=[],c=[],f=[];function v(S){Array.isArray(g)?g.push(S):b!==null&&(g[b]=S)}let a={onObjectBegin:()=>{let S={};v(S),c.push(g),g=S,b=null},onObjectProperty:S=>{b=S},onObjectEnd:()=>{g=c.pop()},onArrayBegin:()=>{let S=[];v(S),c.push(g),g=S,b=null},onArrayEnd:()=>{g=c.pop()},onLiteralValue:v,onError:(S,I,N)=>{f.push({error:S,offset:I,length:N})}};if(r)try{E.visit(r,a),n=g[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return n}doParseRaw(r,n){const b=i.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),g=this.filter(r,b,!0,n);r=g.raw;const c=(0,R.toValuesTree)(r,a=>console.error(`Conflict in settings file ${this._name}: ${a}`)),f=Object.keys(r),v=this.toOverrides(r,a=>console.error(`Conflict in settings file ${this._name}: ${a}`));return{contents:c,keys:f,overrides:v,restricted:g.restricted}}filter(r,n,b,g){if(!g?.scopes&&!g?.skipRestricted)return{raw:r,restricted:[]};const c={},f=[];for(let v in r)if(w.OVERRIDE_PROPERTY_REGEX.test(v)&&b){const a=this.filter(r[v],n,!1,g);c[v]=a.raw,f.push(...a.restricted)}else{const a=n[v],S=a?typeof a.scope!="undefined"?a.scope:3:void 0;a?.restricted&&f.push(v),(S===void 0||g.scopes===void 0||g.scopes.includes(S))&&(g.skipRestricted&&a?.restricted||(c[v]=r[v]))}return{raw:c,restricted:f}}toOverrides(r,n){const b=[];for(const g of Object.keys(r))if(w.OVERRIDE_PROPERTY_REGEX.test(g)){const c={};for(const f in r[g])c[f]=r[g][f];b.push({identifiers:(0,w.overrideIdentifiersFromKey)(g),keys:Object.keys(c),contents:(0,R.toValuesTree)(c,n)})}return b}}e.ConfigurationModelParser=u;class d extends T.Disposable{constructor(r,n,b,g){super();this.userSettingsResource=r,this.scopes=n,this.fileService=g,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(b.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class F{constructor(r,n,b=new p,g=new p,c=new k.ResourceMap,f=new p,v=new k.ResourceMap,a=!0){this._defaultConfiguration=r,this._localUserConfiguration=n,this._remoteUserConfiguration=b,this._workspaceConfiguration=g,this._folderConfigurations=c,this._memoryConfiguration=f,this._memoryConfigurationByResource=v,this._freeze=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(r,n,b){return this.getConsolidateConfigurationModel(n,b).getValue(r)}updateValue(r,n,b={}){let g;b.resource?(g=this._memoryConfigurationByResource.get(b.resource),g||(g=new p,this._memoryConfigurationByResource.set(b.resource,g))):g=this._memoryConfiguration,n===void 0?g.removeValue(r):g.setValue(r,n),b.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,n,b){const g=this.getConsolidateConfigurationModel(n,b),c=this.getFolderConfigurationModelForResource(n.resource,b),f=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,v=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),a=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),S=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),I=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),N=b?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,B=c?n.overrideIdentifier?c.freeze().override(n.overrideIdentifier).getValue(r):c.freeze().getValue(r):void 0,y=n.overrideIdentifier?f.override(n.overrideIdentifier).getValue(r):f.getValue(r),O=g.getValue(r),z=s.distinct(s.flatten(g.overrides.map(U=>U.identifiers))).filter(U=>g.getOverrideValue(r,U)!==void 0);return{defaultValue:v,userValue:a,userLocalValue:S,userRemoteValue:I,workspaceValue:N,workspaceFolderValue:B,memoryValue:y,value:O,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,user:a!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,userRemote:I!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:c?.freeze().getValue(r),override:n.overrideIdentifier?c?.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,memory:y!==void 0?{value:f.getValue(r),override:n.overrideIdentifier?f.getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(r){const n=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,n){this._folderConfigurations.set(r,n),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const b=[];if(!n){const{added:g,updated:c,removed:f}=D(this._defaultConfiguration,r);n=[...g,...c,...f]}for(const g of n)for(const c of(0,w.overrideIdentifiersFromKey)(g)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(c),v=r.getKeysForOverrideIdentifier(c),a=[...v.filter(S=>f.indexOf(S)===-1),...f.filter(S=>v.indexOf(S)===-1),...f.filter(S=>!P.equals(this._defaultConfiguration.override(c).getValue(S),r.override(c).getValue(S)))];b.push([c,a])}return this.updateDefaultConfiguration(r),{keys:n,overrides:b}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:b,removed:g,overrides:c}=D(this.localUserConfiguration,r),f=[...n,...b,...g];return f.length&&this.updateLocalUserConfiguration(r),{keys:f,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:b,removed:g,overrides:c}=D(this.remoteUserConfiguration,r);let f=[...n,...b,...g];return f.length&&this.updateRemoteUserConfiguration(r),{keys:f,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:b,removed:g,overrides:c}=D(this.workspaceConfiguration,r);let f=[...n,...b,...g];return f.length&&this.updateWorkspaceConfiguration(r),{keys:f,overrides:c}}compareAndUpdateFolderConfiguration(r,n){const b=this.folderConfigurations.get(r),{added:g,updated:c,removed:f,overrides:v}=D(b,n);let a=[...g,...c,...f];return(a.length||!b)&&this.updateFolderConfiguration(r,n),{keys:a,overrides:v}}compareAndDeleteFolderConfiguration(r){const n=this.folderConfigurations.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:b,updated:g,removed:c,overrides:f}=D(n,void 0);return{keys:[...b,...g,...c],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,n){let b=this.getConsolidatedConfigurationModelForResource(r,n);return r.overrideIdentifier?b.override(r.overrideIdentifier):b}getConsolidatedConfigurationModelForResource({resource:r},n){let b=this.getWorkspaceConsolidatedConfiguration();if(n&&r){const g=n.getFolder(r);g&&(b=this.getFolderConsolidatedConfiguration(g.uri)||b);const c=this._memoryConfigurationByResource.get(r);c&&(b=b.merge(c))}return b}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let n=this._foldersConsolidatedConfigurations.get(r);if(!n){const b=this.getWorkspaceConsolidatedConfiguration(),g=this._folderConfigurations.get(r);g?(n=b.merge(g),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(r,n)):n=b}return n}getFolderConfigurationModelForResource(r,n){if(n&&r){const b=n.getFolder(r);if(b)return this._folderConfigurations.get(b.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,n)=>{const{contents:b,overrides:g,keys:c}=this._folderConfigurations.get(n);return r.push([n,{contents:b,overrides:g,keys:c}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>r.add(n)),this.userConfiguration.freeze().keys.forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(b=>r.add(b))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(b=>r.add(b))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(b=>n.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(b=>n.add(b)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(b=>n.add(b)),this._folderConfigurations.forEach(b=>b.getKeysForOverrideIdentifier(r).forEach(g=>n.add(g))),[...n.values()]}static parse(r){const n=this.parseConfigurationModel(r.defaults),b=this.parseConfigurationModel(r.user),g=this.parseConfigurationModel(r.workspace),c=r.folders.reduce((f,v)=>(f.set(A.URI.revive(v[0]),this.parseConfigurationModel(v[1])),f),new k.ResourceMap);return new F(n,b,new p,g,c,new p,new k.ResourceMap,!1)}static parseConfigurationModel(r){return new p(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=F;function _(...M){if(M.length===0)return{keys:[],overrides:[]};if(M.length===1)return M[0];const r=new Set,n=new Map;for(const g of M)g.keys.forEach(c=>r.add(c)),g.overrides.forEach(([c,f])=>{const v=(0,k.getOrSet)(n,c,new Set);f.forEach(a=>v.add(a))});const b=[];return n.forEach((g,c)=>b.push([c,[...g.values()]])),{keys:[...r.values()],overrides:b}}e.mergeChanges=_;class m{constructor(r,n,b,g){this.change=r,this.previous=n,this.currentConfiguraiton=b,this.currentWorkspace=g,this._previousConfiguration=void 0;const c=new Set;r.keys.forEach(v=>c.add(v)),r.overrides.forEach(([,v])=>v.forEach(a=>c.add(a))),this.affectedKeys=[...c.values()];const f=new p;this.affectedKeys.forEach(v=>f.setValue(v,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=F.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(n){const b=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.previous?.workspace):void 0,g=this.currentConfiguraiton.getValue(r,n,this.currentWorkspace);return!P.equals(b,g)}return!0}return!1}doesAffectedKeysTreeContains(r,n){let b=(0,R.toValuesTree)({[n]:!0},()=>{}),g;for(;typeof b=="object"&&(g=Object.keys(b)[0]);){if(r=r[g],!r)return!1;b=b[g]}return!0}}e.ConfigurationChangeEvent=m;class h extends m{constructor(r,n,b,g){super({keys:r.allKeys(),overrides:[]},void 0,r,n);this.source=b,this.sourceConfig=g}}e.AllKeysConfigurationChangeEvent=h;function D(M,r){const{added:n,removed:b,updated:g}=l(r,M),c=[],f=M?.getAllOverrideIdentifiers()||[],v=r?.getAllOverrideIdentifiers()||[];if(r){const a=v.filter(S=>!f.includes(S));for(const S of a)c.push([S,r.getKeysForOverrideIdentifier(S)])}if(M){const a=f.filter(S=>!v.includes(S));for(const S of a)c.push([S,M.getKeysForOverrideIdentifier(S)])}if(r&&M){for(const a of f)if(v.includes(a)){const S=l({contents:M.getOverrideValue(void 0,a)||{},keys:M.getKeysForOverrideIdentifier(a)},{contents:r.getOverrideValue(void 0,a)||{},keys:r.getKeysForOverrideIdentifier(a)});c.push([a,[...S.added,...S.removed,...S.updated]])}}return{added:n,removed:b,updated:g,overrides:c}}function l(M,r){const n=M?r?M.keys.filter(c=>r.keys.indexOf(c)===-1):[...M.keys]:[],b=r?M?r.keys.filter(c=>M.keys.indexOf(c)===-1):[...r.keys]:[],g=[];if(M&&r){for(const c of r.keys)if(M.keys.indexOf(c)!==-1){const f=(0,R.getConfigurationValue)(r.contents,c),v=(0,R.getConfigurationValue)(M.contents,c);P.equals(f,v)||g.push(c)}}return{added:n,removed:b,updated:g}}}),define(Ee[84],ye([0,1,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,s.createDecorator)("remoteAuthorityResolverService");var t;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(k,P=t.Unknown,C){super(k);this._message=k,this._code=P,this._detail=C,this.isHandled=P===t.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(k){return k instanceof E&&k._code===t.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof E&&k._code===t.NoResolverFound}static isHandled(k){return k instanceof E&&k.isHandled}}e.RemoteAuthorityResolverError=E}),define(Ee[61],ye([0,1,11]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(A){return A.scheme===s.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=t;function E(A){if(!A)return;const R=A.indexOf("+");return R<0?A:A.substr(0,R)}e.getRemoteName=E;function T(A){return A.scheme!==s.Schemas.file&&A.scheme!==s.Schemas.vscodeRemote}e.isVirtualResource=T;function k(A){if(A.folders.length)return A.folders.every(R=>T(R.uri))?A.folders[0].uri:void 0;if(A.configuration&&T(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=k;function P(A){return k(A)?.scheme}e.getVirtualWorkspaceScheme=P;function C(A){return k(A)!==void 0}e.isVirtualWorkspace=C}),define(Ee[25],ye([0,1,9,3,61]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=T;function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class C{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,o){if(typeof p=="undefined"||p===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof p=="string"||typeof o=="string"){let u=typeof p=="string"?p:p.value,d=typeof o=="string"?o:o.value;return s.equalsIgnoreCase(u,d)}return p._lower===o._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=C;function A(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=A;function R(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function w(i,p){if(p){const o=`onResolveRemoteAuthority:${(0,E.getRemoteName)(p)}`;return i.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=w,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[142],ye([0,1,9,25]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(o,u){return o.uuid&&u.uuid?o.uuid===u.uuid:o.id===u.id?!0:(0,s.compareIgnoreCase)(o.id,u.id)===0}e.areSameExtensions=E;class T{constructor(u,d){this.version=d,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof T?E(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=T;function k(o,u){return`${o}.${u}`}e.getExtensionId=k;function P(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function C(o,u){return P(k(o,u))}e.getGalleryExtensionId=C;function A(o,u){const d=[],F=_=>{for(const m of d)if(m.some(h=>E(u(h),u(_))))return m;return null};for(const _ of o){const m=F(_);m?m.push(_):d.push([_])}return d}e.groupByExtension=A;function R(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function w(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function i(o){const u=new Set;if(o.malicious)for(const d of o.malicious)u.add(d.id);return u}e.getMaliciousExtensionsSet=i;function p(o,u){const d=[],F=u.manifest.extensionDependencies?.slice(0)??[];for(;F.length;){const _=F.shift();if(_&&d.every(m=>!E(m.identifier,{id:_}))){const m=o.filter(h=>E(h.identifier,{id:_}));m.length===1&&(d.push(m[0]),F.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=p}),define(Ee[143],ye([0,1,4,23,3,12]),function(ee,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,E.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,E.createDecorator)("sharedTunnelsService");var k;(function(o){o.Http="http",o.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function A(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=A,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=w;function i(o,u){return u?u!==1&&o<1024:!t.isWindows&&o<1024}e.isPortPrivileged=i;let p=class{constructor(u){this.logService=u,this._onTunnelOpened=new s.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new s.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new s.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u,d){return this._tunnelProvider=u,u?(this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],d=Array.from(this._tunnels.values());for(let F of d){const _=Array.from(F.values());for(let m of _){const h=await m.value;h&&u.push(h)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:d}of u.values())await d.then(F=>F?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,d,F,_,m=!1,h=P.Private,D){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${F} on local port ${_}.`),!u)return;d||(d="localhost");const l=this.retainOrCreateTunnel(u,d,F,_,m,h,D);return l?l.then(M=>{if(!M){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,F);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(M);return(M.tunnelRemoteHost!==d||M.tunnelRemotePort!==F)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const d=this._tunnels.get(u.tunnelRemoteHost);if(d){const F=d.get(u.tunnelRemotePort);F&&(F.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,F))}}}}async tryDisposeTunnel(u,d,F){if(F.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${d}.`);const _=F.value.then(async m=>{m&&(await m.dispose(!0),this._onTunnelClosed.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(d),_}}async closeTunnel(u,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${d} `);const F=this._tunnels.get(u);if(F&&F.has(d)){const _=F.get(d);_.refcount=0,await this.tryDisposeTunnel(u,d,_)}}addTunnelToMap(u,d,F){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(d,{refcount:1,value:F})}async removeEmptyTunnelFromMap(u,d){const F=this._tunnels.get(u);F&&(await F.get(d)||F.delete(d),F.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,d){let F=[u];R(u)?(F.push(...e.LOCALHOST_ADDRESSES),F.push(...e.ALL_INTERFACES_ADDRESSES)):w(u)&&F.push(...e.ALL_INTERFACES_ADDRESSES);const _=F.map(m=>this._tunnels.get(m));for(const m of _){const h=m?.get(d);if(h)return h}}canTunnel(u){return!!A(u)}createWithProvider(u,d,F,_,m,h,D){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${F} on local port ${_}.`);const M={elevationRequired:m?i(_===void 0?F:_):!1},r={remoteAddress:{host:d,port:F},localAddressPort:_,privacy:h,public:h!==P.Private,protocol:D},n=u.forwardPort(r,M);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(d,F,n),n}};p=Be([$e(0,T.ILogService)],p),e.AbstractTunnelService=p}),define(Ee[144],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class s{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,T,k=5){let P;return P=T(C=>{const A=typeof C=="string"?C:C.data;let R=this._terminalBufferMap.get(E);if(R){R.data.push(A);return}const w=setTimeout(()=>this.flushBuffer(E),k);R={data:[A],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(E),P.dispose()}},this._terminalBufferMap.set(E,R)}),P}stopBuffering(E){const T=this._terminalBufferMap.get(E);T&&T.dispose()}flushBuffer(E){const T=this._terminalBufferMap.get(E);T&&(this._terminalBufferMap.delete(E),this._callback(E,T.data.join("")))}}e.TerminalDataBufferer=s}),define(Ee[145],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var s;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(s=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[62],ye([0,1,52,4,6,3,37,145]),function(ee,e,s,t,E,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var C;(function(d){function F(_){return _&&typeof _=="object"&&typeof _.id=="string"}d.isThemeColor=F})(C=e.ThemeColor||(e.ThemeColor={}));function A(d){return{id:d}}e.themeColorFromId=A;var R;(function(d){function F(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||C.isThemeColor(n.color))}d.isThemeIcon=F;const _=new RegExp(`^\\$\\((${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?)\\)$`);function m(n){const b=_.exec(n);if(!b)return;let[,g]=b;return{id:g}}d.fromString=m;function h(n){return{id:n}}d.fromId=h;function D(n,b){let g=n.id;const c=g.lastIndexOf("~");return c!==-1&&(g=g.substring(0,c)),b&&(g=`${g}~${b}`),{id:g}}d.modify=D;function l(n){const b=n.id.lastIndexOf("~");if(b!==-1)return n.id.substring(b+1)}d.getModifier=l;function M(n,b){return n.id===b.id&&n.color?.id===b.color?.id}d.isEqual=M;function r(n,b){return{id:n.id,color:b?A(b):void 0}}d.asThemeIcon=r,d.asClassNameArray=s.CSSIcon.asClassNameArray,d.asClassName=s.CSSIcon.asClassName,d.asCSSSelector=s.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=s.Codicon.file,e.FolderThemeIcon=s.Codicon.folder;function w(d){switch(d){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class i{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(F){return this.themingParticipants.push(F),this.onThemingParticipantAddedEmitter.fire(F),(0,E.toDisposable)(()=>{const _=this.themingParticipants.indexOf(F);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new i;k.Registry.add(e.Extensions.ThemingContribution,p);function o(d){return p.onColorThemeChange(d)}e.registerThemingParticipant=o;class u extends E.Disposable{constructor(F){super();this.themeService=F,this.theme=F.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(F){this.theme=F,this.updateStyles()}updateStyles(){}getColor(F,_){let m=this.theme.getColor(F);return m&&_&&(m=_(m,this.theme)),m?m.toString():null}}e.Themable=u}),define(Ee[47],ye([0,1,21,24,2,3]),function(ee,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var k;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function P(i){const p=i;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=P;function C(i){const p=i;return!!(p&&typeof p=="object"&&E.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=C;class A{constructor(p,o,u,d,F){this._id=p,this._transient=u,this._configuration=d,this._ignorePathCasing=F,this._foldersMap=s.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=s.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=A;class R{constructor(p,o){this.raw=o,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,t.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function w(i){return new R({uri:i,index:0,name:(0,t.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=w}),define(Ee[63],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class s{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const T=this._idPool++;return this._data.set(T,E),this.logDebugInfo(),T}get(E,T){return this._data.has(E)?this._data.get(E)[T]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!s.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=s,s.enableDebugLogging=!1}),define(Ee[30],ye([0,1,11,24,3]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(s.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(P=>{const C=this._providerInfo.get(P.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(P,C){C===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,C)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,E.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[28],ye([0,1,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,s.createDecorator)("IExtHostInitDataService")}),define(Ee[146],ye([0,1,14]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(k,P,C){this._deferredPromises=new Map,this._id=k,this._shared=P,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new s.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of A.values())R.complete()}catch(R){for(const w of A.values())w.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this._init}get(k,P){let C=this._value[k];return typeof C=="undefined"&&(C=P),C}update(k,P){this._value[k]=P;let C=this._deferredPromises.get(k);if(C!==void 0)return C.p;const A=new s.DeferredPromise;return this._deferredPromises.set(k,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class E extends t{constructor(k,P){super(k.identifier.value,!0,P);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=E}),define(Ee[147],ye([0,1,4,2,12]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(P,C){this._logService=P,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new s.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new s.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,C,A){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptModelChanged(C.value,A)}$acceptDirtyStateChanged(P,C){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptDirty(C)}$acceptModelSaved(P){const C=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(P,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,C);const A=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));A.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.apiNotebook})}};T=Be([$e(0,E.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(Ee[13],ye([0,1,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,s.createDecorator)("IExtHostRpcService");class t{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=t});var Ze=this&&this.__classPrivateFieldSet||function(ee,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!E:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(ee,s):E?E.value=s:e.set(ee,s),s},ke=this&&this.__classPrivateFieldGet||function(ee,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(ee):t?t.value:e.get(ee)};define(Ee[148],ye([0,1,25,4]),function(ee,e,s,t){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(P,C){E.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=s.ExtensionIdentifier.toKey(P.identifier),Ze(this,E,C,"f"),ke(this,E,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(P){return ke(this,E,"f").get(this._id,P)}store(P,C){return ke(this,E,"f").store(this._id,P,C)}delete(P){return ke(this,E,"f").delete(this._id,P)}}e.ExtensionSecrets=T,E=new WeakMap}),define(Ee[85],ye([0,1,3,4]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,s.createDecorator)("IExtHostTelemetry")}),define(Ee[48],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var s;(function(_){_[_.Upsert=0]="Upsert",_[_.RemoveChild=1]="RemoveChild",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp",_[_.Bulk=4]="Bulk"})(s=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,E=(_,m)=>{const h={controllerId:m};return t.set(_,h),h};e.createPrivateApiFor=E;const T=_=>t.get(_);e.getPrivateApiFor=T;const k=(_,m,h,D)=>{let l=h;return{enumerable:!0,configurable:!1,get(){return l},set(M){if(!D(l,M)){const r=l;l=M,_.listener?.({op:3,key:m,value:M,previous:r})}}}},P=(_,m)=>_===m,C={range:(_,m)=>_===m?!0:!_||!m?!1:_.isEqual(m),label:P,description:P,busy:P,error:P,canResolveChildren:P,tags:(_,m)=>!(_.length!==m.length||_.some(h=>!m.find(D=>h.id===D.id)))},A=Object.keys(C),R=(_,m)=>({range:k(_,"range",void 0,C.range),label:k(_,"label",m,C.label),description:k(_,"description",void 0,C.description),canResolveChildren:k(_,"canResolveChildren",!1,C.canResolveChildren),busy:k(_,"busy",!1,C.busy),error:k(_,"error",void 0,C.error),tags:k(_,"tags",[],C.tags)}),w=(_,m)=>{const h=new Map;for(const D of A)C[D](_[D],m[D])||h.set(D,m[D]);return h};e.diffTestItems=w;class i extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.DuplicateTestItemError=i;class p extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class o extends Error{constructor(m,h,D){super(`TestItem with ID "${m}" is from controller "${h}" and cannot be added as a child of an item from controller "${D}".`)}}e.MixedTestItemController=o;const u=_=>{const m=(0,e.getPrivateApiFor)(_);let h=new Map;return{get size(){return h.size},forEach(D,l){for(const M of h.values())D.call(l,M,this)},replace(D){const l=new Map,M=new Set(h.keys()),r={op:4,ops:[]};for(const n of D){if(!(n instanceof d))throw new p(n.id);const b=(0,e.getPrivateApiFor)(n).controllerId;if(b!==m.controllerId)throw new o(n.id,b,m.controllerId);if(l.has(n.id))throw new i(n.id);l.set(n.id,n),M.delete(n.id),r.ops.push({op:0,item:n})}for(const n of M.keys())r.ops.push({op:1,id:n});m.listener?.(r),h=l},add(D){if(!(D instanceof d))throw new p(D.id);h.set(D.id,D),m.listener?.({op:0,item:D})},delete(D){h.delete(D)&&m.listener?.({op:1,id:D})},get(D){return h.get(D)},toJSON(){return Array.from(h.values())},[Symbol.iterator](){return h.values()}}};class d{constructor(m,h,D,l){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const M=(0,e.createPrivateApiFor)(this,m);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return M.parent instanceof F?void 0:M.parent}},children:{value:u(this),enumerable:!0,writable:!1},...R(M,D)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=d;class F extends d{constructor(m,h){super(m,m,h,void 0)}}e.TestItemRootImpl=F}),define(Ee[64],ye([0,1,3,143,4,13]),function(ee,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var k;(function(C){function A(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:w.protocol}}C.fromApiTunnel=A;function R(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==t.TunnelPrivacyId.ConstantPrivate&&w.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}C.fromServiceTunnel=R})(k=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,s.createDecorator)("IExtHostTunnelService");let P=class{constructor(A){this.onDidChangeTunnels=new E.Emitter().event}async $applyCandidateFilter(A){return A}async openTunnel(A,R){}async getTunnels(){return[]}async setTunnelExtensionFunctions(A){return{dispose:()=>{}}}registerPortsAttributesProvider(A,R){return{dispose:()=>{}}}async $providePortAttributes(A,R,w,i,p){return[]}async $forwardPort(A,R){}async $closeTunnel(A){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=Be([$e(0,T.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Ze=this&&this.__classPrivateFieldSet||function(ee,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!E:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(ee,s):E?E.value=s:e.set(ee,s),s},ke=this&&this.__classPrivateFieldGet||function(ee,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(ee):t?t.value:e.get(ee)};define(Ee[7],ye([0,1,16,15,77,21,76,9,10,2,36,46,84]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i){"use strict";var p,o,u,d,F,_,m,h,D,l,M,r,n,b,g,c,f,v,a,S;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(x){function L(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(L,x),Object.setPrototypeOf(L.prototype,x.prototype),L}let N=F=class{constructor(L){p.set(this,void 0),Ze(this,p,L,"f")}static from(...L){let Z=L;return new F(function(){if(Z){for(const _e of Z)_e&&typeof _e.dispose=="function"&&_e.dispose();Z=void 0}})}dispose(){typeof ke(this,p,"f")=="function"&&(ke(this,p,"f").call(this),Ze(this,p,void 0,"f"))}};p=new WeakMap,N=F=Be([I],N),e.Disposable=N;let B=_=class{constructor(L,Z){if(L<0)throw(0,t.illegalArgument)("line must be non-negative");if(Z<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=L,this._character=Z}static Min(...L){if(L.length===0)throw new TypeError;let Z=L[0];for(let _e=1;_e<L.length;_e++){const qe=L[_e];qe.isBefore(Z)&&(Z=qe)}return Z}static Max(...L){if(L.length===0)throw new TypeError;let Z=L[0];for(let _e=1;_e<L.length;_e++){const qe=L[_e];qe.isAfter(Z)&&(Z=qe)}return Z}static isPosition(L){if(!L)return!1;if(L instanceof _)return!0;let{line:Z,character:_e}=L;return typeof Z=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,Z=0){if(L===null||Z===null)throw(0,t.illegalArgument)();let _e;return typeof L=="undefined"?_e=0:typeof L=="number"?_e=L:(_e=typeof L.lineDelta=="number"?L.lineDelta:0,Z=typeof L.characterDelta=="number"?L.characterDelta:0),_e===0&&Z===0?this:new _(this.line+_e,this.character+Z)}with(L,Z=this.character){if(L===null||Z===null)throw(0,t.illegalArgument)();let _e;return typeof L=="undefined"?_e=this.line:typeof L=="number"?_e=L:(_e=typeof L.line=="number"?L.line:this.line,Z=typeof L.character=="number"?L.character:this.character),_e===this.line&&Z===this.character?this:new _(_e,Z)}toJSON(){return{line:this.line,character:this.character}}};B=_=Be([I],B),e.Position=B;let y=m=class{constructor(L,Z,_e,qe){let tt,at;if(typeof L=="number"&&typeof Z=="number"&&typeof _e=="number"&&typeof qe=="number"?(tt=new B(L,Z),at=new B(_e,qe)):L instanceof B&&Z instanceof B&&(tt=L,at=Z),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(L){return L instanceof m?!0:L?B.isPosition(L.start)&&B.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof m?this.contains(L._start)&&this.contains(L._end):L instanceof B?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const Z=B.Max(L.start,this._start),_e=B.Min(L.end,this._end);if(!Z.isAfter(_e))return new m(Z,_e)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const Z=B.Min(L.start,this._start),_e=B.Max(L.end,this.end);return new m(Z,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,Z=this.end){if(L===null||Z===null)throw(0,t.illegalArgument)();let _e;return L?B.isPosition(L)?_e=L:(_e=L.start||this.start,Z=L.end||this.end):_e=this.start,_e.isEqual(this._start)&&Z.isEqual(this.end)?this:new m(_e,Z)}toJSON(){return[this.start,this.end]}};y=m=Be([I],y),e.Range=y;let O=h=class extends y{constructor(L,Z,_e,qe){let tt,at;if(typeof L=="number"&&typeof Z=="number"&&typeof _e=="number"&&typeof qe=="number"?(tt=new B(L,Z),at=new B(_e,qe)):L instanceof B&&Z instanceof B&&(tt=L,at=Z),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(L){return L instanceof h?!0:L?y.isRange(L)&&B.isPosition(L.anchor)&&B.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=h=Be([I],O),e.Selection=O;class z{constructor(L,Z,_e){if(typeof L!="string"||L.length===0)throw(0,t.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,t.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,t.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(Z),this.connectionToken=_e}}e.ResolvedAuthority=z;class U extends Error{constructor(L,Z=i.RemoteAuthorityResolverErrorCode.Unknown,_e){super(L);this._message=L,this._code=Z,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static NotAvailable(L,Z){return new U(L,i.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(L){return new U(L,i.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=U;var $;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var W;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let J=D=class{constructor(L,Z){this._range=L,this._newText=Z}static isTextEdit(L){return L instanceof D?!0:L?y.isRange(L)&&typeof L.newText=="string":!1}static replace(L,Z){return new D(L,Z)}static insert(L,Z){return D.replace(new y(L,L),Z)}static delete(L){return D.replace(L,"")}static setEndOfLine(L){const Z=new D(new y(new B(0,0),new B(0,0)),"");return Z.newEol=L,Z}get range(){return this._range}set range(L){if(L&&!y.isRange(L))throw(0,t.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,t.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,t.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};J=D=Be([I],J),e.TextEdit=J;var G;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(G=e.FileEditType||(e.FileEditType={}));let ae=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,Z,_e,qe){this._edits.push({_type:1,from:L,to:Z,options:_e,metadata:qe})}createFile(L,Z,_e){this._edits.push({_type:1,from:void 0,to:L,options:Z,metadata:_e})}deleteFile(L,Z,_e){this._edits.push({_type:1,from:L,to:void 0,options:Z,metadata:_e})}replaceNotebookMetadata(L,Z,_e){this._edits.push({_type:3,metadata:_e,uri:L,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(L,Z,_e,qe,tt){let at,dt,Pt=[],Mt;if(Fe.isNotebookRange(Z)&&xt.isNotebookCellDataArray(_e)&&!xt.isNotebookCellDataArray(qe)?(at=Z.start,dt=Z.end,Pt=_e,Mt=qe):typeof Z=="number"&&typeof _e=="number"&&xt.isNotebookCellDataArray(qe)&&(at=Z,dt=_e,Pt=qe,Mt=tt),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||Pt.length>0)&&this._edits.push({_type:5,uri:L,index:at,count:dt-at,cells:Pt,metadata:Mt})}replaceNotebookCellMetadata(L,Z,_e,qe){this._edits.push({_type:3,metadata:qe,uri:L,edit:{editType:8,index:Z,metadata:_e}})}replace(L,Z,_e,qe){this._edits.push({_type:2,uri:L,edit:new J(Z,_e),metadata:qe})}insert(L,Z,_e,qe){this.replace(L,new y(Z,Z),_e,qe)}delete(L,Z,_e){this.replace(L,Z,"",_e)}has(L){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===L.toString())}set(L,Z){if(Z)for(const _e of Z)_e&&this._edits.push({_type:2,uri:L,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const qe=this._edits[_e];qe._type===2&&qe.uri.toString()===L.toString()&&(this._edits[_e]=void 0)}(0,s.coalesceInPlace)(this._edits)}}get(L){const Z=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===L.toString()&&Z.push(_e.edit);return Z}entries(){const L=new T.ResourceMap;for(let Z of this._edits)if(Z._type===2){let _e=L.get(Z.uri);_e||(_e=[Z.uri,[]],L.set(Z.uri,_e)),_e[1].push(Z.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ae=Be([I],ae),e.WorkspaceEdit=ae;let we=l=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof l?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=l._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,Z=this._tabstop++){if(typeof L=="function"){const _e=new l;_e._tabstop=this._tabstop,L(_e),this._tabstop=_e._tabstop,L=_e.value}else L=l._escape(L);return this.value+="${",this.value+=Z,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,Z=this._tabstop++){const _e=L.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(L,Z){if(typeof Z=="function"){const _e=new l;_e._tabstop=this._tabstop,Z(_e),this._tabstop=_e._tabstop,Z=_e.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};we=l=Be([I],we),e.SnippetString=we;var Se;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(Se=e.DiagnosticTag||(e.DiagnosticTag={}));var ce;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ce=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=M=class{constructor(L,Z){if(this.uri=L,Z)if(Z instanceof y)this.range=Z;else if(Z instanceof B)this.range=new y(Z,Z);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof M?!0:L?y.isRange(L.range)&&A.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=M=Be([I],oe),e.Location=oe;let be=class{constructor(L,Z){this.location=L,this.message=Z}static is(L){return L?typeof L.message=="string"&&L.location&&y.isRange(L.location.range)&&A.URI.isUri(L.location.uri):!1}static isEqual(L,Z){return L===Z?!0:!L||!Z?!1:L.message===Z.message&&L.location.range.isEqual(Z.location.range)&&L.location.uri.toString()===Z.location.uri.toString()}};be=Be([I],be),e.DiagnosticRelatedInformation=be;let Pe=class{constructor(L,Z,_e=ce.Error){if(!y.isRange(L))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=L,this.message=Z,this.severity=_e}toJSON(){return{severity:ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,Z){return L===Z?!0:!L||!Z?!1:L.message===Z.message&&L.severity===Z.severity&&L.code===Z.code&&L.severity===Z.severity&&L.source===Z.source&&L.range.isEqual(Z.range)&&(0,s.equals)(L.tags,Z.tags)&&(0,s.equals)(L.relatedInformation,Z.relatedInformation,be.isEqual)}};Pe=Be([I],Pe),e.Diagnostic=Pe;let Me=class{constructor(L,Z){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=Z}};Me=Be([I],Me),e.Hover=Me;var He;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(He=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ye=class{constructor(L,Z=He.Text){this.range=L,this.kind=Z}toJSON(){return{range:this.range,kind:He[this.kind]}}};Ye=Be([I],Ye),e.DocumentHighlight=Ye;var Qe;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Qe=e.SymbolKind||(e.SymbolKind={}));var H;(function(x){x[x.Deprecated=1]="Deprecated"})(H=e.SymbolTag||(e.SymbolTag={}));let K=r=class{constructor(L,Z,_e,qe,tt){this.name=L,this.kind=Z,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),qe instanceof oe?this.location=qe:_e instanceof y&&(this.location=new oe(qe,_e)),r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Qe[this.kind],location:this.location,containerName:this.containerName}}};K=r=Be([I],K),e.SymbolInformation=K;let X=n=class{constructor(L,Z,_e,qe,tt){this.name=L,this.detail=Z,this.kind=_e,this.range=qe,this.selectionRange=tt,this.children=[],n.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(n.validate)}};X=n=Be([I],X),e.DocumentSymbol=X;var se;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let q=class{constructor(L,Z){this.title=L,this.kind=Z}};q=Be([I],q),e.CodeAction=q;let te=b=class{constructor(L){this.value=L}append(L){return new b(this.value?this.value+b.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+b.sep)}};te.sep=".",te=b=Be([I],te),e.CodeActionKind=te,te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll");let he=class{constructor(L,Z){if(this.range=L,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};he=Be([I],he),e.SelectionRange=he;class Ae{constructor(L,Z,_e,qe,tt,at){this.kind=L,this.name=Z,this.detail=_e,this.uri=qe,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=Ae;class Ue{constructor(L,Z){this.fromRanges=Z,this.from=L}}e.CallHierarchyIncomingCall=Ue;class ze{constructor(L,Z){this.fromRanges=Z,this.to=L}}e.CallHierarchyOutgoingCall=ze;var Ge;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Ge=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(L,Z){this.range=L,this.command=Z}get isResolved(){return!!this.command}};et=Be([I],et),e.CodeLens=et;let st=g=class{constructor(L,Z=!1){o.set(this,void 0),Ze(this,o,new E.MarkdownString(L,{supportThemeIcons:Z}),"f")}static isMarkdownString(L){return L instanceof g?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return ke(this,o,"f").value}set value(L){ke(this,o,"f").value=L}get isTrusted(){return ke(this,o,"f").isTrusted}set isTrusted(L){ke(this,o,"f").isTrusted=L}get supportThemeIcons(){return ke(this,o,"f").supportThemeIcons}set supportThemeIcons(L){ke(this,o,"f").supportThemeIcons=L}get supportHtml(){return ke(this,o,"f").supportHtml}set supportHtml(L){ke(this,o,"f").supportHtml=L}appendText(L){return ke(this,o,"f").appendText(L),this}appendMarkdown(L){return ke(this,o,"f").appendMarkdown(L),this}appendCodeblock(L,Z){return ke(this,o,"f").appendCodeblock(Z??"",L),this}};o=new WeakMap,st=g=Be([I],st),e.MarkdownString=st;let Xe=class{constructor(L,Z){this.label=L,this.documentation=Z}};Xe=Be([I],Xe),e.ParameterInformation=Xe;let nt=class{constructor(L,Z){this.label=L,this.documentation=Z,this.parameters=[]}};nt=Be([I],nt),e.SignatureInformation=nt;let lt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};lt=Be([I],lt),e.SignatureHelp=lt;var vt;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(vt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Oe;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Oe=e.InlayHintKind||(e.InlayHintKind={}));let Rt=class{constructor(L,Z,_e){this.text=L,this.position=Z,this.kind=_e}};Rt=Be([I],Rt),e.InlayHint=Rt;var j;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(j=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Q;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var fe;(function(x){x[x.Deprecated=1]="Deprecated"})(fe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ne=class{constructor(L,Z){this.label=L,this.kind=Z}toJSON(){return{label:this.label,kind:this.kind&&Q[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ne=Be([I],Ne),e.CompletionItem=Ne;let Ve=class{constructor(L=[],Z=!1){this.items=L,this.isIncomplete=Z}};Ve=Be([I],Ve),e.CompletionList=Ve;let ot=class{constructor(L,Z,_e){this.text=L,this.range=Z,this.command=_e}};ot=Be([I],ot),e.InlineSuggestion=ot;let ht=class{constructor(L){this.items=L}};ht=Be([I],ht),e.InlineSuggestions=ht;var Je;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Je=e.ViewColumn||(e.ViewColumn={}));var Tt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Re;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(Re=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ce;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Ce=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var pe;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(pe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ne;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(ne=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var le;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(le=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var de;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(de=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function L(Z){switch(Z){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=L}(ne=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let me=class{constructor(L,Z){if(Z&&!A.URI.isUri(Z))throw(0,t.illegalArgument)("target");if(!y.isRange(L)||L.isEmpty)throw(0,t.illegalArgument)("range");this.range=L,this.target=Z}};me=Be([I],me),e.DocumentLink=me;let Te=class{constructor(L,Z,_e,qe){this.red=L,this.green=Z,this.blue=_e,this.alpha=qe}};Te=Be([I],Te),e.Color=Te;let We=class{constructor(L,Z){if(Z&&!(Z instanceof Te))throw(0,t.illegalArgument)("color");if(!y.isRange(L)||L.isEmpty)throw(0,t.illegalArgument)("range");this.range=L,this.color=Z}};We=Be([I],We),e.ColorInformation=We;let Le=class{constructor(L){if(!L||typeof L!="string")throw(0,t.illegalArgument)("label");this.label=L}};Le=Be([I],Le),e.ColorPresentation=Le;var je;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(je=e.ColorFormat||(e.ColorFormat={}));var it;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class rt{constructor(L,Z,_e){if(this.startIndex=L,this.length=Z,this.tooltip=_e,typeof L!="number"||L<0)throw(0,t.illegalArgument)("startIndex");if(typeof Z!="number"||Z<1)throw(0,t.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=rt;var re;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(re=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(L){this.options=L,typeof L!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=ge;var ie;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(ie=e.TaskRevealKind||(e.TaskRevealKind={}));var V;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(V=e.TaskPanelKind||(e.TaskPanelKind={}));let ve=c=class{constructor(L,Z){if(this.label=Z,typeof L!="string"||typeof Z!="string")throw(0,t.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};ve.Clean=new c("clean","Clean"),ve.Build=new c("build","Build"),ve.Rebuild=new c("rebuild","Rebuild"),ve.Test=new c("test","Test"),ve=c=Be([I],ve),e.TaskGroup=ve;function Ie(x){let L="";for(let Z=0;Z<x.length;Z++)L+=x[Z].replace(/,/g,",,")+",";return L}let Ke=class{constructor(L,Z,_e){if(typeof L!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=L,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=_e):this._options=Z)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,t.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)L.push(Z);return Ie(L)}};Ke=Be([I],Ke),e.ProcessExecution=Ke;let xe=class{constructor(L,Z,_e){if(this._args=[],Array.isArray(Z)){if(!L)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,t.illegalArgument)("command");this._command=L,this._args=Z,this._options=_e}else{if(typeof L!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=L,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,t.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)L.push(typeof Z=="string"?Z:Z.value);return Ie(L)}};xe=Be([I],xe),e.ShellExecution=xe;var ut;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(ut=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class Ct{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=Ct;let bt=f=class{constructor(L,Z,_e,qe,tt,at){this.__deprecated=!1,this._definition=this.definition=L;let dt;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=_e,this.execution=qe,dt=tt,this.__deprecated=!0):Z===wt.Global||Z===wt.Workspace?(this.target=Z,this._name=this.name=_e,this._source=this.source=qe,this.execution=tt,dt=at):(this.target=Z,this._name=this.name=_e,this._source=this.source=qe,this.execution=tt,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ke?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof Ct?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const Z=this._definition.type;(f.EmptyType===Z||f.ProcessType===Z||f.ShellType===Z||f.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=f=Be([I],bt),e.Task=bt;var ft;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let pt=class{constructor(L,Z=yt.None){this.collapsibleState=Z,A.URI.isUri(L)?this.resourceUri=L:this.label=L}};pt=Be([I],pt),e.TreeItem=pt;var yt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(yt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ot=class{constructor(L){this._value=L}async asString(){return JSON.stringify(this._value)}};Ot=Be([I],Ot),e.TreeDataTransferItem=Ot;let kt=class{constructor(){this._items=new Map}get(L){return this._items.get(L)}set(L,Z){this._items.set(L,Z)}forEach(L){this._items.forEach(L)}};kt=Be([I],kt),e.TreeDataTransfer=kt;let It=class{constructor(L,Z){this.id=L,this.color=Z}};It=Be([I],It),e.ThemeIcon=It,It.File=new It("file"),It.Folder=new It("folder");let At=class{constructor(L){this.id=L}};At=Be([I],At),e.ThemeColor=At;var St;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(St=e.ConfigurationTarget||(e.ConfigurationTarget={}));let zt=class{constructor(L,Z){if(typeof L!="string"&&(!L||!A.URI.isUri(L)&&!A.URI.isUri(L.uri)))throw(0,t.illegalArgument)("base");if(typeof Z!="string")throw(0,t.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=A.URI.file(L),this.base=L):A.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=Z}};zt=Be([I],zt),e.RelativePattern=zt;let Lt=class{constructor(L,Z,_e,qe){this.enabled=typeof L=="boolean"?L:!0,typeof Z=="string"&&(this.condition=Z),typeof _e=="string"&&(this.hitCondition=_e),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Lt=Be([I],Lt),e.Breakpoint=Lt;let Et=class extends Lt{constructor(L,Z,_e,qe,tt){super(Z,_e,qe,tt);if(L===null)throw(0,t.illegalArgument)("location");this.location=L}};Et=Be([I],Et),e.SourceBreakpoint=Et;let Qt=class extends Lt{constructor(L,Z,_e,qe,tt){super(Z,_e,qe,tt);this.functionName=L}};Qt=Be([I],Qt),e.FunctionBreakpoint=Qt;let Vt=class extends Lt{constructor(L,Z,_e,qe,tt,at,dt){super(qe,tt,at,dt);if(!Z)throw(0,t.illegalArgument)("dataId");this.label=L,this.dataId=Z,this.canPersist=_e}};Vt=Be([I],Vt),e.DataBreakpoint=Vt;let Yt=class{constructor(L,Z,_e){this.command=L,this.args=Z||[],this.options=_e}};Yt=Be([I],Yt),e.DebugAdapterExecutable=Yt;let si=class{constructor(L,Z){this.port=L,this.host=Z}};si=Be([I],si),e.DebugAdapterServer=si;let Ft=class{constructor(L){this.path=L}};Ft=Be([I],Ft),e.DebugAdapterNamedPipeServer=Ft;let Xt=class{constructor(L){this.implementation=L}};Xt=Be([I],Xt),e.DebugAdapterInlineImplementation=Xt;let ai=class{constructor(L,Z){this.range=L,this.expression=Z}};ai=Be([I],ai),e.EvaluatableExpression=ai;var Jt;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(Jt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(L,Z){this.range=L,this.text=Z}};Wt=Be([I],Wt),e.InlineValueText=Wt;let gt=class{constructor(L,Z,_e=!0){this.range=L,this.variableName=Z,this.caseSensitiveLookup=_e}};gt=Be([I],gt),e.InlineValueVariableLookup=gt;let li=class{constructor(L,Z){this.range=L,this.expression=Z}};li=Be([I],li),e.InlineValueEvaluatableExpression=li;let Nt=class{constructor(L,Z){this.frameId=L,this.stoppedLocation=Z}};Nt=Be([I],Nt),e.InlineValueContext=Nt;var jt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let Zt=v=class extends Error{constructor(L,Z=w.FileSystemProviderErrorCode.Unknown,_e){super(A.URI.isUri(L)?L.toString(!0):L);this.code=_e?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(L){return new v(L,w.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(L){return new v(L,w.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(L){return new v(L,w.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(L){return new v(L,w.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(L){return new v(L,w.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(L){return new v(L,w.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}};Zt=v=Be([I],Zt),e.FileSystemError=Zt;let ci=class{constructor(L,Z,_e){this.start=L,this.end=Z,this.kind=_e}};ci=Be([I],ci),e.FoldingRange=ci;var fi;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class ei{constructor(L,Z=[]){this.tokenTypes=L,this.tokenModifiers=Z}}e.SemanticTokensLegend=ei;function yi(x){return typeof x=="undefined"||(0,C.isStringArray)(x)}class qt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let Z=0,_e=L.tokenTypes.length;Z<_e;Z++)this._tokenTypeStrToInt.set(L.tokenTypes[Z],Z);for(let Z=0,_e=L.tokenModifiers.length;Z<_e;Z++)this._tokenModifierStrToInt.set(L.tokenModifiers[Z],Z)}}push(L,Z,_e,qe,tt){if(typeof L=="number"&&typeof Z=="number"&&typeof _e=="number"&&typeof qe=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(L,Z,_e,qe,tt);if(y.isRange(L)&&typeof Z=="string"&&yi(_e))return this._push(L,Z,_e);throw(0,t.illegalArgument)()}_push(L,Z,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const qe=L.start.line,tt=L.start.character,at=L.end.character-L.start.character,dt=this._tokenTypeStrToInt.get(Z);let Pt=0;if(_e)for(const Mt of _e){if(!this._tokenModifierStrToInt.has(Mt))throw new Error("`tokenModifier` is not in the provided legend");const Ut=this._tokenModifierStrToInt.get(Mt);Pt|=1<<Ut>>>0}this._pushEncoded(qe,tt,at,dt,Pt)}_pushEncoded(L,Z,_e,qe,tt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Pt=this._data.length/5|0;let Mt=0,Ut=0;for(let Bt=0;Bt<Pt;Bt++){let $t=this._data[5*Bt],di=this._data[5*Bt+1];$t===0?($t=Mt,di+=Ut):$t+=Mt,this._data[5*Bt]=$t,this._data[5*Bt+1]=di,Mt=$t,Ut=di}}let at=L,dt=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=tt,this._prevLine=L,this._prevChar=Z}static _sortAndDeltaEncode(L){let Z=[];const _e=L.length/5|0;for(let dt=0;dt<_e;dt++)Z[dt]=dt;Z.sort((dt,Pt)=>{const Mt=L[5*dt],Ut=L[5*Pt];if(Mt===Ut){const Bt=L[5*dt+1],$t=L[5*Pt+1];return Bt-$t}return Mt-Ut});const qe=new Uint32Array(L.length);let tt=0,at=0;for(let dt=0;dt<_e;dt++){const Pt=5*Z[dt],Mt=L[Pt+0],Ut=L[Pt+1],Bt=L[Pt+2],$t=L[Pt+3],di=L[Pt+4],Hi=Mt-tt,Yi=Hi===0?Ut-at:Ut,hi=5*dt;qe[hi+0]=Hi,qe[hi+1]=Yi,qe[hi+2]=Bt,qe[hi+3]=$t,qe[hi+4]=di,tt=Mt,at=Ut}return qe}build(L){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),L):new Gt(qt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=qt;class Gt{constructor(L,Z){this.resultId=Z,this.data=L}}e.SemanticTokens=Gt;class _i{constructor(L,Z,_e){this.start=L,this.deleteCount=Z,this.data=_e}}e.SemanticTokensEdit=_i;class Si{constructor(L,Z){this.resultId=Z,this.edits=L}}e.SemanticTokensEdits=Si;var Kt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Kt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ci;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(Ci=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ti=class{constructor(){}};ti.Back={iconPath:new It("arrow-left")},ti=Be([I],ti),e.QuickInputButtons=ti;var Di;(function(x){x[x.Separator=-1]="Separator",x[x.Default=1]="Default"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(L,Z,_e){this.badge=L,this.tooltip=Z,this.color=_e}static validate(L){if(L.badge){let Z=(0,P.nextCharLength)(L.badge,0);if(Z<L.badge.length&&(Z+=(0,P.nextCharLength)(L.badge,Z)),L.badge.length>Z)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ii=class{constructor(L){this.kind=L}};ii=Be([I],ii),e.ColorTheme=ii;var gi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Fe{constructor(L,Z){if(L<0)throw(0,t.illegalArgument)("start must be positive");if(Z<0)throw(0,t.illegalArgument)("end must be positive");L<=Z?(this._start=L,this._end=Z):(this._start=Z,this._end=L)}static isNotebookRange(L){return L instanceof Fe?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let Z=this._start,_e=this._end;return L.start!==void 0&&(Z=L.start),L.end!==void 0&&(_e=L.end),Z===this._start&&_e===this._end?this:new Fe(Z,_e)}}e.NotebookRange=Fe;class xt{constructor(L,Z,_e,qe,tt,at,dt){this.kind=L,this.value=Z,this.languageId=_e,this.mime=qe,this.outputs=tt??[],this.metadata=at,this.executionSummary=dt,xt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(Z=>xt.isNotebookCellData(Z))}static isNotebookCellData(L){return!0}}e.NotebookCellData=xt;class pi{constructor(L){this.cells=L}}e.NotebookData=pi;class mt{constructor(L,Z){this.data=L,this.mime=Z;const _e=(0,k.normalizeMimeType)(Z,!0);if(!_e)throw new Error(`INVALID mime type: ${Z}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(L){return L instanceof mt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const Z={name:L.name,message:L.message,stack:L.stack};return mt.json(Z,"application/vnd.code.notebook.error")}static stdout(L){return mt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return mt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,Z="application/octet-stream"){return new mt(L,Z)}static text(L,Z=k.Mimes.text){const _e=ke(mt,u,"f",d).encode(String(L));return new mt(_e,Z)}static json(L,Z="application/json"){const _e=JSON.stringify(L,void 0,"	");return mt.text(_e,Z)}}e.NotebookCellOutputItem=mt,u=mt,d={value:new TextEncoder};class ni{constructor(L,Z,_e){this.items=ni.ensureUniqueMimeTypes(L,!0),typeof Z=="string"?(this.id=Z,this.metadata=_e):(this.id=(0,R.generateUuid)(),this.metadata=Z??_e)}static isNotebookCellOutput(L){return L instanceof ni?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,C.isArray)(L.items)}static ensureUniqueMimeTypes(L,Z=!1){const _e=new Set,qe=new Set;for(let tt=0;tt<L.length;tt++){const at=L[tt],dt=(0,k.normalizeMimeType)(at.mime);if(!_e.has(dt)){_e.add(dt);continue}qe.add(tt),Z&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return qe.size===0?L:L.filter((tt,at)=>!qe.has(at))}}e.NotebookCellOutput=ni;var Ii;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var bi;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(bi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(L,Z){this.text=L,this.alignment=Z}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(L,Z=[]){this.uri=L,this.provides=(0,s.asArray)(Z)}}e.NotebookRendererScript=Ri;let ri=class{constructor(L,Z){this.label=L,this.timestamp=Z}};ri=Be([I],ri),e.TimelineItem=ri;var Fi;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Oi;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(Oi=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(L,Z){this.ranges=L,this.wordPattern=Z}}e.LinkedEditingRanges=Li;class Ni{constructor(L,Z){this._port=L,this._autoForwardAction=Z}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var Y;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(Y=e.TestResultState||(e.TestResultState={}));var ue;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(ue=e.TestRunProfileKind||(e.TestRunProfileKind={}));let De=class{constructor(L=void 0,Z=void 0,_e=void 0){this.include=L,this.exclude=Z,this.profile=_e}};De=Be([I],De),e.TestRunRequest=De;let ct=a=class{constructor(L){this.message=L}static diff(L,Z,_e){const qe=new a(L);return qe.expectedOutput=Z,qe.actualOutput=_e,qe}};ct=a=Be([I],ct),e.TestMessage=ct;let _t=class{constructor(L){this.id=L}};_t=Be([I],_t),e.TestTag=_t;let Dt=class{constructor(L,Z){this.covered=L,this.total=Z}};Dt=Be([I],Dt),e.CoveredCount=Dt;let xi=S=class{constructor(L,Z,_e,qe){this.uri=L,this.statementCoverage=Z,this.branchCoverage=_e,this.functionCoverage=qe}static fromDetails(L,Z){const _e=new Dt(0,0),qe=new Dt(0,0),tt=new Dt(0,0);for(const dt of Z)if("branches"in dt){_e.total+=1,_e.covered+=dt.executionCount>0?1:0;for(const Pt of dt.branches)qe.total+=1,qe.covered+=Pt.executionCount>0?1:0}else tt.total+=1,tt.covered+=dt.executionCount>0?1:0;const at=new S(L,_e,qe.total>0?qe:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=Z,at}};xi=S=Be([I],xi),e.FileCoverage=xi;let Ui=class{constructor(L,Z,_e=[]){this.executionCount=L,this.location=Z,this.branches=_e}};Ui=Be([I],Ui),e.StatementCoverage=Ui;let Bi=class{constructor(L,Z){this.executionCount=L,this.location=Z}};Bi=Be([I],Bi),e.BranchCoverage=Bi;let $i=class{constructor(L,Z){this.executionCount=L,this.location=Z}};$i=Be([I],$i),e.FunctionCoverage=$i;var qi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(L,Z,_e,qe,tt,at){this.kind=L,this.name=Z,this.detail=_e,this.uri=qe,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=Qi}),define(Ee[86],ye([0,1,42,11,9,223,113,7,16]),function(ee,e,s,t,E,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function R(o,u){u?A.set(o,u):A.delete(o)}e.setWordDefinitionFor=R;function w(o){return A.get(o)}e.getWordDefinitionFor=w;class i extends T.MirrorTextModel{constructor(u,d,F,_,m,h,D,l){super(d,F,_,m);this._proxy=u,this._languageId=h,this._isDirty=D,this._notebook=l,this._isDisposed=!1}dispose(){(0,s.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,C.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===t.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(d){return d?u._getTextInRange(d):u.getText()},get eol(){return u._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(d){return u._lineAt(d)},offsetAt(d){return u._offsetAt(d)},positionAt(d){return u._positionAt(d)},validateRange(d){return u._validateRange(d)},validatePosition(d){return u._validatePosition(d)},getWordRangeAtPosition(d,F){return u._getWordRangeAtPosition(d,F)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,s.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,s.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const d=this._validateRange(u);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const F=this._eol,_=d.start.line,m=d.end.line,h=[];h.push(this._lines[_].substring(d.start.character));for(let D=_+1;D<m;D++)h.push(this._lines[D]);return h.push(this._lines[m].substring(0,d.end.character)),h.join(F)}_lineAt(u){let d;if(u instanceof P.Position?d=u.line:typeof u=="number"&&(d=u),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new p(d,this._lines[d],d===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(u),F=this._lines[d.index].length;return new P.Position(d.index,Math.min(d.remainder,F))}_validateRange(u){if(!(u instanceof P.Range))throw new Error("Invalid argument");const d=this._validatePosition(u.start),F=this._validatePosition(u.end);return d===u.start&&F===u.end?u:new P.Range(d.line,d.character,F.line,F.character)}_validatePosition(u){if(!(u instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:d,character:F}=u,_=!1;if(d<0)d=0,F=0,_=!0;else if(d>=this._lines.length)d=this._lines.length-1,F=this._lines[d].length,_=!0;else{const m=this._lines[d].length;F<0?(F=0,_=!0):F>m&&(F=m,_=!0)}return _?new P.Position(d,F):u}_getWordRangeAtPosition(u,d){const F=this._validatePosition(u);if(!d)d=w(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const _=(0,k.getWordAtText)(F.character+1,(0,k.ensureValidWordDefinition)(d),this._lines[F.line],0);if(_)return new P.Range(F.line,_.startColumn-1,F.line,_.endColumn-1)}}e.ExtHostDocumentData=i;class p{constructor(u,d,F){this._line=u,this._text=d,this._isLastLine=F}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(Ee[149],ye([0,1,7,4,224,6,56,21,2,36]),function(ee,e,s,t,E,T,k,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(i,p,o,u){this._notebook=o,this._selector=u,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,A.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(F=>{const _=this._cellUris.get(F.document.uri);_!==void 0&&(this._cellLengths.setValue(_,this._cells[_].document.getText().length+1),this._cellLines.setValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const d=F=>{F===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(i.onDidChangeNotebookCells(F=>d(F.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const i=[],p=[];for(const o of this._notebook.getCells())o.kind===s.NotebookCellKind.Code&&(!this._selector||(0,k.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),i.push(o.document.getText().length+1),p.push(o.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(i)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(i){if(!i){let _="";for(const m of this._cells)_+=m.document.getText()+`
`;return _=_.slice(0,-1),_}if(i.isEmpty)return"";const p=this.locationAt(i.start),o=this.locationAt(i.end),u=this._cellUris.get(p.uri),d=this._cellUris.get(o.uri);if(u===void 0||d===void 0)return"";if(u===d)return this._cells[u].document.getText(new s.Range(p.range.start,o.range.end));const F=[this._cells[u].document.getText(new s.Range(p.range.start,new s.Position(this._cells[u].document.lineCount,0)))];for(let _=u+1;_<d;_++)F.push(this._cells[_].document.getText());return F.push(this._cells[d].document.getText(new s.Range(new s.Position(0,0),o.range.end))),F.join(`
`)}offsetAt(i){const p=this._cellLines.getIndexOf(i.line),o=this._cellLengths.getPrefixSum(p.index-1),u=this._cells[p.index].document.offsetAt(i.with(p.remainder));return o+u}positionAt(i){if(typeof i=="number"){const o=this._cellLengths.getIndexOf(i),u=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(u)}const p=this._cellUris.get(i.uri);if(p!==void 0){const o=this._cellLines.getPrefixSum(p-1);return new s.Position(o+i.range.start.line,i.range.start.character)}return new s.Position(0,0)}locationAt(i){s.Range.isRange(i)||(i=new s.Range(i,i));const p=this._cellLines.getIndexOf(i.start.line);let o=p;i.isEmpty||(o=this._cellLines.getIndexOf(i.end.line));const u=new s.Position(p.remainder,i.start.character),d=new s.Position(o.remainder,i.end.character),F=new s.Range(u,d),_=this._cells[p.index];return new s.Location(_.document.uri,_.document.validateRange(F))}contains(i){return this._cellUris.has(i)}validateRange(i){const p=this.validatePosition(i.start),o=this.validatePosition(i.end);return i.with(p,o)}validatePosition(i){const p=this._cellLines.getIndexOf(i.line),o=new s.Position(p.remainder,i.character),u=this._cells[p.index].document.validatePosition(o),d=this._cellLines.getPrefixSum(p.index-1);return new s.Position(d+u.line,u.character)}}e.ExtHostNotebookConcatDocument=R}),define(Ee[150],ye([0,1,7,13,4]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(P){this._actual=new s.ColorTheme(s.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let C=P==="light"?s.ColorThemeKind.Light:P==="dark"?s.ColorThemeKind.Dark:s.ColorThemeKind.HighContrast;this._actual=new s.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Be([$e(0,t.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(Ee[65],ye([0,1,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,s.createDecorator)("IURITransformerService");class t{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=t}),define(Ee[151],ye([0,1,22]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(C){let A=this.buffers.indexOf(C);return A<0&&(A=this.buffers.length,this.buffers.push(C)),A}}function E(P,C){if(C.serializeBuffersForPostMessage){const A=new t,R=(p,o)=>{if(o instanceof ArrayBuffer){const u=A.add(o);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(o)){const u=T(o);if(u){const d=A.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:u,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},w=JSON.stringify(P,R),i=A.buffers.map(p=>{const o=new Uint8Array(p);return s.VSBuffer.wrap(o)});return{message:w,buffers:i}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=E;function T(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(P,C){const A=C.map(i=>{const p=new ArrayBuffer(i.byteLength);return new Uint8Array(p).set(i.buffer),p}),R=C.length?(i,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const o=p,{index:u}=o,d=A[u];if(o.view)switch(o.view.type){case 1:return new Int8Array(d,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return p}:void 0;return{message:JSON.parse(P,R),arrayBuffers:A}}e.deserializeWebviewMessage=k}),define(Ee[152],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var s;(function(t){function E(k){const P=new Map;return k.types.forEach((C,A)=>{P.set(C,{asString:async()=>k.items[A].asString})}),P}t.toITreeDataTransfer=E;async function T(k){const P={types:[],items:[]},C=Array.from(k.entries());for(const A of C)P.types.push(A[0]),P.items.push({asString:await A[1].asString()});return P}t.toTreeDataTransferDTO=T})(s=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Ee[66],ye([0,1,11,2]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(P,C){return P.scheme===s.Schemas.http||P.scheme===s.Schemas.https?P:(C&&C.authority&&C.isRemote&&P.scheme===s.Schemas.file&&(P=t.URI.from({scheme:s.Schemas.vscodeRemote,authority:C.authority,path:P.path})),t.URI.from({scheme:s.Schemas.https,authority:`${P.scheme}+${T(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=E;function T(P){return P.replace(/./g,C=>{const A=C.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?C:"-"+A.toString(16).padStart(4,"0")})}function k(P){return P.replace(/-([0-9a-f]{4})/g,(C,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=k}),define(Ee[153],ye([0,1,4,6,66]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(P,C,A){this._proxy=P,this._editors=C,this._initData=A,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const R=C.getVisibleTextEditors();for(const w of this._insets.values())R.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,C,A,R,w){let i;for(const m of this._editors.getVisibleTextEditors(!0))if(m.value===P){i=m;break}if(!i)throw new Error("not a visible editor");const p=this,o=this._handlePool++,u=new s.Emitter,d=new s.Emitter,F=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(m){return(0,E.asWebviewUri)(m,p._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(m){this._options=m,p._proxy.$setOptions(o,m)}get options(){return this._options}set html(m){this._html=m,p._proxy.$setHtml(o,m)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(m){return p._proxy.$postMessage(o,m)}},_=new class{constructor(){this.editor=P,this.line=C,this.height=A,this.webview=F,this.onDidDispose=d.event}dispose(){p._insets.has(o)&&(p._insets.delete(o),p._proxy.$disposeEditorInset(o),d.fire(),d.dispose(),u.dispose())}};return this._proxy.$createEditorInset(o,i.id,i.value.document.uri,C+1,A,R||{},w.identifier,w.extensionLocation),this._insets.set(o,{editor:P,inset:_,onDidReceiveMessage:u}),_}$onDidDispose(P){const C=this._insets.get(P);C&&C.inset.dispose()}$onDidReceiveMessage(P,C){const A=this._insets.get(P);A&&A.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=T}),define(Ee[154],ye([0,1,125,10,2,6,3,45,37,46,16,11]),function(ee,e,s,t,E,T,k,P,C,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorTabsVisibleContext=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,s.localize)(0,null),providerDisplayName:(0,s.localize)(1,null)},e.ActiveEditorDirtyContext=new P.RawContextKey("activeEditorIsDirty",!1,(0,s.localize)(2,null)),e.ActiveEditorPinnedContext=new P.RawContextKey("activeEditorIsNotPreview",!1,(0,s.localize)(3,null)),e.ActiveEditorStickyContext=new P.RawContextKey("activeEditorIsPinned",!1,(0,s.localize)(4,null)),e.ActiveEditorReadonlyContext=new P.RawContextKey("activeEditorIsReadonly",!1,(0,s.localize)(5,null)),e.ActiveEditorCanRevertContext=new P.RawContextKey("activeEditorCanRevert",!1,(0,s.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new P.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new P.RawContextKey("activeEditor",null,{type:"string",description:(0,s.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new P.RawContextKey("activeEditorAvailableEditorIds","",(0,s.localize)(8,null)),e.TextCompareEditorVisibleContext=new P.RawContextKey("textCompareEditorVisible",!1,(0,s.localize)(9,null)),e.TextCompareEditorActiveContext=new P.RawContextKey("textCompareEditorActive",!1,(0,s.localize)(10,null)),e.SideBySideEditorActiveContext=new P.RawContextKey("sideBySideEditorActive",!1,(0,s.localize)(11,null)),e.EditorGroupEditorsCountContext=new P.RawContextKey("groupEditorsCount",0,(0,s.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new P.RawContextKey("activeEditorGroupEmpty",!1,(0,s.localize)(13,null)),e.ActiveEditorGroupIndexContext=new P.RawContextKey("activeEditorGroupIndex",0,(0,s.localize)(14,null)),e.ActiveEditorGroupLastContext=new P.RawContextKey("activeEditorGroupLast",!1,(0,s.localize)(15,null)),e.ActiveEditorGroupLockedContext=new P.RawContextKey("activeEditorGroupLocked",!1,(0,s.localize)(16,null)),e.MultipleEditorGroupsContext=new P.RawContextKey("multipleEditorGroups",!1,(0,s.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new P.RawContextKey("editorIsOpen",!1,(0,s.localize)(18,null)),e.InEditorZenModeContext=new P.RawContextKey("inZenMode",!1,(0,s.localize)(19,null)),e.IsCenteredLayoutContext=new P.RawContextKey("isCenteredLayout",!1,(0,s.localize)(20,null)),e.SplitEditorsVertically=new P.RawContextKey("splitEditorsVertically",!1,(0,s.localize)(21,null)),e.EditorAreaVisibleContext=new P.RawContextKey("editorAreaVisible",!0,(0,s.localize)(22,null)),e.EditorTabsVisibleContext=new P.RawContextKey("editorTabsVisible",!0,(0,s.localize)(23,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function i(y,O,z){for(const U of z.visibleEditorPanes)if(U.group.id===O&&y.matches(U.input))return U.getViewState()}e.findViewStateForEditor=i;function p(y){if(D(y))return!1;const O=y;return E.URI.isUri(O?.resource)}e.isResourceEditorInput=p;function o(y){if(D(y))return!1;const O=y;return O?.original!==void 0&&O.modified!==void 0}e.isResourceDiffEditorInput=o;function u(y){if(D(y)||o(y))return!1;const O=y;return O?.primary!==void 0&&O.secondary!==void 0}e.isResourceSideBySideEditorInput=u;function d(y){if(D(y))return!1;const O=y;return O?O.resource===void 0||O.resource.scheme===w.Schemas.untitled||O.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=d;var F;(function(y){y[y.SHORT=0]="SHORT",y[y.MEDIUM=1]="MEDIUM",y[y.LONG=2]="LONG"})(F=e.Verbosity||(e.Verbosity={}));var _;(function(y){y[y.EXPLICIT=1]="EXPLICIT",y[y.AUTO=2]="AUTO",y[y.FOCUS_CHANGE=3]="FOCUS_CHANGE",y[y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));var m;(function(y){y[y.None=0]="None",y[y.Readonly=2]="Readonly",y[y.Untitled=4]="Untitled",y[y.Singleton=8]="Singleton",y[y.RequiresTrust=16]="RequiresTrust",y[y.CanSplitInGroup=32]="CanSplitInGroup",y[y.ForceDescription=64]="ForceDescription"})(m=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class h extends T.Disposable{}e.AbstractEditorInput=h;function D(y){return y instanceof h}e.isEditorInput=D;function l(y){const O=y;return E.URI.isUri(O?.preferredResource)}function M(y){const O=y;return D(O?.primary)&&D(O?.secondary)}e.isSideBySideEditorInput=M;function r(y){const O=y;return D(O?.modified)&&D(O?.original)}e.isDiffEditorInput=r;function n(y){return D(y?.editor)}e.isEditorInputWithOptions=n;function b(y){const O=y;return n(y)&&O?.group!==void 0}e.isEditorInputWithOptionsAndGroup=b;function g(y){const O=y;return typeof O?.groupId=="number"&&D(O.editor)}e.isEditorIdentifier=g;var c;(function(y){y[y.UNKNOWN=0]="UNKNOWN",y[y.REPLACE=1]="REPLACE",y[y.MOVE=2]="MOVE",y[y.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var f;(function(y){y[y.GROUP_ACTIVE=0]="GROUP_ACTIVE",y[y.GROUP_INDEX=1]="GROUP_INDEX",y[y.GROUP_LOCKED=2]="GROUP_LOCKED",y[y.EDITOR_OPEN=3]="EDITOR_OPEN",y[y.EDITOR_CLOSE=4]="EDITOR_CLOSE",y[y.EDITOR_MOVE=5]="EDITOR_MOVE",y[y.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",y[y.EDITOR_LABEL=7]="EDITOR_LABEL",y[y.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",y[y.EDITOR_PIN=9]="EDITOR_PIN",y[y.EDITOR_STICKY=10]="EDITOR_STICKY",y[y.EDITOR_DIRTY=11]="EDITOR_DIRTY",y[y.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(f=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var v;(function(y){y[y.PRIMARY=1]="PRIMARY",y[y.SECONDARY=2]="SECONDARY",y[y.BOTH=3]="BOTH",y[y.ANY=4]="ANY"})(v=e.SideBySideEditor||(e.SideBySideEditor={}));class a{getOriginalUri(O,z){if(!O)return;if(z?.supportSideBySide){const{primary:$,secondary:W}=this.getSideEditors(O);if($&&W){if(z?.supportSideBySide===v.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(W,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===v.ANY)return this.getOriginalUri($,{filterByScheme:z.filterByScheme})??this.getOriginalUri(W,{filterByScheme:z.filterByScheme});O=z.supportSideBySide===v.PRIMARY?$:W}}if(o(O)||u(O))return;const U=l(O)?O.preferredResource:O.resource;return!U||!z||!z.filterByScheme?U:this.filterUri(U,z.filterByScheme)}getSideEditors(O){return M(O)||u(O)?{primary:O.primary,secondary:O.secondary}:r(O)||o(O)?{primary:O.modified,secondary:O.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(O,z){if(!O)return;if(z?.supportSideBySide){const{primary:$,secondary:W}=this.getSideEditors(O);if($&&W){if(z?.supportSideBySide===v.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(W,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===v.ANY)return this.getCanonicalUri($,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(W,{filterByScheme:z.filterByScheme});O=z.supportSideBySide===v.PRIMARY?$:W}}if(o(O)||u(O))return;const U=O.resource;return!U||!z||!z.filterByScheme?U:this.filterUri(U,z.filterByScheme)}filterUri(O,z){if(Array.isArray(z)){if(z.some(U=>O.scheme===U))return O}else if(z===O.scheme)return O}}e.EditorResourceAccessor=new a;var S;(function(y){y[y.LEFT=0]="LEFT",y[y.RIGHT=1]="RIGHT"})(S=e.CloseDirection||(e.CloseDirection={}));class I{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(O){const z=this.instantiationService=O.get(k.IInstantiationService);for(const[U,$]of this.editorSerializerConstructors)this.createEditorSerializer(U,$,z);this.editorSerializerConstructors.clear()}createEditorSerializer(O,z,U){const $=U.createInstance(z);this.editorSerializerInstances.set(O,$)}registerFileEditorFactory(O){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=O}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(O,z){if(this.editorSerializerConstructors.has(O)||this.editorSerializerInstances.has(O))throw new Error(`A editor serializer with type ID '${O}' was already registered.`);return this.instantiationService?this.createEditorSerializer(O,z,this.instantiationService):this.editorSerializerConstructors.set(O,z),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(O),this.editorSerializerInstances.delete(O)})}getEditorSerializer(O){return this.editorSerializerInstances.get(typeof O=="string"?O:O.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new I);async function N(y,O){if(!y||!y.length)return[];const z=await Promise.all(y.map(async U=>{const $=E.URI.revive(U.fileUri);if(!$||!await O.canHandleResource($))return;let J=U.exists,G=U.type;if(typeof J!="boolean"||typeof G!="number")try{G=(await O.resolve($)).isDirectory?A.FileType.Directory:A.FileType.Unknown,J=!0}catch{J=!1}if(!J&&U.openOnlyIfExists||G===A.FileType.Directory)return;const ae={selection:J?U.selection:void 0,pinned:!0,override:U.editorOverrideId};let we;return J?we={resource:$,options:ae}:we={resource:$,options:ae,forceUntitled:!0},we}));return(0,R.coalesce)(z)}e.pathsToEditors=N;var B;(function(y){y[y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",y[y.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[155],ye([0,1,4,14,126]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new s.Emitter,this._onExit=new s.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,C,A,R){const w={command:P};if(C&&Object.keys(C).length>0&&(w.arguments=C),this.internalSend("request",w),typeof R=="number"){const i=setTimeout(()=>{clearTimeout(i);const p=this.pendingRequests.get(w.seq);if(p){this.pendingRequests.delete(w.seq);const o={type:"response",seq:0,request_seq:w.seq,success:!1,command:P,message:(0,E.localize)(0,null,R,P)};p(o)}},R)}return A&&this.pendingRequests.set(w.seq,A),w.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,C){return P.type!=="event"||C.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,t.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":{const C=P,A=this.pendingRequests.get(C.request_seq);A&&(this.pendingRequests.delete(C.request_seq),A(C));break}}}}internalSend(P,C){C.type=P,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((C,A)=>P.set(A,C)),await(0,t.timeout)(500),P.forEach((C,A)=>{C({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(Ee[156],ye([0,1,9,2,17,26,11]),function(ee,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function C(r,n,b){return r.replace(P,function(g,c){return n&&c.length>0&&c[0]!=="_"?g:b&&b.hasOwnProperty(c)?b[c]:g})}e.formatPII=C;function A(r){const n={};for(const b of Object.keys(r))b.startsWith("!")||(n[b]=r[b]);return n}e.filterExceptionsFromTelemetry=A;function R(r){return r.configuration.request==="attach"&&!w(r)&&(!r.parentSession||R(r.parentSession))}e.isSessionAttach=R;function w(r){let n=r.configuration.type;if(!!n)return n==="vslsShare"&&(n=r.configuration.adapterProxy.configuration.type),(0,s.equalsIgnoreCase)(n,"extensionhost")||(0,s.equalsIgnoreCase)(n,"pwa-extensionhost")?r:r.parentSession?w(r.parentSession):void 0}e.getExtensionHostDebugSession=w;function i(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=i;function p(r,n,b){let g,c=0;const f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let v=null;for(;v=f.exec(r);){const a=v.index+1,S=a+v[0].length;if(a<=n&&S>=b){g=v[0],c=a;break}}if(g){const a=/\w+/g;let S=null;for(;(S=a.exec(g))&&!(S.index+1+c+S[0].length>=b););S&&(g=g.substring(0,a.lastIndex))}return g?{start:c,end:c+g.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(r){return!!(r&&r.match(o))}e.isUri=u;function d(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(u(r.path))return t.URI.parse(r.path);if((0,E.isAbsolute)(r.path))return t.URI.file(r.path)}return r.path}function F(r){if(typeof r.path=="object"){const n=t.URI.revive(r.path);if(n)return n.scheme===k.Schemas.file?n.fsPath:n.toString()}return r.path}function _(r,n){const b=n?d:F,g=(0,T.deepClone)(r);return h(g,(c,f)=>{c&&f&&(f.path=b(f))}),g}e.convertToDAPaths=_;function m(r,n){const b=n?d:F,g=(0,T.deepClone)(r);return h(g,(c,f)=>{!c&&f&&(f.path=b(f))}),g}e.convertToVSCPaths=m;function h(r,n){switch(r.type){case"event":{const b=r;switch(b.event){case"output":n(!1,b.body.source);break;case"loadedSource":n(!1,b.body.source);break;case"breakpoint":n(!1,b.body.breakpoint.source);break;default:break}break}case"request":{const b=r;switch(b.command){case"setBreakpoints":n(!0,b.arguments.source);break;case"breakpointLocations":n(!0,b.arguments.source);break;case"source":n(!0,b.arguments.source);break;case"gotoTargets":n(!0,b.arguments.source);break;case"launchVSCode":b.arguments.args.forEach(g=>n(!1,g));break;default:break}break}case"response":{const b=r;if(b.success&&b.body)switch(b.command){case"stackTrace":b.body.stackFrames.forEach(g=>n(!1,g.source));break;case"loadedSources":b.body.sources.forEach(g=>n(!1,g));break;case"scopes":b.body.scopes.forEach(g=>n(!1,g.source));break;case"setFunctionBreakpoints":b.body.breakpoints.forEach(g=>n(!1,g.source));break;case"setBreakpoints":b.body.breakpoints.forEach(g=>n(!1,g.source));break;default:break}break}}}function D(r){return r.filter(n=>!n.presentation?.hidden).sort((n,b)=>n.presentation?b.presentation?n.presentation.group?b.presentation.group?n.presentation.group!==b.presentation.group?n.presentation.group.localeCompare(b.presentation.group):l(n.presentation.order,b.presentation.order):-1:b.presentation.group?1:l(n.presentation.order,b.presentation.order):-1:b.presentation?1:0)}e.getVisibleAndSorted=D;function l(r,n){return typeof r!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:r-n}async function M(r,n){const b=r.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(b!=="none"&&(await n.saveAll(),b==="allEditorsInActiveGroup")){const g=n.activeEditorPane;g&&g.input.resource?.scheme===k.Schemas.untitled&&await n.save({editor:g.input,groupId:g.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=M}),define(Ee[87],ye([0,1,29,157,76,11,17,23,45]),function(ee,e,s,t,E,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var A;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",E.Mimes.latex,E.Mimes.markdown,"image/png","image/jpeg",E.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[E.Mimes.latex,E.Mimes.markdown,"application/json",E.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var w;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(w=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var i;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var o;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.ChangeCellMime=13]="ChangeCellMime",a[a.Unknown=100]="Unknown"})(o=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var F;(function(a){a.scheme=T.Schemas.vscodeNotebookCell;const S=/^ch(\d{7,})/;function I(U,$){return U.with({scheme:a.scheme,fragment:`ch${$.toString().padStart(7,"0")}${U.scheme!==T.Schemas.file?U.scheme:""}`})}a.generate=I;function N(U){if(U.scheme!==a.scheme)return;const $=S.exec(U.fragment);return $?{handle:Number($[1]),notebook:U.with({scheme:U.fragment.substring($[0].length)||T.Schemas.file,fragment:null})}:void 0}a.parse=N;function B(U,$,W){return U.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`ch${$.toString().padStart(7,"0")},${W??""},${U.scheme!==T.Schemas.file?U.scheme:""}`})}a.generateCellOutputUri=B;function y(U){if(U.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const $=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(U.fragment);if(!$)return;const W=Number($[1]),J=$[2]&&$[2]!==""?$[2]:void 0,G=$[3];return{handle:W,outputId:J,notebook:U.with({scheme:G||T.Schemas.file,fragment:null})}}a.parseCellOutputUri=y;function O(U,$,W){return U.with({scheme:W,fragment:`ch${$.toString().padStart(7,"0")}${U.scheme!==T.Schemas.file?U.scheme:""}`})}a.generateCellUri=O;function z(U,$){if(U.scheme!==$)return;const W=S.exec(U.fragment);return W?{handle:Number(W[1]),notebook:U.with({scheme:U.fragment.substring(W[0].length)||T.Schemas.file,fragment:null})}:void 0}a.parseCellUri=z})(F=e.CellUri||(e.CellUri={}));const _=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function m(a){return _.get(a)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=m;function h(a){return _.get(a)?.supportedByCore??!1}e.mimeTypeSupportedByCore=h;function D(a){return _.get(a)?.mergeable??!1}e.mimeTypeIsMergeable=D;const l=a=>P.isWindows?a.replace(/\//g,"\\"):a;class M{constructor(S=[],I=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=I,this.order=[...new Set(S)].map(N=>({pattern:N,matches:s.parse(l(N))}))}sort(S){const I=new Map(t.Iterable.map(S,B=>[B,l(B)]));let N=[];for(const{matches:B}of this.order)for(const[y,O]of I)if(B(O)){N.push(y),I.delete(y);break}return I.size&&(N=N.concat([...I.keys()].sort((B,y)=>this.defaultOrder.indexOf(B)-this.defaultOrder.indexOf(y)))),N}prioritize(S,I){const N=this.findIndex(S);if(N===-1){this.order.unshift({pattern:S,matches:s.parse(l(S))});return}const B=new Set(I.map(O=>this.findIndex(O,N)));B.delete(-1);const y=Array.from(B).sort();this.order.splice(N+1,0,...y.map(O=>this.order[O]));for(let O=y.length-1;O>=0;O--)this.order.splice(y[O],1)}toArray(){return this.order.map(S=>S.pattern)}findIndex(S,I=this.order.length){const N=l(S);for(let B=0;B<I;B++)if(this.order[B].matches(N))return B;return-1}}e.MimeTypeDisplayOrder=M;function r(a,S,I,N=(B,y)=>B===y){const B=[];function y(U,$,W){if($===0&&W.length===0)return;const J=B[B.length-1];J&&J.start+J.deleteCount===U?(J.deleteCount+=$,J.toInsert.push(...W)):B.push({start:U,deleteCount:$,toInsert:W})}let O=0,z=0;for(;;){if(O===a.length){y(O,0,S.slice(z));break}if(z===S.length){y(O,a.length-O,[]);break}const U=a[O],$=S[z];if(N(U,$)){O+=1,z+=1;continue}I($)?(y(O,1,[]),O+=1):(y(O,0,[$]),z+=1)}return B}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(a){a.default="default",a.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function b(a){const S=a;return!!((typeof S.include=="string"||s.isRelativePattern(S.include))&&(typeof S.exclude=="string"||s.isRelativePattern(S.exclude)))}e.isDocumentExcludePattern=b;function g(a,S,I){if(Array.isArray(a.viewType)&&a.viewType.indexOf(S)>=0||a.viewType===S)return!0;if(a.filenamePattern){const N=b(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,B=b(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(s.match(N,(0,k.basename)(I.fsPath).toLowerCase()))return!(B&&s.match(B,(0,k.basename)(I.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=g;class c{constructor(S){this.textModel=S}getElements(){const S=new Int32Array(this.textModel.cells.length);for(let I=0;I<this.textModel.cells.length;I++)S[I]=this.textModel.cells[I].getHashValue();return S}}e.CellSequence=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var f;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class v{static create(S){return`${v._prefix}${S}`}static parse(S){if(S.startsWith(v._prefix))return S.substring(v._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=v,v._prefix="notebook/"}),define(Ee[158],ye([0,1,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,s.createDecorator)("INotebookExecutionService")}),define(Ee[159],ye([0,1,3,45]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,s.createDecorator)(e.OUTPUT_SERVICE_ID);var E;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(E=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(Ee[160],ye([0,1,128,3,45]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,s.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,s.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,s.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[161],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function s(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=s;function t(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=t}),define(Ee[88],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var s;(function(w){w[w.Unset=0]="Unset",w[w.Queued=1]="Queued",w[w.Running=2]="Running",w[w.Passed=3]="Passed",w[w.Failed=4]="Failed",w[w.Skipped=5]="Skipped",w[w.Errored=6]="Errored"})(s=e.TestResultState||(e.TestResultState={}));var t;(function(w){w[w.Run=2]="Run",w[w.Debug=4]="Debug",w[w.Coverage=8]="Coverage",w[w.HasNonDefaultProfile=16]="HasNonDefaultProfile",w[w.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(w){w[w.Error=0]="Error",w[w.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var T;(function(w){w[w.NotExpandable=0]="NotExpandable",w[w.Expandable=1]="Expandable",w[w.BusyExpanding=2]="BusyExpanding",w[w.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(w,i)=>{i.expand!==void 0&&(w.expand=i.expand),i.item!==void 0&&(w.item=w.item?Object.assign(w.item,i.item):i.item)};e.applyTestItemUpdate=k;var P;(function(w){w[w.Function=0]="Function",w[w.Statement=1]="Statement"})(P=e.DetailType||(e.DetailType={}));var C;(function(w){w[w.Add=0]="Add",w[w.Update=1]="Update",w[w.Remove=2]="Remove",w[w.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",w[w.Retire=4]="Retire",w[w.AddTag=5]="AddTag",w[w.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(i){}update(i){}remove(i,p){}complete(){}}e.IncrementalChangeCollector=A;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const p=this.createChangeCollector();for(const o of i)switch(o[0]){case 0:{const u=o[1];if(u.parent){if(this.items.has(u.parent)){const d=this.items.get(u.parent);d.children.add(u.item.extId);const F=this.createItem(u,d);this.items.set(u.item.extId,F),p.add(F)}}else{const d=this.createItem(u);this.roots.add(d),this.items.set(u.item.extId,d),p.add(d)}u.expand===2&&this.busyControllerCount++;break}case 1:{const u=o[1],d=this.items.get(u.extId);if(!d)break;u.expand!==void 0&&(d.expand===2&&this.busyControllerCount--,u.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(d,u),p.update(d);break}case 2:{const u=this.items.get(o[1]);if(!u)break;u.parent?this.items.get(u.parent).children.delete(u.item.extId):this.roots.delete(u);const d=[[o[1]]];for(;d.length;)for(const F of d.pop()){const _=this.items.get(F);_&&(d.push(_.children),this.items.delete(F),p.remove(_,_!==u),_.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(o[1]);break;case 3:this.updatePendingRoots(o[1]);break;case 5:this._tags.set(o[1].id,o[1]);break;case 6:this._tags.delete(o[1]);break}p.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=R}),define(Ee[67],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(T){T.Delimiter="\0"})(s=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class E{constructor(k,P=k.length){if(this.path=k,this.viewEnd=P,k.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,P,C=k.parent){if(k.id===P)return new E([P]);let A=[k.id];for(let R=C;R&&R.id!==P;R=R.parent)A.push(R.id);return A.push(P),new E(A.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const P=k.indexOf("\0");return P===-1?k:k.slice(0,P)}static fromString(k){return new E(k.split("\0"))}static join(k,P){return new E([...k.path,P])}static joinToString(k,P){return k.toString()+"\0"+P}static compare(k,P){return k===P?0:P.startsWith(k+"\0")?2:k.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new E(this.path,k)}compare(k){if(typeof k=="string")return E.compare(this.toString(),k);for(let P=0;P<k.viewEnd&&P<this.viewEnd;P++)if(k.path[P]!==this.path[P])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=E}),define(Ee[162],ye([0,1,17,89,10,26,23,78,129]),function(ee,e,s,t,E,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(w,i,p){this._contributedVariables=new Map,this._context=w,this._labelService=i,p&&(this._envVariablesPromise=p.then(o=>this.prepareEnv(o)))}prepareEnv(w){if(k.isWindows){const i=Object.create(null);return Object.keys(w).forEach(p=>{i[p.toLowerCase()]=w[p]}),i}return w}resolveWithEnvironment(w,i,p){return this.recursiveResolve(this.prepareEnv(w),i?i.uri:void 0,p)}async resolveAsync(w,i){return this.recursiveResolve(await this._envVariablesPromise,w?w.uri:void 0,i)}async resolveAnyBase(w,i,p,o){const u=T.deepClone(i);return k.isWindows&&u.windows?Object.keys(u.windows).forEach(d=>u[d]=u.windows[d]):k.isMacintosh&&u.osx?Object.keys(u.osx).forEach(d=>u[d]=u.osx[d]):k.isLinux&&u.linux&&Object.keys(u.linux).forEach(d=>u[d]=u.linux[d]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,w?w.uri:void 0,u,p,o)}async resolveAnyAsync(w,i,p){return this.resolveAnyBase(w,i,p)}async resolveAnyMap(w,i,p){const o=new Map;return{newConfig:await this.resolveAnyBase(w,i,p,o),resolvedVariables:o}}resolveWithInteractionReplace(w,i,p,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,i,p,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,i){if(this._contributedVariables.has(w))throw new Error("Variable "+w+" is contributed twice.");this._contributedVariables.set(w,i)}recursiveResolve(w,i,p,o,u){if(E.isString(p))return this.resolveString(w,i,p,o,u);if(E.isArray(p))return p.map(d=>this.recursiveResolve(w,i,d,o,u));if(E.isObject(p)){let d=Object.create(null);return Object.keys(p).forEach(F=>{const _=this.resolveString(w,i,F,o,u);d[_]=this.recursiveResolve(w,i,p[F],o,u)}),d}return p}resolveString(w,i,p,o,u){return p.replace(A.VARIABLE_REGEXP,(F,_)=>{if(_.includes(A.VARIABLE_LHS))return F;let m=this.evaluateSingleVariable(w,F,_,i,o);return u&&u.set(_,m),m!==F&&E.isString(m)&&m.match(A.VARIABLE_REGEXP)&&(m=this.resolveString(w,i,m,o,u)),m})}fsPath(w){return this._labelService?this._labelService.getUriLabel(w,{noPrefix:!0}):w.fsPath}evaluateSingleVariable(w,i,p,o,u){let d;const F=p.split(":");F.length>1&&(p=F[0],d=F[1]);const _=()=>{const D=this._context.getFilePath();if(D)return D;throw new Error((0,C.localize)(0,null,i))},m=()=>{const D=_();if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new Error((0,C.localize)(1,null,i,s.basename(D)))},h=()=>{if(d){const D=this._context.getFolderUri(d);if(D)return D;throw new Error((0,C.localize)(2,null,i,d))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,i)):new Error((0,C.localize)(4,null,i))};switch(p){case"env":if(d){if(w){const D=w[k.isWindows?d.toLowerCase():d];if(E.isString(D))return D}return""}throw new Error((0,C.localize)(5,null,i));case"config":if(d){const D=this._context.getConfigurationValue(o,d);if(E.isUndefinedOrNull(D))throw new Error((0,C.localize)(6,null,i,d));if(E.isObject(D))throw new Error((0,C.localize)(7,null,i,d));return D}throw new Error((0,C.localize)(8,null,i));case"command":return this.resolveFromMap(i,d,u,"command");case"input":return this.resolveFromMap(i,d,u,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return o||d?(0,P.normalizeDriveLetter)(this.fsPath(h())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return s.basename(this.fsPath(h()));case"lineNumber":{const D=this._context.getLineNumber();if(D)return D;throw new Error((0,C.localize)(9,null,i))}case"selectedText":{const D=this._context.getSelectedText();if(D)return D;throw new Error((0,C.localize)(10,null,i))}case"file":return _();case"fileWorkspaceFolder":return m();case"relativeFile":return o||d?s.relative(this.fsPath(h()),_()):_();case"relativeFileDirname":{const D=s.dirname(_());if(o||d){const l=s.relative(this.fsPath(h()),D);return l.length===0?".":l}return D}case"fileDirname":return s.dirname(_());case"fileExtname":return s.extname(_());case"fileBasename":return s.basename(_());case"fileBasenameNoExtension":{const D=s.basename(_());return D.slice(0,D.length-s.extname(D).length)}case"fileDirnameBasename":return s.basename(s.dirname(_()));case"execPath":{const D=this._context.getExecPath();return D||i}case"execInstallFolder":{const D=this._context.getAppRoot();return D||i}case"pathSeparator":return s.sep;default:try{const D=d?`${p}:${d}`:p;return this.resolveFromMap(i,D,u,void 0)}catch{return i}}}}resolveFromMap(w,i,p,o){if(i&&p){const u=o===void 0?p[i]:p[o+":"+i];if(typeof u=="string")return u;throw new Error((0,C.localize)(11,null,w))}return w}}e.AbstractVariableResolverService=A,A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[90],ye([0,1,3,154]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,s.createDecorator)("editorGroupsService");var E;(function(o){o[o.UP=0]="UP",o[o.DOWN=1]="DOWN",o[o.LEFT=2]="LEFT",o[o.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var T;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(o){o[o.FIRST=0]="FIRST",o[o.LAST=1]="LAST",o[o.NEXT=2]="NEXT",o[o.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var P;(function(o){o[o.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",o[o.EVEN=1]="EVEN",o[o.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(o){o[o.COPY_EDITORS=0]="COPY_EDITORS",o[o.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function A(o){const u=o;return(0,t.isEditorInput)(u?.editor)&&(0,t.isEditorInput)(u?.replacement)}e.isEditorReplacement=A;var R;(function(o){o[o.CREATION_TIME=0]="CREATION_TIME",o[o.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",o[o.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(o){o[o.NEW_EDITOR=1]="NEW_EDITOR",o[o.MOVE_EDITOR=2]="MOVE_EDITOR",o[o.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function i(o){const u=o;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.isEditorGroup=i;function p(o){return o.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=p}),define(Ee[163],ye([0,1,3,90]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,s.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(T){const k=T;return typeof T=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=E}),define(Ee[8],ye([0,1,16,22,77,225,55,26,10,2,59,58,130,82,48,87,67,163,7]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var m;(function(re){function ge(V){const{selectionStartLineNumber:ve,selectionStartColumn:Ie,positionLineNumber:Ke,positionColumn:xe}=V,ut=new _.Position(ve-1,Ie-1),wt=new _.Position(Ke-1,xe-1);return new _.Selection(ut,wt)}re.to=ge;function ie(V){const{anchor:ve,active:Ie}=V;return{selectionStartLineNumber:ve.line+1,selectionStartColumn:ve.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}re.from=ie})(m=e.Selection||(e.Selection={}));var h;(function(re){function ge(V){if(!V)return;const{start:ve,end:Ie}=V;return{startLineNumber:ve.line+1,startColumn:ve.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}re.from=ge;function ie(V){if(!V)return;const{startLineNumber:ve,startColumn:Ie,endLineNumber:Ke,endColumn:xe}=V;return new _.Range(ve-1,Ie-1,Ke-1,xe-1)}re.to=ie})(h=e.Range||(e.Range={}));var D;(function(re){function ge(ie){switch(ie){case 1:return _.StandardTokenType.Comment;case 0:return _.StandardTokenType.Other;case 3:return _.StandardTokenType.RegEx;case 2:return _.StandardTokenType.String}}re.to=ge})(D=e.TokenType||(e.TokenType={}));var l;(function(re){function ge(V){return new _.Position(V.lineNumber-1,V.column-1)}re.to=ge;function ie(V){return{lineNumber:V.line+1,column:V.character+1}}re.from=ie})(l=e.Position||(e.Position={}));var M;(function(re){function ge(ve,Ie){return(0,s.coalesce)((0,s.asArray)(ve).map(Ke=>ie(Ke,Ie)))}re.from=ge;function ie(ve,Ie){if(typeof ve=="string")return{$serialized:!0,language:ve};if(ve)return{$serialized:!0,language:ve.language,scheme:V(ve.scheme,Ie),pattern:typeof ve.pattern=="undefined"?void 0:Q.from(ve.pattern),exclusive:ve.exclusive}}function V(ve,Ie){return Ie&&typeof ve=="string"?Ie.transformOutgoingScheme(ve):ve}})(M=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(re){function ge(V){switch(V){case _.DiagnosticTag.Unnecessary:return 1;case _.DiagnosticTag.Deprecated:return 2}}re.from=ge;function ie(V){switch(V){case 1:return _.DiagnosticTag.Unnecessary;case 2:return _.DiagnosticTag.Deprecated;default:return}}re.to=ie})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(re){function ge(V){let ve;return V.code&&((0,C.isString)(V.code)||(0,C.isNumber)(V.code)?ve=String(V.code):ve={value:String(V.code.value),target:V.code.target}),{...h.from(V.range),message:V.message,source:V.source,code:ve,severity:g.from(V.severity),relatedInformation:V.relatedInformation&&V.relatedInformation.map(b.from),tags:Array.isArray(V.tags)?(0,s.coalesce)(V.tags.map(r.from)):void 0}}re.from=ge;function ie(V){const ve=new _.Diagnostic(h.to(V),V.message,g.to(V.severity));return ve.source=V.source,ve.code=(0,C.isString)(V.code)?V.code:V.code?.value,ve.relatedInformation=V.relatedInformation&&V.relatedInformation.map(b.to),ve.tags=V.tags&&(0,s.coalesce)(V.tags.map(r.to)),ve}re.to=ie})(n=e.Diagnostic||(e.Diagnostic={}));var b;(function(re){function ge(V){return{...h.from(V.location.range),message:V.message,resource:V.location.uri}}re.from=ge;function ie(V){return new _.DiagnosticRelatedInformation(new _.Location(V.resource,h.to(V)),V.message)}re.to=ie})(b=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var g;(function(re){function ge(V){switch(V){case _.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case _.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case _.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case _.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}re.from=ge;function ie(V){switch(V){case p.MarkerSeverity.Info:return _.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return _.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return _.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return _.DiagnosticSeverity.Hint;default:return _.DiagnosticSeverity.Error}}re.to=ie})(g=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(re){function ge(V){return typeof V=="number"&&V>=_.ViewColumn.One?V-1:V===_.ViewColumn.Beside?F.SIDE_GROUP:F.ACTIVE_GROUP}re.from=ge;function ie(V){if(typeof V=="number"&&V>=0)return V+1;throw new Error("invalid 'EditorGroupColumn'")}re.to=ie})(c=e.ViewColumn||(e.ViewColumn={}));function f(re){return typeof re.range!="undefined"}function v(re){return re.length===0?!0:!!f(re[0])}e.isDecorationOptionsArr=v;var a;(function(re){function ge(xe){return xe.map(re.from)}re.fromMany=ge;function ie(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function V(xe){let ut;if(ie(xe)){const{language:ft,value:pt}=xe;ut={value:"```"+ft+`
`+pt+"\n```\n"}}else _.MarkdownString.isMarkdownString(xe)?ut={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml}:typeof xe=="string"?ut={value:xe}:ut={value:""};const wt=Object.create(null);ut.uris=wt;const Ct=ft=>{try{let pt=A.URI.parse(ft,!0);pt=pt.with({query:ve(pt.query,wt)}),wt[ft]=pt}catch{}return""},bt=new T.Renderer;return bt.link=Ct,bt.image=ft=>Ct(E.parseHrefAndDimensions(ft).href),T(ut.value,{renderer:bt}),ut}re.from=V;function ve(xe,ut){if(!xe)return xe;let wt;try{wt=(0,k.parse)(xe)}catch{}if(!wt)return xe;let Ct=!1;return wt=(0,P.cloneAndChange)(wt,bt=>{if(A.URI.isUri(bt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ft]=bt,Ct=!0,ft}else return}),Ct?JSON.stringify(wt):xe}function Ie(xe){const ut=new _.MarkdownString(xe.value,xe.supportThemeIcons);return ut.isTrusted=xe.isTrusted,ut.supportHtml=xe.supportHtml,ut}re.to=Ie;function Ke(xe){if(!!xe)return typeof xe=="string"?xe:re.from(xe)}re.fromStrict=Ke})(a=e.MarkdownString||(e.MarkdownString={}));function S(re){return v(re)?re.map(ge=>({range:h.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?a.fromMany(ge.hoverMessage):ge.hoverMessage?a.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):re.map(ge=>({range:h.from(ge)}))}e.fromRangeOrRangeWithMessage=S;function I(re){return typeof re=="undefined"?re:typeof re=="string"?A.URI.file(re):re}e.pathOrURIToURI=I;var N;(function(re){function ge(ie){return typeof ie=="undefined"?ie:{contentText:ie.contentText,contentIconPath:ie.contentIconPath?I(ie.contentIconPath):void 0,border:ie.border,borderColor:ie.borderColor,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,color:ie.color,backgroundColor:ie.backgroundColor,margin:ie.margin,width:ie.width,height:ie.height}}re.from=ge})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(re){function ge(ie){return typeof ie=="undefined"?ie:{backgroundColor:ie.backgroundColor,outline:ie.outline,outlineColor:ie.outlineColor,outlineStyle:ie.outlineStyle,outlineWidth:ie.outlineWidth,border:ie.border,borderColor:ie.borderColor,borderRadius:ie.borderRadius,borderSpacing:ie.borderSpacing,borderStyle:ie.borderStyle,borderWidth:ie.borderWidth,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,cursor:ie.cursor,color:ie.color,opacity:ie.opacity,letterSpacing:ie.letterSpacing,gutterIconPath:ie.gutterIconPath?I(ie.gutterIconPath):void 0,gutterIconSize:ie.gutterIconSize,overviewRulerColor:ie.overviewRulerColor,before:ie.before?N.from(ie.before):void 0,after:ie.after?N.from(ie.after):void 0}}re.from=ge})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var y;(function(re){function ge(ie){if(typeof ie=="undefined")return ie;switch(ie){case _.DecorationRangeBehavior.OpenOpen:return 0;case _.DecorationRangeBehavior.ClosedClosed:return 1;case _.DecorationRangeBehavior.OpenClosed:return 2;case _.DecorationRangeBehavior.ClosedOpen:return 3}}re.from=ge})(y=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(re){function ge(ie){return{isWholeLine:ie.isWholeLine,rangeBehavior:ie.rangeBehavior?y.from(ie.rangeBehavior):void 0,overviewRulerLane:ie.overviewRulerLane,light:ie.light?B.from(ie.light):void 0,dark:ie.dark?B.from(ie.dark):void 0,backgroundColor:ie.backgroundColor,outline:ie.outline,outlineColor:ie.outlineColor,outlineStyle:ie.outlineStyle,outlineWidth:ie.outlineWidth,border:ie.border,borderColor:ie.borderColor,borderRadius:ie.borderRadius,borderSpacing:ie.borderSpacing,borderStyle:ie.borderStyle,borderWidth:ie.borderWidth,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,cursor:ie.cursor,color:ie.color,opacity:ie.opacity,letterSpacing:ie.letterSpacing,gutterIconPath:ie.gutterIconPath?I(ie.gutterIconPath):void 0,gutterIconSize:ie.gutterIconSize,overviewRulerColor:ie.overviewRulerColor,before:ie.before?N.from(ie.before):void 0,after:ie.after?N.from(ie.after):void 0}}re.from=ge})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(re){function ge(V){return{text:V.newText,eol:V.newEol&&lt.from(V.newEol),range:h.from(V.range)}}re.from=ge;function ie(V){const ve=new _.TextEdit(h.to(V.range),V.text);return ve.newEol=typeof V.eol=="undefined"?void 0:lt.to(V.eol),ve}re.to=ie})(z=e.TextEdit||(e.TextEdit={}));var U;(function(re){function ge(V,ve,Ie){const Ke={edits:[]};if(V instanceof _.WorkspaceEdit)for(let xe of V._allEntries())if(xe._type===1)Ke.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const ut=ve?.getDocument(xe.uri);Ke.edits.push({_type:2,resource:xe.uri,edit:z.from(xe.edit),modelVersionId:ut?.version,metadata:xe.metadata})}else xe._type===3?Ke.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:Ie?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version}):xe._type===5&&Ke.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:Ie?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Je.from)}});return Ke}re.from=ge;function ie(V){const ve=new _.WorkspaceEdit;for(const Ie of V.edits)Ie.edit?ve.replace(A.URI.revive(Ie.resource),h.to(Ie.edit.range),Ie.edit.text):ve.renameFile(A.URI.revive(Ie.oldUri),A.URI.revive(Ie.newUri),Ie.options);return ve}re.to=ie})(U=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(re){const ge=Object.create(null);ge[_.SymbolKind.File]=0,ge[_.SymbolKind.Module]=1,ge[_.SymbolKind.Namespace]=2,ge[_.SymbolKind.Package]=3,ge[_.SymbolKind.Class]=4,ge[_.SymbolKind.Method]=5,ge[_.SymbolKind.Property]=6,ge[_.SymbolKind.Field]=7,ge[_.SymbolKind.Constructor]=8,ge[_.SymbolKind.Enum]=9,ge[_.SymbolKind.Interface]=10,ge[_.SymbolKind.Function]=11,ge[_.SymbolKind.Variable]=12,ge[_.SymbolKind.Constant]=13,ge[_.SymbolKind.String]=14,ge[_.SymbolKind.Number]=15,ge[_.SymbolKind.Boolean]=16,ge[_.SymbolKind.Array]=17,ge[_.SymbolKind.Object]=18,ge[_.SymbolKind.Key]=19,ge[_.SymbolKind.Null]=20,ge[_.SymbolKind.EnumMember]=21,ge[_.SymbolKind.Struct]=22,ge[_.SymbolKind.Event]=23,ge[_.SymbolKind.Operator]=24,ge[_.SymbolKind.TypeParameter]=25;function ie(ve){return typeof ge[ve]=="number"?ge[ve]:6}re.from=ie;function V(ve){for(const Ie in ge)if(ge[Ie]===ve)return Number(Ie);return _.SymbolKind.Property}re.to=V})($=e.SymbolKind||(e.SymbolKind={}));var W;(function(re){function ge(V){switch(V){case _.SymbolTag.Deprecated:return 1}}re.from=ge;function ie(V){switch(V){case 1:return _.SymbolTag.Deprecated}}re.to=ie})(W=e.SymbolTag||(e.SymbolTag={}));var J;(function(re){function ge(V){return{name:V.name,kind:$.from(V.kind),tags:V.tags&&V.tags.map(W.from),containerName:V.containerName,location:ce.from(V.location)}}re.from=ge;function ie(V){const ve=new _.SymbolInformation(V.name,$.to(V.kind),V.containerName,ce.to(V.location));return ve.tags=V.tags&&V.tags.map(W.to),ve}re.to=ie})(J=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(re){function ge(V){const ve={name:V.name||"!!MISSING: name!!",detail:V.detail,range:h.from(V.range),selectionRange:h.from(V.selectionRange),kind:$.from(V.kind),tags:V.tags?.map(W.from)??[]};return V.children&&(ve.children=V.children.map(ge)),ve}re.from=ge;function ie(V){const ve=new _.DocumentSymbol(V.name,V.detail,$.to(V.kind),h.to(V.range),h.to(V.selectionRange));return(0,s.isNonEmptyArray)(V.tags)&&(ve.tags=V.tags.map(W.to)),V.children&&(ve.children=V.children.map(ie)),ve}re.to=ie})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var ae;(function(re){function ge(V){const ve=new _.CallHierarchyItem($.to(V.kind),V.name,V.detail||"",A.URI.revive(V.uri),h.to(V.range),h.to(V.selectionRange));return ve._sessionId=V._sessionId,ve._itemId=V._itemId,ve}re.to=ge;function ie(V,ve,Ie){if(ve=ve??V._sessionId,Ie=Ie??V._itemId,ve===void 0||Ie===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:Ie,name:V.name,detail:V.detail,kind:$.from(V.kind),uri:V.uri,range:h.from(V.range),selectionRange:h.from(V.selectionRange),tags:V.tags?.map(W.from)}}re.from=ie})(ae=e.CallHierarchyItem||(e.CallHierarchyItem={}));var we;(function(re){function ge(ie){return new _.CallHierarchyIncomingCall(ae.to(ie.from),ie.fromRanges.map(V=>h.to(V)))}re.to=ge})(we=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Se;(function(re){function ge(ie){return new _.CallHierarchyOutgoingCall(ae.to(ie.to),ie.fromRanges.map(V=>h.to(V)))}re.to=ge})(Se=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ce;(function(re){function ge(V){return{range:V.range&&h.from(V.range),uri:V.uri}}re.from=ge;function ie(V){return new _.Location(A.URI.revive(V.uri),h.to(V.range))}re.to=ie})(ce=e.location||(e.location={}));var oe;(function(re){function ge(V){const ve=V,Ie=V;return{originSelectionRange:ve.originSelectionRange?h.from(ve.originSelectionRange):void 0,uri:ve.targetUri?ve.targetUri:Ie.uri,range:h.from(ve.targetRange?ve.targetRange:Ie.range),targetSelectionRange:ve.targetSelectionRange?h.from(ve.targetSelectionRange):void 0}}re.from=ge;function ie(V){return{targetUri:A.URI.revive(V.uri),targetRange:h.to(V.range),targetSelectionRange:V.targetSelectionRange?h.to(V.targetSelectionRange):void 0,originSelectionRange:V.originSelectionRange?h.to(V.originSelectionRange):void 0}}re.to=ie})(oe=e.DefinitionLink||(e.DefinitionLink={}));var be;(function(re){function ge(V){return{range:h.from(V.range),contents:a.fromMany(V.contents)}}re.from=ge;function ie(V){return new _.Hover(V.contents.map(a.to),h.to(V.range))}re.to=ie})(be=e.Hover||(e.Hover={}));var Pe;(function(re){function ge(V){return{range:h.from(V.range),expression:V.expression}}re.from=ge;function ie(V){return new _.EvaluatableExpression(h.to(V.range),V.expression)}re.to=ie})(Pe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Me;(function(re){function ge(V){if(V instanceof _.InlineValueText)return{type:"text",range:h.from(V.range),text:V.text};if(V instanceof _.InlineValueVariableLookup)return{type:"variable",range:h.from(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};if(V instanceof _.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(V.range),expression:V.expression};throw new Error("Unknown 'InlineValue' type")}re.from=ge;function ie(V){switch(V.type){case"text":return{range:h.to(V.range),text:V.text};case"variable":return{range:h.to(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};case"expression":return{range:h.to(V.range),expression:V.expression}}}re.to=ie})(Me=e.InlineValue||(e.InlineValue={}));var He;(function(re){function ge(V){return{frameId:V.frameId,stoppedLocation:h.from(V.stoppedLocation)}}re.from=ge;function ie(V){return new _.InlineValueContext(V.frameId,h.to(V.stoppedLocation))}re.to=ie})(He=e.InlineValueContext||(e.InlineValueContext={}));var Ye;(function(re){function ge(V){return{range:h.from(V.range),kind:V.kind}}re.from=ge;function ie(V){return new _.DocumentHighlight(h.to(V.range),V.kind)}re.to=ie})(Ye=e.DocumentHighlight||(e.DocumentHighlight={}));var Qe;(function(re){function ge(ie){switch(ie){case 1:return _.CompletionTriggerKind.TriggerCharacter;case 2:return _.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return _.CompletionTriggerKind.Invoke}}re.to=ge})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var H;(function(re){function ge(ie){return{triggerKind:Qe.to(ie.triggerKind),triggerCharacter:ie.triggerCharacter}}re.to=ge})(H=e.CompletionContext||(e.CompletionContext={}));var K;(function(re){function ge(V){switch(V){case _.CompletionItemTag.Deprecated:return 1}}re.from=ge;function ie(V){switch(V){case 1:return _.CompletionItemTag.Deprecated}}re.to=ie})(K=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(re){const ge=new Map([[_.CompletionItemKind.Method,0],[_.CompletionItemKind.Function,1],[_.CompletionItemKind.Constructor,2],[_.CompletionItemKind.Field,3],[_.CompletionItemKind.Variable,4],[_.CompletionItemKind.Class,5],[_.CompletionItemKind.Interface,7],[_.CompletionItemKind.Struct,6],[_.CompletionItemKind.Module,8],[_.CompletionItemKind.Property,9],[_.CompletionItemKind.Unit,12],[_.CompletionItemKind.Value,13],[_.CompletionItemKind.Constant,14],[_.CompletionItemKind.Enum,15],[_.CompletionItemKind.EnumMember,16],[_.CompletionItemKind.Keyword,17],[_.CompletionItemKind.Snippet,27],[_.CompletionItemKind.Text,18],[_.CompletionItemKind.Color,19],[_.CompletionItemKind.File,20],[_.CompletionItemKind.Reference,21],[_.CompletionItemKind.Folder,23],[_.CompletionItemKind.Event,10],[_.CompletionItemKind.Operator,11],[_.CompletionItemKind.TypeParameter,24],[_.CompletionItemKind.Issue,26],[_.CompletionItemKind.User,25]]);function ie(Ie){return ge.get(Ie)??9}re.from=ie;const V=new Map([[0,_.CompletionItemKind.Method],[1,_.CompletionItemKind.Function],[2,_.CompletionItemKind.Constructor],[3,_.CompletionItemKind.Field],[4,_.CompletionItemKind.Variable],[5,_.CompletionItemKind.Class],[7,_.CompletionItemKind.Interface],[6,_.CompletionItemKind.Struct],[8,_.CompletionItemKind.Module],[9,_.CompletionItemKind.Property],[12,_.CompletionItemKind.Unit],[13,_.CompletionItemKind.Value],[14,_.CompletionItemKind.Constant],[15,_.CompletionItemKind.Enum],[16,_.CompletionItemKind.EnumMember],[17,_.CompletionItemKind.Keyword],[27,_.CompletionItemKind.Snippet],[18,_.CompletionItemKind.Text],[19,_.CompletionItemKind.Color],[20,_.CompletionItemKind.File],[21,_.CompletionItemKind.Reference],[23,_.CompletionItemKind.Folder],[10,_.CompletionItemKind.Event],[11,_.CompletionItemKind.Operator],[24,_.CompletionItemKind.TypeParameter],[25,_.CompletionItemKind.User],[26,_.CompletionItemKind.Issue]]);function ve(Ie){return V.get(Ie)??_.CompletionItemKind.Property}re.to=ve})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(re){function ge(ie,V){const ve=new _.CompletionItem(ie.label);return ve.insertText=ie.insertText,ve.kind=X.to(ie.kind),ve.tags=ie.tags?.map(K.to),ve.detail=ie.detail,ve.documentation=E.isMarkdownString(ie.documentation)?a.to(ie.documentation):ie.documentation,ve.sortText=ie.sortText,ve.filterText=ie.filterText,ve.preselect=ie.preselect,ve.commitCharacters=ie.commitCharacters,R.Range.isIRange(ie.range)?ve.range=h.to(ie.range):typeof ie.range=="object"&&(ve.range={inserting:h.to(ie.range.insert),replacing:h.to(ie.range.replace)}),ve.keepWhitespace=typeof ie.insertTextRules=="undefined"?!1:Boolean(ie.insertTextRules&1),typeof ie.insertTextRules!="undefined"&&ie.insertTextRules&4?ve.insertText=new _.SnippetString(ie.insertText):(ve.insertText=ie.insertText,ve.textEdit=ve.range instanceof _.Range?new _.TextEdit(ve.range,ve.insertText):void 0),ie.additionalTextEdits&&ie.additionalTextEdits.length>0&&(ve.additionalTextEdits=ie.additionalTextEdits.map(Ie=>z.to(Ie))),ve.command=V&&ie.command?V.fromInternal(ie.command):void 0,ve}re.to=ge})(se=e.CompletionItem||(e.CompletionItem={}));var q;(function(re){function ge(V){return{label:V.label,documentation:V.documentation?a.fromStrict(V.documentation):void 0}}re.from=ge;function ie(V){return{label:V.label,documentation:E.isMarkdownString(V.documentation)?a.to(V.documentation):V.documentation}}re.to=ie})(q=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(re){function ge(V){return{label:V.label,documentation:V.documentation?a.fromStrict(V.documentation):void 0,parameters:Array.isArray(V.parameters)?V.parameters.map(q.from):[],activeParameter:V.activeParameter}}re.from=ge;function ie(V){return{label:V.label,documentation:E.isMarkdownString(V.documentation)?a.to(V.documentation):V.documentation,parameters:Array.isArray(V.parameters)?V.parameters.map(q.to):[],activeParameter:V.activeParameter}}re.to=ie})(te=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(re){function ge(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(te.from):[]}}re.from=ge;function ie(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(te.to):[]}}re.to=ie})(he=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(re){function ge(V){return{label:V.text,tooltip:V.tooltip&&a.from(V.tooltip),position:l.from(V.position),kind:Ue.from(V.kind??_.InlayHintKind.Other),whitespaceBefore:V.whitespaceBefore,whitespaceAfter:V.whitespaceAfter}}re.from=ge;function ie(V){const ve=new _.InlayHint(V.label,l.to(V.position),Ue.to(V.kind));return ve.tooltip=E.isMarkdownString(V.tooltip)?a.to(V.tooltip):V.tooltip,ve.whitespaceAfter=V.whitespaceAfter,ve.whitespaceBefore=V.whitespaceBefore,ve}re.to=ie})(Ae=e.InlayHint||(e.InlayHint={}));var Ue;(function(re){function ge(V){return V}re.from=ge;function ie(V){return V}re.to=ie})(Ue=e.InlayHintKind||(e.InlayHintKind={}));var ze;(function(re){function ge(V){return{range:h.from(V.range),url:V.target,tooltip:V.tooltip}}re.from=ge;function ie(V){let ve;if(V.url)try{ve=typeof V.url=="string"?A.URI.parse(V.url,!0):A.URI.revive(V.url)}catch{}return new _.DocumentLink(h.to(V.range),ve)}re.to=ie})(ze=e.DocumentLink||(e.DocumentLink={}));var Ge;(function(re){function ge(V){const ve=new _.ColorPresentation(V.label);return V.textEdit&&(ve.textEdit=z.to(V.textEdit)),V.additionalTextEdits&&(ve.additionalTextEdits=V.additionalTextEdits.map(Ie=>z.to(Ie))),ve}re.to=ge;function ie(V){return{label:V.label,textEdit:V.textEdit?z.from(V.textEdit):void 0,additionalTextEdits:V.additionalTextEdits?V.additionalTextEdits.map(ve=>z.from(ve)):void 0}}re.from=ie})(Ge=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(re){function ge(V){return new _.Color(V[0],V[1],V[2],V[3])}re.to=ge;function ie(V){return[V.red,V.green,V.blue,V.alpha]}re.from=ie})(et=e.Color||(e.Color={}));var st;(function(re){function ge(V){return{range:h.from(V.range)}}re.from=ge;function ie(V){return new _.SelectionRange(h.to(V.range))}re.to=ie})(st=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(re){function ge(ie){switch(ie){case 2:return _.TextDocumentSaveReason.AfterDelay;case 1:return _.TextDocumentSaveReason.Manual;case 3:case 4:return _.TextDocumentSaveReason.FocusOut}}re.to=ge})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(re){function ge(V){switch(V){case _.TextEditorLineNumbersStyle.Off:return 0;case _.TextEditorLineNumbersStyle.Relative:return 2;case _.TextEditorLineNumbersStyle.On:default:return 1}}re.from=ge;function ie(V){switch(V){case 0:return _.TextEditorLineNumbersStyle.Off;case 2:return _.TextEditorLineNumbersStyle.Relative;case 1:default:return _.TextEditorLineNumbersStyle.On}}re.to=ie})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var lt;(function(re){function ge(V){if(V===_.EndOfLine.CRLF)return 1;if(V===_.EndOfLine.LF)return 0}re.from=ge;function ie(V){if(V===1)return _.EndOfLine.CRLF;if(V===0)return _.EndOfLine.LF}re.to=ie})(lt=e.EndOfLine||(e.EndOfLine={}));var vt;(function(re){function ge(ie){if(typeof ie=="object")return ie.viewId;switch(ie){case _.ProgressLocation.SourceControl:return 3;case _.ProgressLocation.Window:return 10;case _.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}re.from=ge})(vt=e.ProgressLocation||(e.ProgressLocation={}));var Oe;(function(re){function ge(ie){const V={start:ie.start+1,end:ie.end+1};return ie.kind&&(V.kind=Rt.from(ie.kind)),V}re.from=ge})(Oe=e.FoldingRange||(e.FoldingRange={}));var Rt;(function(re){function ge(ie){if(ie)switch(ie){case _.FoldingRangeKind.Comment:return w.FoldingRangeKind.Comment;case _.FoldingRangeKind.Imports:return w.FoldingRangeKind.Imports;case _.FoldingRangeKind.Region:return w.FoldingRangeKind.Region}}re.from=ge})(Rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var j;(function(re){function ge(ie){if(ie)return{pinned:typeof ie.preview=="boolean"?!ie.preview:void 0,inactive:ie.background,preserveFocus:ie.preserveFocus,selection:typeof ie.selection=="object"?h.from(ie.selection):void 0,override:typeof ie.override=="boolean"?i.EditorResolution.DISABLED:void 0}}re.from=ge})(j=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(re){function ge(V){return V instanceof _.RelativePattern||typeof V=="string"?V:ie(V)?new _.RelativePattern(V.base,V.pattern):V}re.from=ge;function ie(V){const ve=V;return ve&&typeof ve.base=="string"&&typeof ve.pattern=="string"}})(Q=e.GlobPattern||(e.GlobPattern={}));var fe;(function(re){function ge(ie){if(ie){if(Array.isArray(ie))return ie.map(ge);if(typeof ie=="string")return ie;{const V=ie;return{language:V.language,scheme:V.scheme,pattern:typeof V.pattern=="undefined"?void 0:Q.from(V.pattern),exclusive:V.exclusive}}}else return}re.from=ge})(fe=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(re){function ge(V){return{start:V.start,end:V.end}}re.from=ge;function ie(V){return new _.NotebookRange(V.start,V.end)}re.to=ie})(Ne=e.NotebookRange||(e.NotebookRange={}));var Ve;(function(re){function ge(V){return{timing:typeof V.runStartTime=="number"&&typeof V.runEndTime=="number"?{startTime:V.runStartTime,endTime:V.runEndTime}:void 0,executionOrder:V.executionOrder,success:V.lastRunSuccess}}re.to=ge;function ie(V){return{lastRunSuccess:V.success,runStartTime:V.timing?.startTime,runEndTime:V.timing?.endTime,executionOrder:V.executionOrder}}re.from=ie})(Ve=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ot;(function(re){function ge(V){switch(V){case _.NotebookCellKind.Markup:return u.CellKind.Markup;case _.NotebookCellKind.Code:default:return u.CellKind.Code}}re.from=ge;function ie(V){switch(V){case u.CellKind.Markup:return _.NotebookCellKind.Markup;case u.CellKind.Code:default:return _.NotebookCellKind.Code}}re.to=ie})(ot=e.NotebookCellKind||(e.NotebookCellKind={}));var ht;(function(re){function ge(V){const ve={metadata:V.metadata??Object.create(null),cells:[]};for(let Ie of V.cells)_.NotebookCellData.validate(Ie),ve.cells.push(Je.from(Ie));return ve}re.from=ge;function ie(V){const ve=new _.NotebookData(V.cells.map(Je.to));return(0,C.isEmptyObject)(V.metadata)||(ve.metadata=V.metadata),ve}re.to=ie})(ht=e.NotebookData||(e.NotebookData={}));var Je;(function(re){function ge(V){return{cellKind:ot.from(V.kind),language:V.languageId,mime:V.mime,source:V.value,metadata:V.metadata,internalMetadata:Ve.from(V.executionSummary??{}),outputs:V.outputs?V.outputs.map(Re.from):[]}}re.from=ge;function ie(V){return new _.NotebookCellData(ot.to(V.cellKind),V.source,V.language,V.mime,V.outputs?V.outputs.map(Re.to):void 0,V.metadata,V.internalMetadata?Ve.to(V.internalMetadata):void 0)}re.to=ie})(Je=e.NotebookCellData||(e.NotebookCellData={}));var Tt;(function(re){function ge(V){return{mime:V.mime,valueBytes:t.VSBuffer.wrap(V.data)}}re.from=ge;function ie(V){return new _.NotebookCellOutputItem(V.valueBytes.buffer,V.mime)}re.to=ie})(Tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Re;(function(re){function ge(V){return{outputId:V.id,items:V.items.map(Tt.from),metadata:V.metadata}}re.from=ge;function ie(V){const ve=V.items.map(Tt.to);return new _.NotebookCellOutput(ve,V.outputId,V.metadata)}re.to=ie})(Re=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ce;(function(re){function ge(Ie){if(Ie!=null){if(Ie instanceof _.RelativePattern||typeof Ie=="string")return Ie;if(ve(Ie))return new _.RelativePattern(Ie.base,Ie.pattern);if(V(Ie))return{include:Q.from(Ie.include)||void 0,exclude:Q.from(Ie.exclude)||void 0}}}re.from=ge;function ie(Ie){return typeof Ie=="string"?Ie:ve(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}re.to=ie;function V(Ie){const Ke=Ie,xe=Q.from(Ke.include);if(!(xe&&xe instanceof _.RelativePattern||typeof xe=="string"))return!1;const ut=Q.from(Ke.exclude);return!!(ut&&ut instanceof _.RelativePattern||typeof ut=="string")}function ve(Ie){const Ke=Ie;return Ke&&typeof Ke.base=="string"&&typeof Ke.pattern=="string"}})(Ce=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var pe;(function(re){function ge(ie){return{backgroundColor:ie.backgroundColor,borderColor:ie.borderColor,top:ie.top?N.from(ie.top):void 0}}re.from=ge})(pe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ne;(function(re){function ge(ie,V,ve){const Ie=typeof ie.command=="string"?{title:"",command:ie.command}:ie.command;return{alignment:ie.alignment===_.NotebookCellStatusBarAlignment.Left?1:2,command:V.toInternal(Ie,ve),text:ie.text,tooltip:ie.tooltip,accessibilityInformation:ie.accessibilityInformation,priority:ie.priority}}re.from=ge})(ne=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var le;(function(re){function ge(ie){return{transientOutputs:ie?.transientOutputs??!1,transientCellMetadata:ie?.transientCellMetadata??{},transientDocumentMetadata:ie?.transientDocumentMetadata??{}}}re.from=ge})(le=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var de;(function(re){function ge(V){return{uri:V.uri,provides:V.provides}}re.from=ge;function ie(V){return new _.NotebookRendererScript(A.URI.revive(V.uri),V.provides)}re.to=ie})(de=e.NotebookRendererScript||(e.NotebookRendererScript={}));var me;(function(re){function ge(V){return{message:a.fromStrict(V.message)||"",type:0,expected:V.expectedOutput,actual:V.actualOutput,location:V.location?ce.from(V.location):void 0}}re.from=ge;function ie(V){const ve=new _.TestMessage(typeof V.message=="string"?V.message:a.to(V.message));return ve.actualOutput=V.actual,ve.expectedOutput=V.expected,ve.location=V.location?ce.to(V.location):void 0,ve}re.to=ie})(me=e.TestMessage||(e.TestMessage={}));var Te;(function(re){let ge;(function(ie){ie.Delimiter="\0"})(ge||(ge={})),re.namespace=(ie,V)=>ie+"\0"+V,re.denamespace=ie=>{const V=ie.indexOf("\0");return{ctrlId:ie.slice(0,V),tagId:ie.slice(V+1)}}})(Te=e.TestTag||(e.TestTag={}));var We;(function(re){function ge(Ie){const Ke=(0,o.getPrivateApiFor)(Ie).controllerId;return{extId:d.TestId.fromExtHostTestItem(Ie,Ke).toString(),label:Ie.label,uri:Ie.uri,tags:Ie.tags.map(xe=>Te.namespace(Ke,xe.id)),range:h.from(Ie.range)||null,description:Ie.description||null,error:Ie.error&&a.fromStrict(Ie.error)||null}}re.from=ge;function ie(Ie){return{parent:void 0,error:void 0,id:d.TestId.fromString(Ie.extId).localId,label:Ie.label,uri:A.URI.revive(Ie.uri),tags:(Ie.tags||[]).map(Ke=>{const{tagId:xe}=Te.denamespace(Ke);return new _.TestTag(xe)}),range:h.to(Ie.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ie.description||void 0}}re.toPlain=ie;function V(Ie){const Ke=d.TestId.fromString(Ie.extId),xe=new o.TestItemImpl(Ke.controllerId,Ke.localId,Ie.label,A.URI.revive(Ie.uri));return xe.range=h.to(Ie.range||void 0),xe.description=Ie.description||void 0,xe}function ve(Ie){let Ke;for(const xe of Ie.tests){const ut=V(xe.item);(0,o.getPrivateApiFor)(ut).parent=Ke,Ke=ut}return Ke}re.toItemFromContext=ve})(We=e.TestItem||(e.TestItem={})),function(re){function ge(V){return{id:V.id}}re.from=ge;function ie(V){return new _.TestTag(V.id)}re.to=ie}(Te=e.TestTag||(e.TestTag={}));var Le;(function(re){const ge=(V,ve)=>{const Ie={...We.toPlain(V.item),parent:void 0,taskStates:V.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(xe=>xe.type===0).map(me.to)})),children:V.children.map(Ke=>ve.get(Ke)).filter(C.isDefined).map(Ke=>ge(Ke,ve))};for(const Ke of Ie.children)Ke.parent=Ie;return Ie};function ie(V){const ve=[],Ie=new Map;for(const Ke of V.items)Ie.set(Ke.item.extId,Ke),V.request.targets.some(xe=>xe.controllerId===Ke.controllerId&&xe.testIds.includes(Ke.item.extId))&&ve.push(Ke);return{completedAt:V.completedAt,results:ve.map(Ke=>ge(Ke,Ie))}}re.to=ie})(Le=e.TestResults||(e.TestResults={}));var je;(function(re){function ge(Ie){return{covered:Ie.covered,total:Ie.covered}}function ie(Ie){return"line"in Ie?l.from(Ie):h.from(Ie)}function V(Ie){return"branches"in Ie?{count:Ie.executionCount,location:ie(Ie.location),type:1,branches:Ie.branches.length?Ie.branches.map(Ke=>({count:Ke.executionCount,location:Ke.location&&ie(Ke.location)})):void 0}:{type:0,count:Ie.executionCount,location:ie(Ie.location)}}re.fromDetailed=V;function ve(Ie){return{uri:Ie.uri,statement:ge(Ie.statementCoverage),branch:Ie.branchCoverage&&ge(Ie.branchCoverage),function:Ie.functionCoverage&&ge(Ie.functionCoverage),details:Ie.detailedCoverage?.map(V)}}re.fromFile=ve})(je=e.TestCoverage||(e.TestCoverage={}));var it;(function(re){function ge(ie){switch(ie){case 1:return _.CodeActionTriggerKind.Invoke;case 2:return _.CodeActionTriggerKind.Automatic}}re.to=ge})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var rt;(function(re){function ge(V){const ve=new _.TypeHierarchyItem($.to(V.kind),V.name,V.detail||"",A.URI.revive(V.uri),h.to(V.range),h.to(V.selectionRange));return ve._sessionId=V._sessionId,ve._itemId=V._itemId,ve}re.to=ge;function ie(V,ve,Ie){if(ve=ve??V._sessionId,Ie=Ie??V._itemId,ve===void 0||Ie===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:Ie,kind:$.from(V.kind),name:V.name,detail:V.detail??"",uri:V.uri,range:h.from(V.range),selectionRange:h.from(V.selectionRange),tags:V.tags?.map(W.from)}}re.from=ie})(rt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[164],ye([0,1,2,15,7,8,226]),function(ee,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(A,R,w,i={timeout:1500,errors:3}){this._logService=A,this._documents=R,this._mainThreadBulkEdits=w,this._thresholds=i,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(R,w,i)=>{const o={dispose:this._callbacks.push([R,w,A])};return Array.isArray(i)&&i.push(o),o}}async $participateInSave(A,R){const w=s.URI.revive(A);let i=!1;const p=setTimeout(()=>i=!0,this._thresholds.timeout),o=[];try{for(let u of[...this._callbacks]){if(i)break;const d=this._documents.getDocument(w),F=await this._deliverEventAsyncAndBlameBadListeners(u,{document:d,reason:T.TextDocumentSaveReason.to(R)});o.push(F)}}finally{clearTimeout(p)}return o}_deliverEventAsyncAndBlameBadListeners([A,R,w],i){const p=this._badListeners.get(A);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(w,A,R,i).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const u=this._badListeners.get(A);this._badListeners.set(A,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,R,w,i){const p=[],o=Date.now(),{document:u,reason:d}=i,{version:F}=u,_=Object.freeze({document:u,reason:d,waitUntil(m){if(Object.isFrozen(p))throw(0,t.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(m))}});try{R.apply(w,[_])}catch(m){return Promise.reject(m)}return Object.freeze(p),new Promise((m,h)=>{const D=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(l=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(D),m(l)}).catch(l=>{clearTimeout(D),h(l)})}).then(m=>{const h={edits:[]};for(const D of m)if(Array.isArray(D)&&D.every(l=>l instanceof E.TextEdit))for(const{newText:l,newEol:M,range:r}of D)h.edits.push({_type:2,resource:u.uri,edit:{range:r&&T.Range.from(r),text:l,eol:M&&T.EndOfLine.from(M)}});if(h.edits.length!==0)return F===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(Ee[165],ye([0,1,4,29,2,8,7]),function(ee,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class P{constructor(R,w,i,p,o){this._onDidCreate=new s.Emitter,this._onDidChange=new s.Emitter,this._onDidDelete=new s.Emitter,this._config=0,i&&(this._config+=1),p&&(this._config+=2),o&&(this._config+=4);const u=(0,t.parse)(w),d=R(F=>{if(!i)for(let _ of F.created){const m=E.URI.revive(_);u(m.fsPath)&&this._onDidCreate.fire(m)}if(!p)for(let _ of F.changed){const m=E.URI.revive(_);u(m.fsPath)&&this._onDidChange.fire(m)}if(!o)for(let _ of F.deleted){const m=E.URI.revive(_);u(m.fsPath)&&this._onDidDelete.fire(m)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,d)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(R,w,i){this._logService=w,this._extHostDocumentsAndEditors=i,this._onFileSystemEvent=new s.Emitter,this._onDidRenameFile=new s.Emitter,this._onDidCreateFile=new s.Emitter,this._onDidDeleteFile=new s.Emitter,this._onWillRenameFile=new s.AsyncEmitter,this._onWillCreateFile=new s.AsyncEmitter,this._onWillDeleteFile=new s.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(R,w,i,p){return new P(this._onFileSystemEvent.event,R,w,i,p)}$onFileEvent(R){this._onFileSystemEvent.fire(R)}$onDidRunFileOperation(R,w){switch(R){case 2:this._onDidRenameFile.fire(Object.freeze({files:w.map(i=>({oldUri:E.URI.revive(i.source),newUri:E.URI.revive(i.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:w.map(i=>E.URI.revive(i.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:w.map(i=>E.URI.revive(i.target))}));break;default:}}getOnWillRenameFileEvent(R){return this._createWillExecuteEvent(R,this._onWillRenameFile)}getOnWillCreateFileEvent(R){return this._createWillExecuteEvent(R,this._onWillCreateFile)}getOnWillDeleteFileEvent(R){return this._createWillExecuteEvent(R,this._onWillDeleteFile)}_createWillExecuteEvent(R,w){return(i,p,o)=>{const u=function(F){i.call(p,F)};return u.extension=R,w.event(u,void 0,o)}}async $onWillRunFileOperation(R,w,i,p){switch(R){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:w.map(o=>({oldUri:E.URI.revive(o.source),newUri:E.URI.revive(o.target)}))},i,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:w.map(o=>E.URI.revive(o.target))},i,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:w.map(o=>E.URI.revive(o.target))},i,p)}}async _fireWillEvent(R,w,i,p){const o=new Set,u=[];if(await R.fireAsync(w,p,async(F,_)=>{const m=Date.now(),h=await Promise.resolve(F);h instanceof k.WorkspaceEdit&&(u.push(h),o.add(_.extension.displayName??_.extension.identifier.value)),Date.now()-m>i&&this._logService.warn("SLOW file-participant",_.extension.identifier)}),p.isCancellationRequested||u.length===0)return;const d={edits:[]};for(let F of u){let{edits:_}=T.WorkspaceEdit.from(F,this._extHostDocumentsAndEditors);d.edits=d.edits.concat(_)}return{edit:d,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=C}),define(Ee[166],ye([0,1,11,26,2,8,87]),function(ee,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(w,i,p,o){this.start=w,this.deletedCount=i,this.deletedItems=p,this.items=o}static asApiEvents(w){return w.map(i=>({start:i.start,deletedCount:i.deletedCount,deletedItems:i.deletedItems,items:i.items.map(p=>p.apiCell)}))}}class C{constructor(w,i,p){this.notebook=w,this._extHostDocument=i,this._cellData=p,this.handle=p.handle,this.uri=E.URI.revive(p.uri),this.cellKind=p.cellKind,this._outputs=p.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=p.internalMetadata??{},this._metadata=Object.freeze(p.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}static asModelAddData(w,i){return{EOL:i.eol,lines:i.source,languageId:i.language,uri:i.uri,isDirty:!1,versionId:1,notebook:w}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const w=this,i=this._extHostDocument.getDocument(this.uri);if(!i)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:i.document,get mime(){return w._mime},set mime(p){w._mime=p},get outputs(){return w._outputs.slice(0)},get metadata(){return w._metadata},get executionSummary(){return w._previousResult}})}return this._apiCell}setOutputs(w){this._outputs=w.map(T.NotebookCellOutput.to)}setOutputItems(w,i,p){const o=p.map(T.NotebookCellOutputItem.to),u=this._outputs.find(d=>d.id===w);u&&(i||(u.items.length=0),u.items.push(...o))}setMetadata(w){this._metadata=Object.freeze(w)}setInternalMetadata(w){this._internalMetadata=w,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=C;class A{constructor(w,i,p,o,u,d){this._proxy=w,this._textDocumentsAndEditors=i,this._textDocuments=p,this._emitter=o,this.uri=u,this.handle=A._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=d.viewType,this._metadata=Object.freeze(d.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,d.cells]],!0),this._versionId=d.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const w=this;this._notebook={get uri(){return w.uri},get version(){return w._versionId},get notebookType(){return w._notebookType},get isDirty(){return w._isDirty},get isUntitled(){return w.uri.scheme===s.Schemas.untitled},get isClosed(){return w._disposed},get metadata(){return w._metadata},get cellCount(){return w._cells.length},cellAt(i){return i=w._validateIndex(i),w._cells[i].apiCell},getCells(i){return(i?w._getCells(i):w._cells).map(o=>o.apiCell)},save(){return w._save()}}}return this._notebook}updateBackup(w){this._backup?.delete(),this._backup=w}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(w){w.metadata&&(this._metadata=Object.freeze({...this._metadata,...w.metadata}))}acceptDirty(w){this._isDirty=w}acceptModelChanged(w,i){this._versionId=w.versionId,this._isDirty=i;for(const p of w.rawEvents)p.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(p.changes,!1):p.kind===k.NotebookCellsChangeType.Move?this._moveCell(p.index,p.newIdx):p.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(p.index,p.outputs):p.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(p.index,p.outputId,p.append,p.outputItems):p.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(p.index,p.language):p.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(p.index,p.mime):p.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(p.index,p.metadata):p.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(p.index,p.internalMetadata)}_validateIndex(w){return w=w|0,w<0?0:w>=this._cells.length?this._cells.length-1:w}_validateRange(w){let i=w.start|0,p=w.end|0;return i<0&&(i=0),p>this._cells.length&&(p=this._cells.length),w.with({start:i,end:p})}_getCells(w){w=this._validateRange(w);const i=[];for(let p=w.start;p<w.end;p++)i.push(this._cells[p]);return i}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(w,i){if(this._disposed)return;const p=[],o=[],u=[];w.reverse().forEach(d=>{const _=d[2].map(D=>{const l=new C(this,this._textDocumentsAndEditors,D);return i||o.push(C.asModelAddData(this.apiNotebook,D)),l}),m=new P(d[0],d[1],[],_),h=this._cells.splice(d[0],d[1],..._);for(const D of h)u.push(D.uri),m.deletedItems.push(D.apiCell);p.push(m)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:u}),i||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:P.asApiEvents(p)}))}_moveCell(w,i){const p=this._cells.splice(w,1);this._cells.splice(i,0,...p);const o=[new P(w,1,p.map(u=>u.apiCell),[]),new P(i,0,[],p)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:P.asApiEvents(o)}))}_setCellOutputs(w,i){const p=this._cells[w];p.setOutputs(i),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_setCellOutputItems(w,i,p,o){const u=this._cells[w];u.setOutputItems(i,p,o),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_changeCellLanguage(w,i){const p=this._cells[w];p.apiCell.document.languageId!==i&&this._textDocuments.$acceptModelLanguageChanged(p.uri,i)}_changeCellMime(w,i){const p=this._cells[w];p.apiCell.mime=i}_changeCellMetadata(w,i){const p=this._cells[w],o=p.apiCell.metadata;p.setMetadata(i);const u=p.apiCell.metadata;(0,t.equals)(o,u)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:p.apiCell}))}_changeCellInternalMetadata(w,i){this._cells[w].setInternalMetadata(i)}getCellFromApiCell(w){return this._cells.find(i=>i.apiCell===w)}getCellFromIndex(w){return this._cells[w]}getCell(w){return this._cells.find(i=>i.handle===w)}getCellIndex(w){return this._cells.indexOf(w)}}e.ExtHostNotebookDocument=A,A._handlePool=0}),define(Ee[91],ye([0,1,7,8,15]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:A})}replaceCells(C,A,R){this._throwIfFinalized(),!(C===A&&R.length===0)&&this._collectedEdits.push({editType:1,index:C,count:A-C,cells:R.map(t.NotebookCellData.from)})}}class k{constructor(C,A,R,w,i,p){this.id=C,this._proxy=A,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=i,this._visibleRanges=w,this._viewColumn=p}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(A){if(!Array.isArray(A)||!A.every(s.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");C._selections=A,C._trySetSelections(A)},get visibleRanges(){return C._visibleRanges},revealRange(A,R){C._proxy.$tryRevealRange(C.id,t.NotebookRange.from(A),R??s.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(A){const R=new T(this.document.version);return A(R),C._applyEdit(R.finalize())},setDecorations(A,R){return C.setDecorations(A,R)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(t.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const A=[];let R=-1;for(let w=0;w<C.cellEdits.length;w++){if(R<0){A.push(C.cellEdits[w]),R++;continue}const p=A[R],o=C.cellEdits[w];if(p.editType===1&&o.editType===1&&p.index===o.index){p.cells.push(...C.cellEdits[w].cells),p.count+=C.cellEdits[w].count;continue}A.push(C.cellEdits[w]),R++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,A)}setDecorations(C,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return A.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(A),C.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(Ee[167],ye([0,1,8,139,120,20,53,15]),function(ee,e,s,t,E,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(i){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=i}async withProgress(i,p,o){const u=this._handles++,{title:d,location:F,cancellable:_}=p,m={label:(0,E.localize)(0,null,i.displayName||i.name),id:i.identifier.value};return this._proxy.$startProgress(u,{location:s.ProgressLocation.from(F),title:d,source:m,cancellable:_},i).catch(P.onUnexpectedExternalError),this._withProgress(u,o,!!_)}_withProgress(i,p,o){let u;o&&(u=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(i,u));const d=_=>{this._proxy.$progressEnd(_),this._mapHandleToCancellationSource.delete(_),u&&u.dispose()};let F;try{F=p(new R(this._proxy,i),o&&u?u.token:T.CancellationToken.None)}catch(_){throw d(i),_}return F.then(_=>d(i),_=>d(i)),F}$acceptProgressCanceled(i){const p=this._mapHandleToCancellationSource.get(i);p&&(p.cancel(),this._mapHandleToCancellationSource.delete(i))}}e.ExtHostProgress=C;function A(w,i){return w.message=i.message,typeof i.increment=="number"&&(typeof w.increment=="number"?w.increment+=i.increment:w.increment=i.increment),w}class R extends t.Progress{constructor(i,p){super(o=>this.throttledReport(o));this._proxy=i,this._handle=p}throttledReport(i){this._proxy.$progressReport(this._handle,i)}}Be([(0,k.throttle)(100,(w,i)=>A(w,i),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ee[92],ye([0,1,42,15,54,8,7]),function(ee,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(i,p,o){const u=P._Keys.nextId();i.$registerTextEditorDecorationType(p.identifier,u,T.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:u,dispose(){i.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=P,P._Keys=new E.IdGenerator("TextEditorDecorationType");class C{constructor(i,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=i,this._documentVersionId=i.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(i,p){this._throwIfFinalized();let o=null;if(i instanceof k.Position)o=new k.Range(i,i);else if(i instanceof k.Range)o=i;else throw new Error("Unrecognized location");this._pushEdit(o,p,!1)}insert(i,p){this._throwIfFinalized(),this._pushEdit(new k.Range(i,i),p,!0)}delete(i){this._throwIfFinalized();let p=null;if(i instanceof k.Range)p=i;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(i,p,o){const u=this._document.validateRange(i);this._collectedEdits.push({range:u,text:p,forceMoveMarkers:o})}setEndOfLine(i){if(this._throwIfFinalized(),i!==k.EndOfLine.LF&&i!==k.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=i}}e.TextEditorEdit=C;class A{constructor(i,p,o,u){this._proxy=i,this._id=p,this._accept(o),this._logService=u;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(F){d._setTabSize(F)},get insertSpaces(){return d._insertSpaces},set insertSpaces(F){d._setInsertSpaces(F)},get cursorStyle(){return d._cursorStyle},set cursorStyle(F){d._setCursorStyle(F)},get lineNumbers(){return d._lineNumbers},set lineNumbers(F){d._setLineNumbers(F)}}}_accept(i){this._tabSize=i.tabSize,this._insertSpaces=i.insertSpaces,this._cursorStyle=i.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(i.lineNumbers)}_validateTabSize(i){if(i==="auto")return"auto";if(typeof i=="number"){const p=Math.floor(i);return p>0?p:null}if(typeof i=="string"){const p=parseInt(i,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(i){const p=this._validateTabSize(i);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(i){return i==="auto"?"auto":i==="false"?!1:Boolean(i)}_setInsertSpaces(i){const p=this._validateInsertSpaces(i);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(i){this._cursorStyle!==i&&(this._cursorStyle=i,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:i})))}_setLineNumbers(i){this._lineNumbers!==i&&(this._lineNumbers=i,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(i)})))}assign(i){const p={};let o=!1;if(typeof i.tabSize!="undefined"){const u=this._validateTabSize(i.tabSize);u==="auto"?(o=!0,p.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,o=!0,p.tabSize=u)}if(typeof i.insertSpaces!="undefined"){const u=this._validateInsertSpaces(i.insertSpaces);u==="auto"?(o=!0,p.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,o=!0,p.insertSpaces=u)}typeof i.cursorStyle!="undefined"&&this._cursorStyle!==i.cursorStyle&&(this._cursorStyle=i.cursorStyle,o=!0,p.cursorStyle=i.cursorStyle),typeof i.lineNumbers!="undefined"&&this._lineNumbers!==i.lineNumbers&&(this._lineNumbers=i.lineNumbers,o=!0,p.lineNumbers=T.TextEditorLineNumbersStyle.from(i.lineNumbers)),o&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,p))}_warnOnError(i,p){p.catch(o=>{this._logService.warn(`ExtHostTextEditorOptions '${i}' failed:'`),this._logService.warn(o)})}}e.ExtHostTextEditorOptions=A;class R{constructor(i,p,o,u,d,F,_,m){this.id=i,this._proxy=p,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new A(this._proxy,this.id,F,o),this._visibleRanges=_,this._viewColumn=m;const h=this;this.value=Object.freeze({get document(){return u.getValue()},set document(D){throw(0,t.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(D){if(!(D instanceof k.Selection))throw(0,t.illegalArgument)("selection");h._selections=[D],h._trySetSelection()},get selections(){return h._selections},set selections(D){if(!Array.isArray(D)||D.some(l=>!(l instanceof k.Selection)))throw(0,t.illegalArgument)("selections");h._selections=D,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(D){throw(0,t.readonly)("visibleRanges")},get options(){return h._options.value},set options(D){h._disposed||h._options.assign(D)},get viewColumn(){return h._viewColumn},set viewColumn(D){throw(0,t.readonly)("viewColumn")},edit(D,l={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const M=new C(u.getValue(),l);return D(M),h._applyEdit(M)},insertSnippet(D,l,M={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!l||Array.isArray(l)&&l.length===0)r=h._selections.map(n=>T.Range.from(n));else if(l instanceof k.Position){const{lineNumber:n,column:b}=T.Position.from(l);r=[{startLineNumber:n,startColumn:b,endLineNumber:n,endColumn:b}]}else if(l instanceof k.Range)r=[T.Range.from(l)];else{r=[];for(const n of l)if(n instanceof k.Range)r.push(T.Range.from(n));else{const{lineNumber:b,column:g}=T.Position.from(n);r.push({startLineNumber:b,startColumn:g,endLineNumber:b,endColumn:g})}}return p.$tryInsertSnippet(i,D.value,r,M)},setDecorations(D,l){const M=l.length===0;M&&!h._hasDecorationsForKey.has(D.key)||(M?h._hasDecorationsForKey.delete(D.key):h._hasDecorationsForKey.add(D.key),h._runOnProxy(()=>{if(T.isDecorationOptionsArr(l))return p.$trySetDecorations(i,D.key,T.fromRangeOrRangeWithMessage(l));{const r=new Array(4*l.length);for(let n=0,b=l.length;n<b;n++){const g=l[n];r[4*n]=g.start.line+1,r[4*n+1]=g.start.character+1,r[4*n+2]=g.end.line+1,r[4*n+3]=g.end.character+1}return p.$trySetDecorationsFast(i,D.key,r)}}))},revealRange(D,l){h._runOnProxy(()=>p.$tryRevealRange(i,T.Range.from(D),l||k.TextEditorRevealType.Default))},show(D){p.$tryShowEditor(i,T.ViewColumn.from(D))},hide(){p.$tryHideEditor(i)}})}dispose(){(0,s.ok)(!this._disposed),this._disposed=!0}_acceptOptions(i){(0,s.ok)(!this._disposed),this._options._accept(i)}_acceptVisibleRanges(i){(0,s.ok)(!this._disposed),this._visibleRanges=i}_acceptViewColumn(i){(0,s.ok)(!this._disposed),this._viewColumn=i}_acceptSelections(i){(0,s.ok)(!this._disposed),this._selections=i}async _trySetSelection(){const i=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,i)),this.value}_applyEdit(i){const p=i.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const o=p.edits.map(d=>d.range);o.sort((d,F)=>d.end.line===F.end.line?d.end.character===F.end.character?d.start.line===F.start.line?d.start.character-F.start.character:d.start.line-F.start.line:d.end.character-F.end.character:d.end.line-F.end.line);for(let d=0,F=o.length-1;d<F;d++){const _=o[d].end;if(o[d+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=p.edits.map(d=>({range:T.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,u,{setEndOfLine:typeof p.setEndOfLine=="number"?T.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(i){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):i().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=R}),define(Ee[168],ye([0,1,14,4,6,10,48,8,88,67]),function(ee,e,s,t,E,T,k,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends E.Disposable{constructor(i){super();this.controllerId=i,this.debounceSendDiff=this._register(new s.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new k.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(i){this._resolveHandler=i;for(const p of this.tree.values())this.updateExpandability(p)}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){const p=this.diff[this.diff.length-1];if(p&&i[0]===1){if(p[0]===1&&p[1].extId===i[1].extId){(0,C.applyTestItemUpdate)(p[1],i[1]);return}if(p[0]===0&&p[1].item.extId===i[1].extId){(0,C.applyTestItemUpdate)(p[1],i[1]);return}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,p){const o=this.tree.get(i);if(!!o){if((o.expandLevels===void 0||p>o.expandLevels)&&(o.expandLevels=p),o.expand===1){const u=this.resolveChildren(o);return u.isOpen()?this.expandChildren(o,p-1):u.wait().then(()=>this.expandChildren(o,p-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,p-1)):this.expandChildren(o,p-1)}}dispose(){for(const i of this.tree.values())(0,k.getPrivateApiFor)(i.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(i,p){switch(p.op){case 2:this.pushDiff([4,i.fullId.toString()]);break;case 1:this.removeItem(A.TestId.joinToString(i.fullId,p.id));break;case 0:this.upsertItem(p.item,i);break;case 4:for(const o of p.ops)this.onTestItemEvent(i,o);break;case 3:{const{key:o,value:u,previous:d}=p,F=i.fullId.toString();switch(o){case"canResolveChildren":this.updateExpandability(i);break;case"tags":this.diffTagRefs(u,d,F);break;case"range":this.pushDiff([1,{extId:F,item:{range:P.Range.from(u)}}]);break;case"error":this.pushDiff([1,{extId:F,item:{error:P.MarkdownString.fromStrict(u)||null}}]);break;default:this.pushDiff([1,{extId:F,item:{[o]:u??null}}]);break}break}default:(0,T.assertNever)(p)}}upsertItem(i,p){if(!(i instanceof k.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${i.id} did not`);const o=A.TestId.fromExtHostTestItem(i,this.root.id,p?.actual),u=(0,k.getPrivateApiFor)(i);u.parent&&u.parent!==p?.actual&&u.parent.children.delete(i.id);let d=this.tree.get(o.toString());if(!d){d={fullId:o,actual:i,parent:p?o.parentId:null,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},i.tags.forEach(this.incrementTagRefs,this),this.tree.set(d.fullId.toString(),d),this.setItemParent(i,p),this.pushDiff([0,{parent:d.parent&&d.parent.toString(),controllerId:this.controllerId,expand:d.expand,item:P.TestItem.from(i)}]),this.connectItemAndChildren(i,d,p);return}if(d.actual===i){this.connectItem(i,d,p);return}const F=d.actual.children,_=d.actual,m=(0,k.diffTestItems)(_,i);(0,k.getPrivateApiFor)(_).listener=void 0,d.actual=i,d.expand=0;for(const[h,D]of m)this.onTestItemEvent(d,{op:3,key:h,value:D,previous:_[h]});this.connectItemAndChildren(i,d,p);for(const h of F)i.children.get(h.id)||this.removeItem(A.TestId.joinToString(o,h.id))}diffTagRefs(i,p,o){const u=new Set(p.map(d=>d.id));for(const d of i)u.delete(d.id)||this.incrementTagRefs(d);this.pushDiff([1,{extId:o,item:{tags:i.map(d=>P.TestTag.namespace(this.controllerId,d.id))}}]),u.forEach(this.decrementTagRefs,this)}incrementTagRefs(i){const p=this.tags.get(i.id);p?p.refCount++:(this.tags.set(i.id,{refCount:1}),this.pushDiff([5,{id:P.TestTag.namespace(this.controllerId,i.id),ctrlLabel:this.root.label}]))}decrementTagRefs(i){const p=this.tags.get(i);p&&!--p.refCount&&(this.tags.delete(i),this.pushDiff([6,P.TestTag.namespace(this.controllerId,i)]))}setItemParent(i,p){(0,k.getPrivateApiFor)(i).parent=p&&p.actual!==this.root?p.actual:void 0}connectItem(i,p,o){this.setItemParent(i,o);const u=(0,k.getPrivateApiFor)(i);u.parent=o?.actual,u.listener=d=>this.onTestItemEvent(p,d),this.updateExpandability(p)}connectItemAndChildren(i,p,o){this.connectItem(i,p,o);for(const u of i.children)this.upsertItem(u,p)}updateExpandability(i){let p;this._resolveHandler?i.resolveBarrier?p=i.resolveBarrier.isOpen()?3:2:p=i.actual.canResolveChildren?1:0:p=0,p!==i.expand&&(i.expand=p,this.pushDiff([1,{extId:i.fullId.toString(),expand:p}]),p===1&&i.expandLevels!==void 0&&this.resolveChildren(i))}expandChildren(i,p){if(p<0)return;const o=[];for(const u of i.actual.children){const d=this.expand(A.TestId.joinToString(i.fullId,u.id),p);(0,s.isThenable)(d)&&o.push(d)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this._resolveHandler){const d=new s.Barrier;return d.open(),d}i.expand=2,this.pushExpandStateUpdate(i);const p=i.resolveBarrier=new s.Barrier,o=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),i.actual!==this.root&&(i.actual.error=d.stack||d.message||String(d))};let u;try{u=this._resolveHandler(i.actual===this.root?void 0:i.actual)}catch(d){o(d)}return(0,s.isThenable)(u)?u.catch(o).then(()=>{p.open(),this.updateExpandability(i)}):(p.open(),this.updateExpandability(i)),i.resolveBarrier}pushExpandStateUpdate(i){this.pushDiff([1,{extId:i.fullId.toString(),expand:i.expand}])}removeItem(i){const p=this.tree.get(i);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff([2,i]);const o=[p];for(;o.length;){const u=o.pop();if(!!u){(0,k.getPrivateApiFor)(u.actual).listener=void 0;for(const d of u.actual.tags)this.decrementTagRefs(d.id);this.tree.delete(u.fullId.toString());for(const d of u.actual.children)o.push(this.tree.get(A.TestId.joinToString(u.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.diffOpEmitter.fire(i)}}e.SingleUseTestCollection=R}),define(Ee[169],ye([0,1,3,135]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,s.refineServiceDecorator)(t.IEnvironmentService)}),define(Ee[170],ye([0,1,25,4,17]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=T;class k{constructor(R){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(s.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(s.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let w of R.activationEvents)w==="onUri"&&(w=`onUri:${s.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(w)||this._activationMap.set(w,[]),this._activationMap.get(w).push(R)}}keepOnly(R){const w=new Set;R.forEach(i=>w.add(s.ExtensionIdentifier.toKey(i))),this._extensionDescriptions=this._extensionDescriptions.filter(i=>w.has(s.ExtensionIdentifier.toKey(i.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,w){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const i=k._findLoopingExtensions(this._extensionDescriptions);if(w=w.concat(i.map(p=>p.identifier)),w.length>0){const p=new Set;w.forEach(o=>p.add(s.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!p.has(s.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(i)}static _findLoopingExtensions(R){const w=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,F){this.addNode(d),this.addNode(F),this._arcs.has(d)?this._arcs.get(d).push(F):this._arcs.set(d,[F])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,F){const _=w.getArcs(d);for(let m=0;m<_.length;m++)if(!F.has(_[m]))return!1;return!0}getNodes(){return this._nodesArr}};let i=new Map;for(let d of R){const F=s.ExtensionIdentifier.toKey(d.identifier);if(i.set(F,d),d.extensionDependencies)for(let _ of d.extensionDependencies){const m=s.ExtensionIdentifier.toKey(_);w.addArc(F,m)}}let p=new Set;w.getNodes().filter(d=>w.getArcs(d).length===0).forEach(d=>p.add(d));let o=w.getNodes().filter(d=>!p.has(d)),u;do{u=!1;for(let d=0;d<o.length;d++){const F=o[d];w.hasOnlyGoodArcs(F,p)&&(o.splice(d,1),d--,p.add(F),u=!0)}}while(u);return o.map(d=>i.get(d))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(s.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const w=this._activationMap.get(R);return w?w.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const w=this._extensionsMap.get(s.ExtensionIdentifier.toKey(R));return w||void 0}}e.ExtensionDescriptionRegistry=k;var P;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(P||(P={}));function C(A,R){const w=A.isBuiltin?0:A.isUnderDevelopment?2:1,i=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(w!==i)return w-i;const p=E.posix.basename(A.extensionLocation.path),o=E.posix.basename(R.extensionLocation.path);return p<o?-1:p>o?1:0}}),define(Ee[171],ye([0,1,22]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function T(P){const C=s.VSBuffer.alloc(1);switch(P){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=T;function k(P,C){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=k}),define(Ee[27],ye([0,1,4,2,3,25,142]),function(ee,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var P;(function(h){h[h.None=0]="None",h[h.LocalProcess=1]="LocalProcess",h[h.LocalWebWorker=2]="LocalWebWorker",h[h.Remote=3]="Remote"})(P=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(h){switch(h){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class A{constructor(D){this.dependency=D}}e.MissingExtensionDependency=A;var R;(function(h){h[h.LocalProcess=0]="LocalProcess",h[h.LocalWebWorker=1]="LocalWebWorker",h[h.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function w(h){switch(h){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=w;function i(h,D){return h.enabledApiProposals?h.enabledApiProposals.includes(D):!1}e.isProposedApiEnabled=i;function p(h,D){if(!i(h,D))throw new Error(`Extension '${h.identifier.value}' CANNOT use API proposal: ${D}.
Its package.json#enabledApiProposals-property declares: ${h.enabledApiProposals?.join(", ")??"[]"} but NOT ${D}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${h.identifier.value}`)}e.checkProposedApiEnabled=p;class o{constructor(D,l,M,r){this.codeLoadingTime=D,this.activateCallTime=l,this.activateResolvedTime=M,this.activationReason=r}}e.ActivationTimes=o;class u{constructor(D,l){this.description=D,this.value=l}}e.ExtensionPointContribution=u,e.ExtensionHostLogFileName="exthost";var d;(function(h){h[h.Normal=0]="Normal",h[h.Immediate=1]="Immediate"})(d=e.ActivationKind||(e.ActivationKind={}));function F(h){return{type:h.isBuiltin?0:1,isBuiltin:h.isBuiltin||h.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(h.publisher,h.name),uuid:h.uuid},manifest:h,location:h.extensionLocation}}e.toExtension=F;function _(h,D){return{identifier:new T.ExtensionIdentifier(h.identifier.id),isBuiltin:h.type===0,isUserBuiltin:h.type===1&&h.isBuiltin,isUnderDevelopment:!!D,extensionLocation:h.location,...h.manifest,uuid:h.identifier.uuid}}e.toExtensionDescription=_;class m{constructor(){this.onDidRegisterExtensions=s.Event.None,this.onDidChangeExtensionsStatus=s.Event.None,this.onDidChangeExtensions=s.Event.None,this.onWillActivateByEvent=s.Event.None,this.onDidChangeResponsiveChange=s.Event.None}activateByEvent(D){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(D){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(D){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(D){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(D,l){return Promise.resolve()}_onWillActivateExtension(D){}_onDidActivateExtension(D,l,M,r,n){}_onDidActivateExtensionError(D,l){}_onExtensionRuntimeError(D,l){}_onExtensionHostExit(D){}}e.NullExtensionService=m}),define(Ee[172],ye([0,1,15,25,27,12]),function(ee,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const k=Promise.resolve(void 0);class P{constructor(u,d,F,_){this.startup=u,this.codeLoadingTime=d,this.activateCallTime=F,this.activateResolvedTime=_}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class C{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,d){return u===-1||d===-1?-1:d-u}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class A{constructor(u,d,F,_,m,h){this.activationFailed=u,this.activationFailedError=d,this.activationTimes=F,this.module=_,this.exports=m,this.subscriptions=h}}e.ActivatedExtension=A;class R extends A{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class w extends A{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=w;class i extends A{constructor(u){super(!0,u,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=i;let p=class{constructor(u,d,F,_,m){this._logService=m,this._isDisposed=!1,this._registry=u,this._resolvedExtensionsSet=new Set,d.forEach(h=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(h))),this._hostExtensionsMap=new Map,F.forEach(h=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(h),h)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(u){const d=t.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(d)}getActivatedExtension(u){const d=t.ExtensionIdentifier.toKey(u),F=this._activatedExtensions.get(d);if(!F)throw new Error("Extension `"+u.value+"` is not known or not activated");return F}activateByEvent(u,d){if(this._alreadyActivatedEvents[u])return k;const F=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(F.map(_=>({id:_.identifier,reason:{startup:d,extensionId:_.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,d){const F=this._registry.getExtensionDescription(u);if(!F)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:F.identifier,reason:d}])}_handleActivateRequest(u,d,F){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(u.id))){d[t.ExtensionIdentifier.toKey(u.id)]=u;return}const _=this._registry.getExtensionDescription(u.id);if(!_){const D=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,D,new E.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(u.id),new i(D));return}const m=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let h=!0;for(let D=0,l=m.length;D<l;D++){const M=m[D];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(M)))continue;const r=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(M));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const c=_.displayName||_.identifier.value,f=this._registry.getExtensionDescription(M),v=f&&f.displayName||M,a=new Error(`Cannot activate the '${c}' extension because its dependency '${v}' failed to activate`);a.detail=r.activationFailedError,this._host.onExtensionActivationError(_.identifier,a,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(_.identifier),new i(a));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(M))){h=!1,d[t.ExtensionIdentifier.toKey(M)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(M)),reason:u.reason};continue}const n=this._registry.getExtensionDescription(M);if(n){if(!n.main&&!n.browser)continue;h=!1,d[t.ExtensionIdentifier.toKey(M)]={id:n.identifier,reason:u.reason};continue}const b=_.displayName||_.identifier.value,g=new Error(`Cannot activate the '${b}' extension because it depends on unknown extension '${M}'`);this._host.onExtensionActivationError(_.identifier,g,new E.MissingExtensionDependency(M)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(_.identifier),new i(g));return}h?d[t.ExtensionIdentifier.toKey(_.identifier)]=u:F.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(m=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(m.id))),u.length===0))return Promise.resolve(void 0);const d=Object.create(null),F=[];for(let m=0,h=u.length;m<h;m++)this._handleActivateRequest(u[m],d,F);for(let m=0,h=F.length;m<h;m++){const D=t.ExtensionIdentifier.toKey(F[m].id);d[D]&&delete d[D]}const _=Object.keys(d).map(m=>d[m]);return F.length===0?Promise.all(_.map(m=>this._activateExtension(m.id,m.reason))).then(m=>{}):this._activateExtensions(_).then(m=>this._activateExtensions(F))}_activateExtension(u,d){const F=t.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(F))return Promise.resolve(void 0);const _=this._activatingExtensions.get(F);if(_)return _;const m=this._host.actualActivateExtension(u,d).then(void 0,h=>{const D=new Error;return h&&h.name&&(D.name=h.name),h&&h.message?D.message=`Activating extension '${u.value}' failed: ${h.message}.`:D.message=`Activating extension '${u.value}' failed: ${h}.`,h&&h.stack&&(D.stack=h.stack),this._isDisposed&&s.isPromiseCanceledError(h)?new i(h):(this._host.onExtensionActivationError(u,D,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(h),new i(h))}).then(h=>{this._activatedExtensions.set(F,h),this._activatingExtensions.delete(F)});return this._activatingExtensions.set(F,m),m}};p=Be([$e(4,T.ILogService)],p),e.ExtensionsActivator=p}),define(Ee[173],ye([0,1,12,28,27]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends s.LogService{constructor(P,C){super(P.createLogger(C.logFile,{name:E.ExtensionHostLogFileName}))}};T=Be([$e(0,s.ILoggerService),$e(1,t.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(Ee[174],ye([0,1,15]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,k)=>{this._actualOk=T,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,s.onUnexpectedError)(T))}then(T,k){return this._ensureActual().then(T,k)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=t}),define(Ee[38],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class s{constructor(A,R){this._proxyIdentifierBrand=void 0,this.isMain=A,this.sid=R,this.nid=++s.count}}e.ProxyIdentifier=s,s.count=0;const t=[];function E(C){const A=new s(!0,C);return t[A.nid]=A,A}e.createMainContextProxyIdentifier=E;function T(C){const A=new s(!1,C);return t[A.nid]=A,A}e.createExtHostContextProxyIdentifier=T;function k(C){return t[C].sid}e.getStringIdentifierForProxy=k;class P{constructor(A){this.value=A}}e.SerializableObjectWithBuffers=P}),define(Ee[5],ye([0,1,55,2,38]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var k;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var A;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(A=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var w;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(w=e.CandidatePortSource||(e.CandidatePortSource={}));var i;(function(m){m.name="$ident";function h(l,M){return Object.defineProperty(l,m.name,{value:M,enumerable:!0}),l}m.mixin=h;function D(l){return l[m.name]}m.of=D})(i=e.ObjectIdentifier||(e.ObjectIdentifier={}));class p{static mixin(h){return h._id=p._n++,h}}e.IdObject=p,p._n=0;var o;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.command="m",m.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(m){m[m.File=1]="File",m[m.Text=2]="Text",m[m.Cell=3]="Cell"})(d=e.WorkspaceEditType||(e.WorkspaceEditType={}));function F(m){if(m&&m.edits)for(const h of m.edits)typeof h.resource=="object"?h.resource=t.URI.revive(h.resource):(h.newUri=t.URI.revive(h.newUri),h.oldUri=t.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,s.revive)(h.metadata));return m}e.reviveWorkspaceEditDto=F;var _;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,E.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[68],ye([0,1,5,4,3]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(P){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(s.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,C){return this._proxy.$getPassword(P,C)}store(P,C,A){return this._proxy.$setPassword(P,C,A)}delete(P,C){return this._proxy.$deletePassword(P,C)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(Ee[69],ye([0,1,3,12,5,13]),function(ee,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,s.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(C,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(E.MainContext.MainThreadTelemetry)}report(C,A,R){const w=this.getUsageKey(C,A);this._reportedUsages.has(w)||(this._reportedUsages.add(w),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:C}))}getUsageKey(C,A){return`${C}-${A.identifier.value}`}};k=Be([$e(0,T.IExtHostRpcService),$e(1,t.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(P,C,A){}})}),define(Ee[175],ye([0,1,4,5,7,25]),function(ee,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new s.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,A,R,w={}){const i=T.ExtensionIdentifier.toKey(C.identifier),p=this._inFlightRequests.get(i)||[],o=[...R].sort().join(" ");let u=p.find(d=>d.scopes===o);if(u)return u.result;{const d=this._getSession(C,i,A,R,w);u={scopes:o,result:d},p.push(u),this._inFlightRequests.set(i,p);try{await d}finally{const F=p.findIndex(_=>_.scopes===o);F>-1&&(p.splice(F),this._inFlightRequests.set(i,p))}return d}}async _getSession(C,A,R,w,i={}){await this._proxy.$ensureProvider(R);const p=C.displayName||C.name;return this._proxy.$getSession(R,w,A,p,i)}async removeSession(C,A){const R=this._authenticationProviders.get(C);return R?R.provider.removeSession(A):this._proxy.$removeSession(C,A)}registerAuthenticationProvider(C,A,R,w){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:A,provider:R,options:w??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===C)||this._providers.push({id:C,label:A});const i=R.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(C,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,A,w?.supportsMultipleAccounts??!1),new E.Disposable(()=>{i.dispose(),this._authenticationProviders.delete(C);const p=this._providers.findIndex(o=>o.id===C);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,A){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,A){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,A){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,A){return this._onDidChangeSessions.fire({provider:{id:C,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(Ee[176],ye([0,1,5,13,8]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(P,C){this._extHostDocumentsAndEditors=C,this._proxy=P.getProxy(s.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const C=E.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};T=Be([$e(0,t.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(Ee[177],ye([0,1,5]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(T){const k=T.getProxy(s.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(P){return k.$writeText(P)}})}}e.ExtHostClipboard=t});var Ze=this&&this.__classPrivateFieldSet||function(ee,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!E:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(ee,s):E?E.value=s:e.set(ee,s),s},ke=this&&this.__classPrivateFieldGet||function(ee,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(ee):t?t.value:e.get(ee)};define(Ee[39],ye([0,1,10,7,8,26,5,16,12,55,59,227,2,6,3,13,48,22,38,43]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let D=class{constructor(g,c){h.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Ze(this,h,g.getProxy(k.MainContext.MainThreadCommands),"f"),this._logService=c,this.converter=new l(this,f=>{const v=this._apiCommands.get(f);return v?.result===r.Void?v:void 0},c),this._argumentProcessors=[{processArgument(f){return(0,A.revive)(f)}},{processArgument(f){return(0,T.cloneAndChange)(f,function(v){if(R.Range.isIRange(v))return E.Range.to(v);if(w.Position.isIPosition(v))return E.Position.to(v);if(R.Range.isIRange(v.range)&&i.URI.isUri(v.uri))return E.location.to(v);if(v instanceof F.VSBuffer)return v.buffer.buffer;if(!Array.isArray(v))return v})}}]}registerArgumentProcessor(g){this._argumentProcessors.push(g)}registerApiCommand(g){const c=this.registerCommand(!1,g.id,async(...f)=>{const v=g.args.map((S,I)=>{if(!S.validate(f[I]))throw new Error(`Invalid argument '${S.name}' when running '${g.id}', received: ${f[I]}`);return S.convert(f[I])}),a=await this.executeCommand(g.internalId,...v);return g.result.convert(a,f,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this._apiCommands.set(g.id,g),new t.Disposable(()=>{c.dispose(),this._apiCommands.delete(g.id)})}registerCommand(g,c,f,v,a,S){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:f,thisArg:v,description:a,extension:S}),g&&ke(this,h,"f").$registerCommand(c),new t.Disposable(()=>{this._commands.delete(c)&&g&&ke(this,h,"f").$unregisterCommand(c)})}executeCommand(g,...c){return this._logService.trace("ExtHostCommands#executeCommand",g),this._doExecuteCommand(g,c,!0)}async _doExecuteCommand(g,c,f){if(this._commands.has(g))return this._executeContributedCommand(g,c,!1);{let v=!1;const a=(0,T.cloneAndChange)(c,function(S){if(S instanceof t.Position)return E.Position.from(S);if(S instanceof t.Range)return E.Range.from(S);if(S instanceof t.Location)return E.location.from(S);if(t.NotebookRange.isNotebookRange(S))return E.NotebookRange.from(S);if(S instanceof ArrayBuffer)return v=!0,F.VSBuffer.wrap(new Uint8Array(S));if(S instanceof Uint8Array)return v=!0,F.VSBuffer.wrap(S);if(!Array.isArray(S))return S});try{const S=await ke(this,h,"f").$executeCommand(g,v?new _.SerializableObjectWithBuffers(a):a,f);return(0,A.revive)(S)}catch(S){if(S instanceof Error&&S.message==="$executeCommand:retry")return this._doExecuteCommand(g,c,!1);throw S}}}async _executeContributedCommand(g,c,f){const v=this._commands.get(g);if(!v)throw new Error("Unknown command");let{callback:a,thisArg:S,description:I}=v;if(I)for(let N=0;N<I.args.length;N++)try{(0,s.validateConstraint)(c[N],I.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${I.args[N].name}' - ${I.args[N].description}`)}try{return await a.apply(S,c)}catch(N){if(g===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...c);B&&(g=B.command)}throw this._logService.error(N,g,v.extension?.identifier),f?new class extends Error{constructor(){super((0,m.toErrorMessage)(N));this.id=g,this.source=v.extension?.displayName??v.extension?.name}}:N}}$executeContributedCommand(g,...c){return this._logService.trace("ExtHostCommands#$executeContributedCommand",g),this._commands.has(g)?(c=c.map(f=>this._argumentProcessors.reduce((v,a)=>a.processArgument(v),f)),this._executeContributedCommand(g,c,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this._logService.trace("ExtHostCommands#getCommands",g),ke(this,h,"f").$getCommands().then(c=>(g&&(c=c.filter(f=>f[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(let[c,f]of this._commands){let{description:v}=f;v&&(g[c]=v)}return Promise.resolve(g)}};h=new WeakMap,D=Be([$e(0,u.IExtHostRpcService),$e(1,C.ILogService)],D),e.ExtHostCommands=D,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class l{constructor(g,c,f){this._commands=g,this._lookupApiCommand=c,this._logService=f,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(g,c){if(!g)return;const f={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return f;const v=this._lookupApiCommand(g.command);if(v)f.id=v.internalId,f.arguments=v.args.map((a,S)=>a.convert(g.arguments&&g.arguments[S]));else if((0,P.isNonEmptyArray)(g.arguments)){const a=++this._cachIdPool;this._cache.set(a,g),c.add((0,p.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),f.$ident=a,f.id=this.delegatingCommandId,f.arguments=[a],this._logService.trace("CommandsConverter#CREATE",g.command,a)}return f}fromInternal(g){const c=k.ObjectIdentifier.of(g);return typeof c=="number"?this._cache.get(c):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this._cache.get(g[0])}_executeConvertedCommand(...g){const c=this.getActualCommand(...g);return this._logService.trace("CommandsConverter#EXECUTE",g[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=l;class M{constructor(g,c,f,v){this.name=g,this.description=c,this.validate=f,this.convert=v}optional(){return new M(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,c){return new M(g??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=M,M.Uri=new M("uri","Uri of a text document",b=>i.URI.isUri(b),b=>b),M.Position=new M("position","A position in a text document",b=>t.Position.isPosition(b),E.Position.from),M.Range=new M("range","A range in a text document",b=>t.Range.isRange(b),E.Range.from),M.Selection=new M("selection","A selection in a text document",b=>t.Selection.isSelection(b),E.Selection.from),M.Number=new M("number","",b=>typeof b=="number",b=>b),M.String=new M("string","",b=>typeof b=="string",b=>b),M.CallHierarchyItem=new M("item","A call hierarchy item",b=>b instanceof t.CallHierarchyItem,E.CallHierarchyItem.from),M.TypeHierarchyItem=new M("item","A type hierarchy item",b=>b instanceof t.TypeHierarchyItem,E.TypeHierarchyItem.from),M.TestItem=new M("testItem","A VS Code TestItem",b=>b instanceof d.TestItemImpl,E.TestItem.from);class r{constructor(g,c){this.description=g,this.convert=c}}e.ApiCommandResult=r,r.Void=new r("no result",b=>b);class n{constructor(g,c,f,v,a){this.id=g,this.internalId=c,this.description=f,this.args=v,this.result=a}}e.ApiCommand=n}),define(Ee[178],ye([0,1,8,7,58,39,16,79]),function(ee,e,s,t,E,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new T.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(s.DocumentHighlight.to))),new T.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,p)=>{if((0,k.isFalsyOrEmpty)(i))return;class o extends t.SymbolInformation{static to(d){const F=new o(d.name,s.SymbolKind.to(d.kind),d.containerName||"",new t.Location(p[0],s.Range.to(d.range)));return F.detail=d.detail,F.range=F.location.range,F.selectionRange=s.Range.to(d.selectionRange),F.children=d.children?d.children.map(o.to):[],F}}return i.map(o.to)})),new T.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(s.TextEdit.to))),new T.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range,new T.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(s.TextEdit.to))),new T.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,new T.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new T.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(s.TextEdit.to))),new T.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new T.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new T.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new T.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new T.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(s.location.to))),new T.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(s.Hover.to))),new T.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(p=>t.Position.isPosition(p)),i=>i.map(s.Position.from))],new T.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(p=>{let o;for(const u of p.reverse())o=new t.SelectionRange(s.Range.to(u),o);return o}))),new T.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[T.ApiCommandArgument.String.with("query","Search string")],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(s.WorkspaceSymbol.to))),new T.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(s.CallHierarchyItem.to))),new T.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(s.CallHierarchyIncomingCall.to))),new T.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(s.CallHierarchyOutgoingCall.to))),new T.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(!!i)return{range:s.Range.to(i.range),placeholder:i.text}})),new T.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("newName","The new symbol name")],new T.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return s.WorkspaceEdit.to(i)}})),new T.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new T.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(s.DocumentLink.to))),new T.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new t.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const p=(0,P.decodeSemanticTokensDto)(i);if(p.type==="full")return new t.SemanticTokens(p.data,void 0)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range.optional()],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new t.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const p=(0,P.decodeSemanticTokensDto)(i);if(p.type==="full")return new t.SemanticTokens(p.data,void 0)})),new T.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new T.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,p,o)=>{if(!i)return new t.CompletionList([]);const u=i.suggestions.map(d=>s.CompletionItem.to(d,o));return new t.CompletionList(u,i.incomplete)})),new T.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new T.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return s.SignatureHelp.to(i)})),new T.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new T.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,p,o)=>R(u=>new t.CodeLens(s.Range.to(u.range),u.command&&o.fromInternal(u.command)))(i))),new T.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>t.Range.isRange(i),i=>t.Selection.isSelection(i)?s.Selection.from(i):s.Range.from(i)),T.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new T.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,p,o)=>R(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(u.command)}else{const d=new t.CodeAction(u.title,u.kind?new t.CodeActionKind(u.kind):void 0);return u.edit&&(d.edit=s.WorkspaceEdit.to(u.edit)),u.command&&(d.command=o.fromInternal(u.command)),d.isPreferred=u.isPreferred,d}})(i))),new T.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(p=>new t.ColorInformation(s.Range.to(p.range),s.Color.to(p.color))):[])),new T.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new T.ApiCommandArgument("color","The color to show and insert",i=>i instanceof t.Color,s.Color.from),new T.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:s.Range.from(i.range)}))],new T.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(s.ColorPresentation.to):[])),new T.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of Inlay objects",i=>i.map(s.InlayHint.to))),new T.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new T.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(p=>s.NotebookExclusiveDocumentPattern.to(p))})))),new T.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(s.InlineValue.to))),new T.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[s.ViewColumn.from(i),void 0]:[s.ViewColumn.from(i.viewColumn),s.TextEditorOpenOptions.from(i)])).optional(),T.ApiCommandArgument.String.with("label","").optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[T.ApiCommandArgument.Uri.with("resource","Resource to open"),T.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[s.ViewColumn.from(i),void 0]:[s.ViewColumn.from(i.viewColumn),s.TextEditorOpenOptions.from(i)])).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[T.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),T.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),T.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[s.ViewColumn.from(i.viewColumn),s.TextEditorOpenOptions.from(i)]).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(s.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(s.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(s.TypeHierarchyItem.to))),new T.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[T.ApiCommandArgument.TestItem],T.ApiCommandResult.Void)];class A{static register(p){C.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=A;function R(i){return p=>{if(Array.isArray(p))return p.map(i)}}function w(i){if(!Array.isArray(i))return;const p=[];for(const o of i)E.isLocationLink(o)?p.push(s.DefinitionLink.to(o)):p.push(s.location.to(o));return p}}),define(Ee[179],ye([0,1,14,53,4,6,2,58,25,8,7,5]),function(ee,e,s,t,E,T,k,P,C,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function i(p,o,u){const d=p.getProxy(w.MainContext.MainThreadComments);class F{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const b=this._commentControllers.get(n.handle);return b||n}else if(n&&n.$mid===7){const b=this._commentControllers.get(n.commentControlHandle);if(!b)return n;const g=b.getCommentThread(n.commentThreadHandle);return g||n}else if(n&&n.$mid===8){const b=this._commentControllers.get(n.thread.commentControlHandle);if(!b)return n;const g=b.getCommentThread(n.thread.commentThreadHandle);return g?{thread:g,text:n.text}:n}else if(n&&n.$mid===9){const b=this._commentControllers.get(n.thread.commentControlHandle);if(!b)return n;const g=b.getCommentThread(n.thread.commentThreadHandle);if(!g)return n;let c=n.commentUniqueId,f=g.getCommentByUniqueId(c);return f||n}else if(n&&n.$mid===10){const b=this._commentControllers.get(n.thread.commentControlHandle);if(!b)return n;const g=b.getCommentThread(n.thread.commentThreadHandle);if(!g)return n;let c=n.text,f=n.commentUniqueId,v=g.getCommentByUniqueId(f);return v?(v.body=c,v):n}return n}})}createCommentController(n,b,g){const c=F.handlePool++,f=new m(n,c,b,g);this._commentControllers.set(f.handle,f);const v=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(n.identifier))||[];return v.push(f),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(n.identifier),v),f.value}$createCommentThreadTemplate(n,b,g){const c=this._commentControllers.get(n);!c||c.$createCommentThreadTemplate(b,g)}async $updateCommentThreadTemplate(n,b,g){const c=this._commentControllers.get(n);!c||c.$updateCommentThreadTemplate(b,g)}$deleteCommentThread(n,b){const g=this._commentControllers.get(n);g&&g.$deleteCommentThread(b)}$provideCommentingRanges(n,b,g){const c=this._commentControllers.get(n);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const f=u.getDocument(k.URI.revive(b));return(0,s.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(f,g)).then(v=>v?v.map(a=>A.Range.from(a)):void 0)}$toggleReaction(n,b,g,c,f){const v=this._commentControllers.get(n);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,s.asPromise)(()=>{const a=v.getCommentThread(b);if(a){const S=a.getCommentByUniqueId(c.uniqueIdInThread);if(v!==void 0&&S&&v.reactionHandler)return v.reactionHandler(S,l(f))}return Promise.resolve(void 0)})}dispose(){}}F.handlePool=0;class _{constructor(n,b,g,c,f,v,a){this._commentControllerHandle=b,this._id=g,this._uri=c,this._range=f,this._comments=v,this.handle=_._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),d.$createCommentThread(b,this.handle,this._id,this._uri,A.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(b,this.handle)}});const S=this;this.value={get uri(){return S.uri},get range(){return S.range},set range(I){S.range=I},get comments(){return S.comments},set comments(I){S.comments=I},get collapsibleState(){return S.collapsibleState},set collapsibleState(I){S.collapsibleState=I},get canReply(){return S.canReply},set canReply(I){S.canReply=I},get contextValue(){return S.contextValue},set contextValue(I){S.contextValue=I},get label(){return S.label},set label(I){S.label=I},dispose:()=>{S.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const n=g=>Object.prototype.hasOwnProperty.call(this.modifications,g),b={};n("range")&&(b.range=A.Range.from(this._range)),n("label")&&(b.label=this.label),n("contextValue")&&(b.contextValue=this.contextValue??null),n("comments")&&(b.comments=this._comments.map(g=>h(this,g,this._commentsMap))),n("collapsibleState")&&(b.collapseState=M(this._collapseState)),n("canReply")&&(b.canReply=this.canReply),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,b)}getCommentByUniqueId(n){for(let b of this._commentsMap){let g=b[0],c=b[1];if(n===c)return g}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}_._handlePool=0,Be([(0,t.debounce)(100)],_.prototype,"eventuallyUpdateCommentThread",null);class m{constructor(n,b,g,c){this._extension=n,this._handle=b,this._id=g,this._label=c,this._threads=new Map,d.$registerCommentController(this.handle,g,c);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(v){f.options=v},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(v){f.commentingRangeProvider=v},get reactionHandler(){return f.reactionHandler},set reactionHandler(v){f.reactionHandler=v},createCommentThread(v,a,S){return f.createCommentThread(v,a,S).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,b,g,c){if(typeof n=="string"){const f=new _(this.id,this.handle,n,b,g,c,this._extension.identifier);return this._threads.set(f.handle,f),f}else{const f=new _(this.id,this.handle,void 0,n,b,g,this._extension.identifier);return this._threads.set(f.handle,f),f}}$createCommentThreadTemplate(n,b){const g=new _(this.id,this.handle,void 0,k.URI.revive(n),A.Range.to(b),[],this._extension.identifier);return g.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(g.handle,g),g}$updateCommentThreadTemplate(n,b){let g=this._threads.get(n);g&&(g.range=A.Range.to(b))}$deleteCommentThread(n){let b=this._threads.get(n);b&&b.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function h(r,n,b){let g=b.get(n);g||(g=++r.commentHandle,b.set(n,g));const c=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:g,body:A.MarkdownString.from(n.body),userName:n.author.name,userIconPath:c,label:n.label,commentReactions:n.reactions?n.reactions.map(f=>D(f)):void 0}}function D(r){return{label:r.label,iconPath:r.iconPath?A.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function l(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?k.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function M(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}return new F}e.createExtHostComments=i}),define(Ee[93],ye([0,1,2,5,7,3,13,12,16,9,17]),function(ee,e,s,t,E,T,k,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let w=class wi{constructor(p,o){this._logService=o,this._provider=new Map,this._proxy=p.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,o){const u=wi._handlePool++;this._provider.set(u,{provider:p,extensionId:o}),this._proxy.$registerDecorationProvider(u,o.value);const d=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(F=>{if(!F){this._proxy.$onDidChange(u,null);return}let _=(0,C.asArray)(F);if(_.length<=wi._maxEventSize){this._proxy.$onDidChange(u,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,_.length);const m=_.map(l=>({uri:l,rank:(0,A.count)(l.path,"/")})),h=(0,C.groupBy)(m,(l,M)=>l.rank-M.rank||(0,A.compare)(l.uri.path,M.uri.path));let D=[];e:for(let l of h){let M;for(let r of l){let n=(0,R.dirname)(r.uri.path);if(M!==n&&(M=n,D.push(r.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(u,D)});return new E.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(p,o,u){if(!this._provider.has(p))return Object.create(null);const d=Object.create(null),{provider:F,extensionId:_}=this._provider.get(p);return await Promise.all(o.map(async m=>{try{const{uri:h,id:D}=m,l=await Promise.resolve(F.provideFileDecoration(s.URI.revive(h),u));if(!l)return;try{E.FileDecoration.validate(l),d[D]=[l.propagate,l.tooltip,l.badge,l.color]}catch(M){this._logService.warn(`INVALID decoration from extension '${_.value}': ${M}`)}}catch(h){this._logService.error(h)}})),d}};w._handlePool=0,w._maxEventSize=250,w=Be([$e(0,k.IExtHostRpcService),$e(1,P.ILogService)],w),e.ExtHostDecorations=w,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(ee,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!E:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(ee,s):E?E.value=s:e.set(ee,s),s},ke=this&&this.__classPrivateFieldGet||function(ee,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(ee):t?t.value:e.get(ee)};define(Ee[180],ye([0,1,118,82,2,5,7,8,4,12,21,30]),function(ee,e,s,t,E,T,k,P,C,A,R,w){"use strict";var i,p,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class u{constructor(_,m,h,D,l,M){this._name=_,this._owner=m,this._maxDiagnosticsPerFile=h,i.set(this,void 0),p.set(this,void 0),o.set(this,void 0),this._isDisposed=!1,Ze(this,o,new R.ResourceMap(r=>D.getComparisonKey(r)),"f"),Ze(this,i,l,"f"),Ze(this,p,M,"f")}dispose(){this._isDisposed||(ke(this,p,"f").fire([...ke(this,o,"f").keys()]),ke(this,i,"f")&&ke(this,i,"f").$clear(this._owner),ke(this,o,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(_,m){if(!_){this.clear();return}this._checkDisposed();let h=[];if(E.URI.isUri(_)){if(!m){this.delete(_);return}ke(this,o,"f").set(_,m.slice()),h=[_]}else if(Array.isArray(_)){h=[];let l;_=[..._].sort(u._compareIndexedTuplesByUri);for(const M of _){const[r,n]=M;if((!l||r.toString()!==l.toString())&&(l&&ke(this,o,"f").get(l).length===0&&ke(this,o,"f").delete(l),l=r,h.push(r),ke(this,o,"f").set(r,[])),n){const b=ke(this,o,"f").get(r);b&&b.push(...n)}else{const b=ke(this,o,"f").get(r);b&&(b.length=0)}}}if(ke(this,p,"f").fire(h),!ke(this,i,"f"))return;const D=[];for(let l of h){let M=[];const r=ke(this,o,"f").get(l);if(r)if(r.length>this._maxDiagnosticsPerFile){M=[];const n=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let b=0;b<4;b++)for(let g of r)if(g.severity===n[b]&&M.push(P.Diagnostic.from(g))===this._maxDiagnosticsPerFile)break e;M.push({severity:t.MarkerSeverity.Info,message:(0,s.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:M[M.length-1].startLineNumber,startColumn:M[M.length-1].startColumn,endLineNumber:M[M.length-1].endLineNumber,endColumn:M[M.length-1].endColumn})}else M=r.map(n=>P.Diagnostic.from(n));D.push([l,M])}ke(this,i,"f").$changeMany(this._owner,D)}delete(_){this._checkDisposed(),ke(this,p,"f").fire([_]),ke(this,o,"f").delete(_),ke(this,i,"f")&&ke(this,i,"f").$changeMany(this._owner,[[_,void 0]])}clear(){this._checkDisposed(),ke(this,p,"f").fire([...ke(this,o,"f").keys()]),ke(this,o,"f").clear(),ke(this,i,"f")&&ke(this,i,"f").$clear(this._owner)}forEach(_,m){this._checkDisposed();for(let h of ke(this,o,"f").keys())_.apply(m,[h,this.get(h),this])}get(_){this._checkDisposed();const m=ke(this,o,"f").get(_);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(_){return this._checkDisposed(),Array.isArray(ke(this,o,"f").get(_))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(_,m){return _[0].toString()<m[0].toString()?-1:_[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=u,i=new WeakMap,p=new WeakMap,o=new WeakMap;let d=class oi{constructor(_,m,h){this._logService=m,this._fileSystemInfoService=h,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:D=>D.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=_.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(_){const m=new R.ResourceMap;for(const h of _)m.set(h,h);return{uris:Object.freeze(Array.from(m.values()))}}createDiagnosticCollection(_,m){const{_collections:h,_proxy:D,_onDidChangeDiagnostics:l,_logService:M,_fileSystemInfoService:r}=this,n=new class{$changeMany(c,f){D.$changeMany(c,f),M.trace("[DiagnosticCollection] change many (extension, owner, uris)",_.value,c,f.length===0?"CLEARING":f)}$clear(c){D.$clear(c),M.trace("[DiagnosticCollection] remove all (extension, owner)",_.value,c)}dispose(){D.dispose()}};let b;if(!m)m="_generated_diagnostic_collection_name_#"+oi._idPool++,b=m;else if(!h.has(m))b=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do b=m+oi._idPool++;while(h.has(b))}return new class extends u{constructor(){super(m,b,oi._maxDiagnosticsPerFile,r.extUri,n,l);h.set(b,this)}dispose(){super.dispose(),h.delete(b)}}}getDiagnostics(_){if(_)return this._getDiagnostics(_);{const m=new Map,h=[];for(const D of this._collections.values())D.forEach((l,M)=>{let r=m.get(l.toString());typeof r=="undefined"&&(r=h.length,m.set(l.toString(),r),h.push([l,[]])),h[r][1]=h[r][1].concat(...M)});return h}}_getDiagnostics(_){let m=[];for(let h of this._collections.values())h.has(_)&&(m=m.concat(h.get(_)));return m}$acceptMarkersChange(_){if(!this._mirrorCollection){const m="_generated_mirror",h=new u(m,m,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(m,h),this._mirrorCollection=h}for(const[m,h]of _)this._mirrorCollection.set(E.URI.revive(m),h.map(P.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=Be([$e(1,A.ILogService),$e(2,w.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(Ee[181],ye([0,1,2,5]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(k){this._proxy=k.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(P=>P?P.map(C=>s.URI.revive(C)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(P=>P?s.URI.revive(P):void 0)}}e.ExtHostDialogs=E}),define(Ee[182],ye([0,1,15,2,7,5,11,20,9]),function(ee,e,s,t,E,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(w,i,p){this._documentsAndEditors=i,this._logService=p,this._documentContentProviders=new Map,this._proxy=w.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,i){if(Object.keys(k.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const p=A._handlePool++;this._documentContentProviders.set(p,i),this._proxy.$registerTextContentProvider(p,w);let o;return typeof i.onDidChange=="function"&&(o=i.onDidChange(u=>{if(u.scheme!==w){this._logService.warn(`Provider for scheme '${w}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(p,u).then(d=>{if(!d&&typeof d!="string")return;const F=this._documentsAndEditors.getDocument(u);if(!F)return;const _=(0,C.splitLines)(d);if(!F.equalLines(_))return this._proxy.$onVirtualDocumentChange(u,d)},s.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(w,i){const p=this._documentContentProviders.get(w);return p?Promise.resolve(p.provideTextDocumentContent(t.URI.revive(i),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${i.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(Ee[183],ye([0,1,4,6,2,5,86,8,10,26,7]),function(ee,e,s,t,E,T,k,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(p,o){this._onDidAddDocument=new s.Emitter,this._onDidRemoveDocument=new s.Emitter,this._onDidChangeDocument=new s.Emitter,this._onDidSaveDocument=new s.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const d of u)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const d of u)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const o=this._documentsAndEditors.getDocument(p);if(o)return o}getDocument(p){const o=this.getDocumentData(p);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return o.document}ensureDocumentData(p){const o=this._documentsAndEditors.getDocument(p);if(o)return Promise.resolve(o);let u=this._documentLoader.get(p.toString());return u||(u=this._proxy.$tryOpenDocument(p).then(d=>{this._documentLoader.delete(p.toString());const F=E.URI.revive(d);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(F))},d=>(this._documentLoader.delete(p.toString()),Promise.reject(d))),this._documentLoader.set(p.toString(),u)),u}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(o=>E.URI.revive(o))}$acceptModelLanguageChanged(p,o){const u=E.URI.revive(p),d=this._documentsAndEditors.getDocument(u);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(o),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(p){const o=E.URI.revive(p),u=this._documentsAndEditors.getDocument(o);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(p,o){const u=E.URI.revive(p),d=this._documentsAndEditors.getDocument(u);if(!d)throw new Error("unknown document");d._acceptIsDirty(o),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,o,u){const d=E.URI.revive(p),F=this._documentsAndEditors.getDocument(d);if(!F)throw new Error("unknown document");F._acceptIsDirty(u),F.onEvents(o);let _;o.isUndoing?_=R.TextDocumentChangeReason.Undo:o.isRedoing&&(_=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:F.document,contentChanges:o.changes.map(m=>({range:P.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:_}))}setWordDefinitionFor(p,o){(0,k.setWordDefinitionFor)(p,o)}}e.ExtHostDocuments=w}),define(Ee[49],ye([0,1,42,4,6,2,3,5,86,13,92,8,12,21,11,157,228]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class F{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(h,D){this._extHostRpc=h,this._logService=D,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const D=[],l=[],M=[];if(h.removedDocuments)for(const r of h.removedDocuments){const n=T.URI.revive(r),b=this._documents.get(n);b?.unref()&&(this._documents.delete(n),D.push(b.value))}if(h.addedDocuments)for(const r of h.addedDocuments){const n=T.URI.revive(r.uri);let b=this._documents.get(n);if(b&&n.scheme!==o.Schemas.vscodeNotebookCell&&n.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);b||(b=new F(new C.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),n,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(n,b),l.push(b.value)),b.ref()}if(h.removedEditors)for(const r of h.removedEditors){const n=this._editors.get(r);this._editors.delete(r),n&&M.push(n)}if(h.addedEditors)for(const r of h.addedEditors){const n=T.URI.revive(r.documentUri);s.ok(this._documents.has(n),`document '${n}' does not exist`),s.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const b=this._documents.get(n).value,g=new R.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>b.document),r.selections.map(w.Selection.to),r.options,r.visibleRanges.map(c=>w.Range.to(c)),typeof r.editorPosition=="number"?w.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,g)}h.newActiveEditor!==void 0&&(s.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,E.dispose)(D),(0,E.dispose)(M),h.removedDocuments&&this._onDidRemoveDocuments.fire(D),h.addedDocuments&&this._onDidAddDocuments.fire(l),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const D=this._editors.get(this._activeEditorId);return h?D:D?.value}allEditors(){return[...this._editors.values()]}};_=Be([$e(0,A.IExtHostRpcService),$e(1,i.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[70],ye([0,1,8,5,2,4,3,13,14]),function(ee,e,s,t,E,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");let A=class{constructor(w){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new T.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=w.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(w){let i=-1;this._tabs=w.map((o,u)=>(o.isActive&&(i=u),Object.freeze({label:o.label,viewColumn:s.ViewColumn.to(o.viewColumn),index:u,resource:E.URI.revive(o.resource),additionalResourcesAndViewIds:o.additionalResourcesAndViewIds.map(({resource:d,viewId:F})=>({resource:E.URI.revive(d),viewId:F})),viewId:o.editorId,isActive:o.isActive,move:async(d,F)=>{this._proxy.$moveTab(o,d,s.ViewColumn.from(F)),await(0,C.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(o),await(0,C.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((o,u)=>o.viewColumn===u.viewColumn?o.index-u.index:o.viewColumn-u.viewColumn);const p=this._activeTab;this._activeTab=i===-1?void 0:this._tabs[i],this._activeTab!==p&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};A=Be([$e(0,P.IExtHostRpcService)],A),e.ExtHostEditorTabs=A}),define(Ee[184],ye([0,1,2,5,6,7,8,229,9,22,27]),function(ee,e,s,t,E,T,k,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this._schemes=[]}add(o){this._stateMachine=void 0,this._schemes.push(o)}delete(o){const u=this._schemes.indexOf(o);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const o=this._schemes.sort(),u=[];let d,F,_=14,m=14;for(const h of o){let D=d?(0,C.commonPrefixLength)(d,h):0;for(D===0?F=1:F=m;D<h.length;D++)D+1===h.length?(_=m,m=9):m+=1,u.push([F,h.toUpperCase().charCodeAt(D),m]),u.push([F,h.toLowerCase().charCodeAt(D),m]),F=m;d=h,m=_}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new P.StateMachine(u)}}provideDocumentLinks(o){this._initStateMachine();const u=[],d=P.LinkComputer.computeLinks({getLineContent(F){return o.lineAt(F-1).text},getLineCount(){return o.lineCount}},this._stateMachine);for(const F of d){const _=k.DocumentLink.to(F);_.target&&u.push(_)}return u}}class i{constructor(o,u){this._extHostLanguageFeatures=u,this._linkProvider=new w,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=o.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(o,u,d,F={}){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const _=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(_,d);let m=2;F.isCaseSensitive&&(m+=1024),F.isReadonly&&(m+=2048),typeof d.copy=="function"&&(m+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,R.checkProposedApiEnabled)(o,"fsChunks"),m+=4),this._proxy.$registerFileSystemProvider(_,u,m).catch(D=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${u}`),console.error(D)});const h=d.onDidChangeFile(D=>{const l=[];for(const M of D){let{uri:r,type:n}=M;if(r.scheme!==u)continue;let b;switch(n){case T.FileChangeType.Changed:b=0;break;case T.FileChangeType.Created:b=1;break;case T.FileChangeType.Deleted:b=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:r,type:b})}this._proxy.$onFileSystemChange(_,l)});return(0,E.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(_),this._proxy.$unregisterProvider(_)})}static _asIStat(o){const{type:u,ctime:d,mtime:F,size:_,permissions:m}=o;return{type:u,ctime:d,mtime:F,size:_,permissions:m}}$stat(o,u){return Promise.resolve(this._getFsProvider(o).stat(s.URI.revive(u))).then(d=>i._asIStat(d))}$readdir(o,u){return Promise.resolve(this._getFsProvider(o).readDirectory(s.URI.revive(u)))}$readFile(o,u){return Promise.resolve(this._getFsProvider(o).readFile(s.URI.revive(u))).then(d=>A.VSBuffer.wrap(d))}$writeFile(o,u,d,F){return Promise.resolve(this._getFsProvider(o).writeFile(s.URI.revive(u),d.buffer,F))}$delete(o,u,d){return Promise.resolve(this._getFsProvider(o).delete(s.URI.revive(u),d))}$rename(o,u,d,F){return Promise.resolve(this._getFsProvider(o).rename(s.URI.revive(u),s.URI.revive(d),F))}$copy(o,u,d,F){const _=this._getFsProvider(o);if(!_.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(_.copy(s.URI.revive(u),s.URI.revive(d),F))}$mkdir(o,u){return Promise.resolve(this._getFsProvider(o).createDirectory(s.URI.revive(u)))}$watch(o,u,d,F){const _=this._getFsProvider(o).watch(s.URI.revive(d),F);this._watches.set(u,_)}$unwatch(o,u){const d=this._watches.get(u);d&&(d.dispose(),this._watches.delete(u))}$open(o,u,d){const F=this._getFsProvider(o);if(!F.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(F.open(s.URI.revive(u),d))}$close(o,u){const d=this._getFsProvider(o);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(u))}$read(o,u,d,F){const _=this._getFsProvider(o);if(!_.read)throw new Error('FileSystemProvider does not implement "read"');const m=A.VSBuffer.alloc(F);return Promise.resolve(_.read(u,d,m.buffer,0,F)).then(h=>m.slice(0,h))}$write(o,u,d,F){const _=this._getFsProvider(o);if(!_.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(_.write(u,d,F.buffer,0,F.byteLength))}_getFsProvider(o){const u=this._fsProvider.get(o);if(!u){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return u}}e.ExtHostFileSystem=i}),define(Ee[50],ye([0,1,5,46,7,22,3,13,30,6]),function(ee,e,s,t,E,T,k,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Ht{constructor(i,p){this._fileSystemProvider=new Map,this._proxy=i.getProxy(s.MainContext.MainThreadFileSystem);const o=this;this.value=Object.freeze({async stat(u){try{const d=o._fileSystemProvider.get(u.scheme);if(!d)return await o._proxy.$stat(u);await o._proxy.$ensureActivation(u.scheme);const F=await d.stat(u);return{type:F.type,ctime:F.ctime,mtime:F.mtime,size:F.size,permissions:F.permissions}}catch(d){Ht._handleError(d)}},async readDirectory(u){try{const d=o._fileSystemProvider.get(u.scheme);return d?(await o._proxy.$ensureActivation(u.scheme),(await d.readDirectory(u)).slice()):await o._proxy.$readdir(u)}catch(d){return Ht._handleError(d)}},async createDirectory(u){try{return await o._proxy.$mkdir(u)}catch(d){return Ht._handleError(d)}},async readFile(u){try{const d=o._fileSystemProvider.get(u.scheme);return d?(await o._proxy.$ensureActivation(u.scheme),(await d.readFile(u)).slice()):(await o._proxy.$readFile(u)).buffer}catch(d){return Ht._handleError(d)}},async writeFile(u,d){try{return await o._proxy.$writeFile(u,T.VSBuffer.wrap(d))}catch(F){return Ht._handleError(F)}},async delete(u,d){try{const F=o._fileSystemProvider.get(u.scheme);return F?(await o._proxy.$ensureActivation(u.scheme),await F.delete(u,{recursive:!1,...d})):await o._proxy.$delete(u,{recursive:!1,useTrash:!1,...d})}catch(F){return Ht._handleError(F)}},async rename(u,d,F){try{return await o._proxy.$rename(u,d,{overwrite:!1,...F})}catch(_){return Ht._handleError(_)}},async copy(u,d,F){try{return await o._proxy.$copy(u,d,{overwrite:!1,...F})}catch(_){return Ht._handleError(_)}},isWritableFileSystem(u){const d=p.getCapabilities(u);if(typeof d=="number")return!(d&2048)}})}static _handleError(i){if(i instanceof E.FileSystemError)throw i;if(!(i instanceof Error))throw new E.FileSystemError(String(i));if(i.name==="ENOPRO")throw E.FileSystemError.Unavailable(i.message);switch(i.name){case t.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(i.message);case t.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(i.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(i.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(i.message);case t.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(i.message);case t.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(i.message);default:throw new E.FileSystemError(i.message,i.name)}}addFileSystemProvider(i,p){return this._fileSystemProvider.set(i,p),(0,A.toDisposable)(()=>this._fileSystemProvider.delete(i))}};R=Be([$e(0,P.IExtHostRpcService),$e(1,C.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[185],ye([0,1,2,39]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(k,P,C,A){this._extHostNotebooks=P,this._textDocumentsAndEditors=C,this._commands=A;const R=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",w=>!0,w=>w),new t.ApiCommandArgument("resource","Interactive resource Uri",w=>!0,w=>w),new t.ApiCommandArgument("controllerId","Notebook controller Id",w=>!0,w=>w),new t.ApiCommandArgument("title","Interactive editor title",w=>!0,w=>w)],new t.ApiCommandResult("Notebook and input URI",w=>{if(w.notebookEditorId!==void 0){const i=this._extHostNotebooks.getEditorById(w.notebookEditorId);return{notebookUri:s.URI.revive(w.notebookUri),inputUri:s.URI.revive(w.inputUri),notebookEditor:i.apiEditor}}return{notebookUri:s.URI.revive(w.notebookUri),inputUri:s.URI.revive(w.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(k,P,C,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:C,uri:k,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(s.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(k,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[k]})}}e.ExtHostInteractive=E}),define(Ee[186],ye([0,1,6,5]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(k){this._handlePool=0,this._proxy=k.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,k),(0,s.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=E}),define(Ee[187],ye([0,1,2,26,8,7,5,9,59,16,10,230,6,79,54,63,188,15,4]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentSymbols(H,K){const X=this._documents.getDocument(H),se=await this._provider.provideDocumentSymbols(X,K);if(!(0,A.isFalsyOrEmpty)(se))return se[0]instanceof T.DocumentSymbol?se.map(E.DocumentSymbol.from):m._asDocumentSymbolTree(se)}static _asDocumentSymbolTree(H){H=H.slice(0).sort((se,q)=>{let te=se.location.range.start.compareTo(q.location.range.start);return te===0&&(te=q.location.range.end.compareTo(se.location.range.end)),te});const K=[],X=[];for(const se of H){const q={name:se.name||"!!MISSING: name!!",kind:E.SymbolKind.from(se.kind),tags:se.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:E.Range.from(se.location.range),selectionRange:E.Range.from(se.location.range),children:[]};for(;;){if(X.length===0){X.push(q),K.push(q);break}const te=X[X.length-1];if(C.Range.containsRange(te.range,q.range)&&!C.Range.equalsRange(te.range,q.range)){te.children&&te.children.push(q),X.push(q);break}X.pop()}}return K}}class h{constructor(H,K,X){this._documents=H,this._commands=K,this._provider=X,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,K){const X=this._documents.getDocument(H),se=await this._provider.provideCodeLenses(X,K);if(!se||K.isCancellationRequested)return;const q=this._cache.add(se),te=new i.DisposableStore;this._disposables.set(q,te);const he={cacheId:q,lenses:[]};for(let Ae=0;Ae<se.length;Ae++)he.lenses.push({cacheId:[q,Ae],range:E.Range.from(se[Ae].range),command:this._commands.toInternal(se[Ae].command,te)});return he}async resolveCodeLens(H,K){const X=H.cacheId&&this._cache.get(...H.cacheId);if(!X)return;let se;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?se=X:se=await this._provider.resolveCodeLens(X,K),se||(se=X),K.isCancellationRequested)return;const q=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!q)return H.command=this._commands.toInternal(se.command??h._badCmd,q),H}releaseCodeLenses(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function D(Qe){return Array.isArray(Qe)?Qe.map(E.DefinitionLink.from):Qe?[E.DefinitionLink.from(Qe)]:[]}class l{constructor(H,K){this._documents=H,this._provider=K}async provideDefinition(H,K,X){const se=this._documents.getDocument(H),q=E.Position.to(K),te=await this._provider.provideDefinition(se,q,X);return D(te)}}class M{constructor(H,K){this._documents=H,this._provider=K}async provideDeclaration(H,K,X){const se=this._documents.getDocument(H),q=E.Position.to(K),te=await this._provider.provideDeclaration(se,q,X);return D(te)}}class r{constructor(H,K){this._documents=H,this._provider=K}async provideImplementation(H,K,X){const se=this._documents.getDocument(H),q=E.Position.to(K),te=await this._provider.provideImplementation(se,q,X);return D(te)}}class n{constructor(H,K){this._documents=H,this._provider=K}async provideTypeDefinition(H,K,X){const se=this._documents.getDocument(H),q=E.Position.to(K),te=await this._provider.provideTypeDefinition(se,q,X);return D(te)}}class b{constructor(H,K){this._documents=H,this._provider=K}async provideHover(H,K,X){const se=this._documents.getDocument(H),q=E.Position.to(K),te=await this._provider.provideHover(se,q,X);if(!(!te||(0,A.isFalsyOrEmpty)(te.contents)))return te.range||(te.range=se.getWordRangeAtPosition(q)),te.range||(te.range=new T.Range(q,q)),E.Hover.from(te)}}class g{constructor(H,K){this._documents=H,this._provider=K}async provideEvaluatableExpression(H,K,X){const se=this._documents.getDocument(H),q=E.Position.to(K),te=await this._provider.provideEvaluatableExpression(se,q,X);if(te)return E.EvaluatableExpression.from(te)}}class c{constructor(H,K){this._documents=H,this._provider=K}async provideInlineValues(H,K,X,se){const q=this._documents.getDocument(H),te=await this._provider.provideInlineValues(q,E.Range.to(K),E.InlineValueContext.to(X),se);if(Array.isArray(te))return te.map(he=>E.InlineValue.from(he))}}class f{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentHighlights(H,K,X){const se=this._documents.getDocument(H),q=E.Position.to(K),te=await this._provider.provideDocumentHighlights(se,q,X);if(Array.isArray(te))return te.map(E.DocumentHighlight.from)}}class v{constructor(H,K){this._documents=H,this._provider=K}async provideLinkedEditingRanges(H,K,X){const se=this._documents.getDocument(H),q=E.Position.to(K),te=await this._provider.provideLinkedEditingRanges(se,q,X);if(te&&Array.isArray(te.ranges))return{ranges:(0,A.coalesce)(te.ranges.map(E.Range.from)),wordPattern:te.wordPattern}}}class a{constructor(H,K){this._documents=H,this._provider=K}async provideReferences(H,K,X,se){const q=this._documents.getDocument(H),te=E.Position.to(K),he=await this._provider.provideReferences(q,te,X,se);if(Array.isArray(he))return he.map(E.location.from)}}class S{constructor(H,K,X,se,q,te,he){this._documents=H,this._commands=K,this._diagnostics=X,this._provider=se,this._logService=q,this._extension=te,this._apiDeprecation=he,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(H,K,X,se){const q=this._documents.getDocument(H),te=w.Selection.isISelection(K)?E.Selection.to(K):E.Range.to(K),he=[];for(const st of this._diagnostics.getDiagnostics(H))if(te.intersection(st.range)&&he.push(st)>S._maxCodeActionsPerFile)break;const Ae={diagnostics:he,only:X.only?new T.CodeActionKind(X.only):void 0,triggerKind:E.CodeActionTriggerKind.to(X.trigger)},Ue=await this._provider.provideCodeActions(q,te,Ae,se);if(!(0,A.isNonEmptyArray)(Ue)||se.isCancellationRequested)return;const ze=this._cache.add(Ue),Ge=new i.DisposableStore;this._disposables.set(ze,Ge);const et=[];for(let st=0;st<Ue.length;st++){const Xe=Ue[st];!Xe||(S._isCommand(Xe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Xe.title,command:this._commands.toInternal(Xe,Ge)})):(Ae.only&&(Xe.kind?Ae.only.contains(Xe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[ze,st],title:Xe.title,command:Xe.command&&this._commands.toInternal(Xe.command,Ge),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(E.Diagnostic.from),edit:Xe.edit&&E.WorkspaceEdit.from(Xe.edit),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:ze,actions:et}}async resolveCodeAction(H,K){const[X,se]=H,q=this._cache.get(X,se);if(!q||S._isCommand(q)||!this._provider.resolveCodeAction)return;const te=await this._provider.resolveCodeAction(q,K)??q;return te?.edit?E.WorkspaceEdit.from(te.edit):void 0}releaseCodeActions(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}S._maxCodeActionsPerFile=1e3;class I{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentFormattingEdits(H,K,X){const se=this._documents.getDocument(H),q=await this._provider.provideDocumentFormattingEdits(se,K,X);if(Array.isArray(q))return q.map(E.TextEdit.from)}}class N{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentRangeFormattingEdits(H,K,X,se){const q=this._documents.getDocument(H),te=E.Range.to(K),he=await this._provider.provideDocumentRangeFormattingEdits(q,te,X,se);if(Array.isArray(he))return he.map(E.TextEdit.from)}}class B{constructor(H,K){this._documents=H,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,K,X,se,q){const te=this._documents.getDocument(H),he=E.Position.to(K),Ae=await this._provider.provideOnTypeFormattingEdits(te,he,X,se,q);if(Array.isArray(Ae))return Ae.map(E.TextEdit.from)}}class y{constructor(H,K){this._provider=H,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(H,K){const X=k.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols(H,K);if((0,A.isNonEmptyArray)(se))for(const q of se){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const te=k.IdObject.mixin(E.WorkspaceSymbol.from(q));this._symbolCache.set(te._id,q),X.symbols.push(te)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol(H,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return H;const X=this._symbolCache.get(H._id);if(X){const se=await this._provider.resolveWorkspaceSymbol(X,K);return se&&(0,t.mixin)(H,E.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(H){const K=this._resultCache.get(H);if(K){for(let[X,se]=K;X<=se;X++)this._symbolCache.delete(X);this._resultCache.delete(H)}}}class O{constructor(H,K,X){this._documents=H,this._provider=K,this._logService=X}static supportsResolving(H){return typeof H.prepareRename=="function"}async provideRenameEdits(H,K,X,se){const q=this._documents.getDocument(H),te=E.Position.to(K);try{const he=await this._provider.provideRenameEdits(q,te,X,se);return he?E.WorkspaceEdit.from(he):void 0}catch(he){const Ae=O._asMessage(he);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(H,K,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(H),q=E.Position.to(K);try{const te=await this._provider.prepareRename(se,q,X);let he,Ae;if(T.Range.isRange(te)?(he=te,Ae=se.getText(te)):(0,R.isObject)(te)&&(he=te.range,Ae=te.placeholder),!he||!Ae)return;if(he.start.line>q.line||he.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(he),text:Ae}}catch(te){const he=O._asMessage(te);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(te)}}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class z{constructor(H,K){this.resultId=H,this.tokens=K}}class U{constructor(H,K){this._documents=H,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(H,K,X){const se=this._documents.getDocument(H),q=K!==0?this._previousResults.get(K):null;let te=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,q.resultId,X):await this._provider.provideDocumentSemanticTokens(se,X);return q&&this._previousResults.delete(K),te?(te=U._fixProvidedSemanticTokens(te),this._send(U._convertToEdits(q,te),te)):null}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return U._isSemanticTokens(H)?U._isCorrectSemanticTokens(H)?H:new T.SemanticTokens(new Uint32Array(H.data),H.resultId):U._isSemanticTokensEdits(H)?U._isCorrectSemanticTokensEdits(H)?H:new T.SemanticTokensEdits(H.edits.map(K=>new T.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const K of H.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,K){if(!U._isSemanticTokens(K)||!H||!H.tokens)return K;const X=H.tokens,se=X.length,q=K.data,te=q.length;let he=0;const Ae=Math.min(se,te);for(;he<Ae&&X[he]===q[he];)he++;if(he===se&&he===te)return new T.SemanticTokensEdits([],K.resultId);let Ue=0;const ze=Ae-he;for(;Ue<ze&&X[se-Ue-1]===q[te-Ue-1];)Ue++;return new T.SemanticTokensEdits([{start:he,deleteCount:se-he-Ue,data:q.subarray(he,te-Ue)}],K.resultId)}_send(H,K){if(U._isSemanticTokens(H)){const X=this._nextResultId++;return this._previousResults.set(X,new z(H.resultId,H.data)),(0,p.encodeSemanticTokensDto)({id:X,type:"full",data:H.data})}if(U._isSemanticTokensEdits(H)){const X=this._nextResultId++;return U._isSemanticTokens(K)?this._previousResults.set(X,new z(K.resultId,K.data)):this._previousResults.set(X,new z(H.resultId)),(0,p.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(H.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class ${constructor(H,K){this._documents=H,this._provider=K}async provideDocumentRangeSemanticTokens(H,K,X){const se=this._documents.getDocument(H),q=await this._provider.provideDocumentRangeSemanticTokens(se,E.Range.to(K),X);return q?this._send(q):null}_send(H){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=$;class W{constructor(H,K,X,se,q){this._documents=H,this._commands=K,this._provider=X,this._apiDeprecation=se,this._extension=q,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,K,X,se){const q=this._documents.getDocument(H),te=E.Position.to(K),he=q.getWordRangeAtPosition(te)||new T.Range(te,te),Ae=he.with({end:te}),Ue=new d.StopWatch(!0),ze=await this._provider.provideCompletionItems(q,te,se,E.CompletionContext.to(X));if(!ze||se.isCancellationRequested)return;const Ge=Array.isArray(ze)?new T.CompletionList(ze):ze,et=W.supportsResolving(this._provider)?this._cache.add(Ge.items):this._cache.add([]),st=new i.DisposableStore;this._disposables.set(et,st);const Xe=[],nt={x:et,b:Xe,a:{replace:E.Range.from(he),insert:E.Range.from(Ae)},c:Ge.isIncomplete||void 0,d:Ue.elapsed()};for(let lt=0;lt<Ge.items.length;lt++){const vt=Ge.items[lt],Oe=this._convertCompletionItem(vt,[et,lt],Ae,he);Xe.push(Oe)}return nt}async resolveCompletionItem(H,K){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...H);if(!X)return;const se=await this._provider.resolveCompletionItem(X,K);if(!!se)return this._convertCompletionItem(se,H)}releaseCompletionItems(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,K,X,se){const q=this._disposables.get(K[0]);if(!q)throw Error("DisposableStore is missing...");const te={x:K,a:H.label,b:H.kind!==void 0?E.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(E.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(H.command,q)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),te.h=H.textEdit.newText):typeof H.insertText=="string"?te.h=H.insertText:H.insertText instanceof T.SnippetString&&(te.h=H.insertText.value,te.i|=4);let he;return H.textEdit?he=H.textEdit.range:H.range&&(he=H.range),T.Range.isRange(he)?te.j=E.Range.from(he):he&&(!X?.isEqual(he.inserting)||!se?.isEqual(he.replacing))&&(te.j={insert:E.Range.from(he.inserting),replace:E.Range.from(he.replacing)}),te}}class J{constructor(H,K,X){this._documents=H,this._provider=K,this._commands=X,this._cache=new u.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(H,K,X,se){const q=this._documents.getDocument(H),te=E.Position.to(K),he=await this._provider.provideInlineCompletionItems(q,te,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:E.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text,isSnippetText:X.selectedSuggestionInfo.isSnippetText,completionKind:E.CompletionItemKind.to(X.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:X.triggerKind},se);if(!he||se.isCancellationRequested)return;const Ae=(0,R.isArray)(he)?{items:he}:he,Ue=this._cache.add(Ae.items);let ze;return{pid:Ue,items:Ae.items.map((Ge,et)=>{let st;return Ge.command&&(ze||(ze=new i.DisposableStore,this._disposables.set(Ue,ze)),st=this._commands.toInternal(Ge.command,ze)),{text:Ge.text,range:Ge.range?E.Range.from(Ge.range):void 0,command:st,idx:et}})}}disposeCompletions(H){this._cache.delete(H);const K=this._disposables.get(H);K&&K.clear(),this._disposables.delete(H)}handleDidShowCompletionItem(H,K){const X=this._cache.get(H,K);X&&G.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class G{constructor(){this._onDidShowCompletionItemEmitter=new _.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(H){let K=G.map.get(H);return K||(K=new G,G.map.set(H,K)),K}fireOnDidShowCompletionItem(H){this._onDidShowCompletionItemEmitter.fire(H)}}e.InlineCompletionController=G,G.map=new WeakMap;class ae{constructor(H,K){this._documents=H,this._provider=K,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(H,K,X,se){const q=this._documents.getDocument(H),te=E.Position.to(K),he=this.reviveContext(X),Ae=await this._provider.provideSignatureHelp(q,te,se,he);if(Ae){const Ue=this._cache.add([Ae]);return{...E.SignatureHelp.from(Ae),id:Ue}}}reviveContext(H){let K;if(H.activeSignatureHelp){const X=E.SignatureHelp.to(H.activeSignatureHelp),se=this._cache.get(H.activeSignatureHelp.id,0);se?(K=se,K.activeSignature=X.activeSignature,K.activeParameter=X.activeParameter):K=X}return{...H,activeSignatureHelp:K}}releaseSignatureHelp(H){this._cache.delete(H)}}class we{constructor(H,K){this._documents=H,this._provider=K,this._cache=new u.Cache("InlayHints")}async provideInlayHints(H,K,X){const se=this._documents.getDocument(H),q=await this._provider.provideInlayHints(se,E.Range.to(K),X);if(!(!Array.isArray(q)||q.length===0)&&!X.isCancellationRequested){if(typeof this._provider.resolveInlayHint!="function")return{hints:q.map(E.InlayHint.from)};{const te=this._cache.add(q),he={hints:[],cacheId:te};for(let Ae=0;Ae<q.length;Ae++){const Ue=E.InlayHint.from(q[Ae]);Ue.cacheId=[te,Ae],he.hints.push(Ue)}return he}}}async resolveInlayHint(H,K){if(typeof this._provider.resolveInlayHint!="function")return;const X=this._cache.get(...H);if(!X)return;const se=await this._provider.resolveInlayHint(X,K);if(!!se)return E.InlayHint.from(se)}releaseHints(H){this._cache.delete(H)}}class Se{constructor(H,K){this._documents=H,this._provider=K,this._cache=new u.Cache("DocumentLink")}async provideLinks(H,K){const X=this._documents.getDocument(H),se=await this._provider.provideDocumentLinks(X,K);if(!(!Array.isArray(se)||se.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(Se._validateLink).map(E.DocumentLink.from)};{const q=this._cache.add(se),te={links:[],id:q};for(let he=0;he<se.length;he++){if(!Se._validateLink(se[he]))continue;const Ae=E.DocumentLink.from(se[he]);Ae.cacheId=[q,he],te.links.push(Ae)}return te}}}static _validateLink(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,K){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...H);if(!X)return;const se=await this._provider.resolveDocumentLink(X,K);if(!(!se||!Se._validateLink(se)))return E.DocumentLink.from(se)}releaseLinks(H){this._cache.delete(H)}}class ce{constructor(H,K){this._documents=H,this._provider=K}async provideColors(H,K){const X=this._documents.getDocument(H),se=await this._provider.provideDocumentColors(X,K);return Array.isArray(se)?se.map(te=>({color:E.Color.from(te.color),range:E.Range.from(te.range)})):[]}async provideColorPresentations(H,K,X){const se=this._documents.getDocument(H),q=E.Range.to(K.range),te=E.Color.to(K.color),he=await this._provider.provideColorPresentations(te,{document:se,range:q},X);if(!!Array.isArray(he))return he.map(E.ColorPresentation.from)}}class oe{constructor(H,K){this._documents=H,this._provider=K}async provideFoldingRanges(H,K,X){const se=this._documents.getDocument(H),q=await this._provider.provideFoldingRanges(se,K,X);if(!!Array.isArray(q))return q.map(E.FoldingRange.from)}}class be{constructor(H,K,X){this._documents=H,this._provider=K,this._logService=X}async provideSelectionRanges(H,K,X){const se=this._documents.getDocument(H),q=K.map(E.Position.to),te=await this._provider.provideSelectionRanges(se,q,X);if(!(0,A.isNonEmptyArray)(te))return[];if(te.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Ae=0;Ae<q.length;Ae++){const Ue=[];he.push(Ue);let ze=q[Ae],Ge=te[Ae];for(;;){if(!Ge.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(E.SelectionRange.from(Ge)),!Ge.parent)break;ze=Ge.range,Ge=Ge.parent}}return he}}class Pe{constructor(H,K){this._documents=H,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(H,K,X){const se=this._documents.getDocument(H),q=E.Position.to(K),te=await this._provider.prepareCallHierarchy(se,q,X);if(!te)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(te)?te.map(Ae=>this._cacheAndConvertItem(he,Ae)):[this._cacheAndConvertItem(he,te)]}async provideCallsTo(H,K,X){const se=this._itemFromCache(H,K);if(!se)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(se,X);if(!!q)return q.map(te=>({from:this._cacheAndConvertItem(H,te.from),fromRanges:te.fromRanges.map(he=>E.Range.from(he))}))}async provideCallsFrom(H,K,X){const se=this._itemFromCache(H,K);if(!se)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(se,X);if(!!q)return q.map(te=>({to:this._cacheAndConvertItem(H,te.to),fromRanges:te.fromRanges.map(he=>E.Range.from(he))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,K){const X=this._cache.get(H),se=E.CallHierarchyItem.from(K,H,X.size.toString(36));return X.set(se._itemId,K),se}_itemFromCache(H,K){return this._cache.get(H)?.get(K)}}class Me{constructor(H,K){this._documents=H,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(H,K,X){const se=this._documents.getDocument(H),q=E.Position.to(K),te=await this._provider.prepareTypeHierarchy(se,q,X);if(!te)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(te)?te.map(Ae=>this._cacheAndConvertItem(he,Ae)):[this._cacheAndConvertItem(he,te)]}async provideSupertypes(H,K,X){const se=this._itemFromCache(H,K);if(!se)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(se,X);if(!!q)return q.map(te=>this._cacheAndConvertItem(H,te))}async provideSubtypes(H,K,X){const se=this._itemFromCache(H,K);if(!se)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(se,X);if(!!q)return q.map(te=>this._cacheAndConvertItem(H,te))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,K){const X=this._cache.get(H),se=E.TypeHierarchyItem.from(K,H,X.size.toString(36));return X.set(se._itemId,K),se}_itemFromCache(H,K){return this._cache.get(H)?.get(K)}}class He{constructor(H,K){this.adapter=H,this.extension=K}}class Ye{constructor(H,K,X,se,q,te,he){this._adapter=new Map,this._uriTransformer=K,this._proxy=H.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=se,this._diagnostics=q,this._logService=te,this._apiDeprecation=he}_transformDocumentSelector(H){return E.DocumentSelector.from(H,this._uriTransformer)}_createDisposable(H){return new T.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return Ye._handlePool++}_withAdapter(H,K,X,se,q=!1){const te=this._adapter.get(H);if(!te)return Promise.resolve(se);if(te.adapter instanceof K){let he;te.extension&&(he=Date.now(),this._logService.trace(`[${te.extension.identifier.value}] INVOKE provider '${K.name}'`));const Ae=X(te.adapter,te.extension),Ue=te.extension;return Ue&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${Ue.identifier.value}] provider DONE after ${Date.now()-he}ms`),ze=>{q&&ze instanceof F.CancellationError||(this._logService.error(`[${Ue.identifier.value}] provider FAILED`),this._logService.error(ze))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(H,K){const X=this._nextHandle();return this._adapter.set(X,new He(H,K)),X}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,K,X,se){const q=this._addNewAdapter(new m(this._documents,X),H),te=se&&se.label||Ye._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(K),te),this._createDisposable(q)}$provideDocumentSymbols(H,K,X){return this._withAdapter(H,m,se=>se.provideDocumentSymbols(s.URI.revive(K),X),void 0)}registerCodeLensProvider(H,K,X){const se=this._nextHandle(),q=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new He(new h(this._documents,this._commands.converter,X),H)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(K),q);let te=this._createDisposable(se);if(q!==void 0){const he=X.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(q));te=T.Disposable.from(te,he)}return te}$provideCodeLenses(H,K,X){return this._withAdapter(H,h,se=>se.provideCodeLenses(s.URI.revive(K),X),void 0)}$resolveCodeLens(H,K,X){return this._withAdapter(H,h,se=>se.resolveCodeLens(K,X),void 0)}$releaseCodeLenses(H,K){this._withAdapter(H,h,X=>Promise.resolve(X.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(H,K,X){const se=this._addNewAdapter(new l(this._documents,X),H);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDefinition(H,K,X,se){return this._withAdapter(H,l,q=>q.provideDefinition(s.URI.revive(K),X,se),[])}registerDeclarationProvider(H,K,X){const se=this._addNewAdapter(new M(this._documents,X),H);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDeclaration(H,K,X,se){return this._withAdapter(H,M,q=>q.provideDeclaration(s.URI.revive(K),X,se),[])}registerImplementationProvider(H,K,X){const se=this._addNewAdapter(new r(this._documents,X),H);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideImplementation(H,K,X,se){return this._withAdapter(H,r,q=>q.provideImplementation(s.URI.revive(K),X,se),[])}registerTypeDefinitionProvider(H,K,X){const se=this._addNewAdapter(new n(this._documents,X),H);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideTypeDefinition(H,K,X,se){return this._withAdapter(H,n,q=>q.provideTypeDefinition(s.URI.revive(K),X,se),[])}registerHoverProvider(H,K,X,se){const q=this._addNewAdapter(new b(this._documents,X),H);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideHover(H,K,X,se){return this._withAdapter(H,b,q=>q.provideHover(s.URI.revive(K),X,se),void 0)}registerEvaluatableExpressionProvider(H,K,X,se){const q=this._addNewAdapter(new g(this._documents,X),H);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideEvaluatableExpression(H,K,X,se){return this._withAdapter(H,g,q=>q.provideEvaluatableExpression(s.URI.revive(K),X,se),void 0)}registerInlineValuesProvider(H,K,X,se){const q=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,te=this._addNewAdapter(new c(this._documents,X),H);this._proxy.$registerInlineValuesProvider(te,this._transformDocumentSelector(K),q);let he=this._createDisposable(te);if(q!==void 0){const Ae=X.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(q));he=T.Disposable.from(he,Ae)}return he}$provideInlineValues(H,K,X,se,q){return this._withAdapter(H,c,te=>te.provideInlineValues(s.URI.revive(K),X,se,q),void 0)}registerDocumentHighlightProvider(H,K,X){const se=this._addNewAdapter(new f(this._documents,X),H);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentHighlights(H,K,X,se){return this._withAdapter(H,f,q=>q.provideDocumentHighlights(s.URI.revive(K),X,se),void 0)}registerLinkedEditingRangeProvider(H,K,X){const se=this._addNewAdapter(new v(this._documents,X),H);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideLinkedEditingRanges(H,K,X,se){return this._withAdapter(H,v,async q=>{const te=await q.provideLinkedEditingRanges(s.URI.revive(K),X,se);if(te)return{ranges:te.ranges,wordPattern:te.wordPattern?Ye._serializeRegExp(te.wordPattern):void 0}},void 0)}registerReferenceProvider(H,K,X){const se=this._addNewAdapter(new a(this._documents,X),H);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideReferences(H,K,X,se,q){return this._withAdapter(H,a,te=>te.provideReferences(s.URI.revive(K),X,se,q),void 0)}registerCodeActionProvider(H,K,X,se){const q=new i.DisposableStore,te=this._addNewAdapter(new S(this._documents,this._commands.converter,this._diagnostics,X,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(te,this._transformDocumentSelector(K),{providedKinds:se?.providedCodeActionKinds?.map(he=>he.value),documentation:se?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,q)}))},Ye._extLabel(H),Boolean(X.resolveCodeAction)),q.add(this._createDisposable(te)),q}$provideCodeActions(H,K,X,se,q){return this._withAdapter(H,S,te=>te.provideCodeActions(s.URI.revive(K),X,se,q),void 0)}$resolveCodeAction(H,K,X){return this._withAdapter(H,S,se=>se.resolveCodeAction(K,X),void 0)}$releaseCodeActions(H,K){this._withAdapter(H,S,X=>Promise.resolve(X.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(H,K,X){const se=this._addNewAdapter(new I(this._documents,X),H);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(K),H.identifier,H.displayName||H.name),this._createDisposable(se)}$provideDocumentFormattingEdits(H,K,X,se){return this._withAdapter(H,I,q=>q.provideDocumentFormattingEdits(s.URI.revive(K),X,se),void 0)}registerDocumentRangeFormattingEditProvider(H,K,X){const se=this._addNewAdapter(new N(this._documents,X),H);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(K),H.identifier,H.displayName||H.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(H,K,X,se,q){return this._withAdapter(H,N,te=>te.provideDocumentRangeFormattingEdits(s.URI.revive(K),X,se,q),void 0)}registerOnTypeFormattingEditProvider(H,K,X,se){const q=this._addNewAdapter(new B(this._documents,X),H);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(K),se,H.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(H,K,X,se,q,te){return this._withAdapter(H,B,he=>he.provideOnTypeFormattingEdits(s.URI.revive(K),X,se,q,te),void 0)}registerWorkspaceSymbolProvider(H,K){const X=this._addNewAdapter(new y(K,this._logService),H);return this._proxy.$registerNavigateTypeSupport(X,typeof K.resolveWorkspaceSymbol=="function"),this._createDisposable(X)}$provideWorkspaceSymbols(H,K,X){return this._withAdapter(H,y,se=>se.provideWorkspaceSymbols(K,X),{symbols:[]})}$resolveWorkspaceSymbol(H,K,X){return this._withAdapter(H,y,se=>se.resolveWorkspaceSymbol(K,X),void 0)}$releaseWorkspaceSymbols(H,K){this._withAdapter(H,y,X=>X.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(H,K,X){const se=this._addNewAdapter(new O(this._documents,X,this._logService),H);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(K),O.supportsResolving(X)),this._createDisposable(se)}$provideRenameEdits(H,K,X,se,q){return this._withAdapter(H,O,te=>te.provideRenameEdits(s.URI.revive(K),X,se,q),void 0)}$resolveRenameLocation(H,K,X,se){return this._withAdapter(H,O,q=>q.resolveRenameLocation(s.URI.revive(K),X,se),void 0)}registerDocumentSemanticTokensProvider(H,K,X,se){const q=this._nextHandle(),te=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new He(new U(this._documents,X),H)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(K),se,te);let he=this._createDisposable(q);if(te){const Ae=X.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(te));he=T.Disposable.from(he,Ae)}return he}$provideDocumentSemanticTokens(H,K,X,se){return this._withAdapter(H,U,q=>q.provideDocumentSemanticTokens(s.URI.revive(K),X,se),null,!0)}$releaseDocumentSemanticTokens(H,K){this._withAdapter(H,U,X=>X.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(H,K,X,se){const q=this._addNewAdapter(new $(this._documents,X),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(K),se),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(H,K,X,se){return this._withAdapter(H,$,q=>q.provideDocumentRangeSemanticTokens(s.URI.revive(K),X,se),null,!0)}registerCompletionItemProvider(H,K,X,se){const q=this._addNewAdapter(new W(this._documents,this._commands.converter,X,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(K),se,W.supportsResolving(X),`${H.identifier.value}(${se.join("")})`),this._createDisposable(q)}$provideCompletionItems(H,K,X,se,q){return this._withAdapter(H,W,te=>te.provideCompletionItems(s.URI.revive(K),X,se,q),void 0)}$resolveCompletionItem(H,K,X){return this._withAdapter(H,W,se=>se.resolveCompletionItem(K,X),void 0)}$releaseCompletionItems(H,K){this._withAdapter(H,W,X=>X.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(H,K,X){const se=this._addNewAdapter(new J(this._documents,X,this._commands.converter),H);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideInlineCompletions(H,K,X,se,q){return this._withAdapter(H,J,te=>te.provideInlineCompletions(s.URI.revive(K),X,se,q),void 0)}$handleInlineCompletionDidShow(H,K,X){this._withAdapter(H,J,async se=>{se.handleDidShowCompletionItem(K,X)},void 0)}$freeInlineCompletionsList(H,K){this._withAdapter(H,J,async X=>{X.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(H,K,X,se){const q=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,te=this._addNewAdapter(new ae(this._documents,X),H);return this._proxy.$registerSignatureHelpProvider(te,this._transformDocumentSelector(K),q),this._createDisposable(te)}$provideSignatureHelp(H,K,X,se,q){return this._withAdapter(H,ae,te=>te.provideSignatureHelp(s.URI.revive(K),X,se,q),void 0)}$releaseSignatureHelp(H,K){this._withAdapter(H,ae,X=>X.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(H,K,X){const se=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new we(this._documents,X),H);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(K),typeof X.resolveInlayHint=="function",se);let te=this._createDisposable(q);if(se!==void 0){const he=X.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(se));te=T.Disposable.from(te,he)}return te}$provideInlayHints(H,K,X,se){return this._withAdapter(H,we,q=>q.provideInlayHints(s.URI.revive(K),X,se),void 0)}$resolveInlayHint(H,K,X){return this._withAdapter(H,we,se=>se.resolveInlayHint(K,X),void 0)}$releaseInlayHints(H,K){this._withAdapter(H,we,X=>X.releaseHints(K),void 0)}registerDocumentLinkProvider(H,K,X){const se=this._addNewAdapter(new Se(this._documents,X),H);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(K),typeof X.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(H,K,X){return this._withAdapter(H,Se,se=>se.provideLinks(s.URI.revive(K),X),void 0)}$resolveDocumentLink(H,K,X){return this._withAdapter(H,Se,se=>se.resolveLink(K,X),void 0)}$releaseDocumentLinks(H,K){this._withAdapter(H,Se,X=>X.releaseLinks(K),void 0)}registerColorProvider(H,K,X){const se=this._addNewAdapter(new ce(this._documents,X),H);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentColors(H,K,X){return this._withAdapter(H,ce,se=>se.provideColors(s.URI.revive(K),X),[])}$provideColorPresentations(H,K,X,se){return this._withAdapter(H,ce,q=>q.provideColorPresentations(s.URI.revive(K),X,se),void 0)}registerFoldingRangeProvider(H,K,X){const se=this._nextHandle(),q=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new He(new oe(this._documents,X),H)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(K),q);let te=this._createDisposable(se);if(q!==void 0){const he=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));te=T.Disposable.from(te,he)}return te}$provideFoldingRanges(H,K,X,se){return this._withAdapter(H,oe,q=>q.provideFoldingRanges(s.URI.revive(K),X,se),void 0)}registerSelectionRangeProvider(H,K,X){const se=this._addNewAdapter(new be(this._documents,X,this._logService),H);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideSelectionRanges(H,K,X,se){return this._withAdapter(H,be,q=>q.provideSelectionRanges(s.URI.revive(K),X,se),[])}registerCallHierarchyProvider(H,K,X){const se=this._addNewAdapter(new Pe(this._documents,X),H);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareCallHierarchy(H,K,X,se){return this._withAdapter(H,Pe,q=>Promise.resolve(q.prepareSession(s.URI.revive(K),X,se)),void 0)}$provideCallHierarchyIncomingCalls(H,K,X,se){return this._withAdapter(H,Pe,q=>q.provideCallsTo(K,X,se),void 0)}$provideCallHierarchyOutgoingCalls(H,K,X,se){return this._withAdapter(H,Pe,q=>q.provideCallsFrom(K,X,se),void 0)}$releaseCallHierarchy(H,K){this._withAdapter(H,Pe,X=>Promise.resolve(X.releaseSession(K)),void 0)}registerTypeHierarchyProvider(H,K,X){const se=this._addNewAdapter(new Me(this._documents,X),H);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareTypeHierarchy(H,K,X,se){return this._withAdapter(H,Me,q=>Promise.resolve(q.prepareSession(s.URI.revive(K),X,se)),void 0)}$provideTypeHierarchySupertypes(H,K,X,se){return this._withAdapter(H,Me,q=>q.provideSupertypes(K,X,se),void 0)}$provideTypeHierarchySubtypes(H,K,X,se){return this._withAdapter(H,Me,q=>q.provideSubtypes(K,X,se),void 0)}$releaseTypeHierarchy(H,K){this._withAdapter(H,Me,X=>Promise.resolve(X.releaseSession(K)),void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:(0,P.regExpFlags)(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:Ye._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:Ye._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?Ye._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?Ye._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:Ye._serializeRegExp(H.beforeText),afterText:H.afterText?Ye._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?Ye._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(Ye._serializeOnEnterRule)}setLanguageConfiguration(H,K,X){let{wordPattern:se}=X;if(se&&(0,P.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(K,se):this._documents.setWordDefinitionFor(K,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const q=this._nextHandle(),te={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ye._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?Ye._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ye._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,K,te),this._createDisposable(q)}$setWordDefinitions(H){for(const K of H)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Ye,Ye._handlePool=0}),define(Ee[189],ye([0,1,5,8,7,34,14,6]),function(ee,e,s,t,E,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(R,w,i,p){this._documents=w,this._commands=i,this._uriTransformer=p,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(s.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,w){await this._proxy.$changeLanguage(R,w);const i=this._documents.getDocumentData(R);if(!i)throw new Error(`document '${R.toString}' NOT found`);return i.document}async tokenAtPosition(R,w){const i=R.version,p=t.Position.from(w),o=await this._proxy.$tokensAtPosition(R.uri,p),u={type:E.StandardTokenType.Other,range:R.getWordRangeAtPosition(w)??new E.Range(w.line,w.character,w.line,w.character)};if(!o)return u;const d={range:t.Range.to(o.range),type:t.TokenType.to(o.type)};return!d.range.contains(w)||i!==R.version?u:d}createLanguageStatusItem(R,w,i){const p=this._handlePool++,o=this._proxy,u=this._ids,d=`${R.identifier.value}/${w}`;if(u.has(d))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);u.add(d);const F={selector:i,id:w,name:R.displayName??R.name,severity:E.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let _,m=new P.DisposableStore;const h=()=>{_?.dispose(),_=(0,k.disposableTimeout)(()=>{m.clear(),this._proxy.$setLanguageStatus(p,{id:d,name:F.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(F.selector,this._uriTransformer),label:F.text,detail:F.detail??"",severity:F.severity===E.LanguageStatusSeverity.Error?T.default.Error:F.severity===E.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:F.command&&this._commands.toInternal(F.command,m),accessibilityInfo:F.accessibilityInformation,busy:F.busy})},0)},D={dispose(){m.dispose(),_?.dispose(),o.$removeLanguageStatus(p),u.delete(d)},get id(){return F.id},get name(){return F.name},set name(l){F.name=l,h()},get selector(){return F.selector},set selector(l){F.selector=l,h()},get text(){return F.text},set text(l){F.text=l,h()},get detail(){return F.detail},set detail(l){F.detail=l,h()},get severity(){return F.severity},set severity(l){F.severity=l,h()},get accessibilityInformation(){return F.accessibilityInformation},set accessibilityInformation(l){F.accessibilityInformation=l,h()},get command(){return F.command},set command(l){F.command=l,h()},get busy(){return F.busy},set busy(l){F.busy=l,h()}};return h(),D}}e.ExtHostLanguages=C}),define(Ee[190],ye([0,1,12,5,28,13,4]),function(ee,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends s.AbstractLoggerService{constructor(R,w){const i=new k.Emitter;super(w.logLevel,i.event);this._proxy=R.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(i)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,w,i){return new C(this._proxy,R,w,i)}};P=Be([$e(0,T.IExtHostRpcService),$e(1,E.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class C extends s.AbstractMessageLogger{constructor(R,w,i,p){super(p?.always);this.proxy=R,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(i),this.proxy.$createLogger(w,p).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,w){const i=[[R,w]];this.isLoggerCreated?this.doLog(i):this.buffer.push(...i)}doLog(R){this.proxy.$log(this.file,R)}}}),define(Ee[191],ye([0,1,5,12,27]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(P){return P&&P.title}let k=class{constructor(C,A){this._logService=A,this._proxy=C.getProxy(s.MainContext.MainThreadMessageService)}showMessage(C,A,R,w,i){const p={extension:C};let o;typeof w=="string"||T(w)?o=[w,...i]:(p.modal=w?.modal,p.useCustom=w?.useCustom,p.detail=w?.detail,o=i),p.useCustom&&(0,E.checkProposedApiEnabled)(C,"resolvers");const u=[];for(let d=0;d<o.length;d++){const F=o[d];if(typeof F=="string")u.push({title:F,handle:d,isCloseAffordance:!1});else if(typeof F=="object"){let{title:_,isCloseAffordance:m}=F;u.push({title:_,isCloseAffordance:!!m,handle:d})}else this._logService.warn("Invalid message item:",F)}return this._proxy.$showMessage(A,R,p,u).then(d=>{if(typeof d=="number")return o[d]})}};k=Be([$e(1,t.ILogService)],k),e.ExtHostMessageService=k}),define(Ee[192],ye([0,1,22,4,57,6,21,9,10,2,63,5,8,7,38,166,91]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class F{constructor(m,h,D,l,M){this._textDocumentsAndEditors=D,this._textDocuments=l,this._extensionStoragePaths=M,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=m.getProxy(w.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=m.getProxy(w.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=m.getProxy(w.MainContext.MainThreadNotebookEditors),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const n=r.notebookEditor?.notebookUri,b=r.cell.handle,c=this._documents.get(n)?.getCell(b);if(c)return c.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(m=>m.apiEditor)}getEditorById(m){const h=this._editors.get(m);if(!h)throw new Error(`unknown text editor: ${m}. known editors: ${[...this._editors.keys()]} `);return h}getIdByEditor(m){for(const[h,D]of this._editors)if(D.apiEditor===m)return h}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(m,h){const D=this._documents.get(m);if(!D&&!h)throw new Error(`NO notebook document for '${m}'`);return D}_getProviderData(m){const h=this._notebookContentProviders.get(m);if(!h)throw new Error(`NO provider for '${m}'`);return h}registerNotebookContentProvider(m,h,D,l,M){if((0,P.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);this._notebookContentProviders.set(h,{extension:m,provider:D});let r;return D.onDidChangeNotebookContentOptions&&(r=D.onDidChangeNotebookContentOptions(()=>{const n=i.NotebookDocumentContentOptions.from(D.options);this._notebookProxy.$updateNotebookProviderOptions(h,n)})),this._notebookProxy.$registerNotebookProvider({id:m.identifier,location:m.extensionLocation},h,i.NotebookDocumentContentOptions.from(l),F._convertNotebookRegistrationData(m,M)),new p.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(h),this._notebookProxy.$unregisterNotebookProvider(h)})}static _convertNotebookRegistrationData(m,h){if(!h)return;const D=h.filenamePattern.map(l=>i.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(h.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:h.displayName,filenamePattern:D,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,h,D){const l=F._notebookStatusBarItemProviderHandlePool++,M=typeof D.onDidChangeCellStatusBarItems=="function"?F._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,D),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,M,h);let r;return M!==void 0&&(r=D.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(M))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,M),r&&r.dispose()})}async createNotebookDocument(m){const h=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:m.viewType,content:m.content&&i.NotebookData.from(m.content)});return A.URI.revive(h)}async openNotebookDocument(m){const h=this._documents.get(m);if(h)return h.apiNotebook;const D=await this._notebookDocumentsProxy.$tryOpenNotebook(m),l=this._documents.get(A.URI.revive(D));return(0,C.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(m,h){A.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let D;typeof h=="object"?D={position:i.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(i.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:D={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(m.uri,m.notebookType,D),M=l&&this._editors.get(l)?.apiEditor;if(M)return M;throw l?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,h,D,l){const M=this._notebookStatusBarItemProviders.get(m),r=A.URI.revive(h),n=this._documents.get(r);if(!n||!M)return;const b=n.getCellFromIndex(D);if(!b)return;const g=await M.provideCellStatusBarItems(b.apiCell,l);if(!g)return;const c=new T.DisposableStore,f=this._statusBarCache.add([c]),a=(Array.isArray(g)?g:[g]).map(S=>i.NotebookStatusBarItem.from(S,this._commandsConverter,c));return{cacheId:f,items:a}}$releaseNotebookCellStatusBarItems(m){this._statusBarCache.delete(m)}registerNotebookSerializer(m,h,D,l,M){if((0,P.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,D),this._notebookProxy.$registerNotebookSerializer(r,{id:m.identifier,location:m.extensionLocation},h,i.NotebookDocumentContentOptions.from(l),F._convertNotebookRegistrationData(m,M)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(m,h,D){const l=this._notebookSerializer.get(m);if(!l)throw new Error("NO serializer found");const M=await l.deserializeNotebook(h.buffer,D);return new o.SerializableObjectWithBuffers(i.NotebookData.from(M))}async $notebookToData(m,h,D){const l=this._notebookSerializer.get(m);if(!l)throw new Error("NO serializer found");const M=await l.serializeNotebook(i.NotebookData.to(h.value),D);return s.VSBuffer.wrap(M)}async $openNotebook(m,h,D,l,M){const{provider:r}=this._getProviderData(m),n=await r.openNotebook(A.URI.revive(h),{backupId:D,untitledDocumentData:l?.buffer},M);return new o.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(i.NotebookCellData.from)})}async $saveNotebook(m,h,D){const l=this.getNotebookDocument(A.URI.revive(h)),{provider:M}=this._getProviderData(m);return await M.saveNotebook(l.apiNotebook,D),!0}async $saveNotebookAs(m,h,D,l){const M=this.getNotebookDocument(A.URI.revive(h)),{provider:r}=this._getProviderData(m);return await r.saveNotebookAs(A.URI.revive(D),M.apiNotebook,l),!0}async $backupNotebook(m,h,D){const l=this.getNotebookDocument(A.URI.revive(h)),M=this._getProviderData(m),r=this._extensionStoragePaths.workspaceValue(M.extension)??this._extensionStoragePaths.globalValue(M.extension),n=String((0,E.hash)([l.uri.toString(),this._backupIdPool++])),b=A.URI.joinPath(r,n),g=await M.provider.backupNotebook(l.apiNotebook,{destination:b},D);return l.updateBackup(g),g.id}_createExtHostEditor(m,h,D){if(this._editors.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const l=new d.ExtHostNotebookEditor(h,this._notebookEditorsProxy,m,D.visibleRanges.map(i.NotebookRange.to),D.selections.map(i.NotebookRange.to),typeof D.viewColumn=="number"?i.ViewColumn.to(D.viewColumn):void 0);this._editors.set(h,l)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const D of m.value.removedDocuments){const l=A.URI.revive(D),M=this._documents.get(l);M&&(M.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:M.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(M.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===l.toString()&&this._editors.delete(r.id)}if(m.value.addedDocuments){const D=[];for(const l of m.value.addedDocuments){const M=A.URI.revive(l.uri);if(this._documents.has(M))throw new Error(`adding EXISTING notebook ${M} `);const r=this,n=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(b){r._onDidChangeNotebookCells.fire(b)},emitCellOutputsChange(b){r._onDidChangeCellOutputs.fire(b)},emitCellMetadataChange(b){r._onDidChangeCellMetadata.fire(b)}},M,l);D.push(...l.cells.map(b=>u.ExtHostCell.asModelAddData(n.apiNotebook,b))),this._documents.get(M)?.dispose(),this._documents.set(M,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(m.value.addedEditors)for(const D of m.value.addedEditors){if(this._editors.has(D.id))return;const l=A.URI.revive(D.documentUri),M=this._documents.get(l);M&&this._createExtHostEditor(M,D.id,D)}const h=[];if(m.value.removedEditors)for(const D of m.value.removedEditors){const l=this._editors.get(D);l&&(this._editors.delete(D),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),h.push(l))}if(m.value.visibleEditors){this._visibleNotebookEditors=m.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const D=new Set;this._visibleNotebookEditors.forEach(l=>D.add(l.id));for(const l of this._editors.values()){const M=D.has(l.id);l._acceptVisibility(M)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this._activeNotebookEditor=void 0:m.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=F,F._notebookStatusBarItemProviderHandlePool=0}),define(Ee[193],ye([0,1,4,54,12,5,13,8]),function(ee,e,s,t,E,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(w,i){const p=C._Keys.nextId();w.$registerNotebookEditorDecorationType(p,P.NotebookDecorationRenderOptions.from(i)),this.value={key:p,dispose(){w.$removeNotebookEditorDecorationType(p)}}}}C._Keys=new t.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(w,i,p){this._logService=w,this._extHostRpc=i,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new s.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new s.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(w){return new C(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),w).value}$acceptEditorPropertiesChanged(w,i){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,i);const p=this._notebooksAndEditors.getEditorById(w);i.visibleRanges&&p._acceptVisibleRanges(i.visibleRanges.ranges.map(P.NotebookRange.to)),i.selections&&p._acceptSelections(i.selections.selections.map(P.NotebookRange.to)),i.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.apiEditor,visibleRanges:p.apiEditor.visibleRanges}),i.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.apiEditor,selections:p.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const i in w)this._notebooksAndEditors.getEditorById(i)._acceptViewColumn(P.ViewColumn.to(w[i]))}};A=Be([$e(0,E.ILogService),$e(1,k.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(Ee[194],ye([0,1,16,14,20,4,6,21,2,25,12,5,39,8,7,66,158,27,38]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let m=class{constructor(r,n,b,g,c){this._initData=n,this._extHostNotebook=b,this._commands=g,this._logService=c,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=r.getProxy(w.MainContext.MainThreadNotebookKernels);const f=new i.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new i.ApiCommandArgument("options","Select kernel options",v=>!0,v=>{if(v&&"notebookEditor"in v&&"id"in v){const a=this._extHostNotebook.getIdByEditor(v.notebookEditor);return{id:v.id,extension:v.extension,notebookEditorId:a}}else if(v&&"notebookEditor"in v){const a=this._extHostNotebook.getIdByEditor(v.notebookEditor);if(a===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${v.notebookEditor.document.uri.toString()}`);return{notebookEditorId:a}}return v})],i.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(r,n,b,g,c,f){for(const ae of this._kernelData.values())if(ae.controller.id===n&&A.ExtensionIdentifier.equals(r.identifier,ae.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const v=this._handlePool++,a=this;this._logService.trace(`NotebookController[${v}], CREATED by ${r.identifier.value}, ${n}`);const S=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${r.identifier}'`);let I=!1;const N=new k.DisposableStore,B=new T.Emitter,y=new T.Emitter,O={id:`${r.identifier.value}/${n}`,notebookType:b,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:g||r.identifier.value,preloads:f?f.map(p.NotebookRendererScript.from):[]};let z=c??S,U;this._proxy.$addKernel(v,O).catch(ae=>{console.log(ae),I=!0});let $=0;const W=()=>{if(I)return;const ae=++$;Promise.resolve().then(()=>{ae===$&&this._proxy.$updateKernel(v,O)})},J=new P.ResourceMap,G={get id(){return n},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return O.label},set label(ae){O.label=ae??r.displayName??r.name,W()},get detail(){return O.detail??""},set detail(ae){O.detail=ae,W()},get description(){return O.description??""},set description(ae){O.description=ae,W()},get kind(){return(0,F.checkProposedApiEnabled)(r,"notebookControllerKind"),O.kind??""},set kind(ae){(0,F.checkProposedApiEnabled)(r,"notebookControllerKind"),O.kind=ae,W()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(ae){O.supportedLanguages=ae,W()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){O.supportsExecutionOrder=ae,W()},get rendererScripts(){return O.preloads?O.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(ae){z=ae??S},get interruptHandler(){return U},set interruptHandler(ae){U=ae,O.supportsInterrupt=Boolean(ae),W()},createNotebookCellExecution(ae){if(I)throw new Error("notebook controller is DISPOSED");if(!J.has(ae.notebook.uri))throw a._logService.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(J.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return a._createNotebookCellExecution(ae)},dispose:()=>{I||(this._logService.trace(`NotebookController[${v}], DISPOSED`),I=!0,this._kernelData.delete(v),N.dispose(),B.dispose(),y.dispose(),this._proxy.$removeKernel(v))},updateNotebookAffinity(ae,we){a._proxy.$updateNotebookPriority(v,ae.uri,we)},onDidReceiveMessage:y.event,postMessage(ae,we){return(0,F.checkProposedApiEnabled)(r,"notebookMessaging"),a._proxy.$postMessage(v,we&&a._extHostNotebook.getIdByEditor(we),ae)},asWebviewUri(ae){return(0,F.checkProposedApiEnabled)(r,"notebookMessaging"),(0,u.asWebviewUri)(ae,a._initData.remote)}};return this._kernelData.set(v,{extensionId:r.identifier,controller:G,onDidReceiveMessage:y,onDidChangeSelection:B,associatedNotebooks:J}),G}$acceptNotebookAssociation(r,n,b){const g=this._kernelData.get(r);if(g){const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(n));b?g.associatedNotebooks.set(c.uri,!0):g.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,c.uri.toString(),b),g.onDidChangeSelection.fire({selected:b,notebook:c.apiNotebook})}}async $executeCells(r,n,b){const g=this._kernelData.get(r);if(!g)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(n)),f=[];for(const v of b){const a=c.getCell(v);a&&f.push(a.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,c.uri.toString(),f.length),await g.controller.executeHandler.call(g.controller,f,c.apiNotebook,g.controller)}catch(v){this._logService.error(`NotebookController[${r}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(r,n,b){const g=this._kernelData.get(r);if(!g)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(n));if(g.controller.interruptHandler)await g.controller.interruptHandler.call(g.controller,c.apiNotebook);else for(const f of b){const v=c.getCell(f);v&&this._activeExecutions.get(v.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,n,b){const g=this._kernelData.get(r);if(!g)return;const c=this._extHostNotebook.getEditorById(n);g.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:b}))}$cellExecutionChanged(r,n,b){const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(r)).getCell(n);c&&this._onDidChangeCellExecutionState.fire({cell:c.apiCell,state:b??o.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const b=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!b)throw new Error("invalid cell");if(this._activeExecutions.has(b.uri))throw new Error(`duplicate execution for ${b.uri}`);const g=new D(b.notebook,b,this._proxy);this._activeExecutions.set(b.uri,g);const c=g.onDidChangeState(()=>{g.state===h.Resolved&&(g.dispose(),c.dispose(),this._activeExecutions.delete(b.uri))});return g.asApiObject()}};m=Be([$e(4,R.ILogService)],m),e.ExtHostNotebookKernels=m;var h;(function(M){M[M.Init=0]="Init",M[M.Started=1]="Started",M[M.Resolved=2]="Resolved"})(h||(h={}));class D extends k.Disposable{constructor(r,n,b){super();this._document=r,this._cell=n,this._proxy=b,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=h.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new l(10,g=>this.update(g)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$addExecution(this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const n=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new _.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===h.Init)throw new Error("Must call start before modifying cell output");if(this._state===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let n=this._cell;if(r&&(n=this._document.getCellFromApiCell(r)),!n)throw new Error("INVALID cell");return n.handle}validateAndConvertOutputs(r){return r.map(n=>{const b=o.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return b===n.items?p.NotebookCellOutput.from(n):p.NotebookCellOutput.from({items:b,id:n.id,metadata:n.metadata})})}async updateOutputs(r,n,b){const g=this.cellIndexToHandle(n),c=this.validateAndConvertOutputs((0,s.asArray)(r));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,uri:this._document.uri,cellHandle:g,append:b,outputs:c})}async updateOutputItems(r,n,b){return r=o.NotebookCellOutput.ensureUniqueMimeTypes((0,s.asArray)(r),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,uri:this._document.uri,cellHandle:this._cell.handle,items:r.map(p.NotebookCellOutputItem.from),outputId:n.id,append:b})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(b){r._executionOrder=b,r.update([{editType:d.CellExecutionUpdateType.ExecutionState,uri:r._document.uri,cellHandle:r._cell.handle,executionOrder:r._executionOrder}])},start(b){if(r._state===h.Resolved||r._state===h.Started)throw new Error("Cannot call start again");r._state=h.Started,r._onDidChangeState.fire(),r.update({editType:d.CellExecutionUpdateType.ExecutionState,uri:r._document.uri,cellHandle:r._cell.handle,runStartTime:b})},end(b,g){if(r._state===h.Resolved)throw new Error("Cannot call resolve twice");r._state=h.Resolved,r._onDidChangeState.fire(),r._collector.flush(),r._proxy.$completeExecution(r._document.uri,r._cell.handle,new _.SerializableObjectWithBuffers({uri:r._document.uri,cellHandle:r._cell.handle,runEndTime:g,lastRunSuccess:b}))},clearOutput(b){return r.verifyStateForOutput(),r.updateOutputs([],b,!1)},appendOutput(b,g){return r.verifyStateForOutput(),r.updateOutputs(b,g,!0)},replaceOutput(b,g){return r.verifyStateForOutput(),r.updateOutputs(b,g,!1)},appendOutputItems(b,g){return r.verifyStateForOutput(),r.updateOutputItems(b,g,!0)},replaceOutputItems(b,g){return r.verifyStateForOutput(),r.updateOutputItems(b,g,!1)}})}}class l{constructor(r,n){this.delay=r,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>r.complete())}}}),define(Ee[195],ye([0,1,4,5,91,27]),function(ee,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class k{constructor(C,A){this._extHostNotebook=A,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,A,R){const w=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(A)?.fire({editor:w.apiEditor,message:R})}createRendererMessaging(C,A){if(!C.contributes?.notebookRenderer?.some(p=>p.id===A))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${A})`);const R=(0,T.isProposedApiEnabled)(C,"notebookEditor"),w=new WeakMap;return{onDidReceiveMessage:(p,o,u)=>{const d=R?p:F=>{const _={};w.set(_,F.editor),p({editor:_,message:F.message})};return this.getOrCreateEmitterFor(A).event(d,o,u)},postMessage:(p,o)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(p)&&([p,o]=[o,p]);const u=R?o:w.get(o),d=u&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(d?.id,A,p)}}}getOrCreateEmitterFor(C){let A=this._rendererMessageEmitters.get(C);return A||(A=new s.Emitter({onLastListenerRemove:()=>{A?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,A),A)}}e.ExtHostNotebookRenderers=k}),define(Ee[94],ye([0,1,5,6,3,13,12,159,50,28,30,109,22]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class p extends t.Disposable{constructor(d,F,_,m){super();this.id=d,this.name=F,this.logger=_,this.proxy=m,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(d){this.append(d+`
`)}append(d){this.write(d),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const d=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,d)}replace(d){const F=this.offset;this.write(d),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,F),this.visible&&this.logger.flush()}show(d,F){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof d=="boolean"?d:F))}hide(){this.proxy.$close(this.id)}write(d){this.offset+=i.VSBuffer.fromString(d).byteLength,this.logger.info(d)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=p;let o=class{constructor(d,F,_,m,h){this.extHostFileSystem=_,this.extHostFileSystemInfo=m,this.loggerService=h,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=d.getProxy(s.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(F.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.visibleChannelId=d;for(const[F,_]of this.channels)_.visible=F===this.visibleChannelId}createOutputChannel(d,F){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const _=this.doCreateOutputChannel(d,F);return _.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(d,_)}async doCreateOutputChannel(d,F){const _=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(_,`${this.namePool++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),D=await this.proxy.$register(d,!1,m,F.identifier.value);return new p(D,d,h,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(d,F){let _=!1;const m=()=>{if(_)throw new Error("Channel has been closed")};return{get name(){return d},append(h){m(),F.then(D=>D.append(h))},appendLine(h){m(),F.then(D=>D.appendLine(h))},clear(){m(),F.then(h=>h.clear())},replace(h){m(),F.then(D=>D.replace(h))},show(h,D){m(),F.then(l=>l.show(h,D))},hide(){m(),F.then(h=>h.hide())},dispose(){_=!0,F.then(h=>h.dispose())}}}};o=Be([$e(0,T.IExtHostRpcService),$e(1,A.IExtHostInitDataService),$e(2,C.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,k.ILoggerService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=(0,E.createDecorator)("IExtHostOutputService")}),define(Ee[196],ye([0,1,14,20,4,6,5,2,7,15,16,34,62,27]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(u,d,F){const _=u.getProxy(k.MainContext.MainThreadQuickOpen);class m{constructor(c,f){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=f}showQuickPick(c,f,v=t.CancellationToken.None){this._onDidSelectItem=void 0;const a=Promise.resolve(c),S=++this._instances,I=_.$show(S,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},v),N={},B=I.then(()=>N);return Promise.race([B,a]).then(y=>{if(y!==N)return a.then(O=>{const z=[];for(let U=0;U<O.length;U++){const $=O[U];typeof $=="string"?z.push({label:$,handle:U}):$.kind===C.QuickPickItemKind.Separator?z.push({type:"separator",label:$.label}):z.push({label:$.label,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,handle:U})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{f.onDidSelectItem(O[U])}),_.$setItems(S,z),I.then(U=>{if(typeof U=="number")return O[U];if(Array.isArray(U))return U.map($=>O[$])})})}).then(void 0,y=>{if(!(0,A.isPromiseCanceledError)(y))return _.$setError(S,y),Promise.reject(y)})}$onItemSelected(c){this._onDidSelectItem&&this._onDidSelectItem(c)}showInput(c,f=t.CancellationToken.None){return this._validateInput=c?c.validateInput:void 0,_.$input(c,typeof this._validateInput=="function",f).then(void 0,v=>{if(!(0,A.isPromiseCanceledError)(v))return Promise.reject(v)})}$validateInput(c){return this._validateInput?(0,s.asPromise)(()=>this._validateInput(c)):Promise.resolve(void 0)}async showWorkspaceFolderPick(c,f=t.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!v)return;const a=await this._workspace.getWorkspaceFolders2();if(!!a)return a.find(S=>S.uri.toString()===v.uri.toString())}createQuickPick(c){const f=new n(c,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(c){const f=new b(c,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}$onDidChangeValue(c,f){const v=this._sessions.get(c);v&&v._fireDidChangeValue(f)}$onDidAccept(c){const f=this._sessions.get(c);f&&f._fireDidAccept()}$onDidChangeActive(c,f){const v=this._sessions.get(c);v instanceof n&&v._fireDidChangeActive(f)}$onDidChangeSelection(c,f){const v=this._sessions.get(c);v instanceof n&&v._fireDidChangeSelection(f)}$onDidTriggerButton(c,f){const v=this._sessions.get(c);v&&v._fireDidTriggerButton(f)}$onDidTriggerItemButton(c,f,v){const a=this._sessions.get(c);a instanceof n&&a._fireDidTriggerItemButton(f,v)}$onDidHide(c){const f=this._sessions.get(c);f&&f._fireDidHide()}}class h{constructor(c,f){this._extensionId=c,this._onDidDispose=f,this._id=n._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((f,v)=>{const a=f===C.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(a,f)}),this.update({buttons:c.map((f,v)=>({...r(f),tooltip:f.tooltip,handle:f===C.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const f=this._handlesToButtons.get(c);f&&this._onDidTriggerButtonEmitter.fire(f)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(c){if(!this._disposed){for(const f of Object.keys(c)){const v=c[f];this._pendingUpdate[f]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}h._nextId=1;function D(g){if(g instanceof C.ThemeIcon)return{id:g.id};const c=M(g),f=l(g);return{dark:typeof c=="string"?P.URI.file(c):c,light:typeof f=="string"?P.URI.file(f):f}}function l(g){return typeof g=="object"&&"light"in g?g.light:g}function M(g){return typeof g=="object"&&"dark"in g?g.dark:g}function r(g){const c=D(g.iconPath);let f,v;return"id"in c?v=i.ThemeIcon.asClassName(c):f=c,{iconPath:f,iconClass:v}}class n extends h{constructor(c,f){super(c.identifier,f);this.extension=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){c.some(v=>v.kind!==void 0)&&(0,p.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((v,a)=>{this._handlesToItems.set(a,v),this._itemsToHandles.set(v,a)});const f=[];for(let v=0;v<c.length;v++){const a=c[v];a.kind===C.QuickPickItemKind.Separator?f.push({type:"separator",label:a.label}):f.push({handle:v,label:a.label,description:a.description,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow,buttons:a.buttons?.map((S,I)=>({...r(S),tooltip:S.tooltip,handle:I}))})}this.update({items:f})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(f=>this._itemsToHandles.has(f)),this.update({activeItems:this._activeItems.map(f=>this._itemsToHandles.get(f))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(f=>this._itemsToHandles.has(f)),this.update({selectedItems:this._selectedItems.map(f=>this._itemsToHandles.get(f))})}_fireDidChangeActive(c){const f=(0,R.coalesce)(c.map(v=>this._handlesToItems.get(v)));this._activeItems=f,this._onDidChangeActiveEmitter.fire(f)}_fireDidChangeSelection(c){const f=(0,R.coalesce)(c.map(v=>this._handlesToItems.get(v)));this._selectedItems=f,this._onDidChangeSelectionEmitter.fire(f)}_fireDidTriggerItemButton(c,f){const v=this._handlesToItems.get(c);if(!v||!v.buttons||!v.buttons.length)return;const a=v.buttons[f];a&&this._onDidTriggerItemButtonEmitter.fire({button:a,item:v})}}class b extends h{constructor(c,f){super(c,f);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,this.update({validationMessage:c,severity:c?w.default.Error:w.default.Ignore})}}return new m(d,F)}e.createExtHostQuickOpen=o});var Ze=this&&this.__classPrivateFieldSet||function(ee,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!E:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(ee,s):E?E.value=s:e.set(ee,s),s},ke=this&&this.__classPrivateFieldGet||function(ee,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(ee):t?t.value:e.get(ee)};define(Ee[197],ye([0,1,2,4,53,6,14,5,16,104,12,25,62,8,27]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o){"use strict";var u,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function F(f){if(f)return typeof f.iconPath=="string"?s.URI.file(f.iconPath):s.URI.isUri(f.iconPath)||i.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function _(f,v){if(!f.iconPath&&!v.iconPath)return 0;if(f.iconPath){if(!v.iconPath)return 1}else return-1;const a=typeof f.iconPath=="string"?f.iconPath:s.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,S=typeof v.iconPath=="string"?v.iconPath:s.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,A.comparePaths)(a,S)}function m(f,v){let a=0;if(f.strikeThrough!==v.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==v.faded)return f.faded?1:-1;if(f.tooltip!==v.tooltip)return(f.tooltip||"").localeCompare(v.tooltip||"");if(a=_(f,v),a!==0)return a;if(f.light&&v.light)a=_(f.light,v.light);else{if(f.light)return 1;if(v.light)return-1}if(a!==0)return a;if(f.dark&&v.dark)a=_(f.dark,v.dark);else{if(f.dark)return 1;if(v.dark)return-1}return a}function h(f,v){if(f.command!==v.command)return f.command<v.command?-1:1;if(f.title!==v.title)return f.title<v.title?-1:1;if(f.tooltip!==v.tooltip){if(f.tooltip!==void 0&&v.tooltip!==void 0)return f.tooltip<v.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(f.arguments===v.arguments)return 0;if(f.arguments)if(v.arguments){if(f.arguments.length!==v.arguments.length)return f.arguments.length-v.arguments.length}else return 1;else return-1;for(let a=0;a<f.arguments.length;a++){const S=f.arguments[a],I=v.arguments[a];if(S!==I)return S<I?-1:1}return 0}function D(f,v){let a=(0,A.comparePaths)(f.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(a!==0)return a;if(f.command&&v.command)a=h(f.command,v.command);else{if(f.command)return 1;if(v.command)return-1}if(a!==0)return a;if(f.decorations&&v.decorations)a=m(f.decorations,v.decorations);else{if(f.decorations)return 1;if(v.decorations)return-1}return a}function l(f,v){for(let a=0;a<f.length;a++)if(f[a]!==v[a])return!1;return!0}function M(f,v){return f.command===v.command&&f.title===v.title&&f.tooltip===v.tooltip&&(f.arguments&&v.arguments?l(f.arguments,v.arguments):f.arguments===v.arguments)}function r(f,v){return(0,C.equals)(f,v,M)}class n{constructor(v,a,S){this._extension=v,this._sourceControlHandle=S,u.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,Ze(this,u,a,"f")}get value(){return this._value}set value(v){v=v??"",ke(this,u,"f").$setInputBoxValue(this._sourceControlHandle,v),this.updateValue(v)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(v){ke(this,u,"f").$setInputBoxPlaceholder(this._sourceControlHandle,v),this._placeholder=v}get validateInput(){return(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(v){if((0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=v,ke(this,u,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!v)}get visible(){return this._visible}set visible(v){v=!!v,this._visible!==v&&(this._visible=v,ke(this,u,"f").$setInputBoxVisibility(this._sourceControlHandle,v))}showValidationMessage(v,a){(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),ke(this,u,"f").$showValidationMessage(this._sourceControlHandle,v,a)}$onInputBoxValueChange(v){this.updateValue(v)}updateValue(v){this._value=v,this._onDidChange.fire(v)}}e.ExtHostSCMInputBox=n,u=new WeakMap;class b{constructor(v,a,S,I,N){this._proxy=v,this._commands=a,this._sourceControlHandle=S,this._id=I,this._label=N,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=b._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(v){this._label=v,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,v)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(v){this._hideWhenEmpty=v,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(v){this._resourceStates=[...v],this._onDidUpdateResourceStates.fire()}getResourceState(v){return this._resourceStatesMap.get(v)}$executeResourceCommand(v,a){const S=this._resourceStatesCommandsMap.get(v);return S?(0,k.asPromise)(()=>this._commands.executeCommand(S.command,...S.arguments||[],a)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this._resourceStates].sort(D),S=(0,C.sortedDiff)(this._resourceSnapshot,v,D).map(B=>{const y=B.toInsert.map(O=>{const z=this._resourceHandlePool++;this._resourceStatesMap.set(z,O);const U=O.resourceUri;let $;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const Pe=new T.DisposableStore;$=this._commands.converter.toInternal(O.command,Pe),this._resourceStatesDisposablesMap.set(z,Pe)}else this._resourceStatesCommandsMap.set(z,O.command);const W=F(O.decorations),J=O.decorations&&F(O.decorations.light)||W,G=O.decorations&&F(O.decorations.dark)||W,ae=[J,G],we=O.decorations&&O.decorations.tooltip||"",Se=O.decorations&&!!O.decorations.strikeThrough,ce=O.decorations&&!!O.decorations.faded,oe=O.contextValue||"";return{rawResource:[z,U,ae,we,Se,ce,oe,$],handle:z}});return{start:B.start,deleteCount:B.deleteCount,toInsert:y}}),I=S.map(({start:B,deleteCount:y,toInsert:O})=>[B,y,O.map(z=>z.rawResource)]),N=S.reverse();for(const{start:B,deleteCount:y,toInsert:O}of N){const z=O.map($=>$.handle),U=this._handlesSnapshot.splice(B,y,...z);for(const $ of U)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),this._resourceStatesDisposablesMap.get($)?.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=v,I}dispose(){this._disposed=!0,this._onDidDispose.fire()}}b._handlePool=0;class g{constructor(v,a,S,I,N,B){this._extension=v,this._commands=S,this._id=I,this._label=N,this._rootUri=B,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=g._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ze(this,d,a,"f"),this._inputBox=new n(v,ke(this,d,"f"),this.handle),ke(this,d,"f").$registerSourceControl(this.handle,I,N,B)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(v){this._count!==v&&(this._count=v,ke(this,d,"f").$updateSourceControl(this.handle,{count:v}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(v){this._quickDiffProvider=v,ke(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!v})}get commitTemplate(){return this._commitTemplate}set commitTemplate(v){v!==this._commitTemplate&&(this._commitTemplate=v,ke(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:v}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(v){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=v;const a=this._commands.converter.toInternal(v,this._acceptInputDisposables.value);ke(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:a})}get actionButton(){return(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(v){(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=v;const a=v!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;ke(this,d,"f").$updateSourceControl(this.handle,{actionButton:a??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(v){if(this._statusBarCommands&&v&&r(this._statusBarCommands,v))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=v;const a=(v||[]).map(S=>this._commands.converter.toInternal(S,this._statusBarDisposables.value));ke(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:a})}get selected(){return this._selected}createResourceGroup(v,a){const S=new b(ke(this,d,"f"),this._commands,this.handle,v,a),I=t.Event.once(S.onDidDispose)(()=>this.createdResourceGroups.delete(S));return this.createdResourceGroups.set(S,I),this.eventuallyAddResourceGroups(),S}eventuallyAddResourceGroups(){const v=[],a=[];for(const[S,I]of this.createdResourceGroups){I.dispose();const N=S.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(S),this.eventuallyUpdateResourceStates()});t.Event.once(S.onDidDispose)(()=>{this.updatedResourceGroups.delete(S),N.dispose(),this._groups.delete(S.handle),ke(this,d,"f").$unregisterGroup(this.handle,S.handle)}),v.push([S.handle,S.id,S.label,S.features]);const B=S._takeResourceStateSnapshot();B.length>0&&a.push([S.handle,B]),this._groups.set(S.handle,S)}ke(this,d,"f").$registerGroups(this.handle,v,a),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const v=[];this.updatedResourceGroups.forEach(a=>{const S=a._takeResourceStateSnapshot();S.length!==0&&v.push([a.handle,S])}),v.length>0&&ke(this,d,"f").$spliceResourceStates(this.handle,v),this.updatedResourceGroups.clear()}getResourceGroup(v){return this._groups.get(v)}setSelectionState(v){this._selected=v,this._onDidChangeSelection.fire(v)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(v=>v.dispose()),ke(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,g._handlePool=0,Be([(0,E.debounce)(100)],g.prototype,"eventuallyAddResourceGroups",null),Be([(0,E.debounce)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let c=class zi{constructor(v,a,S){this._commands=a,this.logService=S,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=v.getProxy(P.MainContext.MainThreadSCM),this._telemetry=v.getProxy(P.MainContext.MainThreadTelemetry),a.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===3){const N=this._sourceControls.get(I.sourceControlHandle);if(!N)return I;const B=N.getResourceGroup(I.groupHandle);return B?B.getResourceState(I.handle):I}else if(I&&I.$mid===4){const N=this._sourceControls.get(I.sourceControlHandle);return N?N.getResourceGroup(I.groupHandle):I}else if(I&&I.$mid===5){const N=this._sourceControls.get(I.handle);return N||I}return I}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(v,a,S,I){this.logService.trace("ExtHostSCM#createSourceControl",v.identifier.value,a,S,I),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const N=zi._handlePool++,B=new g(v,this._proxy,this._commands,a,S,I);this._sourceControls.set(N,B);const y=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(v.identifier))||[];return y.push(B),this._sourceControlsByExtension.set(w.ExtensionIdentifier.toKey(v.identifier),y),B}getLastInputBox(v){this.logService.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const a=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(v.identifier)),S=a&&a[a.length-1];return S&&S.inputBox}$provideOriginalResource(v,a,S){const I=s.URI.revive(a);this.logService.trace("ExtHostSCM#$provideOriginalResource",v,I.toString());const N=this._sourceControls.get(v);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>N.quickDiffProvider.provideOriginalResource(I,S)).then(B=>B||null)}$onInputBoxValueChange(v,a){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",v);const S=this._sourceControls.get(v);return S&&S.inputBox.$onInputBoxValueChange(a),Promise.resolve(void 0)}$executeResourceCommand(v,a,S,I){this.logService.trace("ExtHostSCM#$executeResourceCommand",v,a,S);const N=this._sourceControls.get(v);if(!N)return Promise.resolve(void 0);const B=N.getResourceGroup(a);return B?B.$executeResourceCommand(S,I):Promise.resolve(void 0)}$validateInput(v,a,S){this.logService.trace("ExtHostSCM#$validateInput",v);const I=this._sourceControls.get(v);return!I||!I.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>I.inputBox.validateInput(a,S)).then(N=>{if(!N)return Promise.resolve(void 0);const B=p.MarkdownString.fromStrict(N.message);return B?Promise.resolve([B,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this._sourceControls.get(v)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=v,Promise.resolve(void 0)}};c._handlePool=0,c=Be([$e(2,R.ILogService)],c),e.ExtHostSCM=c});var Ze=this&&this.__classPrivateFieldSet||function(ee,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!E:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(ee,s):E?E.value=s:e.set(ee,s),s},ke=this&&this.__classPrivateFieldGet||function(ee,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(ee):t?t.value:e.get(ee)};define(Ee[198],ye([0,1,7,5,121,6,8,10]),function(ee,e,s,t,E,T,k,P){"use strict";var C,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(o,u,d,F,_=s.StatusBarAlignment.Left,m){C.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Ze(this,C,o,"f"),Ze(this,A,u,"f"),this._entryId=R.ID_GEN++,this._extension=d,this._id=F,this._alignment=_,this._priority=this.validatePriority(m)}validatePriority(o){if(!!(0,P.isNumber)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!R.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){this._command?.fromApi!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:ke(this,A,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:ke(this,A,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,ke(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let o;this._extension?this._id?o=`${this._extension.identifier.value}.${this._id}`:o=this._extension.identifier.value:o=this._id;let u;this._name?u=this._name:u=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const F=this._tooltip?k.MarkdownString.fromStrict(this._tooltip):void 0;ke(this,C,"f").$setEntry(this._entryId,o,u,this._text,F,this._command?.internal,d,this._backgroundColor,this._alignment===s.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,C=new WeakMap,A=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new s.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new s.ThemeColor("statusBarItem.warningForeground")]]);class w{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",s.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const u={message:o};return this._messages.unshift(u),this._update(),new s.Disposable(()=>{const d=this._messages.indexOf(u);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(o,u){this._proxy=o.getProxy(t.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new w(this)}createStatusBarEntry(o,u,d,F){return new R(this._proxy,this._commands,o,u,d,F)}setStatusBarMessage(o,u){const d=this._statusMessage.setMessage(o);let F;return typeof u=="number"?F=setTimeout(()=>d.dispose(),u):typeof u!="undefined"&&u.then(()=>d.dispose(),()=>d.dispose()),new s.Disposable(()=>{d.dispose(),clearTimeout(F)})}}e.ExtHostStatusBar=i}),define(Ee[71],ye([0,1,5,4,3]),function(ee,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(P){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(s.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,C){this._proxy.$registerExtensionStorageKeysToSync(P,C)}getValue(P,C,A){return this._proxy.$getValue(P,C).then(R=>R||A)}setValue(P,C,A){return this._proxy.$setValue(P,C,A)}$acceptValue(P,C,A){this._onDidChangeStorage.fire({shared:P,key:C,value:A})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(Ee[72],ye([0,1,3,28,12,50,2]),function(ee,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,s.createDecorator)("IExtensionStoragePaths");let P=class{constructor(A,R,w){this._logService=R,this._extHostFileSystem=w,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(i=>this._value=i)}async _getWorkspaceStorageURI(A){return k.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,R=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:k.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(A){if(this._value)return k.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return k.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=Be([$e(0,t.IExtHostInitDataService),$e(1,E.ILogService),$e(2,T.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(Ee[40],ye([0,1,4,5,3,2,13,6,7,122,15,161,20,36,144,62,10,14]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class _{constructor(g,c,f,v){this._proxy=g,this._id=c,this._creationOptions=f,this._name=v,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(S=>this._pidPromiseComplete=S);const a=this;this.value={get name(){return a._name||""},get processId(){return a._pidPromise},get creationOptions(){return a._creationOptions},get exitStatus(){return a._exitStatus},get state(){return a._state},sendText(S,I=!0){a._checkDisposed(),a._proxy.$sendText(a._id,S,I)},show(S){a._checkDisposed(),a._proxy.$show(a._id,S)},hide(){a._checkDisposed(),a._proxy.$hide(a._id)},dispose(){a._disposed||(a._disposed=!0,a._proxy.$dispose(a._id))},get dimensions(){if(!(a._cols===void 0||a._rows===void 0))return{columns:a._cols,rows:a._rows}}}}async create(g,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:g.name,shellPath:(0,d.withNullAsUndefined)(g.shellPath),shellArgs:(0,d.withNullAsUndefined)(g.shellArgs),cwd:(0,d.withNullAsUndefined)(g.cwd),env:(0,d.withNullAsUndefined)(g.env),icon:(0,d.withNullAsUndefined)(r(g.iconPath)),color:u.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:(0,d.withNullAsUndefined)(g.message),strictEnv:(0,d.withNullAsUndefined)(g.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(g.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(g.location,c?.resolvedExtHostIdentifier),disablePersistence:(0,d.withNullAsUndefined)(g.disablePersistence)})}async createExtensionTerminal(g,c,f,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:u.ThemeColor.isThemeColor(v)?v.id:void 0,location:this._serializeParentTerminal(g,c),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(g,c){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in g?{viewColumn:g.viewColumn,preserveFocus:g.preserveFocus}:void 0:g}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(g){this._name=g}setExitCode(g){this._exitStatus=Object.freeze({code:g})}setDimensions(g,c){return g===this._cols&&c===this._rows||g===0||c===0?!1:(this._cols=g,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(g){this._pidPromiseComplete?(this._pidPromiseComplete(g),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==g&&(this._pidPromise=Promise.resolve(g))})}}e.ExtHostTerminal=_;class m{constructor(g){this._pty=g,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new s.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new s.Emitter,this._onDidChangeProperty=new s.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new s.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(g){this._pty.handleInput?.(g)}resize(g,c){this._pty.setDimensions?.({columns:g,rows:c})}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(g){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(g||void 0),g&&this._pty.setDimensions?.(g),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=m;let h=1,D=class extends P.Disposable{constructor(g,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new s.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new s.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new s.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new s.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new s.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new s.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(g),this._register({dispose:()=>{for(const[f,v]of this._terminalProcesses)v.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(g=>g.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(g){return(g?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(g){return(g?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(g,c){const f=new _(this._proxy,(0,p.generateUuid)(),g,g.name),v=new m(g.pty);return f.createExtensionTerminal(g.location,this._serializeParentTerminal(g,c).resolvedExtHostIdentifier,r(g.iconPath),n(g.color)).then(a=>{const S=this._setupExtHostProcessListeners(a,v);this._terminalProcessDisposables[a]=S}),this._terminals.push(f),f.value}_serializeParentTerminal(g,c){if(c=c||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const f=g.location.parentTerminal;if(f){const v=this._terminals.find(a=>a.value===f);v&&(c.resolvedExtHostIdentifier=v._id)}}else g.location&&typeof g.location!="object"?c.location=g.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(g,c){if(!this._getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const v=new m(c),a=this._setupExtHostProcessListeners(g,v);this._terminalProcessDisposables[g]=a}async $acceptActiveTerminalChanged(g){const c=this._activeTerminal;if(g===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(g);f&&(this._activeTerminal=f,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(g,c){const f=this._getTerminalById(g);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:c})}async $acceptTerminalDimensions(g,c,f){const v=this._getTerminalById(g);v&&v.setDimensions(c,f)&&this._onDidChangeTerminalDimensions.fire({terminal:v.value,dimensions:v.value.dimensions})}async $acceptTerminalMaximumDimensions(g,c,f){this._terminalProcesses.get(g)?.resize(c,f)}async $acceptTerminalTitleChange(g,c){const f=this._getTerminalById(g);f&&(f.name=c)}async $acceptTerminalClosed(g,c){const f=this._getTerminalObjectIndexById(this._terminals,g);if(f!==null){const v=this._terminals.splice(f,1)[0];v.setExitCode(c),this._onDidCloseTerminal.fire(v.value)}}$acceptTerminalOpened(g,c,f,v){if(c){const I=this._getTerminalObjectIndexById(this._terminals,c);if(I!==null){this._terminals[I]._id=g,this._onDidOpenTerminal.fire(this.terminals[I]),this._terminals[I].isOpen=!0;return}}const a={name:v.name,shellPath:v.executable,shellArgs:v.args,cwd:typeof v.cwd=="string"?v.cwd:T.URI.revive(v.cwd),env:v.env,hideFromUser:v.hideFromUser},S=new _(this._proxy,g,a,f);this._terminals.push(S),this._onDidOpenTerminal.fire(S.value),S.isOpen=!0}async $acceptTerminalProcessId(g,c){const f=this._getTerminalById(g);f&&f._setProcessId(c)}async $startExtensionTerminal(g,c){const f=this._getTerminalById(g);if(!f)return{message:(0,A.localize)(0,null,g)};f.isOpen||await new Promise(a=>{const S=this.onDidOpenTerminal(async I=>{I===f.value&&(S.dispose(),a())})});const v=this._terminalProcesses.get(g);v?v.startSendingEvents(c):this._extensionTerminalAwaitingStart[g]={initialDimensions:c}}_setupExtHostProcessListeners(g,c){const f=new P.DisposableStore;f.add(c.onProcessReady(a=>this._proxy.$sendProcessReady(g,a.pid,a.cwd))),f.add(c.onDidChangeProperty(a=>this._proxy.$sendProcessProperty(g,a))),this._bufferer.startBuffering(g,c.onProcessData),f.add(c.onProcessExit(a=>this._onProcessExit(g,a))),this._terminalProcesses.set(g,c);const v=this._extensionTerminalAwaitingStart[g];return v&&c instanceof m&&(c.startSendingEvents(v.initialDimensions),delete this._extensionTerminalAwaitingStart[g]),f}$acceptProcessAckDataEvent(g,c){this._terminalProcesses.get(g)?.acknowledgeDataEvent(c)}$acceptProcessInput(g,c){this._terminalProcesses.get(g)?.input(c)}$acceptTerminalInteraction(g){const c=this._getTerminalById(g);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(g,c,f){try{this._terminalProcesses.get(g)?.resize(c,f)}catch(v){if(v.code!=="EPIPE"&&v.code!=="ERR_IPC_CHANNEL_CLOSED")throw v}}$acceptProcessShutdown(g,c){this._terminalProcesses.get(g)?.shutdown(c)}$acceptProcessRequestInitialCwd(g){this._terminalProcesses.get(g)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(g,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(g){this._terminalProcesses.get(g)?.getCwd().then(c=>this._proxy.$sendProcessProperty(g,{type:"cwd",value:c}))}$acceptProcessRequestLatency(g){return g}registerLinkProvider(g){return this._linkProviders.add(g),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(g),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(g,c,f){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,f),this._proxy.$registerProfileProvider(c,g.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(g,c){const f=new i.CancellationTokenSource().token;let v=await this._profileProviders.get(g)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(v&&!("options"in v)&&(v={options:v}),!v||!("options"in v))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in v.options){this.createExtensionTerminal(v.options,c);return}this.createTerminalFromOptions(v.options,c)}}async $provideLinks(g,c){const f=this._getTerminalById(g);if(!f)return[];this._terminalLinkCache.delete(g);const v=this._terminalLinkCancellationSource.get(g);v&&v.dispose(!0);const a=new i.CancellationTokenSource;this._terminalLinkCancellationSource.set(g,a);const S=[],I={terminal:f.value,line:c},N=[];for(const O of this._linkProviders)N.push(F.Promises.withAsyncBody(async z=>{a.token.onCancellationRequested(()=>z({provider:O,links:[]}));const U=await O.provideTerminalLinks(I,a.token)||[];a.token.isCancellationRequested||z({provider:O,links:U})}));const B=await Promise.all(N);if(a.token.isCancellationRequested)return[];const y=new Map;for(const O of B)O&&O.links.length>0&&S.push(...O.links.map(z=>{const U={id:h++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return y.set(U.id,{provider:O.provider,link:z}),U}));return this._terminalLinkCache.set(g,y),S}$activateLink(g,c){const f=this._terminalLinkCache.get(g)?.get(c);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(g,c){this._bufferer.stopBuffering(g),this._terminalProcesses.delete(g),delete this._extensionTerminalAwaitingStart[g];const f=this._terminalProcessDisposables[g];f&&(f.dispose(),delete this._terminalProcessDisposables[g]),this._proxy.$sendProcessExit(g,c)}_getTerminalById(g){return this._getTerminalObjectById(this._terminals,g)}_getTerminalObjectById(g,c){const f=this._getTerminalObjectIndexById(g,c);return f!==null?g[f]:null}_getTerminalObjectIndexById(g,c){let f=null;return g.some((v,a)=>v._id===c?(f=a,!0):!1),f}getEnvironmentVariableCollection(g){let c=this._environmentVariableCollections.get(g.identifier.value);return c||(c=new l,this._setEnvironmentVariableCollection(g.identifier.value,c)),c}_syncEnvironmentVariableCollection(g,c){const f=(0,w.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(g,c.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(g){g.forEach(c=>{const f=c[0],v=new l(c[1]);this._setEnvironmentVariableCollection(f,v)})}$acceptDefaultProfile(g,c){this._defaultProfile=g,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(g,c){this._environmentVariableCollections.set(g,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(g,c)})}};D=Be([$e(1,k.IExtHostRpcService)],D),e.BaseExtHostTerminalService=D;class l{constructor(g){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new s.Emitter,this.map=new Map(g)}get persistent(){return this._persistent}set persistent(g){this._persistent=g,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(g,c){this._setIfDiffers(g,{value:c,type:C.EnvironmentVariableMutatorType.Replace})}append(g,c){this._setIfDiffers(g,{value:c,type:C.EnvironmentVariableMutatorType.Append})}prepend(g,c){this._setIfDiffers(g,{value:c,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(g,c){const f=this.map.get(g);(!f||f.value!==c.value||f.type!==c.type)&&(this.map.set(g,c),this._onDidChangeCollection.fire())}get(g){return this.map.get(g)}forEach(g,c){this.map.forEach((f,v)=>g.call(c,v,f,this))}delete(g){this.map.delete(g),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let M=class extends D{constructor(g){super(!1,g)}createTerminal(g,c,f){throw new R.NotSupportedError}createTerminalFromOptions(g,c){throw new R.NotSupportedError}};M=Be([$e(0,k.IExtHostRpcService)],M),e.WorkerExtHostTerminalService=M;function r(b){if(!(!b||typeof b=="string"))return"id"in b?{id:b.id,color:b.color}:b}function n(b){return u.ThemeColor.isThemeColor(b)?b:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(ee,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!E:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(ee,s):E?E.value=s:e.set(ee,s),s},ke=this&&this.__classPrivateFieldGet||function(ee,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(ee):t?t.value:e.get(ee)};define(Ee[199],ye([0,1,16,22,20,4,231,57,6,26,10,36,5,13,48,8,7,168,88,67]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let D=class{constructor(I,N){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=I.getProxy(i.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new M(this.proxy),N.registerArgumentProcessor({processArgument:B=>B?.$mid===13?u.TestItem.toItemFromContext(B):B})}createTestController(I,N,B){if(this.controllers.has(I))throw new Error(`Attempt to insert a duplicate controller with ID "${I}"`);const y=new C.DisposableStore,O=y.add(new F.SingleUseTestCollection(I));O.root.label=N;const z=new Map,U=this.proxy,$={items:O.root.children,get label(){return N},set label(J){N=J,O.root.label=J,U.$updateController(I,{label:N})},get refreshHandler(){return B},set refreshHandler(J){B=J,U.$updateController(I,{canRefresh:!!J})},get id(){return I},createRunProfile:(J,G,ae,we,Se)=>{let ce=(0,P.hash)(J);for(;z.has(ce);)ce++;const oe=new v(this.proxy,I,ce,J,G,ae,we,Se);return z.set(ce,oe),oe},createTestItem(J,G,ae){return new o.TestItemImpl(I,J,G,ae)},createTestRun:(J,G,ae=!0)=>this.runTracker.createTestRun(I,O,J,G,ae),set resolveHandler(J){O.resolveHandler=J},get resolveHandler(){return O.resolveHandler},dispose:()=>{y.dispose()}};U.$registerTestController(I,N,!!B),y.add((0,C.toDisposable)(()=>U.$unregisterTestController(I)));const W={controller:$,collection:O,profiles:z};return this.controllers.set(I,W),y.add((0,C.toDisposable)(()=>this.controllers.delete(I))),y.add(O.onDidGenerateDiff(J=>U.$publishDiff(I,J))),$}createTestObserver(){return this.observer.checkout()}async runTests(I,N=E.CancellationToken.None){const B=r(I);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const y=this.controllers.get(B.controllerId);if(!y)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:I.include?.map(O=>O.id)??[y.collection.root.id],profileGroup:a[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:I.exclude?.map(O=>O.id)},N)}$provideFileCoverage(I,N,B){return(0,s.mapFind)(this.runTracker.trackers,O=>O.id===I?O.getCoverage(N):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(I,N,B,y){return(0,s.mapFind)(this.runTracker.trackers,z=>z.id===I?z.getCoverage(N):void 0)?.resolveFileCoverage(B,y)??Promise.resolve([])}$configureRunProfile(I,N){this.controllers.get(I)?.profiles.get(N)?.configureHandler?.()}async $refreshTests(I){await this.controllers.get(I)?.controller.refreshHandler?.()}$publishTestResults(I){this.results=Object.freeze(I.map(N=>(0,A.deepFreeze)(u.TestResults.to(N))).concat(this.results).sort((N,B)=>B.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(I,N){const B=this.controllers.get(m.TestId.fromString(I).controllerId)?.collection;B&&(await B.expand(I,N<0?1/0:N),B.flushDiff())}$acceptDiff(I){this.observer.applyDiff(I)}async $runControllerTests(I,N){const B=this.controllers.get(I.controllerId);if(!B)return;const{collection:y,profiles:O}=B,z=O.get(I.profileId);if(!z)return;const U=I.testIds.map(G=>y.tree.get(G)).filter(R.isDefined),$=I.excludeExtIds.map(G=>B.collection.tree.get(G)).filter(R.isDefined).filter(G=>U.some(ae=>ae.fullId.compare(G.fullId)===2));if(!U.length)return;const W=new d.TestRunRequest(U.some(G=>G.actual instanceof o.TestItemRootImpl)?void 0:U.map(G=>G.actual),$.map(G=>G.actual),z),J=this.runTracker.prepareForMainThreadTestRun(W,n.fromInternal(I,B.collection),N);try{await z.runHandler(W,N)}finally{J.isRunning&&!N.isCancellationRequested&&await T.Event.toPromise(J.onEnd),J.dispose()}}$cancelExtensionTestRun(I){I===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(I)}};D=Be([$e(0,p.IExtHostRpcService)],D),e.ExtHostTesting=D;class l extends C.Disposable{constructor(I,N,B){super();this.dto=I,this.proxy=N,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:y}of this.tasks.values())y.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(I){return this.tasks.get(I)?.coverage}createRun(I){const N=this.dto.id,B=this.dto.controllerId,y=(0,w.generateUuid)(),O=new b(this.proxy,N,y),z=J=>(G,...ae)=>{if($){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(G)||(this.ensureTestIsKnown(G),J(G,...ae))},U=(J,G)=>{const ae=G instanceof Array?G.map(u.TestMessage.from):[u.TestMessage.from(G)];if(J.uri&&J.range){const we={range:u.Range.from(J.range),uri:J.uri};for(const Se of ae)Se.location=Se.location||we}this.proxy.$appendTestMessagesInRun(N,y,m.TestId.fromExtHostTestItem(J,B).toString(),ae)};let $=!1;const W={isPersisted:this.dto.isPersisted,token:this.cts.token,name:I,get coverageProvider(){return O.coverageProvider},set coverageProvider(J){O.coverageProvider=J},enqueued:z(J=>{this.proxy.$updateTestStateInRun(N,y,m.TestId.fromExtHostTestItem(J,B).toString(),1)}),skipped:z(J=>{this.proxy.$updateTestStateInRun(N,y,m.TestId.fromExtHostTestItem(J,B).toString(),5)}),started:z(J=>{this.proxy.$updateTestStateInRun(N,y,m.TestId.fromExtHostTestItem(J,B).toString(),2)}),errored:z((J,G,ae)=>{U(J,G),this.proxy.$updateTestStateInRun(N,y,m.TestId.fromExtHostTestItem(J,B).toString(),6,ae)}),failed:z((J,G,ae)=>{U(J,G),this.proxy.$updateTestStateInRun(N,y,m.TestId.fromExtHostTestItem(J,B).toString(),4,ae)}),passed:z((J,G)=>{this.proxy.$updateTestStateInRun(N,y,m.TestId.fromExtHostTestItem(J,this.dto.controllerId).toString(),3,G)}),appendOutput:(J,G,ae)=>{$||(ae&&(this.dto.isIncluded(ae)?this.ensureTestIsKnown(ae):ae=void 0),this.proxy.$appendOutputToRun(N,y,t.VSBuffer.fromString(J),G&&u.location.from(G),ae&&m.TestId.fromExtHostTestItem(ae,B).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(N,y),this.tasks.delete(y),this.isRunning||this.dispose())}};return this.tasks.set(y,{run:W,coverage:O}),this.proxy.$startedTestRunTask(N,{id:y,name:I,running:!0}),W}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(I){if(!(I instanceof o.TestItemImpl))throw new o.InvalidTestItemError(I.id);if(this.sharedTestIds.has(m.TestId.fromExtHostTestItem(I,this.dto.controllerId).toString()))return;const N=[],B=this.dto.colllection.root;for(;;){const y=u.TestItem.from(I);if(N.unshift(y),this.sharedTestIds.has(y.extId)||(this.sharedTestIds.add(y.extId),I===B))break;I=I.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,N)}}class M{constructor(I){this.proxy=I,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(I,N,B){return this.getTracker(I,N,B)}cancelRunById(I){for(const N of this.tracked.values())if(N.id===I){N.dispose();return}}cancelAllRuns(){for(const I of this.tracked.values())I.dispose()}createTestRun(I,N,B,y,O){const z=this.tracked.get(B);if(z)return z.createRun(y);const U=n.fromPublic(I,N,B,O),$=r(B);this.proxy.$startedExtensionTestRun({controllerId:I,profile:$&&{group:a[$.kind],id:$.profileId},exclude:B.exclude?.map(J=>J.id)??[],id:U.id,include:B.include?.map(J=>J.id)??[N.root.id],persist:O});const W=this.getTracker(B,U);return W.onEnd(()=>this.proxy.$finishedExtensionTestRun(U.id)),W.createRun(y)}getTracker(I,N,B){const y=new l(N,this.proxy,B);return this.tracked.set(I,y),y.onEnd(()=>this.tracked.delete(I)),y}}e.TestRunCoordinator=M;const r=S=>{if(!!S.profile){if(!(S.profile instanceof v))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return S.profile}};class n{constructor(I,N,B,y,O,z){this.controllerId=I,this.id=N,this.isPersisted=O,this.colllection=z,this.includePrefix=B.map(U=>U+"\0"),this.excludePrefix=y.map(U=>U+"\0")}static fromPublic(I,N,B,y){return new n(I,(0,w.generateUuid)(),B.include?.map(O=>m.TestId.fromExtHostTestItem(O,I).toString())??[I],B.exclude?.map(O=>m.TestId.fromExtHostTestItem(O,I).toString())??[],y,N)}static fromInternal(I,N){return new n(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,N)}isIncluded(I){const N=m.TestId.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(N===B||N.startsWith(B))return!1;for(const B of this.includePrefix)if(N===B||N.startsWith(B))return!0;return!1}}e.TestRunDto=n;class b{constructor(I,N,B){this.proxy=I,this.runId=N,this.taskId=B}set coverageProvider(I){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!I||(this._coverageProvider=I,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(I){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(I))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(N){throw this.fileCoverage=void 0,N}}async resolveFileCoverage(I,N){const B=await this.fileCoverage;let y=B?.[I];return!this._coverageProvider||!B||!y?[]:(y.detailedCoverage||(y=B[I]=await this._coverageProvider.resolveFileCoverage?.(y,N)??y),y.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class g extends _.IncrementalChangeCollector{constructor(I){super();this.emitter=I,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(I){this.added.add(I)}update(I){Object.assign(I.revived,u.TestItem.toPlain(I.item)),this.added.has(I)||this.updated.add(I)}remove(I){if(this.added.has(I)){this.added.delete(I);return}if(this.updated.delete(I),I.parent&&this.alreadyRemoved.has(I.parent)){this.alreadyRemoved.add(I.item.extId);return}this.removed.add(I)}getChangeEvent(){const{added:I,updated:N,removed:B}=this;return{get added(){return[...I].map(y=>y.revived)},get updated(){return[...N].map(y=>y.revived)},get removed(){return[...B].map(y=>y.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(I){return this.items.get(I)}getMirroredTestDataByReference(I){return this.items.get(I.id)}createItem(I,N){return{...I,revived:u.TestItem.toPlain(I.item),depth:N?N.depth+1:0,children:new Set}}createChangeCollector(){return new g(this.changeEmitter)}}e.MirroredTestCollection=c;class f{constructor(I){this.proxy=I}checkout(){this.current||(this.current=this.createObserverData());const I=this.current;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(N=>N.revived)},dispose:(0,k.once)(()=>{--I.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(I){return this.current?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.current?.tests.apply(I)}createObserverData(){const I=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:I}}}class v{constructor(I,N,B,y,O,z,U=!1,$=void 0){this.controllerId=N,this.profileId=B,this._label=y,this.kind=O,this.runHandler=z,this._isDefault=U,this._tag=$,h.set(this,void 0),Ze(this,h,I,"f");const W=a[O];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${O}`);ke(this,h,"f").$publishTestRunProfile({profileId:B,controllerId:N,tag:$?u.TestTag.namespace(this.controllerId,$.id):null,label:y,group:W,isDefault:U,hasConfigurationHandler:!1})}get label(){return this._label}set label(I){I!==this._label&&(this._label=I,ke(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:I}))}get isDefault(){return this._isDefault}set isDefault(I){I!==this._isDefault&&(this._isDefault=I,ke(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,ke(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:I?u.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(I){I!==this._configureHandler&&(this._configureHandler=I,ke(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!I}))}dispose(){ke(this,h,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=v,h=new WeakMap;const a={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Ee[200],ye([0,1,4,16,5,92,8,7]),function(ee,e,s,t,E,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(R,w){this._extHostDocumentsAndEditors=w,this._onDidChangeTextEditorSelection=new s.Emitter,this._onDidChangeTextEditorOptions=new s.Emitter,this._onDidChangeTextEditorVisibleRanges=new s.Emitter,this._onDidChangeTextEditorViewColumn=new s.Emitter,this._onDidChangeActiveTextEditor=new s.Emitter,this._onDidChangeVisibleTextEditors=new s.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(i=>this._onDidChangeVisibleTextEditors.fire(i)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(i=>this._onDidChangeActiveTextEditor.fire(i))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const w=this._extHostDocumentsAndEditors.allEditors();return R?w:w.map(i=>i.value)}async showTextDocument(R,w,i){let p;typeof w=="number"?p={position:k.ViewColumn.from(w),preserveFocus:i}:typeof w=="object"?p={position:k.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?k.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:p={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(R.uri,p),u=o&&this._extHostDocumentsAndEditors.getEditor(o);if(u)return u.value;throw o?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,w){return new T.TextEditorDecorationType(this._proxy,R,w).value}$acceptEditorPropertiesChanged(R,w){const i=this._extHostDocumentsAndEditors.getEditor(R);if(!i)throw new Error("unknown text editor");if(w.options&&i._acceptOptions(w.options),w.selections){const p=w.selections.selections.map(k.Selection.to);i._acceptSelections(p)}if(w.visibleRanges){const p=t.coalesce(w.visibleRanges.map(k.Range.to));i._acceptVisibleRanges(p)}if(w.options&&this._onDidChangeTextEditorOptions.fire({textEditor:i.value,options:{...w.options,lineNumbers:k.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const p=P.TextEditorSelectionChangeKind.fromValue(w.selections.source),o=w.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:i.value,selections:o,kind:p})}if(w.visibleRanges){const p=t.coalesce(w.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:i.value,visibleRanges:p})}}$acceptEditorPositionData(R){for(const w in R){const i=this._extHostDocumentsAndEditors.getEditor(w);if(!i)throw new Error("Unknown text editor");const p=k.ViewColumn.to(R[w]);i.value.viewColumn!==p&&(i._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:i.value,viewColumn:p}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=C}),define(Ee[201],ye([0,1,2,3,5,6,7]),function(ee,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class P{constructor(R,w){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(E.MainContext.MainThreadTimeline),w.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===11){const p=i.uri===void 0?void 0:s.URI.revive(i.uri);return this._itemsBySourceAndUriMap.get(i.source)?.get(C(p))?.get(i.handle)}return i}})}async $getTimeline(R,w,i,p,o){return this._providers.get(R)?.provideTimeline(s.URI.revive(w),i,p,o)}registerTimelineProvider(R,w,i,p){const o=new T.DisposableStore,u=this.convertTimelineItem(w.id,p,o).bind(this);let d;w.onDidChange&&(d=w.onDidChange(_=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,..._,id:w.id}),this));const F=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...w,scheme:R,onDidChange:void 0,async provideTimeline(_,m,h,D){D?.resetCache&&(o.clear(),F.get(w.id)?.clear());const l=await w.provideTimeline(_,m,h);if(l==null)return;const M=u(_,D);return{...l,source:w.id,items:l.items.map(M)}},dispose(){for(const _ of F.values())_.get(w.id)?.clear();d?.dispose(),o.dispose()}})}convertTimelineItem(R,w,i){return(p,o)=>{let u;if(o?.cacheResults){let d=this._itemsBySourceAndUriMap.get(R);d===void 0&&(d=new Map,this._itemsBySourceAndUriMap.set(R,d));const F=C(p);u=d.get(F),u===void 0&&(u=new Map,d.set(F,u))}return d=>{const{iconPath:F,..._}=d,m=`${R}|${d.id??d.timestamp}`;u?.set(m,d);let h,D,l;return d.iconPath&&(F instanceof k.ThemeIcon?l={id:F.id,color:F.color}:s.URI.isUri(F)?(h=F,D=F):{light:h,dark:D}=F),{..._,id:_.id??void 0,handle:m,source:R,command:d.command?w.toInternal(d.command,i):void 0,icon:h,iconDark:D,themeIcon:l,accessibilityInformation:d.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,T.toDisposable)(()=>{for(const i of this._itemsBySourceAndUriMap.values())i.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=P;function C(A){return A?.toString()}}),define(Ee[202],ye([0,1,6,11,2,5]),function(ee,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(C){this._openers=new Map,this._proxy=C.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,A,R,w){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const i=w.schemes.find(p=>!k.supportedSchemes.has(p));if(i)throw new Error(`Scheme '${i}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,R),this._proxy.$registerUriOpener(A,w.schemes,C,w.label),(0,s.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(C,A,R){const w=this._openers.get(C);if(!w)throw new Error(`Unknown opener with id: ${C}`);const i=E.URI.revive(A);return w.canOpenExternalUri(i,R)}async $openUri(C,A,R){const w=this._openers.get(C);if(!w)throw new Error(`Unknown opener id: '${C}'`);return w.openExternalUri(E.URI.revive(A.resolvedUri),{sourceUri:E.URI.revive(A.sourceUri)},R)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(Ee[203],ye([0,1,5,2,6,15,25]),function(ee,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(s.MainContext.MainThreadUrls)}registerUriHandler(A,R){if(this.handles.has(k.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const w=P.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(A)),this.handlers.set(w,R),this._proxy.$registerUriHandler(w,A),(0,E.toDisposable)(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(A)),this.handlers.delete(w),this._proxy.$unregisterUriHandler(w)})}$handleExternalUri(A,R){const w=this.handlers.get(A);if(!w)return Promise.resolve(void 0);try{w.handleUri(t.URI.revive(R))}catch(i){(0,T.onUnexpectedError)(i)}return Promise.resolve(void 0)}async createAppUri(A){return t.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=P,P.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(ee,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!E:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(ee,s):E?E.value=s:e.set(ee,s),s},ke=this&&this.__classPrivateFieldGet||function(ee,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(ee):t?t.value:e.get(ee)};define(Ee[51],ye([0,1,4,11,2,131,151,66,5]),function(ee,e,s,t,E,T,k,P,C){"use strict";var A,R,w,i,p,o,u,d,F,_,m,h;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class D{constructor(f,v,a,S,I,N,B){A.set(this,void 0),R.set(this,void 0),w.set(this,void 0),i.set(this,void 0),p.set(this,void 0),o.set(this,void 0),u.set(this,""),d.set(this,void 0),F.set(this,!1),_.set(this,!1),m.set(this,!1),this._onMessageEmitter=new s.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,h.set(this,new s.Emitter),this._onDidDispose=ke(this,h,"f").event,Ze(this,A,f,"f"),Ze(this,R,v,"f"),Ze(this,d,a,"f"),Ze(this,i,S,"f"),Ze(this,p,I,"f"),Ze(this,o,N,"f"),Ze(this,m,l(N),"f"),Ze(this,w,B,"f")}dispose(){Ze(this,F,!0,"f"),ke(this,h,"f").fire(),ke(this,h,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return Ze(this,_,!0,"f"),(0,P.asWebviewUri)(f,ke(this,i,"f").remote)}get cspSource(){const f=ke(this,o,"f").extensionLocation;if(f.scheme===t.Schemas.https||f.scheme===t.Schemas.http){let v=f.toString();return v.endsWith("/")||(v+="/"),v+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),ke(this,u,"f")}set html(f){this.assertNotDisposed(),ke(this,u,"f")!==f&&(Ze(this,u,f,"f"),!ke(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(Ze(this,_,!0,"f"),ke(this,w,"f").report("Webview vscode-resource: uris",ke(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),ke(this,R,"f").$setHtml(ke(this,A,"f"),f))}get options(){return this.assertNotDisposed(),ke(this,d,"f")}set options(f){this.assertNotDisposed(),ke(this,R,"f").$setOptions(ke(this,A,"f"),n(ke(this,o,"f"),ke(this,p,"f"),f)),Ze(this,d,f,"f")}async postMessage(f){if(ke(this,F,"f"))return!1;const v=(0,k.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:ke(this,m,"f")});return ke(this,R,"f").$postMessage(ke(this,A,"f"),v.message,...v.buffers)}assertNotDisposed(){if(ke(this,F,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=D,A=new WeakMap,R=new WeakMap,w=new WeakMap,i=new WeakMap,p=new WeakMap,o=new WeakMap,u=new WeakMap,d=new WeakMap,F=new WeakMap,_=new WeakMap,m=new WeakMap,h=new WeakMap;function l(c){try{const f=(0,T.normalizeVersion)((0,T.parseVersion)(c.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;class M{constructor(f,v,a,S,I){this.initData=v,this.workspace=a,this._logService=S,this._deprecationService=I,this._webviews=new Map,this._webviewProxy=f.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(f,v,a){const S=this.getWebview(f);if(S){const{message:I}=(0,k.deserializeWebviewMessage)(v,a.value);S._onMessageEmitter.fire(I)}}$onMissingCsp(f,v){this._logService.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,v,a){const S=new D(f,this._webviewProxy,b(v),this.initData,this.workspace,a,this._deprecationService);return this._webviews.set(f,S),S._onDidDispose(()=>{this._webviews.delete(f)}),S}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=M;function r(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=r;function n(c,f,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||g(c,f)}}e.serializeWebviewOptions=n;function b(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(f=>E.URI.from(f))}}e.reviveOptions=b;function g(c,f){return[...(f?.getWorkspaceFolders()||[]).map(v=>v.uri),c.extensionLocation]}}),define(Ee[204],ye([0,1,20,57,6,11,24,2,8,51,63,5,7]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(l,M){this.document=l,this._storagePath=M,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(l){return this._edits.add([l])}async undo(l,M){await this.getEdit(l).undo(),M||this.disposeBackup()}async redo(l,M){await this.getEdit(l).redo(),M||this.disposeBackup()}disposeEdits(l){for(const M of l)this._edits.delete(M)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const l=h(this.document.uri)+this._backupCounter++;return(0,k.joinPath)(this._storagePath,l)}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(l){const M=this._edits.get(l,0);if(!M)throw new Error("No edit found");return M}}class o{constructor(){this._documents=new Map}get(l,M){return this._documents.get(this.key(l,M))}add(l,M,r){const n=this.key(l,M.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${l} resource:${M.uri}`);const b=new p(M,r);return this._documents.set(n,b),b}delete(l,M){const r=this.key(l,M.uri);this._documents.delete(r)}key(l,M){return`${l}@@@${M}`}}var u;(function(D){D[D.Text=0]="Text",D[D.Custom=1]="Custom"})(u||(u={}));class d{constructor(){this._providers=new Map}addTextProvider(l,M,r){return this.add(0,l,M,r)}addCustomProvider(l,M,r){return this.add(1,l,M,r)}get(l){return this._providers.get(l)}add(l,M,r,n){if(this._providers.has(M))throw new Error(`Provider for viewType:${M} already registered`);return this._providers.set(M,{type:l,extension:r,provider:n}),new i.Disposable(()=>this._providers.delete(M))}}class F{constructor(l,M,r,n,b){this._extHostDocuments=M,this._extensionStoragePaths=r,this._extHostWebview=n,this._extHostWebviewPanels=b,this._editorProviders=new d,this._documents=new o,this._proxy=l.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,M,r,n){const b=new E.DisposableStore;return _(r)?(b.add(this._editorProviders.addTextProvider(M,l,r)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(l),M,n.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(l))):(b.add(this._editorProviders.addCustomProvider(M,l,r)),this.supportEditing(r)&&b.add(r.onDidChangeCustomDocument(g=>{const c=this.getCustomDocumentEntry(M,g.document.uri);if(m(g)){const f=c.addEdit(g);this._proxy.$onDidEdit(g.document.uri,M,f,g.label)}else this._proxy.$onContentChange(g.document.uri,M)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(l),M,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(l))),i.Disposable.from(b,new i.Disposable(()=>{this._proxy.$unregisterEditorProvider(M)}))}async $createCustomDocument(l,M,r,n,b){const g=this._editorProviders.get(M);if(!g)throw new Error(`No provider found for '${M}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${M}'`);const c=P.URI.revive(l),f=await g.provider.openCustomDocument(c,{backupId:r,untitledDocumentData:n?.buffer},b);let v;return this.supportEditing(g.provider)&&this._extensionStoragePaths&&(v=this._extensionStoragePaths.workspaceValue(g.extension)??this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(M,f,v),{editable:this.supportEditing(g.provider)}}async $disposeCustomDocument(l,M){const r=this._editorProviders.get(M);if(!r)throw new Error(`No provider found for '${M}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${M}'`);const n=P.URI.revive(l),{document:b}=this.getCustomDocumentEntry(M,n);this._documents.delete(M,b),b.dispose()}async $resolveWebviewEditor(l,M,r,n,b,g){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);const f=C.ViewColumn.to(b),v=this._extHostWebview.createNewWebview(M,n.webviewOptions,c.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(M,r,n.title,f,n.panelOptions,v),S=P.URI.revive(l);switch(c.type){case 1:{const{document:I}=this.getCustomDocumentEntry(r,S);return c.provider.resolveCustomEditor(I,a,g)}case 0:{const I=this._extHostDocuments.getDocument(S);return c.provider.resolveCustomTextEditor(I,a,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,M,r){this.getCustomDocumentEntry(M,l).disposeEdits(r)}async $onMoveCustomEditor(l,M,r){const n=this._editorProviders.get(r);if(!n)throw new Error(`No provider found for '${r}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const b=this._extHostWebviewPanels.getWebviewPanel(l);if(!b)throw new Error("No webview found");const g=P.URI.revive(M),c=this._extHostDocuments.getDocument(g);await n.provider.moveCustomTextEditor(c,b,s.CancellationToken.None)}async $undo(l,M,r,n){return this.getCustomDocumentEntry(M,l).undo(r,n)}async $redo(l,M,r,n){return this.getCustomDocumentEntry(M,l).redo(r,n)}async $revert(l,M,r){const n=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).revertCustomDocument(n.document,r),n.disposeBackup()}async $onSave(l,M,r){const n=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).saveCustomDocument(n.document,r),n.disposeBackup()}async $onSaveAs(l,M,r,n){const b=this.getCustomDocumentEntry(M,l);return this.getCustomEditorProvider(M).saveCustomDocumentAs(b.document,P.URI.revive(r),n)}async $backup(l,M,r){const n=this.getCustomDocumentEntry(M,l),g=await this.getCustomEditorProvider(M).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},r);return n.updateBackup(g),g.id}getCustomDocumentEntry(l,M){const r=this._documents.get(l,P.URI.revive(M));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(l){const r=this._editorProviders.get(l)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(l){return!!l.onDidChangeCustomDocument}}e.ExtHostCustomEditors=F;function _(D){return typeof D.resolveCustomTextEditor=="function"}function m(D){return typeof D.undo=="function"&&typeof D.redo=="function"}function h(D){const l=D.scheme===T.Schemas.file||D.scheme===T.Schemas.untitled?D.fsPath:D.toString();return(0,t.hash)(l)+""}});var Ze=this&&this.__classPrivateFieldSet||function(ee,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!E:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(ee,s):E?E.value=s:e.set(ee,s),s},ke=this&&this.__classPrivateFieldGet||function(ee,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(ee):t?t.value:e.get(ee)};define(Ee[205],ye([0,1,4,6,2,36,8,51,5,7]),function(ee,e,s,t,E,T,k,P,C,A){"use strict";var R,w,i,p,o,u,d,F,_,m,h,D,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class M extends t.Disposable{constructor(g,c,f,v,a,S,I){super();R.set(this,void 0),w.set(this,void 0),i.set(this,void 0),p.set(this,void 0),o.set(this,void 0),u.set(this,void 0),d.set(this,void 0),F.set(this,void 0),_.set(this,!0),m.set(this,!0),h.set(this,!1),D.set(this,this._register(new s.Emitter)),this.onDidDispose=ke(this,D,"f").event,l.set(this,this._register(new s.Emitter)),this.onDidChangeViewState=ke(this,l,"f").event,Ze(this,R,g,"f"),Ze(this,w,c,"f"),Ze(this,i,f,"f"),Ze(this,o,S,"f"),Ze(this,F,a,"f"),Ze(this,u,v,"f"),Ze(this,p,I,"f")}dispose(){ke(this,h,"f")||(Ze(this,h,!0,"f"),ke(this,D,"f").fire(),ke(this,w,"f").$disposeWebview(ke(this,R,"f")),ke(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),ke(this,p,"f")}get viewType(){return this.assertNotDisposed(),ke(this,i,"f")}get title(){return this.assertNotDisposed(),ke(this,u,"f")}set title(g){this.assertNotDisposed(),ke(this,u,"f")!==g&&(Ze(this,u,g,"f"),ke(this,w,"f").$setTitle(ke(this,R,"f"),g))}get iconPath(){return this.assertNotDisposed(),ke(this,d,"f")}set iconPath(g){this.assertNotDisposed(),ke(this,d,"f")!==g&&(Ze(this,d,g,"f"),ke(this,w,"f").$setIconPath(ke(this,R,"f"),E.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return ke(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof ke(this,F,"f")=="number"&&ke(this,F,"f")<0))return ke(this,F,"f")}get active(){return this.assertNotDisposed(),ke(this,m,"f")}get visible(){return this.assertNotDisposed(),ke(this,_,"f")}_updateViewState(g){ke(this,h,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(Ze(this,m,g.active,"f"),Ze(this,_,g.visible,"f"),Ze(this,F,g.viewColumn,"f"),ke(this,l,"f").fire({webviewPanel:this}))}reveal(g,c){this.assertNotDisposed(),ke(this,w,"f").$reveal(ke(this,R,"f"),{viewColumn:g?k.ViewColumn.from(g):void 0,preserveFocus:!!c})}assertNotDisposed(){if(ke(this,h,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,w=new WeakMap,i=new WeakMap,p=new WeakMap,o=new WeakMap,u=new WeakMap,d=new WeakMap,F=new WeakMap,_=new WeakMap,m=new WeakMap,h=new WeakMap,D=new WeakMap,l=new WeakMap;class r{constructor(g,c,f){this.webviews=c,this.workspace=f,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(g,c,f,v,a={}){const S=typeof v=="object"?v.viewColumn:v,I={viewColumn:k.ViewColumn.from(S),preserveFocus:typeof v=="object"&&!!v.preserveFocus},N=(0,P.shouldSerializeBuffersForPostMessage)(g),B=r.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(g),B,c,{title:f,panelOptions:n(a),webviewOptions:(0,P.serializeWebviewOptions)(g,this.workspace,a),serializeBuffersForPostMessage:N},I);const y=this.webviews.createNewWebview(B,a,g);return this.createNewWebviewPanel(B,c,f,S,a,y)}$onDidChangeWebviewPanelViewStates(g){const c=Object.keys(g);c.sort((f,v)=>{const a=g[f],S=g[v];return a.active?1:S.active?-1:+a.visible-+S.visible});for(const f of c){const v=this.getWebviewPanel(f);if(!v)continue;const a=g[f];v._updateViewState({active:a.active,visible:a.visible,viewColumn:k.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,c,f){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:f,extension:g}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(g)}),new A.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(g,c,f,v){const a=this._serializers.get(c);if(!a)throw new Error(`No serializer found for '${c}'`);const{serializer:S,extension:I}=a,N=this.webviews.createNewWebview(g,f.webviewOptions,I),B=this.createNewWebviewPanel(g,c,f.title,v,f.panelOptions,N);await S.deserializeWebviewPanel(B,f.state)}createNewWebviewPanel(g,c,f,v,a,S){const I=new M(g,this._proxy,c,f,v,a,S);return this._webviewPanels.set(g,I),I}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=r;function n(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(ee,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!E:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(ee,s):E?E.value=s:e.set(ee,s),s},ke=this&&this.__classPrivateFieldGet||function(ee,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(ee):t?t.value:e.get(ee)};define(Ee[206],ye([0,1,4,6,51,5,7]),function(ee,e,s,t,E,T,k){"use strict";var P,C,A,R,w,i,p,o,u,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class F extends t.Disposable{constructor(h,D,l,M,r,n){super();P.set(this,void 0),C.set(this,void 0),A.set(this,void 0),R.set(this,void 0),w.set(this,!1),i.set(this,void 0),p.set(this,void 0),o.set(this,void 0),u.set(this,this._register(new s.Emitter)),this.onDidChangeVisibility=ke(this,u,"f").event,d.set(this,this._register(new s.Emitter)),this.onDidDispose=ke(this,d,"f").event,Ze(this,A,l,"f"),Ze(this,p,M,"f"),Ze(this,P,h,"f"),Ze(this,C,D,"f"),Ze(this,R,r,"f"),Ze(this,i,n,"f")}dispose(){ke(this,w,"f")||(Ze(this,w,!0,"f"),ke(this,d,"f").fire(),ke(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),ke(this,p,"f")}set title(h){this.assertNotDisposed(),ke(this,p,"f")!==h&&(Ze(this,p,h,"f"),ke(this,C,"f").$setWebviewViewTitle(ke(this,P,"f"),h))}get description(){return this.assertNotDisposed(),ke(this,o,"f")}set description(h){this.assertNotDisposed(),ke(this,o,"f")!==h&&(Ze(this,o,h,"f"),ke(this,C,"f").$setWebviewViewDescription(ke(this,P,"f"),h))}get visible(){return ke(this,i,"f")}get webview(){return ke(this,R,"f")}get viewType(){return ke(this,A,"f")}_setVisible(h){h===ke(this,i,"f")||ke(this,w,"f")||(Ze(this,i,h,"f"),ke(this,u,"f").fire())}show(h){this.assertNotDisposed(),ke(this,C,"f").$show(ke(this,P,"f"),!!h)}assertNotDisposed(){if(ke(this,w,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,C=new WeakMap,A=new WeakMap,R=new WeakMap,w=new WeakMap,i=new WeakMap,p=new WeakMap,o=new WeakMap,u=new WeakMap,d=new WeakMap;class _{constructor(h,D){this._extHostWebview=D,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,D,l,M){if(this._viewProviders.has(D))throw new Error(`View provider for '${D}' already registered`);return this._viewProviders.set(D,{provider:l,extension:h}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(h),D,{retainContextWhenHidden:M?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(D),this._proxy.$unregisterWebviewViewProvider(D)})}async $resolveWebviewView(h,D,l,M,r){const n=this._viewProviders.get(D);if(!n)throw new Error(`No view provider found for '${D}'`);const{provider:b,extension:g}=n,c=this._extHostWebview.createNewWebview(h,{},g),f=new F(h,this._proxy,D,l,c,!0);this._webviewViews.set(h,f),await b.resolveWebviewView(f,{state:M},r)}async $onDidChangeWebviewViewVisibility(h,D){this.getWebviewView(h)._setVisible(D)}async $disposeWebviewView(h){const D=this.getWebviewView(h);this._webviewViews.delete(h),D.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const D=this._webviewViews.get(h);if(!D)throw new Error("No webview found");return D}}e.ExtHostWebviewViews=_}),define(Ee[95],ye([0,1,4,5,2,11,9,3,13]),function(ee,e,s,t,E,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class Wi{constructor(w){this._onDidChangeWindowState=new s.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wi.InitialState,this._proxy=w.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(i=>this.$onDidChangeWindowFocus(i))}get state(){return this._state}$onDidChangeWindowFocus(w){w!==this._state.focused&&(this._state={...this._state,focused:w},this._onDidChangeWindowState.fire(this._state))}openUri(w,i){let p;if(typeof w=="string"){p=w;try{w=E.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,k.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this._proxy.$openUri(w,p,i)}async asExternalUri(w,i){if((0,k.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(w,i);return E.URI.from(p)}};A.InitialState={focused:!0},A=Be([$e(0,C.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(Ee[207],ye([0,1,14,22,20,15,4,6,105,174,38]),function(ee,e,s,t,E,T,k,P,C,A,R){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function i(a,S){try{return JSON.stringify(a,S)}catch{return"null"}}const p="$$ref$$",o={[p]:-1};class u{constructor(S,I){this.jsonString=S,this.referencedBuffers=I}}function d(a,S=null,I=!1){const N=[];return{jsonString:(I?i:JSON.stringify)(a,(y,O)=>{if(typeof O=="undefined")return o;if(typeof O=="object"){if(O instanceof t.VSBuffer){const z=N.push(O)-1;return{[p]:z}}if(S)return S(y,O)}return O}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=d;function F(a,S,I){return JSON.parse(a,(N,B)=>{if(B){const y=B[p];if(typeof y=="number")return S[y];if(I&&B.$mid===1)return I.transformIncoming(B)}return B})}e.parseJsonAndRestoreBufferRefs=F;function _(a,S){return JSON.stringify(a,S)}function m(a){return a?(S,I)=>I&&I.$mid===1?a.transformOutgoing(I):I:null}var h;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var D;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(D=e.ResponsiveState||(e.ResponsiveState={}));const l=()=>{},M=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class n extends P.Disposable{constructor(S,I=null,N=null){super();this[w]=!0,this._onDidChangeResponsiveState=this._register(new k.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=S,this._logger=I,this._uriTransformer=N,this._uriReplacer=m(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let B=0,y=R.ProxyIdentifier.count;B<y;B++)this._locals[B]=null,this._proxies[B]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new s.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(B=>this._receiveOneMessage(B))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(S=>{this._pendingRPCReplies[S].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(S){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(S){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(S){this._responsiveState!==S&&(this._responsiveState=S,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(S){return this._uriTransformer?(0,C.transformIncomingURIs)(S,this._uriTransformer):S}getProxy(S){const{nid:I,sid:N}=S;return this._proxies[I]||(this._proxies[I]=this._createProxy(I,N)),this._proxies[I]}_createProxy(S,I){let N={get:(B,y)=>(typeof y=="string"&&!B[y]&&y.charCodeAt(0)===36&&(B[y]=(...O)=>this._remoteCall(S,y,O)),y===r?I:B[y])};return new Proxy(Object.create(null),N)}set(S,I){return this._locals[S.nid]=I,I}assertRegistered(S){for(let I=0,N=S.length;I<N;I++){const B=S[I];if(!this._locals[B.nid])throw new Error(`Missing actor ${B.sid} (isMain: ${B.isMain})`)}}_receiveOneMessage(S){if(this._isDisposed)return;const I=S.byteLength,N=b.read(S,0),B=N.readUInt8(),y=N.readUInt32();switch(B){case 1:case 2:{let{rpcId:O,method:z,args:U}=c.deserializeRequestJSONArgs(N);this._uriTransformer&&(U=(0,C.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(I,y,O,z,U,B===2);break}case 3:case 4:{let{rpcId:O,method:z,args:U}=c.deserializeRequestMixedArgs(N);this._uriTransformer&&(U=(0,C.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(I,y,O,z,U,B===4);break}case 5:{this._logger&&this._logger.logIncoming(I,y,0,"ack"),this._onDidReceiveAcknowledge(y);break}case 6:{this._receiveCancel(I,y);break}case 7:{this._receiveReply(I,y,void 0);break}case 9:{let O=c.deserializeReplyOKJSON(N);this._uriTransformer&&(O=(0,C.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReply(I,y,O);break}case 10:{const O=c.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(I,y,O);break}case 8:{let O=c.deserializeReplyOKVSBuffer(N);this._receiveReply(I,y,O);break}case 11:{let O=c.deserializeReplyErrError(N);this._uriTransformer&&(O=(0,C.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReplyErr(I,y,O);break}case 12:{this._receiveReplyErr(I,y,void 0);break}default:console.error("received unexpected message"),console.error(S)}}_receiveRequest(S,I,N,B,y,O){this._logger&&this._logger.logIncoming(S,I,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(N)}.${B}(`,y);const z=String(I);let U,$;if(O){const J=new E.CancellationTokenSource;y.push(J.token),U=this._invokeHandler(N,B,y),$=()=>J.cancel()}else U=this._invokeHandler(N,B,y),$=l;this._cancelInvokedHandlers[z]=$;const W=c.serializeAcknowledged(I);this._logger&&this._logger.logOutgoing(W.byteLength,I,1,"ack"),this._protocol.send(W),U.then(J=>{delete this._cancelInvokedHandlers[z];const G=c.serializeReplyOK(I,J,this._uriReplacer);this._logger&&this._logger.logOutgoing(G.byteLength,I,1,"reply:",J),this._protocol.send(G)},J=>{delete this._cancelInvokedHandlers[z];const G=c.serializeReplyErr(I,J);this._logger&&this._logger.logOutgoing(G.byteLength,I,1,"replyErr:",J),this._protocol.send(G)})}_receiveCancel(S,I){this._logger&&this._logger.logIncoming(S,I,1,"receiveCancel");const N=String(I);this._cancelInvokedHandlers[N]&&this._cancelInvokedHandlers[N]()}_receiveReply(S,I,N){this._logger&&this._logger.logIncoming(S,I,0,"receiveReply:",N);const B=String(I);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const y=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B],y.resolveOk(N)}_receiveReplyErr(S,I,N){this._logger&&this._logger.logIncoming(S,I,0,"receiveReplyErr:",N);const B=String(I);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const y=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B];let O;N&&(N.$isError?(O=new Error,O.name=N.name,O.message=N.message,O.stack=N.stack):O=N),y.resolveErr(O)}_invokeHandler(S,I,N){try{return Promise.resolve(this._doInvokeHandler(S,I,N))}catch(B){return Promise.reject(B)}}_doInvokeHandler(S,I,N){const B=this._locals[S];if(!B)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(S));let y=B[I];if(typeof y!="function")throw new Error("Unknown method "+I+" on actor "+(0,R.getStringIdentifierForProxy)(S));return y.apply(B,N)}_remoteCall(S,I,N){if(this._isDisposed)return Promise.reject(T.canceled());let B=null;if(N.length>0&&E.CancellationToken.isCancellationToken(N[N.length-1])&&(B=N.pop()),B&&B.isCancellationRequested)return Promise.reject(T.canceled());const y=c.serializeRequestArguments(N,this._uriReplacer),O=++this._lastMessageId,z=String(O),U=new A.LazyPromise;B&&B.onCancellationRequested(()=>{const W=c.serializeCancel(O);this._logger&&this._logger.logOutgoing(W.byteLength,O,0,"cancel"),this._protocol.send(c.serializeCancel(O))}),this._pendingRPCReplies[z]=U,this._onWillSendRequest(O);const $=c.serializeRequest(O,S,I,y,!!B);return this._logger&&this._logger.logOutgoing($.byteLength,O,0,`request: ${(0,R.getStringIdentifierForProxy)(S)}.${I}(`,N),this._protocol.send($),U}}e.RPCProtocol=n,w=M,n.UNRESPONSIVE_TIME=3*1e3;class b{constructor(S,I){this._buff=S,this._offset=I}static alloc(S,I,N){let B=new b(t.VSBuffer.alloc(N+1+4),0);return B.writeUInt8(S),B.writeUInt32(I),B}static read(S,I){return new b(S,I)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(S){this._buff.writeUInt8(S,this._offset),this._offset+=1}readUInt8(){const S=this._buff.readUInt8(this._offset);return this._offset+=1,S}writeUInt32(S){this._buff.writeUInt32BE(S,this._offset),this._offset+=4}readUInt32(){const S=this._buff.readUInt32BE(this._offset);return this._offset+=4,S}static sizeShortString(S){return 1+S.byteLength}writeShortString(S){this._buff.writeUInt8(S.byteLength,this._offset),this._offset+=1,this._buff.set(S,this._offset),this._offset+=S.byteLength}readShortString(){const S=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,N}static sizeLongString(S){return 4+S.byteLength}writeLongString(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readLongString(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,N}writeBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}static sizeVSBuffer(S){return 4+S.byteLength}writeVSBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readVSBuffer(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const I=this._buff.slice(this._offset,this._offset+S);return this._offset+=S,I}static sizeMixedArray(S){let I=0;I+=1;for(let N=0,B=S.length;N<B;N++){const y=S[N];switch(I+=1,y.type){case 1:I+=this.sizeLongString(y.value);break;case 2:I+=this.sizeVSBuffer(y.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(y.value);for(let O=0;O<y.buffers.length;++O)I+=this.sizeVSBuffer(y.buffers[O]);break;case 4:break}}return I}writeMixedArray(S){this._buff.writeUInt8(S.length,this._offset),this._offset+=1;for(let I=0,N=S.length;I<N;I++){const B=S[I];switch(B.type){case 1:this.writeUInt8(1),this.writeLongString(B.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(B.value);break;case 3:this.writeUInt8(3),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let y=0;y<B.buffers.length;++y)this.writeBuffer(B.buffers[y]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const S=this._buff.readUInt8(this._offset);this._offset+=1;let I=new Array(S);for(let N=0;N<S;N++)switch(this.readUInt8()){case 1:I[N]=this.readLongString();break;case 2:I[N]=this.readVSBuffer();break;case 3:{const y=this.readUInt32(),O=this.readLongString(),z=[];for(let U=0;U<y;++U)z.push(this.readVSBuffer());I[N]=new R.SerializableObjectWithBuffers(F(O,z,null));break}case 4:I[N]=void 0;break}return I}}b.sizeUInt32=4;var g;(function(a){a[a.Simple=0]="Simple",a[a.Mixed=1]="Mixed"})(g||(g={}));class c{static _useMixedArgSerialization(S){for(let I=0,N=S.length;I<N;I++)if(S[I]instanceof t.VSBuffer||S[I]instanceof R.SerializableObjectWithBuffers||typeof S[I]=="undefined")return!0;return!1}static serializeRequestArguments(S,I){if(this._useMixedArgSerialization(S)){const N=[];for(let B=0,y=S.length;B<y;B++){const O=S[B];if(O instanceof t.VSBuffer)N[B]={type:2,value:O};else if(typeof O=="undefined")N[B]={type:4};else if(O instanceof R.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:U}=d(O.value,I);N[B]={type:3,value:t.VSBuffer.fromString(z),buffers:U}}else N[B]={type:1,value:t.VSBuffer.fromString(_(O,I))}}return{type:1,args:N}}return{type:0,args:_(S,I)}}static serializeRequest(S,I,N,B,y){switch(B.type){case 0:return this._requestJSONArgs(S,I,N,B.args,y);case 1:return this._requestMixedArgs(S,I,N,B.args,y)}}static _requestJSONArgs(S,I,N,B,y){const O=t.VSBuffer.fromString(N),z=t.VSBuffer.fromString(B);let U=0;U+=b.sizeUInt8(),U+=b.sizeShortString(O),U+=b.sizeLongString(z);let $=b.alloc(y?2:1,S,U);return $.writeUInt8(I),$.writeShortString(O),$.writeLongString(z),$.buffer}static deserializeRequestJSONArgs(S){const I=S.readUInt8(),N=S.readShortString(),B=S.readLongString();return{rpcId:I,method:N,args:JSON.parse(B)}}static _requestMixedArgs(S,I,N,B,y){const O=t.VSBuffer.fromString(N);let z=0;z+=b.sizeUInt8(),z+=b.sizeShortString(O),z+=b.sizeMixedArray(B);let U=b.alloc(y?4:3,S,z);return U.writeUInt8(I),U.writeShortString(O),U.writeMixedArray(B),U.buffer}static deserializeRequestMixedArgs(S){const I=S.readUInt8(),N=S.readShortString(),B=S.readMixedArray(),y=new Array(B.length);for(let O=0,z=B.length;O<z;O++){const U=B[O];typeof U=="string"?y[O]=JSON.parse(U):y[O]=U}return{rpcId:I,method:N,args:y}}static serializeAcknowledged(S){return b.alloc(5,S,0).buffer}static serializeCancel(S){return b.alloc(6,S,0).buffer}static serializeReplyOK(S,I,N){if(typeof I=="undefined")return this._serializeReplyOKEmpty(S);if(I instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(S,I);if(I instanceof R.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:y}=d(I.value,N,!0);return this._serializeReplyOKJSONWithBuffers(S,B,y)}else return this._serializeReplyOKJSON(S,i(I,N))}static _serializeReplyOKEmpty(S){return b.alloc(7,S,0).buffer}static _serializeReplyOKVSBuffer(S,I){let N=0;N+=b.sizeVSBuffer(I);let B=b.alloc(8,S,N);return B.writeVSBuffer(I),B.buffer}static deserializeReplyOKVSBuffer(S){return S.readVSBuffer()}static _serializeReplyOKJSON(S,I){const N=t.VSBuffer.fromString(I);let B=0;B+=b.sizeLongString(N);let y=b.alloc(9,S,B);return y.writeLongString(N),y.buffer}static _serializeReplyOKJSONWithBuffers(S,I,N){const B=t.VSBuffer.fromString(I);let y=0;y+=b.sizeUInt32,y+=b.sizeLongString(B);for(const z of N)y+=b.sizeVSBuffer(z);let O=b.alloc(10,S,y);O.writeUInt32(N.length),O.writeLongString(B);for(const z of N)O.writeBuffer(z);return O.buffer}static deserializeReplyOKJSON(S){const I=S.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(S,I){const N=S.readUInt32(),B=S.readLongString(),y=[];for(let O=0;O<N;++O)y.push(S.readVSBuffer());return new R.SerializableObjectWithBuffers(F(B,y,I))}static serializeReplyErr(S,I){return I?this._serializeReplyErrEror(S,I):this._serializeReplyErrEmpty(S)}static _serializeReplyErrEror(S,I){const N=t.VSBuffer.fromString(i(T.transformErrorForSerialization(I),null));let B=0;B+=b.sizeLongString(N);let y=b.alloc(11,S,B);return y.writeLongString(N),y.buffer}static deserializeReplyErrError(S){const I=S.readLongString();return JSON.parse(I)}static _serializeReplyErrEmpty(S){return b.alloc(12,S,0).buffer}}var f;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",a[a.ReplyErrError=11]="ReplyErrError",a[a.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var v;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",a[a.Undefined=4]="Undefined"})(v||(v={}))}),define(Ee[208],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const s=function(T){const k=P=>{self.removeEventListener("message",k);const C=P.data;Object.defineProperties(self,{postMessage:{value(A,R){C.postMessage(A,R)}},onmessage:{get(){return C.onmessage},set(A){C.onmessage=A}}}),C.addEventListener("message",A=>{self.dispatchEvent(new MessageEvent("message",{data:A.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",k)}.toString();class t extends EventTarget{constructor(T,k,P){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${s})('${k}'))`,A=new Blob([C],{type:"application/javascript"}),R=URL.createObjectURL(A),w=new MessageChannel,i=R,p={type:"_newWorker",id:i,port:w.port2,url:R,options:P};T(p,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:i};w.port1.postMessage(o),URL.revokeObjectURL(R),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(o){w.port1.onmessage=o}},onmessageerror:{get(){return w.port1.onmessageerror},set(o){w.port1.onmessageerror=o}}}),w.port1.addEventListener("messageerror",o=>{const u=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(u)}),w.port1.addEventListener("message",o=>{const u=new MessageEvent("message",{data:o.data});this.dispatchEvent(u)}),w.port1.start()}}e.NestedWorker=t}),define(Ee[209],ye([0,1,3]),function(ee,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,s.createDecorator)("remoteAgentService")}),define(Ee[210],ye([0,1,35,11,17,23,24,2,3,61,47,169,209]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let p=class Vi{constructor(u,d,F,_){this.localUserHome=u,this.remoteAgentService=d,this.environmentService=F,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||T.OS)(),this.resolveUserHome=(async()=>{const m=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=m?.userHome||u})()}hasValidBasename(u,d,F){return typeof d=="string"||typeof d=="undefined"?this.resolveOS.then(_=>this.doHasValidBasename(u,_,d)):this.doHasValidBasename(u,d,F)}doHasValidBasename(u,d,F){return u.scheme===t.Schemas.file||u.scheme===t.Schemas.vscodeRemote?(0,s.isValidBasename)(F??(0,k.basename)(u),d===1):!0}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(u,d){if(u.remoteAuthority)return t.Schemas.vscodeRemote;const F=(0,A.getVirtualWorkspaceScheme)(d.getWorkspace());if(F)return F;const _=d.getWorkspace().folders[0];if(_)return _.uri.scheme;const m=d.getWorkspace().configuration;return m?m.scheme:t.Schemas.file}async userHome(u){return u?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(u=>u===1?E.win32:E.posix)}async fileURI(u){let d="";if(await this.resolveOS===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const _=u.indexOf("/",2);_===-1?(d=u.substring(2),u="/"):(d=u.substring(2,_),u=u.substring(_)||"/")}return P.URI.from({scheme:t.Schemas.file,authority:d,path:u,query:"",fragment:""})}};p=Be([$e(1,i.IRemoteAgentService),$e(2,w.IWorkbenchEnvironmentService),$e(3,R.IWorkspaceContextService)],p),e.AbstractPathService=p}),define(Ee[96],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class s{constructor(k,P){this.line=k,this.character=P}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,P){return new s(0,0)}with(k){return new s(0,0)}}e.Position=s;class t{constructor(k,P,C,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new s(k,P),this.end=new s(C,A)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new t(0,0,0,0)}with(k){return new t(0,0,0,0)}}e.Range=t;var E;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[41],ye([0,1,16,29,26,35,9,3,17,15,96,10]),function(ee,e,s,t,E,T,k,P,C,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const i="\u27EA ",p=" characters skipped \u27EB",o=(i.length+p.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var u;(function(W){W[W.file=0]="file",W[W.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(W){W[W.File=1]="File",W[W.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function F(W){return!!W.preview}e.resultIsMatch=F;function _(W){return!!W.resource}e.isFileMatch=_;function m(W){return!!W.message}e.isProgressMessage=m;var h;(function(W){W[W.Normal=0]="Normal",W[W.NewSearchStarted=1]="NewSearchStarted"})(h=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class D{constructor(J){this.resource=J,this.results=[]}}e.FileMatch=D;class l{constructor(J,G,ae){this.ranges=G;const we=Array.isArray(G)?G:[G];if(ae&&ae.matchLines===1&&M(we)){J=(0,k.getNLines)(J,ae.matchLines);let Se="",ce=0,oe=0;const be=Math.floor(ae.charsPerLine/5),Pe=[];for(const Me of we){const He=Math.max(Me.startColumn-be,0),Ye=Me.startColumn+ae.charsPerLine;if(He>oe+be+o){const Qe=i+(He-oe)+p;Se+=Qe+J.slice(He,Ye),ce+=He-(oe+Qe.length)}else Se+=J.slice(oe,Ye);Pe.push(new n(0,Me.startColumn-ce,Me.endColumn-ce)),oe=Ye}this.preview={text:Se,matches:Array.isArray(this.ranges)?Pe:Pe[0]}}else{const Se=Array.isArray(G)?G[0].startLineNumber:G.startLineNumber;this.preview={text:J,matches:(0,s.mapArrayOrNot)(G,ce=>new r(ce.startLineNumber-Se,ce.startColumn,ce.endLineNumber-Se,ce.endColumn))}}}}e.TextSearchMatch=l;function M(W){const J=W[0].startLineNumber;for(const G of W)if(G.startLineNumber!==J||G.endLineNumber!==J)return!1;return!0}class r{constructor(J,G,ae,we){this.startLineNumber=J,this.startColumn=G,this.endLineNumber=ae,this.endColumn=we}}e.SearchRange=r;class n extends r{constructor(J,G,ae){super(J,G,J,ae)}}e.OneLineRange=n;var b;(function(W){W.Default="default",W.FileNames="fileNames",W.Type="type",W.Modified="modified",W.CountDescending="countDescending",W.CountAscending="countAscending"})(b=e.SearchSortOrder||(e.SearchSortOrder={}));function g(W,J=!0){const G=W&&W.files&&W.files.exclude,ae=J&&W&&W.search&&W.search.exclude;if(!G&&!ae)return;if(!G||!ae)return G||ae;let we=Object.create(null);return we=E.mixin(we,E.deepClone(G)),we=E.mixin(we,E.deepClone(ae),!0),we}e.getExcludes=g;function c(W,J){return W.excludePattern&&t.match(W.excludePattern,J)?!1:W.includePattern||W.usingSearchPaths?W.includePattern&&t.match(W.includePattern,J)?!0:W.usingSearchPaths?!!W.folderQueries&&W.folderQueries.some(G=>{const ae=G.folder.fsPath;if(T.isEqualOrParent(J,ae)){const we=C.relative(ae,J);return!G.includePattern||!!t.match(G.includePattern,we)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var f;(function(W){W[W.unknownEncoding=1]="unknownEncoding",W[W.regexParseError=2]="regexParseError",W[W.globParseError=3]="globParseError",W[W.invalidLiteral=4]="invalidLiteral",W[W.rgProcessError=5]="rgProcessError",W[W.other=6]="other",W[W.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class v extends Error{constructor(J,G){super(J);this.code=G}}e.SearchError=v;function a(W){const J=W.message;if((0,A.isPromiseCanceledError)(W))return new v(J,f.canceled);try{const G=JSON.parse(J);return new v(G.message,G.code)}catch{return new v(J,f.other)}}e.deserializeSearchError=a;function S(W){const J={message:W.message,code:W.code};return new Error(JSON.stringify(J))}e.serializeSearchError=S;function I(W){return W.type==="error"?!0:W.type==="success"}e.isSerializedSearchComplete=I;function N(W){return W.type==="success"}e.isSerializedSearchSuccess=N;function B(W){return!!W.path}e.isSerializedFileMatch=B;function y(W,J){const G=W.searchPath?W.searchPath:W.relativePath;return(0,k.fuzzyContains)(G,J)}e.isFilePatternMatch=y;class O{constructor(J){this.path=J,this.results=[]}addMatch(J){this.results.push(J)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function z(W,J){const G={...W||{},...J||{}};return Object.keys(G).filter(ae=>{const we=G[ae];return typeof we=="boolean"&&we})}e.resolvePatternsForProvider=z;class U{constructor(J,G){this._parsedIncludeExpression=null,this._excludeExpression={...J.excludePattern||{},...G.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let ae=J.includePattern;G.includePattern&&(ae?ae={...ae,...G.includePattern}:ae=G.includePattern),ae&&(this._parsedIncludeExpression=t.parse(ae))}matchesExcludesSync(J,G,ae){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(J,G,ae))}includedInQuerySync(J,G,ae){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(J,G,ae)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(J,G,ae))}includedInQuery(J,G,ae){const we=this._parsedExcludeExpression(J,G,ae),Se=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(J,G,ae):!0;return(0,w.isPromise)(we)?we.then(ce=>ce?!1:Se()):Se()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=U;function $(W){for(const J in W)if(typeof W[J]!="boolean")return!0;return!1}}),define(Ee[31],ye([0,1,16,14,20,4,21,11,75,24,9,10,2,124,3,12,137,47,30,28,13,7,41,5]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m,h,D,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(S,I,N){return new A.ExtUri(B=>c(B,N)).isEqual(S,I)}function n(S,I,N){return r(S.uri,I.uri,N)?0:(0,R.compare)(S.uri.toString(),I.uri.toString())}function b(S,I,N){return S.index!==I.index?S.index<I.index?-1:1:r(S.uri,I.uri,N)?(0,R.compare)(S.name,I.name):(0,R.compare)(S.uri.toString(),I.uri.toString())}function g(S,I,N,B){const y=S.slice(0).sort((z,U)=>N(z,U,B)),O=I.slice(0).sort((z,U)=>N(z,U,B));return(0,s.delta)(y,O,(z,U)=>N(z,U,B))}function c(S,I){const N=I.getCapabilities(S.scheme);return!(N&&N&1024)}class f extends F.Workspace{constructor(I,N,B,y,O,z,U){super(I,B.map($=>new F.WorkspaceFolder($)),y,O,U);this._name=N,this._isUntitled=z,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(U),B.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(I,N,B,y){if(!I)return{workspace:null,added:[],removed:[]};const{id:O,name:z,folders:U,configuration:$,transient:W,isUntitled:J}=I,G=[],ae=N;N?U.forEach((oe,be)=>{const Pe=i.URI.revive(oe.uri),Me=f._findFolder(B||N,Pe,y);Me?(Me.name=oe.name,Me.index=oe.index,G.push(Me)):G.push({uri:Pe,name:oe.name,index:be})}):G.push(...U.map(({uri:oe,name:be,index:Pe})=>({uri:i.URI.revive(oe),name:be,index:Pe}))),G.sort((oe,be)=>oe.index<be.index?-1:1);const we=new f(O,z,G,!!W,$?i.URI.revive($):null,!!J,oe=>c(oe,y)),{added:Se,removed:ce}=g(ae?ae.workspaceFolders:[],we.workspaceFolders,n,y);return{workspace:we,added:Se,removed:ce}}static _findFolder(I,N,B){for(let y=0;y<I.folders.length;y++){const O=I.workspaceFolders[y];if(r(O.uri,N,B))return O}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(I,N){return N&&this._structure.get(I)&&(I=(0,A.dirname)(I)),this._structure.findSubstr(I)}resolveWorkspaceFolder(I){return this._structure.get(I)}}let v=class{constructor(I,N,B,y){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=y,this._extHostFileSystemInfo=B,this._requestIdProvider=new C.Counter,this._barrier=new t.Barrier,this._proxy=I.getProxy(M.MainContext.MainThreadWorkspace),this._messageService=I.getProxy(M.MainContext.MainThreadMessageService);const O=N.workspace;this._confirmedWorkspace=O?new f(O.id,O.name,[],!!O.transient,O.configuration?i.URI.revive(O.configuration):null,!!O.isUntitled,z=>c(z,B)):void 0}$initializeWorkspace(I,N){this._trusted=N,this.$acceptWorkspaceData(I),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?i.URI.from({scheme:P.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(I,N,B,...y){const O=[];if(Array.isArray(y)&&y.forEach(J=>{i.URI.isUri(J.uri)&&!O.some(G=>r(G.uri,J.uri,this._extHostFileSystemInfo))&&O.push({uri:J.uri,name:J.name||(0,A.basenameOrAuthority)(J.uri)})}),this._unconfirmedWorkspace||[N,B].some(J=>typeof J!="number"||J<0)||B===0&&O.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+B>z.length)return!1;const U=z.slice(0);U.splice(N,B,...O.map(J=>({uri:J.uri,name:J.name||(0,A.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<U.length;J++){const G=U[J];if(U.some((ae,we)=>we!==J&&r(G.uri,ae.uri,this._extHostFileSystemInfo)))return!1}U.forEach((J,G)=>J.index=G);const{added:$,removed:W}=g(z,U,b,this._extHostFileSystemInfo);if($.length===0&&W.length===0)return!1;if(this._proxy){const J=I.displayName||I.name;this._proxy.$updateWorkspaceFolders(J,N,B,O).then(void 0,G=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(d.Severity.Error,(0,p.localize)(0,null,J,G.toString()),{extension:I},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(I,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(I,N)}async getWorkspaceFolder2(I,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(I,N)}async resolveWorkspaceFolder(I){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(I)}getPath(){if(!this._actualWorkspace)return;const{folders:I}=this._actualWorkspace;if(I.length!==0)return I[0].uri.fsPath}getRelativePath(I,N){let B,y="";if(typeof I=="string"?(B=i.URI.file(I),y=I):typeof I!="undefined"&&(B=I,y=I.fsPath),!B)return y;const O=this.getWorkspaceFolder(B,!0);if(!O)return y;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let z=(0,A.relativePath)(O.uri,B);return N&&O.name&&(z=`${O.name}/${z}`),z}trySetWorkspaceFolders(I){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:I,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(I){const{workspace:N,added:B,removed:y}=f.toExtHostWorkspace(I,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:y}))}findFiles(I,N,B,y,O=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${y.value}, entryPoint: findFiles`);let z;if(N===null?z=!1:N&&(typeof N=="string"?z=N:z=N.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:$}=a(I);return this._proxy.$startFileSearch((0,w.withUndefinedAsNull)(U),(0,w.withUndefinedAsNull)($),(0,w.withUndefinedAsNull)(z),(0,w.withUndefinedAsNull)(B),O).then(W=>Array.isArray(W)?W.map(J=>i.URI.revive(J)):[])}async findTextInFiles(I,N,B,y,O=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${y.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),U=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:$,folder:W}=a(N.include),J=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,G={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:U,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:$,excludePattern:J},ae=!1;if(this._activeSearchCallbacks[z]=we=>{if(ae)return;const Se=i.URI.revive(we.resource);we.results.forEach(ce=>{(0,l.resultIsMatch)(ce)?B({uri:Se,preview:{text:ce.preview.text,matches:(0,s.mapArrayOrNot)(ce.preview.matches,oe=>new D.Range(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))},ranges:(0,s.mapArrayOrNot)(ce.ranges,oe=>new D.Range(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))}):B({uri:Se,text:ce.text,lineNumber:ce.lineNumber})})},O.isCancellationRequested)return{};try{const we=await this._proxy.$startTextSearch(I,(0,w.withUndefinedAsNull)(W),G,z,O);return delete this._activeSearchCallbacks[z],we||{}}catch(we){throw delete this._activeSearchCallbacks[z],we}}$handleTextSearchResult(I,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](I)}saveAll(I){return this._proxy.$saveAll(I)}resolveProxy(I){return this._proxy.$resolveProxy(I)}get trusted(){return this._trusted}requestWorkspaceTrust(I){return this._proxy.$requestWorkspaceTrust(I)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};v=Be([$e(0,h.IExtHostRpcService),$e(1,m.IExtHostInitDataService),$e(2,_.IExtHostFileSystemInfo),$e(3,u.ILogService)],v),e.ExtHostWorkspace=v,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function a(S){let I,N;return S&&(typeof S=="string"?I=S:(I=S.pattern,N=S.baseFolder||i.URI.file(S.base))),{includePattern:I,folder:N}}}),define(Ee[32],ye([0,1,26,4,31,5,7,141,83,10,14,3,13,12,2]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(M,r){if(r){const n=r.split(".");let b=M;for(let g=0;b&&g<n.length;g++)b=b[n[g]];return b}}function d(M){return M instanceof o.URI}function F(M){return M&&M.uri instanceof o.URI&&M.languageId&&typeof M.languageId=="string"}function _(M){return M&&!M.uri&&M.languageId&&typeof M.languageId=="string"}function m(M){return M&&M.uri instanceof o.URI&&(!M.name||typeof M.name=="string")&&(!M.index||typeof M.index=="number")}function h(M){if(d(M))return{resource:M};if(F(M))return{resource:M.uri,overrideIdentifier:M.languageId};if(_(M))return{overrideIdentifier:M.languageId};if(m(M))return{resource:M.uri};if(M===null)return{resource:null}}let D=class{constructor(r,n,b){this._proxy=r.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=b,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new l(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,n){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(r,n))}};D=Be([$e(0,i.IExtHostRpcService),$e(1,E.IExtHostWorkspace),$e(2,p.ILogService)],D),e.ExtHostConfiguration=D;class l{constructor(r,n,b,g){this._onDidChangeConfiguration=new t.Emitter,this._proxy=r,this._logService=g,this._extHostWorkspace=n,this._configuration=P.Configuration.parse(b),this._configurationScopes=this._toMap(b.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,n){const b={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,b))}getConfiguration(r,n,b){const g=h(n)||{},c=this._toReadonlyValue(r?u(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,g,b?.identifier);function f(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const v={has(a){return typeof u(c,a)!="undefined"},get:(a,S)=>{this._validateConfigurationAccess(r?`${r}.${a}`:a,g,b?.identifier);let I=u(c,a);if(typeof I=="undefined")I=S;else{let N;const B=(y,O)=>{let z;const U=()=>{N=N||(0,s.deepClone)(c),z=z||u(N,O)};return(0,A.isObject)(y)?new Proxy(y,{get:($,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return U(),()=>z;if(N)return z=z||u(N,O),z[W];const J=$[W];return typeof W=="string"?B(J,`${O}.${W}`):J},set:($,W,J)=>(U(),z&&(z[W]=J),!0),deleteProperty:($,W)=>(U(),z&&delete z[W],!0),defineProperty:($,W,J)=>(U(),z&&Object.defineProperty(z,W,J),!0)}):y};I=B(I,a)}return I},update:(a,S,I,N)=>{a=r?`${r}.${a}`:a;const B=f(I);return S!==void 0?this._proxy.$updateConfigurationOption(B,a,S,g,N):this._proxy.$removeConfigurationOption(B,a,g,N)},inspect:a=>{a=r?`${r}.${a}`:a;const S=(0,s.deepClone)(this._configuration.inspect(a,g,this._extHostWorkspace.workspace));if(S)return{key:a,defaultValue:S.default?.value,globalValue:S.user?.value,workspaceValue:S.workspace?.value,workspaceFolderValue:S.workspaceFolder?.value,defaultLanguageValue:S.default?.override,globalLanguageValue:S.user?.override,workspaceLanguageValue:S.workspace?.override,workspaceFolderLanguageValue:S.workspaceFolder?.override,languageIds:S.overrideIdentifiers}}};return typeof c=="object"&&(0,s.mixin)(v,c,!1),Object.freeze(v)}_toReadonlyValue(r){const n=b=>(0,A.isObject)(b)?new Proxy(b,{get:(g,c)=>n(g[c]),set:(g,c,f)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(g,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(g,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return n(r)}_validateConfigurationAccess(r,n,b){const g=C.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),c=b?`[${b.value}] `:"";if(g===4){typeof n?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){n?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,n){const b=new P.ConfigurationChangeEvent(r,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,c)=>b.affectsConfiguration(g,h(c))})}_toMap(r){return r.reduce((n,b)=>(n.set(b[0],b[1]),n),new Map)}}e.ExtHostConfigProvider=l,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(ee,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!E:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(ee,s):E?E.value=s:e.set(ee,s),s},ke=this&&this.__classPrivateFieldGet||function(ee,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(ee):t?t.value:e.get(ee)};define(Ee[97],ye([0,1,2,14,4,5,7,31,49,32,20,40,13,28,3,11,23,12,69,160,15]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m,h){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var l;(function(O){function z($){if($!=null)return $}O.from=z;function U($){if($!=null)return $}O.to=U})(l=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var M;(function(O){function z($){if($!=null)return $}O.from=z;function U($){if($!=null)return $}O.to=U})(M=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(O){function z($){if($!=null)return $}O.from=z;function U($){if($!=null)return $}O.to=U})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(O){function z(W){if(W){const J=W;return J&&!!J.process}else return!1}O.is=z;function U(W){if(W==null)return;const J={process:W.process,args:W.args};return W.options&&(J.options=r.from(W.options)),J}O.from=U;function $(W){if(W!=null)return new k.ProcessExecution(W.process,W.args,W.options)}O.to=$})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var b;(function(O){function z($){if($!=null)return $}O.from=z;function U($){if($!=null)return $}O.to=U})(b=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var g;(function(O){function z(W){if(W){const J=W;return J&&(!!J.commandLine||!!J.command)}else return!1}O.is=z;function U(W){if(W==null)return;const J={};return W.commandLine!==void 0?J.commandLine=W.commandLine:(J.command=W.command,J.args=W.args),W.options&&(J.options=b.from(W.options)),J}O.from=U;function $(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new k.ShellExecution(W.commandLine,W.options):new k.ShellExecution(W.command,W.args?W.args:[],W.options)}O.to=$})(g=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(O){function z(W){if(W){let J=W;return J&&J.customExecution==="customExecution"}else return!1}O.is=z;function U(W){return{customExecution:"customExecution"}}O.from=U;function $(W,J){return J.get(W)}O.to=$})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var f;(function(O){function z(U,$){let W;return U.scope!==void 0&&typeof U.scope!="number"?W=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===k.TaskScope.Workspace&&$&&$.workspaceFile?W=$.workspaceFile:W=m.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:W}}O.from=z})(f=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(O){function z(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}O.from=z})(v=e.TaskGroupDTO||(e.TaskGroupDTO={}));var a;(function(O){function z(W,J){if(W==null)return[];const G=[];for(let ae of W){const we=U(ae,J);we&&G.push(we)}return G}O.fromMany=z;function U(W,J){if(W==null)return;let G;W.execution instanceof k.ProcessExecution?G=n.from(W.execution):W.execution instanceof k.ShellExecution?G=g.from(W.execution):W.execution&&W.execution instanceof k.CustomExecution&&(G=c.from(W.execution));const ae=l.from(W.definition);let we;return W.scope?typeof W.scope=="number"?we=W.scope:we=W.scope.uri:we=k.TaskScope.Workspace,!ae||!we?void 0:{_id:W._id,definition:ae,name:W.name,source:{extensionId:J.identifier.value,label:W.source,scope:we},execution:G,isBackground:W.isBackground,group:v.from(W.group),presentationOptions:M.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}O.from=U;async function $(W,J,G){if(W==null)return;let ae;n.is(W.execution)?ae=n.to(W.execution):g.is(W.execution)?ae=g.to(W.execution):c.is(W.execution)&&(ae=c.to(W._id,G));const we=l.to(W.definition);let Se;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?Se=W.source.scope:Se=await J.resolveWorkspaceFolder(s.URI.revive(W.source.scope)):Se=k.TaskScope.Workspace),!we||!Se)return;const ce=new k.Task(we,Se,W.name,W.source.label,ae,W.problemMatchers);return W.isBackground!==void 0&&(ce.isBackground=W.isBackground),W.group!==void 0&&(ce.group=k.TaskGroup.from(W.group._id),ce.group&&W.group.isDefault&&(ce.group=new k.TaskGroup(ce.group.id,ce.group.label),W.group.isDefault&&(ce.group.isDefault=W.group.isDefault))),W.presentationOptions&&(ce.presentationOptions=M.to(W.presentationOptions)),W._id&&(ce._id=W._id),W.detail&&(ce.detail=W.detail),ce}O.to=$})(a=e.TaskDTO||(e.TaskDTO={}));var S;(function(O){function z($){return $}O.from=z;function U($){if(!!$)return Object.assign(Object.create(null),$)}O.to=U})(S=e.TaskFilterDTO||(e.TaskFilterDTO={}));class I{constructor(z,U,$){this._id=U,this._task=$,D.set(this,void 0),Ze(this,D,z,"f")}get task(){return this._task}terminate(){ke(this,D,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}D=new WeakMap;var N;(function(O){function z(U){return{id:U._id,task:void 0}}O.from=z})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(z,U,$,W,J,G,ae,we){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=z.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=W,this._configurationService=J,this._terminalService=G,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ae,this._deprecationService=we,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,U,$){if(!$)return new k.Disposable(()=>{});const W=this.nextHandle();return this._handlers.set(W,{type:U,provider:$,extension:z}),this._proxy.$registerTaskProvider(W,U),new k.Disposable(()=>{this._handlers.delete(W),this._proxy.$unregisterTaskProvider(W)})}registerTaskSystem(z,U){this._proxy.$registerTaskSystem(z,U)}fetchTasks(z){return this._proxy.$fetchTasks(S.from(z)).then(async U=>{const $=[];for(let W of U){const J=await a.to(W,this._workspaceProvider,this._providedCustomExecutions2);J&&$.push(J)}return $})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(U=>z.push(U)),z}terminateTask(z){if(!(z instanceof I))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,U,$){const W=this._providedCustomExecutions2.get(z.id);W&&(this._activeCustomExecutions2.set(z.id,W),this._terminalService.attachPtyToTerminal(U,await W.callback($))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const U=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:U})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const U=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:U,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const U=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:U,exitCode:z.exitCode})}$provideTasks(z,U){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));const W=[],J=(0,t.asPromise)(()=>$.provider.provideTasks(R.CancellationToken.None)).then(G=>this.provideTasksInternal(U,W,$,G));return new Promise(G=>{J.then(ae=>{Promise.all(W).then(()=>{G(ae)})})})}async $resolveTask(z,U){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));if(U.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${$.type}].`);const W=await a.to(U,this._workspaceProvider,this._providedCustomExecutions2);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const J=await $.provider.resolveTask(W,R.CancellationToken.None);if(!J)return;this.checkDeprecation(J,$);const G=a.from(J,$.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(J.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(G.execution)&&await this.addCustomExecution(G,J,!0),await this.resolveTaskInternal(G)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,U,$){const W=await this._proxy.$createTaskId(z);!$&&!this._providedCustomExecutions2.has(W)&&(this._notProvidedCustomExecutions.add(W),this._activeCustomExecutions2.set(W,U.execution)),this._providedCustomExecutions2.set(W,U.execution)}async getTaskExecution(z,U){if(typeof z=="string"){const J=this._taskExecutionPromises.get(z);if(!J)throw new Error("Unexpected: The specified task is missing an execution");return J}let $=this._taskExecutionPromises.get(z.id);if($)return $;const W=new Promise((J,G)=>{function ae(we,Se,ce){ce?J(new I(we,Se.id,ce)):G("Unexpected: Task does not exist.")}U?ae(this,z,U):a.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(we=>ae(this,z,we))});return this._taskExecutionPromises.set(z.id,W),W.then(J=>(this._taskExecutions.set(z.id,J),J),J=>Promise.reject(J))}checkDeprecation(z,U){z._deprecated&&this._deprecationService.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let $=this._notProvidedCustomExecutions.values(),W=$.next();for(;!W.done;)!this._activeCustomExecutions2.has(W.value)&&this._lastStartedTask!==W.value&&(this._providedCustomExecutions2.delete(W.value),this._notProvidedCustomExecutions.delete(W.value)),W=$.next()}};B=Be([$e(0,i.IExtHostRpcService),$e(1,p.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,C.IExtHostDocumentsAndEditors),$e(4,A.IExtHostConfiguration),$e(5,w.IExtHostTerminalService),$e(6,F.ILogService),$e(7,_.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let y=class extends B{constructor(z,U,$,W,J,G,ae,we){super(z,U,$,W,J,G,ae,we);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(z,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const $=a.from(U,z);if($===void 0)throw new Error("Task is not valid");if(c.is($.execution))await this.addCustomExecution($,U,!1);else throw new h.NotSupportedError;const W=await this.getTaskExecution(await this._proxy.$getTaskExecution($),U);return this._proxy.$executeTask($).catch(J=>{throw new Error(J)}),W}provideTasksInternal(z,U,$,W){const J=[];if(W)for(let G of W){this.checkDeprecation(G,$),(!G.definition||!z[G.definition.type])&&this._logService.warn(`The task [${G.source}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`);const ae=a.from(G,$.extension);ae&&c.is(ae.execution)?(J.push(ae),U.push(this.addCustomExecution(ae,G,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:J,extension:$.extension}}async resolveTaskInternal(z){if(c.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,U,$){}};y=Be([$e(0,i.IExtHostRpcService),$e(1,p.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,C.IExtHostDocumentsAndEditors),$e(4,A.IExtHostConfiguration),$e(5,w.IExtHostTerminalService),$e(6,F.ILogService),$e(7,_.IExtHostApiDeprecationService)],y),e.WorkerExtHostTask=y,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(Ee[211],ye([0,1,16,74,29,78,21,11,17,24,9,10,2,232,127,81,47,90,210,41]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(f,v,a,S){this.configurationService=f,this.workspaceContextService=v,this.editorGroupsService=a,this.pathService=S}text(f,v,a={}){f=this.getContentPattern(f,a);const S=this.configurationService.getValue(),I=v&&v.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(v?.map(d.toWorkspaceFolder),a),type:2,contentPattern:f,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:S.search.usePCRE2||I||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles}}getContentPattern(f,v){const a=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const S={...f,wordSeparators:a.editor.wordSeparators};return this.isCaseSensitive(f,v)&&(S.isCaseSensitive=!0),this.isMultiline(f)&&(S.isMultiline=!0),S}file(f,v={}){return{...this.commonQuery(f,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}handleIncludeExclude(f,v){return f?(f=Array.isArray(f)?f.map(n):n(f),v?this.parseSearchPaths(f):{pattern:l(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],v={}){const a=this.handleIncludeExclude(v.includePattern,v.expandPatterns),S=this.handleIncludeExclude(v.excludePattern,v.expandPatterns),I=f.length>1,N=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,v,S)):f.map(O=>this.getFolderQueryForRoot(O,v,S,I))).filter(O=>!!O),B={_reason:v._reason,folderQueries:N,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:S.pattern,includePattern:a.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const z=s.coalesce(s.flatten(this.editorGroupsService.groups.map($=>$.editors.map(W=>W.resource)))).filter($=>(0,m.pathIncludedInQuery)(B,$.fsPath)),U=this.commonQueryFromFileList(z);return{...B,...U}}const y=v.extraFileResources&&v.extraFileResources.filter(O=>(0,m.pathIncludedInQuery)(B,O.fsPath));return B.extraFileResources=y&&y.length?y:void 0,B}commonQueryFromFileList(f){const v=[],a=new k.ResourceMap,S={};let I=!1;return f.forEach(N=>{if(N.scheme===P.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(N)){const y=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:C.dirname(N.fsPath)});let O=a.get(y);O||(I=!0,O={folder:y,includePattern:{}},v.push(O),a.set(y,O));const z=C.relative(y.fsPath,N.fsPath);(0,w.assertIsDefined)(O.includePattern)[z.replace(/\\/g,"/")]=!0}else N.fsPath&&(I=!0,S[N.fsPath]=!0)}),{folderQueries:v,includePattern:S,usingSearchPaths:!0,excludePattern:I?void 0:{"**/*":!0}}}isCaseSensitive(f,v){if(v.isSmartCase){if(f.isRegExp){if(R.containsUppercaseCharacter(f.pattern,!0))return!0}else if(R.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,p.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const v=U=>C.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),S=(Array.isArray(f)?f:M(f)).map(U=>{const $=this.pathService.resolvedUserHome;return $?(0,T.untildify)(U,$.scheme===P.Schemas.file?$.fsPath:$.path):U}),I=t.groupBy(S,U=>v(U)?"searchPaths":"exprSegments"),N=(I.exprSegments||[]).map(U=>R.rtrim(U,"/")).map(U=>R.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),r(U))),B={},y=this.expandSearchPathPatterns(I.searchPaths||[]);y&&y.length&&(B.searchPaths=y);const O=s.flatten(N),z=l(...O);return z&&(B.pattern=z),B}getExcludesForFolder(f,v){return v.disregardExcludeSettings?void 0:(0,m.getExcludes)(f,!v.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const v=s.flatten(f.map(S=>{let{pathPortion:I,globPortion:N}=D(S);N&&(N=b(N));const B=this.expandOneSearchPath(I);return s.flatten(B.map(y=>this.resolveOneSearchPathPattern(y,N)))})),a=new Map;return v.forEach(S=>{const I=S.searchPath.toString(),N=a.get(I);N?S.pattern&&(N.pattern=N.pattern||{},N.pattern[S.pattern]=!0):a.set(I,{searchPath:S.searchPath,pattern:S.pattern?l(S.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(f){if(C.isAbsolute(f)){const v=this.workspaceContextService.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==P.Schemas.file?[{searchPath:v[0].uri.with({path:f})}]:[{searchPath:i.URI.file(C.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const v=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=n(f),f.startsWith("../")||f===".."){const S=C.posix.resolve(v.path,f);return[{searchPath:v.with({path:S})}]}const a=b(f);return[{searchPath:v,pattern:a}]}else{if(f==="./"||f===".\\")return[];{const v=f.replace(/^\.[\/\\]/,""),S=this.workspaceContextService.getWorkspace().folders.map(I=>{const N=v.match(new RegExp(`^${R.escapeRegExpCharacters(I.name)}(?:/(.*)|$)`));return N?{match:N,folder:I}:null}).filter(w.isDefined);if(S.length)return S.map(I=>{const N=I.match[1];return{searchPath:I.folder.uri,pattern:N&&b(N)}});{const I=f.match(/\.[\/\\](.+)[\/\\]?/),N=I?I[1]:f,B=o.localize(0,null,N);throw new Error(B)}}}}resolveOneSearchPathPattern(f,v){const a=f.pattern&&v?`${f.pattern}/${v}`:f.pattern||v,S=[{searchPath:f.searchPath,pattern:a}];return a&&!a.endsWith("**")&&S.push({searchPath:f.searchPath,pattern:a+"/**"}),S}getFolderQueryForSearchPath(f,v,a){const S=this.getFolderQueryForRoot((0,d.toWorkspaceFolder)(f.searchPath),v,a,!1);return S?{...S,includePattern:f.pattern}:null}getFolderQueryForRoot(f,v,a,S){let I;const N=i.URI.isUri(f)?f:f.uri;if(a.searchPaths){const U=a.searchPaths.filter($=>(0,A.isEqual)($.searchPath,N))[0];if(U&&!U.pattern)return null;U&&(I=U.pattern)}const B=this.configurationService.getValue({resource:N}),O={...this.getExcludesForFolder(B,v)||{},...I||{}},z=i.URI.isUri(f)?(0,A.basename)(f):f.name;return{folder:N,folderName:S?z:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!B.search.followSymlinks}}};h=Be([$e(0,u.IConfigurationService),$e(1,d.IWorkspaceContextService),$e(2,F.IEditorGroupsService),$e(3,_.IPathService)],h),e.QueryBuilder=h;function D(c){const f=c.match(/[\*\{\}\(\)\[\]\?]/);if(f){const v=f.index,a=c.substr(0,v).match(/[/|\\][^/\\]*$/);if(a){let S=c.substr(0,a.index);return S.match(/[/\\]/)||(S+="/"),{pathPortion:S,globPortion:c.substr((a.index||0)+1)}}}return{pathPortion:c}}function l(...c){return c.length?c.reduce((f,v)=>(f[v]=!0,f),Object.create(null)):void 0}function M(c){return E.splitGlobAware(c,",").map(f=>f.trim()).filter(f=>!!f.length)}function r(c){return[`**/${c}/**`,`**/${c}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function n(c){return c.replace(/\\/g,"/")}function b(c){return n(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(c,f){c=s.distinct(c,S=>S.toString());const v=[],a=f.getWorkspace();return c&&c.forEach(S=>{let I;if(f.getWorkbenchState()===2)I=(0,A.relativePath)(a.folders[0].uri,S),I&&I!=="."&&(I="./"+I);else{const N=f.getWorkspaceFolder(S);if(N){const B=N.name;if(a.folders.filter(O=>O.name===B).length===1){const O=(0,A.relativePath)(N.uri,S);O===""?I=`./${N.name}`:I=`./${N.name}/${O}`}else I=S.fsPath}}I&&v.push(I)}),v}e.resolveResourcesForSearchIncludes=g}),define(Ee[212],ye([0,1,24,2,20,15,3,211,41,47]),function(ee,e,s,t,E,T,k,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function w(u,d){const F=d.activationEvents;if(!F)return Promise.resolve(void 0);const _=[],m=[];for(const n of F)if(/^workspaceContains:/.test(n)){const b=n.substr("workspaceContains:".length);b.indexOf("*")>=0||b.indexOf("?")>=0||u.forceUsingSearch?m.push(b):_.push(b)}if(_.length===0&&m.length===0)return Promise.resolve(void 0);let h;const D=new Promise((n,b)=>{h=n}),l=n=>h({activationEvent:n}),M=Promise.all(_.map(n=>i(u,n,l))).then(()=>{}),r=p(u,d.identifier,m,l);return Promise.all([M,r]).then(()=>{h(void 0)}),D}e.checkActivateWorkspaceContainsExtension=w;async function i(u,d,F){for(const _ of u.folders)if(await u.exists(s.joinPath(t.URI.revive(_),d))){F(`workspaceContains:${d}`);return}}async function p(u,d,F,_){if(F.length===0)return Promise.resolve(void 0);const m=new E.CancellationTokenSource,h=u.checkExists(u.folders,F,m.token),D=setTimeout(async()=>{m.cancel(),u.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${F.join(",")}`)},R);let l=!1;try{l=await h}catch(M){T.isPromiseCanceledError(M)||T.onUnexpectedError(M)}m.dispose(),clearTimeout(D),l&&_(`workspaceContains:${F.join(",")}`)}function o(u,d,F,_){const m=u.get(k.IInstantiationService),h=u.get(C.ISearchService),l=m.createInstance(P.QueryBuilder).file(d.map(M=>(0,A.toWorkspaceFolder)(t.URI.revive(M))),{_reason:"checkExists",includePattern:F,exists:!0});return h.fileSearch(l,_).then(M=>!!M.limitHit,M=>T.isPromiseCanceledError(M)?!1:Promise.reject(M))}e.checkGlobFileExists=o});var Ze=this&&this.__classPrivateFieldSet||function(ee,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!E:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(ee,s):E?E.value=s:e.set(ee,s),s},ke=this&&this.__classPrivateFieldGet||function(ee,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(ee):t?t.value:e.get(ee)};define(Ee[33],ye([0,1,119,17,73,24,14,6,21,2,12,5,32,172,71,31,27,170,15,25,22,146,7,84,3,28,72,13,60,64,40,4,212,68,148,11]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m,h,D,l,M,r,n,b,g,c,f,v,a,S,I,N,B){"use strict";var y,O,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let U=class ji extends P.Disposable{constructor(G,ae,we,Se,ce,oe,be,Pe,Me,He){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ae,this._extHostContext=we,this._initData=be,this._extHostWorkspace=Se,this._extHostConfiguration=ce,this._logService=oe,this._extHostTunnelService=Me,this._extHostTerminalService=He,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(w.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(w.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(w.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new F.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new I.ExtHostSecretState(this._extHostContext),this._storagePath=Pe,this._instaService=G.createChild(new c.ServiceCollection([o.IExtHostStorage,this._storage],[I.IExtHostSecretState,this._secretState]));const Ye=new Set;this._initData.hostExtensions.forEach(Qe=>Ye.add(m.ExtensionIdentifier.toKey(Qe))),this._activator=this._register(new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Qe,H,K)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Qe,_.transformErrorForSerialization(H),K)},actualActivateExtension:async(Qe,H)=>{if(Ye.has(m.ExtensionIdentifier.toKey(Qe)))return await this._mainThreadExtensionsProxy.$activateExtension(Qe,H),new p.HostExtension;const K=this._registry.getExtensionDescription(Qe);return this._activateExtension(K,H)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(G){_.onUnexpectedError(G)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let G=[];try{G=this._registry.getAllExtensionDescriptions().map(ce=>ce.identifier).filter(ce=>this.isActivated(ce)).map(ce=>this._deactivate(ce))}catch{}await Promise.all(G)}isActivated(G){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(G):!1}_activateByEvent(G,ae){return this._activator.activateByEvent(G,ae)}_activateById(G,ae){return this._activator.activateById(G,ae)}activateByIdWithErrors(G,ae){return this._activateById(G,ae).then(()=>{const we=this._activator.getActivatedExtension(G);if(we.activationFailed)return Promise.reject(we.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(G=>this._registry)}getExtensionExports(G){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(G).exports:null}async _realPathExtensionUri(G){if(G.scheme!==B.Schemas.file)return G;const ae=await this._hostUtils.realpath(G.fsPath);return A.URI.file(ae)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const G=C.TernarySearchTree.forUris(ae=>T.extUriBiasedIgnorePathCase.ignorePathCasing(ae));for(const ae of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ae)){const we=await this._realPathExtensionUri(ae.extensionLocation);G.set(we,ae)}return G})()),this._extensionPathIndex}_deactivate(G){let ae=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(G))return ae;const we=this._activator.getActivatedExtension(G);if(!we)return ae;try{typeof we.module.deactivate=="function"&&(ae=Promise.resolve(we.module.deactivate()).then(void 0,Se=>(this._logService.error(Se),Promise.resolve(void 0))))}catch(Se){this._logService.error(`An error occurred when deactivating the extension '${G.value}':`),this._logService.error(Se)}try{(0,P.dispose)(we.subscriptions)}catch(Se){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this._logService.error(Se)}return ae}async _activateExtension(G,ae){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier),this._doActivateExtension(G,ae).then(we=>{const Se=we.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(G.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,ae),this._logExtensionActivationTimes(G,ae,"success",Se),we},we=>{throw this._logExtensionActivationTimes(G,ae,"failure"),we})}_logExtensionActivationTimes(G,ae,we,Se){const ce=$(G,ae);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ce,...Se||{},outcome:we})}_doActivateExtension(G,ae){const we=$(G,ae);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",we);const Se=this._getEntryPoint(G);if(!Se)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${ae.startup}, activationEvent: '${ae.activationEvent}'${G.identifier.value!==ae.extensionId.value?`, root cause: ${ae.extensionId.value}`:""}`),this._logService.flush();const ce=new p.ExtensionActivationTimesBuilder(ae.startup);return Promise.all([this._loadCommonJSModule(G.identifier,(0,T.joinPath)(G.extensionLocation,Se),ce),this._loadExtensionContext(G)]).then(oe=>(E.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),ji._callActivate(this._logService,G.identifier,oe[0],oe[1],ce))).then(oe=>(E.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),oe))}_loadExtensionContext(G){const ae=new D.ExtensionGlobalMemento(G,this._storage),we=new D.ExtensionMemento(G.identifier.value,!1,this._storage),Se=new N.ExtensionSecrets(G,this._secretState),ce=G.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?l.ExtensionMode.Test:l.ExtensionMode.Development:l.ExtensionMode.Production,oe=this._initData.remote.isRemote?l.ExtensionKind.Workspace:l.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([ae.whenReady,we.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let Pe;const Me=(0,d.isProposedApiEnabled)(G,"ipc")?this._initData.messagePorts?.get(m.ExtensionIdentifier.toKey(G.identifier)):void 0;return Object.freeze({globalState:ae,workspaceState:we,secrets:Se,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(He){return t.join(G.extensionLocation.fsPath,He)},get storagePath(){return be._storagePath.workspaceValue(G)?.fsPath},get globalStoragePath(){return be._storagePath.globalValue(G).fsPath},get logPath(){return t.join(be._initData.logsLocation.fsPath,G.identifier.value)},get logUri(){return A.URI.joinPath(be._initData.logsLocation,G.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(G)},get globalStorageUri(){return be._storagePath.globalValue(G)},get extensionMode(){return ce},get extension(){return Pe===void 0&&(Pe=new W(be,G.identifier,G,oe)),Pe},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(G,"extensionRuntime"),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(G)},messagePassingProtocol:Me&&{onDidReceiveMessage:a.Event.fromDOMEventEmitter(Me,"message",He=>He.data),postMessage:Me.postMessage.bind(Me)}})})}static _callActivate(G,ae,we,Se,ce){return we=we||{activate:void 0,deactivate:void 0},this._callActivateOptional(G,ae,we,Se,ce).then(oe=>new p.ActivatedExtension(!1,null,ce.build(),we,oe,Se.subscriptions))}static _callActivateOptional(G,ae,we,Se,ce){if(typeof we.activate=="function")try{ce.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${ae.value}`);const oe=typeof global=="object"?global:self,be=we.activate.apply(oe,[Se]);return ce.activateCallStop(),ce.activateResolveStart(),Promise.resolve(be).then(Pe=>(ce.activateResolveStop(),Pe))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(we)}_activateOneStartupFinished(G,ae){this._activateById(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:ae}).then(void 0,we=>{this._logService.error(we)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const G of this._registry.getAllExtensionDescriptions())if(G.activationEvents)for(const ae of G.activationEvents)ae==="onStartupFinished"&&this._activateOneStartupFinished(G,ae)}_handleEagerExtensions(){const G=this._activateByEvent("*",!0).then(void 0,ce=>{this._logService.error(ce)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ce=>this._handleWorkspaceContainsEagerExtensions(ce.added)));const ae=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],we=this._handleWorkspaceContainsEagerExtensions(ae),Se=Promise.all([G,we]).then(()=>{});return Promise.race([Se,(0,k.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Se}_handleWorkspaceContainsEagerExtensions(G){return G.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ae=>this._handleWorkspaceContainsEagerExtension(G,ae))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(G,ae){if(this.isActivated(ae.identifier))return;const we=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Se={logService:this._logService,folders:G.map(oe=>oe.uri),forceUsingSearch:we,exists:oe=>this._hostUtils.exists(oe.fsPath),checkExists:(oe,be,Pe)=>this._mainThreadWorkspaceProxy.$checkExists(oe,be,Pe)},ce=await(0,S.checkActivateWorkspaceContainsExtension)(Se,ae);if(!!ce)return this._activateById(ae.identifier,{startup:!0,extensionId:ae.identifier,activationEvent:ce.activationEvent}).then(void 0,oe=>this._logService.error(oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(G){throw console.error(G),G}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:ae}=this._initData.environment;if(!G||!ae)throw new Error(s.localize(0,null));const we=await this._loadCommonJSModule(null,ae,new p.ExtensionActivationTimesBuilder(!1));if(!we||typeof we.run!="function")throw new Error(s.localize(1,null,ae.toString()));return new Promise((Se,ce)=>{const oe=(Me,He)=>{Me?ce(Me):Se(typeof He=="number"&&He>0?1:0)},be=(0,T.originalFSPath)(ae),Pe=we.run(be,oe);Pe&&Pe.then&&Pe.then(()=>{Se(0)}).catch(Me=>{ce(Me instanceof Error&&Me.stack?Me.stack:String(Me))})})}async $extensionTestsExit(G){this._logService.info(`Extension host terminating: test runner requested exit with code ${G}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${G}`),this._logService.flush(),this._hostUtils.exit(G)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,ae){return this._resolvers[G]=ae,(0,P.toDisposable)(()=>{delete this._resolvers[G]})}async _activateAndGetResolver(G){const ae=G.indexOf("+");if(ae===-1)throw new Error("Not an authority that can be resolved!");const we=G.substr(0,ae);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${we}`,!1),{authorityPrefix:we,resolver:this._resolvers[we]}}async $resolveAuthority(G,ae){const{authorityPrefix:we,resolver:Se}=await this._activateAndGetResolver(G);if(!Se)return{type:"error",error:{code:M.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${we}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(Se)),E.mark(`code/extHost/willResolveAuthority/${we}`);const ce=await Se.resolve(G,{resolveAttempt:ae});E.mark(`code/extHost/didResolveAuthorityOK/${we}`);const oe={authority:G,host:ce.host,port:ce.port,connectionToken:ce.connectionToken},be={extensionHostEnv:ce.extensionHostEnv,isTrusted:ce.isTrusted,authenticationSession:ce.authenticationSessionForInitializingExtensions?{id:ce.authenticationSessionForInitializingExtensions.id,providerId:ce.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:oe,options:be,tunnelInformation:{environmentTunnels:ce.environmentTunnels}}}}catch(ce){if(E.mark(`code/extHost/didResolveAuthorityError/${we}`),ce instanceof l.RemoteAuthorityResolverError)return{type:"error",error:{code:ce._code,message:ce._message,detail:ce._detail}};throw ce}}async $getCanonicalURI(G,ae){const{authorityPrefix:we,resolver:Se}=await this._activateAndGetResolver(G);if(!Se)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${we}`);const ce=A.URI.revive(ae);if(typeof Se.getCanonicalURI=="undefined")return ce;const oe=await(0,k.asPromise)(()=>Se.getCanonicalURI(ce));return oe||ce}$startExtensionHost(G){return this._registry.keepOnly(G),this._startExtensionHost()}$activateByEvent(G,ae){return ae===1?this._activateByEvent(G,!1):this._readyToRunExtensions.wait().then(we=>this._activateByEvent(G,!1))}async $activate(G,ae){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(G)?(await this._activateById(G,ae),!0):!1}async $deltaExtensions(G,ae){G.forEach(Se=>Se.extensionLocation=A.URI.revive(Se.extensionLocation));const we=await this.getExtensionPathIndex();return await Promise.all(ae.map(async Se=>{const ce=this._registry.getExtensionDescription(Se);ce&&we.delete(await this._realPathExtensionUri(ce.extensionLocation))})),await Promise.all(G.map(async Se=>{const ce=await this._realPathExtensionUri(Se.extensionLocation);we.set(ce,Se)})),this._registry.deltaExtensions(G,ae),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){let ae=h.VSBuffer.alloc(G),we=Math.random()%256;for(let Se=0;Se<G;Se++)ae.writeUInt8(we,Se);return ae}async $updateRemoteConnectionData(G){this._remoteConnectionData=G,this._onDidChangeRemoteConnectionData.fire()}};U=Be([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,g.IExtHostRpcService),$e(3,u.IExtHostWorkspace),$e(4,i.IExtHostConfiguration),$e(5,R.ILogService),$e(6,n.IExtHostInitDataService),$e(7,b.IExtensionStoragePaths),$e(8,f.IExtHostTunnelService),$e(9,v.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function $(J,G){return{id:J.identifier.value,name:J.name,extensionVersion:J.version,publisherDisplayName:J.publisher,activationEvents:J.activationEvents?J.activationEvents.join(","):null,isBuiltin:J.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class W{constructor(G,ae,we,Se){y.set(this,void 0),O.set(this,void 0),z.set(this,void 0),Ze(this,y,G,"f"),Ze(this,O,ae,"f"),Ze(this,z,we.identifier,"f"),this.id=we.identifier.value,this.extensionUri=we.extensionLocation,this.extensionPath=t.normalize((0,T.originalFSPath)(we.extensionLocation)),this.packageJSON=we,this.extensionKind=Se}get isActive(){return ke(this,y,"f").isActivated(ke(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return ke(this,y,"f").getExtensionExports(ke(this,z,"f"))}activate(){return ke(this,y,"f").activateByIdWithErrors(ke(this,z,"f"),{startup:!1,extensionId:ke(this,O,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,y=new WeakMap,O=new WeakMap,z=new WeakMap}),define(Ee[98],ye([0,1,17,2,4,14,5,7,155,31,33,49,162,32,156,13,3,10,89,70]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,d.createDecorator)("IExtHostDebugService");let h=class{constructor(c,f,v,a,S,I){this._workspaceService=f,this._extensionService=v,this._editorsService=a,this._configurationService=S,this._editorTabs=I,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=c.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(N=>{N.onDidChange(B=>{this.registerAllDebugTypes(N)}),this.registerAllDebugTypes(N)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,f){const v=c;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let a=`debug:${encodeURIComponent(v.path||"")}`,S="?";return f&&(a+=`${S}session=${encodeURIComponent(f.id)}`,S="&"),a+=`${S}ref=${v.sourceReference}`,t.URI.parse(a)}else{if(v.path)return t.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const f=[];for(const v of c.getAllExtensionDescriptions())if(v.contributes){const a=v.contributes.debuggers;if(a&&a.length>0)for(const S of a)(0,o.isDebuggerMainContribution)(S)&&f.push(S.type)}this._debugServiceProxy.$registerDebugTypes(f)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(f=>c.push(f)),c}addBreakpoints(c){this.startBreakpoints();const f=c.filter(S=>{const I=S.id;return this._breakpoints.has(I)?!1:(this._breakpoints.set(I,S),!0)});this.fireBreakpointChanges(f,[],[]);const v=[],a=new Map;for(const S of f)if(S instanceof P.SourceBreakpoint){let I=a.get(S.location.uri.toString());I||(I={type:"sourceMulti",uri:S.location.uri,lines:[]},a.set(S.location.uri.toString(),I),v.push(I)),I.lines.push({id:S.id,enabled:S.enabled,condition:S.condition,hitCondition:S.hitCondition,logMessage:S.logMessage,line:S.location.range.start.line,character:S.location.range.start.character})}else S instanceof P.FunctionBreakpoint&&v.push({type:"function",id:S.id,enabled:S.enabled,hitCondition:S.hitCondition,logMessage:S.logMessage,condition:S.condition,functionName:S.functionName});return this._debugServiceProxy.$registerBreakpoints(v)}removeBreakpoints(c){this.startBreakpoints();const f=c.filter(I=>this._breakpoints.delete(I.id));this.fireBreakpointChanges([],f,[]);const v=f.filter(I=>I instanceof P.SourceBreakpoint).map(I=>I.id),a=f.filter(I=>I instanceof P.FunctionBreakpoint).map(I=>I.id),S=f.filter(I=>I instanceof P.DataBreakpoint).map(I=>I.id);return this._debugServiceProxy.$unregisterBreakpoints(v,a,S)}startDebugging(c,f,v){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,f,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,debugUI:v.debugUI,suppressSaveBeforeStart:v.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,f,v){if(!f)return new P.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:a,provider:f}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,v,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,a),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(S=>S.provider!==f),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(c,f,v){if(!v)return new P.Disposable(()=>{});if(!this.definesDebugType(c,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.getAdapterDescriptorFactoryByType(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:f,handle:a,factory:v}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(f,a),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(S=>S.factory!==v),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(c,f){if(!f)return new P.Disposable(()=>{});const v=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:v,factory:f}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==f)})}async $runInTerminal(c,f){return Promise.resolve(void 0)}async $substituteVariables(c,f){if(!this._variableResolver){const[S,I]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(S||[],this._editorsService,I)}let v;const a=await this.getFolder(c);return a&&(v={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(v,f)}createDebugAdapter(c,f){if(c.type==="implementation")return new n(c.implementation)}createSignService(){}async $startDASession(c,f){const v=this,a=await this.getSession(f);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const I=this.convertToDto(S),N=this.createDebugAdapter(I,a);if(!N)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const B=N;return this._debugAdapters.set(c,B),this.getDebugAdapterTrackers(a).then(y=>(y&&this._debugAdaptersTrackers.set(c,y),B.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const z=O,U={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(z.arguments.value);U.body={signature:$},B.sendResponse(U)}else throw new Error("no signer")}catch($){U.success=!1,U.message=$.message,B.sendResponse(U)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(O),O=(0,o.convertToVSCPaths)(O,!0),v._debugServiceProxy.$acceptDAMessage(c,O)}),B.onError(O=>{y&&y.onError&&y.onError(O),this._debugServiceProxy.$acceptDAError(c,O.name,O.message,O.stack)}),B.onExit(O=>{y&&y.onExit&&y.onExit((0,F.withNullAsUndefined)(O),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,F.withNullAsUndefined)(O),void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),B.startSession()))})}$sendDAMessage(c,f){f=(0,o.convertToDAPaths)(f,!1);const v=this._debugAdaptersTrackers.get(c);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(f);const a=this._debugAdapters.get(c);a&&a.sendMessage(f)}$stopDASession(c){const f=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),f&&f.onWillStopSession&&f.onWillStopSession();const v=this._debugAdapters.get(c);return this._debugAdapters.delete(c),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const f=[],v=[],a=[];if(c.added)for(const S of c.added){const I=S.id;if(I&&!this._breakpoints.has(I)){let N;if(S.type==="function")N=new P.FunctionBreakpoint(S.functionName,S.enabled,S.condition,S.hitCondition,S.logMessage);else if(S.type==="data")N=new P.DataBreakpoint(S.label,S.dataId,S.canPersist,S.enabled,S.hitCondition,S.condition,S.logMessage);else{const B=t.URI.revive(S.uri);N=new P.SourceBreakpoint(new P.Location(B,new P.Position(S.line,S.character)),S.enabled,S.condition,S.hitCondition,S.logMessage)}N._id=I,this._breakpoints.set(I,N),f.push(N)}}if(c.removed)for(const S of c.removed){const I=this._breakpoints.get(S);I&&(this._breakpoints.delete(S),v.push(I))}if(c.changed){for(const S of c.changed)if(S.id){const I=this._breakpoints.get(S.id);if(I){if(I instanceof P.FunctionBreakpoint&&S.type==="function"){const N=I;N.enabled=S.enabled,N.condition=S.condition,N.hitCondition=S.hitCondition,N.logMessage=S.logMessage,N.functionName=S.functionName}else if(I instanceof P.SourceBreakpoint&&S.type==="source"){const N=I;N.enabled=S.enabled,N.condition=S.condition,N.hitCondition=S.hitCondition,N.logMessage=S.logMessage,N.location=new P.Location(t.URI.revive(S.uri),new P.Position(S.line,S.character))}a.push(I)}}}this.fireBreakpointChanges(f,v,a)}$provideDebugConfigurations(c,f,v){return(0,T.asPromise)(async()=>{const a=this.getConfigProviderByHandle(c);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const S=await this.getFolder(f);return a.provideDebugConfigurations(S,v)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(c,f,v,a){return(0,T.asPromise)(async()=>{const S=this.getConfigProviderByHandle(c);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.getFolder(f);return S.resolveDebugConfiguration(I,v,a)})}$resolveDebugConfigurationWithSubstitutedVariables(c,f,v,a){return(0,T.asPromise)(async()=>{const S=this.getConfigProviderByHandle(c);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.getFolder(f);return S.resolveDebugConfigurationWithSubstitutedVariables(I,v,a)})}async $provideDebugAdapter(c,f){const v=this.getAdapterDescriptorFactoryByHandle(c);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(f);return this.getAdapterDescriptor(v,a).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(S)})}async $acceptDebugSessionStarted(c){const f=await this.getSession(c);this._onDidStartDebugSession.fire(f)}async $acceptDebugSessionTerminated(c){const f=await this.getSession(c);f&&(this._onDidTerminateDebugSession.fire(f),this._debugSessions.delete(f.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,f){const v=await this.getSession(c);v&&v._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(c,f){const a={session:await this.getSession(c),event:f.event,body:f.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(c){if(c instanceof P.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof P.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const f=this._adapterFactories.filter(v=>v.type===c);if(f.length>0)return f[0].factory}getAdapterDescriptorFactoryByHandle(c){const f=this._adapterFactories.filter(v=>v.handle===c);if(f.length>0)return f[0].factory}getConfigProviderByHandle(c){const f=this._configProviders.filter(v=>v.handle===c);if(f.length>0)return f[0].provider}definesDebugType(c,f){if(c.contributes){const v=c.contributes.debuggers;if(v&&v.length>0){for(const a of v)if(a.label&&a.type&&a.type===f)return!0}}return!1}getDebugAdapterTrackers(c){const v=c.configuration.type,a=this._trackerFactories.filter(S=>S.type===v||S.type==="*").map(S=>(0,T.asPromise)(()=>S.factory.createDebugAdapterTracker(c)).then(I=>I,I=>null));return Promise.race([Promise.all(a).then(S=>{const I=S.filter(N=>!!N);if(I.length>0)return new r(I)}),new Promise((S,I)=>{const N=setTimeout(()=>{clearTimeout(N),I(new Error("timeout"))},1e3)})]).catch(S=>{})}async getAdapterDescriptor(c,f){const v=f.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new P.DebugAdapterServer(v));if(c){const S=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>c.createDebugAdapterDescriptor(f,this.daExecutableFromPackage(f,S))).then(I=>{if(I)return I})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(f,a))}daExecutableFromPackage(c,f){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,f,v){(c.length>0||f.length>0||v.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:f,changed:v}))}async getSession(c){if(c)if(typeof c=="string"){const f=this._debugSessions.get(c);if(f)return f}else{let f=this._debugSessions.get(c.id);if(!f){const v=await this.getFolder(c.folderUri),a=c.parent?this._debugSessions.get(c.parent):void 0;f=new D(this._debugServiceProxy,c.id,c.type,c.name,v,c.configuration,a),this._debugSessions.set(f.id,f),this._debugServiceProxy.$sessionCached(f.id)}return f}throw new Error("cannot find session")}getFolder(c){if(c){const f=t.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}};h=Be([$e(0,u.IExtHostRpcService),$e(1,A.IExtHostWorkspace),$e(2,R.IExtHostExtensionService),$e(3,w.IExtHostDocumentsAndEditors),$e(4,p.IExtHostConfiguration),$e(5,m.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class D{constructor(c,f,v,a,S,I,N){this._debugServiceProxy=c,this._id=f,this._type=v,this._name=a,this._workspaceFolder=S,this._configuration=I,this._parentSession=N}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,f){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,f)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=D;class l{constructor(c){this.value=Object.freeze({append(f){c.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.ExtHostDebugConsole=l;class M extends i.AbstractVariableResolverService{constructor(c,f,v,a,S){function I(){if(f){const N=f.activeEditor();if(N)return N.document.uri;const B=a.tabs.filter(y=>y.isActive);if(B.length>0){const y=B[0].resource;return y&&(y.primary||y.secondary)?y.primary??y.secondary:B[0].resource}}}super({getFolderUri:N=>{const B=c.filter(y=>y.name===N);if(B&&B.length>0)return B[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(N,B)=>v.getConfiguration(void 0,N).get(B),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const N=I();if(N)return s.normalize(N.fsPath)},getWorkspaceFolderPathForFile:()=>{if(S){const N=I();if(N){const B=S.getWorkspaceFolder(N);if(B)return s.normalize(B.uri.fsPath)}}},getSelectedText:()=>{if(f){const N=f.activeEditor();if(N&&!N.selection.isEmpty)return N.document.getText(N.selection)}},getLineNumber:()=>{if(f){const N=f.activeEditor();if(N)return String(N.selection.end.line+1)}}},void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=M;class r{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(f=>f.onError?f.onError(c):void 0)}onExit(c,f){this.trackers.forEach(v=>v.onExit?v.onExit(c,f):void 0)}}class n extends C.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let b=class extends h{constructor(c,f,v,a,S,I){super(c,f,v,a,S,I)}createVariableResolver(c,f,v){return new M(c,f,v,this._editorTabs)}};b=Be([$e(0,u.IExtHostRpcService),$e(1,A.IExtHostWorkspace),$e(2,R.IExtHostExtensionService),$e(3,w.IExtHostDocumentsAndEditors),$e(4,p.IExtHostConfiguration),$e(5,m.IExtHostEditorTabs)],b),e.WorkerExtHostDebugService=b}),define(Ee[213],ye([0,1,73,2,5,32,27,25,13,28,3,33,89,12]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(m,h,D,l,M,r,n){this._apiFactory=m,this._extensionRegistry=h,this._instaService=D,this._extHostConfiguration=l,this._extHostExtensionService=M,this._initData=r,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),s.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();s.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,h,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(d,h)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(F,h,this._initData.environment.appUriScheme))}register(m){if(Array.isArray(m.nodeModuleName))for(let h of m.nodeModuleName)this._factories.set(h,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(h=>m.alternativeModuleName(h))}};o=Be([$e(2,R.IInstantiationService),$e(3,T.IExtHostConfiguration),$e(4,w.IExtHostExtensionService),$e(5,A.IExtHostInitDataService),$e(6,p.ILogService)],o),e.RequireInterceptor=o;class u{constructor(m,h,D,l,M){this._apiFactory=m,this._extensionPaths=h,this._extensionRegistry=D,this._configProvider=l,this._logService=M,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,h){const D=this._extensionPaths.findSubstr(h);if(D){let l=this._extApiImpl.get(P.ExtensionIdentifier.toKey(D.identifier));return l||(l=this._apiFactory(D,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(D.identifier),l)),l}if(!this._defaultApiImpl){let l="";this._extensionPaths.forEach((M,r)=>l+=`	${r} -> ${M.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${l}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let d=class{constructor(m,h,D){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=h.getProxy(E.MainContext.MainThreadTelemetry);const{environment:l}=D,M=h.getProxy(E.MainContext.MainThreadKeytar);if(l.appRoot){let r=l.appRoot.fsPath;i.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,n)=>M.$getPassword(r,n),setPassword:(r,n,b)=>M.$setPassword(r,n,b),deletePassword:(r,n)=>M.$deletePassword(r,n),findPassword:r=>M.$findPassword(r),findCredentials(r){return M.$findCredentials(r)}}}load(m,h){const D=this._extensionPaths.findSubstr(h);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:D?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const h=m.length;if(h<=7||!this.alternativeNames)return;const D=h-7;if((m.charAt(D)==="/"||m.charAt(D)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};d=Be([$e(1,C.IExtHostRpcService),$e(2,A.IExtHostInitDataService)],d);let F=class{constructor(m,h,D){this._extensionPaths=m,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=D.getProxy(E.MainContext.MainThreadTelemetry);const l=D.getProxy(E.MainContext.MainThreadWindow);this._impl=(M,r)=>{const n=t.URI.parse(M);return r?this.callOriginal(M,r):n.scheme==="http"||n.scheme==="https"?l.$openUri(n,M,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?l.$openUri(n,M,{}):this.callOriginal(M,r)}}load(m,h,D){const l=this._extensionPaths.findSubstr(h);return l&&(this._extensionId=l.identifier.value,this.sendShimmingTelemetry()),this._original=D(m),this._impl}callOriginal(m,h){return this.sendNoForwardTelemetry(),this._original(m,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};F=Be([$e(2,C.IExtHostRpcService)],F)}),define(Ee[214],ye([0,1,14,15,73,6,2,5,207,12,44,60,28,136,13,65,33,40]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(h,D,l,M,r){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=l,this._rpcProtocol=new C.RPCProtocol(h,null,M),D=_._transform(D,this._rpcProtocol);const n=new w.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());n.set(i.IExtHostInitDataService,{_serviceBrand:void 0,...D,messagePorts:r}),n.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),n.set(u.IURITransformerService,new u.URITransformerService(M)),n.set(d.IHostUtils,l);const b=new p.InstantiationService(n,!0);this._disposables.add(b.invokeFunction(v=>v.get(F.IExtHostTerminalService))),this._disposables.add(b.invokeFunction(v=>v.get(d.IExtHostExtensionService))),this._logService=b.invokeFunction(v=>v.get(A.ILogService)),E.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",D),this._extensionService=b.invokeFunction(v=>v.get(d.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(v=>{Error.prepareStackTrace=(a,S)=>{let I="",N,B;for(const y of S)I+=`
	at ${y.toString()}`,B=y.getFileName(),!N&&B&&(N=v.findSubstr(k.URI.file(B)));return g.set(a,N),`${a.name||"Error"}: ${a.message||""}${I}`}});const c=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),f=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(v=>{const a=t.transformErrorForSerialization(v),S=g.get(v);S?c.$onExtensionRuntimeError(S.identifier,a):f.$onUnexpectedError(a)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(l=>{this._logService.error(l)}),this._rpcProtocol.dispose();const D=this._extensionService.deactivateAll();Promise.race([(0,s.timeout)(5e3),D]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(h,D){h.extensions.forEach(M=>M.extensionLocation=k.URI.revive(D.transformIncomingURIs(M.extensionLocation))),h.environment.appRoot=k.URI.revive(D.transformIncomingURIs(h.environment.appRoot));const l=h.environment.extensionDevelopmentLocationURI;return l&&(h.environment.extensionDevelopmentLocationURI=l.map(M=>k.URI.revive(D.transformIncomingURIs(M)))),h.environment.extensionTestsLocationURI=k.URI.revive(D.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=k.URI.revive(D.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=k.URI.revive(D.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=k.URI.revive(D.transformIncomingURIs(h.logsLocation)),h.logFile=k.URI.revive(D.transformIncomingURIs(h.logFile)),h.workspace=D.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=_}),define(Ee[215],ye([0,1,17,20,43,29,24,188,41]),function(ee,e,s,t,E,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(i,p,o){this.config=i,this.provider=p,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=i.filePattern,this.includePattern=i.includePattern&&T.parse(i.includePattern),this.maxResults=i.maxResults||void 0,this.exists=i.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=i.excludePattern&&T.parse(i.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(i=>i.cancel()),this.activeCancellationTokens=new Set}search(i){const p=this.config.folderQueries||[];return new Promise((o,u)=>{const d=F=>{this.resultCount++,i(F)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(F=>{const _=F.toString(),m=s.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,m)||this.matchFile(d,{base:F,basename:m})}),Promise.all(p.map(F=>this.searchInFolder(F,d))).then(F=>{o({limitHit:this.isLimitHit,stats:F[0]||void 0})},F=>{u(new Error((0,E.toErrorMessage)(F)))})})}async searchInFolder(i,p){const o=new t.CancellationTokenSource,u=this.getSearchOptionsForFolder(i),d=this.initDirectoryTree(),F=new C.QueryGlobTester(this.config,i),_=!F.hasSiblingExcludeClauses();let m;try{this.activeCancellationTokens.add(o),m=P.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,o.token),D=m.elapsed(),l=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(M=>{const r=s.posix.relative(i.folder.path,M.path);if(_){const n=s.basename(M.path);this.matchFile(p,{base:i.folder,relativePath:r,basename:n});return}this.addDirectoryEntries(d,i.folder,r,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,F,p),{providerTime:D,postProcessTime:l.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(i){const p=(0,C.resolvePatternsForProvider)(this.config.includePattern,i.includePattern),o=(0,C.resolvePatternsForProvider)(this.config.excludePattern,i.excludePattern);return{folder:i.folder,excludes:o,includes:p,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries({pathToEntries:i},p,o,u){if(o===this.filePattern){const F=s.basename(this.filePattern);this.matchFile(u,{base:p,relativePath:this.filePattern,basename:F})}function d(F){const _=s.basename(F),m=s.dirname(F);let h=i[m];h||(h=i[m]=[],d(m)),h.push({base:p,relativePath:F,basename:_})}d(o)}matchDirectoryTree({rootEntries:i,pathToEntries:p},o,u){const d=this,F=this.filePattern;function _(m){const h=T.hasSiblingFn(()=>m.map(D=>D.basename));for(let D=0,l=m.length;D<l;D++){const M=m[D],{relativePath:r,basename:n}=M;if(o.matchesExcludesSync(r,n,F!==n?h:void 0))continue;const b=p[r];if(b)_(b);else{if(r===F)continue;d.matchFile(u,M)}if(d.isLimitHit)break}}_(i)}matchFile(i,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||i(p))}}class R{constructor(){this.sessions=new Map}fileSearch(i,p,o,u){const d=this.getSessionTokenSource(i.cacheKey),F=new A(i,p,d&&d.token);let _=0;const m=h=>{_+=h.length,o(h.map(D=>this.rawMatchToSearchItem(D)))};return this.doSearch(F,R.BATCH_SIZE,m,u).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:h.stats}}))}clearCache(i){const p=this.getSessionTokenSource(i);p&&p.cancel()}getSessionTokenSource(i){if(!!i)return this.sessions.has(i)||this.sessions.set(i,new t.CancellationTokenSource),this.sessions.get(i)}rawMatchToSearchItem(i){return i.relativePath?{resource:k.joinPath(i.base,i.relativePath)}:{resource:i.base}}doSearch(i,p,o,u){u.onCancellationRequested(()=>{i.cancel()});const d=_=>{_&&(F.push(_),p>0&&F.length>=p&&(o(F),F=[]))};let F=[];return i.search(d).then(_=>(F.length&&o(F),_),_=>(F.length&&o(F),Promise.reject(_)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Ee[216],ye([0,1,16,20,43,29,11,17,24,10,2,41]),function(ee,e,s,t,E,T,k,P,C,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class i{constructor(m,h,D,l){this.query=m,this.provider=h,this.fileUtils=D,this.processType=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(m,h){const D=this.query.folderQueries||[],l=new t.CancellationTokenSource;return h.onCancellationRequested(()=>l.cancel()),new Promise((M,r)=>{this.collector=new o(m);let n=!1;const b=(g,c)=>{if(!n&&!this.isLimitHit){const f=this.resultSize(g);d(g)&&typeof this.query.maxResults=="number"&&this.resultCount+f>this.query.maxResults&&(this.isLimitHit=!0,n=!0,l.cancel(),g=this.trimResultToSize(g,this.query.maxResults-this.resultCount));const v=this.resultSize(g);this.resultCount+=v,(v>0||!d(g))&&this.collector.add(g,c)}};Promise.all(D.map((g,c)=>this.searchInFolder(g,f=>b(f,c),l.token))).then(g=>{l.dispose(),this.collector.flush();const c=g.some(f=>!!f&&!!f.limitHit);M({limitHit:this.isLimitHit||c,messages:(0,s.flatten)(g.map(f=>f?.message?(0,A.isArray)(f.message)?f.message:[f.message]:[])),stats:{type:this.processType}})},g=>{l.dispose();const c=(0,E.toErrorMessage)(g);r(new Error(c))})})}resultSize(m){return d(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}trimResultToSize(m,h){const D=Array.isArray(m.ranges)?m.ranges:[m.ranges],l=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:D.slice(0,h),preview:{matches:l.slice(0,h),text:m.preview.text},uri:m.uri}}async searchInFolder(m,h,D){const l=new w.QueryGlobTester(this.query,m),M=[],r={report:g=>{if(!this.validateProviderResult(g))return;const c=m.folder.scheme===k.Schemas.file?T.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(g.uri))):void 0,f=C.relativePath(m.folder,g.uri);if(f){const v=l.includedInQuery(f,P.basename(f),c);(0,A.isPromise)(v)?M.push(v.then(a=>{a&&h(g)})):v&&h(g)}}},n=this.getSearchOptionsForFolder(m),b=await this.provider.provideTextSearchResults(p(this.query.contentPattern),n,r,D);return M.length&&await Promise.all(M),b}validateProviderResult(m){if(d(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(m){const h=(0,w.resolvePatternsForProvider)(this.query.includePattern,m.includePattern),D=(0,w.resolvePatternsForProvider)(this.query.excludePattern,m.excludePattern),l={folder:R.URI.from(m.folder),excludes:D,includes:h,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.fileUtils.toCanonicalName(m.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=i;function p(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class o{constructor(m){this._onResult=m,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new F(512,h=>this.sendItems(h))}add(m,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!C.isEqual(this._currentUri,m.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:m.uri,results:[]}),this._currentFileMatch.results.push(u(m))}pushToCollector(){const m=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,m)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(m){this._onResult(m)}}e.TextSearchResultsCollector=o;function u(_){return d(_)?{preview:{matches:(0,s.mapArrayOrNot)(_.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:_.preview.text},ranges:(0,s.mapArrayOrNot)(_.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function d(_){return!!_.preview}e.extensionResultIsMatch=d;class F{constructor(m,h){this.maxBatchSize=m,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(m,h){!m||this.addItemToBatch(m,h)}addItems(m,h){!m||this.addItemsToBatch(m,h)}addItemToBatch(m,h){this.batch.push(m),this.batchSize+=h,this.onUpdate()}addItemsToBatch(m,h){this.batch=this.batch.concat(m),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<F.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},F.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=F,F.TIMEOUT=4e3,F.START_BATCH_AFTER_COUNT=50}),define(Ee[99],ye([0,1,6,5,3,215,13,65,12,2,216]),function(ee,e,s,t,E,T,k,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let w=class{constructor(u,d,F){this.extHostRpc=u,this._uriTransformer=d,this._logService=F,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,d){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const F=this._handlePool++;return this._textSearchProvider.set(F,d),this._proxy.$registerTextSearchProvider(F,this._transformScheme(u)),(0,s.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(F),this._proxy.$unregisterProvider(F)})}registerFileSearchProvider(u,d){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const F=this._handlePool++;return this._fileSearchProvider.set(F,d),this._proxy.$registerFileSearchProvider(F,this._transformScheme(u)),(0,s.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(F),this._proxy.$unregisterProvider(F)})}$provideFileSearchResults(u,d,F,_){const m=i(F),h=this._fileSearchProvider.get(u);if(h)return this._fileSearchManager.fileSearch(m,h,D=>{this._proxy.$handleFileMatch(u,d,D.map(l=>l.resource))},_);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,d,F,_){const m=this._textSearchProvider.get(u);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const h=i(F);return this.createTextSearchManager(h,m).search(l=>this._proxy.$handleTextMatch(u,d,l),_)}$enableExtensionHostSearch(){}createTextSearchManager(u,d){return new R.TextSearchManager(u,d,{readdir:F=>Promise.resolve([]),toCanonicalName:F=>F},"textSearchProvider")}};w=Be([$e(0,k.IExtHostRpcService),$e(1,P.IURITransformerService),$e(2,C.ILogService)],w),e.ExtHostSearch=w;function i(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(p),extraFileResources:o.extraFileResources&&o.extraFileResources.map(u=>A.URI.revive(u))}}e.reviveQuery=i;function p(o){return{...o,folder:A.URI.revive(o.folder)}}}),define(Ee[217],ye([0,1,44,94,31,93,32,39,49,40,97,98,99,71,64,69,95,50,30,68,85,70,190,12,173]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m,h,D,l,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(M.ILoggerService,l.ExtHostLoggerService),(0,s.registerSingleton)(M.ILogService,r.ExtHostLogService),(0,s.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,s.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,s.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration),(0,s.registerSingleton)(F.IExtHostConsumerFileSystem,F.ExtHostConsumerFileSystem),(0,s.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService),(0,s.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,s.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,s.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,s.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,s.registerSingleton)(i.IExtHostSearch,i.ExtHostSearch),(0,s.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage),(0,s.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,s.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,s.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,s.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow),(0,s.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,s.registerSingleton)(m.IExtHostSecretState,m.ExtHostSecretState),(0,s.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,s.registerSingleton)(D.IExtHostEditorTabs,D.ExtHostEditorTabs)}),define(Ee[218],ye([0,1,44,3]),function(ee,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class E{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(k){if(k&&this._dragOperations.has(k)){const P=this._dragOperations.get(k);return this._dragOperations.delete(k),P}}addDragOperationTransfer(k,P){this._dragOperations.set(k,P)}}e.TreeViewsDragAndDropService=E,(0,s.registerSingleton)(e.ITreeViewsDragAndDropService,E)}),define(Ee[219],ye([0,1,123,24,2,4,6,14,7,10,16,8,20,152,218]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(_,m){if((0,A.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let h;return Array.isArray(_.highlights)&&(h=_.highlights.filter(D=>D.length===2&&typeof D[0]=="number"&&typeof D[1]=="number"),h=h.length?h:void 0),{label:_.label,highlights:h}}}class d{constructor(m,h,D){this._proxy=m,this.commands=h,this.logService=D,this.treeViews=new Map,this.treeDragAndDropService=new o.TreeViewsDragAndDropService;function l(M){return M&&M.$treeViewId&&M.$treeItemHandle}h.registerArgumentProcessor({processArgument:M=>l(M)?this.convertArgument(M):Array.isArray(M)&&M.length>0?M.map(r=>l(r)?this.convertArgument(r):r):M})}registerTreeDataProvider(m,h,D){const l=this.createTreeView(m,{treeDataProvider:h},D);return{dispose:()=>l.dispose()}}createTreeView(m,h,D){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=h.dragAndDropController?.supportedMimeTypes,M=!!h.dragAndDropController?.onWillDrop,r=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,dragAndDropMimeTypes:l,hasWillDrop:M}),n=this.createExtHostTreeView(m,h,D);return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get message(){return n.message},set message(b){n.message=b},get title(){return n.title},set title(b){n.title=b},get description(){return n.description},set description(b){n.description=b},reveal:(b,g)=>n.reveal(b,g),dispose:async()=>{await r,this.treeViews.delete(m),n.dispose()}}}$getChildren(m,h){const D=this.treeViews.get(m);return D?D.getChildren(h):Promise.reject(new Error((0,s.localize)(0,null,m)))}async $onDrop(m,h,D,l,M,r){const n=this.treeViews.get(m);if(!n)return Promise.reject(new Error((0,s.localize)(1,null,m)));const b=p.TreeDataTransferConverter.toITreeDataTransfer(h);return M===m&&r&&await this.addAdditionalTransferItems(b,n,r,l),n.onDrop(b,D)}async addAdditionalTransferItems(m,h,D,l){const M=this.treeDragAndDropService.removeDragOperationTransfer(l);let r;if(M)r=await M;else if(l&&h.onWillDrop){const n=h.onWillDrop(D);this.treeDragAndDropService.addDragOperationTransfer(l,n),r=await n}return r&&r.forEach((n,b)=>{n&&m.set(b,n)}),m}async $onWillDrop(m,h,D){const l=this.treeViews.get(m);if(!l)return Promise.reject(new Error((0,s.localize)(2,null,m)));const M=await this.addAdditionalTransferItems(new Map,l,h,D);if(!!M)return p.TreeDataTransferConverter.toTreeDataTransferDTO(M)}async $hasResolve(m){const h=this.treeViews.get(m);if(!h)throw new Error((0,s.localize)(3,null,m));return h.hasResolve}$resolve(m,h,D){const l=this.treeViews.get(m);if(!l)throw new Error((0,s.localize)(4,null,m));return l.resolveTreeItem(h,D)}$setExpanded(m,h,D){const l=this.treeViews.get(m);if(!l)throw new Error((0,s.localize)(5,null,m));l.setExpanded(h,D)}$setSelection(m,h){const D=this.treeViews.get(m);if(!D)throw new Error((0,s.localize)(6,null,m));D.setSelection(h)}$setVisible(m,h){const D=this.treeViews.get(m);if(!D)throw new Error((0,s.localize)(7,null,m));D.setVisible(h)}createExtHostTreeView(m,h,D){const l=new F(m,h,this._proxy,this.commands.converter,this.logService,D);return this.treeViews.set(m,l),l}convertArgument(m){const h=this.treeViews.get(m.$treeViewId);return h?h.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=d;class F extends k.Disposable{constructor(m,h,D,l,M,r){super();if(this.viewId=m,this.proxy=D,this.commands=l,this.logService=M,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new i.CancellationTokenSource,r.contributes&&r.contributes.views)for(const g in r.contributes.views)for(const c of r.contributes.views[g])c.id===m&&(this._title=c.name);this.dataProvider=h.treeDataProvider,this.dndController=h.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(g=>this._onDidChangeData.fire({message:!1,element:g}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(g=>this._onDidChangeData.fire({message:!1,element:g})));let n,b;this._register(T.Event.debounce(this._onDidChangeData.event,(g,c)=>(g||(g={message:!1,elements:[]}),c.element!==!1&&(n||(n=new Promise(f=>b=f),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(c.element)?g.elements.push(...c.element):g.elements.push(c.element)),c.message&&(g.message=!0),g),200,!0)(({message:g,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=b;return n=null,this.refresh(c).then(()=>f())})),g&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,A.isUndefinedOrNull)(m))}async getChildren(m){const h=m?this.getExtensionElement(m):void 0;if(m&&!h)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);let D=this.getChildrenNodes(m);return D||(D=await this.fetchChildrenNodes(h)),D?D.map(l=>l.item):void 0}getExtensionElement(m){return this.elements.get(m)}reveal(m,h){h=h||{select:!0,focus:!1};const D=(0,A.isUndefinedOrNull)(h.select)?!0:h.select,l=(0,A.isUndefinedOrNull)(h.focus)?!1:h.focus,M=(0,A.isUndefinedOrNull)(h.expand)?!1:h.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(r=>this.resolveTreeNode(m,r[r.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:r.map(b=>b.item)},{select:D,focus:l,expand:M})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:D,focus:l,expand:M})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,h){const D=this.getExtensionElement(m);D&&(h?this._onDidExpandElement.fire(Object.freeze({element:D})):this._onDidCollapseElement.fire(Object.freeze({element:D})))}setSelection(m){(0,R.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(m){const h=[];for(const D of m){const l=this.getExtensionElement(D);l&&h.push(l)}if(!(!this.dndController?.onWillDrop||h.length===0))return this.dndController.onWillDrop(h)}get hasOnWillDrop(){return!!this.dndController?.onWillDrop}async onDrop(m,h){const D=this.getExtensionElement(h);if(!!D)return(0,P.asPromise)(()=>this.dndController?.onDrop(m,D))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,h){if(!this.dataProvider.resolveTreeItem)return;const D=this.elements.get(m);if(D){const l=this.nodes.get(D);if(l){const M=await this.dataProvider.resolveTreeItem(l.extensionItem,D,h)??l.extensionItem;return l.item.tooltip=this.getTooltip(M.tooltip),l.item.command=this.getCommand(l.disposableStore,M.command),l.item}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(h=>h?this.resolveUnknownParentChain(h).then(D=>this.resolveTreeNode(h,D[D.length-1]).then(l=>(D.push(l),D))):Promise.resolve([]))}resolveParent(m){const h=this.nodes.get(m);return h?Promise.resolve(h.parent?this.elements.get(h.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,h){const D=this.nodes.get(m);return D?Promise.resolve(D):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(l=>this.createHandle(m,l,h,!0)).then(l=>this.getChildren(h?h.item.handle:void 0).then(()=>{const M=this.getExtensionElement(l);if(M){const r=this.nodes.get(M);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(m){if(m){let h;if(typeof m=="string"){const D=this.getExtensionElement(m);h=D?this.nodes.get(D):void 0}else h=m;return h&&h.children||void 0}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const h=new i.CancellationTokenSource(this._refreshCancellationSource.token);try{const D=m?this.nodes.get(m):void 0,l=await this.dataProvider.getChildren(m);if(h.token.isCancellationRequested)return;const M=await Promise.all((0,R.coalesce)(l||[]).map(async r=>{const n=await this.dataProvider.getTreeItem(r);return n&&!h.token.isCancellationRequested?this.createAndRegisterTreeNode(r,n,D):null}));return h.token.isCancellationRequested?void 0:(0,R.coalesce)(M)}finally{h.dispose()}}refresh(m){if(m.some(D=>!D))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new i.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const D=this.getHandlesToRefresh(m);if(D.length)return this.refreshHandles(D)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const h=new Set,D=m.map(M=>this.nodes.get(M));for(const M of D)if(M&&!h.has(M.item.handle)){let r=M;for(;r&&r.parent&&D.findIndex(n=>r&&r.parent&&n&&n.item.handle===r.parent.item.handle)===-1;){const n=this.elements.get(r.parent.item.handle);r=n?this.nodes.get(n):void 0}r&&!r.parent&&h.add(M.item.handle)}const l=[];return h.forEach(M=>{const r=this.elements.get(M);if(r){const n=this.nodes.get(r);n&&(!n.parent||!h.has(n.parent.item.handle))&&l.push(M)}}),l}refreshHandles(m){const h={};return Promise.all(m.map(D=>this.refreshNode(D).then(l=>{l&&(h[D]=l.item)}))).then(()=>Object.keys(h).length?this.proxy.$refresh(this.viewId,h):void 0)}refreshNode(m){const h=this.getExtensionElement(m);if(h){const D=this.nodes.get(h);if(D)return this.clearChildren(h),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(l=>{if(l){const M=this.createTreeNode(h,l,D.parent);return this.updateNodeCache(h,M,D,D.parent),D.dispose(),M}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,h,D){const l=this.createTreeNode(m,h,D);if(h.id&&this.elements.has(l.item.handle))throw new Error((0,s.localize)(8,null,h.id));return this.addNodeToCache(m,l),this.addNodeToParentCache(l,D),l}getTooltip(m){return C.MarkdownString.isMarkdownString(m)?w.MarkdownString.from(m):m}getCommand(m,h){return h?this.commands.toInternal(h,m):void 0}createTreeNode(m,h,D){const l=new k.DisposableStore,M=this.createHandle(m,h,D),r=this.getLightIconPath(h);return{item:{handle:M,parentHandle:D?D.item.handle:void 0,label:u(h.label,this.extension),description:h.description,resourceUri:h.resourceUri,tooltip:this.getTooltip(h.tooltip),command:this.getCommand(l,h.command),contextValue:h.contextValue,icon:r,iconDark:this.getDarkIconPath(h)||r,themeIcon:this.getThemeIcon(h),collapsibleState:(0,A.isUndefinedOrNull)(h.collapsibleState)?C.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation},extensionItem:h,parent:D,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(m){return m.iconPath instanceof C.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:h,label:D,resourceUri:l},M,r){if(h)return`${F.ID_HANDLE_PREFIX}/${h}`;const n=u(D,this.extension),b=M?M.item.handle:F.LABEL_HANDLE_PREFIX;let g=n?n.label:l?(0,t.basename)(l):"";g=g.indexOf("/")!==-1?g.replace("/","//"):g;const c=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,f=this.getChildrenNodes(M)||[];let v,a=0;do{if(v=`${b}/${a}:${g}`,r||!this.elements.has(v)||c===v)break;a++}while(a<=f.length);return v}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof C.ThemeIcon))return typeof m.iconPath=="string"||E.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof C.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return E.URI.isUri(m)?m:E.URI.file(m)}addNodeToCache(m,h){this.elements.set(h.item.handle,m),this.nodes.set(m,h)}updateNodeCache(m,h,D,l){this.elements.delete(h.item.handle),this.nodes.delete(m),h.item.handle!==D.item.handle&&this.elements.delete(D.item.handle),this.addNodeToCache(m,h);const M=this.getChildrenNodes(l)||[],r=M.filter(n=>n.item.handle===D.item.handle)[0];r&&M.splice(M.indexOf(r),1,h)}addNodeToParentCache(m,h){h?(h.children||(h.children=[]),h.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const h=this.nodes.get(m);if(h){if(h.children)for(const D of h.children){const l=this.elements.get(D.item.handle);l&&this.clear(l)}h.children=void 0}}else this.clearAll()}clear(m){const h=this.nodes.get(m);if(h){if(h.children)for(const D of h.children){const l=this.elements.get(D.item.handle);l&&this.clear(l)}this.nodes.delete(m),this.elements.delete(h.item.handle),h.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}F.LABEL_HANDLE_PREFIX="0",F.ID_HANDLE_PREFIX="1"}),define(Ee[220],ye([0,1,20,15,4,34,2,112,233,106,56,46,5,178,177,39,179,32,180,181,182,164,183,49,33,184,165,187,189,191,94,167,196,197,198,71,40,200,219,8,7,203,51,95,31,74,153,186,61,93,97,98,99,12,65,13,28,192,150,64,69,175,201,149,72,50,206,204,205,176,30,199,202,68,70,85,194,96,195,11,138,193,147,185,6,27]),function(ee,e,s,t,E,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m,h,D,l,M,r,n,b,g,c,f,v,a,S,I,N,B,y,O,z,U,$,W,J,G,ae,we,Se,ce,oe,be,Pe,Me,He,Ye,Qe,H,K,X,se,q,te,he,Ae,Ue,ze,Ge,et,st,Xe,nt,lt,vt,Oe,Rt,j,Q,fe,Ne,Ve,ot,ht,Je,Tt,Re,Ce,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ne(le){const de=le.get(K.IExtHostInitDataService),me=le.get(lt.IExtHostFileSystemInfo),Te=le.get(Ge.IExtHostConsumerFileSystem),We=le.get(r.IExtHostExtensionService),Le=le.get(ae.IExtHostWorkspace),je=le.get(Q.IExtHostTelemetry),it=le.get(F.IExtHostConfiguration),rt=le.get(Qe.IURITransformerService),re=le.get(H.IExtHostRpcService),ge=le.get(B.IExtHostStorage),ie=le.get(ze.IExtensionStoragePaths),V=le.get(Ye.ILoggerService),ve=le.get(Ye.ILogService),Ie=le.get(q.IExtHostTunnelService),Ke=le.get(te.IExtHostApiDeprecationService),xe=le.get(G.IExtHostWindow),ut=le.get(Rt.IExtHostSecretState),wt=le.get(j.IExtHostEditorTabs);re.set(i.ExtHostContext.ExtHostFileSystemInfo,me),re.set(i.ExtHostContext.ExtHostLogLevelServiceShape,V),re.set(i.ExtHostContext.ExtHostWorkspace,Le),re.set(i.ExtHostContext.ExtHostConfiguration,it),re.set(i.ExtHostContext.ExtHostExtensionService,We),re.set(i.ExtHostContext.ExtHostStorage,ge),re.set(i.ExtHostContext.ExtHostTunnelService,Ie),re.set(i.ExtHostContext.ExtHostWindow,xe),re.set(i.ExtHostContext.ExtHostSecretState,ut),re.set(i.ExtHostContext.ExtHostTelemetry,je),re.set(i.ExtHostContext.ExtHostEditorTabs,wt);const Ct=re.set(i.ExtHostContext.ExtHostDecorations,le.get(be.IExtHostDecorations)),bt=re.set(i.ExtHostContext.ExtHostDocumentsAndEditors,le.get(M.IExtHostDocumentsAndEditors)),ft=re.set(i.ExtHostContext.ExtHostCommands,le.get(u.IExtHostCommands)),pt=re.set(i.ExtHostContext.ExtHostTerminalService,le.get(y.IExtHostTerminalService)),yt=re.set(i.ExtHostContext.ExtHostDebugService,le.get(Me.IExtHostDebugService)),Ot=re.set(i.ExtHostContext.ExtHostSearch,le.get(He.IExtHostSearch)),kt=re.set(i.ExtHostContext.ExtHostTask,le.get(Pe.IExtHostTask)),It=re.set(i.ExtHostContext.ExtHostOutputService,le.get(v.IExtHostOutputService)),At=re.set(i.ExtHostContext.ExtHostUrls,new W.ExtHostUrls(re)),St=re.set(i.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(re,bt)),zt=re.set(i.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(re,bt,ve)),Lt=re.set(i.ExtHostContext.ExtHostDocumentSaveParticipant,new D.ExtHostDocumentSaveParticipant(ve,St,re.getProxy(i.MainContext.MainThreadBulkEdits))),Et=re.set(i.ExtHostContext.ExtHostNotebook,new X.ExtHostNotebookController(re,ft,bt,St,ie)),Qt=re.set(i.ExtHostContext.ExtHostNotebookDocuments,new Tt.ExtHostNotebookDocuments(ve,Et)),Vt=re.set(i.ExtHostContext.ExtHostNotebookEditors,new Je.ExtHostNotebookEditors(ve,re,Et)),Yt=re.set(i.ExtHostContext.ExtHostNotebookKernels,new fe.ExtHostNotebookKernels(re,de,Et,ft,ve)),si=re.set(i.ExtHostContext.ExtHostNotebookRenderers,new Ve.ExtHostNotebookRenderers(re,Et)),Ft=re.set(i.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(re,bt)),Xt=re.set(i.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(re.getProxy(i.MainContext.MainThreadTreeViews),ft,ve)),ai=re.set(i.ExtHostContext.ExtHostEditorInsets,new Se.ExtHostEditorInsets(re.getProxy(i.MainContext.MainThreadEditorInsets),Ft,de)),Jt=re.set(i.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(re,ve,me)),Wt=re.set(i.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(re,St,ft.converter,rt)),gt=re.set(i.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(re,rt,St,ft,Jt,ve,Ke)),li=re.set(i.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(re,gt)),Nt=re.set(i.ExtHostContext.ExtHostFileSystemEventService,new b.ExtHostFileSystemEventService(re,ve,bt)),jt=re.set(i.ExtHostContext.ExtHostQuickOpen,(0,S.createExtHostQuickOpen)(re,Le,ft)),Zt=re.set(i.ExtHostContext.ExtHostSCM,new I.ExtHostSCM(re,ft,ve)),ci=re.set(i.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(re,ft,St)),fi=re.set(i.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(re.getProxy(i.MainContext.MainThreadProgress))),Ei=re.set(i.ExtHostContext.ExtHosLabelService,new ce.ExtHostLabelService(re)),mi=re.set(i.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(re)),ei=re.set(i.ExtHostContext.ExtHostAuthentication,new he.ExtHostAuthentication(re)),yi=re.set(i.ExtHostContext.ExtHostTimeline,new Ae.ExtHostTimeline(re,ft)),qt=re.set(i.ExtHostContext.ExtHostWebviews,new J.ExtHostWebviews(re,{remote:de.remote},Le,ve,Ke)),Gt=re.set(i.ExtHostContext.ExtHostWebviewPanels,new Xe.ExtHostWebviewPanels(re,qt,Le)),_i=re.set(i.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors(re,St,ie,qt,Gt)),Si=re.set(i.ExtHostContext.ExtHostWebviewViews,new et.ExtHostWebviewViews(re,qt)),Kt=re.set(i.ExtHostContext.ExtHostTesting,new vt.ExtHostTesting(re,ft)),Ci=re.set(i.ExtHostContext.ExtHostUriOpeners,new Oe.ExtHostUriOpeners(re));re.set(i.ExtHostContext.ExtHostInteractive,new Re.ExtHostInteractive(re,Et,bt,ft));const ti=(0,we.values)(i.ExtHostContext);re.assertRegistered(ti);const Di=new nt.ExtHostBulkEdits(re,bt),ki=new o.ExtHostClipboard(re),ui=new f.ExtHostMessageService(re,ve),ii=new m.ExtHostDialogs(re),gi=new N.ExtHostStatusBar(re,ft.converter);return p.ExtHostApiCommands.register(ft),function(Fe,xt,pi){const mt=function(){let Y=!Fe.isUnderDevelopment;function ue(){Y||(ve.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function De(ct){if(Array.isArray(ct))ct.forEach(De);else if(typeof ct=="string")ue();else{const _t=ct;typeof _t.scheme=="undefined"&&ue(),typeof _t.exclusive=="boolean"&&(0,pe.checkProposedApiEnabled)(Fe,"documentFiltersExclusive")}return ct}}(),ni={getSession(Y,ue,De){return ei.getSession(Fe,Y,ue,De)},async hasSession(Y,ue){return(0,pe.checkProposedApiEnabled)(Fe,"authSession"),!!await ei.getSession(Fe,Y,ue,{silent:!0})},get onDidChangeSessions(){return ei.onDidChangeSessions},registerAuthenticationProvider(Y,ue,De,ct){return ei.registerAuthenticationProvider(Y,ue,De,ct)}},Ii={registerCommand(Y,ue,De){return ft.registerCommand(!0,Y,ue,De,void 0,Fe)},registerTextEditorCommand(Y,ue,De){return ft.registerCommand(!0,Y,(...ct)=>{const _t=Ft.getActiveTextEditor();if(!_t){ve.warn("Cannot execute "+Y+" because there is no active text editor.");return}return _t.edit(Dt=>{ue.apply(De,[_t,Dt,...ct])}).then(Dt=>{Dt||ve.warn("Edits from command "+Y+" were not applied.")},Dt=>{ve.warn("An error occurred while running command "+Y,Dt)})},void 0,void 0,Fe)},registerDiffInformationCommand:(Y,ue,De)=>((0,pe.checkProposedApiEnabled)(Fe,"diffCommand"),ft.registerCommand(!0,Y,async(...ct)=>{const _t=bt.activeEditor(!0);if(!_t){ve.warn("Cannot execute "+Y+" because there is no active text editor.");return}const Dt=await Ft.getDiffInformation(_t.id);ue.apply(De,[Dt,...ct])},void 0,void 0,Fe)),executeCommand(Y,...ue){return ft.executeCommand(Y,...ue)},getCommands(Y=!1){return ft.getCommands(Y)}},vi={get machineId(){return de.telemetryInfo.machineId},get sessionId(){return de.telemetryInfo.sessionId},get language(){return de.environment.appLanguage},get appName(){return de.environment.appName},get appRoot(){return de.environment.appRoot?.fsPath??""},get appHost(){return de.environment.appHost},get uriScheme(){return de.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return pt.getDefaultShell(!1)},get isTelemetryEnabled(){return je.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return je.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(de.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ue){return xe.openUri(Y,{allowTunneling:!!de.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===de.environment.appUriScheme)return At.createAppUri(Y);try{return await xe.asExternalUri(Y,{allowTunneling:!!de.remote.authority})}catch(ue){if((0,ht.matchesScheme)(Y,ot.Schemas.http)||(0,ht.matchesScheme)(Y,ot.Schemas.https))return Y;throw ue}},get remoteName(){return(0,oe.getRemoteName)(de.remote.authority)},get remoteAuthority(){return(0,pe.checkProposedApiEnabled)(Fe,"resolvers"),de.remote.authority},get uiKind(){return de.uiKind}};de.environment.extensionTestsLocationURI||Object.freeze(vi);const bi=de.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Pi={createTestController(Y,ue,De){return Kt.createTestController(Y,ue,De)},createTestObserver(){return(0,pe.checkProposedApiEnabled)(Fe,"testObserver"),Kt.createTestObserver()},runTests(Y){return(0,pe.checkProposedApiEnabled)(Fe,"testObserver"),Kt.runTests(Y)},get onDidChangeTestResults(){return(0,pe.checkProposedApiEnabled)(Fe,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,pe.checkProposedApiEnabled)(Fe,"testObserver"),Kt.results}},Ti={getExtension(Y){const ue=xt.getExtensionDescription(Y);if(ue)return new r.Extension(We,Fe.identifier,ue,bi)},get all(){return xt.getAllExtensionDescriptions().map(Y=>new r.Extension(We,Fe.identifier,Y,bi))},get onDidChange(){return xt.onDidChange}},Ai={createDiagnosticCollection(Y){return Jt.createDiagnosticCollection(Fe.identifier,Y)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:Y=>Jt.getDiagnostics(Y),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Y,ue){return Wt.changeLanguage(Y.uri,ue)},match(Y,ue){return(0,R.score)(U.LanguageSelector.from(Y),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(Y,ue,De){return gt.registerCodeActionProvider(Fe,mt(Y),ue,De)},registerCodeLensProvider(Y,ue){return gt.registerCodeLensProvider(Fe,mt(Y),ue)},registerDefinitionProvider(Y,ue){return gt.registerDefinitionProvider(Fe,mt(Y),ue)},registerDeclarationProvider(Y,ue){return gt.registerDeclarationProvider(Fe,mt(Y),ue)},registerImplementationProvider(Y,ue){return gt.registerImplementationProvider(Fe,mt(Y),ue)},registerTypeDefinitionProvider(Y,ue){return gt.registerTypeDefinitionProvider(Fe,mt(Y),ue)},registerHoverProvider(Y,ue){return gt.registerHoverProvider(Fe,mt(Y),ue,Fe.identifier)},registerEvaluatableExpressionProvider(Y,ue){return gt.registerEvaluatableExpressionProvider(Fe,mt(Y),ue,Fe.identifier)},registerInlineValuesProvider(Y,ue){return gt.registerInlineValuesProvider(Fe,mt(Y),ue,Fe.identifier)},registerDocumentHighlightProvider(Y,ue){return gt.registerDocumentHighlightProvider(Fe,mt(Y),ue)},registerLinkedEditingRangeProvider(Y,ue){return gt.registerLinkedEditingRangeProvider(Fe,mt(Y),ue)},registerReferenceProvider(Y,ue){return gt.registerReferenceProvider(Fe,mt(Y),ue)},registerRenameProvider(Y,ue){return gt.registerRenameProvider(Fe,mt(Y),ue)},registerDocumentSymbolProvider(Y,ue,De){return gt.registerDocumentSymbolProvider(Fe,mt(Y),ue,De)},registerWorkspaceSymbolProvider(Y){return gt.registerWorkspaceSymbolProvider(Fe,Y)},registerDocumentFormattingEditProvider(Y,ue){return gt.registerDocumentFormattingEditProvider(Fe,mt(Y),ue)},registerDocumentRangeFormattingEditProvider(Y,ue){return gt.registerDocumentRangeFormattingEditProvider(Fe,mt(Y),ue)},registerOnTypeFormattingEditProvider(Y,ue,De,...ct){return gt.registerOnTypeFormattingEditProvider(Fe,mt(Y),ue,[De].concat(ct))},registerDocumentSemanticTokensProvider(Y,ue,De){return gt.registerDocumentSemanticTokensProvider(Fe,mt(Y),ue,De)},registerDocumentRangeSemanticTokensProvider(Y,ue,De){return gt.registerDocumentRangeSemanticTokensProvider(Fe,mt(Y),ue,De)},registerSignatureHelpProvider(Y,ue,De,...ct){return typeof De=="object"?gt.registerSignatureHelpProvider(Fe,mt(Y),ue,De):gt.registerSignatureHelpProvider(Fe,mt(Y),ue,typeof De=="undefined"?[]:[De,...ct])},registerCompletionItemProvider(Y,ue,...De){return gt.registerCompletionItemProvider(Fe,mt(Y),ue,De)},registerInlineCompletionItemProvider(Y,ue){return(0,pe.checkProposedApiEnabled)(Fe,"inlineCompletions"),gt.registerInlineCompletionsProvider(Fe,mt(Y),ue)},registerDocumentLinkProvider(Y,ue){return gt.registerDocumentLinkProvider(Fe,mt(Y),ue)},registerColorProvider(Y,ue){return gt.registerColorProvider(Fe,mt(Y),ue)},registerFoldingRangeProvider(Y,ue){return gt.registerFoldingRangeProvider(Fe,mt(Y),ue)},registerSelectionRangeProvider(Y,ue){return gt.registerSelectionRangeProvider(Fe,Y,ue)},registerCallHierarchyProvider(Y,ue){return gt.registerCallHierarchyProvider(Fe,Y,ue)},registerTypeHierarchyProvider(Y,ue){return gt.registerTypeHierarchyProvider(Fe,Y,ue)},setLanguageConfiguration:(Y,ue)=>gt.setLanguageConfiguration(Fe,Y,ue),getTokenInformationAtPosition(Y,ue){return(0,pe.checkProposedApiEnabled)(Fe,"tokenInformation"),Wt.tokenAtPosition(Y,ue)},registerInlayHintsProvider(Y,ue){return(0,pe.checkProposedApiEnabled)(Fe,"inlayHints"),gt.registerInlayHintsProvider(Fe,Y,ue)},createLanguageStatusItem(Y,ue){return(0,pe.checkProposedApiEnabled)(Fe,"languageStatus"),Wt.createLanguageStatusItem(Fe,Y,ue)}},Ri={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return pt.activeTerminal},get terminals(){return pt.terminals},async showTextDocument(Y,ue,De){const ct=await(k.URI.isUri(Y)?Promise.resolve(ri.openTextDocument(Y)):Promise.resolve(Y));return Ft.showTextDocument(ct,ue,De)},createTextEditorDecorationType(Y){return Ft.createTextEditorDecorationType(Fe,Y)},onDidChangeActiveTextEditor(Y,ue,De){return Ft.onDidChangeActiveTextEditor(Y,ue,De)},onDidChangeVisibleTextEditors(Y,ue,De){return Ft.onDidChangeVisibleTextEditors(Y,ue,De)},onDidChangeTextEditorSelection(Y,ue,De){return Ft.onDidChangeTextEditorSelection(Y,ue,De)},onDidChangeTextEditorOptions(Y,ue,De){return Ft.onDidChangeTextEditorOptions(Y,ue,De)},onDidChangeTextEditorVisibleRanges(Y,ue,De){return Ft.onDidChangeTextEditorVisibleRanges(Y,ue,De)},onDidChangeTextEditorViewColumn(Y,ue,De){return Ft.onDidChangeTextEditorViewColumn(Y,ue,De)},onDidCloseTerminal(Y,ue,De){return pt.onDidCloseTerminal(Y,ue,De)},onDidOpenTerminal(Y,ue,De){return pt.onDidOpenTerminal(Y,ue,De)},onDidChangeActiveTerminal(Y,ue,De){return pt.onDidChangeActiveTerminal(Y,ue,De)},onDidChangeTerminalDimensions(Y,ue,De){return(0,pe.checkProposedApiEnabled)(Fe,"terminalDimensions"),pt.onDidChangeTerminalDimensions(Y,ue,De)},onDidChangeTerminalState(Y,ue,De){return pt.onDidChangeTerminalState(Y,ue,De)},onDidWriteTerminalData(Y,ue,De){return(0,pe.checkProposedApiEnabled)(Fe,"terminalDataWriteEvent"),pt.onDidWriteTerminalData(Y,ue,De)},get state(){return xe.state},onDidChangeWindowState(Y,ue,De){return xe.onDidChangeWindowState(Y,ue,De)},showInformationMessage(Y,...ue){return ui.showMessage(Fe,T.default.Info,Y,ue[0],ue.slice(1))},showWarningMessage(Y,...ue){return ui.showMessage(Fe,T.default.Warning,Y,ue[0],ue.slice(1))},showErrorMessage(Y,...ue){return ui.showMessage(Fe,T.default.Error,Y,ue[0],ue.slice(1))},showQuickPick(Y,ue,De){return Array.isArray(Y)&&Y.some(ct=>ct.kind===$.QuickPickItemKind.Separator)&&(0,pe.checkProposedApiEnabled)(Fe,"quickPickSeparators"),jt.showQuickPick(Y,ue,De)},showWorkspaceFolderPick(Y){return jt.showWorkspaceFolderPick(Y)},showInputBox(Y,ue){return jt.showInput(Y,ue)},showOpenDialog(Y){return ii.showOpenDialog(Y)},showSaveDialog(Y){return ii.showSaveDialog(Y)},createStatusBarItem(Y,ue,De){let ct,_t,Dt;return typeof Y=="string"?(ct=Y,_t=ue,Dt=De):(_t=Y,Dt=ue),gi.createStatusBarEntry(Fe,ct,_t,Dt)},setStatusBarMessage(Y,ue){return gi.setStatusBarMessage(Y,ue)},withScmProgress(Y){return Ke.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),fi.withProgress(Fe,{location:$.ProgressLocation.SourceControl},(ue,De)=>Y({report(ct){}}))},withProgress(Y,ue){return fi.withProgress(Fe,Y,ue)},createOutputChannel(Y){return It.createOutputChannel(Y,Fe)},createWebviewPanel(Y,ue,De,ct){return Gt.createWebviewPanel(Fe,Y,ue,De,ct)},createWebviewTextEditorInset(Y,ue,De,ct){return(0,pe.checkProposedApiEnabled)(Fe,"editorInsets"),ai.createWebviewEditorInset(Y,ue,De,ct,Fe)},createTerminal(Y,ue,De){return typeof Y=="object"?"pty"in Y?pt.createExtensionTerminal(Y):pt.createTerminalFromOptions(Y):pt.createTerminal(Y,ue,De)},registerTerminalLinkProvider(Y){return pt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,ue){return pt.registerProfileProvider(Fe,Y,ue)},registerTreeDataProvider(Y,ue){return Xt.registerTreeDataProvider(Y,ue,Fe)},createTreeView(Y,ue){return Xt.createTreeView(Y,ue,Fe)},registerWebviewPanelSerializer:(Y,ue)=>Gt.registerWebviewPanelSerializer(Fe,Y,ue),registerCustomEditorProvider:(Y,ue,De={})=>_i.registerCustomEditorProvider(Fe,Y,ue,De),registerFileDecorationProvider(Y){return Ct.registerFileDecorationProvider(Y,Fe.identifier)},registerUriHandler(Y){return At.registerUriHandler(Fe.identifier,Y)},createQuickPick(){return jt.createQuickPick(Fe)},createInputBox(){return jt.createInputBox(Fe.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(Y,ue,De){return mi.onDidChangeActiveColorTheme(Y,ue,De)},registerWebviewViewProvider(Y,ue,De){return Si.registerWebviewViewProvider(Fe,Y,ue,De?.webviewOptions)},get activeNotebookEditor(){return(0,pe.checkProposedApiEnabled)(Fe,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ue,De){return(0,pe.checkProposedApiEnabled)(Fe,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(Y,ue,De)},get visibleNotebookEditors(){return(0,pe.checkProposedApiEnabled)(Fe,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,pe.checkProposedApiEnabled)(Fe,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ue,De){return(0,pe.checkProposedApiEnabled)(Fe,"notebookEditor"),Vt.onDidChangeNotebookEditorSelection(Y,ue,De)},onDidChangeNotebookEditorVisibleRanges(Y,ue,De){return(0,pe.checkProposedApiEnabled)(Fe,"notebookEditor"),Vt.onDidChangeNotebookEditorVisibleRanges(Y,ue,De)},showNotebookDocument(Y,ue){return(0,pe.checkProposedApiEnabled)(Fe,"notebookEditor"),Et.showNotebookDocument(Y,ue)},registerExternalUriOpener(Y,ue,De){return(0,pe.checkProposedApiEnabled)(Fe,"externalUriOpener"),Ci.registerExternalUriOpener(Fe.identifier,Y,ue,De)},get tabs(){return(0,pe.checkProposedApiEnabled)(Fe,"tabs"),wt.tabs},get activeTab(){return(0,pe.checkProposedApiEnabled)(Fe,"tabs"),wt.activeTab},get onDidChangeTabs(){return(0,pe.checkProposedApiEnabled)(Fe,"tabs"),wt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,pe.checkProposedApiEnabled)(Fe,"tabs"),wt.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,pe.checkProposedApiEnabled)(Fe,"inlineCompletions"),g.InlineCompletionController.get(Y)}},ri={get rootPath(){return Ke.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Le.getPath()},set rootPath(Y){throw t.readonly()},getWorkspaceFolder(Y){return Le.getWorkspaceFolder(Y)},get workspaceFolders(){return Le.getWorkspaceFolders()},get name(){return Le.name},set name(Y){throw t.readonly()},get workspaceFile(){return Le.workspaceFile},set workspaceFile(Y){throw t.readonly()},updateWorkspaceFolders:(Y,ue,...De)=>Le.updateWorkspaceFolders(Fe,Y,ue||0,...De),onDidChangeWorkspaceFolders:function(Y,ue,De){return Le.onDidChangeWorkspace(Y,ue,De)},asRelativePath:(Y,ue)=>Le.getRelativePath(Y,ue),findFiles:(Y,ue,De,ct)=>Le.findFiles(U.GlobPattern.from(Y),U.GlobPattern.from(ue),De,Fe.identifier,ct),findTextInFiles:(Y,ue,De,ct)=>{(0,pe.checkProposedApiEnabled)(Fe,"findTextInFiles");let _t,Dt;return typeof ue=="object"?(_t=ue,Dt=De):(_t={},Dt=ue,ct=De),Le.findTextInFiles(Y,_t||{},Dt,Fe.identifier,ct)},saveAll:Y=>Le.saveAll(Y),applyEdit(Y){return Di.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ue,De,ct)=>Nt.createFileSystemWatcher(U.GlobPattern.from(Y),ue,De,ct),get textDocuments(){return St.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw t.readonly()},openTextDocument(Y){let ue;const De=Y;if(typeof Y=="string")ue=Promise.resolve(k.URI.file(Y));else if(k.URI.isUri(Y))ue=Promise.resolve(Y);else if(!De||typeof De=="object")ue=St.createDocumentData(De);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(ct=>St.ensureDocumentData(ct).then(_t=>_t.document))},onDidOpenTextDocument:(Y,ue,De)=>St.onDidAddDocument(Y,ue,De),onDidCloseTextDocument:(Y,ue,De)=>St.onDidRemoveDocument(Y,ue,De),onDidChangeTextDocument:(Y,ue,De)=>St.onDidChangeDocument(Y,ue,De),onDidSaveTextDocument:(Y,ue,De)=>St.onDidSaveDocument(Y,ue,De),onWillSaveTextDocument:(Y,ue,De)=>Lt.getOnWillSaveTextDocumentEvent(Fe)(Y,ue,De),get notebookDocuments(){return Et.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,ue){let De;if(k.URI.isUri(Y))De=Y,await Et.openNotebookDocument(Y);else if(typeof Y=="string")De=k.URI.revive(await Et.createNotebookDocument({viewType:Y,content:ue}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(De).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(Y,ue,De,ct){return Et.registerNotebookSerializer(Fe,Y,ue,De,(0,pe.isProposedApiEnabled)(Fe,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(Y,ue,De,ct)=>((0,pe.checkProposedApiEnabled)(Fe,"notebookContentProvider"),Et.registerNotebookContentProvider(Fe,Y,ue,De,(0,pe.isProposedApiEnabled)(Fe,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(Y,ue,De)=>pi.onDidChangeConfiguration(Y,ue,De),getConfiguration(Y,ue){return ue=arguments.length===1?void 0:ue,pi.getConfiguration(Y,ue,Fe)},registerTextDocumentContentProvider(Y,ue){return zt.registerTextDocumentContentProvider(Y,ue)},registerTaskProvider:(Y,ue)=>(Ke.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Fe,Y,ue)),registerFileSystemProvider(Y,ue,De){return(0,Ce.combinedDisposable)(li.registerFileSystemProvider(Fe,Y,ue,De),Te.addFileSystemProvider(Y,ue))},get fs(){return Te.value},registerFileSearchProvider:(Y,ue)=>((0,pe.checkProposedApiEnabled)(Fe,"fileSearchProvider"),Ot.registerFileSearchProvider(Y,ue)),registerTextSearchProvider:(Y,ue)=>((0,pe.checkProposedApiEnabled)(Fe,"textSearchProvider"),Ot.registerTextSearchProvider(Y,ue)),registerRemoteAuthorityResolver:(Y,ue)=>((0,pe.checkProposedApiEnabled)(Fe,"resolvers"),We.registerRemoteAuthorityResolver(Y,ue)),registerResourceLabelFormatter:Y=>((0,pe.checkProposedApiEnabled)(Fe,"resolvers"),Ei.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ue,De)=>Nt.onDidCreateFile(Y,ue,De),onDidDeleteFiles:(Y,ue,De)=>Nt.onDidDeleteFile(Y,ue,De),onDidRenameFiles:(Y,ue,De)=>Nt.onDidRenameFile(Y,ue,De),onWillCreateFiles:(Y,ue,De)=>Nt.getOnWillCreateFileEvent(Fe)(Y,ue,De),onWillDeleteFiles:(Y,ue,De)=>Nt.getOnWillDeleteFileEvent(Fe)(Y,ue,De),onWillRenameFiles:(Y,ue,De)=>Nt.getOnWillRenameFileEvent(Fe)(Y,ue,De),openTunnel:Y=>((0,pe.checkProposedApiEnabled)(Fe,"resolvers"),Ie.openTunnel(Fe,Y).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,pe.checkProposedApiEnabled)(Fe,"resolvers"),Ie.getTunnels()},onDidChangeTunnels:(Y,ue,De)=>((0,pe.checkProposedApiEnabled)(Fe,"resolvers"),Ie.onDidChangeTunnels(Y,ue,De)),registerPortAttributesProvider:(Y,ue)=>((0,pe.checkProposedApiEnabled)(Fe,"portsAttributes"),Ie.registerPortsAttributesProvider(Y,ue)),registerTimelineProvider:(Y,ue)=>((0,pe.checkProposedApiEnabled)(Fe,"timeline"),yi.registerTimelineProvider(Y,ue,Fe.identifier,ft.converter)),get isTrusted(){return Le.trusted},requestWorkspaceTrust:Y=>((0,pe.checkProposedApiEnabled)(Fe,"workspaceTrust"),Le.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,ue,De)=>Le.onDidGrantWorkspaceTrust(Y,ue,De)},Fi={get inputBox(){return Ke.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),Zt.getLastInputBox(Fe)},createSourceControl(Y,ue,De){return Zt.createSourceControl(Fe,Y,ue,De)}},Mi={createCommentController(Y,ue){return ci.createCommentController(Fe,Y,ue)}},Oi={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},onDidStartDebugSession(Y,ue,De){return yt.onDidStartDebugSession(Y,ue,De)},onDidTerminateDebugSession(Y,ue,De){return yt.onDidTerminateDebugSession(Y,ue,De)},onDidChangeActiveDebugSession(Y,ue,De){return yt.onDidChangeActiveDebugSession(Y,ue,De)},onDidReceiveDebugSessionCustomEvent(Y,ue,De){return yt.onDidReceiveDebugSessionCustomEvent(Y,ue,De)},onDidChangeBreakpoints(Y,ue,De){return yt.onDidChangeBreakpoints(Y,ue,De)},registerDebugConfigurationProvider(Y,ue,De){return yt.registerDebugConfigurationProvider(Y,ue,De||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ue){return yt.registerDebugAdapterDescriptorFactory(Fe,Y,ue)},registerDebugAdapterTrackerFactory(Y,ue){return yt.registerDebugAdapterTrackerFactory(Y,ue)},startDebugging(Y,ue,De){return!De||typeof De=="object"&&"configuration"in De?yt.startDebugging(Y,ue,{parentSession:De}):yt.startDebugging(Y,ue,De||{})},stopDebugging(Y){return yt.stopDebugging(Y)},addBreakpoints(Y){return yt.addBreakpoints(Y)},removeBreakpoints(Y){return yt.removeBreakpoints(Y)},asDebugSourceUri(Y,ue){return yt.asDebugSourceUri(Y,ue)}},Li={registerTaskProvider:(Y,ue)=>kt.registerTaskProvider(Fe,Y,ue),fetchTasks:Y=>kt.fetchTasks(Y),executeTask:Y=>kt.executeTask(Fe,Y),get taskExecutions(){return kt.taskExecutions},onDidStartTask:(Y,ue,De)=>kt.onDidStartTask(Y,ue,De),onDidEndTask:(Y,ue,De)=>kt.onDidEndTask(Y,ue,De),onDidStartTaskProcess:(Y,ue,De)=>kt.onDidStartTaskProcess(Y,ue,De),onDidEndTaskProcess:(Y,ue,De)=>kt.onDidEndTaskProcess(Y,ue,De)},Ni={createNotebookController(Y,ue,De,ct,_t){return Yt.createNotebookController(Fe,Y,ue,De,ct,(0,pe.isProposedApiEnabled)(Fe,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(Y,ue)=>Et.registerNotebookCellStatusBarItemProvider(Fe,Y,ue),get onDidSaveNotebookDocument(){return(0,pe.checkProposedApiEnabled)(Fe,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,pe.checkProposedApiEnabled)(Fe,"notebookEditorDecorationType"),Vt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return si.createRendererMessaging(Fe,Y)},onDidChangeNotebookDocumentMetadata(Y,ue,De){return(0,pe.checkProposedApiEnabled)(Fe,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(Y,ue,De)},onDidChangeNotebookCells(Y,ue,De){return(0,pe.checkProposedApiEnabled)(Fe,"notebookEditor"),Et.onDidChangeNotebookCells(Y,ue,De)},onDidChangeNotebookCellExecutionState(Y,ue,De){return(0,pe.checkProposedApiEnabled)(Fe,"notebookCellExecutionState"),Yt.onDidChangeNotebookCellExecutionState(Y,ue,De)},onDidChangeCellOutputs(Y,ue,De){return(0,pe.checkProposedApiEnabled)(Fe,"notebookEditor"),Et.onDidChangeCellOutputs(Y,ue,De)},onDidChangeCellMetadata(Y,ue,De){return(0,pe.checkProposedApiEnabled)(Fe,"notebookEditor"),Et.onDidChangeCellMetadata(Y,ue,De)},createConcatTextDocument(Y,ue){return(0,pe.checkProposedApiEnabled)(Fe,"notebookConcatTextDocument"),new Ue.ExtHostNotebookConcatDocument(Et,St,Y,ue)}};return{version:de.version,authentication:ni,commands:Ii,comments:Mi,debug:Oi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Fi,tasks:Li,tests:Pi,window:Ri,workspace:ri,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:s.CancellationTokenSource,CandidatePortSource:i.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:A.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:i.UIKind,Uri:k.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:Ne.TextSearchCompleteMessageType,TreeDataTransfer:$.TreeDataTransfer,TreeDataTransferItem:$.TreeDataTransferItem,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=ne}),define(Ee[221],ye([0,1,220,33,213,7,14,5,11]),function(ee,e,s,t,E,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class A extends E.RequireInterceptor{_installInterceptor(){}getModule(o,u){for(let d of this._alternatives){let F=d(o);if(F){o=F;break}}if(this._factories.has(o))return this._factories.get(o).load(o,u,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends t.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const o=this._extHostContext.getProxy(P.MainContext.MainThreadConsole);i(o,this._initData.environment.isExtensionDevelopmentDebug);const u=this._instaService.invokeFunction(s.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(A,u,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(o){return o.browser}async _loadCommonJSModule(o,u,d){u=u.with({path:w(u.path,".js")}),o&&performance.mark(`code/extHost/willFetchExtensionCode/${o.value}`);const F=await fetch(C.FileAccess.asBrowserUri(u).toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o.value}`),F.status!==200)throw new Error(F.statusText);const _=await F.text(),m=`${u.toString(!0)}#vscode-extension`,h=`${_}
//# sourceURL=${m}`;let D;try{D=new Function("module","exports","require",h)}catch(n){throw console.error(o?`Loading code for extension ${o.value} failed: ${n.message}`:`Loading code failed: ${n.message}`),console.error(`${u.toString(!0)}${typeof n.line=="number"?` line ${n.line}`:""}${typeof n.column=="number"?` column ${n.column}`:""}`),console.error(n),n}const l={},M={exports:l},r=n=>{const b=this._fakeModules.getModule(n,u);if(b===void 0)throw new Error(`Cannot load module '${n}'`);return b};try{return d.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o.value}`),D(M,l,r),M.exports!==l?M.exports:l}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o.value}`),d.codeLoadingStop()}}async $setRemoteEnvironment(o){}async _waitForDebuggerAttachment(o=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const u=Date.now()+o;for(;Date.now()<u&&!("__jsDebugIsReady"in globalThis);)await(0,k.timeout)(10)}}e.ExtHostExtensionService=R;function w(p,o){return p.endsWith(o)?p:p+o}function i(p,o){u("info","log"),u("log","log"),u("warn","warn"),u("error","error");function u(_,m){const h=console[_];console[_]=function(){p.$logExtensionHostMessage({type:"__$console",severity:m,arguments:F(arguments)}),o&&h.apply(console,arguments)}}const d=1e5;function F(_){const m=[],h=[];if(_.length)for(let D=0;D<_.length;D++){if(typeof _[D]=="undefined")_[D]="undefined";else if(_[D]instanceof Error){const l=_[D];l.stack?_[D]=l.stack:_[D]=l.toString()}h.push(_[D])}try{const D=JSON.stringify(h,function(l,M){if(M&&typeof M=="object"){if(m.indexOf(M)!==-1)return"[Circular]";m.push(M)}return M});return D.length>d?"Output omitted for a large object that exceeds the limits":D}catch(D){return`Output omitted for an object that cannot be inspected ('${D.toString()}')`}}}}),define(Ee[222],ye([0,1,44,33,72,221]),function(ee,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(t.IExtHostExtensionService,T.ExtHostExtensionService),(0,s.registerSingleton)(E.IExtensionStoragePaths,E.ExtensionStoragePaths)}),define(Ee[234],ye([0,1,22,4,171,214,208,17,73,11,2,217,222]),function(ee,e,s,t,E,T,k,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const i=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const p=fetch.bind(self);if(self.fetch=function(m,h){return m instanceof Request||/^file:/i.test(String(m))&&(m=A.FileAccess.asBrowserUri(R.URI.parse(String(m))).toString(!0)),p(m,h)},self.XMLHttpRequest=class extends XMLHttpRequest{open(m,h,D,l,M){return/^file:/i.test(h.toString())&&(h=A.FileAccess.asBrowserUri(R.URI.parse(h.toString())).toString(!0)),super.open(m,h,D??!0,l,M)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const m=self.Worker;Worker=function(h,D){/^file:/i.test(h.toString())&&(h=A.FileAccess.asBrowserUri(R.URI.parse(h.toString())).toString(!0));const M=`(${function(g){function c(a){return typeof a=="string"||a instanceof URL?String(a).replace(/^file:\/\//i,"vscode-file://vscode-app"):a}const f=fetch.bind(self);self.fetch=function(a,S){return a instanceof Request?f(a,S):f(c(a),S)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,S,I,N,B){return super.open(a,c(S),I??!0,N,B)}};const v=importScripts.bind(self);self.importScripts=(...a)=>{v(...a.map(c))},v(g)}.toString()}('${h}'))`;D=D||{},D.name=D.name||P.basename(h.toString());const r=new Blob([M],{type:"application/javascript"}),n=URL.createObjectURL(r);return new m(n,D)}}else self.Worker=class extends k.NestedWorker{constructor(m,h){super(i,m,{name:P.basename(m.toString()),...h})}};const o=new class{constructor(){this.pid=void 0}exit(m){w()}async exists(m){return!0}async realpath(m){return m}};class u{constructor(){const h=new MessageChannel,D=new t.Emitter;let l=!1;i(h.port2,[h.port2]),h.port1.onmessage=M=>{const{data:r}=M;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const n=s.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,E.isMessageOfType)(n,2)){l=!0,F("received terminate message from renderer");return}D.fire(n)},this.protocol={onMessage:D.event,send:M=>{if(!l){const r=M.buffer.buffer.slice(M.buffer.byteOffset,M.buffer.byteOffset+M.buffer.byteLength);h.port1.postMessage(r,[r])}}}}}function d(m){return new Promise(h=>{const D=m.onMessage(l=>{D.dispose();const M=JSON.parse(l.toString());m.send((0,E.createMessageOfType)(0)),h({protocol:m,initData:M})});m.send((0,E.createMessageOfType)(1))})}let F=m=>w();function _(){C.mark("code/extHost/willConnectToRenderer");const m=new u;return{onmessage(h){d(m.protocol).then(D=>{C.mark("code/extHost/didWaitForInitData");const l=new T.ExtensionHostMain(D.protocol,D.initData,o,null,h);F=M=>l.terminate(M)})}}}e.create=_})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ea2afbaf90cb6d9672d8a681e90492d23c687064/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
